$(function() {

    //Wait for Pinegrow to wake-up
    $('body').one('pinegrow-ready', function(e, pinegrow) {

        //Create new Pinegrow framework object
        var f = new PgFramework('pg.fontawesome.5', 'Font Awesome 5');

        //This will prevent activating multiple versions of the plugin, provided that other versions set the same type
        f.type = "pg.fontawesome";
        f.allow_single_type = true;

        //Don't show these files in CSS tab
        f.ignore_css_files = [/font\-?awesome/i];

        //Auto detect if font-awesome css is included
        f.detect = function(pgPage) {
            return pgPage.hasStylesheet(/font\-?awesome/i);
        }

        //Tell Pinegrow about the framework
        pinegrow.addFramework(f);

        var activateFontawesome5 = function () {
            var $head = $('head');

            $('<link href="lib/fontawesome5/css/all.min.css" rel="stylesheet" id="fontawesome5">').appendTo($head);

            $head.find('> #fontawesome4').remove();
        }

        var icons = {};
        var icons_types = ['solid', 'regular', 'brands'];

        icons['solid'] = ['fa-ad', 'fa-address-book', 'fa-address-card', 'fa-adjust', 'fa-air-freshener', 'fa-align-center', 'fa-align-justify', 'fa-align-left', 'fa-align-right', 'fa-allergies', 'fa-ambulance', 'fa-american-sign-language-interpreting', 'fa-anchor', 'fa-angle-double-down', 'fa-angle-double-left', 'fa-angle-double-right', 'fa-angle-double-up', 'fa-angle-down', 'fa-angle-left', 'fa-angle-right', 'fa-angle-up', 'fa-angry', 'fa-ankh', 'fa-apple-alt', 'fa-archive', 'fa-archway', 'fa-arrow-alt-circle-down', 'fa-arrow-alt-circle-left', 'fa-arrow-alt-circle-right', 'fa-arrow-alt-circle-up', 'fa-arrow-circle-down', 'fa-arrow-circle-left', 'fa-arrow-circle-right', 'fa-arrow-circle-up', 'fa-arrow-down', 'fa-arrow-left', 'fa-arrow-right', 'fa-arrow-up', 'fa-arrows-alt', 'fa-arrows-alt-h', 'fa-arrows-alt-v', 'fa-assistive-listening-systems', 'fa-asterisk', 'fa-at', 'fa-atlas', 'fa-atom', 'fa-audio-description', 'fa-award', 'fa-baby', 'fa-baby-carriage', 'fa-backspace', 'fa-backward', 'fa-bacon', 'fa-bacteria', 'fa-bacterium', 'fa-bahai', 'fa-balance-scale', 'fa-balance-scale-left', 'fa-balance-scale-right', 'fa-ban', 'fa-band-aid', 'fa-barcode', 'fa-bars', 'fa-baseball-ball', 'fa-basketball-ball', 'fa-bath', 'fa-battery-empty', 'fa-battery-full', 'fa-battery-half', 'fa-battery-quarter', 'fa-battery-three-quarters', 'fa-bed', 'fa-beer', 'fa-bell', 'fa-bell-slash', 'fa-bezier-curve', 'fa-bible', 'fa-bicycle', 'fa-biking', 'fa-binoculars', 'fa-biohazard', 'fa-birthday-cake', 'fa-blender', 'fa-blender-phone', 'fa-blind', 'fa-blog', 'fa-bold', 'fa-bolt', 'fa-bomb', 'fa-bone', 'fa-bong', 'fa-book', 'fa-book-dead', 'fa-book-medical', 'fa-book-open', 'fa-book-reader', 'fa-bookmark', 'fa-border-all', 'fa-border-none', 'fa-border-style', 'fa-bowling-ball', 'fa-box', 'fa-box-open', 'fa-box-tissue', 'fa-boxes', 'fa-braille', 'fa-brain', 'fa-bread-slice', 'fa-briefcase', 'fa-briefcase-medical', 'fa-broadcast-tower', 'fa-broom', 'fa-brush', 'fa-bug', 'fa-building', 'fa-bullhorn', 'fa-bullseye', 'fa-burn', 'fa-bus', 'fa-bus-alt', 'fa-business-time', 'fa-calculator', 'fa-calendar', 'fa-calendar-alt', 'fa-calendar-check', 'fa-calendar-day', 'fa-calendar-minus', 'fa-calendar-plus', 'fa-calendar-times', 'fa-calendar-week', 'fa-camera', 'fa-camera-retro', 'fa-campground', 'fa-candy-cane', 'fa-cannabis', 'fa-capsules', 'fa-car', 'fa-car-alt', 'fa-car-battery', 'fa-car-crash', 'fa-car-side', 'fa-caravan', 'fa-caret-down', 'fa-caret-left', 'fa-caret-right', 'fa-caret-square-down', 'fa-caret-square-left', 'fa-caret-square-right', 'fa-caret-square-up', 'fa-caret-up', 'fa-carrot', 'fa-cart-arrow-down', 'fa-cart-plus', 'fa-cash-register', 'fa-cat', 'fa-certificate', 'fa-chair', 'fa-chalkboard', 'fa-chalkboard-teacher', 'fa-charging-station', 'fa-chart-area', 'fa-chart-bar', 'fa-chart-line', 'fa-chart-pie', 'fa-check', 'fa-check-circle', 'fa-check-double', 'fa-check-square', 'fa-cheese', 'fa-chess', 'fa-chess-bishop', 'fa-chess-board', 'fa-chess-king', 'fa-chess-knight', 'fa-chess-pawn', 'fa-chess-queen', 'fa-chess-rook', 'fa-chevron-circle-down', 'fa-chevron-circle-left', 'fa-chevron-circle-right', 'fa-chevron-circle-up', 'fa-chevron-down', 'fa-chevron-left', 'fa-chevron-right', 'fa-chevron-up', 'fa-child', 'fa-church', 'fa-circle', 'fa-circle-notch', 'fa-city', 'fa-clinic-medical', 'fa-clipboard', 'fa-clipboard-check', 'fa-clipboard-list', 'fa-clock', 'fa-clone', 'fa-closed-captioning', 'fa-cloud', 'fa-cloud-download-alt', 'fa-cloud-meatball', 'fa-cloud-moon', 'fa-cloud-moon-rain', 'fa-cloud-rain', 'fa-cloud-showers-heavy', 'fa-cloud-sun', 'fa-cloud-sun-rain', 'fa-cloud-upload-alt', 'fa-cocktail', 'fa-code', 'fa-code-branch', 'fa-coffee', 'fa-cog', 'fa-cogs', 'fa-coins', 'fa-columns', 'fa-comment', 'fa-comment-alt', 'fa-comment-dollar', 'fa-comment-dots', 'fa-comment-medical', 'fa-comment-slash', 'fa-comments', 'fa-comments-dollar', 'fa-compact-disc', 'fa-compass', 'fa-compress', 'fa-compress-alt', 'fa-compress-arrows-alt', 'fa-concierge-bell', 'fa-cookie', 'fa-cookie-bite', 'fa-copy', 'fa-copyright', 'fa-couch', 'fa-credit-card', 'fa-crop', 'fa-crop-alt', 'fa-cross', 'fa-crosshairs', 'fa-crow', 'fa-crown', 'fa-crutch', 'fa-cube', 'fa-cubes', 'fa-cut', 'fa-database', 'fa-deaf', 'fa-democrat', 'fa-desktop', 'fa-dharmachakra', 'fa-diagnoses', 'fa-dice', 'fa-dice-d20', 'fa-dice-d6', 'fa-dice-five', 'fa-dice-four', 'fa-dice-one', 'fa-dice-six', 'fa-dice-three', 'fa-dice-two', 'fa-digital-tachograph', 'fa-directions', 'fa-disease', 'fa-divide', 'fa-dizzy', 'fa-dna', 'fa-dog', 'fa-dollar-sign', 'fa-dolly', 'fa-dolly-flatbed', 'fa-donate', 'fa-door-closed', 'fa-door-open', 'fa-dot-circle', 'fa-dove', 'fa-download', 'fa-drafting-compass', 'fa-dragon', 'fa-draw-polygon', 'fa-drum', 'fa-drum-steelpan', 'fa-drumstick-bite', 'fa-dumbbell', 'fa-dumpster', 'fa-dumpster-fire', 'fa-dungeon', 'fa-edit', 'fa-egg', 'fa-eject', 'fa-ellipsis-h', 'fa-ellipsis-v', 'fa-envelope', 'fa-envelope-open', 'fa-envelope-open-text', 'fa-envelope-square', 'fa-equals', 'fa-eraser', 'fa-ethernet', 'fa-euro-sign', 'fa-exchange-alt', 'fa-exclamation', 'fa-exclamation-circle', 'fa-exclamation-triangle', 'fa-expand', 'fa-expand-alt', 'fa-expand-arrows-alt', 'fa-external-link-alt', 'fa-external-link-square-alt', 'fa-eye', 'fa-eye-dropper', 'fa-eye-slash', 'fa-fan', 'fa-fast-backward', 'fa-fast-forward', 'fa-faucet', 'fa-fax', 'fa-feather', 'fa-feather-alt', 'fa-female', 'fa-fighter-jet', 'fa-file', 'fa-file-alt', 'fa-file-archive', 'fa-file-audio', 'fa-file-code', 'fa-file-contract', 'fa-file-csv', 'fa-file-download', 'fa-file-excel', 'fa-file-export', 'fa-file-image', 'fa-file-import', 'fa-file-invoice', 'fa-file-invoice-dollar', 'fa-file-medical', 'fa-file-medical-alt', 'fa-file-pdf', 'fa-file-powerpoint', 'fa-file-prescription', 'fa-file-signature', 'fa-file-upload', 'fa-file-video', 'fa-file-word', 'fa-fill', 'fa-fill-drip', 'fa-film', 'fa-filter', 'fa-fingerprint', 'fa-fire', 'fa-fire-alt', 'fa-fire-extinguisher', 'fa-first-aid', 'fa-fish', 'fa-fist-raised', 'fa-flag', 'fa-flag-checkered', 'fa-flag-usa', 'fa-flask', 'fa-flushed', 'fa-folder', 'fa-folder-minus', 'fa-folder-open', 'fa-folder-plus', 'fa-font', 'fa-football-ball', 'fa-forward', 'fa-frog', 'fa-frown', 'fa-frown-open', 'fa-funnel-dollar', 'fa-futbol', 'fa-gamepad', 'fa-gas-pump', 'fa-gavel', 'fa-gem', 'fa-genderless', 'fa-ghost', 'fa-gift', 'fa-gifts', 'fa-glass-cheers', 'fa-glass-martini', 'fa-glass-martini-alt', 'fa-glass-whiskey', 'fa-glasses', 'fa-globe', 'fa-globe-africa', 'fa-globe-americas', 'fa-globe-asia', 'fa-globe-europe', 'fa-golf-ball', 'fa-gopuram', 'fa-graduation-cap', 'fa-greater-than', 'fa-greater-than-equal', 'fa-grimace', 'fa-grin', 'fa-grin-alt', 'fa-grin-beam', 'fa-grin-beam-sweat', 'fa-grin-hearts', 'fa-grin-squint', 'fa-grin-squint-tears', 'fa-grin-stars', 'fa-grin-tears', 'fa-grin-tongue', 'fa-grin-tongue-squint', 'fa-grin-tongue-wink', 'fa-grin-wink', 'fa-grip-horizontal', 'fa-grip-lines', 'fa-grip-lines-vertical', 'fa-grip-vertical', 'fa-guitar', 'fa-h-square', 'fa-hamburger', 'fa-hammer', 'fa-hamsa', 'fa-hand-holding', 'fa-hand-holding-heart', 'fa-hand-holding-medical', 'fa-hand-holding-usd', 'fa-hand-holding-water', 'fa-hand-lizard', 'fa-hand-middle-finger', 'fa-hand-paper', 'fa-hand-peace', 'fa-hand-point-down', 'fa-hand-point-left', 'fa-hand-point-right', 'fa-hand-point-up', 'fa-hand-pointer', 'fa-hand-rock', 'fa-hand-scissors', 'fa-hand-sparkles', 'fa-hand-spock', 'fa-hands', 'fa-hands-helping', 'fa-hands-wash', 'fa-handshake', 'fa-handshake-alt-slash', 'fa-handshake-slash', 'fa-hanukiah', 'fa-hard-hat', 'fa-hashtag', 'fa-hat-cowboy', 'fa-hat-cowboy-side', 'fa-hat-wizard', 'fa-hdd', 'fa-head-side-cough', 'fa-head-side-cough-slash', 'fa-head-side-mask', 'fa-head-side-virus', 'fa-heading', 'fa-headphones', 'fa-headphones-alt', 'fa-headset', 'fa-heart', 'fa-heart-broken', 'fa-heartbeat', 'fa-helicopter', 'fa-highlighter', 'fa-hiking', 'fa-hippo', 'fa-history', 'fa-hockey-puck', 'fa-holly-berry', 'fa-home', 'fa-horse', 'fa-horse-head', 'fa-hospital', 'fa-hospital-alt', 'fa-hospital-symbol', 'fa-hospital-user', 'fa-hot-tub', 'fa-hotdog', 'fa-hotel', 'fa-hourglass', 'fa-hourglass-end', 'fa-hourglass-half', 'fa-hourglass-start', 'fa-house-damage', 'fa-house-user', 'fa-hryvnia', 'fa-i-cursor', 'fa-ice-cream', 'fa-icicles', 'fa-icons', 'fa-id-badge', 'fa-id-card', 'fa-id-card-alt', 'fa-igloo', 'fa-image', 'fa-images', 'fa-inbox', 'fa-indent', 'fa-industry', 'fa-infinity', 'fa-info', 'fa-info-circle', 'fa-italic', 'fa-jedi', 'fa-joint', 'fa-journal-whills', 'fa-kaaba', 'fa-key', 'fa-keyboard', 'fa-khanda', 'fa-kiss', 'fa-kiss-beam', 'fa-kiss-wink-heart', 'fa-kiwi-bird', 'fa-landmark', 'fa-language', 'fa-laptop', 'fa-laptop-code', 'fa-laptop-house', 'fa-laptop-medical', 'fa-laugh', 'fa-laugh-beam', 'fa-laugh-squint', 'fa-laugh-wink', 'fa-layer-group', 'fa-leaf', 'fa-lemon', 'fa-less-than', 'fa-less-than-equal', 'fa-level-down-alt', 'fa-level-up-alt', 'fa-life-ring', 'fa-lightbulb', 'fa-link', 'fa-lira-sign', 'fa-list', 'fa-list-alt', 'fa-list-ol', 'fa-list-ul', 'fa-location-arrow', 'fa-lock', 'fa-lock-open', 'fa-long-arrow-alt-down', 'fa-long-arrow-alt-left', 'fa-long-arrow-alt-right', 'fa-long-arrow-alt-up', 'fa-low-vision', 'fa-luggage-cart', 'fa-lungs', 'fa-lungs-virus', 'fa-magic', 'fa-magnet', 'fa-mail-bulk', 'fa-male', 'fa-map', 'fa-map-marked', 'fa-map-marked-alt', 'fa-map-marker', 'fa-map-marker-alt', 'fa-map-pin', 'fa-map-signs', 'fa-marker', 'fa-mars', 'fa-mars-double', 'fa-mars-stroke', 'fa-mars-stroke-h', 'fa-mars-stroke-v', 'fa-mask', 'fa-medal', 'fa-medkit', 'fa-meh', 'fa-meh-blank', 'fa-meh-rolling-eyes', 'fa-memory', 'fa-menorah', 'fa-mercury', 'fa-meteor', 'fa-microchip', 'fa-microphone', 'fa-microphone-alt', 'fa-microphone-alt-slash', 'fa-microphone-slash', 'fa-microscope', 'fa-minus', 'fa-minus-circle', 'fa-minus-square', 'fa-mitten', 'fa-mobile', 'fa-mobile-alt', 'fa-money-bill', 'fa-money-bill-alt', 'fa-money-bill-wave', 'fa-money-bill-wave-alt', 'fa-money-check', 'fa-money-check-alt', 'fa-monument', 'fa-moon', 'fa-mortar-pestle', 'fa-mosque', 'fa-motorcycle', 'fa-mountain', 'fa-mouse', 'fa-mouse-pointer', 'fa-mug-hot', 'fa-music', 'fa-network-wired', 'fa-neuter', 'fa-newspaper', 'fa-not-equal', 'fa-notes-medical', 'fa-object-group', 'fa-object-ungroup', 'fa-oil-can', 'fa-om', 'fa-otter', 'fa-outdent', 'fa-pager', 'fa-paint-brush', 'fa-paint-roller', 'fa-palette', 'fa-pallet', 'fa-paper-plane', 'fa-paperclip', 'fa-parachute-box', 'fa-paragraph', 'fa-parking', 'fa-passport', 'fa-pastafarianism', 'fa-paste', 'fa-pause', 'fa-pause-circle', 'fa-paw', 'fa-peace', 'fa-pen', 'fa-pen-alt', 'fa-pen-fancy', 'fa-pen-nib', 'fa-pen-square', 'fa-pencil-alt', 'fa-pencil-ruler', 'fa-people-arrows', 'fa-people-carry', 'fa-pepper-hot', 'fa-percent', 'fa-percentage', 'fa-person-booth', 'fa-phone', 'fa-phone-alt', 'fa-phone-slash', 'fa-phone-square', 'fa-phone-square-alt', 'fa-phone-volume', 'fa-photo-video', 'fa-piggy-bank', 'fa-pills', 'fa-pizza-slice', 'fa-place-of-worship', 'fa-plane', 'fa-plane-arrival', 'fa-plane-departure', 'fa-plane-slash', 'fa-play', 'fa-play-circle', 'fa-plug', 'fa-plus', 'fa-plus-circle', 'fa-plus-square', 'fa-podcast', 'fa-poll', 'fa-poll-h', 'fa-poo', 'fa-poo-storm', 'fa-poop', 'fa-portrait', 'fa-pound-sign', 'fa-power-off', 'fa-pray', 'fa-praying-hands', 'fa-prescription', 'fa-prescription-bottle', 'fa-prescription-bottle-alt', 'fa-print', 'fa-procedures', 'fa-project-diagram', 'fa-pump-medical', 'fa-pump-soap', 'fa-puzzle-piece', 'fa-qrcode', 'fa-question', 'fa-question-circle', 'fa-quidditch', 'fa-quote-left', 'fa-quote-right', 'fa-quran', 'fa-radiation', 'fa-radiation-alt', 'fa-rainbow', 'fa-random', 'fa-receipt', 'fa-record-vinyl', 'fa-recycle', 'fa-redo', 'fa-redo-alt', 'fa-registered', 'fa-remove-format', 'fa-reply', 'fa-reply-all', 'fa-republican', 'fa-restroom', 'fa-retweet', 'fa-ribbon', 'fa-ring', 'fa-road', 'fa-robot', 'fa-rocket', 'fa-route', 'fa-rss', 'fa-rss-square', 'fa-ruble-sign', 'fa-ruler', 'fa-ruler-combined', 'fa-ruler-horizontal', 'fa-ruler-vertical', 'fa-running', 'fa-rupee-sign', 'fa-sad-cry', 'fa-sad-tear', 'fa-satellite', 'fa-satellite-dish', 'fa-save', 'fa-school', 'fa-screwdriver', 'fa-scroll', 'fa-sd-card', 'fa-search', 'fa-search-dollar', 'fa-search-location', 'fa-search-minus', 'fa-search-plus', 'fa-seedling', 'fa-server', 'fa-shapes', 'fa-share', 'fa-share-alt', 'fa-share-alt-square', 'fa-share-square', 'fa-shekel-sign', 'fa-shield-alt', 'fa-shield-virus', 'fa-ship', 'fa-shipping-fast', 'fa-shoe-prints', 'fa-shopping-bag', 'fa-shopping-basket', 'fa-shopping-cart', 'fa-shower', 'fa-shuttle-van', 'fa-sign', 'fa-sign-in-alt', 'fa-sign-language', 'fa-sign-out-alt', 'fa-signal', 'fa-signature', 'fa-sim-card', 'fa-sink', 'fa-sitemap', 'fa-skating', 'fa-skiing', 'fa-skiing-nordic', 'fa-skull', 'fa-skull-crossbones', 'fa-slash', 'fa-sleigh', 'fa-sliders-h', 'fa-smile', 'fa-smile-beam', 'fa-smile-wink', 'fa-smog', 'fa-smoking', 'fa-smoking-ban', 'fa-sms', 'fa-snowboarding', 'fa-snowflake', 'fa-snowman', 'fa-snowplow', 'fa-soap', 'fa-socks', 'fa-solar-panel', 'fa-sort', 'fa-sort-alpha-down', 'fa-sort-alpha-down-alt', 'fa-sort-alpha-up', 'fa-sort-alpha-up-alt', 'fa-sort-amount-down', 'fa-sort-amount-down-alt', 'fa-sort-amount-up', 'fa-sort-amount-up-alt', 'fa-sort-down', 'fa-sort-numeric-down', 'fa-sort-numeric-down-alt', 'fa-sort-numeric-up', 'fa-sort-numeric-up-alt', 'fa-sort-up', 'fa-spa', 'fa-space-shuttle', 'fa-spell-check', 'fa-spider', 'fa-spinner', 'fa-splotch', 'fa-spray-can', 'fa-square', 'fa-square-full', 'fa-square-root-alt', 'fa-stamp', 'fa-star', 'fa-star-and-crescent', 'fa-star-half', 'fa-star-half-alt', 'fa-star-of-david', 'fa-star-of-life', 'fa-step-backward', 'fa-step-forward', 'fa-stethoscope', 'fa-sticky-note', 'fa-stop', 'fa-stop-circle', 'fa-stopwatch', 'fa-stopwatch-20', 'fa-store', 'fa-store-alt', 'fa-store-alt-slash', 'fa-store-slash', 'fa-stream', 'fa-street-view', 'fa-strikethrough', 'fa-stroopwafel', 'fa-subscript', 'fa-subway', 'fa-suitcase', 'fa-suitcase-rolling', 'fa-sun', 'fa-superscript', 'fa-surprise', 'fa-swatchbook', 'fa-swimmer', 'fa-swimming-pool', 'fa-synagogue', 'fa-sync', 'fa-sync-alt', 'fa-syringe', 'fa-table', 'fa-table-tennis', 'fa-tablet', 'fa-tablet-alt', 'fa-tablets', 'fa-tachometer-alt', 'fa-tag', 'fa-tags', 'fa-tape', 'fa-tasks', 'fa-taxi', 'fa-teeth', 'fa-teeth-open', 'fa-temperature-high', 'fa-temperature-low', 'fa-tenge', 'fa-terminal', 'fa-text-height', 'fa-text-width', 'fa-th', 'fa-th-large', 'fa-th-list', 'fa-theater-masks', 'fa-thermometer', 'fa-thermometer-empty', 'fa-thermometer-full', 'fa-thermometer-half', 'fa-thermometer-quarter', 'fa-thermometer-three-quarters', 'fa-thumbs-down', 'fa-thumbs-up', 'fa-thumbtack', 'fa-ticket-alt', 'fa-times', 'fa-times-circle', 'fa-tint', 'fa-tint-slash', 'fa-tired', 'fa-toggle-off', 'fa-toggle-on', 'fa-toilet', 'fa-toilet-paper', 'fa-toilet-paper-slash', 'fa-toolbox', 'fa-tools', 'fa-tooth', 'fa-torah', 'fa-torii-gate', 'fa-tractor', 'fa-trademark', 'fa-traffic-light', 'fa-trailer', 'fa-train', 'fa-tram', 'fa-transgender', 'fa-transgender-alt', 'fa-trash', 'fa-trash-alt', 'fa-trash-restore', 'fa-trash-restore-alt', 'fa-tree', 'fa-trophy', 'fa-truck', 'fa-truck-loading', 'fa-truck-monster', 'fa-truck-moving', 'fa-truck-pickup', 'fa-tshirt', 'fa-tty', 'fa-tv', 'fa-umbrella', 'fa-umbrella-beach', 'fa-underline', 'fa-undo', 'fa-undo-alt', 'fa-universal-access', 'fa-university', 'fa-unlink', 'fa-unlock', 'fa-unlock-alt', 'fa-upload', 'fa-user', 'fa-user-alt', 'fa-user-alt-slash', 'fa-user-astronaut', 'fa-user-check', 'fa-user-circle', 'fa-user-clock', 'fa-user-cog', 'fa-user-edit', 'fa-user-friends', 'fa-user-graduate', 'fa-user-injured', 'fa-user-lock', 'fa-user-md', 'fa-user-minus', 'fa-user-ninja', 'fa-user-nurse', 'fa-user-plus', 'fa-user-secret', 'fa-user-shield', 'fa-user-slash', 'fa-user-tag', 'fa-user-tie', 'fa-user-times', 'fa-users', 'fa-users-cog', 'fa-users-slash', 'fa-utensil-spoon', 'fa-utensils', 'fa-vector-square', 'fa-venus', 'fa-venus-double', 'fa-venus-mars', 'fa-vial', 'fa-vials', 'fa-video', 'fa-video-slash', 'fa-vihara', 'fa-virus', 'fa-virus-slash', 'fa-viruses', 'fa-voicemail', 'fa-volleyball-ball', 'fa-volume-down', 'fa-volume-mute', 'fa-volume-off', 'fa-volume-up', 'fa-vote-yea', 'fa-vr-cardboard', 'fa-walking', 'fa-wallet', 'fa-warehouse', 'fa-water', 'fa-wave-square', 'fa-weight', 'fa-weight-hanging', 'fa-wheelchair', 'fa-wifi', 'fa-wind', 'fa-window-close', 'fa-window-maximize', 'fa-window-minimize', 'fa-window-restore', 'fa-wine-bottle', 'fa-wine-glass', 'fa-wine-glass-alt', 'fa-won-sign', 'fa-wrench', 'fa-x-ray', 'fa-yen-sign', 'fa-yin-yang'];

        icons['regular'] = ['fa-address-book', 'fa-address-card', 'fa-angry', 'fa-arrow-alt-circle-down', 'fa-arrow-alt-circle-left', 'fa-arrow-alt-circle-right', 'fa-arrow-alt-circle-up', 'fa-bell', 'fa-bell-slash', 'fa-bookmark', 'fa-building', 'fa-calendar', 'fa-calendar-alt', 'fa-calendar-check', 'fa-calendar-minus', 'fa-calendar-plus', 'fa-calendar-times', 'fa-caret-square-down', 'fa-caret-square-left', 'fa-caret-square-right', 'fa-caret-square-up', 'fa-chart-bar', 'fa-check-circle', 'fa-check-square', 'fa-circle', 'fa-clipboard', 'fa-clock', 'fa-clone', 'fa-closed-captioning', 'fa-comment', 'fa-comment-alt', 'fa-comment-dots', 'fa-comments', 'fa-compass', 'fa-copy', 'fa-copyright', 'fa-credit-card', 'fa-dizzy', 'fa-dot-circle', 'fa-edit', 'fa-envelope', 'fa-envelope-open', 'fa-eye', 'fa-eye-slash', 'fa-file', 'fa-file-alt', 'fa-file-archive', 'fa-file-audio', 'fa-file-code', 'fa-file-excel', 'fa-file-image', 'fa-file-pdf', 'fa-file-powerpoint', 'fa-file-video', 'fa-file-word', 'fa-flag', 'fa-flushed', 'fa-folder', 'fa-folder-open', 'fa-frown', 'fa-frown-open', 'fa-futbol', 'fa-gem', 'fa-grimace', 'fa-grin', 'fa-grin-alt', 'fa-grin-beam', 'fa-grin-beam-sweat', 'fa-grin-hearts', 'fa-grin-squint', 'fa-grin-squint-tears', 'fa-grin-stars', 'fa-grin-tears', 'fa-grin-tongue', 'fa-grin-tongue-squint', 'fa-grin-tongue-wink', 'fa-grin-wink', 'fa-hand-lizard', 'fa-hand-paper', 'fa-hand-peace', 'fa-hand-point-down', 'fa-hand-point-left', 'fa-hand-point-right', 'fa-hand-point-up', 'fa-hand-pointer', 'fa-hand-rock', 'fa-hand-scissors', 'fa-hand-spock', 'fa-handshake', 'fa-hdd', 'fa-heart', 'fa-hospital', 'fa-hourglass', 'fa-id-badge', 'fa-id-card', 'fa-image', 'fa-images', 'fa-keyboard', 'fa-kiss', 'fa-kiss-beam', 'fa-kiss-wink-heart', 'fa-laugh', 'fa-laugh-beam', 'fa-laugh-squint', 'fa-laugh-wink', 'fa-lemon', 'fa-life-ring', 'fa-lightbulb', 'fa-list-alt', 'fa-map', 'fa-meh', 'fa-meh-blank', 'fa-meh-rolling-eyes', 'fa-minus-square', 'fa-money-bill-alt', 'fa-moon', 'fa-newspaper', 'fa-object-group', 'fa-object-ungroup', 'fa-paper-plane', 'fa-pause-circle', 'fa-play-circle', 'fa-plus-square', 'fa-question-circle', 'fa-registered', 'fa-sad-cry', 'fa-sad-tear', 'fa-save', 'fa-share-square', 'fa-smile', 'fa-smile-beam', 'fa-smile-wink', 'fa-snowflake', 'fa-square', 'fa-star', 'fa-star-half', 'fa-sticky-note', 'fa-stop-circle', 'fa-sun', 'fa-surprise', 'fa-thumbs-down', 'fa-thumbs-up', 'fa-times-circle', 'fa-tired', 'fa-trash-alt', 'fa-user', 'fa-user-circle', 'fa-window-close', 'fa-window-maximize', 'fa-window-minimize', 'fa-window-restore'];

        icons['brands'] = ['fa-500px', 'fa-accessible-icon', 'fa-accusoft', 'fa-acquisitions-incorporated', 'fa-adn', 'fa-adobe', 'fa-adversal', 'fa-affiliatetheme', 'fa-airbnb', 'fa-algolia', 'fa-alipay', 'fa-amazon', 'fa-amazon-pay', 'fa-amilia', 'fa-android', 'fa-angellist', 'fa-angrycreative', 'fa-angular', 'fa-app-store', 'fa-app-store-ios', 'fa-apper', 'fa-apple', 'fa-apple-pay', 'fa-artstation', 'fa-asymmetrik', 'fa-atlassian', 'fa-audible', 'fa-autoprefixer', 'fa-avianex', 'fa-aviato', 'fa-aws', 'fa-bandcamp', 'fa-battle-net', 'fa-behance', 'fa-behance-square', 'fa-bimobject', 'fa-bitbucket', 'fa-bitcoin', 'fa-bity', 'fa-black-tie', 'fa-blackberry', 'fa-blogger', 'fa-blogger-b', 'fa-bluetooth', 'fa-bluetooth-b', 'fa-bootstrap', 'fa-btc', 'fa-buffer', 'fa-buromobelexperte', 'fa-buy-n-large', 'fa-buysellads', 'fa-canadian-maple-leaf', 'fa-cc-amazon-pay', 'fa-cc-amex', 'fa-cc-apple-pay', 'fa-cc-diners-club', 'fa-cc-discover', 'fa-cc-jcb', 'fa-cc-mastercard', 'fa-cc-paypal', 'fa-cc-stripe', 'fa-cc-visa', 'fa-centercode', 'fa-centos', 'fa-chrome', 'fa-chromecast', 'fa-cloudscale', 'fa-cloudsmith', 'fa-cloudversify', 'fa-codepen', 'fa-codiepie', 'fa-confluence', 'fa-connectdevelop', 'fa-contao', 'fa-cotton-bureau', 'fa-cpanel', 'fa-creative-commons', 'fa-creative-commons-by', 'fa-creative-commons-nc', 'fa-creative-commons-nc-eu', 'fa-creative-commons-nc-jp', 'fa-creative-commons-nd', 'fa-creative-commons-pd', 'fa-creative-commons-pd-alt', 'fa-creative-commons-remix', 'fa-creative-commons-sa', 'fa-creative-commons-sampling', 'fa-creative-commons-sampling-plus', 'fa-creative-commons-share', 'fa-creative-commons-zero', 'fa-critical-role', 'fa-css3', 'fa-css3-alt', 'fa-cuttlefish', 'fa-d-and-d', 'fa-d-and-d-beyond', 'fa-dailymotion', 'fa-dashcube', 'fa-deezer', 'fa-delicious', 'fa-deploydog', 'fa-deskpro', 'fa-dev', 'fa-deviantart', 'fa-dhl', 'fa-diaspora', 'fa-digg', 'fa-digital-ocean', 'fa-discord', 'fa-discourse', 'fa-dochub', 'fa-docker', 'fa-draft2digital', 'fa-dribbble', 'fa-dribbble-square', 'fa-dropbox', 'fa-drupal', 'fa-dyalog', 'fa-earlybirds', 'fa-ebay', 'fa-edge', 'fa-edge-legacy', 'fa-elementor', 'fa-ello', 'fa-ember', 'fa-empire', 'fa-envira', 'fa-erlang', 'fa-ethereum', 'fa-etsy', 'fa-evernote', 'fa-expeditedssl', 'fa-facebook', 'fa-facebook-f', 'fa-facebook-messenger', 'fa-facebook-square', 'fa-fantasy-flight-games', 'fa-fedex', 'fa-fedora', 'fa-figma', 'fa-firefox', 'fa-firefox-browser', 'fa-first-order', 'fa-first-order-alt', 'fa-firstdraft', 'fa-flickr', 'fa-flipboard', 'fa-fly', 'fa-font-awesome', 'fa-font-awesome-alt', 'fa-font-awesome-flag', 'fa-fonticons', 'fa-fonticons-fi', 'fa-fort-awesome', 'fa-fort-awesome-alt', 'fa-forumbee', 'fa-foursquare', 'fa-free-code-camp', 'fa-freebsd', 'fa-fulcrum', 'fa-galactic-republic', 'fa-galactic-senate', 'fa-get-pocket', 'fa-gg', 'fa-gg-circle', 'fa-git', 'fa-git-alt', 'fa-git-square', 'fa-github', 'fa-github-alt', 'fa-github-square', 'fa-gitkraken', 'fa-gitlab', 'fa-gitter', 'fa-glide', 'fa-glide-g', 'fa-gofore', 'fa-goodreads', 'fa-goodreads-g', 'fa-google', 'fa-google-drive', 'fa-google-pay', 'fa-google-play', 'fa-google-plus', 'fa-google-plus-g', 'fa-google-plus-square', 'fa-google-wallet', 'fa-gratipay', 'fa-grav', 'fa-gripfire', 'fa-grunt', 'fa-gulp', 'fa-hacker-news', 'fa-hacker-news-square', 'fa-hackerrank', 'fa-hips', 'fa-hire-a-helper', 'fa-hooli', 'fa-hornbill', 'fa-hotjar', 'fa-houzz', 'fa-html5', 'fa-hubspot', 'fa-ideal', 'fa-imdb', 'fa-instagram', 'fa-instagram-square', 'fa-intercom', 'fa-internet-explorer', 'fa-invision', 'fa-ioxhost', 'fa-itch-io', 'fa-itunes', 'fa-itunes-note', 'fa-java', 'fa-jedi-order', 'fa-jenkins', 'fa-jira', 'fa-joget', 'fa-joomla', 'fa-js', 'fa-js-square', 'fa-jsfiddle', 'fa-kaggle', 'fa-keybase', 'fa-keycdn', 'fa-kickstarter', 'fa-kickstarter-k', 'fa-korvue', 'fa-laravel', 'fa-lastfm', 'fa-lastfm-square', 'fa-leanpub', 'fa-less', 'fa-line', 'fa-linkedin', 'fa-linkedin-in', 'fa-linode', 'fa-linux', 'fa-lyft', 'fa-magento', 'fa-mailchimp', 'fa-mandalorian', 'fa-markdown', 'fa-mastodon', 'fa-maxcdn', 'fa-mdb', 'fa-medapps', 'fa-medium', 'fa-medium-m', 'fa-medrt', 'fa-meetup', 'fa-megaport', 'fa-mendeley', 'fa-microblog', 'fa-microsoft', 'fa-mix', 'fa-mixcloud', 'fa-mixer', 'fa-mizuni', 'fa-modx', 'fa-monero', 'fa-napster', 'fa-neos', 'fa-nimblr', 'fa-node', 'fa-node-js', 'fa-npm', 'fa-ns8', 'fa-nutritionix', 'fa-odnoklassniki', 'fa-odnoklassniki-square', 'fa-old-republic', 'fa-opencart', 'fa-openid', 'fa-opera', 'fa-optin-monster', 'fa-orcid', 'fa-osi', 'fa-page4', 'fa-pagelines', 'fa-palfed', 'fa-patreon', 'fa-paypal', 'fa-penny-arcade', 'fa-periscope', 'fa-phabricator', 'fa-phoenix-framework', 'fa-phoenix-squadron', 'fa-php', 'fa-pied-piper', 'fa-pied-piper-alt', 'fa-pied-piper-hat', 'fa-pied-piper-pp', 'fa-pied-piper-square', 'fa-pinterest', 'fa-pinterest-p', 'fa-pinterest-square', 'fa-playstation', 'fa-product-hunt', 'fa-pushed', 'fa-python', 'fa-qq', 'fa-quinscape', 'fa-quora', 'fa-r-project', 'fa-raspberry-pi', 'fa-ravelry', 'fa-react', 'fa-reacteurope', 'fa-readme', 'fa-rebel', 'fa-red-river', 'fa-reddit', 'fa-reddit-alien', 'fa-reddit-square', 'fa-redhat', 'fa-renren', 'fa-replyd', 'fa-researchgate', 'fa-resolving', 'fa-rev', 'fa-rocketchat', 'fa-rockrms', 'fa-rust', 'fa-safari', 'fa-salesforce', 'fa-sass', 'fa-schlix', 'fa-scribd', 'fa-searchengin', 'fa-sellcast', 'fa-sellsy', 'fa-servicestack', 'fa-shirtsinbulk', 'fa-shopify', 'fa-shopware', 'fa-simplybuilt', 'fa-sistrix', 'fa-sith', 'fa-sketch', 'fa-skyatlas', 'fa-skype', 'fa-slack', 'fa-slack-hash', 'fa-slideshare', 'fa-snapchat', 'fa-snapchat-ghost', 'fa-snapchat-square', 'fa-soundcloud', 'fa-sourcetree', 'fa-speakap', 'fa-speaker-deck', 'fa-spotify', 'fa-squarespace', 'fa-stack-exchange', 'fa-stack-overflow', 'fa-stackpath', 'fa-staylinked', 'fa-steam', 'fa-steam-square', 'fa-steam-symbol', 'fa-sticker-mule', 'fa-strava', 'fa-stripe', 'fa-stripe-s', 'fa-studiovinari', 'fa-stumbleupon', 'fa-stumbleupon-circle', 'fa-superpowers', 'fa-supple', 'fa-suse', 'fa-swift', 'fa-symfony', 'fa-teamspeak', 'fa-telegram', 'fa-telegram-plane', 'fa-tencent-weibo', 'fa-the-red-yeti', 'fa-themeco', 'fa-themeisle', 'fa-think-peaks', 'fa-tiktok', 'fa-trade-federation', 'fa-trello', 'fa-tripadvisor', 'fa-tumblr', 'fa-tumblr-square', 'fa-twitch', 'fa-twitter', 'fa-twitter-square', 'fa-typo3', 'fa-uber', 'fa-ubuntu', 'fa-uikit', 'fa-umbraco', 'fa-uniregistry', 'fa-unity', 'fa-unsplash', 'fa-untappd', 'fa-ups', 'fa-usb', 'fa-usps', 'fa-ussunnah', 'fa-vaadin', 'fa-viacoin', 'fa-viadeo', 'fa-viadeo-square', 'fa-viber', 'fa-vimeo', 'fa-vimeo-square', 'fa-vimeo-v', 'fa-vine', 'fa-vk', 'fa-vnv', 'fa-vuejs', 'fa-waze', 'fa-weebly', 'fa-weibo', 'fa-weixin', 'fa-whatsapp', 'fa-whatsapp-square', 'fa-whmcs', 'fa-wikipedia-w', 'fa-windows', 'fa-wix', 'fa-wizards-of-the-coast', 'fa-wolf-pack-battalion', 'fa-wordpress', 'fa-wordpress-simple', 'fa-wpbeginner', 'fa-wpexplorer', 'fa-wpforms', 'fa-wpressr', 'fa-xbox', 'fa-xing', 'fa-xing-square', 'fa-y-combinator', 'fa-yahoo', 'fa-yammer', 'fa-yandex', 'fa-yandex-international', 'fa-yarn', 'fa-yelp', 'fa-yoast', 'fa-youtube', 'fa-youtube-square', 'fa-zhihu'];

        var getIconOptions = function (sel_icons, type) {
            var icons_options = [];
            for (var i = 0; i < sel_icons.length; i++) {
                var g = sel_icons[i];
                icons_options.push({
                    key: g,
                    name: g.replace('fa-', ''),
                    html: '<i class="fa' + type[0] + ' ' + g + '"></i>'
                });
            }
            return icons_options;
        }

        var icons_options = {};
        for (var i = 0; i < icons_types.length; i++) {
            var type = icons_types[i];
            icons_options[type] = getIconOptions(icons[type], type);
        }

        // var icons_options = {
        //     'solid': getIconOptions(solid_icons),
        //     'regular': getIconOptions(regular_icons),
        //     'brands': getIconOptions(brands_icons)
        // }

        var getType = function(pgel) {
            for (var i = 0; i < icons_types.length; i++) {
                var type = icons_types[i];
                if(pgel.hasClass('fa' + type[0])) return type;
            }
            return 'regular';
        }

        var getFaClass = function(pgel, type) {
            var cls = pgel.attr('class');
            if (cls) {
                cls = cls.split(' ');
                var sel_icons = icons[type];

                for (var i = 0; i < cls.length; i++) {
                    if (cls[i].indexOf('fa-') == 0) {
                        for (var j = 0; j < sel_icons.length; j++) {
                            if (cls[i] == sel_icons[j]) return cls[i];
                        }
                    }
                }
            }
            return null;
        }

        var getIconSections = function (type, icon_options) {
            return {
                ['fontawesome_' + type + '_options']: {
                    name: "Icon options",
                    fields: {
                        ['fontawesome_' + type + '_icon']: {
                            type: 'select',
                            name: 'Icon',
                            options: icon_options,
                            rich: {
                                title: 'Select icon',
                                modal: true,
                                class: 'icons-grid'
                            },
                            action: 'custom',
                            can_make_change_action: 'apply_class', //action for checking if change can be made
                            get_value: function (pgel) {
                                return getFaClass(pgel, type);
                            },
                            set_value: function (pgel, value, values) {
                                var cls = getFaClass(pgel, type);
                                if (cls) pgel.removeClass(cls);
                                pgel.addClass(value);
                                pgel.addClass('fa' + type[0]);
                                return value;
                            }
                        },
                        ['fontawesome_' + type + '_size']: {
                            'type': 'select',
                            'name': 'Size',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'fa-xs', name: 'Xs' },
                                { key: 'fa-sm', name: 'Sm' },
                                { key: 'fa-lg', name: 'Lg' },
                                { key: 'fa-2x', name: '1x' },
                                { key: 'fa-2x', name: '2x' },
                                { key: 'fa-3x', name: '3x' },
                                { key: 'fa-4x', name: '4x' },
                                { key: 'fa-5x', name: '5x' },
                                { key: 'fa-6x', name: '6x' },
                                { key: 'fa-7x', name: '7x' },
                                { key: 'fa-8x', name: '8x' },
                                { key: 'fa-9x', name: '9x' },
                                { key: 'fa-10x', name: '10x' }
                            ]
                        },
                        ['fontawesome_' + type + '_stacked_size']: {
                            'type': 'select',
                            'name': 'Stacked size',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [{
                                    key: 'fa-stack-1x',
                                    name: '1x'
                                },
                                {
                                    key: 'fa-stack-2x',
                                    name: '2x'
                                }
                            ]
                        },
                        ['fontawesome_' + type + '_fixed_width']: {
                            type: 'checkbox',
                            name: 'Fixed width',
                            action: 'apply_class',
                            value: 'fa-fw'
                        },
                        ['fontawesome_' + type + '_li']: {
                            type: 'checkbox',
                            name: 'List item',
                            action: 'custom',
                            value: '1',
                            get_value: function (pgel) {
                                return pgel.hasClass('fa-li') ? '1' : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                if (value) {
                                    pgel.addClass('fa-li');
                                    var pgul = pgel.closest('ul');
                                    if (pgul && !pgul.hasClass('fa-ul')) {
                                        pgul.addClass('fa-ul'); //add fa-ul to enclosing ul
                                        pinegrow.showQuickMessage('Class <b>.fa-ul</b> was added to enclosing <b>ul element</b>');
                                    }
                                } else {
                                    pgel.removeClass('fa-li');
                                    //let user manually remove fa-ul class on enclosing ul
                                }
                                return value;
                            }
                        },
                        ['fontawesome_' + type + '_border']: {
                            type: 'checkbox',
                            name: 'Border',
                            action: 'apply_class',
                            value: 'fa-border'
                        },
                        ['fontawesome_' + type + '_pull']: {
                            'type': 'select',
                            'name': 'Pull',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'fa-pull-left', name: 'Left' },
                                { key: 'fa-pull-right', name: 'Right' }
                            ]
                        },
                        ['fontawesome_' + type + '_animation']: {
                            'type': 'select',
                            'name': 'Animation',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'fa-spin', name: 'Spin' },
                                { key: 'fa-pulse', name: 'pulse' }
                            ]
                        },
                        ['fontawesome_' + type + '_rotate']: {
                            'type': 'select',
                            'name': 'Rotate',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'fa-rotate-90', name: '90' },
                                { key: 'fa-rotate-180', name: '180' },
                                { key: 'fa-rotate-270', name: '270' }
                            ]
                        },
                        ['fontawesome_' + type + '_flip']: {
                            'type': 'select',
                            'name': 'Flip',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'fa-flip-both', name: 'Both' },
                                { key: 'fa-flip-horizontal', name: 'Horizontal' },
                                { key: 'fa-flip-vertical', name: 'Vertical' }
                            ]
                        },
                        ['fontawesome_' + type + '_inverse']: {
                            type: 'checkbox',
                            name: 'Inverse color',
                            action: 'apply_class',
                            value: 'fa-inverse'
                        }
                    }
                }
            }
        }

        var solid_icons_def = new PgComponentType('fontawesome_solid_icon', 'FA solid icon', {
            selector: '.fas',
            code: '<i class="fas fa-address-book"></i>',
            sections: getIconSections('solid', icons_options['solid'])
        });
        f.addComponentType(solid_icons_def);

        var regular_icons_def = new PgComponentType('fontawesome_regular_icon', 'FA regular icon', {
            selector: '.far',
            code: '<i class="far fa-address-book"></i>',
            sections: getIconSections('regular', icons_options['regular'])
        });
        f.addComponentType(regular_icons_def);

        var brands_icons_def = new PgComponentType('fontawesome_brands_icon', 'FA brands icon', {
            selector: '.fab',
            code: '<i class="fab fa-angular"></i>',
            sections: getIconSections('brands', icons_options['brands'])
        });
        f.addComponentType(brands_icons_def);


        var stack_def = new PgComponentType('fontawesome_stack', 'FA stack');
        stack_def.selector = '.fa-stack';
        stack_def.code = '<span class="fa-stack fa-lg"><i class="fas fa-circle fa-stack-2x"></i><i class="fas fa-flag fa-stack-1x fa-inverse"></i></span>';
        stack_def.action_menu = {
            add: ['fontawesome_solid_icon', 'fontawesome_regular_icon', 'fontawesome_brands_icon']
        };
        stack_def.sections = {
            fontawesome_options: {
                name: "Stack options",
                fields: {
                    fontawesome_size: {
                        type: 'select',
                        name: 'Size',
                        action: 'apply_class',
                        show_empty: true,
                        options: [
                            { key: 'fa-xs', name: 'Xs' },
                            { key: 'fa-sm', name: 'Sm' },
                            { key: 'fa-lg', name: 'Lg' },
                            { key: 'fa-2x', name: '1x' },
                            { key: 'fa-2x', name: '2x' },
                            { key: 'fa-3x', name: '3x' },
                            { key: 'fa-4x', name: '4x' },
                            { key: 'fa-5x', name: '5x' },
                            { key: 'fa-6x', name: '6x' },
                            { key: 'fa-7x', name: '7x' },
                            { key: 'fa-8x', name: '8x' },
                            { key: 'fa-9x', name: '9x' },
                            { key: 'fa-10x', name: '10x' }
                        ]
                    }
                }
            }
        }
        f.addComponentType(stack_def);

        var pageSeleccted = false;
        f.on_page_selected = function (page) {
            pageSeleccted = true;
        }

        pinegrow.addEventHandler('on_element_selected', function (page, pgel, info) {
            if (pageSeleccted) {
                pageSeleccted = false;
                if (page.frameworks.indexOf(f) > -1) {
                    activateFontawesome5(page);
                }
            }
        });

        f.on_dynamic_element = function(page, status) {
            if(!status.pgel) {
                var $el = status.$el.closest('.svg-inline--fa');
                if($el.length) {
                    status.$el = $el;
                    status.pgel = getElementPgNode($el);
                }
            }
        }

        f.on_before_inline_edit = function(page, $el, status) {
            if($el.find('.svg-inline--fa').length > 0) {
                status.allowed = false;
                status.msg += `Can't use Text editing mode on elements that contain Font Awesome 5 icons included with Javascript. Use Element Code edit ${pgShowKbdCombo('CMD+H')} instead.`;
            }
            //replaceSvgsWithIcons(page, $el);
        }

        var replaceSvgsWithIcons = function(page, $el) {
            $el.find('.svg-inline--fa').each(function(i, e) {
                var $e = $(e);
                var pgel = getElementPgNode($e);
                if(pgel) {
                    var code = pgel.getViewHtml(page);
                    $e.replaceWith($(code));
                }
            })
        }

        f.on_plugin_activated = function(page, done) {
            activateFontawesome5(page);

            //Add support for FA to Editable areas
            var pgc_ext = new PgEditableAreaExtension('fa', 'Font Awesome 5', f);


            var options = {
                getValue: function (node) {
                    return getFaClass(node, getType(node));
                },
                setValue: function (value, node) {
                    var icon = getFaClass(node, getType(node));
                    if (value) {
                        node.removeClass(icon);
                        node.addClass(value);
                    }
                },
                shouldShowField : function(page, $el) {
                    return $el.is('i,.fab,.fas');
                },
                getProperty: function (value, pgel) {
                    if (pgel) {
                        var type = getType(pgel);
                        return {
                            type: 'select',
                            name: 'Font Awesome Icon',
                            options: icons_options[type],
                            rich: {
                                title: 'Select icon',
                                modal: true,
                                class: 'icons-grid'
                            },
                            action: 'custom',
                            get_value: function (pgel) {
                                return getFaClass(pgel, getType(pgel));
                            },
                            set_value: function (pgel, value, values) {
                                var type = getType(pgel);
                                var cls = getFaClass(pgel, type);
                                if (cls) {
                                    pgel.removeClass(cls);
                                }
                                pgel.addClass(value);
                                pgel.addClass('fa' + type[0]);
                                return value;
                            }
                        }
                    }
                },
                canMakeChange : function (pgel, action, data) {
                    return (action == 'add_class' || action == 'remove_class') && icons.indexOf(data) >= 0;
                },
                fieldDefinition : {
                    type: 'checkbox',
                    name: 'Icon',
                    value: '1',
                    empty_attribute: true
                }
            }


            pgc_ext.addField('', options);

            pinegrow.addEditableAreaExtension(pgc_ext);

            //End support for FA to Editable areas
            if (done) done(f);
        }


        //Now, lets define sections and elements shown in LIB tab
        var section = new PgFrameworkLibSection('fontawesome-icons', 'Icons');
        //Pass components in array
        section.setComponentTypes([solid_icons_def, regular_icons_def, brands_icons_def, stack_def]);
        f.addLibSection(section);

        var onAddResourceFilter = function(res) {
            if(add_js && res.type == 'application/javascript') {
                return true;
            } else if(!add_js && res.type == 'text/css') {
                return true;
            }
            return false;
        }

        var res = new PgComponentTypeResource('https://use.fontawesome.com/releases/v5.13.1/js/all.js');
        res.type = 'application/javascript';
        res.footer = true;
        res.on_add_resource_filter = onAddResourceFilter;
        f.resources.add(res);

        var res = new PgComponentTypeResource('https://use.fontawesome.com/releases/v5.13.1/css/all.css');
        res.type = 'text/css';
        res.footer = false;
        res.on_add_resource_filter = onAddResourceFilter;
        f.resources.add(res);

        f.resources.description = "Include Font Awesome CSS and font files from official Font Awesome CDN. Updating resources will add the latest version of Font Awesome CSS to the page. If you have older or local version of Font Awesome linked to the page, remove the old CSS links from the head element.";

        var add_js = true;





        f.on_add_resources = function(is_project, done) {
            pinegrow.showAlert(`<p>Font Awesome 5 can be included to the page in two different ways:</p><ul><li><b>With Javascript</b> that replaces &lt;i&gt; elements with dynamic SVG elements. This option is recommended by Font Awesome, but it <b>requires Javascript</b> to work. Also, text editing mode in Pinegrow can't be used on elements that contain icons included with Javascript.</li><li><b>With classic CSS font stylesheet</b>. The icons are included like a normal CSS stylesheet. This option doesn't require Javascript.</li></ul><p>How would you like to include Font Awesome 5?</p>`, 'Javascript or CSS?', 'Cancel', 'Add with Javascript', null, function() {
                add_js = true;
                done(true);
            }, 'Add with CSS', function() {
                add_js = false;
                done(true);
            })
        }

    });
});