var PgFoundationHelpers = function(options, f, version) {
    if (typeof options.reqVersion != "function") {
        options.reqVersion = function () {
            return true;
        }
    }

    // More options
    options.framework_prefix = 'fd' + version;
    options.container_selector = '.grid-x';
    options.grid_container_selector = 'grid-x';
    options.style = '.pghelper-' + options.framework_prefix + '-column {\
        padding: 0;\
    }';

    var pgFrameworkHelpers = new PgFrameworkHelpers('Foundation', options, f, version, PgFDMenuPointColumnSize);

    pgFrameworkHelpers.getCodeForLarge = function () {
        var code_large;
        switch(this.version) {
            case 6:
                code_large = '<pgdiv class="small-1 pinegrow-ui-helper"><pgdiv class="pinegrow-ui-helper"></pgdiv></pgdiv>';
                break;
        }

        return code_large;
    }

    pgFrameworkHelpers.getCodeForSmall = function () {
        var code_small;
        switch(this.version) {
            case 6:
                code_small = '<pgdiv class="small-1 pinegrow-ui-helper" style="padding-left:0;padding-right:0;"><pgdiv class="pinegrow-ui-helper"></pgdiv></pgdiv>';
                break;
        }

        return code_small;
    }

    pgFrameworkHelpers.getClassForSize = function(size, prefix, add) {
        if(add === null || add === undefined) {
            add = '';
        }  else {
            add = add + '';
        }
        return prefix + size + (add.length ? ('-' + add) : '');
    }

    pgFrameworkHelpers.getColumnSizes = function(pgel_or_node) {
        var re = new RegExp('^(' + options.sizes.join('|') + ')\\-([0-9]+)');

        var map = {};

        var list = pgel_or_node instanceof pgParserNode ? pgel_or_node.getClasses() : pgel_or_node.classList;

        list.forEach(function(cls) {
            var m = cls.match(re);
            if(m) {
                var size = m[1];
                var cols = m[2];
                map[size] = cols;
            }
        })
        return map;
    }

    pgFrameworkHelpers.init();

    return pgFrameworkHelpers;
}