/*
Licensed under MIT license
 */

$(function () {
    //Wait for Pinegrow to wake-up
    $("body").one("pinegrow-ready", function (e, pinegrow) {
        var f = new PgFramework('mat1.0.0', 'Materialize 1.0.0');
        f.type = "materialize";
        f.allow_single_type = true;

        f.description = '<a href="http://materializecss.com/">Materialize</a> starting pages and components. Templates are based on Materialize 1.0.0.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        //Don't show these files in CSS tab
        f.ignore_css_files = [/materialize/i];

        //Auto detect if font-awesome css is included
        f.detect = function (pgPage) {
            return pgPage.hasStylesheet(/materialize/i);
        }

        f.setScriptFileByScriptTagId('plugin-materialize-1-0-0');

        f.customResourceNamespace = '';

        // Tell Pinegrow about the framework
        pinegrow.addFramework(f);

        const FONT_URL = "https://fonts.googleapis.com/icon?family=Material+Icons";

        var bm = new PgToggleButtonMaker();
        var num_columns = 12;

        var showOrbitMessage = function () {
            crsaQuickMessage('Refresh the page (Page -&gt; Refresh / CMD + R) to activate changes.', 2000, true);
        }

        var getPlaceholderImage = function () {
            return pinegrow.getPlaceholderImage();
        }

        var getMatColor = function (type) {
            switch (type) {
                case 'red':
                    return '#f44336';
                case 'pink':
                    return '#e91e63';
                case 'purple':
                    return '#9c27b0';
                case 'deep-purple':
                    return '#673ab7';
                case 'indigo':
                    return '#3f51b5';
                case 'blue':
                    return '#2196f3';
                case 'light-blue':
                    return '#03a9f4';
                case 'cyan':
                    return '#00bcd4';
                case 'teal':
                    return '#009688';
                case 'green':
                    return '#4caf50';
                case 'light-green':
                    return '#8bc34a';
                case 'lime':
                    return '#cddc39';
                case 'yellow':
                    return '#ffeb3b';
                case 'amber':
                    return '#ffc107';
                case 'orange':
                    return '#ff9800';
                case 'deep-orange':
                    return '#ff5722';
                case 'brown':
                    return '#795548';
                case 'grey':
                    return '#9e9e9e';
                case 'blue-grey':
                    return '#607d8b';
                case 'black':
                    return '#000000';
                case 'white':
                    return '#ffffff';
                case 'light':
                    return '#f8f9fa';
                default:
                    return '#fff';
            }
        }

        var icons = ['3d_rotation', 'ac_unit', 'access_alarm', 'access_alarms', 'access_time', 'accessibility', 'accessible', 'account_balance', 'account_balance_wallet', 'account_box', 'account_circle', 'adb', 'add', 'add_a_photo', 'add_alarm', 'add_alert', 'add_box', 'add_circle', 'add_circle_outline', 'add_location', 'add_shopping_cart', 'add_to_photos', 'add_to_queue', 'adjust', 'airline_seat_flat', 'airline_seat_flat_angled', 'airline_seat_individual_suite', 'airline_seat_legroom_extra', 'airline_seat_legroom_normal', 'airline_seat_legroom_reduced', 'airline_seat_recline_extra', 'airline_seat_recline_normal', 'airplanemode_active', 'airplanemode_inactive', 'airplay', 'airport_shuttle', 'alarm', 'alarm_add', 'alarm_off', 'alarm_on', 'album', 'all_inclusive', 'all_out', 'android', 'announcement', 'apps', 'archive', 'arrow_back', 'arrow_downward', 'arrow_drop_down', 'arrow_drop_down_circle', 'arrow_drop_up', 'arrow_forward', 'arrow_upward', 'art_track', 'aspect_ratio', 'assessment', 'assignment', 'assignment_ind', 'assignment_late', 'assignment_return', 'assignment_returned', 'assignment_turned_in', 'assistant', 'assistant_photo', 'attach_file', 'attach_money', 'attachment', 'audiotrack', 'autorenew', 'av_timer', 'backspace', 'backup', 'battery_alert', 'battery_charging_full', 'battery_full', 'battery_std', 'battery_unknown', 'beach_access', 'beenhere', 'block', 'bluetooth', 'bluetooth_audio', 'bluetooth_connected', 'bluetooth_disabled', 'bluetooth_searching', 'blur_circular', 'blur_linear', 'blur_off', 'blur_on', 'book', 'bookmark', 'bookmark_border', 'border_all', 'border_bottom', 'border_clear', 'border_color', 'border_horizontal', 'border_inner', 'border_left', 'border_outer', 'border_right', 'border_style', 'border_top', 'border_vertical', 'branding_watermark', 'brightness_1', 'brightness_2', 'brightness_3', 'brightness_4', 'brightness_5', 'brightness_6', 'brightness_7', 'brightness_auto', 'brightness_high', 'brightness_low', 'brightness_medium', 'broken_image', 'brush', 'bubble_chart', 'bug_report', 'build', 'burst_mode', 'business', 'business_center', 'cached', 'cake', 'call', 'call_end', 'call_made', 'call_merge', 'call_missed', 'call_missed_outgoing', 'call_received', 'call_split', 'call_to_action', 'camera', 'camera_alt', 'camera_enhance', 'camera_front', 'camera_rear', 'camera_roll', 'cancel', 'card_giftcard', 'card_membership', 'card_travel', 'casino', 'cast', 'cast_connected', 'center_focus_strong', 'center_focus_weak', 'change_history', 'chat', 'chat_bubble', 'chat_bubble_outline', 'check', 'check_box', 'check_box_outline_blank', 'check_circle', 'chevron_left', 'chevron_right', 'child_care', 'child_friendly', 'chrome_reader_mode', 'class', 'clear', 'clear_all', 'close', 'closed_caption', 'cloud', 'cloud_circle', 'cloud_done', 'cloud_download', 'cloud_off', 'cloud_queue', 'cloud_upload', 'code', 'collections', 'collections_bookmark', 'color_lens', 'colorize', 'comment', 'compare', 'compare_arrows', 'computer', 'confirmation_number', 'contact_mail', 'contact_phone', 'contacts', 'content_copy', 'content_cut', 'content_paste', 'control_point', 'control_point_duplicate', 'copyright', 'create', 'create_new_folder', 'credit_card', 'crop', 'crop_16_9', 'crop_3_2', 'crop_5_4', 'crop_7_5', 'crop_din', 'crop_free', 'crop_landscape', 'crop_original', 'crop_portrait', 'crop_rotate', 'crop_square', 'dashboard', 'data_usage', 'date_range', 'dehaze', 'delete', 'delete_forever', 'delete_sweep', 'description', 'desktop_mac', 'desktop_windows', 'details', 'developer_board', 'developer_mode', 'device_hub', 'devices', 'devices_other', 'dialer_sip', 'dialpad', 'directions', 'directions_bike', 'directions_boat', 'directions_bus', 'directions_car', 'directions_railway', 'directions_run', 'directions_subway', 'directions_transit', 'directions_walk', 'disc_full', 'dns', 'do_not_disturb', 'do_not_disturb_alt', 'do_not_disturb_off', 'do_not_disturb_on', 'dock', 'domain', 'done', 'done_all', 'donut_large', 'donut_small', 'drafts', 'drag_handle', 'drive_eta', 'dvr', 'edit', 'edit_location', 'eject', 'email', 'enhanced_encryption', 'equalizer', 'error', 'error_outline', 'euro_symbol', 'ev_station', 'event', 'event_available', 'event_busy', 'event_note', 'event_seat', 'exit_to_app', 'expand_less', 'expand_more', 'explicit', 'explore', 'exposure', 'exposure_neg_1', 'exposure_neg_2', 'exposure_plus_1', 'exposure_plus_2', 'exposure_zero', 'extension', 'face', 'fast_forward', 'fast_rewind', 'favorite', 'favorite_border', 'featured_play_list', 'featured_video', 'feedback', 'fiber_dvr', 'fiber_manual_record', 'fiber_new', 'fiber_pin', 'fiber_smart_record', 'file_download', 'file_upload', 'filter', 'filter_1', 'filter_2', 'filter_3', 'filter_4', 'filter_5', 'filter_6', 'filter_7', 'filter_8', 'filter_9', 'filter_9_plus', 'filter_b_and_w', 'filter_center_focus', 'filter_drama', 'filter_frames', 'filter_hdr', 'filter_list', 'filter_none', 'filter_tilt_shift', 'filter_vintage', 'find_in_page', 'find_replace', 'fingerprint', 'first_page', 'fitness_center', 'flag', 'flare', 'flash_auto', 'flash_off', 'flash_on', 'flight', 'flight_land', 'flight_takeoff', 'flip', 'flip_to_back', 'flip_to_front', 'folder', 'folder_open', 'folder_shared', 'folder_special', 'font_download', 'format_align_center', 'format_align_justify', 'format_align_left', 'format_align_right', 'format_bold', 'format_clear', 'format_color_fill', 'format_color_reset', 'format_color_text', 'format_indent_decrease', 'format_indent_increase', 'format_italic', 'format_line_spacing', 'format_list_bulleted', 'format_list_numbered', 'format_paint', 'format_quote', 'format_shapes', 'format_size', 'format_strikethrough', 'format_textdirection_l_to_r', 'format_textdirection_r_to_l', 'format_underlined', 'forum', 'forward', 'forward_10', 'forward_30', 'forward_5', 'free_breakfast', 'fullscreen', 'fullscreen_exit', 'functions', 'g_translate', 'gamepad', 'games', 'gavel', 'gesture', 'get_app', 'gif', 'golf_course', 'gps_fixed', 'gps_not_fixed', 'gps_off', 'grade', 'gradient', 'grain', 'graphic_eq', 'grid_off', 'grid_on', 'group', 'group_add', 'group_work', 'hd', 'hdr_off', 'hdr_on', 'hdr_strong', 'hdr_weak', 'headset', 'headset_mic', 'healing', 'hearing', 'help', 'help_outline', 'high_quality', 'highlight', 'highlight_off', 'history', 'home', 'hot_tub', 'hotel', 'hourglass_empty', 'hourglass_full', 'http', 'https', 'image', 'image_aspect_ratio', 'import_contacts', 'import_export', 'important_devices', 'inbox', 'indeterminate_check_box', 'info', 'info_outline', 'input', 'insert_chart', 'insert_comment', 'insert_drive_file', 'insert_emoticon', 'insert_invitation', 'insert_link', 'insert_photo', 'invert_colors', 'invert_colors_off', 'iso', 'keyboard', 'keyboard_arrow_down', 'keyboard_arrow_left', 'keyboard_arrow_right', 'keyboard_arrow_up', 'keyboard_backspace', 'keyboard_capslock', 'keyboard_hide', 'keyboard_return', 'keyboard_tab', 'keyboard_voice', 'kitchen', 'label', 'label_outline', 'landscape', 'language', 'laptop', 'laptop_chromebook', 'laptop_mac', 'laptop_windows', 'last_page', 'launch', 'layers', 'layers_clear', 'leak_add', 'leak_remove', 'lens', 'library_add', 'library_books', 'library_music', 'lightbulb_outline', 'line_style', 'line_weight', 'linear_scale', 'link', 'linked_camera', 'list', 'live_help', 'live_tv', 'local_activity', 'local_airport', 'local_atm', 'local_bar', 'local_cafe', 'local_car_wash', 'local_convenience_store', 'local_dining', 'local_drink', 'local_florist', 'local_gas_station', 'local_grocery_store', 'local_hospital', 'local_hotel', 'local_laundry_service', 'local_library', 'local_mall', 'local_movies', 'local_offer', 'local_parking', 'local_pharmacy', 'local_phone', 'local_pizza', 'local_play', 'local_post_office', 'local_printshop', 'local_see', 'local_shipping', 'local_taxi', 'location_city', 'location_disabled', 'location_off', 'location_on', 'location_searching', 'lock', 'lock_open', 'lock_outline', 'looks', 'looks_3', 'looks_4', 'looks_5', 'looks_6', 'looks_one', 'looks_two', 'loop', 'loupe', 'low_priority', 'loyalty', 'mail', 'mail_outline', 'map', 'markunread', 'markunread_mailbox', 'memory', 'menu', 'merge_type', 'message', 'mic', 'mic_none', 'mic_off', 'mms', 'mode_comment', 'mode_edit', 'monetization_on', 'money_off', 'monochrome_photos', 'mood', 'mood_bad', 'more', 'more_horiz', 'more_vert', 'motorcycle', 'mouse', 'move_to_inbox', 'movie', 'movie_creation', 'movie_filter', 'multiline_chart', 'music_note', 'music_video', 'my_location', 'nature', 'nature_people', 'navigate_before', 'navigate_next', 'navigation', 'near_me', 'network_cell', 'network_check', 'network_locked', 'network_wifi', 'new_releases', 'next_week', 'nfc', 'no_encryption', 'no_sim', 'not_interested', 'note', 'note_add', 'notifications', 'notifications_active', 'notifications_none', 'notifications_off', 'notifications_paused', 'offline_pin', 'ondemand_video', 'opacity', 'open_in_browser', 'open_in_new', 'open_with', 'pages', 'pageview', 'palette', 'pan_tool', 'panorama', 'panorama_fish_eye', 'panorama_horizontal', 'panorama_vertical', 'panorama_wide_angle', 'party_mode', 'pause', 'pause_circle_filled', 'pause_circle_outline', 'payment', 'people', 'people_outline', 'perm_camera_mic', 'perm_contact_calendar', 'perm_data_setting', 'perm_device_information', 'perm_identity', 'perm_media', 'perm_phone_msg', 'perm_scan_wifi', 'person', 'person_add', 'person_outline', 'person_pin', 'person_pin_circle', 'personal_video', 'pets', 'phone', 'phone_android', 'phone_bluetooth_speaker', 'phone_forwarded', 'phone_in_talk', 'phone_iphone', 'phone_locked', 'phone_missed', 'phone_paused', 'phonelink', 'phonelink_erase', 'phonelink_lock', 'phonelink_off', 'phonelink_ring', 'phonelink_setup', 'photo', 'photo_album', 'photo_camera', 'photo_filter', 'photo_library', 'photo_size_select_actual', 'photo_size_select_large', 'photo_size_select_small', 'picture_as_pdf', 'picture_in_picture', 'picture_in_picture_alt', 'pie_chart', 'pie_chart_outlined', 'pin_drop', 'place', 'play_arrow', 'play_circle_filled', 'play_circle_outline', 'play_for_work', 'playlist_add', 'playlist_add_check', 'playlist_play', 'plus_one', 'poll', 'polymer', 'pool', 'portable_wifi_off', 'portrait', 'power', 'power_input', 'power_settings_new', 'pregnant_woman', 'present_to_all', 'print', 'priority_high', 'public', 'publish', 'query_builder', 'question_answer', 'queue', 'queue_music', 'queue_play_next', 'radio', 'radio_button_checked', 'radio_button_unchecked', 'rate_review', 'receipt', 'recent_actors', 'record_voice_over', 'redeem', 'redo', 'refresh', 'remove', 'remove_circle', 'remove_circle_outline', 'remove_from_queue', 'remove_red_eye', 'remove_shopping_cart', 'reorder', 'repeat', 'repeat_one', 'replay', 'replay_10', 'replay_30', 'replay_5', 'reply', 'reply_all', 'report', 'report_problem', 'restaurant', 'restaurant_menu', 'restore', 'restore_page', 'ring_volume', 'room', 'room_service', 'rotate_90_degrees_ccw', 'rotate_left', 'rotate_right', 'rounded_corner', 'router', 'rowing', 'rss_feed', 'rv_hookup', 'satellite', 'save', 'scanner', 'schedule', 'school', 'screen_lock_landscape', 'screen_lock_portrait', 'screen_lock_rotation', 'screen_rotation', 'screen_share', 'sd_card', 'sd_storage', 'search', 'security', 'select_all', 'send', 'sentiment_dissatisfied', 'sentiment_neutral', 'sentiment_satisfied', 'sentiment_very_dissatisfied', 'sentiment_very_satisfied', 'settings', 'settings_applications', 'settings_backup_restore', 'settings_bluetooth', 'settings_brightness', 'settings_cell', 'settings_ethernet', 'settings_input_antenna', 'settings_input_component', 'settings_input_composite', 'settings_input_hdmi', 'settings_input_svideo', 'settings_overscan', 'settings_phone', 'settings_power', 'settings_remote', 'settings_system_daydream', 'settings_voice', 'share', 'shop', 'shop_two', 'shopping_basket', 'shopping_cart', 'short_text', 'show_chart', 'shuffle', 'signal_cellular_4_bar', 'signal_cellular_connected_no_internet_4_bar', 'signal_cellular_no_sim', 'signal_cellular_null', 'signal_cellular_off', 'signal_wifi_4_bar', 'signal_wifi_4_bar_lock', 'signal_wifi_off', 'sim_card', 'sim_card_alert', 'skip_next', 'skip_previous', 'slideshow', 'slow_motion_video', 'smartphone', 'smoke_free', 'smoking_rooms', 'sms', 'sms_failed', 'snooze', 'sort', 'sort_by_alpha', 'spa', 'space_bar', 'speaker', 'speaker_group', 'speaker_notes', 'speaker_notes_off', 'speaker_phone', 'spellcheck', 'star', 'star_border', 'star_half', 'stars', 'stay_current_landscape', 'stay_current_portrait', 'stay_primary_landscape', 'stay_primary_portrait', 'stop', 'stop_screen_share', 'storage', 'store', 'store_mall_directory', 'straighten', 'streetview', 'strikethrough_s', 'style', 'subdirectory_arrow_left', 'subdirectory_arrow_right', 'subject', 'subscriptions', 'subtitles', 'subway', 'supervisor_account', 'surround_sound', 'swap_calls', 'swap_horiz', 'swap_vert', 'swap_vertical_circle', 'switch_camera', 'switch_video', 'sync', 'sync_disabled', 'sync_problem', 'system_update', 'system_update_alt', 'tab', 'tab_unselected', 'tablet', 'tablet_android', 'tablet_mac', 'tag_faces', 'tap_and_play', 'terrain', 'text_fields', 'text_format', 'textsms', 'texture', 'theaters', 'thumb_down', 'thumb_up', 'thumbs_up_down', 'time_to_leave', 'timelapse', 'timeline', 'timer', 'timer_10', 'timer_3', 'timer_off', 'title', 'toc', 'today', 'toll', 'tonality', 'touch_app', 'toys', 'track_changes', 'traffic', 'train', 'tram', 'transfer_within_a_station', 'transform', 'translate', 'trending_down', 'trending_flat', 'trending_up', 'tune', 'turned_in', 'turned_in_not', 'tv', 'unarchive', 'undo', 'unfold_less', 'unfold_more', 'update', 'usb', 'verified_user', 'vertical_align_bottom', 'vertical_align_center', 'vertical_align_top', 'vibration', 'video_call', 'video_label', 'video_library', 'videocam', 'videocam_off', 'videogame_asset', 'view_agenda', 'view_array', 'view_carousel', 'view_column', 'view_comfy', 'view_compact', 'view_day', 'view_headline', 'view_list', 'view_module', 'view_quilt', 'view_stream', 'view_week', 'vignette', 'visibility', 'visibility_off', 'voice_chat', 'voicemail', 'volume_down', 'volume_mute', 'volume_off', 'volume_up', 'vpn_key', 'vpn_lock', 'wallpaper', 'warning', 'watch', 'watch_later', 'wb_auto', 'wb_cloudy', 'wb_incandescent', 'wb_iridescent', 'wb_sunny', 'wc', 'web', 'web_asset', 'weekend', 'whatshot', 'widgets', 'wifi', 'wifi_lock', 'wifi_tethering', 'work', 'wrap_text', 'youtube_searched_for', 'zoom_in', 'zoom_out', 'zoom_out_map'];

        var wavesEffect = {
            type: 'checkbox',
            action: 'apply_class',
            value: 'waves-effect',
            name: 'Wave Effect'
        }
        var wavesCircle = {
            type: 'checkbox',
            action: 'apply_class',
            value: 'waves-circle',
            name: 'Wave Circle'
        }
        var wavesColor = {
            type : 'select',
            name: 'Wave Color',
            action: 'apply_class',
            show_empty: true,
            toggle_buttons: true,
            options: [
                { key: 'waves-light',  name: 'Light',  'html': bm.makeColorText(getMatColor('light')) },
                { key: 'waves-red',    name: 'Red',    'html': bm.makeColorText(getMatColor('red')) },
                { key: 'waves-yellow', name: 'Yellow', 'html': bm.makeColorText(getMatColor('yellow')) },
                { key: 'waves-orange', name: 'Orange', 'html': bm.makeColorText(getMatColor('orange')) },
                { key: 'waves-purple', name: 'Purple', 'html': bm.makeColorText(getMatColor('purple')) },
                { key: 'waves-green', name: 'Green',   'html': bm.makeColorText(getMatColor('green')) },
                { key: 'waves-teal',  name: 'Teal',    'html': bm.makeColorText(getMatColor('teal')) }
            ]
        }

        var def_all = new PgComponentType('mat-all', 'All elements', {
            selector: function (pgel) { return true },
            name: 'Div',
            display_name: 'tag',
            priority: 2001,
            sections: {
                'mat-text': {
                    name: 'Text &amp; Context',
                    fields: {
                        'mat-flow-text': {
                            'type': 'checkbox',
                            'name': 'Flow text',
                            'action': 'apply_class',
                            'value': 'flow-text'
                        },
                        'mat-truncate': {
                            'type': 'checkbox',
                            'name': 'Truncate',
                            'action': 'apply_class',
                            'value': 'truncate'
                        },
                        'mat-veralign': {
                            'type': 'checkbox',
                            'name': 'Vertical align',
                            'action': 'custom',
                            'value': '1',
                            get_value: function (pgel) {
                                return pgel.hasClass('valign') && pgel.parent.hasClass('valign-wrapper') ? '1' : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pgp = pgel.parent;
                                if (value) {
                                    pgel.addClass('valign');
                                    pgp.addClass('valign-wrapper');
                                } else {
                                    pgel.removeClass('valign');
                                    pgp.removeClass('valign-wrapper');
                                }
                                return value;
                            }
                        },
                        'mat-align': {
                            'type' : 'select',
                            'name' : 'Text align',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'toggle_buttons': true,
                            'options' : [
                                { 'key' : 'left-align', 'name' : 'Left', 'html' : bm.makeIcon('align-left') },
                                { 'key' : 'center-align', 'name' : 'Center', 'html' : bm.makeIcon('align-center') },
                                { 'key' : 'right-align', 'name' : 'Right', 'html' : bm.makeIcon('align-right') }
                            ]
                        },
                        'mat-text-color': {
                            'type' : 'select',
                            'name' : 'Text color',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'toggle_buttons': true,
                            'options' : [
                                { key: 'red-text', name: "Red", html: bm.makeColorText(getMatColor('red')) },
                                { key: 'pink-text', name: "Pink", html: bm.makeColorText(getMatColor('pink')) },
                                { key: 'purple-text', name: "Purple", html: bm.makeColorText(getMatColor('purple')) },
                                { key: 'deep-purple-text', name: "Deep Purple", html: bm.makeColorText(getMatColor('deep-purple'))},
                                { key: 'indigo-text', name: "Indigo", html: bm.makeColorText(getMatColor('indigo')) },
                                { key: 'blue-text', name: "Blue", html: bm.makeColorText(getMatColor('blue')) },
                                { key: 'light-blue-text', name: "Light Blue", html: bm.makeColorText(getMatColor('light-blue')) },
                                { key: 'cyan-text', name: "Cyan", html: bm.makeColorText(getMatColor('cyan')) },
                                { key: 'teal-text', name: "Teal", html: bm.makeColorText(getMatColor('teal')) },
                                { key: 'green-text', name: "Green", html: bm.makeColorText(getMatColor('green')) },
                                { key: 'light-green-text', name: "Light Green", html: bm.makeColorText(getMatColor('light-green'))},
                                { key: 'lime-text', name: "Lime", html: bm.makeColorText(getMatColor('lime')) },
                                { key: 'yellow-text', name: "Yellow", html: bm.makeColorText(getMatColor('yellow')) },
                                { key: 'amber-text', name: "Amber", html: bm.makeColorText(getMatColor('amber')) },
                                { key: 'orange-text', name: "Orange", html: bm.makeColorText(getMatColor('orange')) },
                                { key: 'deep-orange-text', name: "Deep Orange", html: bm.makeColorText(getMatColor('deep-orange'))},
                                { key: 'brown-text', name: "Brown", html: bm.makeColorText(getMatColor('brown')) },
                                { key: 'grey-text', name: "Grey", html: bm.makeColorText(getMatColor('grey')) },
                                { key: 'blue-grey-text', name: "Blue Grey", html: bm.makeColorText(getMatColor('blue-grey')) },
                                { key: 'black-text', name: "Black", html: bm.makeColorText(getMatColor('black')) },
                                { key: 'white-text', name: "White", html: bm.makeColorText(getMatColor('white'), { attributes: { 'title': 'White'  } }) },
                                { key: 'transparent-text', name: "Transparent", html: bm.makeColorText(getMatColor('transparent'), { attributes: { 'title': 'Transparent'  } }) }
                            ]
                        },
                        'mat-text-degree': {
                            'type' : 'select',
                            'name' : 'Color degree',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                { key: 'text-lighten-5', name: "Lighten 5" },
                                { key: 'text-lighten-4', name: "Lighten 4" },
                                { key: 'text-lighten-3', name: "Lighten 3" },
                                { key: 'text-lighten-2', name: "Lighten 2" },
                                { key: 'text-lighten-1', name: "Lighten 1" },
                                { key: 'text-darken-1', name: "Darken 1" },
                                { key: 'text-darken-2', name: "Darken 2" },
                                { key: 'text-darken-3', name: "Darken 3" },
                                { key: 'text-darken-4', name: "Darken 4" },
                                { key: 'text-accent-1', name: "Accent 1" },
                                { key: 'text-accent-2', name: "Accent 2" },
                                { key: 'text-accent-3', name: "Accent 3" },
                                { key: 'text-accent-4', name: "Accent 4" }
                            ]
                        }
                    }
                },
                'mat-background': {
                    name: 'Background',
                    fields: {
                        'mat-bg-color': {
                            'type' : 'select',
                            'name' : 'Background color',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'toggle_buttons': true,
                            'options' : [
                                { key: 'red', name: "Red", html: bm.makeColorText(getMatColor('red')) },
                                { key: 'pink', name: "Pink", html: bm.makeColorText(getMatColor('pink')) },
                                { key: 'purple', name: "Purple", html: bm.makeColorText(getMatColor('purple')) },
                                { key: 'deep-purple', name: "Deep Purple", html: bm.makeColorText(getMatColor('deep-purple')) },
                                { key: 'indigo', name: "Indigo", html: bm.makeColorText(getMatColor('indigo')) },
                                { key: 'blue', name: "Blue", html: bm.makeColorText(getMatColor('blue')) },
                                { key: 'light-blue', name: "Light Blue", html: bm.makeColorText(getMatColor('light-blue')) },
                                { key: 'cyan', name: "Cyan", html: bm.makeColorText(getMatColor('cyan')) },
                                { key: 'teal', name: "Teal", html: bm.makeColorText(getMatColor('teal')) },
                                { key: 'green', name: "Green", html: bm.makeColorText(getMatColor('green')) },
                                { key: 'light-green', name: "Light Green", html: bm.makeColorText(getMatColor('light-green')) },
                                { key: 'lime', name: "Lime", html: bm.makeColorText(getMatColor('lime')) },
                                { key: 'yellow', name: "Yellow", html: bm.makeColorText(getMatColor('yellow')) },
                                { key: 'amber', name: "Amber", html: bm.makeColorText(getMatColor('amber')) },
                                { key: 'orange', name: "Orange", html: bm.makeColorText(getMatColor('orange')) },
                                { key: 'deep-orange', name: "Deep Orange", html: bm.makeColorText(getMatColor('deep-orange')) },
                                { key: 'brown', name: "Brown", html: bm.makeColorText(getMatColor('brown')) },
                                { key: 'grey', name: "Grey", html: bm.makeColorText(getMatColor('grey')) },
                                { key: 'blue-grey', name: "Blue Grey", html: bm.makeColorText(getMatColor('blue-grey')) },
                                { key: 'black', name: "Black", html: bm.makeColorText(getMatColor('black')) },
                                { key: 'white', name: "White", html: bm.makeColorText(getMatColor('white')) },
                                { key: 'transparent', name: "Transparent", html: bm.makeColorText(getMatColor('transparent')) }
                            ]
                        },
                        'mat-bg-degree': {
                            'type' : 'select',
                            'name' : 'Color degree',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                { key: 'lighten-5', name: "Lighten 5" },
                                { key: 'lighten-4', name: "Lighten 4" },
                                { key: 'lighten-3', name: "Lighten 3" },
                                { key: 'lighten-2', name: "Lighten 2" },
                                { key: 'lighten-1', name: "Lighten 1" },
                                { key: 'darken-1', name: "Darken 1" },
                                { key: 'darken-2', name: "Darken 2" },
                                { key: 'darken-3', name: "Darken 3" },
                                { key: 'darken-4', name: "Darken 4" },
                                { key: 'accent-1', name: "Accent 1" },
                                { key: 'accent-2', name: "Accent 2" },
                                { key: 'accent-3', name: "Accent 3" },
                                { key: 'accent-4', name: "Accent 4" }
                            ]
                        }
                    }
                },
                'mat-layout': {
                    name: 'Layout',
                    fields: {
                        'mat-float': {
                            'type': 'select',
                            'name': 'Pull',
                            'action': 'apply_class',
                            'show_empty':  true,
                            'toggle_buttons': true,
                            'options': [
                                { 'key': 'left', 'name' : 'Left', 'html' : bm.makeIcon('float-left', { attributes: { 'title': 'Left' } }) },
                                { 'key': 'right', 'name' : 'Right', 'html' : bm.makeIcon('float-right', { attributes: { 'title': 'right' } }) }
                            ]
                        },
                        'mat-shadow': {
                            type : 'select',
                            action: 'apply_class',
                            show_empty: true,
                            name: 'Shadow',
                            options: [
                                { key: 'z-depth-1', name: "Z Depth 1" },
                                { key: 'z-depth-2', name: "Z Depth 2" },
                                { key: 'z-depth-3', name: "Z Depth 3" },
                                { key: 'z-depth-4', name: "Z Depth 4" },
                                { key: 'z-depth-5', name: "Z Depth 5" }
                            ]
                        }
                    }
                },
                'mat-visibility': {
                    name: 'visibility',
                    fields: {
                        'mat-visibiity-hide' : {
                            'type' : 'select',
                            'name' : 'Hide',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                { 'key' : 'hide', 'name' : 'Hidden for all Devices' },
                                { 'key' : 'hide-on-small-only', 'name' : 'Hidden for Mobile Only' },
                                { 'key' : 'hide-on-med-only', 'name' : 'Hidden for Tablet Only' },
                                { 'key' : 'hide-on-med-and-down', 'name' : 'Hidden for Tablet and Below' },
                                { 'key' : 'hide-on-med-and-up', 'name' : 'Hidden for Tablet and Above' },
                                { 'key' : 'hide-on-large-only', 'name' : 'Hidden for Desktop Only' }
                            ]
                        },
                        'mat-visibiity-show': {
                            'type' : 'select',
                            'name' : 'Show',
                            'action' : 'apply_class',
                            'show_empty' : true,
                            'options' : [
                                { 'key': 'show-on-small',           'name': 'Show for Mobile Only' },
                                { 'key': 'show-on-medium',          'name': 'Show for Tablet Only' },
                                { 'key': 'show-on-large',           'name': 'Show for Desktop Only' },
                                { 'key': 'show-on-medium-and-up',   'name': 'Show for Tablet and Above' },
                                { 'key': 'show-on-medium-and-down', 'name': 'Show for Tablet and Below' }
                            ]
                        }
                    }
                },
                'mat-effect': {
                    name: 'Effect',
                    fields: {
                        'mat-hoverable': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'hoverable',
                            name: 'Hoverable'
                        },
                        'mat-pulse': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'pulse',
                            name: 'Pulse'
                        },
                        'mat-scale-transition': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'scale-transition',
                            name: 'Scale transition'
                        },
                        'mat-scale-out': {
                            type: 'checkbox',
                            show_if: "mat-scale-transition",
                            action: 'apply_class',
                            value: 'scale-out',
                            name: 'Scale out'
                        }
                    }
                },
                'mat-javascript': {
                    name: 'Javascript',
                    fields: {
                        'mat-materialboxed': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'materialboxed',
                            name: 'Material Boxed'
                        },
                        'mat-scrollspy': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'scrollspy',
                            name: 'Scrollspy'
                        },
                        'mat-data-target': {
                            type: 'text',
                            action: 'element_attribute',
                            attribute: 'data-target',
                            name: 'Target'
                        },
                        'mat-tooltipped': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'tooltipped',
                            name: 'Tooltipped'
                        },
                        'mat-tooltipped-data-tooltip': {
                            type: 'text',
                            name: 'Text',
                            action: 'element_attribute',
                            attribute: 'data-tooltip',
                            show_if: "mat-tooltipped"
                        },
                        'mat-tooltipped-data-position': {
                            type: 'select',
                            name: 'Position',
                            action: 'element_attribute',
                            attribute: 'data-position',
                            show_if: "mat-tooltipped",
                            show_empty: true,
                            options: [
                                { key: 'left', name: 'Left' },
                                { key: 'top', name: 'Top' },
                                { key: 'right', name: 'Right' },
                                { key: 'bottom', name: 'Bottom' },
                            ]
                        },
                    }
                }
            }
        });
        f.addComponentType(def_all);

        var def_container = new PgComponentType('mat-container', 'Container', {
            'selector': '.container',
            'tags': 'major',
            'empty_placeholder': true,
            'inline_edit': true,
            'code': '<div class="container"></div>',
            'action_menu': {
                add: ['mat-row']
            }
        });
        f.addComponentType(def_container);

        var def_row = new PgComponentType('mat-row', 'Row', {
            'selector': '.row',
            'tags': 'major',
            'empty_placeholder': true,
            'inline_edit': true,
            'code': '<div class="row"></div>',
            'action_menu': {
                add: ['mat-column']
            },
        });
        f.addComponentType(def_row);

        var createColumnSpans = function (name, base, empty, start) {
            if (typeof start == 'undefined') start = 1;
            var span_select = {
                'type': 'select',
                'name': null,
                'action': 'apply_class',
                'show_empty': empty,
                'options': []
            }
            for (var n = start; n <= num_columns; n++) {
                span_select.options.push({
                    key: base + n,
                    name: n
                });
            }
            return span_select;
        }

        var def_col = new PgComponentType('mat-column', 'Column', {
            'selector': '.col',
            'parent_selector': '.row',
            'tags': 'major',
            'empty_placeholder': true,
            'inline_edit': true,
            'code': '<div class="col s12 m4 l4">\
                <h3>Column title</h3>\
                <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
            </div>',
            'sections': {
                layout: {
                    name: "Layout",
                    fields: {
                        layout_control: {
                            type: 'custom',
                            name: 'layout_control',
                            action: 'none',
                            show: function ($dest, obj, fn, fdef, values, $scrollParent) {
                                var sizes = ["s", "m", "l"];
                                var fields = ["", "offset-", "push-", "pull-"];
                                var field_names = ["Span&nbsp;", "Offs&nbsp;", "Push&nbsp;", "Pull&nbsp;"];
                                var field_keys = ["span_", "offset_", "push_", "pull_"];
                                var $table = $("<table/>", {
                                    class: 'grid-control columns-control four-col-grid'
                                }).appendTo($dest);
                                var $row = $("<tr/>").html("<td></td><td><label>S</label></td><td><label>M</label></td><td><label>L</label></td>").appendTo($table);

                                for (var n = 0; n < fields.length; n++) {
                                    $row = $("<tr/>").appendTo($table);
                                    var $td = $("<td/>").html('<label>' + field_names[n] + '</label>').appendTo($row);
                                    for (var m = 0; m < sizes.length; m++) {
                                        $td = $("<td/>").appendTo($row);

                                        var field = field_keys[n] + sizes[m];
                                        $.fn.crsa("addInputField", $td, obj, field, createColumnSpans(field_names[n], fields[n] + sizes[m], true, fields[n] == '' ? 1 : 0), values, false, $scrollParent);
                                    }
                                }
                            }
                        }
                    }
                },
                layout_phone: {
                    name: 'Phone',
                    show: false,
                    fields: {
                        span_s: createColumnSpans("Span", "s", true),
                        offset_s: createColumnSpans("Offs", "s-offset", true, 0),
                        push_s: createColumnSpans("Push", "s-push", true, 0),
                        pull_s: createColumnSpans("Pull", "s-pull", true, 0),
                        span_m: createColumnSpans("Span", "m", true),
                        offset_m: createColumnSpans("Offs", "m-offset", true, 0),
                        push_m: createColumnSpans("Push", "m-push", true, 0),
                        pull_m: createColumnSpans("Pull", "m-pull", true, 0),
                        span_l: createColumnSpans("Span", "l", true),
                        offset_l: createColumnSpans("Offs", "l-offset", true, 0),
                        push_l: createColumnSpans("Push", "l-push", true, 0),
                        pull_l: createColumnSpans("Pull", "l-pull", true, 0)
                    }
                }
            }
        });
        f.addComponentType(def_col);

        var grid_section = new PgFrameworkLibSection('mat-grid', 'Grid');
        grid_section.setComponentTypes([def_container, def_row, def_col]);
        f.addLibSection(grid_section);



        var def_button = new PgComponentType('mat-button', 'Button', {
            'selector': '.btn,.btn-large,.btn-flat,.btn-floating',
            'tags': 'major',
            'code': '<a class="btn">Button</a>',
            'sections': {
                'mat-button' : {
                    'name': 'Button Options',
                    'fields': {
                        'mat-button-waves-effect': wavesEffect,
                        'mat-button-waves-circle': wavesCircle,
                        'mat-button-floating': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'btn-floating',
                            name: 'Floating button'
                        },
                        'mat-button-disabled': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'disabled',
                            name: 'Disabled button'
                        },
                        'mat-button-waves-color' : wavesColor,
                        'mat-button-type' : {
                            type : 'select',
                            action: 'apply_class',
                            name: 'Button Type',
                            show_empty: true,
                            options: [
                                {key: 'btn', name: "Regular"},
                                {key: 'btn-large', name: "Large"},
                                {key: 'btn-small', name: "Small"},
                                {key: 'btn-flat', name: "Flat"}
                            ]
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-icon']
            }
        });
        f.addComponentType(def_button);

        var def_floating_button = new PgComponentType('mat-floating-button', 'Floating button', {
            selector: '.btn-floating',
            code: '<a class="btn-floating halfway-fab waves-effect waves-light red"><i class="material-icons">add</i></a>',
            'sections': {
                'mat-floating-button': {
                    'name': 'Floating button',
                    'fields': {
                        'mat-floating-button-halfway-fab': {
                            type: 'checkbox',
                            name: 'Halfway fab',
                            action: 'apply_class',
                            value: 'halfway-fab'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_floating_button);

        // Fixed action button
        var def_fixed_button = new PgComponentType('mat-fixed-button', 'Fixed Action Button', {
            'selector': '.fixed-action-btn',
            'tags': 'major',
            'preview_image': 'fixedActionButton.png',
            'code': '<div class="fixed-action-btn">\
                <a class="btn-floating btn-large red">\
                    <i class="large material-icons">mode_edit</i>\
                </a>\
                <ul>\
                    <li><a class="btn-floating red"><i class="material-icons">insert_chart</i></a></li>\
                    <li><a class="btn-floating yellow darken-1"><i class="material-icons">format_quote</i></a></li>\
                    <li><a class="btn-floating green"><i class="material-icons">publish</i></a></li>\
                    <li><a class="btn-floating blue"><i class="material-icons">attach_file</i></a></li>\
                </ul>\
            </div>',
            'action_menu': {
                add: ['mat-floating-button', 'ul-html']
            }
        });
        f.addComponentType(def_fixed_button);

        var button_section = new PgFrameworkLibSection('mat-button', 'Button');
        button_section.setComponentTypes([def_button, def_floating_button, def_fixed_button]);
        f.addLibSection(button_section);



        var textImagesSection = [];
        var hoptions = [
            {key: 'h1', name: 'Heading 1'},
            {key: 'h2', name: 'Heading 2'},
            {key: 'h3', name: 'Heading 3'},
            {key: 'h4', name: 'Heading 4'},
            {key: 'h5', name: 'Heading 5'},
            {key: 'h6', name: 'Heading 6'}
        ];

        $.each(hoptions, function (i, hopt) {
            var h = hopt.key;
            var def_head = new PgComponentType('mat-' + h, h, {
                'selector': h,
                'code': '<' + h + '>Heading ' + (i + 1) + '</' + h + '>',
                'sections': {
                    'mat-head-style': {
                        name: 'Heading',
                        fields: {
                            description: {
                                'type': 'select',
                                'name': 'Level',
                                'action': 'custom',
                                'show_empty': false,
                                options: hoptions,
                                get_value: function (pgel) {
                                    for (var i = 0; i < hoptions.length; i++) {
                                        if (pgel.tagName == hoptions[i].key) {
                                            return hoptions[i].key;
                                        }
                                    }
                                    return null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();
                                    var newpgel = pgel.replaceTag(value);
                                    return value;
                                }
                            }
                        }
                    }
                }
            });
            f.addComponentType(def_head);
            textImagesSection.push(def_head);
        });

        var def_blockquote = new PgComponentType('mat-blockquote', 'Blockquote', {
            'selector': 'blockquote',
            'preview_image': 'blockquote.png',
            'tags': 'major',
            'code': '<blockquote>\
                This is an example quotation that uses the blockquote tag.\
            </blockquote>'
        });
        f.addComponentType(def_blockquote);
        textImagesSection.push(def_blockquote);

        var def_image = new PgComponentType('mat-img', 'Image', {
            'selector' : 'img',
            'code' : function() {
                return '<img src="' + getPlaceholderImage() + '" width="200"/>'
            },
            'sections' : {
                'mat-image' : {
                    name : 'Image',
                    fields : {
                        'src' : {name : 'Url', type : 'image', action: 'element_attribute', attribute: 'src'},
                        'alt' : {name : 'Alt', type : 'text', action: 'element_attribute', attribute: 'alt'},
                        'width' : {name : 'Width', type : 'text', action: 'element_attribute', attribute: 'width'},
                        'height' : {name : 'Height', type : 'text', action: 'element_attribute', attribute: 'height'},
                        'circle' : {
                            'type' : 'checkbox',
                            'name' : 'Circle',
                            'action' : 'apply_class',
                            'value' : 'circle'
                        },
                        responsive : {
                            type: 'checkbox',
                            name: 'Responsive',
                            action: 'apply_class',
                            value: 'responsive-img'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_image);
        textImagesSection.push(def_image);

        var def_video_cont = new PgComponentType('mat-video-container', 'Video container', {
            'selector': '.video-container',
            'empty_placeholder': true,
            'code': '<div class="video-container">\
                <iframe width="853" height="480" src="//www.youtube.com/embed/Q8TXgCzxEnw?rel=0" frameborder="0" allowfullscreen></iframe>\
            </div>'
        });
        f.addComponentType(def_video_cont);
        textImagesSection.push(def_video_cont);

        var def_res_video = new PgComponentType('mat-responsive-video', 'Responsive video', {
            'selector': '.video-container',
            'drag_helper': '<div class="pg-empty-placeholder">Video container</div>',
            'empty_placeholder': true,
            'code': '<video class="responsive-video" controls>\
                <source src="movie.mp4" type="video/mp4">\
            </video>'
        });
        f.addComponentType(def_res_video);
        textImagesSection.push(def_res_video);

        var icons_options = [];
        for(var i = 0; i < icons.length; i++) {
            var g = icons[i];
            icons_options.push({key: g, name: g, html: '<i class="material-icons">' + g + '</i>'});
        }

        var def_icon = new PgComponentType('mat-icon', 'Icon', {
            'selector': '.material-icons',
            'preview_image': 'icon.png',
            'code': '<i class="material-icons">add</i>',
            'sections': {
                'maticons' : {
                    'name': "Icon options",
                    'fields': {
                        'mat-icons-select' : {
                            type: 'select',
                            name: 'Icon',
                            options: icons_options,
                            rich: {
                                'title': 'Select icon',
                                'modal': true,
                                'class': 'icons-grid'
                            },
                            'action': 'custom',
                            get_value: function (pgel) {
                                return pgel.html();
                            },
                            set_value: function (pgel, value, values) {
                                pgel.html(value);
                                return value;
                            }
                        },
                        'mat-icons-size' : {
                            'type' : 'select',
                            'action': 'apply_class',
                            'show_empty': true,
                            'name': 'Icon Size',
                            'options': [
                                { key: 'tiny', name: "Tiny" },
                                { key: 'small', name: "Small" },
                                { key: 'medium', name: "Medium" },
                                { key: 'large', name: "Large" }
                            ]
                        },
                        'mat-icons-align' : {
                            'type' : 'select',
                            'action': 'apply_class',
                            'show_empty': true,
                            'name': 'Icon Align',
                            'options': [
                                {key: 'prefix', name: "Prefix"},
                                {key: 'left', name: "Left"},
                                {key: 'right', name: "Right"}
                            ]
                        }
                    }
                }
            }
        });
        f.addComponentType(def_icon);
        textImagesSection.push(def_icon);

        var text_images_section = new PgFrameworkLibSection('mat-text-images', 'Text &amp; Images');
        text_images_section.setComponentTypes(textImagesSection);
        f.addLibSection(text_images_section);



        // Form
        var def_form = new PgComponentType('mat-form', 'Form', {
            'selector': 'form',
            'tags': 'major',
            'preview_image': 'form.png',
            'code': '<form>\
                <div class="row">\
                    <div class="input-field col s6">\
                        <input placeholder="Placeholder" id="first_name" type="text" class="validate">\
                        <label for="first_name">First Name</label>\
                    </div>\
                    <div class="input-field col s6">\
                        <input id="last_name" type="text" class="validate">\
                        <label for="last_name">Last Name</label>\
                    </div>\
                </div>\
                <div class="row">\
                    <div class="input-field col s12">\
                        <i class="material-icons prefix">remove_circle</i>\
                        <input disabled value="I am not editable" id="disabled" type="text" class="validate">\
                        <label for="disabled">Disabled</label>\
                    </div>\
                </div>\
                <div class="row">\
                    <div class="input-field col s12">\
                        <select>\
                            <option value="" disabled selected>Choose your option</option>\
                            <option value="1">Option 1</option>\
                            <option value="2">Option 2</option>\
                            <option value="3">Option 3</option>\
                        </select>\
                        <label>Materialize Select</label>\
                    </div>\
                </div>\
                <div class="row">\
                    <div class="input-field col s12">\
                        <textarea id="textarea1" class="materialize-textarea"></textarea>\
                        <label for="textarea1">Message</label>\
                    </div>\
                </div>\
                <input type="submit" class="btn red" value="Stuff">\
            </form>',
            'action_menu': {
                add: ['mat-input-field', 'mat-file-field', 'mat-checkbox-field', 'mat-radio-field', 'mat-range-field', 'mat-switch-field']
            },
            'on_inserted': function () {
                showOrbitMessage();
            }
        });
        f.addComponentType(def_form);

        var def_input_field = new PgComponentType('mat-input-field', 'Input field', {
            'selector': '.input-field',
            'code': '<div class="input-field">\
                <input placeholder="Placeholder" id="first_name" type="text" class="validate">\
                <label for="first_name">First Name</label>\
            </div>',
            'action_menu': {
                add: ['mat-label', 'mat-icon', 'mat-input', 'mat-textarea', 'mat-helper-text']
            },
            'sections': {
                'mat-input-field': {
                    'name': 'Input options',
                    'fields': {
                        'mat-input-field-inline': {
                            type: 'checkbox',
                            name: 'Inline',
                            action: 'apply_class',
                            value: 'inline'
                        },
                        'mat-input-field-file-field': {
                            type: 'checkbox',
                            name: 'File field',
                            action: 'apply_class',
                            value: 'file-field'
                        },
                    }
                }
            }
        });
        f.addComponentType(def_input_field);

        var def_file_field = new PgComponentType('mat-file-field', 'File field', {
            'selector': '.file-field',
            'preview_image': 'fileField.png',
            'priority': '100',
            'code': '<div class="file-field input-field">\
                <div class="btn">\
                    <span>File</span>\
                    <input type="file">\
                </div>\
                <div class="file-path-wrapper">\
                    <input class="file-path validate" type="text">\
                </div>\
            </div>',
            'sections': {
                'mat-file-field': {
                    'name': 'File field options',
                    'fields': {
                        'mat-file-field-multiple' : {
                            'type' : 'checkbox',
                            'name' : 'Multiple',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('input[type="file"]');
                                return pginput.getAttr('multiple');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('input[type="file"]');
                                if (value) {
                                    pgel.getAttr('multiple', value);
                                } else {
                                    pgel.removeAttr('multiple');
                                }
                                return value;
                            }
                        }
                    }
                }
            }
        });
        f.addComponentType(def_file_field);

        var inputDataLength = {
            type: 'slider',
            name: 'Data length',
            action: 'element_attribute',
            attribute: 'data-length'
        };

        var inputDisabled = {
            type: 'checkbox',
            name: 'Disabled',
            action: 'custom',
            value: '1',
            get_value: function (pgel) {
                return pgel.hasAttr('disabled') ? '1' : null;
            },
            set_value: function (pgel, value) {
                if (value) {
                    pgel.setAttr('disabled', 'disabled');
                }
                else {
                    pgel.removeAttr('disabled');
                }

                return value;
            }
        }

        var def_input = new PgComponentType('mat-input', 'Input', {
            'type': 'mat-input',
            'selector_new': function (pgel) {
                if(pgel.tagName == 'input' && pgel.getAttr('type') != 'checkbox' && pgel.getAttr('type') != 'radio') return true;
                return false;
            },
            'name': 'Input',
            'code': '<input placeholder="Placeholder" type="text">',
            'sections': {
                'mat-input': {
                    'name': 'Input options',
                    'fields': {
                        'mat-input-validate': {
                            type: 'checkbox',
                            name: 'Validate',
                            action: 'apply_class',
                            value: 'validate'
                        },
                        'mat-input-disabled': inputDisabled,
                        'mat-input-type': {
                            type: 'select',
                            name: 'Type',
                            action: 'apply_class',
                            options: [
                                { key: 'datepicker', name: 'Date picker' },
                                { key: 'timepicker', name: 'Time Picker' }
                            ]
                        },
                        'mat-input-data-length': inputDataLength,
                    }
                }
            }
        });
        f.addComponentType(def_input);

        var def_label = new PgComponentType('mat-label', 'Label', {
            'selector': 'label',
            'code': '<label>Label</label>',
        });
        f.addComponentType(def_label);

        var def_helper_text = new PgComponentType('mat-helper-text', 'Helper text', {
            'selector': '.helper-text',
            'code': '<span class="helper-text" data-error="wrong" data-success="right">Helper text</span>',
            'sections': {
                'mat-helper-text': {
                    'name': 'Helper text options',
                    'fields': {
                        'mat-helper-text-data-success': {
                            type: 'text',
                            name: 'Success text',
                            action: 'element_attribute',
                            attribute: 'data-success'
                        },
                        'mat-helper-text-data-error': {
                            type: 'text',
                            name: 'Error text',
                            action: 'element_attribute',
                            attribute: 'data-error'
                        },
                    }
                }
            }
        });
        f.addComponentType(def_helper_text);

        var def_textarea = new PgComponentType('mat-textarea', 'Textarea', {
            'selector': 'textarea',
            'code': '<textarea class="materialize-textarea"></textarea>',
            'sections': {
                name: 'Textarea options',
                fields: {
                    'mat-textarea-data-length': inputDataLength,
                }
            }
        });
        f.addComponentType(def_textarea);

        var def_checkbox_field = new PgComponentType('mat-checkbox-field', 'Checkbox field', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'label' && pgel.find('> input[type="checkbox"]').length > 0) return true;
                return false;
            },
            'code': '<label>\
                <input type="checkbox" />\
                <span>Label for checkbox</span>\
            </label>'
        });
        f.addComponentType(def_checkbox_field);

        var def_checkbox = new PgComponentType('mat-checkbox', 'Checkbox', {
            'selector': '[type="checkbox"]',
            'code': '<input type="checkbox" />',
            'sections': {
                'mat-checkbox': {
                    name: 'Checkbox options',
                    fields: {
                        'mat-checkbox-filled-in': {
                            type: 'checkbox',
                            name: 'Filled in',
                            action: 'apply_class',
                            value: 'filled-in'
                        },
                        'mat-checkbox-disabled': inputDisabled,
                    }
                }
            }
        });
        f.addComponentType(def_checkbox);

        var def_radio_field = new PgComponentType('mat-radio-field', 'Radio field', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'label' && pgel.find('> input[type="radio"]').length > 0) return true;
                return false;
            },
            'code': '<label>\
                <input type="radio" />\
                <span>Radio text</span>\
            </label>'
        });
        f.addComponentType(def_radio_field);

        var def_radio = new PgComponentType('mat-radio', 'Radio', {
            'selector': '[type="radio"]',
            'code': '<input type="radio" />',
            'sections': {
                'mat-radio': {
                    name: 'Radio options',
                    fields: {
                        'mat-radio-with-gap': {
                            type: 'checkbox',
                            name: 'With gap',
                            action: 'apply_class',
                            value: 'with-gap'
                        },
                        'mat-radio-disabled': inputDisabled,
                    }
                }
            }
        });
        f.addComponentType(def_radio);

        var def_range_field = new PgComponentType('mat-range-field', 'Range field', {
            'selector': '.range-field',
            'code': '<p class="range-field">\
                <input type="range" min="0" max="100" />\
            </p>'
        });
        f.addComponentType(def_range_field);

        var def_switch_field = new PgComponentType('mat-switch-field', 'Switch field', {
            'type': 'mat-switch',
            'selector': '.switch',
            'preview_image': 'switchInput.png',
            'code': '<div class="switch">\
                <label>\
                    Off\
                    <input type="checkbox">\
                    <span class="lever"></span>\
                    On\
                </label>\
            </div>',
            'sections': {
                'mat-switch': {
                    'name': 'Switch options',
                    'fields': {
                        'mat-switch-disabled' : {
                            'type' : 'checkbox',
                            'name' : 'Disabled',
                            'action' : 'custom',
                            'value' : '1',
                            get_value: function (pgel) {
                                var pginput = pgel.findOne('input[type="checkbox"]');
                                return pginput.hasAttr('disabled');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pginput = pgel.findOne('input[type="checkbox"]');
                                if (value) {
                                    pginput.setAttr('disabled', true);
                                } else {
                                    pginput.removeAttr('disabled');
                                }
                                return value;
                            }
                        }
                    }
                }
            }
        });
        f.addComponentType(def_switch_field);

        var def_select = new PgComponentType('mat-select', 'Select', {
            'selector': 'select',
            'code': '<select>\
                <option value="" disabled selected>Choose your option</option>\
                <option value="" data-icon="images/sample-1.jpg">example 1</option>\
                <option value="" data-icon="images/office.jpg">example 2</option>\
                <option value="" data-icon="images/yuna.jpg">example 3</option>\
            </select>',
            'sections': {
                'mat-select': {
                    name: 'Select options',
                    fields: {
                        'mat-select-icons': {
                            type: 'checkbox',
                            name: 'Icons',
                            action: 'apply_class',
                            value: 'icons'
                        },
                        'mat-select-browser-default': {
                            type: 'checkbox',
                            name: 'Browser default',
                            action: 'apply_class',
                            value: 'browser-default'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_select);

        var def_select_option = new PgComponentType('mat-select-option', 'Option', {
            'selector': 'option',
            'code': '<option value="">Choose your option</option>',
            'sections': {
                'mat-select-option': {
                    name: 'Select options',
                    fields: {
                        'mat-select-option-disabled': inputDisabled,
                        'mat-select-option-icons': {
                            type: 'text',
                            name: 'Icon',
                            action: 'element_attribute',
                            attribute: 'data-icon'
                        },
                        'matoptioniconposition' : {
                            'type': 'select',
                            'name': 'Icon position',
                            'action': 'apply_class',
                            'show_empty': true,
                            'toggle_buttons': true,
                            'options': [
                                { 'key': 'left', 'name': 'Left', 'html' : bm.makeIcon('align-left') },
                                { 'key': 'right', 'name': 'Right', 'html' : bm.makeIcon('align-right') }
                            ]
                        }
                    }
                }
            }
        });
        f.addComponentType(def_select_option);

        var form_section = new PgFrameworkLibSection('mat-form', 'Form');
        form_section.setComponentTypes([def_form, def_input_field, def_file_field, def_checkbox_field, def_radio_field, def_range_field, def_switch_field, def_input, def_textarea, def_checkbox, def_radio, def_select]);
        f.addLibSection(form_section);



        var getTablePreviewCode = function(t) {
            return '<table class="table preview-' + t + '">\
                <thead>\
                    <tr>\
                        <th>#</th>\
                        <th>First Name</th>\
                        <th>Last Name</th>\
                        <th>Username</th>\
                    </tr>\
                </thead>\
                <tbody>\
                    <tr class="sel">\
                        <td>1</td>\
                        <td class="sel">Mark</td>\
                        <td>Otto</td>\
                        <td>@mdo</td>\
                    </tr>\
                    <tr>\
                        <td>2</td>\
                        <td>Jacob</td>\
                        <td>Thornton</td>\
                        <td>@fat</td>\
                    </tr>\
                    <tr>\
                        <td>3</td>\
                        <td>Larry</td>\
                        <td>the Bird</td>\
                        <td>@twitter</td>\
                    </tr>\
                </tbody>\
            </table>';
        }

        var def_table = new PgComponentType('mat-table', 'Table', {
            'selector': 'table',
            'tags': 'major',
            'preview_image': 'table.png',
            'code': '<table>\
                <thead>\
                    <tr>\
                        <th data-field="id">Name</th>\
                        <th data-field="name">Item Name</th>\
                        <th data-field="price">Item Price</th>\
                    </tr>\
                </thead>\
                <tbody>\
                    <tr>\
                        <td>Alvin</td>\
                        <td>Eclair</td>\
                        <td>$0.87</td>\
                    </tr>\
                    <tr>\
                        <td>Alan</td>\
                        <td>Jellybean</td>\
                        <td>$3.76</td>\
                    </tr>\
                    <tr>\
                        <td>Jonathan</td>\
                        <td>Lollipop</td>\
                        <td>$7.00</td>\
                    </tr>\
                </tbody>\
            </table>',
            'sections': {
                'mat-table-option' : {
                    'name': 'Table options',
                    'fields': {
                        'mat-table-type' : {
                            'type': 'select',
                            'name': 'Table type',
                            'action': 'apply_class',
                            'show_empty': true,
                            'options': [
                                { key: 'striped', name: "Striped" },
                                { key: 'centered', name: "Centered" },
                                { key: 'highlight', name: "Highlight" },
                                { key: 'responsive-table', name: "Responsive Table" }
                            ]
                        }
                    }
                }
            }
        });
        f.addComponentType(def_table);

        var def_table_head = new PgComponentType('mat-thead', 'Table heading', {
            'selector': 'thead',
            'parent_selector': 'table',
            'code': '<thead><tr><td></td></tr></thead>',
            'preview': getTablePreviewCode('thead'),
        });
        f.addComponentType(def_table_head);

        var def_table_body = new PgComponentType('mat-tbody', 'Table body', {
            'selector': 'tbody',
            'parent_selector': 'table',
            'code' : '<tbody><tr><td></td></tr></tbody>',
            'preview': getTablePreviewCode('tbody'),
        });
        f.addComponentType(def_table_body);

        var def_table_row = new PgComponentType('mat-tr', 'Table row', {
            'selector' : 'tr',
            'parent_selector': 'table,tbody,thead,tfooter',
            'code': '<tr><td></td></tr>',
            'preview': getTablePreviewCode('tr')
        });
        f.addComponentType(def_table_row);

        var def_table_cell = new PgComponentType('mat-td', 'Table cell', {
            'selector': 'td',
            'parent_selector': 'tr',
            'code': '<td></td>',
            'preview': getTablePreviewCode('td')
        });
        f.addComponentType(def_table_cell);

        var tables_section = new PgFrameworkLibSection('mat-table', 'Tables');
        tables_section.setComponentTypes([def_table, def_table_head, def_table_body, def_table_row, def_table_cell]);
        f.addLibSection(tables_section);



        // Navbar
        var def_navbar = new PgComponentType('mat-navbar', 'Navbar', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'nav' && pgel.find('> .nav-wrapper').length > 0) return true;
                return false;
            },
            'preview_image': 'navbar.png',
            'tags': 'major',
            'priority': 100,
            'code': '<nav>\
                <div class="nav-wrapper">\
                    <a href="#" class="brand-logo">Logo</a>\
                    <ul id="nav-mobile" class="right hide-on-med-and-down">\
                        <li><a href="#">Sass</a></li>\
                        <li><a href="#">Components</a></li>\
                        <li>\
                            <a class="dropdown-button" href="#dropdown1" data-activates="dropdown1">\
                                Dropdown<i class="material-icons right">arrow_drop_down</i>\
                            </a>\
                            <ul id="dropdown1" class="dropdown-content">\
                                <li><a href="#!">one</a></li>\
                                <li><a href="#!">two</a></li>\
                                <li class="divider"></li>\
                                <li><a href="#!">three</a></li>\
                            </ul>\
                        </li>\
                    </ul>\
                </div>\
            </nav>',
            'sections': {
                'mat-navbar': {
                    'name': 'Navbar options',
                    'fields': {
                        'mat-navbar-fixed': {
                            'type': 'checkbox',
                            'name': 'Fixed navbar',
                            'action': 'custom',
                            value: '1',
                            get_value: function (pgel) {
                                var pgp = pgel.parent;
                                return pgp && pgp.hasClass('navbar-fixed') ? '1' : null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pgp = pgel.parent;
                                if (value && !pgp.hasClass('navbar-fixed')) {
                                    var fixedPgel = pgCreateNodeFromHtml('<div class="navbar-fixed"></div>');
                                    fixedPgel.insertBefore(pgel);
                                    fixedPgel.append(pgel);
                                } else if (pgp.hasClass('navbar-fixed')) {
                                    pgel.insertBefore(pgp);
                                    pgp.remove();
                                }
                                return value;
                            }
                        },
                        'mat-navbar-extended': {
                            'type': 'checkbox',
                            'name': 'Extended',
                            'action': 'apply_class',
                            'value': 'nav-extended'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-nav-wrapper', 'mat-nav-content']
            }
        });
        f.addComponentType(def_navbar);

        var def_nav_content = new PgComponentType('mat-nav-content', 'Navbar content', {
            'selector': '.nav-content',
            'tags': 'major',
            'code': '<div class="nav-content">\
                <span class="nav-title">Title</span>\
                <a class="btn-floating btn-large halfway-fab waves-effect waves-light teal">\
                    <i class="material-icons">add</i>\
                </a>\
            </div>',
            'action_menu': {
                add: ['mat-nav-title', 'mat-floating-button']
            }
        });
        f.addComponentType(def_nav_content);

        var def_nav_title = new PgComponentType('mat-nav-title', 'Navbar title', {
            'selector': '.nav-title',
            'tags': 'major',
            'code': '<span class="nav-title">Title</span>'
        });
        f.addComponentType(def_nav_title);

        var def_nav_wrapper = new PgComponentType('mat-nav-wrapper', 'Nav wrapper', {
            'selector': '.nav-wrapper',
            'code': '<div class="nav-wrapper"></div>',
            'tags': 'major',
            'action_menu': {
                add: ['mat-navbar-logo', 'mat-navbar-list', 'mat-sidenav-trigger', 'mat-navbar-search']
            }
        });
        f.addComponentType(def_nav_wrapper);

        var def_search_navbar = new PgComponentType('mat-search-navbar', 'Search navbar', {
            'type': 'mat-search-navbar',
            'name': 'Search navbar',
            'preview_image': 'searchBar.png',
            'code': ' <nav>\
                <div class="nav-wrapper">\
                    <form>\
                        <div class="input-field">\
                        <input id="search" type="search" required>\
                        <label class="label-icon" for="search"><i class="material-icons">search</i></label>\
                        <i class="material-icons">close</i>\
                        </div>\
                    </form>\
                </div>\
            </nav>'
        });
        f.addComponentType(def_search_navbar);

        var def_navbar_form = new PgComponentType('mat-navbar-search', 'Navbar form', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'form' && pgel.parent && pgel.parent.hasClass('nav-wrapper')) return true;
                return false;
            },
            'tags': 'major',
            'priority': 100,
            'code': '<form>\
                <div class="input-field">\
                    <input id="search" type="search" required>\
                    <label class="label-icon" for="search"><i class="material-icons">search</i></label>\
                    <i class="material-icons">close</i>\
                </div>\
            </form>'
        });
        f.addComponentType(def_navbar_form);

        var def_navbar_fixed = new PgComponentType('mat-navbar-fixed', 'Navbar fixed', {
            'selector': '.navbar-fixed',
            'tags': 'major',
            'code': '<div class="navbar-fixed"></div>',
            'action_menu': {
                add: ['mat-navbar']
            }
        });
        f.addComponentType(def_navbar_fixed);

        var def_navbar_logo = new PgComponentType('mat-navbar-logo', 'Navbar logo', {
            'selector': '.brand-logo',
            'preview_image': 'logo.png',
            'code': '<a href="#" class="brand-logo">Logo</a>',
            'sections': {
                'mat-navbar-logo': {
                    'name': 'Logo options',
                    'fields': {
                        'mat-navbar-logo-align': {
                            'type' : 'select',
                            'action': 'apply_class',
                            'name': 'Align',
                            'show_empty': true,
                            'toggle_buttons': true,
                            'options': [
                                { key: 'left', name: "Left", 'html' : bm.makeIcon('align-left') },
                                { key: 'center', name: "Center", 'html' : bm.makeIcon('align-center') },
                                { key: 'right', name: "Right", 'html' : bm.makeIcon('align-right') }
                            ]
                        }
                    }
                }
            }
        });
        f.addComponentType(def_navbar_logo);

        var def_navbar_list = new PgComponentType('mat-navbar-list', 'Navbar list', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'ul' && pgel.parent && pgel.parent.is('.nav-wrapper')) return true;
                return false;
            },
            'preview_image': 'navMobile.png',
            'code': '<ul id="nav-mobile" class="right hide-on-med-and-down">\
                <li><a href="#">Sass</a></li>\
                <li><a href="#">Components</a></li>\
                <li><a href="#">JavaScript</a></li>\
            </ul>',
            'sections': {
                'mat-navbar-list' : {
                    'name': 'Navbar list options',
                    'fields': {
                        'mat-navbar-list-align': {
                            'type': 'select',
                            'action': 'apply_class',
                            'name': 'Align',
                            'show_empty': true,
                            'toggle_buttons': true,
                            'options': [
                                { key: 'left', name: "Left", 'html' : bm.makeIcon('align-left') },
                                { key: 'right', name: "Right", 'html' : bm.makeIcon('align-right') }
                            ]
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-navbar-list-item']
            }
        });
        f.addComponentType(def_navbar_list);

        var def_navbar_list_item = new PgComponentType('mat-navbar-list-item', 'Navbar list item', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'li' && pgel.parent && pgel.parent.parent && pgel.parent.parent.isSelector('.nav-wrapper')) return true;
                return false;
            },
            'preview_image': 'navElement.png',
            'code': '<li><a href="#">Link item</a></li>',
            'sections': {
                'mat-navbar-list-item' : {
                    name : 'Navbar list item options',
                    fields : {
                        'mat-navbar-list-item-active' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'active',
                            name: 'Active'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_navbar_list_item);

        var def_sidenav_button = new PgComponentType('mat-sidenav-trigger', 'Sidenav trigger', {
            'selector': '.sidenav-trigger',
            'parent_selector': '.nav-wrapper',
            'preview_image': 'collapseButton.png',
            'code': '<a href="#" data-target="mobile-demo" class="sidenav-trigger"><i class="material-icons">menu</i></a>',
            'tags': 'major',
            'sections': {
                'mat-sidenav-button': {
                    'name': 'sidenav button options',
                    'fields': {
                        'mat-sidenav-button-data-actiates': {
                            'type': 'text',
                            'name': 'Data Activate',
                            'action': 'custom',
                            'live_update': true,
                            get_value: function (pgel) {
                                return pgel.getAttr('data-target');
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pgsidenavList = pgel.siblings('#' + pgel.attr('data-target'));

                                if (pgsidenavList.length > 0) {
                                    pgsidenavList.setAttr('id', value);
                                }
                                pgel.setAttr('data-target', value);
                                return value;
                            }
                        }
                    }
                }
            },
            'on_changed': function () {
                // showOrbitMessage();
            }
        });
        f.addComponentType(def_sidenav_button);

        var def_sidenav = new PgComponentType('mat-sidenav', 'Sidenav', {
            'selector': '.sidenav',
            'tags': 'major',
            'preview_image': 'collapseList.png',
            'code': function () {
                var id = getUniqueId('sidenav-');

                return '<ul class="sidenav" id="' + id + '">\
                    <li><a href="sass.html">Sass</a></li>\
                    <li><a href="badges.html">Components</a></li>\
                    <li><a href="collapsible.html">JavaScript</a></li>\
                </ul>';
            },
            'action_menu': {
                add: ['mat-sidenav-list-item']
            }
        });
        f.addComponentType(def_sidenav);

        var def_sidenav_item = new PgComponentType('mat-sidenav-list-item', 'Sidenav list item', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'li' && pgel.parent && pgel.parent.parent && pgel.parent.parent.isSelector('.sidenav')) return true;
                return false;
            },
            'code': '<li><a href="#">Link item</a></li>',
            'sections': {
                'mat-sidenav-list-item': {
                    name : 'Sidenav list item options',
                    fields : {
                        'mat-sidenav-list-item-active' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'active',
                            name: 'Active'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_sidenav_item);

        // Breadcrumb
        var def_breadcrumb = new PgComponentType('mat-breadcrumb', 'Breadcrumb', {
            'selector': '.breadcrumb',
            'preview_image': 'breadcrumb.png',
            'code': '<nav>\
                <div class="nav-wrapper">\
                    <div class="col s12">\
                        <a href="#!" class="breadcrumb">First</a>\
                        <a href="#!" class="breadcrumb">Second</a>\
                        <a href="#!" class="breadcrumb">Third</a>\
                    </div>\
                </div>\
            </nav>'
        });
        f.addComponentType(def_breadcrumb);

        // Pagination
        var def_pagination = new PgComponentType('mat-pagination', 'Pagination', {
            'selector': '.pagination',
            'preview_image': 'pagination.png',
            'tags': 'major',
            'code': '<ul class="pagination">\
                <li class="disabled"><a href="#!"><i class="material-icons">chevron_left</i></a></li>\
                <li class="active"><a href="#!">1</a></li>\
                <li class="waves-effect"><a href="#!">2</a></li>\
                <li class="waves-effect"><a href="#!">3</a></li>\
                <li class="waves-effect"><a href="#!">4</a></li>\
                <li class="waves-effect"><a href="#!">5</a></li>\
                <li class="waves-effect"><a href="#!"><i class="material-icons">chevron_right</i></a></li>\
            </ul>',
            'action_menu': {
                'add': ['mat-pagination-prev-arrow', 'mat-pagination-item', 'mat-pagination-next-arrow']
            }
        });
        f.addComponentType(def_pagination);

        var def_pagination_item = new PgComponentType('mat-pagination-item', 'Pagination item', {
            'selector_new': function (pgel) {
                var pgp = pgel.parent;
                if (pgel.tagName == 'li' && pgp && pgp.hasClass('pagination')) return true;
                return false;
            },
            'code': '<li class="waves-effect"><a href="#!">0</a></li>',
            'sections': {
                'mat-pagination-item' : {
                    'name': 'Pagination item options',
                    'fields': {
                        'mat-pagination-item-diabled': {
                            'type': 'checkbox',
                            'name': 'Disabled',
                            'action': 'apply_class',
                            'value': 'disabled'
                        },
                        'mat-pagination-item-active': {
                            'type': 'checkbox',
                            'name': 'Active',
                            'action': 'apply_class',
                            'value': 'active'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_pagination_item);

        var def_pagination_prev_arrow = new PgComponentType('mat-pagination-prev-arrow', 'Pagination prev arrow', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'li') {
                    var pgp = pgel.parent;
                    if (pgp && pgp.hasClass('pagination')) {
                        var icon = pgel.findOne('> a > .material-icons');
                        if (icon && icon.html() == "chevron_left") return true;
                    }
                }
                return false;
            },
            'priority': 100,
            'code': '<li><a href="#!"><i class="material-icons">chevron_left</i></a></li>',
        });
        f.addComponentType(def_pagination_prev_arrow);

        var def_pagination_next_arrow = new PgComponentType('mat-pagination-next-arrow', 'Pagination next arrow', {
            'selector_new': function (pgel) {
                if (pgel.tagName == 'li') {
                    var pgp = pgel.parent;
                    if (pgp && pgp.hasClass('pagination')) {
                        var icon = pgel.findOne('> a > .material-icons');
                        if (icon && icon.html() == "chevron_right") return true;
                    }
                }
                return false;
            },
            'priority': 100,
            'code': '<li><a href="#!"><i class="material-icons">chevron_right</i></a></li>'
        });
        f.addComponentType(def_pagination_next_arrow);

        var navigation_section = new PgFrameworkLibSection('mat-navigation', 'Navigation');
        navigation_section.setComponentTypes([def_navbar, def_search_navbar, def_sidenav, def_breadcrumb, def_pagination]);
        f.addLibSection(navigation_section);



        var def_section = new PgComponentType('mat-section', 'Section', {
            'selector': '.section',
            'empty_placeholder': true,
            'inline_edit': true,
            'code': '<div class="section">\
                <h5>Section 1</h5>\
                <p>Stuff</p>\
            </div>',
        });
        f.addComponentType(def_section);

        var def_divider = new PgComponentType('mat-divider', 'Divider', {
            'selector': '.divider',
            'code': '<div class="divider"></div>'
        });
        f.addComponentType(def_divider);

        var def_badge = new PgComponentType('mat-badge', 'Badge', {
            'selector': '.badge',
            'preview_image': 'badge.png',
            'code': '<span class="badge">144</span>',
            'sections': {
                'mat-badge': {
                    name: 'Badge Options',
                    fields: {
                        'mat-badge-shape': {
                            type: 'checkbox',
                            action: 'apply_class',
                            value: 'new',
                            name: 'New'
                        },
                        'mat-badge-caption': {
                            type: 'text',
                            name: 'Caption',
                            action: 'element_attribute',
                            attribute: 'data-badge-caption'
                        }
                    }
                }
            }
        });
        f.addComponentType(def_badge);

        // Card
        var activatorField = {
            type: 'checkbox',
            action: 'apply_class',
            value: 'activator',
            name: 'Activator'
        }

        var def_card = new PgComponentType('mat-card', 'Card', {
            'selector': '.card',
            'preview_image': 'card.png',
            'tags': 'major',
            'code': '<div class="card blue-grey darken-1">\
                <div class="card-content white-text">\
                    <span class="card-title">Card Title</span>\
                    <p>I am a very simple card. I am good at containing small bits of information.\
                    I am convenient because I require little markup to use effectively.</p>\
                </div>\
                <div class="card-action">\
                    <a href="#">This is a link</a>\
                    <a href="#">This is a link</a>\
                </div>\
            </div>',
            'sections': {
                'mat-card' : {
                    name : 'Card options',
                    fields : {
                        'mat-card-horizontal': {
                            type: 'checkbox',
                            name: 'Horizontal',
                            action: 'apply_class',
                            value: 'horizontal'
                        },
                        'mat-card-sticky-action': {
                            type: 'checkbox',
                            name: 'Sticky action',
                            action: 'apply_class',
                            value: 'sticky-action'
                        },
                        'mat-card-size': {
                            type: 'select',
                            action: 'apply_class',
                            name: 'Card',
                            show_empty: true,
                            options: [
                                {key: 'small', name: "Small"},
                                {key: 'medium', name: "Medium"},
                                {key: 'large', name: "Large"}
                            ]
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-card-image-container', 'mat-card-content', 'mat-card-action', 'mat-card-reveal', 'mat-card-stacked', 'mat-card-tabs']
            }
        });
        f.addComponentType(def_card);

        var def_card_stacked = new PgComponentType('mat-card-stacked', 'Card stacked', {
            'selector': '.card-stacked',
            'preview_image': 'cardContent.png',
            'parent_selector': '.card',
            'code': function () {
                return '<div class="card-stacked">\
                    <div class="card-content">\
                        <p>I am a very simple card. I am good at containing small bits of information.</p>\
                    </div>\
                    <div class="card-action">\
                        <a href="#">This is a link</a>\
                    </div>\
                </div>';
            },
            'sections': {
                'mat-card-image-container' : {
                    name : 'Card Image Container Options',
                    fields : {
                        'mat-card-image-container-waves-effect' : wavesEffect,
                        'mat-card-image-container-waves-circle': wavesCircle,
                        'mat-card-image-container-waves-color': wavesColor,
                        'mat-card-image-container-waves-block' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'waves-block',
                            name: 'Wave Block'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-card-image', 'mat-card-title', 'mat-floating-button']
            }
        });
        f.addComponentType(def_card_stacked);

        var def_card_image_cont = new PgComponentType('mat-card-image-container', 'Card image container', {
            'selector': '.card-image',
            'preview_image': 'cardImage.png',
            'parent_selector': '.card',
            'code': function () {
                return '<div class="card-image">\
                    <img src="' + getPlaceholderImage() + '">\
                    <span class="card-title">Card Title</span>\
                </div>';
            },
            'sections': {
                'mat-card-image-container' : {
                    name : 'Card Image Container Options',
                    fields : {
                        'mat-card-image-container-waves-effect' : wavesEffect,
                        'mat-card-image-container-waves-circle': wavesCircle,
                        'mat-card-image-container-waves-color': wavesColor,
                        'mat-card-image-container-waves-block' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'waves-block',
                            name: 'Wave Block'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-card-image', 'mat-card-title', 'mat-floating-button']
            }
        });
        f.addComponentType(def_card_image_cont);

        var def_card_image = new PgComponentType('mat-card-image', 'Card image', {
            'selector_new': function (pgel) {
                var pgp = pgel.parent;
                if (pgel.is('img') && (pgp && pgp.hasClass('card-image'))) return true;
                return false;
            },
            'parent_selector': '.card-image',
            'preview_image': 'cardImage.png',
            'code': function () {
                return '<img src="' + getPlaceholderImage() + '">';
            },
            'sections': {
                'mat-card-image' : {
                    name : 'Card Image Options',
                    fields : {
                        'mat-card-image-activator': activatorField
                    }
                }
            }
        });
        f.addComponentType(def_card_image);

        var def_card_content = new PgComponentType('mat-card-content', 'Card content', {
            'selector': '.card-content',
            'parent_selector': '.card',
            'preview_image': 'cardContent.png',
            'code': '<div class="card-content white-text">\
                <span class="card-title">Card Title</span>\
                <p>I am a very simple card. I am good at containing small bits of information.\
                I am convenient because I require little markup to use effectively.</p>\
            </div>',
            'action_menu': {
                add: ['mat-card-title', 'html-p']
            }
        });
        f.addComponentType(def_card_content);

        var def_card_title = new PgComponentType('mat-card-title', 'Card title', {
            'selector': '.card-title',
            'parent_selector': '.card-image,.card-content',
            'code': '<span class="card-title">Card Title</span>',
            'sections': {
                'mat-card-title': {
                    name: 'Card title',
                    fields: {
                        'mat-card-title-activator': activatorField
                    }
                }
            }
        });
        f.addComponentType(def_card_title);

        var def_card_action = new PgComponentType('mat-card-action', 'Card action', {
            'selector': '.card-action',
            'parent_selector': '.card',
            'preview_image': 'cardAction.png',
            'code': '<div class="card-action">\
                <a href="#">This is a link</a>\
                <a href="#">This is a link</a>\
            </div>',
            'action_menu': {
                add: ['html-a']
            }
        });
        f.addComponentType(def_card_action);

        var def_card_reveal = new PgComponentType('mat-card-reveal', 'Card reveal', {
            'selector': '.card-reveal',
            'parent_selector': '.card',
            'preview_image': 'cardReveal.png',
            'code': '<div class="card-reveal">\
                <span class="card-title grey-text text-darken-4">Card Title<i class="material-icons right">close</i></span>\
                <p>Here is some more information about this product that is only revealed once clicked on.</p>\
            </div>',
            'action_menu': {
                add: ['mat-card-title', 'html-p', 'html-span']
            }
        });
        f.addComponentType(def_card_reveal);

        var def_card_tabs = new PgComponentType('mat-card-tabs', 'Card tabs', {
            'selector': '.card-tabs',
            'preview_image': 'cardTabs.png',
            'tags': 'major',
            'code': function () {
                var id1 = getUniqueId('tab', null, 0);
                var id2 = getUniqueId('tab', null, id1);
                var id3 = getUniqueId('tab', null, id2);

                return '<div class="card-tabs">\
                    <ul class="tabs tabs-fixed-width">\
                        <li class="tab"><a class="active" href="#' + id1 + '">Test 1</a></li>\
                        <li class="tab"><a href="#' + id2 + '">Test 2</a></li>\
                        <li class="tab"><a href="#' + id3 + '">Test 3</a></li>\
                    </ul>\
                </div>'
            },
            on_inserted: function (pgel) {
                var pgtc = pgCreateNodeFromHtml('<div class="card-content grey lighten-4"></div>').insertAfter(pgel);

                var pgtabs = pgel.findOne('.tabs');
                var pgelchildren = pgtabs.children;
                var j = 0;
                for (var i = 0; i < pgelchildren.length; i++) {
                    var pgt = pgelchildren[i];

                    if (pgt.is('li')) {
                        var id = pgt.findOne('> a').getAttr('href');
                        if (id) id = id.replace('#', '');
                        var pgp = pgCreateNodeFromHtml('<div>Test ' + (j + 1) + '</div>');
                        if (id) pgp.setAttr('id', id);
                        if (j == 0) pgp.addClass('active');
                        pgtc.append(pgp);
                        j++;
                    }
                }
            },
        });
        f.addComponentType(def_card_tabs);

        var def_card_panel = new PgComponentType('mat-card-panel', 'Card panel', {
            'selector': '.card-panel',
            'preview_image': 'cardPanel.png',
            'tags': 'major',
            'code': '<div class="card-panel teal">\
                <span class="white-text">I am a very simple card. I am good at containing small bits of information.\
                I am convenient because I require little markup to use effectively. I am similar to what is called a panel in other frameworks.\
                </span>\
            </div>',
            'action_menu': {
                add: ['html-p', 'html-span']
            }
        });
        f.addComponentType(def_card_panel);

        // Collection
        var def_collection = new PgComponentType('mat-collection', 'Collection', {
            'selector': '.collection',
            'tags': 'major',
            'preview_image': 'collection.png',
            'code': '<ul class="collection">\
                <li class="collection-item">Alvin<span class="badge">1</span></li>\
                <li class="collection-item">Alvin</li>\
                <li class="collection-item">Alvin<span class="new badge">4</span></li>\
                <li class="collection-item">Alvin</li>\
            </ul>',
            'sections': {
                'mat-collection' : {
                    name : 'Collection options',
                    fields : {
                        'mat-collection-with-header': {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'with-header',
                            name: 'With header'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-collection-header', 'mat-collection-item', 'mat-collection-link-item', 'mat-collection-avatar-item', 'mat-collection-secondary-item']
            }
        });
        f.addComponentType(def_collection);

        var def_collection_item = new PgComponentType('mat-collection-item', 'Collection item', {
            'selector': '.collection-item',
            'parent_selector': '.collection',
            'preview_image': 'collectionItem.png',
            'code': '<li class="collection-item">Alvin</li>',
            'sections': {
                'mat-collection-item' : {
                    'name': 'Collection item options',
                    'fields': {
                        'mat-collection-item-active' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'active',
                            name: 'Active'
                        },
                        'mat-collection-item-avatar' : {
                            type : 'checkbox',
                            action: 'apply_class',
                            value: 'avatar',
                            name: 'Avatar'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-secondary-for-collection-item', 'mat-badge']
            }
        });
        f.addComponentType(def_collection_item);

        var def_collection_header = new PgComponentType('mat-collection-header', 'Collection header', {
            'selector': '.collection-header',
            'parent_selector': '.collection',
            'preview_image': 'collectionHeader.png',
            'code': '<li class="collection-header"><h4>Collection Header</h4></li>'
        });
        f.addComponentType(def_collection_header);

        var def_collection_link_item = new PgComponentType('mat-collection-link-item', 'Collection link item', {
            'parent_selector': '.collection',
            'preview_image': 'linkCollectionItem.png',
            'code': '<a href="#!" class="collection-item">Alvin</a>'
        });
        f.addComponentType(def_collection_link_item);

        var def_collection_avatar_item = new PgComponentType('mat-collection-avatar-item', 'Collection avatar item', {
            'selector': '.collection-item.avatar',
            'parent_selector': '.collection',
            'preview_image': 'avatarCollectionItem.png',
            'code': '<li class="collection-item avatar">\
                <img src="assets/img/user.png" class="circle">\
                <span class="title">Title</span>\
                <p>First Line <br>\
                    Second Line\
                </p>\
                <a href="#!" class="secondary-content"><i class="material-icons">grade</i></a>\
            </li>',
            'action_menu': {
                add: ['html-img', 'html-span', 'html-p']
            }
        });
        f.addComponentType(def_collection_avatar_item);

        var def_collection_secondary_item = new PgComponentType('mat-collection-secondary-item', 'Collection with secondary item', {
            'parent_selector': '.collection',
            'preview_image': 'collectionItemWithSecondary.png',
            'code': '<li class="collection-item"><div>Alvin<a href="#!" class="secondary-content"><i class="material-icons">send</i></a></div></li>'
        });
        f.addComponentType(def_collection_secondary_item);

        var def_sec_for_collection_item = new PgComponentType('mat-secondary-for-collection-item', 'Collection secondary item', {
            'parent_selector': '.collection-item',
            'preview_image': 'collectionSecondaryItem.png',
            'code': '<a href="#!" class="secondary-content"><i class="material-icons">send</i></a>'
        });
        f.addComponentType(def_sec_for_collection_item);

        // Footer
        var def_footer = new PgComponentType('mat-footer', 'Footer', {
            'selector': '.page-footer',
            'name': 'Footer',
            'tags': 'major',
            'preview_image': 'footer.png',
            'code': '<footer class="page-footer">\
                <div class="container">\
                    <div class="row">\
                    <div class="col l6 s12">\
                        <h5 class="white-text">Footer Content</h5>\
                        <p class="grey-text text-lighten-4">You can use rows and columns here to organize your footer content.</p>\
                    </div>\
                    <div class="col l4 offset-l2 s12">\
                        <h5 class="white-text">Links</h5>\
                        <ul>\
                        <li><a class="grey-text text-lighten-3" href="#!">Link 1</a></li>\
                        <li><a class="grey-text text-lighten-3" href="#!">Link 2</a></li>\
                        <li><a class="grey-text text-lighten-3" href="#!">Link 3</a></li>\
                        <li><a class="grey-text text-lighten-3" href="#!">Link 4</a></li>\
                        </ul>\
                    </div>\
                    </div>\
                </div>\
                <div class="footer-copyright">\
                    <div class="container">\
                    © 2014 Copyright Text\
                    <a class="grey-text text-lighten-4 right" href="#!">More Links</a>\
                    </div>\
                </div>\
            </footer>',
            'action_menu': {
                add: ['mat-container', 'mat-footer-copyright']
            }
        });
        f.addComponentType(def_footer);

        var def_footer_copyright = new PgComponentType('mat-footer-copyright', 'Footer copyright', {
            'selector': '.footer-copyright',
            'parent_selector': '.page-footer',
            'preview_image': 'footer-copyright.png',
            'code': '<div class="footer-copyright">\
                <div class="container">\
                    © 2014 Copyright Text\
                    <a class="grey-text text-lighten-4 right" href="#!">More Links</a>\
                </div>\
            </div>',
            'action_menu': {
                add: ['mat-container', 'html-a']
            }
        });
        f.addComponentType(def_footer_copyright);

        // Progressbar
        var getProgressBarChild = function (pgel) {
            var pgchild = pgel.findOne('> .determinate');
            if (!pgchild) {
                pgchild = pgel.findOne('> .indeterminate');
            }

            return pgchild;
        }

        var def_progressbar = new PgComponentType('mat-progressbar', 'Progress bar', {
            'selector': '.progress',
            'preview_image': 'progressBar.png',
            'code': '<div class="progress">\
                <div class="determinate" style="width: 70%"></div>\
            </div>',
            'sections': {
                'mat-progressbar' : {
                    name: 'Progress bar',
                    fields: {
                        'mat-progressbar-type' : {
                            'type' : 'select',
                            'name' : 'Type',
                            'action' : 'custom',
                            'show_empty' : false,
                            'options' : [
                                {key: 'determinate', name: 'Determinate'},
                                {key: 'indeterminate', name: 'Indeterminate'}
                            ],
                            get_value: function (pgel) {
                                var pgchild = getProgressBarChild(pgel);

                                if (pgchild.hasClass('determinate')) {
                                    return 'determinate';
                                }
                                else if (pgchild.hasClass('indeterminate')) {
                                    return 'indeterminate';
                                }

                                return null;
                            },
                            set_value: function (pgel, value, values, oldValue, eventType) {
                                var pgchild = getProgressBarChild(pgel);

                                if (pgchild) pgchild.removeClass(oldValue);
                                if (value) {
                                    if (!pgchild) {
                                        pgchild = pgCreateNodeFromHtml('<div class="' + value + '"></div>');
                                        pgchild.appendTo(pgel);
                                    }
                                    pgchild.addClass(value);
                                }

                                return value;
                            }
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-determinate-progressbar', 'mat-indeterminate-progressbar']
            }
        });
        f.addComponentType(def_progressbar);

        var progressbar_sections = {
            'matprogressbar' : {
                name : 'Progress bar options',
                fields : {
                    'matprogressbartype' : {
                        'type' : 'select',
                        'name' : 'Type',
                        'action' : 'apply_class',
                        'show_empty' : false,
                        'options' : [
                            {key: 'determinate', name: 'Determinate'},
                            {key: 'indeterminate', name: 'Indeterminate'}
                        ]
                    }
                }
            }
        }

        var def_determinate_progressbar = new PgComponentType('mat-determinate-progressbar', 'Determinate', {
            'selector': '.determinate',
            'parent_selector': '.progress',
            'code': '<div class="determinate" style="width: 70%"></div>',
            'sections': progressbar_sections
        });
        f.addComponentType(def_determinate_progressbar);

        var def_indeterminate_progressbar = new PgComponentType('mat-indeterminate-progressbar', 'Indeterminate', {
            'selector': '.indeterminate',
            'parent_selector': '.progress',
            'code': '<div class="indeterminate"></div>',
            'sections': progressbar_sections
        });
        f.addComponentType(def_indeterminate_progressbar);

        // Preload circular
        var def_circular_preload = new PgComponentType('mat-circular-preload', 'Circular preload', {
            'selector': '.preloader-wrapper',
            'preview_image': 'preloadCircular.png',
            'tags': 'major',
            'code': '<div class="preloader-wrapper big active">\
                <div class="spinner-layer spinner-blue-only">\
                    <div class="circle-clipper left">\
                        <div class="circle"></div>\
                    </div>\
                    <div class="gap-patch">\
                        <div class="circle"></div>\
                    </div>\
                    <div class="circle-clipper right">\
                        <div class="circle"></div>\
                    </div>\
                </div>\
            </div>',
            'sections': {
                'mat-circular-preload' : {
                    'name': 'Circular Preload Options',
                    'fields': {
                        'mat-circular-preload-active' : {
                            'type': 'checkbox',
                            'action': 'apply_class',
                            'value': 'active',
                            'name': 'Active'
                        },
                        'mat-circular-preload-size' : {
                            'type': 'select',
                            'action': 'apply_class',
                            'name': 'Circular size',
                            'show_empty': true,
                            'options': [
                                { key: 'big', name: "Big" },
                                { key: 'small', name: "Small" }
                            ]
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-spinner-layer']
            }
        });
        f.addComponentType(def_circular_preload);

        var def_spinner_layer = new PgComponentType('mat-spinner-layer', 'Spinner layer', {
            'selector': '.spinner-layer',
            'parent_selector': '.preloader-wrapper',
            'code': '<div class="spinner-layer spinner-blue-only">\
                <div class="circle-clipper left">\
                    <div class="circle"></div>\
                </div>\
                <div class="gap-patch">\
                    <div class="circle"></div>\
                </div>\
                <div class="circle-clipper right">\
                    <div class="circle"></div>\
                </div>\
            </div>',
            'sections': {
                'mat-spinner-layer' : {
                    name : 'Circular Preload Options',
                    fields : {
                        'mat-spinner-layer-color' : {
                            type : 'select',
                            action: 'apply_class',
                            name: 'Spinner Color',
                            options: [
                                { key: 'spinner-blue-only', name: "Blue Only" },
                                { key: 'spinner-blue', name: "Blue" },
                                { key: 'spinner-red-only', name: "Red Only" },
                                { key: 'spinner-red', name: "Red" },
                                { key: 'spinner-yellow-only', name: "Yellow Only" },
                                { key: 'spinner-yellow', name: "Yellow" },
                                { key: 'spinner-green-only', name: "Green Only" },
                                { key: 'spinner-green', name: "Green" }
                            ]
                        }
                    }
                }
            },
            'on_inserted': function () {
                showOrbitMessage();
            },
            'on_changed': function () {
                showOrbitMessage();
            }
        });
        f.addComponentType(def_spinner_layer);

        var uielement_section = new PgFrameworkLibSection('mat-elements', 'UI Elements');
        uielement_section.setComponentTypes([def_section, def_divider, def_badge, def_card, def_card_panel, def_progressbar, def_circular_preload, def_collection, def_footer]);
        f.addLibSection(uielement_section);



        // Carousel
        var gotoCarouselSlide = function (pgel) {
            var id = pgel.findOne('> img').getId();
            var code = '$(\'[data-pg-id="' + id + '"]\').click();';
            var page = pgel.getPage();

            pinegrow.setIgnoreClicks(true);
            pinegrow.executeScriptInPage(page, code);
            pinegrow.setIgnoreClicks(false);
        }

        // Slider
        var callSlider = function (pgel, func, msg) {
            var id = pgel.getId();
            var code = '$(\'[data-pg-id="' + id + '"]\').' + func + ';';

            var page = pgel.getPage();
            pinegrow.setIgnoreClicks(true);
            pinegrow.executeScriptInPage(page, code);
            pinegrow.setIgnoreClicks(false);
            if (msg) {
                pinegrow.showQuickMessage(msg);
            }
        }

        var def_carousel = new PgComponentType('mat-carousel', 'Carousel', {
            'selector': '.carousel',
            'tags': 'major',
            'code': function () {
                return '<div class="carousel" data-carousel>\
                    <a class="carousel-item" href="#one!"><img src="' + getPlaceholderImage() + '"></a>\
                    <a class="carousel-item" href="#two!"><img src="' + getPlaceholderImage() + '"></a>\
                    <a class="carousel-item" href="#three!"><img src="' + getPlaceholderImage() + '"></a>\
                    <a class="carousel-item" href="#four!"><img src="' + getPlaceholderImage() + '"></a>\
                    <a class="carousel-item" href="#five!"><img src="' + getPlaceholderImage() + '"></a>\
                </div>'
            },
            'action_menu': {
                actions : [
                    {label: "Next slide", action: function (pgel) {
                        callSlider(pgel, "carousel('next')");
                    }},
                    {label: "Previous slide", action: function (pgel) {
                        callSlider(pgel, "carousel('prev')");
                    }}
                ],
                add: ['mat-carousel-slide']
            }
        });
        f.addComponentType(def_carousel);

        var def_carousel_slide = new PgComponentType('mat-carousel-slide', 'Carousel slide', {
            'selector': '.carousel-item',
            'code': function () {
                return '<a class="carousel-item" href="#five!"><img src="' + getPlaceholderImage() + '"></a>';
            },
            'action_menu': {
                add: ['html-img']
            },
            'on_selected': function (pgel) {
                gotoCarouselSlide(pgel);
            }
        });
        f.addComponentType(def_carousel_slide);

        // Coolapsible
        var def_collapsible = new PgComponentType('mat-collapsible', 'Collapsible', {
            'selector': '.collapsible',
            'preview_image': 'collapsible.png',
            'tags': 'major',
            'code': '<ul class="collapsible">\
                <li>\
                    <div class="collapsible-header"><i class="material-icons">filter_drama</i>First</div>\
                    <div class="collapsible-body"><span>Lorem ipsum dolor sit amet.</span></div>\
                </li>\
                <li>\
                    <div class="collapsible-header"><i class="material-icons">place</i>Second</div>\
                    <div class="collapsible-body"><span>Lorem ipsum dolor sit amet.</span></div>\
                </li>\
                <li>\
                    <div class="collapsible-header"><i class="material-icons">whatshot</i>Third</div>\
                    <div class="collapsible-body"><span>Lorem ipsum dolor sit amet.</span></div>\
                </li>\
            </ul>',
            'sections': {
                'mat-collapsible' : {
                    name : 'Collapsible',
                    fields : {
                        'mat-collapsible-type' : {
                            type : 'select',
                            action: 'apply_class',
                            show_empty: true,
                            name: 'Type',
                            options: [
                                { key: 'popout', name: "Popout" }
                            ]
                        },
                        'mat-collapsible-style' : {
                            type : 'select',
                            name: 'Style',
                            action: 'apply_class',
                            show_empty: true,
                            options: [
                                { key: 'expandable', name: 'Expandable' }
                            ]
                        }
                    }
                }
            },
            'on_inserted': function () {
                showOrbitMessage();
            },
            'on_changed': function () {
                showOrbitMessage();
            },
            "action_menu": {
                add: ['mat-collapsible-item']
            }
        });
        f.addComponentType(def_collapsible);

        var def_collapsible_item = new PgComponentType('mat-collapsible-item', 'Collapsible item', {
            'selector_new': function (pgel) {
                var pgp = pgel.parent;
                if (pgel.tagName == 'li' && pgp && pgp.hasClass('collapsible')) return true;
                return false;
            },
            'code': '<li>\
                <div class="collapsible-header"><i class="material-icons">whatshot</i>Third</div>\
                <div class="collapsible-body"><span>Lorem ipsum dolor sit amet.</span></div>\
            </li>',
            'on_inserted': function () {
                showOrbitMessage();
            },
            'on_changed': function () {
                showOrbitMessage();
            },
            "action_menu": {
                add: ['mat-collapsible-item-header', 'mat-collapsible-item-body']
            }
        });
        f.addComponentType(def_collapsible_item);

        var def_collapsible_header = new PgComponentType('mat-collapsible-item-header', 'Collapsible header', {
            'selector': '.collapsible-header',
            'code': '<div class="collapsible-header"><i class="material-icons">whatshot</i>Three</div>',
            'sections': {
                'matcollapsibleitemheader': {
                    'name': "Collapsible header",
                    'fields': {
                        'matcollapsible': {
                            'type': 'checkbox',
                            'name': 'Active',
                            'action': 'apply_class',
                            'value': 'active'
                        }
                    }
                }
            },
            'on_inserted': function () {
                showOrbitMessage();
            },
            'on_changed': function () {
                showOrbitMessage();
            },
            "action_menu": {
                add: ['mat-icon']
            }
        });
        f.addComponentType(def_collapsible_header);

        var def_collapsible_body = new PgComponentType('mat-collapsible-item-body', 'Collapsible body', {
            'selector': '.collapsible-body',
            'code': '<div class="collapsible-body"><span>Lorem ipsum dolor sit amet.</span></div>',
            'on_inserted': function () {
                showOrbitMessage();
            },
            'on_changed': function () {
                showOrbitMessage();
            },
            "action_menu": {
                add: ['html-p']
            }
        });
        f.addComponentType(def_collapsible_body);

        // Dropdown
        var def_dropdown_button = new PgComponentType('mat-dropdown-button', 'Dropdown button', {
            'selector': '.dropdown-button',
            'tags': 'major',
            'code': function () {
                var id = getUniqueId('dropdown');
                return "<a class='dropdown-trigger btn' href='#' data-target='" + id + "'>Drop Me!</a>"
            },
            'on_inserted': function (pgel, page) {
                var pgdropdownList = pgel.siblingOne('#' + pgel.attr('data-target'));

                if (!pgdropdownList) {
                    pgdropdownList = pgCreateNodeFromHtml('<ul id="' + pgel.attr('data-target') + '" class="dropdown-content">\
                        <li><a href="#!">one</a></li>\
                        <li><a href="#!">two</a></li>\
                        <li class="divider" tabindex="-1"></li>\
                        <li><a href="#!">three</a></li>\
                        <li><a href="#!"><i class="material-icons">view_module</i>four</a></li>\
                        <li><a href="#!"><i class="material-icons">cloud</i>five</a></li>\
                    </ul>')
                    pgdropdownList.insertAfter(pgel);
                }
            }
        });
        f.addComponentType(def_dropdown_button);

        var def_dropdown_content = new PgComponentType('mat-dropdown-content', 'Dropdown content', {
            'selector': '.dropdown-content',
            'code': function () {
                var id = getUniqueId('dropdown');

                return '<ul id="' + id + '" class="dropdown-content">\
                    <li><a href="#!">one</a></li>\
                    <li><a href="#!">two</a></li>\
                    <li class="divider"></li>\
                    <li><a href="#!">three</a></li>\
                </ul>'
            },
            'action_menu': {
                add: ['html-li']
            }
        });
        f.addComponentType(def_dropdown_content);

        // Slider
        var callSlider = function(pgel, func, msg) {
            var id = pgel.getId();
            var code = '$(\'[data-pg-id="' + id + '"]\').' + func + ';';

            var page = pgel.getPage();
            pinegrow.setIgnoreClicks(true);
            pinegrow.executeScriptInPage(page, code);
            pinegrow.setIgnoreClicks(false);
            if (msg) {
                pinegrow.showQuickMessage(msg);
            }
        }

        var gotoSlide = function (pgel) {
            var pgslider = pgel.closest('.slider');
            callSlider(pgslider, "slider('pause')");
            var slideId = pgel.index();
            var $slider = pgslider.get$DOMElement();
            var $active = $slider.find('> .slides > .active');
            var currElId = $active.index();

            numToGoTo = slideId - currElId;
            while (numToGoTo != 0) {
                if (numToGoTo > 0) {
                    callSlider(pgslider, "slider('next')");
                    numToGoTo--;
                }
                else if (numToGoTo < 0) {
                    callSlider(pgslider, "slider('prev')");
                    numToGoTo++;
                }
            }
        }

        var def_slider = new PgComponentType('mat-slider', 'Slider', {
            'selector': '.slider',
            'preview_image': 'slider.png',
            'tags': 'major',
            'code': function () {
                return '<div class="slider" data-slider>\
                    <ul class="slides">\
                        <li>\
                            <img src="' + getPlaceholderImage() + '">\
                            <div class="caption center-align">\
                                <h3>This is our big Tagline!</h3>\
                                <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                            </div>\
                        </li>\
                        <li>\
                            <img src="' + getPlaceholderImage() + '">\
                            <div class="caption left-align">\
                                <h3>Left Aligned Caption</h3>\
                                <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                            </div>\
                        </li>\
                        <li>\
                            <img src="' + getPlaceholderImage() + '">\
                            <div class="caption right-align">\
                                <h3>Right Aligned Caption</h3>\
                                <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                            </div>\
                        </li>\
                        <li>\
                            <img src="' + getPlaceholderImage() + '">\
                            <div class="caption center-align">\
                                <h3>This is our big Tagline!</h3>\
                                <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                            </div>\
                        </li>\
                    </ul>\
                </div>';
            },
            'action_menu': {
                actions : [
                    {label: "Pause slider", action: function(pgel) {
                        callSlider(pgel, "slider('pause')", "Slider paused.");
                    }},
                    {label: "Resume slider", action: function(pgel) {
                        callSlider(pgel, "slider('start')", "Slider resumed.");
                    }},
                    {label: "Next slide", action: function(pgel) {
                        callSlider(pgel, "slider('next')");
                    }},
                    {label: "Previous slide", action: function(pgel) {
                        callSlider(pgel, "slider('prev')");
                    }}
                ],
                add: ['mat-slider-slides']
            }
        });
        f.addComponentType(def_slider);

        var def_slides = new PgComponentType('mat-slider-slides', 'Slides', {
            'selector': '.slides',
            'preview_image': 'slider.png',
            'code': function () {
                return '<ul class="slides">\
                    <li>\
                        <img src="' + getPlaceholderImage() + '">\
                        <div class="caption center-align">\
                            <h3>This is our big Tagline!</h3>\
                            <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                        </div>\
                    </li>\
                    <li>\
                        <img src="' + getPlaceholderImage() + '">\
                        <div class="caption left-align">\
                            <h3>Left Aligned Caption</h3>\
                            <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                        </div>\
                    </li>\
                    <li>\
                        <img src="' + getPlaceholderImage() + '">\
                        <div class="caption right-align">\
                            <h3>Right Aligned Caption</h3>\
                            <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                        </div>\
                    </li>\
                    <li>\
                        <img src="' + getPlaceholderImage() + '">\
                        <div class="caption center-align">\
                            <h3>This is our big Tagline!</h3>\
                            <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                        </div>\
                    </li>\
                </ul>';
            },
            'action_menu': {
                add: ['mat-slide-item']
            }
        });
        f.addComponentType(def_slides);

        var def_slides_item = new PgComponentType('mat-slide-item', 'Slide item', {
            'selector_new': function (pgel) {
                var pgp = pgel.parent;
                if (pgel.tagName == 'li' && pgp && pgp.hasClass('slides')) return true;
                return false;
            },
            'preview_image': 'slider.png',
            'code': function () {
                return '<li>\
                    <img src="' + getPlaceholderImage() + '">\
                    <div class="caption center-align">\
                        <h3>This is our big Tagline!</h3>\
                        <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
                    </div>\
                </li>';
            },
            'action_menu': {
                add: ['html-img', 'mat-slide-caption']
            },
            on_selected: function(pgel) {
                pinegrow.showQuickMessage("Going to slide...");
                gotoSlide(pgel);
            }
        });
        f.addComponentType(def_slides_item);

        var def_slides_caption = new PgComponentType('mat-slide-caption', 'Slides caption', {
            'selector': '.caption',
            'code': '<div class="caption center-align">\
                <h3>This is our big Tagline!</h3>\
                <h5 class="light grey-text text-lighten-3">Here\'s our small slogan.</h5>\
            </div>',
            'sections': {
                'mat-slide-caption': {
                    'name': 'Slide caption options',
                    'fields': {
                        'mat-slide-caption-align': {
                            'type': 'select',
                            'name': 'Text align',
                            'action': 'apply_class',
                            'toggle_buttons': true,
                            'options': [
                                { 'key' : 'left-align', 'name' : 'Left', 'html' : bm.makeIcon('align-left') },
                                { 'key' : 'center-align', 'name' : 'Center', 'html' : bm.makeIcon('align-center') },
                                { 'key' : 'right-align', 'name' : 'Right', 'html' : bm.makeIcon('align-right') }
                            ]
                        }
                    }
                }
            }
        });
        f.addComponentType(def_slides_caption);

        // Modal
        var def_modal_button = new PgComponentType('mat-modal-button', 'Modal button', {
            'selector': '.modal-trigger',
            'preview_image': 'modal.png',
            'priority': 100,
            'tags': 'major',
            'code': function () {
                var id = getUniqueId('modal');
                return '<a class="waves-effect waves-light btn modal-trigger" href="#' + id + '">Modal</a>';
            },
            'on_inserted': function (pgel, page) {
                var id = pgel.getAttr('href');
                var pgmodalStructure = pgel.siblingOne(id);

                if (!pgmodalStructure) {
                    pgmodalStructure = pgCreateNodeFromHtml('<div id="' + id.substr(1, id.length) + '" class="modal">\
                        <div class="modal-content">\
                            <h4>Modal Header</h4>\
                            <p>A bunch of text</p>\
                        </div>\
                        <div class="modal-footer">\
                            <a href="#!" class="modal-close waves-effect waves-green btn-flat">Agree</a>\
                        </div>\
                    </div>');

                    pgmodalStructure.insertAfter(pgel);
                }
                showOrbitMessage();
            }
        });
        f.addComponentType(def_modal_button);

        var def_modal = new PgComponentType('mat-modal', 'Modal', {
            'selector': '.modal',
            'preview_image': 'modal.png',
            'tags': 'major',
            'code': function () {
                var id = getUniqueId('modal');

                return '<div id="' + id + '" class="modal">\
                    <div class="modal-content">\
                        <h4>Modal Header</h4>\
                        <p>A bunch of text</p>\
                    </div>\
                    <div class="modal-footer">\
                        <a href="#!" class="modal-close waves-effect waves-green btn-flat">Agree</a>\
                    </div>\
                </div>';
            },
            'sections': {
                'mat-modal' : {
                    name : 'Modal options',
                    fields : {
                        'mat-modal-bottom-sheet': {
                            type : 'checkbox',
                            name: 'Bottom sheet',
                            action: 'apply_class',
                            value: 'bottom-sheet'
                        }
                    }
                }
            },
            'action_menu': {
                add: ['mat-modal-content', 'mat-modal-footer']
            }
        });
        f.addComponentType(def_modal);

        var def_modal_content = new PgComponentType('mat-modal-content', 'Modal content', {
            'selector': '.modal-content',
            'code': '<div class="modal-content">\
                <h4>Modal Header</h4>\
                <p>A bunch of text</p>\
            </div>'
        });
        f.addComponentType(def_modal_content);

        var def_modal_footer = new PgComponentType('mat-modal-footer', 'Modal footer', {
            'selector': '.modal-footer',
            'code': '<div class="modal-footer">\
                <a href="#!" class=" modal-action modal-close waves-effect waves-green btn-flat">Agree</a>\
            </div>'
        });
        f.addComponentType(def_modal_footer);

        // Parallax
        var def_parallax_container = new PgComponentType('mat-parallax-container', 'Parallax container', {
            'selector': '.parallax-container',
            'preview_image': 'parallax.png',
            'tags': 'major',
            'code': function () {
                return '<div class="parallax-container">\
                    <div class="parallax"><img src="' + getPlaceholderImage() + '"></div>\
                </div>';
            },
            'action_menu': {
                add: ['mat-parallax']
            }
        });
        f.addComponentType(def_parallax_container);

        var def_parallax = new PgComponentType('mat-parallax', 'Parallax', {
            'selector': '.parallax',
            'code': function () {
                return '<div class="parallax"><img src="' + getPlaceholderImage() + '"></div>';
            },
            'action_menu': {
                add: ['html-img']
            }
        });
        f.addComponentType(def_parallax);

        // Tabs
        var def_tabs = new PgComponentType('mat-tabs', 'Tabs', {
            'selector': '.tabs',
            'tags': 'major',
            'code': function () {
                var id1 = getUniqueId('tabs');
                var id2 = getUniqueId('tabs');
                var id3 = getUniqueId('tabs');
                var id4 = getUniqueId('tabs');

                return '<ul class="tabs">\
                    <li class="tab col s3"><a class="active" href="#' + id1 + '">Test 1</a></li>\
                    <li class="tab col s3"><a href="#' + id2 + '">Test 2</a></li>\
                    <li class="tab col s3 disabled"><a href="#' + id3 + '">Disabled Tab</a></li>\
                    <li class="tab col s3"><a href="#' + id4 + '">Test 4</a></li>\
                </ul>';
            },
            'action_menu': {
                add: ['mat-tabs-item'],
                on_add: function(pgel, pgnew, newdef, prepend) {
                    var pgtabs = pgel.parent;

                    var id = pgnew.findOne('a').attr('href');
                    id = id.substr(1, id.length);
                    var pgTabContent = pgCreateNodeFromHtml('<div id="' + id + '" class="col s12">Test</div>');

                    if (prepend) {
                        pgel.prepend(pgnew);
                        pgTabContent.insertAfter(pgtabs);
                    } else {
                        pgel.append(pgnew);
                        pgTabContent.insertAfter(pgtabs);
                    }
                    showOrbitMessage();
                }
            },
            'on_inserted': function(pgel) {
                var pgtabs = pgel;
                var pgelchildren = pgtabs.children;
                var j = 0;
                for (var i = 0; i < pgelchildren.length; i++) {
                    var pgt = pgelchildren[i];

                    if (pgt.is('li')) {
                        var id = pgt.findOne('> a').getAttr('href');
                        if (id) id = id.replace('#', '');
                        var pgp = pgCreateNodeFromHtml('<div>Test ' + (j + 1) + '</div>');
                        if (id) pgp.setAttr('id', id);
                        if (j == 0) pgp.addClass('active');
                        pgp.insertAfter(pgtabs);
                        j++;
                    }
                }
            },
        });
        f.addComponentType(def_tabs);

        var def_tabs_item = new PgComponentType('mat-tabs-item', 'Tabs', {
            'code': function () {
                var id = getUniqueId('tabs');
                return '<li class="tab col s3"><a href="#' + id + '">Test</a></li>';
            }
        });
        f.addComponentType(def_tabs_item);

        var javascript_section = new PgFrameworkLibSection('mat-javascript', 'Javascript');
        javascript_section.setComponentTypes([def_carousel, def_slider, def_collapsible, def_dropdown_button, def_dropdown_content, def_modal_button, def_modal, def_parallax_container, def_tabs]);
        f.addLibSection(javascript_section);


        //Load local CSS file + fonts so that plugin works in offline mode. Include only when needed.
        var materialize_icon_fonts_included = false;
        var includeMaterializeIconFontsIntoPGUI = function () {
            if (!materialize_icon_fonts_included) {
                $('head').append('<link href="' + FONT_URL + '" rel="stylesheet">');
                materialize_icon_fonts_included = true;
            }
        }

        f.on_plugin_activated = function (pgPage, done) {
            if (f.detect(pgPage)) {
                includeMaterializeIconFontsIntoPGUI();
            }

            if (done) done(f);
        }


        var pb = new PgPluginBuilder(f);

        var rs = pb.addResource(FONT_URL);
        res.type = 'text/css';
        rs.aaareplace = function (page, pgel) {
            return (pgel.getAttr('href') || '').indexOf(FONT_URL) < 0;
        }

        rs = pb.addResource("materialize/css/materialize.min.css");
        rs.aaareplace = function (page, pgel) {
            return (pgel.getAttr('href') || '').indexOf("materialize.min.css") < 0;
        }

        rs = pb.addResource("materialize/js/materialize.min.js");
        rs.aaareplace = function (page, pgel) {
            return (pgel.getAttr('href') || '').indexOf("materialize.min.js") < 0;
        }

        //Register starting page template
        var notRequiredFiles = ["parallax-template.css", "starter-template.css", "mat-template.css", "style.css"];
        var templatesOrder = ["index.html", "materialize.html", "parallax-template.html", "starter-template.html"];

        f.addTemplateProjectFromResourceFolder('template', null, 7, function (node) {
            var currentFilesName = notRequiredFiles.filter(function (fileName) {
                return node.name == fileName;
            });
            if (currentFilesName && currentFilesName.length > 0) {
                node.required = false;
            }

            var nodeIndex = templatesOrder.indexOf(node.name);
            if (nodeIndex >= 0) node.order = nodeIndex;
        });
    });
});
