var PgDmFontCombo = function(data) {

    var names = {
        h: 'heading',
        s: 'lead',
        t: 'text'
    }

    this.toFonts = function(fonts) {
        ['h', 's', 't'].forEach(function(key) {
            var f = new PgDmFont();
            f.family = data[key].f;
            f.italic = data[key].v.indexOf('i') >= 0;
            f.weight = data[key].v.replace('i', '');
            f.key = names[key];
            fonts.setFont(f);
        })
    }

}

var PgDmProject = function(done) {
    var _this = this;
    var outcs = PgCSSStylesheet();
    outcs.fast = true;
    outcs.loaded = true;
    outcs.ignoreInSave = true;
    //this.attachTo(cs, pgOwnerNode);

    this.dmAddOns = {};

    this.css_mode = 'generate';//'inject';
    //this.css_mode = 'inject';

    var path = require('path');

    var localFile = null;

    this.palettes = new PgDmPalettes();

    this.getResourceFileName = function(file) {
        return path.join(crsaGetAppDir(), 'frameworks', 'pg.dm', file);
    }

    this.getResourceUrl = function(url) {
        return crsaMakeUrlFromFile(this.getResourceFileName(crsaMakeFileFromUrl(url)));
    }

    var params = {}

    this.getParams = function() {
        return params;
    }

    this.getParamsCopy = function() {
        return $.extend({}, params);
    }

    this.restoreParams = function(p) {
        params = $.extend({}, p);
        this.update();
    }

    this.setParameter = function(param, value) {
        params[param] = value;
        //pgDmStore.design.setDesignParameter(param, value);
    }

    this.getParameter = function(param) {
        return params[param] || null;
    }

    var space = function(from, inc, unit) {
        return (from + ((params['spacer'] || 1) - 1) * inc).toString() + unit;
    }

    var round = function(from, unit, param) {
        param = param || 'roundness';
        var f = param in params ? params[param] : 1.0;
        return (f > 1 ? (from + (from / 0.333) * (f - 1)) : from * f) + unit;
    }

    var num_colors = 5;

    this.colors = [];
    for(var i = 1; i <= num_colors; i++) {
        this.colors.push(`color${i}`);
    }
    this.colors.push(`success`);
    this.colors.push(`info`);
    this.colors.push(`warning`);
    this.colors.push(`danger`);

    var getColorShade = function(color, step) {
        return pgDmStore.design.getColorShade(color, step);
    }

    var pallets = chroma.brewer;
    var pallets_list = [];
    var num_pallets = 0;
    $.each(pallets, function(i, e) {
        num_pallets++;
        pallets_list.push(i);
    });

    this.getAllPallets = function() {
        return pallets_list;
    }

    this.getPalleteOptions = function() {
        return pallets_list.map(function(pn) {
            return {key: pn, name: pn};
        })
    }

    var selectedPallete = function() {
        var pn = _this.getParameter('pallete') || 'OrRd';
        return pallets[pn];
    }

    var color = function(idx) {
        var p = primary();
        var pal = selectedPallete();
        var list = chroma.scale(pal)
            .mode('lch').colors(num_colors);
        return list[idx];
    }

    var primary = function() {
        return params['blue'] || '#007bff';
    }



    var vars = {}
/*
    this.colors.forEach(function(c) {
        vars[c] = function() {
            return _this.getParameter(c);
        }

        if(c.startsWith('color')) {
            $.each(pgDmStore.design.getColorShadeDescriptions(), function (num, name) {
                num = parseInt(num);
                if(num != 0) {
                    vars[c + '-' + name] = function () {
                        return pgDmStore.design.getColorShade(chroma(_this.getParameter(c)), num);
                    }
                }
            })
        }
    })
*/

    var other_vars = {
        'grid-breakpoints-disable': `(sm: 0, md: 768px, lg: 1200px)`,
        'pg-colors': '(1: $color1, 2: $color2, 3: $color3, 4: $color3, 5: $color3)',
        'm-sizes': function() {
            var f = 1.414;
            var up = 8;
            var down = 2;
            var sizes = [`0: 1rem`];
            for(var i = 1; i <= up; i++) {
                sizes.push(`${i}: ${Math.pow(f, i).toFixed(4)}rem`);
            }
            for(var i = 1; i <= down; i++) {
                sizes.unshift(`${-i}: ${Math.pow(f, -i).toFixed(4)}rem`);
            }
            return `( ${sizes.join(', ')} );`;
        },
        'primary': '$color1',
        'secondary': '$color2',
        'light': function() {
            return _this.getParameter('light') || 'rgba(255, 255, 255, 0.85)';
        },
        'dark': function() {
            return _this.getParameter('dark') || null;//'rgba(0, 0, 0, 0.8)';
        },
        /*    'secondary': function() {
         return _this.getParameter('secondary');
         },*/
        'link-color': function() {
            for(var i = 0; i < _this.colors.length; i++) {
                var c = _this.getParameter(_this.colors[i]);
                if(c) {
                    var d = chroma.deltaE(c, '#212529');
                    var cont = chroma.contrast('#ffffff', c);
                    console.log(_this.colors[i] + ' c dist ' + d + ', cont ' + cont);
                    if(d > 34 && cont >= 3) return c;
                }
            }
            return null;
        },
        'body-bg': function() {
            var b = _this.getParameter('bck_color');
            return b;
        },
        'nav-tabs-link-active-bg': function() {
            if(_this.getParameter('bck_color')) {
                return 'white';
            }
        },
        /*
        'font-family-sans-serif': function() {
            return pgDmStore.design.getFont('text').family;
        },
        'font-weight-base': function() {
            return pgDmStore.design.getFont('text').weight;
            return params.fontcombo.getWeight('t');
            return params.font ? params.font.w : null;
        },
        'lead-font-weight': function() {
            return pgDmStore.design.getFont('lead').weight;
            return params.fontcombo.getWeight('s');
            return params.font ? params.font.leadw : null;
        },
        'headings-font-family': function() {
            return pgDmStore.design.getFont('heading').family;
            return params.fontcombo.getFamily('h');
            return params.headfont ? params.headfont.name : null;
        },
        'headings-font-weight': function() {
            return pgDmStore.design.getFont('heading').weight;
            return params.fontcombo.getWeight('h');
            return (params.headfont && params.headfont.w) ? params.headfont.w : null;
        },
        'headings-color': function() {
            return params.colorful ? '$primary' : null;
        },

        'border-radius': function() {
            return round(0.25, 'rem');
        },
        'border-radius-lg': function() {
            return round(0.3, 'rem');
        },
        'border-radius-sm': function() {
            return round(0.2, 'rem');
        },

        'btn-border-radius': function() {
            return round(0.25, 'rem', 'buttonRoundness');
        },
        'btn-border-radius-lg': function() {
            return round(0.3, 'rem', 'buttonRoundness');
        },
        'btn-border-radius-sm': function() {
            return round(0.2, 'rem', 'buttonRoundness');
        }

        'enable-shadows': function() {
            return params.shadows ? 'true' : 'false';
        },
        'enable-gradients': function() {
            return params.gradients ? 'true' : 'false';
        }*/
    }

    vars = $.extend(vars, other_vars);



    this.getVarValue = function(v) {
        return vars[v] ? vars[v]() : null;
    }

    var fonts = [
        'Oswald', 'Lato', 'Roboto', 'Montserrat', 'Playfair Display', 'Open Sans', 'Merriweather', 'Indie Flower'
    ]

    var text_fonts = [
        {name: 'Lato'},
        {name: 'Montserrat'},
        {name: 'Playfair Display'},
        {name: 'Open Sans'},
        {name: 'Merriweather'},
        {name: 'Georgia', system: true}
    ]

    var heading_fonts = [
        {name: 'Faster One', w: 400, s: '2px'},
        {name: 'Chonburi'},
        {name: 'Tulpen One', w: 400},
        {name: 'Oswald'},
        {name: 'Open Sans', w: 700},
        {name: 'Montserrat', w: 400, s: '2px', t: 'u'},
        {name: 'Playfair Display'},
        {name: 'Indie Flower'},
        {name: 'Georgia',system: true, style: 'italic'}
    ]


    var getFontStyles = function(f, getstr, only) {
        var s = {};
        s['font-family'] = '\'' + f.name + '\'';
        if(f.style) {
            s['font-style'] = f.style;
        }
        if(f.w) {
            s['font-weight'] = f.w;
        }
        if(f.s) {
            s['letter-spacing'] = f.s;
        }
        if(f.t) {
            s['text-transform'] = f.t == 'u' ? 'uppercase' : 'lowercase';
        }
        if(getstr) {
            var str = '';
            $.each(s, function(key, val) {
                if(only && only.indexOf(key) < 0) return true;
                str += key + ':' + val + ';';
            })
            return str;
        }
        return s;
    }

    var getFontUrl = function(f) {
        var ws = [f.w];
        if(f.leadw) ws.push(f.leadw);
        return `https://fonts.googleapis.com/css?family=${f.name.replace(/ /g, '+')}:${ws.join(',')}${f.style ? f.style[0] : ''}`;
    }

    this.getRandomFont = function(fonts) {
        return fonts[Math.round(Math.random() * (fonts.length - 1))];
    }

    this.getRandomTextFont = function() {
        return this.getRandomFont(text_fonts)
    }

    this.getRandomHeadingFont = function() {
        return this.getRandomFont(heading_fonts)
    }

    font_sample_text = 'AaBbCcDdEeFfGgHhIiJjKk';

    this.getFontOptions = function(fonts) {
        var idx = 1;
        return fonts.map(function(f) {
            return {key: idx++, name: f.name, html: '<span style="' + getFontStyles(f, true) + '">' + f.name + '</span>'}
        })
    }

    this.getTextFontOptions = function() {
        return this.getFontOptions(text_fonts);
    }

    this.getHeadingFontOptions = function() {
        return this.getFontOptions(heading_fonts);
    }

    this.getTextFontByKey = function(idx) {
        return text_fonts[idx-1];
    }

    this.getHeadingFontByKey = function(idx) {
        return heading_fonts[idx-1];
    }

    this.getTextFontKey = function(f) {
        return text_fonts.indexOf(f) + 1;
    }

    this.getHeadingFontKey = function(f) {
        return heading_fonts.indexOf(f) + 1;
    }

    this.loadAllFonts = function() {
        return;

        var $head = $('head');
        fonts.forEach(function(name) {
            var url = 'https://fonts.googleapis.com/css?family=' + name.replace(/ /g, '+');
            if($head.find('link[href="' + url + '"]').length == 0) {
                $head.append('<link rel="stylesheet" href="' + url + '">');
            }
        })
    }

    this.updateColorsFromPalette = function(locked) {
        var p = this;
        try {
            p.colors.forEach(function (c) {
                var palette = p.getParameter('palette');
                if (!locked || !locked[c]) {
                    var col = palette.getColor(c)
                    p.setParameter(c, col);
                    pinegrow.dispatchEvent('on_dm_color_changed', null, c, col)
                }
            })
        } catch(err) {
            console.log(err);
        }
    }

    this.magic = function(locked, skip_update, done) {
        var p = this;
        var doMagic = function() {
            var done_list = [];

            pgDmStore.db.startBatchUpdates();

            pgDmStore.forEachDesignSkill(function(skill) {
                done_list.push(skill);
            })

            pgDmStore.forEachDesignSkill(function(skill) {
                skill.surpriseMe(function() {
                    var idx = done_list.indexOf(skill);
                    idx >= 0 && done_list.splice(idx, 1);
                    if(done_list.length === 0) {
                        pgDmStore.db.endBatchUpdates('Surprise me!', 'design_panel');
                        if(!skip_update) {
                            p.update(done);
                        } else {
                            done && done();
                        }
                        //pinegrow.dispatchEvent('on_dm_design_changed', null, );
                    }
                });
            })
        }

        var dp = pgDmStore.getActiveDesignProvider();
        if(dp && dp.onBeforeSurpriseMe) {
            dp.onBeforeSurpriseMe(function() {
                doMagic();
            })
        } else {
            doMagic();
        }



    }

    var busy = false;
    var update_after_busy = false;

    this.update = function(done) {

        pgDmStore.update(done);
        return;

        if(busy) {
            update_after_busy = true;
            return;
        }

        update_after_busy = false;
        busy = true;

        var updateSection = function(content, section, code) {
            var re = new RegExp('\\/\\*\\s*Pinegrow generated ' + section + ' Begin\\s*\\*\\/[\\s\\S]*?\\/\\*\\s*Pinegrow generated ' + section + ' End\\s*\\*\\/', 'ig');

            if(!content.match(re)) {
                //throw "Section " + section + " not found in " + file + ".";
            } else {
                content = content.replace(re, '/* Pinegrow generated ' + section + ' Begin */\n' + code + '\n    /* Pinegrow generated ' + section + ' End */');
            }
            return content;
        }

        var code = '';
        var extra_code = '';

        /*
         if(params.font) {
         code += '@import url(\'' + getFontUrl(params.font) + '\');' + "\r\n";
         }
         if(params.headfont && params.headfont != params.font) {
         code += '@import url(\'' + getFontUrl(params.headfont) + '\');' + "\r\n";
         }*/





        if(false && params.bck_color && params.gradients) {
            code += `body {
    background: linear-gradient(135deg, ${params.bck_color} 0%, ${chroma(params.bck_color).brighten(2)} 100%);
    background-attachment: fixed;
    }`;
            fullh = true;
        }






        var compiledCs = null;

        if(this.css_mode == 'inject') {
            var source = customCs.getSource();
            source = updateSection(source, 'DM1', code);
            source = updateSection(source, 'DM2', extra_code);

            //customCs.compiledStylesheet.fast = true;
            customCs.includeSourceMap = false;
            //customCs.dontAddIds = true;

            compiledCs = customCs.compiledStylesheet;

            //customCs.setSource(source);

            //return;
            customCs.setSource(source, function () {
                var cs = customCs;
                cs.compiledStylesheet.resetError();

                busy = false;
                if(update_after_busy) {
                    _this.update();
                    return;
                }
                //pinegrow.stylesheets.applyToPagesQuick(cs.compiledStylesheet, cs.compiledStylesheet.source);

                //console.log(renderResult.css.toString())

                // cs.updateCompiledCode(renderResult.css, function () {

                //});
                /*
                 cs.regenerateCssFromCompilableSource(function (compilationError, renderResult) {
                 if (compilationError) {

                 } else {
                 cs.compiledStylesheet.resetError();
                 pinegrow.stylesheets.applyToPagesQuick(cs.compiledStylesheet, renderResult.css);

                 //console.log(renderResult.css.toString())

                 cs.updateCompiledCode(renderResult.css, function () {

                 });
                 }
                 })*/
            }, false, true, true /* fast delayed */)

            //code = source;
        } else {
            compiledCs = cs.compiledStylesheet;

            extraCs.setSource(extra_code);

            customCs.setSource(code, function () {
                cs.regenerateCssFromCompilableSource(function (compilationError, renderResult) {
                    if (compilationError) {
                        console.log(compilationError);
                        busy = false;
                        if(update_after_busy) {
                            _this.update();
                            return;
                        }

                    } else {
                        cs.compiledStylesheet.resetError();

                        busy = false;
                        if(update_after_busy) {
                            _this.update();
                            return;
                        }

                        pinegrow.stylesheets.applyToPagesQuick(cs.compiledStylesheet, renderResult.css);

                        //console.log(renderResult.css.toString())

                        cs.updateCompiledCode(renderResult.css, function () {

                        });
                    }
                })
            }, false, true)
        }
        console.log(code);

        //console.log(extra_code);

        var addFontsToPageViews = function(cs, urls) {
            var pages = pinegrow.stylesheets.getPagesForStylesheet(cs);
            pages.forEach(function(page) {
                page.getPageViews().forEach(function(pv) {
                    var cid = getUniqueIdFast('fonts');
                    var $html = pv.get$Html();
                    $html.find('.pg-dm-temp').removeClass('pg-dm-temp').addClass('pg-dm-temp-old' + cid);
                    var html = '';
                    urls.forEach(function(url) {
                        html += `<link href="${url}" rel="stylesheet" class="pg-dm-temp"/>`;
                    })
                    if(html) {
                        $html.find('head').append(html);
                    }

                    setTimeout(function() {
                        try {
                            $html.find('.pg-dm-temp-old' + cid).remove();
                        } catch(err) {}
                    }, 2000)
                })
            })
        }

        var fonts = [];
        if(params.fontcombo) {
            fonts.push(params.fontcombo.getUrl());
        }

        addFontsToPageViews(compiledCs, fonts);
    }

    this.onGetCSS = function(part, o) {

        var code = '';
        var extra_code = '';

        if(!o.config) o.config = {};

        pgDmStore.forEachDesignSkill(function(skill) {
            code += skill.onGetCSS(part, o.cs_url);
            if(skill.onGetConfigObject) {
                skill.onGetConfigObject(part, o.config, o.cs_url);
            }
        })

        o.css += code;
    }

    if(done) done.call(this);

}



var PgDmPalettes = function() {

    var list = null;

    var getList = function() {
        if(list === null) {
            var str = require('fs').readFileSync(pgDmProject.getResourceFileName('palettes.json'), {encoding: 'utf8'});
            list = JSON.parse(str);
        }
        return list;
    }

    this.getRandomPalette = function() {
        var l = getList();
        return new PgDmPalette( l[ getRand(0, l.length - 1)]);
    }
}

var PgNewDmPalette = function(colors, image_url, max_colors) {

    var v = new Vibrant(image_url, {
       // ImageClass: Image.Browser
    })
    v.getPalette().then(function(palette) {
        console.log(palette);
    });

    this.getColorsInfo = function(done) {


        return;

        var r = [];
        for(var i = 0; i < image_colors.length; i++) {
            r.push({name: `color${i+1}`, color: image_colors[i]});
        }
        return r;
    }

}

var PgDmPalette = function(colors, image, max_colors) {

    var swatches = null;
    var used = {};
    var image_colors = null;
    var on_done;

    this.harmony = null;

    var _this = this;

    if(max_colors < 2) max_colors = 2;

    this.getColors = function() {
        return colors;
    }

    this.getColorsInfo = function(done) {
        on_done = done;
        if(image_colors === null) {
            draw();
        }
        /*
        var r = [];
        for(var i = 0; i < image_colors.length; i++) {
            r.push({name: `color${i+1}`, color: image_colors[i]});
        }
        return r;

         */
    }

    this.getPrimary = function() {
        var c = swatches.DarkVibrant.getHex();
        used[c] = true;
        return c;
    }

    this.getSecondary = function() {
        var c = chroma(chroma.scale([this.getPrimary(), 'white']).colors(8)[6]).desaturate(0.1).css();
        used[c] = true;
        return c;
        return swatches.Vibrant.getHex();
    }

    this.getInfo = function() {
        var c = swatches.Muted ? swatches.Muted.getHex() : swatches.LightVibrant.getHex();
        used[c] = true;
        return c;
    }

    var getClosestTo = function(toc) {
        var d = null;
        var sel = null;
        colors.forEach(function(c) {
            var dist = chroma.deltaE(toc, c);
            if(!used[c] && (dist < d || d === null)) {
                sel = c;
                d = dist;
            }
        })
        return sel;
    }

    this.success = null;

    this.getSuccess = function() {
        if(this.success) return this.success;
        return null;

        var c = getClosestTo('green');
        if(c) used[c] = true;
        this.success = c;
        return c;
    }

    this.warning = null;

    this.getWarning = function() {
        if(this.warning) return this.warning;
        return null;

        var c = getClosestTo('orange');
        if(c) used[c] = true;
        this.warning = c;
        return c;
    }

    this.danger = null;

    this.getDanger = function() {
        if(this.danger) return this.danger;
        return null;

        var c = getClosestTo('red');
        if(c) used[c] = true;
        this.danger = c;
        return c;
    }


    //this.colors = ['primary', 'secondary', 'success', 'info', 'warning', 'danger', 'white', 'light', 'muted', 'dark' ]

    this.colors = pgDmProject.colors;


    this.getColor = function(c) {
        if(image_colors === null) {
            draw();
        }
        var idx = c.startsWith('color') ? parseInt(c.replace('color', '')) - 1 : 0;
        return idx < image_colors.length ? image_colors[idx].css() : '#000';

        switch(c) {
            case 'color1':
                return this.getPrimary();
            case 'color2':
                return this.getSecondary();
            case 'color3':
                return this.getInfo();
            case 'success':
                return this.getSuccess();
            case 'danger':
                return this.getDanger();
            case 'warning':
                return this.getWarning();
            default:
                return null;
        }
    }

    function draw() {
        var w = 100;
        var h = 20;

        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');

        if(image) {

            canvas.width = image.naturalWidth;
            canvas.height = image.naturalHeight;
            ctx.drawImage(image, 0, 0);
            ctx.drawImage(image, 0, 0, image.width, image.height);

            var colorThief = new ColorThief();
            var pal_colors = colorThief.getPalette(image, max_colors, 3);
            var image_colors_backup = pal_colors.map(function(a) {
                return chroma(a);
            })

            //var vibrant = new Vibrant(canvas, 64, 4);
            //swatches = vibrant.swatches();

            /*
            var dominant = chroma(colorThief.getColor(image), 3);

            var d = swatches.DarkVibrant || swatches.Vibrant;
            if(d) {
                dominant = chroma(d.getHex());
            }

            image_colors.sort(function(a, b) {
                return chroma.distance(a, dominant) - chroma.distance(b, dominant);
            })

            image_colors[0] = dominant;

            image_colors[0] = chroma(swatches.Vibrant.getHex());
            image_colors[1] = chroma(swatches.LightVibrant.getHex());

             */
            var v = new Vibrant(image.src, {
                // ImageClass: Image.Browser
            })
            v.getPalette().then(function(swatches) {
                //console.log(swatches);

                image_colors = [];

                var vib_colors = ['Vibrant', 'DarkVibrant', 'LightVibrant', 'Muted', 'DarkMuted', 'LightMuted'];
                for(var i = 0; i < vib_colors.length; i++) {
                    if(swatches[vib_colors[i]]) {
                        image_colors.push(chroma(swatches[vib_colors[i]].getHex()));
                    }
                }

                if(max_colors > image_colors.length) {
                    var getMaxDistance = function(a) {
                        var max = 0;
                        for(var i = 0; i < image_colors.length; i++) {
                            var dist = chroma.distance(a, image_colors[i]);
                            if(dist > max) max = dist;
                        }
                        return max;
                    }
                    image_colors_backup.sort(function(a, b) {
                        return getMaxDistance(a) - getMaxDistance(b);
                    })
                    while(image_colors.length < max_colors) {
                        image_colors.push(image_colors_backup.shift());
                    }
                }

                var generated = [];
                var base = image_colors[0];

                var harmony = _this.harmony;

                switch(harmony) {
                    case 'complimentary':
                        generated.push( base.set('hsl.h', '+180') );
                        break;
                    case 'split':
                        generated.push( base.set('hsl.h', '+150') );
                        generated.push( base.set('hsl.h', '+210') );
                        break;
                    case 'triad':
                        generated.push( base.set('hsl.h', '+120') );
                        generated.push( base.set('hsl.h', '+240') );
                        break;
                    case 'analog':
                        generated.push( base.set('hsl.h', '-30') );
                        generated.push( base.set('hsl.h', '+30') );
                        break;
                }


                var si = 2;
                for(var i = 0; i < generated.length; i++) {
                    if(image_colors.length > si + i) {
                        image_colors[si + i] = generated[i];
                    } else {
                        image_colors.push(generated[i]);
                    }
                }

                var r = [];
                for(var i = 0; i < image_colors.length; i++) {
                    r.push({name: `color${i+1}`, color: image_colors[i]});
                }

                on_done && on_done(r);
            });



        } else {
            //canvas.width = w;
            //canvas.height = colors.length * h;

            image_colors = [];

            //var y = 0;
            colors.forEach(function (c) {
                image_colors.push(chroma(c));
                /*
                 ctx.fillStyle = c;
                 ctx.fillRect(0, y, 100, h);
                 y += h;*/
            })
            var r = [];
            for(var i = 0; i < image_colors.length; i++) {
                r.push({name: `color${i+1}`, color: image_colors[i]});
            }

            on_done && on_done(r);
        }

        return;

        image_colors.sort(function(a, b) {
            var colorA = a.hsl();
            var colorB = b.hsl();
            // distribute into hue zone
            var hueA = isNaN(colorA[0]) ? 100 : Math.floor(colorA[0] / 30);
            var hueB = isNaN(colorB[0]) ? 100 : Math.floor(colorB[0] / 30);
            // if they have the same hue zone, sort by lightness
            return hueA === hueB ? colorB[2] - colorA[2] : hueA - hueB;
        })


        return;
        //var url = canvas.toDataURL();
        var vibrant = new Vibrant(canvas);
        swatches = vibrant.swatches()

        var $d = $('.pg-dm-debug').empty();

        for (var swatch in swatches) {
            if (swatches.hasOwnProperty(swatch) && swatches[swatch]) {
                $d.append(`<div style="background: ${swatches[swatch].getHex()};height:30px;">${swatch}</div>`);
                console.log(swatch, swatches[swatch].getHex())
            }
        }

    }
}

var PgDmColorSwatches = function(colors, skill) {

    var _this = this;

    var map = {}
    var $add = null;

    //var max_colors = pgDmStore.design.options.max_colors;

    this.$element = $('<div class="pg-dm-color-swatches"></div>');

    var updateDisplay = this.updateDisplay = function(set_color) {
        $.each(map, function(i,cs) {
            cs.destroy();
        })

        $add && $add.remove();

        colors.forEachColor(function(key, val, color_obj) {

            color_obj.setLocked( pgDmStore.isParamLocked(skill, key, color_obj.isLocked()));

            var cs = new PgDmColorSwatch();

            map[key] = cs;

            _this.$element.append(cs.$element)

            cs.onColorChanged = function(color, name, moving_in_picker) {
                _this.onColorChanged(key, color, moving_in_picker);
            }

            cs.onColorRenamed = function(old_name, name) {
                map[name] = map[key];
                delete map[key];
                key = name;
                _this.onColorRenamed(old_name, name, color_obj)
            }

            cs.onLocked = function(locked) {
                colors.setLocked(key, locked);
                pgDmStore.setParamLocked(skill, key, locked);
            }

            cs.onTextTool = function() {
                colors.onTextTool(key, colors.getColor(key));
            }

            cs.onBackgroundTool = function(event) {
                colors.onBackgroundTool(key, colors.getColor(key), event);
            }

            cs.onColorDeleted = function() {
                _this.onColorDeleted(color_obj);
            }

            if(set_color) {
                cs.setColor(val, key, color_obj);
            }
        })

        if(colors.can_edit) {
            $add = $(`<div class="add-new"><i class="icon icon-plus"></i></div>`).appendTo(_this.$element);
            addTooltip($add, 'Add a new color.')
        }
    }

    updateDisplay();

    this.$element.on('contextmenu', '.pg-dm-color-swatch', function(e) {
        colors.showContextMenu(this.getAttribute('data-name'), $(this));
        return false;
    })

    this.$element.on('click', '.add-new', function(e) {
        e.preventDefault();

        var parseShades = function(val) {
            var list = [];
            if(!val) return list;
            list = val.trim().split(',').map(function(shade) {
                return shade.trim();
            })
            for(var i = 0; i < list.length; i++) {
                if(!list[i] || !list[i].match(/^[a-z0-9]+$/i)) {
                    return false;
                }
            }
            return list;
        }

        var fields = {
            name: {
                type: 'text',
                name: 'Color name',
                validate: function(obj, prop, value) {
                    if(!value) {
                        return 'Please enter the color name.'
                    }
                    if(!value.match(/^[a-z0-9\_]+$/i)) {
                        return 'Color name should only contain letters, numbers and _ character.';
                    }
                    var has = false;
                    value = value.toLowerCase();
                    colors.forEachColor(function(key, val) {
                        if(key.toLowerCase() === value) {
                            has = true;
                        }
                    })
                    if(has) {
                        return `Color with the name ${value} already exists.`;
                    }
                }
            },
            color: {
                type: 'color',
                name: 'Color value',
                validate: function(obj, prop, value) {
                    if(!value || value.trim().length === 0) {
                        return 'Please select a color.'
                    }
                }
            },
            shades: {
                type: 'text',
                name: 'Shades',
                placeholder: 'light, normal, dark',
                value: colors.default_shades ? colors.default_shades.join(', ') : null,
                helptext: '<p>Leave empty to add a color without shades.</p>',
                validate: function(obj, prop, value) {
                    var list = parseShades(value);
                    if(list === false) {
                        return 'Shades have to be separated with commas and only contain letters and numbers.'
                    }
                }
            }
        }

        if(!colors.default_shades) {
            delete fields.shades;
        }

        pinegrow.showQuickDialog('Add a new color', `Color information`, ``, fields, 'Cancel', 'Add color', null, function(values) {
            var list = parseShades(values.shades);
            var shades = null;
            if(list.length) {
                shades = {}
                for(var i = 0; i < list.length; i++) {
                    shades[list[i]] = values.color;
                }
            }
            var c = colors.add(values.name, values.color, false, shades, true);
            c.calculateShades();
            updateDisplay(true);

            _this.onColorsReordered('copy');
        })

    })

    var reorder = new PgDraggableReorder(this.$element, '.pg-dm-color-swatch', function(dragged, dropped_on, mode) {
        var list = [];
        var color_values = [];

        //replace
        if(dragged && dropped_on) {
            var key = dragged.getAttribute('data-name');
            var dest = dropped_on.getAttribute('data-name');

            var c = map[key].color_object.clone();
            var c2 = map[dest].color_object.clone();

            if(mode === 'move') {
                colors.copyFromColor(key, c2, true);
                colors.copyFromColor(dest, c, true);

                map[key].setColorFromColorObject(c2);
                map[dest].setColorFromColorObject(c);

            } else if(mode === 'copy') {

                colors.copyFromColor(dest, c, true /* leave shade keys */);
                map[dest].setColorFromColorObject(c);
            }

            //updateDisplay(true);
            _this.onColorsReordered(mode);
        }

        //reorder
        /*
        _this.$element.find('.pg-dm-color-swatch').each(function(i, e) {
            var key = e.getAttribute('data-name');
            list.push(key);
            color_values.push(map[key].getColor());
        })

        var i = 0;
        colors.forEachColor(function(key) {
            colors.setColor(key, color_values[i])
            i++;
        })
        updateDisplay(true);
        _this.onColorsReordered();

         */
    }, function(drag_target) {
        var key = drag_target.attr('data-name');
        var c = map[key].color_object;
        return 'move';
        //return c.isLocked() ? 'copy' : 'move';
    })

    /*
    for(var i = 0; i < max_colors; i++) {

        (function(i) {
            var cs = new PgDmColorSwatch();

            map.push(cs);

            _this.$element.append(cs.$element)

            cs.onColorChanged = function (color, name) {
                _this.onColorChanged(i, color, name)
            }
        })(i)
    }
     */

    this.setColor = function(key, color, color_object) {
        map[key] && map[key].setColor(color, key, color_object);
    }

    this.setLocked = function(key, locked) {
        map[key] && map[key].setLocked(locked)
    }

    this.onColorChanged = function() {}

    this.getSwatch = function(key) {
        return map[key];
    }

    this.debug = function() {
        //console.log(map)
    }

}

var PgDmColorSwatch = function() {

    var _this = this;
    this.color = null;
    this.color_object = null;
    this.name = null;
    this.locked = false;
    this.can_rename = false;

    this.onLocked = function(val) {}

    this.onColorChanged = function(color) {}

    this.onColorDeleted = function(color_object) {}

    this.$element = $('<div class="pg-dm-color-swatch"><div class="pg-dm-color-swatch-color" draggable="true"><div class="pg-dm-color-swatch-shades"></div></div><!--<div class="pg-dm-color-swatch-tool pg-dm-color-swatch-tool-text"><i class="icon icon-ikone1-100-copy-63"></i></div><div class="pg-dm-color-swatch-tool pg-dm-color-swatch-tool-background"><i class="icon icon-Pin21"></i></div>--></div>');

    var $color = this.$element.find('.pg-dm-color-swatch-color');
    var $shades = this.$element.find('.pg-dm-color-swatch-shades');

    var $tools = this.$element.find('.pg-dm-color-swatch-tool');

    var $label = $('<div class="pg-dm-color-swatch-label"></div>').appendTo(this.$element);

    var $lock = $('<i class="icon icon-Lock_closed pg-dm-color-swatch-lock"></i>').appendTo(this.$element);
    var $menu = $('<i class="icon icon-down pg-dm-color-swatch-menu"></i>').appendTo(this.$element);

    addTooltip(this.$element, `Click to pick color,<br>Drag to swap colors,<br>${is_mac ? pgShowKbd('OPTION') : pgShowKbd('ALT')} drag to copy color.`, {delay: {"show": 1200, "hide": 100}})

    this.setColor = function(col, name, color_object, calc_shades) {
        this.color = col;
        if(name !== undefined) {
            this.name = name;
        }
        if(color_object) {
            this.color_object = color_object;
        }
        this.color_object && this.color_object.setValue(col);

        calc_shades && this.color_object.calculateShades();

        this.$element.attr('data-name', name);
        $color.css('background-color', col);
        if(name) {
            $label.html(`<span>${name}</span>`);
        }
        var shades = '';
        this.color_object.forEachShade(function(key, color) {
            shades += `<div title="${name}-${key}" style="background-color:${color};"></div>`;
        })
        if(shades.length) {
            $shades.get(0).innerHTML = shades;
            pg$Show($shades, 'flex');
        } else {
            pg$Hide($shades);
        }

        var dark = chroma.contrast('#ffffff', col) > 4.5;

        if(dark) {
            $tools.addClass('dark');
        } else {
            $tools.removeClass('dark');
        }
        color_object && this.setLocked(color_object.isLocked());
    }

    this.setColorFromColorObject = function(co) {
        this.setColor(co.getValue());
    }

    this.update = function() {
        this.setColor(this.color, this.name);
    }

    this.getColor = function() {
        return this.color;
    }

    this.setLocked = function(locked) {
        _this.locked = locked;
        if(_this.locked) {
            $lock.addClass('active icon-Lock_open').removeClass('icon-Lock_closed');
        } else {
            $lock.removeClass('active icon-Lock_open').addClass('icon-Lock_closed');
        }
    }

    var editShades = function() {
        var keys = '';
        if(_this.color_object.shades) {
            keys = Object.keys(_this.color_object.shades).join(', ');
        }

        var txt = '';
        _this.color_object.forEachShade(function(key, col) {
            txt += `${key} = ${col}
`;
        })
        var fields = {
            base: {
                type: 'color',
                name: 'Base color',
                value: _this.color_object.value,
                helptext: `<p>Set the base color.</p>`,
                validate: function(obj, fn, value) {
                    if(!value) return 'Base color is required.'
                }
            },
            shades: {
                name: 'Shades',
                type: 'text',
                textarea: true,
                value: txt,
                placeholder: '50 = #eee\n100 = #ddd\n200 = #ccc...',
                helptext: `<p>List shades, one per line. Use the format shade = color (in every line), or just list shades if the color will be generated from the base color. Leave empty to remove all shades.</p>`
            }
            /* ,
            generate: {
                name: 'Generate shade colors from the base color',
                type: 'checkbox',
                value: 'true',
                default_value: _this.color_object.generate_shades,
                helptext: `<p>Check to calculate shade colors from the base color.</p>`
            }*/
        }

        pinegrow.showQuickDialog('Edit color and shades for ' + _this.color_object.name, `Define color shades`, `<p>List color shades, one per line in the format:</p><pre>100 = #111111
200 = #222222
...</pre>
<p>If the shade colors should be auto-generated from the base color use:</p>
<pre>100
200
...</pre>
<p>Both styles can be combined:</p>
<pre>
100 = #111111 &lt;- Will not be calculated
200           &lt;- Calculate it
...
</pre>
`, fields, 'Cancel', 'OK', null, function(values) {
            var lines = values.shades.split("\n").filter(function(line) {
                return line.length > 0;
            }).map(function(line) {
                return line.trim();
            })

            var shades = null;
            var calc_list = [];
            var calc = false;

            if(lines.length) {
                shades = {};
                var i = 0;

                lines.forEach(function(line) {
                    var a = line.split(/\s*=\s*/);
                    if(a.length === 1) {
                        shades[a[0]] = null;
                        calc_list.push(a[0]);
                        calc = true;
                    } else {
                        shades[a[0]] = a[1];
                    }
                    i++;
                })
            } else {

            }
            _this.color_object.setValue(values.base);
            _this.color_object.setShades(shades, calc, calc_list);
            _this.update();
            _this.onColorChanged(_this.color, _this.name, false);
        })

        /*

        pinegrow.showPrompt(`<p>List color shades, separated with commas. Leave empty to remove shades.</p>`, "Edit color shades", keys, "light, normal, dark", null, function (val) {
            var list = null;
            list = val.trim().split(',').map(function(shade) {
                return shade.trim();
            }).filter(function(shade) {
                return shade.length > 0;
            })

            _this.color_object.setShadeKeys(list);
            _this.update();

        });

         */
    }

    var renameColor = function(oval) {
        pinegrow.showPrompt("Color name", "Rename color", oval || _this.name, "", null, function (val) {
            var c = pgDmStore.design.findColorByName(this.name);
            if(val && !val.match(/^[a-z0-9\-\_]+$/i)) {
                pinegrow.showQuickError('The color name can only contain letters, numbers, - and _.');
                renameColor(val);
                return;
            }
            if (val && val !== this.name) {
                if (pgDmStore.design.findColorByName(val)) {
                    pinegrow.showQuickError('Color with this name already exists.');
                    renameColor(val);
                } else {
                    var old_name = _this.name;
                    _this.name = val;
                    $label.html(`<span>${_this.name}</span>`);
                    _this.onColorRenamed(old_name, _this.name);
                }
            }
        });
    }

    var deleteColor = function() {
        _this.onColorDeleted(_this);
    }

    $label.on('click', 'span', function(e) {
        e.preventDefault();

        var dp = pgDmStore.getActiveDesignProvider();
        if(dp.canEditColors()) {
            renameColor();
        }

        return false;
    })

    $tools.on('click', function(e) {
        if(this.classList.contains('pg-dm-color-swatch-tool-background')) {
            _this.onBackgroundTool(e);
        } else {
            _this.onTextTool(e);
        }
        return false;
    })

    $lock.on('click', function(e) {
        _this.setLocked(!_this.locked);
        _this.onLocked(_this.locked);
        return false;
    })

    this.$element.on('click', '.pg-dm-color-swatch-color', function(e) {
        e.preventDefault();

        var original_color;
        var trigger_change_on_end = false;
        var color_changed = false;
        var original_shades = null;

        _this.$element.spectrum({
            showAlpha : true,
            clickoutFiresChange : true,
            showInitial : true,
            showInput : true,
            allowEmpty: true,
            preferredFormat: "hex",
            // showPalette: true,
            palette: [
                //               []
            ],
            beforeShow : function(color) {
                original_color = _this.color;
                if(_this.color_object.shades) {
                    original_shades = cloneObject(_this.color_object.shades);
                }
                return true;
            },
            move : function(color) {
                _this.setColor(colorToString(color), _this.name, null, true);
                _this.onColorChanged(_this.color, _this.name, true);
                color_changed = true;
                //trigger_change_on_end = true;
            },
            show : function(color) {
            },
            change : function(color) {
                //original_color = setInputValue(colorToString(color));
                trigger_change_on_end = true;
            },
            hide : function(color) {
                if (trigger_change_on_end) {
                    _this.setColor(colorToString(color), _this.name, null, true);
                    _this.onColorChanged(_this.color, _this.name);
                    trigger_change_on_end = false;
                } else {
                    //cancel after moving color
                    if(color_changed) {
                        _this.color_object.shades = original_shades;
                        _this.setColor(original_color, _this.name, null, false);
                        //_this.color_object.shades = original_shades;
                        _this.onColorChanged(original_color, _this.name, true); //use move parameter to just move the color back to original without triggering change event
                    }
                }
                _this.$element.spectrum("destroy")
            }
        });

        var pgSpectrumHelper = new PgSpectrumHelper(_this.$element, {
            'mouse-moved': function ($el) {
                var color = $el.spectrum('get');
                _this.setColor(colorToString(color));
                _this.onColorChanged(_this.color, _this.name);
            },
            'color-picked': function ($el) {
                var color = $el.spectrum('get');
                //original_color = setInputValue(colorToString(color));
                trigger_change_on_end = true;
            }
        }, true);

        _this.$element.spectrum("set", _this.color);

        _this.$element.spectrum("show");

        return false;
    })

    var showMenu = function($el) {

        var dp = pgDmStore.getActiveDesignProvider();

        var a = [

        ]

        if(dp.canEditColors()) {

            if(dp.supportsColorShades()) {
                a.push({
                    label: 'Edit shades...',
                    action: function () {
                        editShades();
                    }
                })
            }

            a.push({
                label: 'Rename color...',
                action: function () {
                    renameColor();
                }
            })

            a.push({
                label: 'Delete color',
                action: function () {
                    deleteColor();
                }
            })
        } else {
            a.push({
                type: 'header',
                label: 'Colors can not be renamed or deleted.'
            })
        }

        var m = new CrsaContextMenu(a, $el);
        m.showForElement($el);
    }

    this.$element.on('contextmenu', function(e) {
        showMenu($(this));
        return false;
    })

    this.$element.find('.pg-dm-color-swatch-menu').on('click', function(e) {
        showMenu($(this));
        return false;
    })

    this.destroy = function() {
        this.$element.remove();
        this.onLocked = null;
        this.onColorChanged = null;
    }
}



$(function() {


    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('pg.dm', 'Pinegrow Design Magic');
        f.type = "pg.dm";
        f.allow_single_type = true;

        f.description = 'Magic.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        f.has_actions = false;
        f.show_in_manager = true;

        f.setScriptFileByScriptTagId('plugin-pgdm');
        pinegrow.addFramework(f);

        window.pgDmFramework = f;

        /*
        var PgDmControlSpacer extends PgDmControl;

        PgDmControlSpacer.onChange = function(value) {
            var scss;

            scss.setCustomVariable('spacers', value + 'rem')
        }*/

        //load font combos






        pinegrow.addEventHandler('on_dm_register_addons', function(page, list) {
            var bm = new PgToggleButtonMaker();

            var heading_options = [];

            for(var i = 1; i <= 6; i++) {
                heading_options.push({key: 'h' + i, name: 'H' + i, html: bm.makeText('H' + i)})
            }

            var dmAddOnHeadingLine = new PgDmAddOn('heading.line', 'Heading Line', function() {
                this.description = 'Display a line under headings';

                this.addControl('headings',
                    {
                        type: 'select',
                        name: 'Headings',
                        toggle_buttons: true,
                        multiple: true,
                        options: heading_options,
                        help: 'Select Headings that should have a line under them.'
                    }
                )

                this.addControl('color',
                    {
                        type: 'color',
                        name: 'Color',
                        help: 'Line color.'
                    }
                )

                this.addControl('width',
                    {
                        name: 'Width',
                        type: 'slider',
                        default_value: '40px',
                        slider_min: 0
                    }
                )

                this.addControl('height',
                    {
                        name: 'Height',
                        type: 'slider',
                        slider_min: 0
                    }
                )

                this.addControl('opacity',
                    {
                        name: 'Opacity',
                        type: 'range',
                        range_min: 0,
                        range_max: 1.0,
                        range_step: 0.05
                    }
                )

                this.populateDefaultParams = function() {
                    this.setParam('headings', 'h1,h2');
                    this.setParam('width', '50px');
                    this.setParam('height', '0.05em');
                }

                this.getExtraCSS = function() {
                    var headings = this.getParam('headings');
                    var color = this.getParam('color');
                    var width = this.getParam('width');
                    var height = this.getParam('height');
                    var opacity = this.getParam('opacity');

                    if (headings) {
                        var extras = [];
                        if(opacity !== null) {
                            extras.push(`opacity: ${opacity};`)
                        }
                        return `
${headings} {
    &:after {
        border-top: ${height} solid ${color ? (' ' + color) : ''};
        display: block;
        width: ${width};
        height: 1px;
        margin-top: 1rem;
        content: "";
        ${extras.join("\n")}
    }
    
    &.text-center,&.text-sm-center,&.text-md-center,&.text-lg-center,&.text-xl-center {
        &:after {
            margin-left: auto;
            margin-right: auto;
        }
    }
    
    &.text-left,&.text-sm-left,&.text-md-left,&.text-lg-left,&.text-xl-left {
        &:after {
            margin-left: 0;
            margin-right: auto;
        }
    }
    
    &.text-right,&.text-sm-right,&.text-md-right,&.text-lg-right,&.text-xl-right {
        &:after {
            margin-left: auto;
            margin-right: 0;
        }
    }
}
`;
                    }
                }
            });

            list.push(dmAddOnHeadingLine);

            var dmAddOnHeadingSpacing = new PgDmAddOn('heading.spacing', 'Heading Spacing', function() {
                this.description = 'Add more space before headings.';

                var bm = new PgToggleButtonMaker();

                this.addControl('headings',
                    {
                        type: 'select',
                        name: 'Headings',
                        toggle_buttons: true,
                        multiple: true,
                        options: heading_options,
                        help: 'Select Headings that should have top spacing.'
                    }
                )

                this.addControl('space',
                    {
                        name: 'Top spacing',
                        type: 'range',
                        range_min: 0,
                        range_max: 2,
                        range_step: 0.25
                    }
                )

                this.populateDefaultParams = function() {
                    this.setParam('space', 0);
                }

                this.getExtraCSS = function() {
                    var space = this.getParam('space');
                    var headings = this.getParam('headings');

                    if (headings && space) {
                        return `
${headings} {
    margin-top: ${space}em;
}
${headings} {
    &:aaafirst-child {
        margin-top: 0;
    }
}
`;
                    }
                }
            });
        })



/*

        //////props
        var prefix = 'bs4.';

        var num_columns = parseInt(pinegrow.getSetting('bootstrap-col-num', '12')) || 12;
        var sizes = ["xs", "sm", "md", "lg", "xl"];
        var sizes_names = ["Extra Small", "Small", "Medium", "Large", "Extra Large"];
        var sizes_breakpoints = [0, 576, 768, 992, 1200];
        var sizes_view_sizes = [320, 640, 768, 1024, 1280];
        var sizes_icons = ['icon-Xs', 'icon-IPAD', 'icon-tableta-lezeca', 'icon-ikone100--copy_laptop', 'icon-Lg'];

        var size_for_all = sizes[0];

        var sizes_breakpoints_map = {};
        for(var i = 0; i < sizes.length; i++) {
            sizes_breakpoints_map[sizes[i]] = sizes_breakpoints[i];
        }

        var isColumn = function(pgel) {
            if(pgel.tagName == 'div') {
                if(pgel.parent && pgel.parent.isSelector('.row,.form-row') && !pgel.hasClass('row')) return true;
                if(pgel.getData(prefix + 'was-column')) return true;
            }
            if(pgel.tagName == 'label') return false;
            var cls = pgel.getAttr('class');
            if(cls) {
                if(cls.match(/(\s|^)col($|[\-\s])/i)) return true; //handle .col as well
            }
            return false;
        }

        var isContainer = function(pgel) {
            return pgel.hasClass('container') || pgel.hasClass('container-fluid')
        }

        var bs_options = {
            num_columns: num_columns,
            sizes: sizes,
            sizes_breakpoints: sizes_breakpoints,
            sizes_breakpoints_map: sizes_breakpoints_map,
            sizes_view_sizes: sizes_view_sizes,
            sizes_icons: sizes_icons,
            size_for_all: size_for_all,
            sizes_names: sizes_names,
            prefix: prefix,
            col_prefix_class: 'col',
            isColumn: isColumn,
            onClickOnColumnPoint: function() {
                var q = PgQuickProperties([def_all.sections[this.options.prefix + 'columns']], this.menu.pgel, this.$element, 'Column size &amp; order', 300);
            }
        }

        var gh = PgBootstrapHelpers(bs_options, f, 4);
*/


    })



});