var PgDmPropertiesView = function() {

    var $element = $('<div class="crsa-panel crsa-properties"></div>');

    var view = new PgUIView($element, 'prop', 'Props');

    this.view = view;

    this.just_obj = false;

    view.tabIcon = 'icon-settings';

    var _this = this;
    var current_pgel = null;

    var show_props = new PgShowProperties($element);

    show_props.view.get$Element().appendTo($element);

    var skip_sections = ['pg-classes'];

    show_props.filterSection = function(key, def) {
        return skip_sections.indexOf(key) < 0;
    }


    var onElementSelected = function(page) {
        if(!_this.just_obj) {
            var pgel = pinegrow.selectedElements.getLastSelected();
            _this.show(pgel, null, _this.just_obj);
        }
    }

    this.show = function(pgel, just_obj) {
        this.just_obj = just_obj;
        view.whenVisible(function() {
            if(pgel) {
                pinegrow.dispatchEvent('on_before_properties_shown', pgel.getPage());
            }
            show_props.show(pgel, null, just_obj);
        })
        current_pgel = pgel;

    }


    this.show(null);


    var onFrameworksChanged = function() {
        if(pinegrow.getSelectedPage()) {
            view.whenVisible(function () {
                show_props.show(current_pgel, null, _this.just_obj);
            })
        }
    }

    view.onAddedToLayout = function(c) {

    }

    view.onResize = function() {
        show_props.updateLayout();
    }

    $('body')
        .on('crsa-frameworks-changed', onFrameworksChanged);

    //this event is triggered by fields on change. We use it to dispatch another event used for syncing changes across diff Prop windows
    $element.on('crsa-field-value-changed', function(event) {
        pinegrow.dispatchEventDelayedForObject(current_pgel, 'on_prop_field_changed', null, current_pgel, {source: _this})
        return false;
    })

    $element.on('crsa-refresh-properties', function(event) {
        _this.show(current_pgel, _this.just_obj);
        return false;
    })

    var onPropFieldChanged = function(page, pgel, info) {
        if(info && info.source && info.source == _this) {
            show_props.updateHasDataDelayed();
            return;
        }
        onElementSelected();
    }

    pinegrow.addEventHandler('on_prop_field_changed', onPropFieldChanged);

    pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);

    var onClassesChanged = function(page, col, info) {
        onElementSelected();
    }

    pinegrow.addEventHandler('on_element_classes_changed', onClassesChanged);

    view.onDestroy = function() {
        show_props.show(null);
        if(show_general) show_general.show(null);

        pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);
        pinegrow.removeEventHandler('on_prop_field_changed', onPropFieldChanged);
        pinegrow.removeEventHandler('on_element_classes_changed', onClassesChanged);
        $('body')
        //.off('crsa-element-selected', onElementSelected)
            .off('crsa-frameworks-changed', onFrameworksChanged);
    }
}