$(function() {

    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('pg.docs.maker', 'Pinegrow Docs Maker');
        f.type = "pg.docs.maker";
        f.allow_single_type = true;

        f.description = 'Helpers for building Pinegrow in-app documentation.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        f.has_actions = true;
        f.show_in_manager = pgIsDev();

        f.setScriptFileByScriptTagId('plugin-pgdocsmaker');
        pinegrow.addFramework(f, 3);



        var pgdm_item = new PgComponentType('pgdm.item', 'Doc item');
        pgdm_item.short_name = 'Doc item';
        pgdm_item.selector = "[data-pgdm-item]";
        pgdm_item.attribute = 'data-pgdm-item';
        pgdm_item.action = true;
        pgdm_item.code = '<div data-pgdm-item="item_id"><h1>Title</h1><p class="lead">Short description</p><p>Tell me about it...</p></div>',
        pgdm_item.not_main_type = true;
        pgdm_item.sections = {
            'pgdm.item.parameters' : {
                name : 'Options',
                fields : {
                    'data-pgdm-item' : {
                        type : 'text',
                        name : 'Item id',
                        action : "element_attribute",
                        attribute : 'data-pgdm-item',
                        attribute_keep_if_empty : true,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('item id')
                    },
                    'data-pgdm-item-topic' : {
                        type : 'text',
                        name : 'Topic id',
                        action : "element_attribute",
                        attribute : 'data-pgdm-item-topic',
                        attribute_keep_if_empty : false,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('bootstrap')
                    }
                }
            }
        };
 
        f.addComponentType(pgdm_item);



        var pgdm_item_section = new PgComponentType('pgdm.item.section', 'Item section');
        pgdm_item_section.selector = "[data-pgdm-item-section]";
        pgdm_item_section.attribute = 'data-pgdm-item-section';
        pgdm_item_section.action = true;
        pgdm_item_section.not_main_type = true;
        pgdm_item_section.code = '<div data-pgdm-item-section></div>';
        pgdm_item_section.sections = {
            'pgdm.section.parameters' : {
                name: 'Options',
                fields: {
                    'data-pgdm-item-section-open' : {
                        type : 'checkbox',
                        name : 'Open',
                        action : "element_attribute",
                        attribute: 'data-pgdm-item-section-open',
                        value: '1',
                        empty_attribute: true
                    }
                }
            }
        }

        f.addComponentType(pgdm_item_section);



        var pgdm_include = new PgComponentType('pgdm.include', 'Include item');
        pgdm_include.short_name = 'Include item';
        pgdm_include.selector = "[data-pgdm-include]";
        pgdm_include.attribute = 'data-pgdm-include';
        pgdm_include.action = true;
        pgdm_include.not_main_type = true;
        pgdm_include.sections = {
            'pgdm.include.parameters' : {
                name : 'Options',
                fields : {
                    'data-pgdm-include' : {
                        type : 'text',
                        name : 'Item id',
                        action : "element_attribute",
                        attribute : 'data-pgdm-include',
                        attribute_keep_if_empty : false,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('item id')
                    }
                }
            }
        };

        f.addComponentType(pgdm_include);

        
        
        var pgdm_index = new PgComponentType('pgdm.index', 'Index');
        pgdm_index.short_name = 'Index';
        pgdm_index.selector = "[data-pgdm-index]";
        pgdm_index.attribute = 'data-pgdm-index';
        pgdm_index.action = true;
        pgdm_index.not_main_type = true;
        pgdm_index.sections = {
            'pgdm.index.parameters' : {
                name : 'Options',
                fields : {
                    'data-pgdm-index' : {
                        type : 'text',
                        name : 'Item id',
                        action : "element_attribute",
                        attribute : 'data-pgdm-index',
                        attribute_keep_if_empty : false,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('item id')
                    }
                }
            }
        };

        f.addComponentType(pgdm_index);



        var pgdm_condition = new PgComponentType('pgdm.condition', 'Condition');
        pgdm_condition.selector = "[data-pgdm-condition]";
        pgdm_condition.attribute = 'data-pgdm-condition';
        pgdm_condition.action = true;
        pgdm_condition.not_main_type = true;
        pgdm_condition.sections = {
            'pgdm.condition.parameters' : {
                name : 'Options',
                fields : {
                    'data-pgdm-condition' : {
                        type : 'text',
                        name : 'Condition',
                        action : "element_attribute",
                        attribute : 'data-pgdm-condition',
                        attribute_keep_if_empty : false,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('not_selected')
                    }
                }
            }
        };

        f.addComponentType(pgdm_condition);



        var pgdm_ui = new PgComponentType('pgdm.ui', 'UI');
        pgdm_ui.selector = "[data-pgdm-ui]";
        pgdm_ui.attribute = 'data-pgdm-ui';
        pgdm_ui.action = true;
        pgdm_ui.not_main_type = true;
        pgdm_ui.sections = {
            'pgdm.ui.parameters' : {
                name : 'Options',
                fields : {
                    'data-pgdm-ui' : {
                        type : 'text',
                        name : 'Condition',
                        action : "element_attribute",
                        attribute : 'data-pgdm-ui',
                        attribute_keep_if_empty : false,
                        //validate : f.fieldIsRequired,
                        placeholder: f.textDefaultValue('ui panel/func id')
                    }
                }
            }
        };

        f.addComponentType(pgdm_ui);


        var pgdm_hide_in_app = new PgComponentType('pgdm.hide.inapp', 'Hide in app');
        pgdm_hide_in_app.selector = "[data-pgdm-hide-in-app]";
        pgdm_hide_in_app.attribute = 'data-pgdm-hide-in-app';
        pgdm_hide_in_app.action = true;
        pgdm_hide_in_app.not_main_type = true;

        f.addComponentType(pgdm_hide_in_app);


        var pgdm_hide_online = new PgComponentType('pgdm.hide.online', 'Hide online');
        pgdm_hide_online.selector = "[data-pgdm-hide-online]";
        pgdm_hide_online.attribute = 'data-pgdm-hide-online';
        pgdm_hide_online.action = true;
        pgdm_hide_online.not_main_type = true;

        f.addComponentType(pgdm_hide_online);


        var section = new PgFrameworkLibSection('pgdm', 'Docs Maker');
        section.setComponentTypes([pgdm_item, pgdm_index, pgdm_item_section, pgdm_include, pgdm_condition, pgdm_ui, pgdm_hide_in_app, pgdm_hide_online]);
        f.addActionsSection(section);



        //Display help

        var intro_class = 'lead'; //class used for intro paragraph
        var ui_defs = {
            prop: {
                icon: 'icon-settings', name: 'Element properties'
            },
            style: {
                icon: 'icon-Pin15', name: 'Style'
            },
            element_code_panel: {
                icon: 'icon-KODA', name: 'Element code'
            },
            library: {
                icon: 'icon-import', name: 'Library'
            },
            act: {
                icon: 'icon-actions', name: 'Actions'
            },
            cms: {
                icon: 'icon-WP', name: 'WordPress'
            },
            project: {
                icon: 'icon-project', name: 'Project'
            },
            history: {
                icon: 'icon-undo', name: 'History'
            },
            tree: {
                icon: 'icon-Pin11', name: 'Tree'
            },
            pagecode: {
                icon: 'icon-KODA', name: 'Page code'
            }
        }

        var source_topic_map = {};
        var node_topic_map = {};
        var html_topic_map = {};

        //Read JSON data
        try {
            var file = require('path').join(process.cwd(), 'help', 'help.json');
            var data = require('fs').readFileSync(file, {encoding: 'utf8'});
            html_topic_map = JSON.parse(data);

        } catch(err) {
            console.log('Could not read help data from ' + file);
        }

        f.docsAddTopic = function(id, title, html) {
            html_topic_map[id] = {title: title, html: html};
        }

        ///

        var filterText = function(c) {
            c = c.replace(/([A-Z\+0-9]+)\_KEY/g, function(m, key) {
                return pgShowKbdCombo(key);
            })
            c = c.replace(/([a-zA-Z\-\_0-9]+)\_ICON/g, function(m, key) {
                return '<i class="icon icon-' + key + '"></i>';
            })
            c = c.replace(/UNDO/g, 'undo');
            c = c.replace(/\. RIGHT_CLICK/g, ' Right click');
            c = c.replace(/ RIGHT_CLICK/g, ' right click');
            c = c.replace(/RIGHT_CLICK/g, 'Right click');
            c = c.replace(/DOUBLE_CLICK/g, 'double click');
            c = c.replace(/\. CLICK/g, '. Click');
            c = c.replace(/ CLICK/g, ' click');
            c = c.replace(/CLICK/g, 'Click');
            return c;
        }

        var getSourceForTopic = function(tid) {
            return source_topic_map[tid] || '<h1>Topic ' + tid + ' not found.</h1>';
        }

        var getNodeForTopic = function(tid) {
            if(!node_topic_map[tid]) {
                node_topic_map[tid] = 'doing';

                var p = new pgParser();
                p.assignIds = false;
                p.parse(getSourceForTopic(tid));

                var root;

                if(isRemoteDoc(tid)) {
                    var sel = 'body';

                    if(tid.startsWith('https://pinegrow.com/docs/')) {
                        sel = 'article';
                    }

                    var body = p.rootNode.findOne(sel);

                    if(body) {
                        body.withoutEvents(function () {
                            body.find('script,footer').forEach(function (n) {
                                n.remove();
                            })

                            var h2 = body.findOne('h2');
                            if (h2) {
                                var main = h2.parent;

                                var start_h2 = null;
                                var list = [];

                                main.children.slice(0).forEach(function (n) {

                                    if (n.tagName === 'h2') {
                                        if (start_h2) {
                                            var s = pgCreate('<div data-pgdm-item-section class=""></div>');
                                            s.insertBefore(start_h2);
                                            list.forEach(function (n) {
                                                s.append(n);
                                            })
                                        }
                                        start_h2 = n;
                                        list = [n]
                                    } else if (start_h2) {
                                        list.push(n);
                                    }

                                })

                                if (start_h2) {
                                    var s = pgCreate('<div data-pgdm-item-section class=""></div>');
                                    s.insertBefore(start_h2);
                                    list.forEach(function (n) {
                                        s.append(n);
                                    })
                                }

                            }

                            body.find('.excerpt-content p').forEach(function (p) {
                                p.addClass('lead');
                            })

                            body.find('img').forEach(function (p) {
                                p.getAttrList().slice(0).forEach(function (a) {
                                    if (a.name.startsWith('data-lazy-')) {
                                        p.setAttr(a.name.replace('data-lazy-', ''), a.value);
                                        p.removeAttribute(a.name);
                                    }
                                    p.removeAttribute('srcset');
                                    p.removeAttribute('sizes');

                                    var src = p.getAttr('src');
                                    if(src) {
                                        src = (new URL(src, tid)).toString();
                                        p.setAttr('src', src);
                                    }
                                })
                            })

                            root = pgCreate(`<div class="pg-docs-remote-wrapper"></div>`);
                            body.children.slice(0).forEach(function (ch) {
                                root.append(ch);
                            })
                        })
                    } else {
                        root = p.rootNode;
                    }
                } else {
                    root = p.rootNode;
                }

                var replace = [];

                root.withoutEvents(function() {

                    root.walk(function(node) {
                        if(node.textNode) {
                            //node.content = filterText(node.content);
                        } else {
                            var include = node.getAttribute('data-pgdm-include');
                            if(include) {
                                replace.push({node: node, include: include});
                            }

                            var ui = node.getAttribute('data-pgdm-ui');
                            if(ui && ui_defs[ui]) {
                                node.html('<i class="pgdm-ui-icon icon ' + ui_defs[ui].icon + '"></i>' + ui_defs[ui].name, false);
                                node.addClass(ui_defs[ui].class || 'pgdm-ui-panel');
                            }
                            var url = node.getAttribute('src');
                            if(url) {
                                if(!crsaIsAbsoluteUrl(url)) {
                                    url = 'help/' + url;
                                    node.setAttribute('src', url);
                                }
                            }

                            var index = node.getAttribute('data-pgdm-index');
                            if(index) {
                                if(!isRemoteDoc(index)) {
                                    var h1 = getNodeForTopic(index).findOne('h1,h2,h3');
                                    if (h1) {
                                        node.replaceContentWithContentOf(h1.clone(true));
                                        var small = node.findOne('small');
                                        if(small) small.remove();
                                    }
                                }
                            }
                        }

                        return true;
                    })

                    replace.forEach(function(d) {
                        var r = getNodeForTopic(d.include);
                        if(r === 'doing') {
                            d.node.replaceWith(pgCreate('<h1>Circular include: ' + d.include + '</h1>'));
                        } else {
                            r = r.clone(true /* no ids */);
                            var level = d.node.getHeadingLevelOfSection();
                            if(level > 0) {
                                r.rebaseHeadingLevel(level);
                                //remove intro classes
                                r.findIncludingSelf('.' + intro_class).forEach(function(node) {
                                    node.removeClass(intro_class);
                                })
                            }
                            d.node.replaceWithContentOf(r);
                        }
                    })
                })
                node_topic_map[tid] = root;
            }
            return node_topic_map[tid];
        }

        var isRemoteDoc = function(tid) {
            return crsaIsAbsoluteUrl(tid);
        }

        var getHtmlForTopic = function(tid, done) {
            if(html_topic_map[tid]) {
                if(done) done(html_topic_map[tid].html);
                return html_topic_map[tid].html;
            }
            if(isRemoteDoc(tid) && !source_topic_map[tid]) {
                //have to first load it

                $.ajax({
                    url: tid,
                    data: null,
                    dataType: 'html'
                }).done(function(data) {
                    source_topic_map[tid] = data;
                    var html = getNodeForTopic(tid).toStringOriginal(true);
                    if(done) done(html);

                }).fail(function() {
                    source_topic_map[tid] = `<p>${tid} could not be loaded.</p>`;
                    var html = getNodeForTopic(tid).toStringOriginal(true);
                    if(done) done(html);
                });

                return `<p>Loading ${tid}...</p>`;

            } else {
                var html = getNodeForTopic(tid).toStringOriginal(true);
                if(done) done(html);
                return html;
            }
        }

        var getTitleForTopic = function(tid) {
            if(html_topic_map[tid] && html_topic_map[tid].title) {
                return html_topic_map[tid].title;
            }
            var h1 = getNodeForTopic(tid).findOne('h1');
            if(h1) {
                h1 = h1.clone(true);
                var small = h1.findOne('small');
                if (small) small.remove();
                return h1.html();
            }
            return 'Documentation';
        }

        /*
        var getIndexForTopic = function(tid) {
            var h1 = getNodeForTopic(tid).findOne('h1,h2,h3');
            if(h1) {
                return h1.html();
            } else {
                return ''
            }
        }*/

        var wp_image_url = 'http://download.pinegrow.com/docsmedia/';
        var wp_output_dir = '/Users/Matjaz/Dropbox/Development/DVWeb/DV/Pinegrow/DocsExport';

        var compile = function(wp) {
            var items = {};

            source_topic_map = {};
            node_topic_map = {};
            html_topic_map = {};

            var project = pinegrow.getCurrentProject();
            project.forEachEditableFile( function( page, pageDone, status ) {
                //on page

                var node = page.sourceNode.clone(true);

                node.findIncludingSelf('img').forEach(function(img) {
                    var src = img.getAttribute('src');
                    if(src) {
                        src = page.makeAbsoluteUrl(src);
                        src = src.replace(project.getUrl() + '/', '');

                        if(wp) {
                            src = wp_image_url + src.replace('images/', '');
                            //img.setAttribute('onload', "this.style.maxWidth=(this.naturalWidth/2) + 'px';this.onload=null;");
                            img.setAttribute('onload', "this.style.maxWidth=(this.naturalWidth/2) + 'px';");
                        }

                        img.setAttribute('src', src);
                    }
                })

                if(wp) {
                    node.find('[' + pgdm_hide_online.attribute + ']').forEach(function(node) {
                        node.remove();
                    })
                } else {
                    node.find('[' + pgdm_hide_in_app.attribute + ']').forEach(function(node) {
                        node.remove();
                    })
                }

                if(wp) {
                    node.find('[data-pgdm-ui]').forEach(function(node) {
                        if(node.tagName == 'a') {
                            node = node.replaceTag('span');
                            node.removeAttribute('href');
                        }
                    })
                }

                node.walk(function(node) {
                    var did = node.getAttribute('data-pgdm-item');
                    if(did) {
                        items[did] = $.trim(filterText(node.html()));
                    }
                    return true;
                })
                pageDone(page, status);

            }, function() {

                source_topic_map = items;

                $.each(source_topic_map, function(tid, raw) {

                    if(!isRemoteDoc(tid)) {
                        html_topic_map[tid] = {
                            title: getTitleForTopic(tid),
                            html: getHtmlForTopic(tid)
                        }

                        if (wp) {
                            var file = require('path').join(wp_output_dir, tid + '.html');
                            require('fs').writeFileSync(file, html_topic_map[tid].html, {encoding: 'utf8'});
                        }
                    }
                })

                if(!wp) {
                    pinegrow.showDocsTopic('add.remove.classes')

                    var file = require('path').join(project.getDir(), 'help.json');
                    require('fs').writeFileSync(file, JSON.stringify(html_topic_map), {encoding: 'utf8'});
                }
                pinegrow.showQuickMessage('Compiled!');
            }, 'Compiling in-app help docs...')
        }


        var $menu = $('<li class="dropdown"><a href="#" class="dropdown-toggle" data-toggle="dropdown"><span>Doc Maker</span></a>\
    <ul class="dropdown-menu with-checkboxes">\
        <li><a href="#" class="compile">Compile</a></li>\
        <li><a href="#" class="export">Export for WP</a></li>\
        <li><a href="#" class="test">Test</a></li>\
    </ul></li>');

        pinegrow.addPluginControlToTopbar(f, $menu);

        $menu.find('.compile').on('click', function(e) {
            compile();
        })
        $menu.find('.export').on('click', function(e) {
            compile(true);
        })
        $menu.find('.test').on('click', function(e) {
            pinegrow.showDocsTopic();
        })

        //Register starting page template
        /*
        f.addTemplateProjectFromResourceFolder('template', null, 0, function (node) {
        });
        */

        var openExample = function(url) {
            pinegrow.openExample(url.replace('open:', ''))
        }

        var open_in_external = pinegrow.getSetting('help-open-in-external', '0') == '1';
        var current_topic_id = null;
        var topic_view_data = {};

        var TopicData = function(tid) {
            this.tid = tid;
            this.activeSection = -1;
            this.openSections = {};
        }
        TopicData.prototype.isSectionOpen = function(idx) {
            return this.openSections['s'+idx] || false;
        }
        TopicData.prototype.setSectionOpen = function(idx, val) {
            this.openSections['s'+idx] = val;
        }

        var getTopicData = function(tid) {
            tid = tid || current_topic_id;
            if(!topic_view_data[tid]) {
                topic_view_data[tid] = new TopicData(tid);
            }
            return topic_view_data[tid];
        }

        var PgDocsViewerView = function() {

            var $element = $('<div class="pg-doc-viewer"><div class="pg-doc-viewer-toolbar"></div><div class="pg-doc-viewer-content"></div></div>');

            //To get correct tooltips in external window
            setTimeout(function() {
                var toolbar = new PgButtonToolbar();
                toolbar.addSection('index');

                var indexButton = new PgButtonToolbarItem('<span>Content</span>', 'Go back to "Power-up with Pinegrow" index.');
                toolbar.addItem('index', indexButton);
                indexButton.onClick = function () {
                    pinegrow.showDocsTopic('docs.index')
                }

                $element.find('.pg-doc-viewer-toolbar').append(toolbar.$element)

                //right toolbar
                var rightToolbar = new PgButtonToolbar();
                rightToolbar.addSection('win');

                var winButton = new PgButtonToolbarItem(open_in_external ? 'icon-108' : 'icon-109', open_in_external ? 'Open in the main Pinegrow window' : 'Open in a separate window');
                rightToolbar.addItem('win', winButton);
                winButton.onClick = function () {

                    open_in_external = !open_in_external;

                    pinegrow.setSetting('help-open-in-external', open_in_external ? '1' : '0')

                    if (docViewer) {
                        docViewer.destroy();
                    }
                    docViewer = null;

                    if (docsWindow) {
                        docsWindow.close(true);
                    }
                    docsWindow = null;

                    pinegrow.showDocsTopic(current_topic_id)
                }

                $element.find('.pg-doc-viewer-toolbar').append(rightToolbar.$element.addClass('right-toolbar'))
            }, 100);

            //////

            var $content = $element.find('.pg-doc-viewer-content');

            var connection = null;
            var removeConnectionTimer = null;

            var removeConnection = function() {
                if(removeConnectionTimer) {
                    clearTimeout(removeConnectionTimer);
                    removeConnectionTimer = null;
                }
                if(connection) {
                    connection.destroy();
                    connection = null;
                }
            }

            var getVisibleSection = function() {
                var st = $content.scrollTop();
                var h = $content.height();
                var idx = -1;
                $content.find('[data-pgdm-item-section]').each(function(i, s) {
                    var $s = $(s);
                    var pos = $s.position();
                    var sh = $s.height();
                    if(pos.top + sh < 0 || pos.top > h) {
                        //not visible
                    } else {
                        idx = i;
                        return false;
                    }
                })
                return idx;
            }

            var scrollToSection = function(idx) {
                var $all = $content.find('[data-pgdm-item-section]');
                if(idx < 0 || $all.length < idx) return;
                var $s = $($all.get(idx));
                var pos = $s.position();
                $content.scrollTop(pos.top);
            }

            var scrollTimer = null;

            $content.on('scroll', function() {
                if(scrollTimer) {
                    clearTimeout(scrollTimer);
                }
                scrollTimer = setTimeout(function() {
                    var idx = getVisibleSection();
                    var td = getTopicData();
                    td.activeSection = idx;
                    //console.log('Active section is ' + idx)
                }, 300)
            })

            $content.on('click', 'a', function(e) {
                var $a = $(this);
                var url = $a.attr('href');
                if(url && crsaIsAbsoluteUrl(url)) {
                    e.preventDefault();

                    if($a.closest('.pg-open-page').length) {
                        pinegrow.openOrShowPage(url);
                    } else {
                        var gui = require('nw.gui');
                        gui.Shell.openExternal(url);
                    }
                }
            })
            $content.on('click', '[data-pgdm-index]', function(e) {
                e.preventDefault();
                var tid = $(this).attr('data-pgdm-index');
                pinegrow.showDocsTopic(tid);
            });
            $content.on('click', '[data-pgdm-ui]', function(e) {
                e.preventDefault();

                removeConnection();

                var ui = $(this).attr('data-pgdm-ui');
                if(ui.startsWith('open:')) {
                    openExample(ui);
                } else if(ui.startsWith('$')) {
                    pgRevealElement($(ui.replace('$','')));

                } else {
                    if(pinegrow.startScreenManager.isVisible()) {
                        pinegrow.showQuickError('Can\'t show the panel. Please create or open a page first.', 3000);
                        return;
                    }

                    if(ui == 'pagecode') {
                        var page = pinegrow.getSelectedPage();
                        if (page) {
                            pinegrow.editCode(page, true);
                        }
                        setTimeout(function() {
                            pgRevealElement(pgPageCodeEditorsStack.getStack().element);
                        }, 500);

                    } else {
                        var view = pinegrow.showUIPanel(ui, false);
                        if (view) {
                            if(pgDoElementsIntersect($element.get(0), view.getTab().element.get(0))) {
                                if(_this.quickWin) {
                                    _this.quickWin.showFor$El(view.getTab().element);
                                }
                            }

                            pgRevealElement(view.getTab().element);

                            /*
                             connection = new PgConnector();
                             connection.$from = $(this);
                             connection.toOffset = 0;
                             connection.$to = view.getTab().element;
                             connection.color = 'blue';

                             if(pgDoElementsIntersect($element.get(0), connection.$to.get(0))) {
                             if(_this.quickWin) {
                             _this.quickWin.showFor$El(connection.$to);
                             }
                             }

                             pinegrow.connectors.add(connection);
                             */

                            if (removeConnectionTimer) {
                                clearTimeout(removeConnectionTimer);
                            }
                            removeConnectionTimer = setTimeout(removeConnection, 2000);
                        }
                    }
                }
            })

            $content.on('scroll', function() {
                removeConnection();
            })

            var view = new PgUIView($element, 'help');
            this.view = view;
            var _this = this;

            var current_topic_id = null;

            this.showTopic = function(topic_id) {
                current_topic_id = topic_id;

                var r = getHtmlForTopic(topic_id, function(html) {

                    if(current_topic_id === topic_id) {
                        $content.html(html);

                        if (this.quickWin) {
                            this.quickWin.setTitle('Help - ' + getTitleForTopic(topic_id));
                        }
                        if (docsWindow) {
                            docsWindow.title = 'Help - ' + getTitleForTopic(topic_id);
                        }
                        addTooltip($content.find('.pgdm-ui-panel'), 'Click to reveal the panel.');

                        $content.find('h2').each(function (i, h) {
                            var $h = $(h);
                            $h.prepend('<span class="count">' + (i + 1) + '</span>');
                            $h.append('<i class="icon icon-right closed"></i>');
                            $h.append('<i class="icon icon-down opened"></i>');
                        })

                        var td = getTopicData();

                        $content.find('[data-pgdm-item-section]').each(function (i, s) {
                            var $s = $(s);
                            var $headings = $s.find('h1,h2,h3,h4,h5,h6');
                            if ($headings.length) {
                                var $h1 = $($headings.get(0));

                                var open = $s.is('[data-pgdm-item-section-open]');

                                if (!open) {
                                    open = td.isSectionOpen(i);
                                }
                                if (i == -10 || open) {

                                } else {
                                    $s.addClass('closed')
                                }

                                $h1.on('click', function (e) {
                                    e.preventDefault();
                                    $s.toggleClass('closed');
                                    td.setSectionOpen(i, !$s.hasClass('closed'));
                                    removeConnection();
                                })

                                $s.addClass('animate');
                            }
                        })

                        var td = getTopicData();
                        scrollToSection(td.activeSection);

                        onElementSelected();
                    }
                })

                if(r.startsWith('<p>Loading ')) {
                    $content.html(`<p>Loading...</p>`);
                }

            }

            view.onResize = function() {
            }

            var onElementSelected = function() {
                if(pinegrow.selectedElements.getLastSelected()) {
                    $content.find('[data-pgdm-condition="not_selected"]').hide();
                } else {
                    $content.find('[data-pgdm-condition="not_selected"]').show();
                }
            }

            pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);

            view.onDestroy = function() {
                removeConnection();
                pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);
            }
        }

        var PgQuickDocViewer = function($target) {

            var dv = new PgDocsViewerView();

            var win = new PgQuickWindow('Documentation', dv, 'quickDocViewer', 640, 640, true);

            win.$element.addClass('pg-docs-win');

            dv.quickWin = win;

            win.showFor$El($('#crsa-topbar .icon-271'), true /* at previous pos */);

            this.showTopic = function(tid) {
                dv.showTopic(tid);
            }

            win.onDestroy = function() {
                docViewer = null
            }

            this.destroy = function() {
                win.destroy();
            }
        }

        var docViewer = null;
        var docsWindow = null;
        var docsView = null;
        
        pinegrow.showDocsTopic = function(tid) {
            tid = tid || current_topic_id || 'docs.index';

            current_topic_id = tid;

            if(!open_in_external) {
                if (!docViewer) {
                    docViewer = new PgQuickDocViewer();
                }
                docViewer.showTopic(tid);
            } else {
                if (docsWindow) {
                    if(docsView) {
                        docsView.showTopic(tid);
                    }
                } else {
                    var gui = require('nw.gui');

                    gui.Window.get().on('close', function() {
                        if(docsWindow) {
                            docsWindow.close(true);
                        }
                    })

                    gui.Window.open('empty.html', {
                        focus: true,
                        id: 'pgDocs',
                        always_on_top: true,
                        title: 'Help - Pinegrow'
                    }, function (win) {
                        docsWindow = win;

                        var first_load = true;

                        docsWindow.on('loaded', function () {
                            if (first_load) {
                                docsView = new PgDocsViewerView();

                                docsView.view.alwaysVisible = true;
                                docsView.view.updateVisibility();

                                $(docsWindow.window.document.body).find('#win-content').append(docsView.view.get$Element());
                                docsView.showTopic(tid);
                                first_load = false;

                                docsWindow.title = 'Help - Pinegrow';
                            }
                        })

                        docsWindow.on('closed', function () {
                            docsView.view.destroy();
                            docsWindow = null;
                        });
                    })
                }
            }
        }

    });


});