$(function() {

    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('pg.info.editor', 'Info panel editor');
        f.type = "pg.info.editor";
        f.allow_single_type = true;

        f.description = 'Helpers for editing the content of the Info panel.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        f.has_actions = true;
        f.show_in_manager = false;

        f.detect = function(page) {
            return page.name === '_info.html';
        }

        f.setScriptFileByScriptTagId('plugin-pginfoeditor', 'pg.info.editor.js');
        pinegrow.addFramework(f, 3);



        var select_action = new PgComponentType('pginfo.select', 'Select element');
        select_action.selector = "[data-pginfo-select]";
        select_action.attribute = 'data-pginfo-select';
        select_action.action = true;
        select_action.not_main_type = true;
        select_action.sections = {
            'pginfo.select.parameters' : {
                name : 'Options',
                fields : {
                    'data-pginfo-select' : {
                        type : 'selector',
                        name : 'Selector',
                        action : "element_attribute",
                        attribute : 'data-pginfo-select',
                        attribute_keep_if_empty : true,
                        selector_global: true,
                        get_selector_base: function(pgel) { return pgel.closest('html'); },
                        placeholder: 'element selector'
                    },
                    'data-pginfo-select-page' : {
                        type : 'text',
                        name : 'Page name',
                        action : "element_attribute",
                        attribute : 'data-pginfo-select-page',
                        placeholder: f.textDefaultValue('selected page')
                    },
                    'data-pginfo-select-no-reveal' : {
                        type : 'checkbox',
                        name : 'Do not reveal',
                        action : "element_attribute",
                        attribute : 'data-pginfo-select-no-reveal',
                        value: 'true'
                    },
                }
            }
        };

        f.addComponentType(select_action);

        
        

        var select_animation = new PgComponentType('pginfo.animation', 'Select animation');
        select_animation.selector = "[data-pginfo-animation]";
        select_animation.attribute = 'data-pginfo-animation';
        select_animation.action = true;
        select_animation.not_main_type = true;
        select_animation.sections = {
            'pginfo.animation.parameters' : {
                name : 'Options',
                fields : {
                    'data-pginfo-animation' : {
                        type : 'select',
                        name : 'Action',
                        action : "element_attribute",
                        attribute : 'data-pginfo-animation',
                        attribute_keep_if_empty : true,
                        options: [
                            {key: 'animation-action', name: 'Interactions'},
                            {key: 'scroll-scene', name: 'Scroll scene'},
                            {key: 'animation-hide', name: 'Hide at start'},
                            {key: 'animation-show', name: 'Show at start'},
                            {key: 'animation-smooth-scroll', name: 'Smooth scroll'},
                            {key: 'animation-apply', name: 'Apply to many'},
                        ]
                    },
                    'data-pginfo-animation-index' : {
                        type : 'text',
                        name : 'Animation index',
                        action : "element_attribute",
                        attribute : 'data-pginfo-animation-index',
                        placeholder: f.textForExample('1 is the first')
                    },
                    'data-pginfo-animation-edit' : {
                        type : 'checkbox',
                        name : 'Open in timeline',
                        action : "element_attribute",
                        attribute : 'data-pginfo-animation-edit',
                        value: 'true'
                    },
                }
            }
        };

        f.addComponentType(select_animation);




        var tooltip_action = new PgComponentType('pginfo.tooltip', 'Tooltip');
        tooltip_action.selector = "[data-pginfo-tooltip]";
        tooltip_action.attribute = 'data-pginfo-tooltip';
        tooltip_action.action = true;
        tooltip_action.not_main_type = true;
        tooltip_action.sections = {
            'pginfo.tooltip.parameters' : {
                name : 'Options',
                fields : {
                    'data-pginfo-tooltip' : {
                        type : 'select',
                        name : 'Tooltip',
                        action : "element_attribute",
                        attribute : 'data-pginfo-tooltip',
                        attribute_keep_if_empty : true,
                        options: [
                            {key: 'code_editor', name: 'code_editor'},
                            {key: 'page_view', name: 'page_view'},
                            {key: 'check', name: 'check'},
                            {key: 'edit_text', name: 'edit_text (sel. menu)'},
                            {key: 'edit_text_done', name: 'edit_text_done'},
                            {key: 'insert_char', name: 'insert_char'},
                            {key: 'edit_text_link', name: 'edit_text_link'},
                            {key: 'insert_menu', name: 'insert_menu'},
                            {key: 'edit_text_span', name: 'edit_text_span'},
                            {key: 'duplicate', name: 'duplicate'},
                            {key: 'more_actions', name: 'more_actions'},
                            {key: 'attributes_panel', name: 'attributes_panel'},
                            {key: 'click_icon', name: 'click_icon (sel. menu)'},
                            {key: 'style', name: 'style panel'},
                            {key: 'tree_panel', name: 'structure / tree panel'},
                            {key: 'design', name: 'design panel'},
                            {key: 'classstyles', name: 'classstyles panel'},
                            {key: 'interactions_panel', name: 'interactions_panel'},
                            {key: 'menu_toggle', name: 'menu_toggle'},
                            {key: 'empty_placeholder', name: 'empty_placeholder'},
                            {key: 'save_css', name: 'save_css as new rule'},
                            {key: 'preview', name: 'preview'},
                            {key: 'project_menu', name: 'project_menu'},
                        ]
                    }
                }
            }
        };

        f.addComponentType(tooltip_action);

        var show_field_selector_map = {
            prop_general: 'prop:niga, .pg-combined-panel-master',
            prop_framework: 'prop:niga, .pg-combined-panel-master-helper',
            bs5_button_type: 'prop:niga, .crsa-field-bs5-buttontype',
            bs5_spacing: 'prop:niga, .bs4-margin-and-padding',
            bs5_spacing_device_sizes: 'prop:niga, .pg-ui-section[data-key=\'sec_open_Spacing_Bootstrap 5\'] .sc-device-selector',
            bs5_helper_grid: '.page .pg-button-toolbar-section .pg-button-toolbar-item:nth-child(1)',
            bs5_helper_columns: '.page .pg-button-toolbar-section .pg-button-toolbar-item:nth-child(2)',
            prop_classes: 'prop:niga, .crsa-field-rules',
            design_saved_styles: 'pgdm:niga, .pg-dm-keep-list-uigrid',
            design_surprise_me: 'pgdm:niga, .pg-dm-design-controls .pg-button:first-child',
            design_colors: 'pgdm:niga, .pg-ui-section[data-key=\'sec_open_Colors_null\']',
            design_fonts: 'pgdm:niga, .pg-ui-section[data-key=\'sec_open_Typography_null\']',
            design_background: 'pgdm:niga, .pg-ui-section[data-key=\'sec_open_Background_null\']',
            design_bs_options: 'pgdm:niga, .pg-ui-section[data-key=\'sec_open_Bootstrap options_null\']',
        }

        f.ieGetSelectorForShowField = function($el) {
            var key = $el.attr('data-pginfo-selectui');
            var panel = $el.attr('data-pginfo-selectui-panel');
            var selector = $el.attr('data-pginfo-selectui-selector');
            if(key) {
                if(show_field_selector_map[key]) {
                    return show_field_selector_map[key];
                }
            }
            return null;
        }

        var select_in_ui = new PgComponentType('pginfo.selectui', 'Select in UI');
        select_in_ui.selector = "[data-pginfo-selectui]";
        select_in_ui.attribute = 'data-pginfo-selectui';
        select_in_ui.action = true;
        select_in_ui.not_main_type = true;
        select_in_ui.sections = {
            'pginfo.selectui.parameters' : {
                name : 'Options',
                fields : {
                    'data-pginfo-selectui' : {
                        type : 'select',
                        name : 'Panel',
                        action : "element_attribute",
                        attribute : 'data-pginfo-selectui',
                        attribute_keep_if_empty : true,
                        options: function() {
                            var r = [];
                            $.each(show_field_selector_map, function(key, val) {
                                r.push({key: key, name: key})
                            })
                            return r;
                        }
                    },
                    'data-pginfo-selectui-panel' : {
                        type : 'select',
                        name : 'Panel',
                        action : "element_attribute",
                        attribute : 'data-pginfo-selectui-panel',
                        attribute_keep_if_empty : true,
                        options: [
                            {key: 'library', name: 'library'},
                            {key: 'project', name: 'project'},
                            {key: 'history', name: 'history'},
                            {key: 'tree', name: 'tree'},
                            {key: 'prop', name: 'prop'},
                            {key: 'style', name: 'style'},
                            {key: 'info', name: 'info'},
                            {key: 'act', name: 'act'},
                            {key: 'cms', name: 'cms'},
                            {key: 'classstyles', name: 'classstyles'},
                            {key: 'animations', name: 'animations'},
                        ]
                    },
                    'data-pginfo-selectui-selector' : {
                        type : 'selector',
                        name : 'Selector',
                        action : "element_attribute",
                        attribute : 'data-pginfo-selectui-selector',
                        attribute_keep_if_empty : true,
                        selector_global: true,
                        get_selector_base: function(pgel) { return pgel.closest('html'); },
                        placeholder: 'element selector'
                    },
                }
            }
        };

        f.addComponentType(select_in_ui);



        var section = new PgFrameworkLibSection('pginfo', 'Info editor');
        section.setComponentTypes([select_action, select_animation, tooltip_action, select_in_ui]);
        f.addActionsSection(section);
        
        var delayedTasks = new PgDelayedTasks();

        f.on_page_changes_done = function(page, info) {
            delayedTasks.run('update', function() {
                var node = page.sourceNode.clone(true);
                var body = node.findOne('body');
                var h1 = body.findOne('h1');
    
                var info_data = {
                    title: h1.html()
                }
    
                h1.remove();
    
                info_data.content = pinegrow.kidsTutorial.addInteractiveElementsToHTML(body.html());
    
                pinegrow.infoPanel.setContent(null, info_data, true);
            }, 500)
        }



        //Display help

        var intro_class = 'lead'; //class used for intro paragraph
        var ui_defs = {
            prop: {
                icon: 'icon-settings', name: 'Element properties'
            },
            style: {
                icon: 'icon-Pin15', name: 'Style'
            },
            element_code_panel: {
                icon: 'icon-KODA', name: 'Element code'
            },
            library: {
                icon: 'icon-import', name: 'Library'
            },
            act: {
                icon: 'icon-actions', name: 'Actions'
            },
            cms: {
                icon: 'icon-WP', name: 'WordPress'
            },
            project: {
                icon: 'icon-project', name: 'Project'
            },
            history: {
                icon: 'icon-undo', name: 'History'
            },
            tree: {
                icon: 'icon-Pin11', name: 'Tree'
            },
            interactions: {
                icon: 'icon-113', name: 'Interactions'
            },
            pagecode: {
                icon: 'icon-KODA', name: 'Page code'
            }
        }

    });


});