$(function() {


    $('body').one('pinegrow-ready', function(e, pinegrow) {




        pinegrow.addEventHandler('on_get_actions_for_start_menu', function(pagenull, start_actions) {

            var actions = [];

            var video_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-camera-reels" viewBox="0 0 16 16">
<path d="M6 3a3 3 0 1 1-6 0 3 3 0 0 1 6 0zM1 3a2 2 0 1 0 4 0 2 2 0 0 0-4 0z"/>
<path d="M9 6h.5a2 2 0 0 1 1.983 1.738l3.11-1.382A1 1 0 0 1 16 7.269v7.462a1 1 0 0 1-1.406.913l-3.111-1.382A2 2 0 0 1 9.5 16H2a2 2 0 0 1-2-2V8a2 2 0 0 1 2-2h7zm6 8.73V7.27l-3.5 1.555v4.35l3.5 1.556zM1 8v6a1 1 0 0 0 1 1h7.5a1 1 0 0 0 1-1V8a1 1 0 0 0-1-1H2a1 1 0 0 0-1 1z"/>
<path d="M9 6a3 3 0 1 0 0-6 3 3 0 0 0 0 6zM7 3a2 2 0 1 1 4 0 2 2 0 0 1-4 0z"/>
</svg>`,
                label: 'Watch the intro video',
                desc: 'First time here? Learn everything you need to get started.',
                class: 'pg-lessons-intro-video',
                action: function () {
                    var video_player = new PgTutorialVideo('569606233', pgTutorialSubtitles.get('intro.video.kids'));
                    pinegrow.backend.setLessonStatus({
                        key: 'intro.video.kids'
                    }, 'done');
                }
            }

            actions.push(video_action);

            var docs_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-map" viewBox="0 0 16 16">
  <path fill-rule="evenodd" d="M15.817.113A.5.5 0 0 1 16 .5v14a.5.5 0 0 1-.402.49l-5 1a.502.502 0 0 1-.196 0L5.5 15.01l-4.902.98A.5.5 0 0 1 0 15.5v-14a.5.5 0 0 1 .402-.49l5-1a.5.5 0 0 1 .196 0L10.5.99l4.902-.98a.5.5 0 0 1 .415.103zM10 1.91l-4-.8v12.98l4 .8V1.91zm1 12.98 4-.8V1.11l-4 .8v12.98zm-6-.8V1.11l-4 .8v12.98l4-.8z"/>
</svg>`,
                label: 'Pinegrow Academy',
                desc: 'Learn how to get started and get the most out of Pinegrow.',
                url: 'https://htmlplanetforkids.com/guide.html'
            }

            actions.push(docs_action);

            var community_action = {
                icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chat" viewBox="0 0 16 16">
  <path d="M2.678 11.894a1 1 0 0 1 .287.801 10.97 10.97 0 0 1-.398 2c1.395-.323 2.247-.697 2.634-.893a1 1 0 0 1 .71-.074A8.06 8.06 0 0 0 8 14c3.996 0 7-2.807 7-6 0-3.192-3.004-6-7-6S1 4.808 1 8c0 1.468.617 2.83 1.678 3.894zm-.493 3.905a21.682 21.682 0 0 1-.713.129c-.2.032-.352-.176-.273-.362a9.68 9.68 0 0 0 .244-.637l.003-.01c.248-.72.45-1.548.524-2.319C.743 11.37 0 9.76 0 8c0-3.866 3.582-7 8-7s8 3.134 8 7-3.582 7-8 7a9.06 9.06 0 0 1-2.347-.306c-.52.263-1.639.742-3.468 1.105z"/>
</svg>`,
                label: 'Join the community',
                desc: 'Interact with Pinegrow users and the team.',
                action: function() {
                    var html = `<p>Join our community to interact with users and development team.</p>
<p><a href="https://forum.pinegrow.com" class="btn pg-button pg-button-primary" target="_blank">Community forum</a></p>
<p><a href="https://www.facebook.com/pinegrow" class="btn pg-button pg-button-primary" target="_blank">Facebook</a></p>
<p><a href="https://www.youtube.com/channel/UCo2RGSbsI9GIxVvJPXanUuw" class="btn pg-button pg-button-primary" target="_blank">YouTube</a></p>
<p><a href="https://twitter.com/pinegrow" class="btn pg-button pg-button-primary" target="_blank">Twitter</a></p>

    <h4 class="footer-links--header">Subscribe to our Newsletter</h4>
    <p style="margin-bottom: 10px;">Get news about Pinegrow. You can unsubscribe at any time.</p>
    <div class="row-signup" style="padding: 0;">
        <form class="form-inline" action="https://www.getdrip.com/forms/8855293/submissions" method="post" target="_blank" rel="noopener" data-drip-embedded-form="8855293" style="margin-bottom: 10px;"> 
            <div class="form-group subscribe-group"> 
                <label for="emailfield" class="sr-only">Email address:</label>
                <input type="email" class="form-control" placeholder="email@example.com" required="true" name="fields[email]" id="emailfield">
                <button type="submit" class="btn btn-primary subscribe btn-lg">Subscribe</button>                                         
            </div>                                     
        </form>
    </div>                             
                        
`;

                    pinegrow.showAlert(html, 'Join the community', 'Close', null);
                }
            }

            actions.push(community_action);

            if(!pinegrow.currentUser.isPro()) {
                var activate_action = {
                    icon: `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-gift" viewBox="0 0 16 16">
<path d="M3 2.5a2.5 2.5 0 0 1 5 0 2.5 2.5 0 0 1 5 0v.006c0 .07 0 .27-.038.494H15a1 1 0 0 1 1 1v2a1 1 0 0 1-1 1v7.5a1.5 1.5 0 0 1-1.5 1.5h-11A1.5 1.5 0 0 1 1 14.5V7a1 1 0 0 1-1-1V4a1 1 0 0 1 1-1h2.038A2.968 2.968 0 0 1 3 2.506V2.5zm1.068.5H7v-.5a1.5 1.5 0 1 0-3 0c0 .085.002.274.045.43a.522.522 0 0 0 .023.07zM9 3h2.932a.56.56 0 0 0 .023-.07c.043-.156.045-.345.045-.43a1.5 1.5 0 0 0-3 0V3zM1 4v2h6V4H1zm8 0v2h6V4H9zm5 3H9v8h4.5a.5.5 0 0 0 .5-.5V7zm-7 8V7H2v7.5a.5.5 0 0 0 .5.5H7z"/>
</svg>`,
                    label: 'Activate Pinegrow Pro',
                    desc: 'Buy or activate your Pinegrow Pro license.',
                    action: function () {
                    }
                }
                actions.push(activate_action);
            }




            actions.forEach(function(a) {
                start_actions.push(a);
            })
        })

        pinegrow.addEventHandler('on_get_new_project_templates', function(pagenull, template_list) {
            var list = [
                {
                    name: 'Blank Plain HTML Project',
                    pid: 'https://tutorial_new_html',
                    thumb: 'blank_html.png',
                    desc: 'Sometimes HTML &amp; CSS is all you need.',
                    vid: '',
                    subid: ''
                },
                {
                    name: 'Blank Bootstrap 5 Project',
                    pid: 'https://tutorial_new_bs',
                    thumb: 'blank_bootstrap.jpg',
                    desc: 'Bootstrap 5 with Design panel and Blocks.',
                    vid: '',
                    subid: ''
                },
                {
                    name: 'Blank Tailwind CSS Project',
                    pid: 'https://tutorial_new_tw',
                    thumb: 'blank_tailwind.png',
                    desc: 'Tailwind CSS with Design panel and Blocks.',
                    vid: '',
                    subid: ''
                }
            ]

            /*
            if(location.hostname === 'pinegrowonline') {
                list.forEach(function(i) {
                    i.pid = i.pid.replace('pine/', 'matjaz/');
                })
                list.push({
                    name: 'New',
                    pid: 'new',
                    thumb: 'blank.jpg',
                    desc: 'Create from scratch',
                    vid: '',
                    subid: ''
                })

                list.push(
                {
                    name: 'Agency',
                    pid: 'matjaz/agency',
                    thumb: 'blank.jpg',
                    desc: 'Create from scratch',
                    vid: '',
                    subid: ''
                });
            }

             */

            list.forEach(function(t) {
                t.thumb = `images/project_templates/${t.thumb}`;
                //t.thumb = `images/project_templates/${t.thumb}`;
                template_list.push(t);
            })
        })

    })
})