$(function() {

    $('body').one('pinegrow-ready', function (e, pinegrow) {

        class PgTutorialFirstBlock extends PgTutorial {
            constructor() {
                super();
                this.name = 'Build your first block';
                this.description = ``;
                this.prefix = 'build_your_first_block_';
                this.registerThisTutorial = true;
                this.allowRandomAccess = true;

                this.mainLesson = null;

                this.pinegrow_json = `{"files":{},"open-pages":["index.html"],"urls":{"index.html":{"open-with-wrapper":false}},"wp-theme-info":{"dir":null,"name":"Cool Blocks","slug":"cool_blocks","auto_increment_version":"1","page":"index.html","wpseo":"true","wpjquery":"false","generator":"true","images":{},"blocks_type":"native-auto","pg_version":"1.0","blocks_editor_styles":[],"project_type":"plugin","blocks_inline_svg":"false","wc_enabled":"false","project_version":"1.0.0"},"wp-insight":{"menus":["primary","social"],"taxonomies":["category","post_tag"],"customizer_sections":[],"customizer_controls":[],"post_types":["attachment","page","post"],"template_parts":[],"sidebars":[],"master_pages":[],"image_sizes":["full","large","medium","medium_large","post-thumbnail","thumbnail"],"custom_funcs":[],"block_categories":[]}}`;

                this.lesson_01_Intro();
                this.lesson_02_Layout();
                this.lesson_03_Grid();
                this.lesson_04_ActivateWP();
                this.lesson_05_DefineBlock();
                this.lesson_06_Editable();
                this.lesson_07_Wrapper();
                this.lesson_08_CreatingCSSRules();
                this.lesson_09_Styling();
                this.lesson_10_Link();
                this.lesson_11_ConditionalLink();
                this.lesson_12_LinkLabel();
                this.lesson_13_BlockIconAndCat();
                this.lesson_14_Responsive();
            }

            newLesson(key) {
                var l = new PgTutorialLesson(this.prefix + key, null, null);
                l.main_lesson = this.mainLesson;
                return l;
            }

            lesson_01_Intro() {
                var l = this.newLesson('intro');
                l.name = 'Introduction';
                l.description = l.makeDesc('000', 'Intro')
                l.main_lesson_project_name = this.name;

                l.description = l.makeDesc(
                    '483417920',
                    `<p>Join us on an exciting adventure of building a real custom Gutenberg block.</p>`,
                    `<p>Lots of fun content coming here soon... </p>
<ol>
<li>Steps will come here...</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html><html><head><meta name="viewport" content="width=device-width, initial-scale=1.0"/><link href="css/normalize.css" rel="stylesheet"><link href="css/style.css" rel="stylesheet">
        </head><body></body></html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }
                this.mainLesson = l;
                this.addLesson(l);
            }

            lesson_02_Layout() {
                var l = this.newLesson('layout');
                l.name = 'Build the HTML structure';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Build the HTML structure for the About Me block.</p>`,
                    `<p>Let's create the following HTML structure:</p>
<pre>
section     &lt;-- Main block element
  div       &lt;-- Left column
    img     &lt;-- Image
  div       &lt;-- Right column
    h3      &lt;-- Name
    p       &lt;-- Description
</pre>

<ol>
<li>Open the <b>${this.tooltip('Insert', 'insert_menu')}</b> panel.</li>
<li>Drag <b>${this.showLibElement( this.showElement('section'), '.crsa-factory-element-type-html-section')}</b> to the page.</li>
<li>Use the <b>Tree panel</b> to inspect the HTML structure.</li>
<li>Open the <b>${this.tooltip('Insert', 'insert_menu')}</b> panel again.</li>
<li><p>Type or copy-paste the following into the <b>${this.showLibElement( 'Insert code', '.pg-code-insert')}</b>:</p>
<pre>
div
  img
div
  h3 Mr. Pine Cone
  p Something about me...
</pre>
</li>
<li>Drag <b>${this.showLibElement( 'the created HTML', '.pg-code-insert .crsa-factory-element')}</b> inside the <b>${this.select('section')}</b> on the page or in the tree.</li>
</ol>

`)

                l.addPage('index.html', `<!doctype html><html><head><meta name="viewport" content="width=device-width, initial-scale=1.0"/><link href="css/normalize.css" rel="stylesheet"><link href="css/style.css" rel="stylesheet">
        </head><body></body></html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_03_Grid() {
                var l = this.newLesson('grid');
                l.name = 'Design the layout with CSS Grid';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Use the CSS grid editor to create the layout.</p>`,
                    `<ol>
<li>Select the <b>${this.select('section')}</b> element.</li>
<li>Open the <b>CSS grid</b> editor.</li>
<li>Click on the <b>${this.showGridElement('Create CSS grid', '.create-grid')}</b> button.</li>
<li>Delete one of the grid <b>${this.showGridElement('columns', '.pg-dm-grid-view-grid-col')}</b> so that only two columns remain.</li>
<li>Set the <b>${this.showGridElement('row height', '.pg-dm-grid-view-grid-row')}</b> to <code>auto</code>. Double-click on the field for dropdown of values.</li>
<li>Set the <b>${this.showGridElement('gap', '.crsa-field-gap')}</b> to <code>20px</code>.</li>
<li>Close the CSS grid editor.</li>
<li>To fix the image size, select the <b>${this.select('img')}</b> element and go to the <b>Style panel</b>.</li>
<li>Set the <b>Max width</b> property to <code>100%</code>.</li>
</ol>

`)

                l.addPage('index.html', `<!doctype html>
        <html>
        <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
                <link href="css/style.css" rel="stylesheet"/>
                </head>
        <body>
        <section>
        <div>
        <img src="https://pinegrow.com/placeholders/img16.jpg"/>
        </div>
        <div>
        <h3>Mr. Pine Cone</h3>
        <p>Something about me...</p>
        </div>
        </section>
        </body>
        </html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_04_ActivateWP() {
                var l = this.newLesson('activatewp');
                l.name = 'Setup the WordPress export';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Create and activate the WordPress plugin.</p><blockquote>Note: The first step will open a modal dialog box and you won't be able to see these instructions. Read steps 1-5 first, and then do the first step.</blockquote>`,
                    `<ol>
<li>Click on the <b>WordPress menu</b> button to activate the WordPress export.</li>
<li>Set <b>Project type</b> to <code>Plugin</code>.</li>
<li>Set <b>Plugin name</b> to <code>Cool Blocks</code> (or similar).</li>
<li>Set <b>Project slug</b> to <code>cool_blocks</code>.</li>
<li>Click on the <b>Save settings</b> button to keep the settings and close the dialog.</li>
<li>Click on the <b>WordPress menu</b> again. Now it displays the menu.</li>
<li>Select the <b>Export the plugin</b> command from the WordPress menu.</li>
<li>Go to <a href="/wp-admin/plugins.php" target="_blank">WordPress dashboard -&gt; Plugins</a> and activate the plugin <b>Cool Blocks</b>.</li>
</ol>

`)

                l.addPage('index.html', `<!doctype html>
<html>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section style="display:grid;grid-template-columns:1fr 1fr;grid-template-rows:auto;gap:20px;">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" style="max-width: 100%;"/>
            </div>
            <div>
                <h3>Mr. Pine Cone</h3>
                <p>Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_05_DefineBlock() {
                var l = this.newLesson('defineblock');
                l.name = 'Use the Block action to define the block';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Add the Block action to create a new custom block.</p>`,
                    `<ol>
<li>Select the <b>${this.select('section')}</b> element.</li>
<li>Switch to the <b>WordPress panel</b>.</li>
<li>Click on the <b>${this.showWPActionName('Block', '[data-action="cms-block"]')}</b> action to add it to the selected element.</li>
<li>Set the <b>${this.showWPActionField('Unique id', 'cms-block')}</b> to <code>about-me</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block', 'title')}</b> to <code>About me</code>.</li>
<li><b>Export the plugin</b>.</li>
<li>Go to WordPress dashboard, edit a page and add the block <code>About me</code> to the content.</li>
</ol>

`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section style="display:grid;grid-template-columns:1fr 1fr;grid-template-rows:auto;gap:20px;">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" style="max-width: 100%;"/>
            </div>
            <div>
                <h3>Mr. Pine Cone</h3>
                <p>Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_06_Editable() {
                var l = this.newLesson('editable');
                l.name = 'Make the block editable';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Add the Block Attributes action to make the block content editable.</p>`,
                    `<ol>
<li>Select the <b>${this.select('h3')}</b> element.</li>
<li>Switch to the <b>WordPress panel</b>.</li>
<li>Click on the <b>${this.showWPActionName('Block Attributes', '[data-action="cms-block-field"]')}</b> action to add it to the selected heading.</li>
<li>Set the <b>${this.showWPActionField('Attribute id', 'cms-block-field')}</b> to <code>name</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block-field', 'title')}</b> to <code>Name</code>.</li>

<li>Select the <b>${this.select('p')}</b> element.</li>
<li>Add the <b>${this.showWPActionName('Block Attributes', '[data-action="cms-block-field"]')}</b> action.</li>
<li>Set the <b>${this.showWPActionField('Attribute id', 'cms-block-field')}</b> to <code>bio</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block-field', 'title')}</b> to <code>Bio</code>.</li>

<li>Select the <b>${this.select('img')}</b> element.</li>
<li>Add the <b>${this.showWPActionName('Block Attributes', '[data-action="cms-block-field"]')}</b> action.</li>
<li>Set the <b>${this.showWPActionField('Attribute id', 'cms-block-field')}</b> to <code>image</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block-field', 'title')}</b> to <code>Image</code>.</li>
<li>Notice that <b>${this.showWPActionField('Use as', 'cms-block-field', 'type')}</b> is set to <code>Image</code>.</li>

<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section style="display:grid;grid-template-columns:1fr 1fr;grid-template-rows:auto;gap:20px;" cms-block="about-me" cms-block-title="About me">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" style="max-width: 100%;"/>
            </div>
            <div>
                <h3>Mr. Pine Cone</h3>
                <p>Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_07_Wrapper() {
                var l = this.newLesson('wrapper');
                l.name = 'Use the site styling during editing';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Open the block inside a live site view.</p>`,
                    `<ol>
<li>Go to the <b>Project panel</b>.</li>
<li><code>Right-click</code> on the file <b>${this.showProjectFile('index.html')}</b>.</li>
<li>Select the <b>Open in wrapper</b> command.</li>
<li><p>Set <b>URL of the page</b> to <code>/</code> to display the block on the home page.</p><p>Or, you can use any other page on the site. For best results, DO NOT use a page where the block is already displayed.</li>
<li>Leave the <b>CSS Selector</b> field empty to display the block in the first <code>article</code>, <code>main</code> or <code>body</code> element. Or, enter the selector of the element on the page where the block should be displayed during editing.</li>
<li>Click on the <b>Save &amp; open</b> button.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section style="display:grid;grid-template-columns:1fr 1fr;grid-template-rows:auto;gap:20px;" cms-block="about-me" cms-block-title="About me">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" style="max-width: 100%;" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_08_CreatingCSSRules() {
                var l = this.newLesson('creatingrules');
                l.name = 'Create CSS rules';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Save inline styles into CSS class rules.</p>`,
                    `<ol>
<li>Select the ${this.select('section')} element.</li>
<li>Go to the <b>Style panel</b>.</li>
<li><b>Save the inline style</b> in a CSS rule with the selector <code>.cool-blocks-about-me</code>.</li>
<li>Select the ${this.select('img')} element.</li>
<li><b>Save the inline style</b> in a CSS rule with the selector <code>.cool-blocks-about-me img</code>.</li>
<li>Select the ${this.select('section')} element.</li>
<li>Go to the <b>WordPress panel</b>.</li>
<li>Open the <b>${this.showWPAction('More options', `[data-action="cms-block"] .pg-action-section .icon-right`, true)}</b> section.</li>
<li>Set the <b>${this.showWPActionField('Style', 'cms-block', 'style')}</b> field to <code>css/style.css</code>.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section style="display:grid;grid-template-columns:1fr 1fr;grid-template-rows:auto;gap:20px;" cms-block="about-me" cms-block-title="About me">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" style="max-width: 100%;" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', '');
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_09_Styling() {
                var l = this.newLesson('style');
                l.name = 'Tweak the styling';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Add the padding and size the image.</p>`,
                    `<ol>
<li>Select the ${this.select('section')} element.</li>
<li>Go to the <b>Style panel</b>.</li>
<li>Make sure that the rule <code>.cool-blocks-about-me</code> is selected.</li>
<li>Set <b>Padding top / bottom</b> to <code>20px</code>.</li>
<li>Select the ${this.select('img')} element.</li>
<li>Make sure that the rule <code>.cool-blocks-about-me img</code> is selected.</li>
<li>Set <b>Min height</b> to <code>340px</code>.</li>
<li>Set <b>Object fit</b> to <code>cover</code>.</li>
<li>Play around with different ways of styling the block. Use visual controls, properties or code editor. If needed, ${this.tooltip('Turn off the visual helpers', 'menu_toggle')} to better see the selected element.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: auto;
    gap: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_10_Link() {
                var l = this.newLesson('link');
                l.name = 'Add editable link';
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Add a Learn more link to the block.</p>`,
                    `<ol>
<li>Use the <b>Insert panel</b> to insert an anchor ${this.showElement('a')} into the ${this.select('second <div>', 'div:nth-of-type(2)')}.</li>
<li><b>Activate the text editor</b> and change the link label to <code>Learn more about me</code>.</li>
<li>Click on the <b>${this.tooltip('Done button', 'edit_text_done')}</b> in the blue Text edit menu above the element when you're done with changing the text.</li>
<li>Or, you could use the <b>Inner HTML</b> field in the <b>Properties panel</b> to edit the link label.</li>
<li>Or, you could use the <b>${this.tooltip('element code editor', 'more_actions')}</b> to edit it.</li>
<li>Go to the <b>WordPress panel</b>.</li>
<li>Add the <b>${this.showWPActionName('Block Attributes', '[data-action="cms-block-field"]')}</b> action.</li>
<li>Set the <b>${this.showWPActionField('Attribute id', 'cms-block-field')}</b> to <code>more_link</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block-field', 'title')}</b> to <code>Learn more link</code>.</li>
<li>Notice that <b>${this.showWPActionField('Use as', 'cms-block-field', 'type')}</b> is set to <code>Link</code>.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 2fr 3fr;
    grid-template-rows: auto;
    gap: 20px;
    padding-top: 20px;
    padding-bottom: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
    min-height: 340px;
    object-fit: cover;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_11_ConditionalLink() {
                var l = this.newLesson('conditionallink');
                l.name = `Conditionally display the link`;
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Display the link only when it is set.</p>`,
                    `<ol>
<li>Select the <b>${this.select('link <a>', 'a')}</b> element.</li>
<li>Go to the <b>WordPress panel</b>.</li>
<li>Open the <b>${this.showWPAction('Attribute options', `[data-action="cms-block-field"] .pg-action-section .icon-right`, true)}</b> section on the Block Attributes action.</li>
<li>Set the <b>${this.showWPActionField('If empty', 'cms-block-field', 'if-empty')}</b> to <code>Remove the element</code>.</li>
<li>With this setting the link will only be displayed if the <code>more_link</code> attribute is set.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p><a href="" cms-block-field="more_link" cms-block-field-type="link" cms-block-field-title="Learn more link">Learn more about me</a>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 2fr 3fr;
    grid-template-rows: auto;
    gap: 20px;
    padding-top: 20px;
    padding-bottom: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
    min-height: 340px;
    object-fit: cover;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_12_LinkLabel() {
                var l = this.newLesson('linklabel');
                l.name = `Make the link label editable`;
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Add an editable block attribute for the link label.</p>`,
                    `<ol>
<li>Select the <b>${this.select('link <a>', 'a')}</b> element.</li>
<li>Go to the <b>WordPress panel</b>.</li>
<li>Click on the <b>${this.showWPActionAddItem('+ Add attribute', `cms-block-field`)}</b> button to add the second editable attribute.</li>
<li>Set the <b>${this.showWPActionField('Attribute id', 'cms-block-field', '2')}</b> to <code>more_link_label</code>.</li>
<li>Set the <b>${this.showWPActionField('Title', 'cms-block-field', 'title-2')}</b> to <code>Learn more link label</code>.</li>
<li>Set the <b>${this.showWPActionField('Use as', 'cms-block-field', 'type-2')}</b> field to <code>Content</code> so that the value of the attribute replaces is used as the content of the element.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p><a href="" cms-block-field="more_link" cms-block-field-type="link" cms-block-field-title="Learn more link">Learn more about me</a>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 2fr 3fr;
    grid-template-rows: auto;
    gap: 20px;
    padding-top: 20px;
    padding-bottom: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
    min-height: 340px;
    object-fit: cover;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_13_BlockIconAndCat() {
                var l = this.newLesson('blockiconcat');
                l.name = `Block icon and category`;
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Create a new blocks category and add icon to the block.</p>`,
                    `<ol>
<li>Select the <b>${this.select('section')}</b> element.</li>
<li>Go to the <b>WordPress panel</b>.</li>
<li>Click on the <b>${this.showWPActionField('Browse icons', 'cms-block', 'icon-browse')}</b> icon and select <code>Bootstrap icons</code>.</li>
<li>This opens Bootstrap icons website in a new tab. Find a suitable icon and copy its SVG code.</li>
<li>Paste the SVG code into the <b>${this.showWPActionField('Icon', 'cms-block', 'icon')}</b> field.</li>
<li>Set the <b>${this.showWPActionField('Category', 'cms-block', 'category')}</b> field to <code>Custom</code>.</li>
<li>Set the <b>${this.showWPActionField('Custom category id', 'cms-block', 'category-custom')}</b> to <code>cool_blocks</code>.</li>
<li>Check the <b>${this.showWPActionField('Register category', 'cms-block', 'category-custom-register')}</b> checkbox.</li>
<li>Set the <b>${this.showWPActionField('Category name', 'cms-block', 'category-custom-register-name')}</b> to <code>Cool Blocks</code>.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
                <a href="" cms-block-field="more_link" cms-block-field-type="link" cms-block-field-title="Learn more link" cms-block-field-2="more_link_label" cms-block-field-title-2="Learn more link label" cms-block-field-type-2="content">Learn more about me</a>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 2fr 3fr;
    grid-template-rows: auto;
    gap: 20px;
    padding-top: 20px;
    padding-bottom: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
    min-height: 340px;
    object-fit: cover;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lesson_14_Responsive() {
                var l = this.newLesson('responsive');
                l.name = `Making the block responsive`;
                l.description = l.makeDesc(
                    '483417920',
                    `<p>Create a mobile layout for the block.</p>`,
                    `<ol>
<li><b>${this.tooltip('Open a new page view', '', 'field', '.page-tab-header .icon-add')}</b> to see the page in desktop and mobile view.</li>
<li>Select the <b>${this.select('section')}</b> element.</li>
<li>Go to the <b>Style panel</b>.</li>
<li>Make sure the CSS rule <code>.cool-blocks-about-me</code> is selected.</li>
<li>Switch to the <b>${this.tooltip('MD size', '', 'field', 'style:niga,.crsa-css-gui .pg-dm-sizes-control [data-size=\'MD\']')}</b>.</li>
<li>Click on the <b>${this.tooltip('Create the rule', '', 'field', 'style:niga,.crsa-css-gui .pg-css-editor-no-rule-overlay button')}</b> button.</li>
<li>Open the <b>CSS grid</b> editor.</li>
<li>Delete one of the grid <b>${this.showGridElement('columns', '.pg-dm-grid-view-grid-col')}</b> so that only one column remains.</li>
<li>Switch to the rule <b>${this.showGridElement('(min-width: 769px) .cool-blocks-about-me', '.crsa-field-rule')}</b>.</li>
<li>Click on the <b>${this.showGridElement('Create CSS grid', '.create-grid')}</b> button.</li>
<li>Delete one column and set the other two to <code>2fr</code> and <code>3fr</code>. Set the </li>
<li>Set the <b>${this.showGridElement('row height', '.pg-dm-grid-view-grid-row')}</b> to <code>auto</code>. Double-click on the field for dropdown of values.</li>
<li>Close the CSS grid editor.</li>
<li><b>Export the plugin</b> and test the block.</li>
</ol>
`)

                l.addPage('index.html', `<!doctype html>
<html wp-template>
    <head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
        <link href="css/normalize.css" rel="stylesheet"/>
        <link href="css/style.css" rel="stylesheet"/>
    </head>
    <body>
        <section cms-block="about-me" cms-block-title="About me" class="cool-blocks-about-me" cms-block-style="css/style.css" cms-block-icon="<svg xmlns=&quot;http://www.w3.org/2000/svg&quot; width=&quot;16&quot; height=&quot;16&quot; fill=&quot;currentColor&quot; class=&quot;bi bi-person-lines-fill&quot; viewBox=&quot;0 0 16 16&quot;>   <path d=&quot;M6 8a3 3 0 1 0 0-6 3 3 0 0 0 0 6zm-5 6s-1 0-1-1 1-4 6-4 6 3 6 4-1 1-1 1H1zM11 3.5a.5.5 0 0 1 .5-.5h4a.5.5 0 0 1 0 1h-4a.5.5 0 0 1-.5-.5zm.5 2.5a.5.5 0 0 0 0 1h4a.5.5 0 0 0 0-1h-4zm2 3a.5.5 0 0 0 0 1h2a.5.5 0 0 0 0-1h-2zm0 3a.5.5 0 0 0 0 1h2a.5.5 0 0 0 0-1h-2z&quot;/> </svg>" cms-block-category="custom" cms-block-category-custom="cool_blocks" cms-block-category-custom-register="true" cms-block-category-custom-register-name="Cool Blocks">
            <div>
                <img src="https://pinegrow.com/placeholders/img16.jpg" cms-block-field="image" cms-block-field-type="image" cms-block-field-title="image"/>
            </div>
            <div>
                <h3 cms-block-field="name" cms-block-field-type="content" cms-block-field-title="Name">Mr. Pine Cone</h3>
                <p cms-block-field="bio" cms-block-field-type="content" cms-block-field-title="Bio">Something about me...</p>
                <a href="" cms-block-field="more_link" cms-block-field-type="link" cms-block-field-title="Learn more link">Learn more about me</a>
            </div>
        </section>
    </body>
</html>`);

                l.addStylesheet('css/normalize.css', pgSVGIcons.css_normalize);
                l.addStylesheet('css/style.css', `.cool-blocks-about-me {
    display: grid;
    grid-template-columns: 2fr 3fr;
    grid-template-rows: auto;
    gap: 20px;
    padding-top: 20px;
    padding-bottom: 20px;
}

.cool-blocks-about-me img {
    max-width: 100%;
    min-height: 340px;
    object-fit: cover;
}`);
                l.addPage('pinegrow.json', this.pinegrow_json);

                l.onCheck = function (page, status) {
                    var error = null;

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(l);
            }

            lessonDemo() {
                var h1 = this.newLesson('intro')

                h1.name = `Meet the h1 element`;
                h1.display_title = `Meet the h1 element`;

                h1.description = h1.makeDesc(
                    '483417920',
                    `<p>The ${this.showElement('h1')} (Heading 1) element is used for the main heading (title) of the page.</p>`,
                    `<p>Add the heading to Blotomic's message:</p>
                    <ol>
                    <li><b>Drag the H1 element</b> to the top of the message:<br>${h1.getHtmlForLibButton(this.tag('h1', 'Change me!'), '<h1>Change me!</h1>', null, null, 'body > h1:first-child', 'Place the H1 at the top of the yellow box.')}</li>
                    <li>Make sure that the ${this.select('H1 element', 'h1')} is selected on the page (selected element has a blue border and a menu). Click on the element to select it.</li>
                    <li><b>Activate the text editor</b> by clicking on the ${this.tooltip('text editor', 'edit_text')} icon in the blue menu above the H1 element.</li>
                    <li><b>Change the text</b> in the heading. For example, write <code>A special message</code>.</li>
                    <li>Click on the <b>${this.tooltip('Done button', 'edit_text_done')}</b> in the blue Text edit menu above the element when you're done with changing the text.</li>
                    <li><b>Open the ${this.tooltip('code editor', 'code_editor')}</b> to see how the H1 element looks in the code.</li>
                    <!-- <li><b>Change the text</b> of the title using the code editor.</li> -->
        </ol>
        `)

                h1.addPage('index.html', `<!doctype html><html><head><meta name="viewport" content="width=device-width, initial-scale=1.0"/><link href="style.css" rel="stylesheet">
        </head><body><p>Hello! My name is Blotomic. Welcome to HTML Planet! Here you will get to learn HTML and CSS. We also have many fun adventures for you. With the help of HTML Planet you'll be able to make super cool websites in no time! Good luck, I hope you'll enjoy it!</p></body></html>`);

                h1.addStylesheet('style.css', '');

                var use_structure_to_fix = `<br><br>Use the ${this.tooltip('structure panel', 'structure')} to fix the problem.`;

                h1.onCheck = function (page, status) {
                    var error = null;

                    var h1s = page.sourceNode.find('h1');
                    if (h1s.length === 0) {
                        error = 'There is <b>no H1 element</b> on the page.';
                    } else if (h1s.length > 1) {
                        error = `There should be <b>only one H1</b> on the page. ${use_structure_to_fix}`
                    } else {
                        if (h1s[0].text().toLowerCase().indexOf('change me') >= 0) {
                            error = 'Use the Text edit tool to change the title of the message.';
                        } else if (h1s[0].validateTree().length) {
                            error = 'The H1 element has <b>code errors</b>. Go to the code editor and check for missing &lt; and &gt; or incorrectly closed tags.'
                        } else if (h1s[0].text().trim().length === 0) {
                            error = 'The H1 needs some text.';
                        } else if (h1s[0].prev()) {
                            error = 'The H1 element should be <b>at the top of the yellow page</b>.'
                        }
                    }

                    if (error) {
                        status.result = 'error';
                        status.message = error;
                    } else {
                        status.result = 'ok';
                    }
                    //status.decoration = addAlien('alien1', 'check-box');
                }

                this.addLesson(h1);
            }
        }

        var tutorial = new PgTutorialFirstBlock();

    })
})
