//body/root
var body = {
    'type' : 'body',
    'selector' : 'body',
    'name' : 'Body'
}
$.fn.crsa.addDefinition(body);



var crsaAddStandardSections = function(addTo) {
    var rules_section = {
        name : 'Classes',
        fields : {
            'rules' : {
                'type' : 'rules',
                'name' : 'Classes',
                'action' : 'rules'
            }
        }
    };

    var s = {
        'id' : {
            name : 'Element',
            fields : {
                'element_id' : {
                    'type' : 'text',
                    'name' : 'Element Id',
                    'action' : 'element_id'
                }
            }
        },
        rules : rules_section
    };
    $.each(s, function(k,v) {
        addTo[k] = v;
    });
    return addTo;
}

//button
var button = {
    'type' : 'bs-button',
    'selector' : '.btn',
    'name' : 'Button',
    'code' : '<a class="btn">Button</a>',
    'panel_code' : '<a class="btn">Button</a>',
    'content_selector' : null,
    'drag_code' : null, //same as panel code
    'allowed_in' : null, //everywhere
    'sections' : crsaAddStandardSections({
        'button' : {
            name : 'Button',
            fields : {
                type : {
                    'type' : 'select',
                    'name' : 'Type',
                    'action' : 'apply_class',
                    'options' : [
                        {
                            'key' : 'btn-primary',
                            'name' : 'Primary'
                        },
                        {
                            'key' : 'btn-info',
                            'name' : 'Info'
                        },
                        {
                            'key' : 'btn-success',
                            'name' : 'Success'
                        },
                        {
                            'key' : 'btn-warning',
                            'name' : 'Warning'
                        },
                        {
                            'key' : 'btn-danger',
                            'name' : 'Danger'
                        },
                        {
                            'key' : 'btn-inverse',
                            'name' : 'Inverse'
                        },
                        {
                            'key' : 'btn-link',
                            'name' : 'Link'
                        }
                    ]
                },
                size : {
                    'type' : 'select',
                    'name' : 'Size',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        {
                            'key' : 'btn-large',
                            'name' : 'Large'
                        },
                        {
                            'key' : '__EMPTY__',
                            'name' : 'Default'
                        },
                        {
                            'key' : 'btn-small',
                            'name' : 'Small'
                        },
                        {
                            'key' : 'btn-mini',
                            'name' : 'Mini'
                        }
                    ]
                }
            }
        }
    })
};

$.fn.crsa.addDefinition(button);

var crsaBootstrapAddHtmlSections = function(addTo) {
    var s = {
     /*   responsive : {
            fields : {
                'visible-phone' : { name : 'Visible on Phone', type : 'checkbox', action : 'apply_class'},
                'visible-tablet' : { name : 'Visible on Tablet', type : 'checkbox', action : 'apply_class'},
                'visible-desktop' : { name : 'Visible on Desktop', type : 'checkbox', action : 'apply_class'},
                'hidden-phone' : { name : 'Hidden on Phone', type : 'checkbox', action : 'apply_class'},
                'hidden-tablet' : { name : 'Hidden on Tablet', type : 'checkbox', action : 'apply_class'},
                'hidden-desktop' : { name : 'Hidden on Desktop', type : 'checkbox', action : 'apply_class'}
            }
        },*/
        dimension : {
            name : 'Dimension',
            fields : {
                width : { name : 'Width', 'type': 'slider' , min: 0, max: 2000, units: true },
                height : { name : 'Height', 'type': 'slider' , min: 0, max: 2000, units: true },
                'position' : {name : 'Position', type : 'slider'},
                'display' : {name : 'Display', type : 'slider'},
                'border' : {name : 'Border', type : 'slider'},
                'border-radius' : {name : 'Border radius', type : 'slider'}
            }
        },
        text : {
            name : 'Text',
            fields : {
                'color' : {name : 'Color', type : 'color'},
                'fontSize' : {name : 'Size', type : 'slider'},
                'lineHeight' : {name : 'Line height', type : 'slider'},
                'fontWeight' : {name : 'Weight', type : 'slider'},
                'fontStyle' : {name : 'Style', type : 'slider'}
            }
        },
        background : {
            name : 'Background',
            fields : {
                'background-color' : {name : 'Color', type : 'color'},
                'background-image' : {name : 'Image', type : 'image'}
            }
        }
    };
    $.each(s, function(k,v) {
        addTo[k] = v;
    });
    return addTo;
}

//Scaffolding
$.fn.crsa.addDefinition({
    'type' : 'bs-container',
    'selector' : 'div.container, div.container-fluid',
    'code' : '<div class="container"></div>',
    'name' : 'Container',
    'inline_edit' : true,
    'sections' : crsaAddStandardSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'container',  'name' : 'Fixed' },
                        { 'key' : 'container-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});

$.fn.crsa.addDefinition({
    'type' : 'bs-row',
    'selector' : 'div.row, div.row-fluid',
    'code' : '<div class="row"></div>',
    'name' : 'Row',
    'sections' : crsaAddStandardSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'row',  'name' : 'Fixed' },
                        { 'key' : 'row-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});

var span_select = {
        'type' : 'select',
        'name' : 'Span',
        'action' : 'apply_class',
        'show_empty' : false,
        'options' : [
            { 'key' : 'span1',  'name' : '1' },
            { 'key' : 'span2',  'name' : '2' },
            { 'key' : 'span3',  'name' : '3' },
            { 'key' : 'span4',  'name' : '4' },
            { 'key' : 'span5',  'name' : '5' },
            { 'key' : 'span6',  'name' : '6' },
            { 'key' : 'span7',  'name' : '7' },
            { 'key' : 'span8',  'name' : '8' },
            { 'key' : 'span9',  'name' : '9' },
            { 'key' : 'span10',  'name' : '10 (Fluid only)' },
            { 'key' : 'span11',  'name' : '11 (Fluid only)' },
            { 'key' : 'span12',  'name' : '12 (Fluid only)' }
        ]
    };

var offset_select = {
    'type' : 'select',
    'name' : 'Offset',
    'action' : 'apply_class',
    'show_empty' : true,
    'options' : [
        { 'key' : 'offset1',  'name' : '1' },
        { 'key' : 'offset2',  'name' : '2' },
        { 'key' : 'offset3',  'name' : '3' },
        { 'key' : 'offset4',  'name' : '4' },
        { 'key' : 'offset5',  'name' : '5' },
        { 'key' : 'offset6',  'name' : '6' },
        { 'key' : 'offset7',  'name' : '7' },
        { 'key' : 'offset8',  'name' : '8' },
        { 'key' : 'offset9',  'name' : '9' },
        { 'key' : 'offset10',  'name' : '10 (Fluid only)' },
        { 'key' : 'offset11',  'name' : '11 (Fluid only)' },
        { 'key' : 'offset12',  'name' : '12 (Fluid only)' }
    ]
};

$.fn.crsa.addDefinition({
    'type' : 'bs-column',
    'selector' : 'div.span1,div.span2,div.span3,div.span4,div.span5,div.span6,div.span7,div.span8,div.span9,div.span10,div.span11,div.span12',
    'code' : '<div class="span1"></div>',
    'name' : 'Column',
    'inline_edit' : true,
    'sections' : crsaAddStandardSections({
        layout : {
            name : 'Layout',
            fields : {
                span : span_select,
                offset : offset_select
            }
        }
    })
});



$.fn.crsa.addDefinition({
    'type' : 'bs-thumbnails',
    'selector' : 'ul.thumbnails',
    'code' : '<ul class="thumbnails"></ul>',
    'name' : 'Thumbnails',
    'inline_edit' : true,
    'sections' : crsaAddStandardSections({
    })
});

$.fn.crsa.addDefinition({
    'type' : 'bs-thumbnail',
    'selector' : 'li',
    'parent_selector' : 'ul.thumbnails',
    'code' : '<li><h3>Item title</h3><p>Item description.</p></li>',
    'name' : 'Thumbnail',
    'inline_edit' : true,
    'sections' : crsaAddStandardSections({
        layout : {
            name : 'Layout',
            fields : {
                span : span_select,
                offset : offset_select
            }
        }
    })
});

//tags
var div = {
    'type' : 'div',
    'selector' : 'div',
    'code' : '<div>DIV</div>',
    'name' : 'Div',
    'inline_edit' : true,
    'sections' : crsaAddStandardSections({})
}
$.fn.crsa.addDefinition(div);



var headings = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
$.each(headings, function(i,h) {
    var hdef = {
        'type' : h,
        'selector' : h,
        'code' : '<' + h + '>Heading</' + h + '>',
        'name' : h,
        'sections' : crsaAddStandardSections({})
    }
    $.fn.crsa.addDefinition(hdef);
});

var tag = {
    'type' : 'p',
    'selector' : 'p',
    'code' : '<p>Paragraph</p>',
    'name' : 'p',
    'sections' : crsaAddStandardSections({})
}
$.fn.crsa.addDefinition(tag);

tag = {
    'type' : 'div',
    'selector' : 'div',
    'code' : '<div>Div</div>',
    'name' : 'div',
    'sections' : crsaAddStandardSections({})
}
$.fn.crsa.addDefinition(tag);

tag = {
    'type' : 'img',
    'selector' : 'img',
    'code' : '<img src=""/>',
    'name' : 'Image',
    'sections' : crsaAddStandardSections({})
}
$.fn.crsa.addDefinition(tag);

tag = {
    'type' : 'tag',
    'selector' : '*',
    'ignore_tags' : ['br','b','strong','em','span'],
    'code' : '<p>TAG</p>',
    'name' : 'HTML tag',
    'display_name' : 'tag',
    'sections' : crsaAddStandardSections({})
}
$.fn.crsa.addDefinition(tag);




//variables
$.fn.crsa.addVariablesSection('custom', 'Custom variables');
$.fn.crsa.addVariable('@test', '@test', 'text', '100px', 'custom');
//$.fn.crsa.addVariable('@a', '@a', 'text', '100px', 'custom');

//rules
var rule = {
    'type' : 'rule',
    'selector' : 'img',
    'code' : '<img src=""/>',
    'name' : 'Image',
    'sections' : crsaBootstrapAddHtmlSections({
        name : {
            name : 'Class name',
            fields : {
                class_name : {
                    type : 'text',
                    name : 'Class name',
                    action : 'rule_name',
                    live_update : false
                },
                media_rule : {
                    type : 'text',
                    name : 'Media rule',
                    action : 'rule_media',
                    live_update : true
                }
            }
        }
    })
}
$.fn.crsa.addRulesDefinition(rule);

$.fn.crsa.addLibSection('bs', 'Bootstrap');
$.fn.crsa.addElementsToLibSection('bs', ['bs-button','bs-container','bs-row','bs-column','bs-thumbnails','bs-thumbnail']);

$.fn.crsa.addLibSection('html', 'Html');
$.fn.crsa.addElementsToLibSection('html', ['div','img','p','h1','h2','h3']);

$.fn.crsa.addRulesSection('buttons', 'Buttons');
$.fn.crsa.addRule('buttons','.btn','Default', {'color' : '$button_text_color'});
$.fn.crsa.addRule('buttons','.btn-primary','Primary');
$.fn.crsa.addRule('buttons','.btn-info','Info');
$.fn.crsa.addRule('buttons','.btn-success','Success');
$.fn.crsa.addRule('buttons','.btn-warning','Warning');
$.fn.crsa.addRule('buttons','.btn-danger','Danger');
$.fn.crsa.addRule('buttons','.btn-inverse','Inverse');
$.fn.crsa.addRule('buttons','.btn-link','Link');




