//body/root
var body = {
    'type' : 'body',
    'selector' : 'body',
    'name' : 'Body'
}
$.fn.crsa.addDefinition(body);


var crsaBootstrapAddHtmlSections = function(addTo) {
    var s = {
        dimension : {
            name : 'Dimension',
            fields : {
                width : { name : 'Width', 'type': 'slider' , min: 0, max: 2000, units: true },
                height : { name : 'Height', 'type': 'slider' , min: 0, max: 2000, units: true },
                'position' : {name : 'Position', type : 'slider'},
                'display' : {name : 'Display', type : 'slider'},
                'border' : {name : 'Border', type : 'slider'},
                'borderRadius' : {name : 'Border radius', type : 'slider'}
            }
        },
        text : {
            name : 'Text',
            fields : {
                'color' : {name : 'Color', type : 'color'},
                'fontSize' : {name : 'Size', type : 'slider'},
                'lineHeight' : {name : 'Line height', type : 'slider'},
                'fontWeight' : {name : 'Weight', type : 'slider'},
                'fontStyle' : {name : 'Style', type : 'slider'}
            }
        },
        background : {
            name : 'Background',
            fields : {
                'backgroundColor' : {name : 'Color', type : 'color'},
                'backgroundImage' : {name : 'Image', type : 'image'}
            }
        }
    };
    $.each(s, function(k,v) {
        addTo[k] = v;
    });
    return addTo;
}

//Scaffolding
$.fn.crsa.addDefinition({
    'type' : 'project',
    'selector' : 'div.project',
    'code' : '<div class="project"><h1>Project name</h1><p>Project description</p><h2>Content types</h2><div></div></div>',
    'name' : 'Project',
    'inner_container' : '> div',
    'inline_edit' : true,
    'sections' : crsaBootstrapAddHtmlSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'container',  'name' : 'Fixed' },
                        { 'key' : 'container-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});

$.fn.crsa.addDefinition({
    'type' : 'type',
    'selector' : 'div.type',
    'code' : '<div class="type"><h3>Type name</h3><p>Type description</p><div></div></div>',
    'name' : 'Type',
    'inner_container' : '> div',
    'inline_edit' : true,
    'sections' : crsaBootstrapAddHtmlSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'container',  'name' : 'Fixed' },
                        { 'key' : 'container-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});

$.fn.crsa.addDefinition({
    'type' : 'type_fields',
    'selector' : 'div.type_fields',
    'code' : '<div class="type_fields"><h4>Fields</h4><div></div></div>',
    'name' : 'Type fields',
    'inner_container' : '> div',
    'inline_edit' : true,
    'sections' : crsaBootstrapAddHtmlSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'container',  'name' : 'Fixed' },
                        { 'key' : 'container-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});

$.fn.crsa.addDefinition({
    'type' : 'field',
    'selector' : 'div.field',
    'code' : '<div class="field"><h5>Field name</h5><p>Field description</p></div>',
    'name' : 'Field',
    'inner_container' : null,
    'inline_edit' : true,
    'sections' : crsaBootstrapAddHtmlSections({
        layout : {
            name : 'Layout',
            fields : {
                span : {
                    'type' : 'select',
                    'name' : 'Fixed / Fluid',
                    'action' : 'apply_class',
                    'show_empty' : false,
                    'options' : [
                        { 'key' : 'container',  'name' : 'Fixed' },
                        { 'key' : 'container-fluid',  'name' : 'Fluid' }
                    ]
                }
            }
        }
    })
});


var div = {
    'type' : 'div',
    'selector' : 'div',
    'code' : '<div>DIV</div>',
    'name' : 'Div',
    'inline_edit' : true,
    'sections' : crsaBootstrapAddHtmlSections({})
}
$.fn.crsa.addDefinition(div);


//variables
$.fn.crsa.addVariablesSection('buttons', 'Buttons');
$.fn.crsa.addVariable('button_text_color', 'Button label color', 'color', null);

//rules
$.fn.crsa.addRulesSection('buttons', 'Buttons');
$.fn.crsa.addRule('buttons','.btn','Default', {'color' : '$button_text_color'});
$.fn.crsa.addRule('buttons','.btn-primary','Primary');
$.fn.crsa.addRule('buttons','.btn-info','Info');
$.fn.crsa.addRule('buttons','.btn-success','Success');
$.fn.crsa.addRule('buttons','.btn-warning','Warning');
$.fn.crsa.addRule('buttons','.btn-danger','Danger');
$.fn.crsa.addRule('buttons','.btn-inverse','Inverse');
$.fn.crsa.addRule('buttons','.btn-link','Link');




