/**
 * Created by Matjaz on 22/12/16.
 */



function editElementSource($el) {
    //todo30 remove
    pinegrow.stats.using('edit.elementcode');

    if($el.is('script') || $el.find('script').length > 0) {
        //showAlert("<p>Editing code blocks <strong>with scripts</strong> is not supported.</p><p>Use page code view instead (Page -&gt; Edit code).</p>", "Can't edit code here");
        //return;
    }


    if($el.is('body') || $el.is('head') || $el.find('body').length) {
        showAlert("<p>Use page code view to edit the code of the whole page including <b>body</b> and <b>head</b> (<b>Page -&gt; Edit code</b> or <b>CMD + E</b>).</p><p>Or edit the code of <b>individual elements within body or head</b>.</p>", "Can't edit code here");
        return;
    }

    var pgEl = getElementPgNode($el);

    var problems = new pgParserSourceProblem(pgEl, $el);

    if(!pgEl) {
        problems.add('element', getElementName($el), 'find');
    }
    if(!problems.ok()) {
        showAlert(problems.toString(), "Can't edit this element");
        return;
    }
    if(!canMakeChange(pgEl, 'edit_code')) return;

    var crsaPage = pinegrow.getCrsaPageOfPgParserNode(pgEl);

    var dynmirror = null;
    var change_happened = false;

    var $parent = $el.parent();

    willMakeChange(selectedCrsaPage, "Edit element code / " + getElementName($el));

    var editorData = showCodeEditor("application/x-httpd-php", /* "text/html",*/ "Edit element code", 'edit-element-html',
        function() {
            //onchange
            if(applySource(mirror.getDoc().getValue())) {
                ignore_select_element = true;
                methods.setNeedsUpdateDelayed($parent);
                didMakeChange(selectedCrsaPage); //ops edit source
            }
            return has_error;
        },
        function() {
            //on ok
            removeEventHandlers();
            if(has_error) {
                applySource(original_source, true);
                ignore_select_element = true;
                methods.setNeedsUpdate(true, $parent);
                didMakeChange(selectedCrsaPage); //ops edit source
            }
            methods.setNeedsUpdate(true, $parent);

        }, function() {
            //on cancel
            removeEventHandlers();
            if(change_happened) {
                applySource(original_source, true);
                ignore_select_element = true;
                methods.setNeedsUpdate(true, $parent);
                didMakeChange(selectedCrsaPage); //ops edit source
            }
            //getCrsaPageForIframe(selectedCrsaPage).undoStack.remove();

        });

    var mirror = editorData.mirror;
    var $dialog = editorData.dialog;
    var $chk = $dialog.find('.modal-footer label');

    mirror.on('contextmenu', function(instance, event) {
        codeEditor.selectClickedElement(mirror, event, crsaPage);
        return false;
    });

    editorData.editor_el.on('copy', function() {
        var selectedText = mirror.getDoc().getSelection();

        if(selectedText && selectedText.length) {

            setTimeout(function() {
                var gui = require('nw.gui');
                var clipboard = gui.Clipboard.get();
                selectedText = pgRemovePgIdsFromCode(selectedText);
                //console.log(selectedText);
                clipboard.set(selectedText, 'text');
            }, 50);
        }
    });

    var element = $el.get(0);

    var ignore_change = false;
    var ignore_select_element = false;

    var applySource = function(s, force) {
        if(ignore_change) return false;
        s = $.trim(s);

        change_happened = true;
        //debugger;
        try {
            var pgNewEl = pgCreateNodeFromHtml(s);
            pgCurrentRequestContext.setCurrentRequestContext(selectedCrsaPage.url, selectedCrsaPage.sourceNode);
            var html = pgNewEl.toStringWithIds(true, pinegrow.getFormatHtmlOptions(), function(linkNode, str, type) {
                if(type == 'node' && linkNode.tagName == 'script' && linkNode.getAttr('type') != 'php') {
                    return '<script data-pg-id="' + linkNode.getId() + '"></script>';
                }
                return pgCurrentRequestContext.createProxyUrlNodeOutputFilter(linkNode, str, type);
            });

            if(pgNewEl.validateTree().length && !force) {
                throw 'Syntax error - pgParser';
            }

            //console.log(html);
            var $newEl = $(getIframeDocument(selectedPage.get(0)).createElement('div')).append(html).contents();
            //console.log($newEl);

            if($newEl.length != 1 && !force) {
                throw "Syntax error - DOM";
            }

            if(!pg_use_ops) $el.replaceWith($newEl);

            if(selectedElement && selectedElement.type == 'element'
                && (selectedElement.data.get(0) == $el.get(0)
                || jQuery.contains($el.get(0), selectedElement.data.get(0)))
            ) {
                selectedElement = getObjectFromElement($newEl);
            }
            $el = $newEl;

            pgEl.withoutEvents(function() {
                pgEl.replaceWith(pgNewEl);
                pgEl.remove();
            });
            pgNewEl.update();

            pgEl = pgNewEl;
            setDialogNotice($dialog, '');
            $chk.show();

            last_good_source = s;
            has_error = false;
            return true;
        }
        catch(err) {
            has_error = true;
            $chk.hide();
            setDialogNotice($dialog, 'Syntax error - or - You\'re editing more than one HTML element!', 'text-danger');
        }
        return false;
    }

    var code_ignore_change_timeout = null;

    var original_source;// = element.outerHTML;

    original_source = pgEl.toStringWithIds(true, pinegrow.getFormatHtmlOptions());

    var last_good_source = original_source;
    var has_error = false;

    /*
     pinegrow.httpServer.setCurrentRequestContext(selectedCrsaPage.url, selectedCrsaPage.sourceNode);
     var original_source = pgEl.toStringWithIds(true, pinegrow.getFormatHtmlOptions(), function(linkNode, str, type) {
     if(type == 'node' && linkNode.tagName == 'script') {
     return '<script data-pg-id="' + linkNode.getId() + '"></script>';
     }
     return pinegrow.httpServer.createProxyUrlNodeOutputFilter(linkNode, str, type);
     });
     */



    //source = pinegrow.formatHtml(source);
    var id_to_markers = {};

    var setCode = function(source) {
        var source = removeCrsaClassesFromHtml(source);

        ignore_change = true;

        if(code_ignore_change_timeout) {
            clearTimeout(code_ignore_change_timeout);
            code_ignore_change_timeout = null;
        }

        mirror.operation(function() {
            var si = mirror.getScrollInfo();
            mirror.getDoc().setValue(source);
            id_to_markers = codeEditor.findAndHideIds(mirror, id_to_markers);

            codeEditor.findAndHideCollapsed(mirror);

            mirror.getDoc().clearHistory();
            mirror.scrollTo(si.left, si.top);

            code_ignore_change_timeout = setTimeout(function() {
                ignore_change = false;
                code_ignore_change_timeout = null;
            }, 100);
        });
    }

    setCode(original_source);

    var $modal_body = $dialog.find('.modal-body>div');

    var onPageChanged = function(event, changeObj) {
        if(changeObj.element) {
            var chpgel = getElementPgNode(changeObj.element);
            if(chpgel) {
                if(chpgel == pgEl || chpgel.isDescendantOf(pgEl)) {
                    original_source = pgEl.toStringWithIds(true, pinegrow.getFormatHtmlOptions());
                    setCode(original_source);
                    if(selectedElement) {
                        //onElementSelected(null, selectedElement);
                    }

                }
            }
        }
    }

    $body.on('crsa-page-changed', onPageChanged);

    var onElementSelected = function(e, element) {
        if(element && element.user_action) {
            setTimeout(function() {
                if(!ignore_select_element && element && element.type == 'element') {
                    var $el = element.data;
                    codeEditor.selectElementInCodeMirror($el, mirror, id_to_markers);
                }
                ignore_select_element = false;
            }, 100); //delay so that we're called after crsa-page-changed event
        }
    }

    $body.on('crsa-element-selected', onElementSelected);

    var removeEventHandlers = function() {
        $body.off('crsa-page-changed', onPageChanged);
        $body.off('crsa-element-selected', onElementSelected);
    }

    return;

    var p = pgFindDynamicDiffs(pgEl, $el);
    if(p) {
        editorData.editor_el.css('height', '60%');

        var html = pgDescribeDynamicDiffs(p);

        html = $.trim(html);

        $modal_body.css('height', '300px');
        $modal_body.append('<div class="dynamic-info">This element contains <a href="#">dynamic content</a>:<pre>' + html + '</pre></div>');
        $modal_body.find('a').tooltip({container: 'body', placement: 'top', title: 'Dynamic elements are not present in source files. They are usually added or changed by Javascript code after the page is loaded. Edit the Javascript code if you want to change them.', trigger: 'hover'});
    }
}