(function( $ ){

    var tree = null;
    var tree_e = null;
    var tree_dest_el = null;
    var main_el = null;
    var new_el_count = 0;
    
    var ur_hidden = false;
    var user_reg_timer = null;
    
    var index = {};
    
    var current_selected = [];
    var active_element = null;
    var active_elements = null;
    
    var moused = {};
    var moused_i = 0;
    
    var last_menu = null;
    
    var opened = true;
    
    var wait_c = 0;
    
    var settings = {
      'create_url'         : '/cob/callSmarty/MsbElement/externalCreateObject/',
      'move_url'         : '/cob/callSmarty/MsbElement/externalMoveObject/',
      'disconnect_url'         : '/cob/callSmarty/MsbElement/externalDisconnectObject/',
      'save_url'         : '/cob/callSmarty/MsbElement/externalSaveChanges/',
      'delete_url'         : '/cob/callSmarty/MsbElement/externalDeleteObject/',
      'create_value_url'         : '/cob/callSmarty/MsbElement/externalCreateValue/',
      'create_rule_url'         : '/cob/callSmarty/MsbElement/externalCreateRule/',
      'edit_position_url'         : '/cob/callSmarty/MsbElement/externalEditPosition/',
      'create_in_position_url'    : '/cob/create/',
      'object_browser_url' : '/cob/callSmarty/MsbElement/externalObjectBrowser/',
      'get_object_url' : '/cob/callSmarty/MsbElement/externalGetObject/',
      'reg_user_url' : '/cob/callSmarty/MsbElement/externalRegisterUser/',
      'login_user_url' : '/cob/callSmarty/MsbElement/externalLoginUser/',
      'url_base' : '',
      'inline' : false
    };      
        
    var methods = {
       init : function( options ) {
           return this.each(function(i,e){
               if ( options ) { 
                    $.extend( settings, options );
               }
               e = $(e);
               main_el = e;
               main_el.bind('createObject.crsa', onCreateObject);
               main_el.bind('editObject.crsa', methods.actionEdit);
               main_el.bind('createObjectInPosition.crsa', onCreateObjectPosition);
               main_el.bind('objectBrowser.crsa', showObjectBrowser);
               main_el.bind('objectCreated.crsa', onObjectCreated);
               main_el.bind('save.crsa', onSaveChanges);
               main_el.bind('createValue.crsa', onCreateValue);
               main_el.bind('createRule.crsa', onCreateRule);
               main_el.bind('editPosition.crsa', onEditPosition);
               
               if(!settings.inline) {
                   $('#crsa-palette-toggle').click(function() {
                       if(opened) {
                           $('#crsa-palette').addClass('crsa-palette-closed');
                       } else {
                           $('#crsa-palette').removeClass('crsa-palette-closed');
                       }
                       opened = !opened;
                   });
                   
                   $('#crsa-palette').addClass('crsa-palette-closed');
                   opened = false;
                   
                   $('#crsa-site-prop > a').click(function(e) {
                        main_el.trigger('edit.crsa', ['msb', null, null, $(e.currentTarget)]);
                        return false;
                   });
                   $('#crsa-site-delete > a').click(function(e) {
                       methods.actionDelete({data: $('#msb')});
                       return false;
                   });
                          
                   $('#crsa-help').click(function() {
                        academy();
                        return false;
                   });
                     
                   if(settings.temp_user && !ur_hidden) {
                    //   user_reg_timer = setTimeout(function() { methods.userRegistration(); }, 20000);
                        
                   }
                   if(settings.temp_user) {
                       setTimeout(function() { academy(); }, 1000);
                   }
                   
                   $('#crsa-screen-size select').change(function(e) {
                       var val = $(e.currentTarget).val();
                       
                       main_el.removeClass('ipad-landscape').removeClass('ipad-portrait').removeClass('desktop').removeClass('desktop-wide').removeClass('desktop-test').addClass(val);
                       $(window).resize();
                       methods.generateChapterTools();
                   });

                   methods.setMsbSize(); 
                    main_el.find('> div').each(function(i,e) {
                        main_el.crsalive('scaleFonts', $(e));
                    });
                                           
                   $(window).resize(function() {
                       methods.setMsbSize();  

                        main_el.find('> div').each(function(i,e) {
                            main_el.crsalive('scaleFonts', $(e));
                        });
                   }); 
               }         
           });

     },
     isInit : function() {
         return main_el != null;
     },
     getSiteName : function() {
         var d = main_el.data('crsa');
         return d != null ? d.data['DvSite_name'] : 'Unknown Name';
     },
     setMsbSize: function() {
        if(main_el.hasClass('horizontal')) {
            var w = 0;
            main_el.find('> div').each(function(i,e) {
                w = w + $(e).innerWidth();
            });
            if(w == 0) w = 1024;
            main_el.css('width',w + 'px');
        }
     },
     destroy : function( ) {

       return this.each(function(){
         $(window).unbind('.tooltip');
       })

     },
     getNewId : function() {
         return getNewId();
     },
     clearIndex : function() {
         index = {};
     },
     idToEids : function(id) {
         return id in index ? index[id] : [];
     },
     addToIndex : function(crsa) {
         var id = "id_" + crsa.id;
         if(!(id in index)) index[id] = [];
         if($.inArray(crsa.eid, index[id]) < 0) index[id].push(crsa.eid);
     },
     update : function() {
        this.each(function(i,e){
            methods.clearIndex();
            var tree = {eid: 'msb', e: $('#msb'), children: [], name: 'Pllop', type: 'DvSite.site'};
            var dict = {msb: tree};
            methods.updateItem($('#msb'));
            
            var elist = $(e).find('*:not(#cms *)');
            elist.each(function(ii, el) {
                var el = $(el);
                var data = el.data('crsa');
                if(data == null) {
                    return true;
                }
                methods.addToIndex(data);
                var o = {eid: data.eid, e: el, children: [], name: data.name, type: data.type};
                dict[data.eid] = o;
                
                var parent = el.parents('.crsa');
                var pobj = null;
                if(parent.length == 0) {
                    //root
                    pobj = tree;
                } else {
                    var pdata = parent.data('crsa');
                    if(pdata == null) {
                        $.error( 'Element ' + parent[0].Id + ' has class .crsa bit no data');
                        return true;
                    }
                    pobj = dict[pdata.eid];
                }
                pobj.children.push(o);
                
          //      console.log('Adding ' + o.eid + ' to ' + pobj.eid);
                //other actions on crsa elements
//                el.click(methods.actionDelete);
              //  el.click(methods.actionEdit);
                methods.updateItem(el);
                
            });
            
            //tree is done
            $(e).data('crsa.tree', tree).data('crsa.dict', dict);

        });    
     },
     insertObjectIntoSelected: function($o, pos, $ref, type) {
         if(typeof pos == 'undefined') pos = 'last';
         var parent = active_element;
         if(typeof $ref != 'undefined') {
             if(pos == 'after' || pos == 'before') {
                 parent = $ref.parent();
             } else {
                 parent = $ref;
             }
         }
        if(parent == null) {
            alert('First select destination element in the tree!');
            return;
        }
        var cdata = $o.data('crsafactory');
        var ctype = $o.data('crsaFactoryType');
        var dtype = parent.data('crsa').type;
        
        if(dtype in settings.tree_types) {
            var r = settings.tree_types[dtype];
        } else {
            var r = settings.tree_types['default'];
        }
        if(r.valid_children == 'none' || (r.valid_children != 'all' && r.valid_children.indexOf(ctype) < 0)) {
            alert(getTypeName(ctype) + ' can not be inserted into an element of type ' + getTypeName(dtype) + '. Chapter can only be inserted into the Page. Content can be inserted into a chapter.');
            return;
        }
        if(cdata != null && ("id" in cdata)) {
            var event = jQuery.Event("createObject.crsa");
            event.crsaId = cdata.id;
            event.crsaData = cdata;
            event.crsaParent = parent;
            event.crsaRefObject = $ref ? $ref : event.crsaParent;
            event.crsaPosition = pos;
            event.crsaType = type;
            main_el.trigger(event);
        }
     },
     updateItem: function(el) {
         el.addClass('crsa');
         var d = el.data('crsa');
         var isMsbElement = d.type.indexOf('MsbElement') == 0;
         if(d.type != 'MsbTemplate' && !settings.inline) {
             el.mouseover(methods.onMouseEnterNode).mouseout(methods.onMouseLeaveNode);
//             el.mouseenter(methods.onMouseEnterNode).mouseleave(methods.onMouseLeaveNode);
             if(isMsbElement ) {
                 el.droppable({
                    greedy: false,
                    activeClass: 'crsa-droppable-active',
                    hoverClass: 'crsa-droppable-hover',
                    drop: function( event, ui ) {
                        var $o = ui.draggable;
                        var cdata = $o.data('crsafactory');
                        if(cdata != null && ("id" in cdata)) {
                            var event = jQuery.Event("createObject.crsa");
                            event.crsaId = cdata.id;
                            event.crsaData = cdata;
                            event.crsaParent = $(this);
                            event.crsaPosition = 'last';
                            main_el.trigger(event);
                            return false;
                        }
                        
                    }
                 });
             }
         }
     },
     updateItems: function(e) {
        var elist = $(e).find('*');
        elist.each(function(ii, el) {
            var el = $(el);
            var data = el.data('crsa');
            if(data == null) {
                return true;
            }
            methods.updateItem(el);
        });
     },
     generateChapterTools : function() {
        $('div.crsa-slide-bar').remove(); 
        main_el.find('> div.crsa-slide').each(function(i,e) {
            var $e = $(e);
            var d = $e.data('crsa');
            var $bar = $e.data('crsaBar');
            var $cms = $('#msb_body');
            if($bar != null) {
                $bar.remove();
            }
            var id = getNewId();
            $cms.append('<div id="' + id + '" class="crsa-slide-bar"><a class="crsa-slide-bar-name" href="">' + d.name + '</a><div class="crsa-tooltip">Edit the appearance of this chapter - colors, background image, text size...</div><a href="" class="crsa-slide-bar-delete">Delete</a><div class="crsa-tooltip">Delete this chapter - it will never come back.</div><a href="" class="crsa-slide-bar-add-content">Insert Content</a><div class="crsa-tooltip">Add new content to the content area of this chapter.</div><a href="" class="crsa-slide-bar-move-left">Left</a><div class="crsa-tooltip">Move this chapter to the left.</div><span>Move</span><a href="" class="crsa-slide-bar-move-right">Right</a><div class="crsa-tooltip">Move this chapter to the right.</div><a href="" class="crsa-slide-bar-new">Add Chapter</a><div class="crsa-tooltip">Insert new chapter to the right.</div></div>');
            var $bar = $('#' + id);
            $e.data('crsaBar', $bar);

            var p = $e.offset();
            var w = $e.innerWidth();
            $bar.css('width', w + 'px').css('left',p.left + 'px').css('top', (p.top-30) + 'px');
            
            var newChapter = {id: '2717', label: 'Chapter', type: 'MsbElement.slide', data: {id: '2717'}};
            
            $bar.find('> a.crsa-slide-bar-name').click(function(e) {
                 $(main_el).trigger('edit.crsa', [$e[0].id]);
                 return false;
            });
            $bar.find('> a.crsa-slide-bar-delete').click(function(e) {
                 methods.actionDelete({data: $e});
                 return false;
            });
            
            $bar.find('> a.crsa-slide-bar-new').click(function(e) {
                var $l = $(e.currentTarget);
                $l.data('crsafactory',newChapter.data).data('crsafactoryLabel',newChapter.label).data('crsaFactoryType', newChapter.type);
                main_el.crsa('insertObjectIntoSelected', $l, 'after', $e);
                return false;
            });
            $bar.find('> a.crsa-slide-bar-move-left').click(function(e) {
                methods.moveLeft($e);
                methods.repaintTree();
                return false;
            });
            $bar.find('> a.crsa-slide-bar-move-right').click(function(e) {
                methods.moveRight($e);
                methods.repaintTree();
                return false;
            });
            $bar.find('> a.crsa-slide-bar-add-content').click(function(e) {
                var p = $(e.currentTarget).offset();
                var $m = main_el.crsatoolbox('paintInsertContentMenu', $e, p.left, p.top + 30, $(e.currentTarget));
                $m.toggle();
                return false;
            });
            $bar.find('> a').tooltip({'predelay':500,'relative':true, 'position' : ['bottom', 'left'], 'offset': [0, 120]});

        });
     },
     moveLeft : function($e, inline) {
        var $o = $e;
        var $op = $e.parent();
        var $np = $op;
        var list = $e.parent().find('> div');
        var cp = list.index($e);
        if(cp < 1) return false;
        cp--;
        var $r = $(list.get(cp));
        var pos = 'before';
        methods.moveElement($o, $op, $np, $r, pos, cp, inline);
     },
     moveRight : function($e, inline) {
        var $o = $e;
        var $op = $e.parent();
        var $np = $op;
        var list = $e.parent().find('> div');
        var cp = list.index($e);
        if(cp >= list.length-1) return false;
        cp++;
        var $r = $(list.get(cp));
        var pos = 'after';
        methods.moveElement($o, $op, $np, $r, pos, cp);
     },
     repaintTree: function() {
        main_el.crsa('update');
        main_el.crsa('paintTree','#crsa-tree'); 
        methods.setMsbSize(); 
        if(active_element != null) {
            $(tree_dest_el).jstree("select_node", $('#treeleaf_' + active_element.data('crsa').eid));
        }
        methods.generateChapterTools();
        $('#crsa-site-prop > a').html(methods.getSiteName());
     },
     actionPropEdit: function(event) {
         var $e = !event.data ? $(event.currentTarget) : event.data;
         $(main_el).trigger('edit.crsa', [$e[0].id]);
         return false;
     },
     actionEdit: function(event) {
        var $e = !event.data ? $(event.currentTarget) : event.data;
        var data = $e.data('crsa');
        if(!event.crsaUrl) {
            var editAction = data.actions.edit ? data.actions.edit : null;
            var update = $e[0].id;
            var next = null;
        } else {
            var editAction = event.crsaUrl ? event.crsaUrl : null;
            var update = event.crsaUpdate ? event.crsaUpdate : null;
            var next = event.crsaNext ? event.crsaNext : null;
        }
        
        if(editAction) {
            var ids = methods.createWindow('Edit');
            methods.waitStart();
            $.ajax({
              url: editAction,
              dataType: 'html',
              beforeSend:function(request) { 
                  request.setRequestHeader('X-Update', ids.cid);
              },           
              success: function(html){
                  var $w = $('#' + ids.cid);
                  $w.html(html).bind('saveObject.crsa', onSaveObject).data('crsaUpdateElement', update).data('crsaNext', next);
                  wirePositionMenus($w);
                  methods.updateItems($w);
                  methods.waitDone();
                 // alert(html);
              },
              error: function(a,b,c) {
                  methods.waitDone();
                  alert(a.responseText);
              }          
              
            });                        
        }
        return false;
     },
     actionAdd: function(event) {
        var $e = !event.data ? $(event.currentTarget) : event.data;
        var data = $e.data('crsa');
        var aid = $e.data('crsapositionmenu');
        var $a = $('#' + aid);
        dvCloseAll('.cms_gui_menu');
        var p = $e.offset();
        dvMoveToLayer(aid, 'cms');
        //$a.appendTo($('#cms'));
        $a.css('top', (p.top) + 'px').css('left', p.left + 'px').show();
        return false;
     },
     actionDelete: function(event) {
        var $e = !event.data ? $(event.currentTarget) : event.data;
        var data = $e.data('crsa');
        var wid = getNewId();
        
        if(data.type == 'MsbElement.slide') {
            var c = main_el.find('.crsa-slide').length;
            if(c == 1) {
                alert("Sorry, you can not delete this chapter. Every Pllop needs at least one chapter.");
                return false; 
            }
        }
        
        if(confirm("Element will be deleted! Proceed?")) {
            methods.hideItemContextMenu($e);
            methods.waitStart();
            $.ajax({
              url: settings.url_base + settings.delete_url + data.id,
              dataType: 'json',
              beforeSend:function(request) { 
                  request.setRequestHeader('X-Update', wid);
              },           
              success: function(r){
                tree_e.jstree("remove","#" + $e[0].id + "_treeleaf");
                main_el.trigger("objectDeleted.crsa", [{id: data.id, eid: $e[0].id}]);
                $e.remove();
                if(r.affected) {
                    $.each(r.affected, function(i, a) {
                        onObjectChanged(a.id, 'delete', a.position);
                    });
                }
                methods.repaintTree();
                methods.waitDone();
              },
              error: function(a,b,c) {
                  alert(a.responseText);
                  methods.waitDone();
              }          
              
            }); 
        }
        return false;
     },
     actionDisconnect: function(event) {
        var $e = !event.data ? $(event.currentTarget) : event.data;
        var data = $e.data('crsa');
        methods.hideItemContextMenu($e);
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.disconnect_url + data.id + '/' + data.connectedTo + '/' + data.connectedAs,
          dataType: 'html',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(html){
              var eid = $e[0].id;
            tree_e.jstree("remove","#treeleaf_" + $e[0].id);
            methods.removeObject($e);
            //main_el.trigger("objectDisconnected.crsa", [{id: data.id, eid: eid, connectedTo: data.connectedTo, position: data.connectedAs}]);
            onObjectDisconnected(data);
            methods.repaintTree();
            methods.waitDone();
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        }); 
        return false;
     },
     removeObject: function($e) {
         var $m = $e.data('crsamenu');
         if($m != null) $m.remove();
         $e.remove();
     },
     onNodeNameClicked : function(event) {
         var treen = $(event.target).parent()[0];
         var eid = treen.id.replace('treeleaf_','');
         active_element = $('#' + eid);
         active_elements = null; //trigger refresh
         if(active_element.data('crsa') != null) {         
            $(main_el).trigger('edit.crsa', [eid, null, 'tree', $(treen)]);
            console.log("edit.crsa triggered");
           // $.scrollTo(active_element, {duration:300});
         }
     },
     getActiveElements : function() {
         if(active_elements == null) {
             var l = $(tree_dest_el).find('a.jstree-clicked');
             active_elements = [];
             l.each(function(i,e) {
                 var eid = $(e).parent()[0].id.replace('treeleaf_','');
                 active_elements.push($('#' + eid));
                 console.log('ae ' + eid);
             });
         }
         return active_elements;
     },
     onMouseEnterNode: function(event) {
         //var eid = $(event.target).parent()[0].id.replace('treeleaf_','');
         var eid = $(event.currentTarget)[0].id.replace('treeleaf_','');
         var $e = $('#' + eid);
         if(current_selected != null ) {
             $('#' + current_selected).removeClass('crsa-selected');
             methods.hideItemContextMenu($('#' + current_selected));
         }
         current_selected = eid;
         $e.addClass('crsa-selected');
         event.stopImmediatePropagation();
         methods.showItemContextMenu($e);
         moused_i++;
         moused[eid] = moused_i;
    //     methods.showMoused();
     },
     onMouseLeaveNode: function(event) {
//         var eid = $(event.target).parent()[0].id.replace('treeleaf_','');
         var eid = $(event.currentTarget)[0].id.replace('treeleaf_','');
         var $e = $('#' + eid);
         if(methods.isMouseOverMenu($e, event)) return false;
         $e.removeClass('crsa-selected');
         current_selected = null;
         event.stopImmediatePropagation();
         methods.hideItemContextMenu($e);
       if(eid in moused) delete moused[eid];
    //   methods.showMoused();
     },
     showMoused : function() {
         var s = "";
         var max = "";
         var max_v = 0;
         $.each(moused, function(eid, eidv) {
             if(moused[eid] > max_v) { max_v = moused[eid]; max = eid; }
             s = s + ", " + eid;
         });
         console.log("Moused: " + s + " - Active is " + max);
     },
     hasAction : function(t, a) {
         if(!(t in settings.actions)) return true;
         return settings.actions[t].indexOf(a) >= 0;
     },
     showItemContextMenu: function($e) {
         if($e.parent()[0].id == 'msb' || $e[0].id == 'msb') return null;
         var $m = $e.data('crsamenu');
         if($m != null) return $m;
         if(last_menu != null && last_menu != $e) methods.hideItemContextMenu(last_menu);
         
         last_menu = $e;
         
         var id = getNewId();
         var b = '<div class="crsa-context-menu" id="' + id + '">';
         var id_edit = id + '_edit';
         var id_del = id + '_del';
         var id_dc = id + '_dc';
         var id_pos = id + '_pos';
         
         var posmenu = $e.data('crsapositionmenu');
         if(posmenu) {
             b += '<a href="#" id="' + id_pos + '" class="crsa-action-link crsa-action-add">&nbsp;</a>';
             //b += '<div class="crsa-tooltip">Add new content to this position</div>';
         }
         var d = $e.data('crsa');
         if(d == null) return [];
         
         var isMsbElement = d.type.indexOf('MsbElement') == 0;

         if(methods.hasAction(d.type, 'e')) {
             if(!isMsbElement) {
                b += '<a href="#" id="' + id_edit + '" class="crsa-action-link crsa-action-edit">&nbsp;</a>';
                b += '<div class="crsa-tooltip">Edit the content of this element.</div>';
             } else {
                b += '<a href="#" id="' + id_edit + '" class="crsa-action-link crsa-action-prop-edit">&nbsp;</a>';
                b += '<div class="crsa-tooltip">Edit the appearance of this element - colors, background image, text size...</a>';
             }
         }
         if(methods.hasAction(d.type, 'r')) {
            b += '<a href="#" id="' + id_dc + '" class="crsa-action-link crsa-action-disconnect">&nbsp;</a>';
            b += '<div class="crsa-tooltip">Remove this element from here, but keep it in the library.</div>';
         }
         if(methods.hasAction(d.type, 'd')) {
            b += '<a href="#" id="' + id_del + '" class="crsa-action-link crsa-action-delete">&nbsp;</a>';
            b += '<div class="crsa-tooltip crsa-tooltip-danger">Delete this element (will also be deleted from the library and from any other Pllop).</div>';
         }
         
         b += '</div>';
         $('#cms').append(b);
         var $m = $('#' + id);
         if(!isMsbElement) {
            $('#' + id_edit).bind('click', $e, methods.actionEdit);
         } else {
            $('#' + id_edit).bind('click', $e, methods.actionPropEdit);
         }
         $('#' + id_del).bind('click', $e, methods.actionDelete);
         $('#' + id_dc).bind('click', $e, methods.actionDisconnect);
         $('#' + id_pos).bind('click', $e, methods.actionAdd);
         
         $m.find('.crsa-action-link').tooltip({'predelay':500, 'relative':true});
         
         $e.data('crsamenu', $m);
         var o = $e.offset();
         if(o != null)
            $m.css('left',o.left + 'px').css('top',(o.top - 0) + 'px');
         return $m;
     },
     hideItemContextMenu: function($e) {
         var $m = $e.data('crsamenu');
         if($m != null) {
             $m.remove();
             $e.data('crsamenu', null);
         } else {
             $('.crsa-context-menu').remove();
         }
     },
     isMouseOverMenu: function($e, event) {
         var $m = $e.data('crsamenu');
         if($m == null) return false;
         var o = $m.offset();
         var w = $m.width();
         var h = $m.height();
         //console.log(w + ' ' + h);
         if((event.pageX >= o.left && event.pageX <= o.left + w) && (event.pageY >= o.top && event.pageY <= o.top + h)) {
             //console.log('is over');
             return true;
         }
         return false;
     },
     moveNode : function($o, $r, p) {
        var getJsCont = $r.data('crsaGetContentContainer');
        var $cc = getJsCont != null ? getJsCont($r) : $r; 
        switch(p) {
            case 'inside':
            case 'last':
                //move o into r
                if(typeof $o == 'object') {
                    $o.appendTo($cc);
                } else {
                    $cc.append($o);
                }
                break;
            case 'first':
                //move o into r
                if(typeof $o == 'object') {
                    $o.prependTo($cc);
                } else {
                    $cc.prepend($o);
                }
                break;
            case 'after':
                //move o after r
                if(typeof $o == 'object') {
                    $o.insertAfter($r);
                } else {
                    $r.after($o);
                }
                break;
            case 'before':
                if(typeof $o == 'object') {
                    $o.insertBefore($r);
                } else {
                    $r.before($o);
                }
                break;
            default:
                break;
        }
        tree_e.crsa('update');
     },
     wireLeafMenusInTree: function(menus) {
        $.each(menus, function(mid, obj) {
            $('#' + mid + ' .crsa-open-actions' ).click(function(event) {
                var mid = $(event.target).closest('.crsa-leaf-actions')[0].id;
                $('.crsa-leaf-actions > div:not(#' + mid + '_d)').hide();
                $(event.target).next().toggle().mouseleave(function(event) {
                    $(event.currentTarget).hide();
                });
            }); 
        });
     },
     paintTree : function(destel) {
         this.each(function(i,e) {
            var tree = $(e).data('crsa.tree');
            tree_e = $(e);
            tree_dest_el = destel;
            
            var menus = {};
            
            $(destel).html(getTreeHtml(e, menus)); 
            $(destel).find(".crsa-tree-node-name").bind('click', methods.onNodeNameClicked);
            
            $(destel).find("li").bind('mouseover', methods.onMouseEnterNode).bind('mouseout', methods.onMouseLeaveNode);
            
            /*.droppable({
                drop: function( event, ui ) {
                    alert('dropped');
                }
            });*/
//            $(destel).find(".crsa-tree-node-name").bind('mouseenter', methods.onMouseEnterNode).bind('mouseleave', methods.onMouseLeaveNode);
            
            $('.crsa-leaf-actions a').click(actionClicked);
            $('.crsa-tree-checkbox').click(function(e) {
                var $t = $(e.currentTarget);
                var $e = $('#' + $t.closest('li')[0].id.replace('treeleaf_',''));
                if($t.hasClass('crsa-tree-cb-hidden')) {
                    $t.removeClass('crsa-tree-cb-hidden');
                    $e.show();
                } else {
                    $t.addClass('crsa-tree-cb-hidden');
                    $e.hide();
                }
            });
            methods.wireLeafMenusInTree(menus);
                        
            $(destel).jstree({
                   "crrm" : {
                        "move" : {
                            "check_move" : function (m) {
                                return true;
                            },
                        }
                    },
                    "dnd" : {
                        "drop_finish" : function () {
                            alert("DROP");
                        },
                        "drag_finish" : function (data) { 
                            var o = data.o;
                            var r = data.r;
                            //var oid = o.id.replace('treeleaf_','');
                            var rid = r[0].id.replace('treeleaf_','');
                            var $o = $(o);
                            if(!$o.hasClass('crsa-factory-object')) $o = $o.closest('.crsa-factory-object');
                            var $r = $('#' + rid);                            
                            var cdata = $o.data('crsafactory');
                            if(cdata != null && ("id" in cdata)) {
                                var event = jQuery.Event("createObject.crsa");
                                event.crsaId = cdata.id;
                                event.crsaData = cdata;
                                event.crsaParent = $r;
                                event.crsaPosition = 'last';//data.p;
                                main_el.trigger(event);
                                if("crsaObject" in event) $o = event.crsaObject;
                            }
                            /*
                            methods.moveNode($o, $r, data.p);
                            var lid = 'treeleaf_' + $o[0].id;
                            $(destel).jstree("create", $(r), data.p, {data: $o[0].id, attr: {id: lid}}, null, true);//,  { "data" : "child2" 
                            $('#' + lid + ' a').bind('click', methods.onNodeNameClicked);
                            */
                        }                        
                    },            
                    "themes" : {
                        "theme" : "default",
                        'url' : '/js/jstree/themes/default/style.css',
                        "dots" : false,
                        "icons" : false
                    },                    
                    "types" : {
                        "types" : settings.tree_types
                    },
                    "plugins" : ["html_data","ui","crrm","dnd","types"],
                    "core" : { "initially_open" : [], "animation":0 }
                }).bind('move_node.jstree', function(event, data) {
                    var o = data.args[0].o;
                    var r = data.args[0].r;
                    var op = data.args[0].op;
                    var oid = o[0].id.replace('treeleaf_','');
                    var rid = r[0].id.replace('treeleaf_','');
                    var orid = op[0].id.replace('treeleaf_','');
                    var npid = data.args[0].np[0].id.replace('treeleaf_','');
                    var $o = $('#' + oid);
                    var $r = $('#' + rid);
                    var $op = $('#' + orid);
                    var $np = $('#' + npid);
                    var cp = data.args[0].cp;
                    
                    methods.moveElement($o, $op, $np, $r, data.args[0].p, cp);
                    /*
                    methods.moveNode($o, $r, data.args[0].p);
                    $.ajax({
                      url: settings.url_base + settings.move_url + $o.data('crsa').id + '/' + $op.data('crsa').id + '/' + $np.data('crsa').id + '/' + cp,
                      dataType: 'json',
                      beforeSend:function(request) { 
                          request.setRequestHeader('X-Update', 'dummy');
                      },           
                      success: function(r){
                      },
                      error: function(a,b,c) {
                          alert(a.responseText);
                      }          
                      
                    });*/
                            
                }).bind("loaded.jstree", function (event, data) { $(destel).jstree("open_all", -1); });
                
         }); 
     },
     moveElement : function($o, $op, $np, $r, pos, cp, inline) {
            if(typeof inline == 'undefined' || inline == null) inline = false;
            inline = inline ? '1' : '0';
            methods.moveNode($o, $r, pos);
            methods.waitStart();
            $.ajax({
              url: settings.url_base + settings.move_url + $o.data('crsa').id + '/' + $op.data('crsa').id + '/' + $np.data('crsa').id + '/' + cp + '/inline:' + inline,
              dataType: 'json',
              beforeSend:function(request) { 
                  request.setRequestHeader('X-Update', 'dummy');
              },           
              success: function(r){
                  methods.waitDone();
              },
              error: function(a,b,c) {
                  methods.waitDone();
                  alert(a.responseText);
              }          
              
            });
     },
     createWindow : function(title, content, cls) {
         var id = getNewId();
         var r = {wid: id, cid: id + '_content'};
         var b = '<div id="' + id + '" class="crsa-window crsa-shadow"><div class="crsa-window-title crsa-label">' + title + '</div><a class="crsa-window-close">&nbsp;</a><div id="' + r.cid + '" class="crsa-window-content"></div></div>';
         $('#cms').append(b);
         if(typeof content != 'undefined') {
            $('#' + r.cid).html(content);
         }
         var $w  = $('#' + id);
         $('#' + id + ' > .crsa-window-close').click(function(event) { $(event.target).closest('.crsa-window').remove(); });
         $w.draggable({handle: ".crsa-window-title"});
         if(typeof cls != 'undefined') $w.addClass(cls);
         var dy = $(window).scrollTop() + Math.floor(Math.random()*200)+100;
         var dx = $(window).scrollLeft() + Math.floor(Math.random()*200)+100;
         $w.css('top',dy + 'px').css('left',dx + 'px');
         return r;
     },
     onServerSideValueChanged : function(eid) {
        var $e = $('#' + eid);
        var d = $e.data('crsa');
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.get_object_url + d.id,
          dataType: 'json',
          type: 'post',
          data: {changes: JSON.stringify(d.data)},
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(ret){
              var r = cleanReturned(ret.html, eid);
              $e.html(r);        
              methods.updateItems($e);   
              methods.waitDone();   
          },
          error: function(jqXHR, textStatus, errorThrown) {
              console.log(textStatus);
              methods.waitDone();
          }
        });    
    },
     userRegistration : function() {
         if(user_reg_timer != null) clearTimeout(user_reg_timer);
         
         var b = '<div id="crsa-ur"><h1>Hey, you are not logged in!</h1><p class="crsa-ur-warn">You need to <a href="#" class="crsa-login">login</a> or <a href="#" class="crsa-register">register</a> to keep your work.</p>';
         
         b += '<div id="crsa-login-div"><h2>Welcome back!</h2><form method="post" action="/"><div class="crsa-ur-email"><p class="error" style="display:none;"></p><label>E-mail:</label><input type="text" name="email" class="cms_input" /></div><div class="crsa-ur-password"><p class="error" style="display:none;"></p><label>Password:</label><input type="password" name="password" class="cms_input" /></div><input type="submit" value="Login!" /></form></div>';
         
         b += '<div id="crsa-register-div"><h2>Be a part of the Pllop family!</h2><form method="post" action="/"><div class="crsa-ur-email"><p class="error" style="display:none;"></p><label>E-mail:</label><input type="text" name="email" class="cms_input" /></div><div class="crsa-ur-password"><p class="error" style="display:none;"></p><label>Password:</label><input type="password" name="password" class="cms_input" /></div><div class="crsa-ur-username"><p class="error" style="display:none;"></p><label>Nickname and url:</label>pllop.com/<span></span><input type="text" name="username" class="cms_input" /></div><div class="checkbox" style="display:none;"><input type="checkbox" class="cms_checkbox" name="news" /><label>Subscribe to Pllop News</label><small>Sent once or twice per month. Contains tutorials, tips, news and show cases.</small></div><input type="submit" value="Create my Pllop Space!" /></form></div>';
         
         b += '<a class="crsa-ur-close" href="#">I just want to play around. Ask me again later.</a><div class="crsa-ur-be-here" style="display:none;">I will be right here waiting for you...</div></div>';
         
         var $c = $('#crsa-ur');
         if($c.length == 0) {
             $('#cms').append(b);
             var $c = $('#crsa-ur');
         }
         
         $c.find('.crsa-ur-username input').bind('input', function(e) {
             $c.find('.crsa-ur-username span').html($(e.target).val());
         });
         
         $c.overlay({
                mask: {
                    color: '#03abf1',
                    loadSpeed: 200,
                    opacity: 0.65,
                    maskId: 'crsa-mask'
                },
                closeOnClick: false,
                closeOnEsc: false,
                left: 'center',
                top: '10%'
         });
         var api = $c.data("overlay");
         api.load();
         
             
         //$c.animate({'top': '0px'}, 1000);
         
         $c.find('.crsa-ur-close').click(function() {
/*            var d = 0 - $c.innerHeight() + 45;
            $c.animate({'top': d + 'px'}, 1000);
            ur_hidden = true;
            $c.find('.crsa-ur-be-here').show();
            */
            var api = $c.data("overlay");
            api.close();
         });
         
         $c.mouseenter(function() {
            if(ur_hidden) {
                $c.animate({'top': '0px'}, 1000);
                ur_hidden = false;
                $c.find('.crsa-ur-be-here').hide();
            }
         });
         
         $c.find('.crsa-login').click(function() {
            $('#crsa-register-div').hide();
            $('#crsa-login-div').show();
         });
         $c.find('.crsa-register').click(function() {
            $('#crsa-register-div').show();
            $('#crsa-login-div').hide();
         });
         
         $c.find('#crsa-register-div form').submit(function() {
             var $cc = $('#crsa-register-div');
             var email = $cc.find('.crsa-ur-email input').val();
             var pass = $cc.find('.crsa-ur-password input').val();
             var username = $cc.find('.crsa-ur-username input').val();
             var news = $cc.find('.cms_checkbox:checked').val() !== undefined ? "1" : "0";
             
             var d = {email: email, password: pass, username: username, news: news};
             methods.waitStart();
            $.ajax({
                  url: settings.url_base + settings.reg_user_url,
                  dataType: 'json',
                  type: 'post',
                  data: {user: JSON.stringify(d)},
                  beforeSend:function(request) { 
                      request.setRequestHeader('X-Update', 'dummy');
                  },           
                  success: function(ret){
                      $cc.find('.crsa-ur-email .error').html('').hide();
                      $cc.find('.crsa-ur-password .error').html('').hide();
                      $cc.find('.crsa-ur-username .error').html('').hide();
                      $cc.find('.crsa-ur-email').removeClass('has_error');
                      $cc.find('.crsa-ur-password').removeClass('has_error');
                      $cc.find('.crsa-ur-username').removeClass('has_error');
                      if(ret.ok) {
                        console.log('ok');
                        var api = $c.data("overlay");
                        api.close();
                        settings.temp_user = false;
                      } else {
                          if(ret.email_msg) {
                              $cc.find('.crsa-ur-email .error').html(ret.email_msg).show();
                              $cc.find('.crsa-ur-email').addClass('has_error');
                          }
                          if(ret.password_msg) {
                              $cc.find('.crsa-ur-password .error').html(ret.password_msg).show();
                              $cc.find('.crsa-ur-password').addClass('has_error');
                          }
                          if(ret.username_msg) {
                              $cc.find('.crsa-ur-username .error').html(ret.username_msg).show();
                              $cc.find('.crsa-ur-username').addClass('has_error');
                          }
                          console.log('error');
                      }
                      methods.waitDone();
                  },
                    error: function(a,b,c) {
                        methods.waitDone();
                        alert(a.responseText);
                    }          

            });             
             return false;
         });
         
         $c.find('#crsa-login-div form').submit(function() {
             var $cc = $('#crsa-login-div');
             var email = $cc.find('.crsa-ur-email input').val();
             var pass = $cc.find('.crsa-ur-password input').val();
             
             var d = {email: email, password: pass};
             methods.waitStart();
            $.ajax({
                  url: settings.url_base + settings.login_user_url,
                  dataType: 'json',
                  type: 'post',
                  data: {user: JSON.stringify(d)},
                  beforeSend:function(request) { 
                      request.setRequestHeader('X-Update', 'dummy');
                  },           
                  success: function(ret){
                      $cc.find('.crsa-ur-email .error').html('').hide();
                      $cc.find('.crsa-ur-password .error').html('').hide();
                      $cc.find('.crsa-ur-email').removeClass('has_error');
                      $cc.find('.crsa-ur-password').removeClass('has_error');
                      if(ret.ok) {
                        console.log('ok');
                        var api = $c.data("overlay");
                        api.close();
                        settings.temp_user = false;
                      } else {
                          if(ret.email_msg) {
                              $cc.find('.crsa-ur-email .error').html(ret.email_msg).show();
                              $cc.find('.crsa-ur-email').addClass('has_error');
                          }
                          if(ret.password_msg) {
                              $cc.find('.crsa-ur-password .error').html(ret.password_msg).show();
                              $cc.find('.crsa-ur-password').addClass('has_error');
                          }
                      }
                      methods.waitDone();
                  },
                    error: function(a,b,c) {
                        methods.waitDone();
                        alert(a.responseText);
                    }          

            });             
             return false;
         });
         
         
     },
     onObjectChanged : function(connectTo, reason, position) {
        onObjectChanged(connectTo, reason, position);     
     },
     waitStart : function() {
         wait_c++;
         if(wait_c > 0) {
             $("#crsa-wait").show();
         }
     },
     waitDone : function() {
         wait_c--;
         if(wait_c < 0) wait_c = 0;
         if(wait_c == 0) {
            $("#crsa-wait").hide();
         }
     },
     getObjectData : function(id, func) {
            var d = null;
            var cls = 'crsa-id-' + id;
            var $e = null;
            var $e = $('div.' + cls);
            /*
            if($('#msb').hasClass(cls)) {
                var $e = $('#msb');
            } else {
                $e = $('#msb').find('.' + cls);
            }
            */
            $.ajax({
              url: settings.url_base + settings.get_object_url + id + '/data',
              dataType: 'json',
              type: 'post',
              data: {},
              beforeSend:function(request) { 
                  request.setRequestHeader('X-Update', 'dummy');
              },           
              success: function(r){
                  $e.each(function(i,e) {
                      console.log('updating ' + e.id);
                      var $el = $(e);
                      var d = $el.data('crsa');
                      if(d) {
                          d.data = r.msbdata;
                      } else {
                          d = r.data;
                          d.eid = $el[0].id;
                      }
                      $el.data('crsa', d);
                      methods.updateItems($el);
                      main_el.crsaui('repaintElementIfActive', e.id);    
                      
                  });
                  if(typeof func == 'function') func(r); 
              },
              error: function(jqXHR, textStatus, errorThrown) {
                  console.log(textStatus);
                  if(typeof func == 'function') func(null); 
              }
            });    
        }
    }

    var getTreeHtml = function( e, menus ) {
         var b = '';
         var tree = $(e).data('crsa.tree');
         if(tree == null) {
             $.error('Tree data is not set');
             return;
         }
         b += '<ul>' + paintTreeLevel(tree, menus) + '</ul>';
         return b;
     };

    var paintTreeLevel = function(obj, menus) {
        var id = 'treeleaf_' + obj.eid;
        var c = obj.type ? obj.type.replace('.','-') : 'Root';
        var b = '<li id="' + id + '" class="crsa-type-' + c + '" rel="' + obj.type + '">';
        var lm = makeLeafMenu(obj);
        menus[lm.id] = obj;
        //
        b += '<a href="#" class="crsa-tree-node-name" ><span class="crsa-tree-checkbox"></span>' + obj.name + '</a>' + lm.html;
       // b += '<span class="crsa-tree-node"><a href="#" class="crsa-tree-node-name">' + obj.name + '</a>' + lm.html + '</span>';
//        b += '<a href="#" id="' + id + '" class="crsa-tree-node-name">' + obj.eid + '</a>';
        if(obj.children.length > 0) {
            b += '<ul>';
            for(var n = 0; n < obj.children.length; n++) {
                b += paintTreeLevel(obj.children[n], menus);
            }
            b += '</ul>';
        }
        b += '</li>';
        return b;
    };
    
    var actionClicked = function(event) {
        var $e = $(event.currentTarget);
        var eid = $e.closest('li')[0].id.replace('treeleaf_','');
        var action = 'edit';
        if($e.hasClass('crsa-action-prop-edit')) action = 'prop-edit';
        if($e.hasClass('crsa-action-disconnect')) action = 'disconnect';
        if($e.hasClass('crsa-action-delete')) action = 'delete';
        if($e.hasClass('crsa-action-template')) action = 'template';
        var ne = {currentTarget: $('#' + eid)[0]};
        switch(action) {
            case 'prop-edit':
                methods.actionPropEdit(ne);
                break;
            case 'edit':
                methods.actionEdit(ne);
                break;
            case 'delete':
                methods.actionDelete(ne);
                break;
            case 'disconnect':
                methods.actionDisconnect(ne);
                break;
            case 'template':
                dvCreateTemplate($('#' + eid).data('crsa').id);
                break;
            default:
                alert('Unknown action ' + action);
                break;
        }
        return false;
    };
    
    var makeLeafMenu = function(obj) {
        var id = getNewId();
        var b = '<div id="' + id + '" class="crsa-leaf-actions"><a href="#" class="crsa-action-edit">edit</a><span class="crsa-open-actions">&gt;</span><div  id="' + id + '_d" style="display:none;">';
        if(methods.hasAction(obj.type, 'r')) {
            b += '<a href="#" class="crsa-action-disconnect">disconnect</a>';
        }
        if(methods.hasAction(obj.type, 'd')) {
            b += '<a href="#" class="crsa-action-delete">delete</a>';
        }
        if(methods.hasAction(obj.type, 't')) {
            b += '<a href="#" class="crsa-action-template">template</a>';
        }
        b += '</div></div>';
        
        return {html:b, id:id};
    };
    
    var onCreateObject = function(event, data) {
        var parent = 0;
        var order = null;
        if(event.crsaRefObject && event.crsaPosition == 'after') {
            order = event.crsaParent.find('> div').index(event.crsaRefObject[0]) + 1;
        }
        if(event.crsaParent.data('crsa')) parent = event.crsaParent.data('crsa').id;
        var url = settings.url_base + settings.create_url + event.crsaId + '/' + parent;
        if(order != null) url = url + '/' + order;
        methods.waitStart();
        $.ajax({
          url: url,
          dataType: 'json',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
                var nevent = jQuery.Event("objectCreated.crsa");
                nevent.crsaParent = event.crsaParent;
                nevent.crsaRefObject = event.crsaRefObject ? event.crsaRefObject : event.crsaParent;
                nevent.crsaPosition = event.crsaPosition;
                nevent.crsaType = event.crsaType ? event.crsaType : 'Unknown'; 
                nevent.crsaObjectHtml = r.objectHtml;
                nevent.crsaObjectId = r.objectId;
                nevent.crsaObjectName = r.objectName;
                nevent.crsaElementId = r.elementId;
                main_el.trigger(nevent);
                methods.waitDone();
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        });
    };
    var onObjectCreated = function(event) {
        var html = event.crsaObjectHtml;
        var $ref = event.crsaRefObject ? event.crsaRefObject : event.crsaParent;
        var $r = $('#' + $ref[0].id);
        methods.moveNode(html, $r, event.crsaPosition);
        methods.repaintTree();
        
        if(settings.auto_edit.indexOf(event.crsaType) >= 0)
            methods.actionEdit({data: $('#' + event.crsaElementId)});

        return;
        $l = $('#' + lid);
        $e = $('#' + event.crsaElementId);
        var data = $e.data('crsa');

        var $rleaf = $('#treeleaf_' + event.crsaParent[0].id);
        var lid = 'treeleaf_' + event.crsaElementId;
        $(tree_dest_el).jstree("create", $rleaf, event.crsaPosition, {data: event.crsaObjectName, attr: {id: lid, rel: data.type}}, null, true);//,  { "data" : "child2" 
        $('#' + lid + ' > a').bind('click', methods.onNodeNameClicked).addClass('crsa-tree-node-name').prepend('<span class="crsa-tree-checkbox"></span>');
        
        var c = 'crsa-type-' + (data.type ? data.type.replace('.','-') : 'Root');
        $l.addClass(c);
        var obj = {eid: event.crsaElementId, id: data.id, type: data.type};
        var lm = makeLeafMenu(obj);
        $l.append(lm.html);
        var menus = {};
        menus[lm.id] = obj;
        methods.wireLeafMenusInTree(menus);
        
    };

    var showObjectBrowser = function(event, data) {
        var ids = methods.createWindow('Library', null, 'crsa-ob-window');
        var mode = data.position ? 'position' : 'field';
        var url = settings.url_base + settings.object_browser_url;
        if(data.position) {
            url = url + mode + '/' + data.position + '/' + data.positionId;
        } else {
            url = url + mode + '/' + data.type + '/' + data.subtype;
        }
        methods.waitStart();
        $.ajax({
          url: url,
          dataType: 'html',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', ids.cid);
          },           
          success: function(r){
              methods.waitDone();
              var $c = $('#' + ids.cid);
              $c.html(r);
              if(!data.position) {
                  $c.bind('objectBrowserUpdated.crsa', function(event) {
                      $c.find('.crsa-ob-wrap').append('<a href="#" class="crsa-ob-connect">connect</a>');
                      $c.find('.crsa-ob-connect').bind('click', data, onConnectObjectFromObjectBrowser);
                      return false;
                  });
              }
              $c.trigger('objectBrowserUpdated.crsa');
          },
          error: function(a,b,c) {
                methods.waitDone();
              alert(a.responseText);
          }          
          
        });
    };

    var onConnectObjectFromObjectBrowser = function(event) {
        var data = event.data;
        var obj = $(event.target).closest('.crsa-ob-wrap');
        var objid = obj.data('object_id');
        var objname = obj.data('object_name');
        if(data.position) {
        } else {
            $('#' + data.fieldId).val(objid);
            $('#' + data.textId).html(objname);
        }
        return false;
    };
    
    var onCreateObjectPosition = function(event, data) {
        var ids = methods.createWindow('Edit');
        
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.create_in_position_url + data.type + '/subtype=' + data.subtype + '/connect_to=' + data.connectTo + '/position=' + data.position,
          dataType: 'html',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', ids.cid);
          },           
          success: function(r){
              $('#' + ids.cid).html(r).bind('saveObject.crsa', data, onSaveObjectInPosition);
              methods.waitDone();
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        });
    };
    
            
    var onSaveObjectInPosition = function(event) {
        var data = event.data;
        var wid = $(event.currentTarget);
        var $pos = data.positionElement;
        methods.waitStart();
        $.ajax({
          url: event.crsaSaveUrl + 'did=' + data.positionId + '/next=show_object',
          dataType: 'html',
          data: event.crsaData,
          type: 'POST',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
              //alert(r);
              methods.waitDone();
              var p = wid.parent();
              wid.remove();
              if(p.hasClass('crsa-window')) p.remove();
              
//              var ue = wid.data('crsa.updateElement'); 
//              r = cleanReturned(r, ue);
              if(data.insertion == 'bottom') {
                $pos.append(r);
              } else {
                $pos.prepend(r);
              }
              methods.updateItems($pos);
              onObjectChanged(data.connectTo, 'connect', data.position);
              methods.repaintTree();
          },
          error: function(a,b,c) {
              methods.waitDone();
              wid.html(a.responseText);
              wirePositionMenus(wid);
              methods.updateItems(wid);
          }
        });        
    };
            
    var onObjectDisconnected = function(data) {
        var pid = data.connectedTo;
        onObjectChanged(pid, 'disconnect', data.connectedAs);
    };
    
    var onObjectChanged = function(id, reason, ref) {
        var d = null;
        var cls = 'crsa-id-' + id;
        if($('#msb').hasClass(cls)) {
            var $e = $('#msb');
            d = $e.data('crsa');
        } else {
            $('#msb').find('.' + cls).each(function(i,e) {
                var $e = $(e);
                d = $e.data('crsa');
                return;
            });
        }
        if(d == null) return;
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.get_object_url + id,
          dataType: 'json',
          type: 'post',
          data: {changes: JSON.stringify(d.data)},
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
              console.log(id + ' ' + reason + ' ' + ref);
              methods.waitDone();
              $('#msb').find('.crsa-id-' + id).each(function(i,e) {
                  console.log('updating ' + e.id);
                  var $e = $(e);
                  var d = $e.data('crsa');
                  var rh = cleanReturned(r.html, e.id);
                  $e.html(rh); 
                  methods.updateItems($e);
                  main_el.crsaui('repaintElementIfActive', e.id);     
              });
             /*                       
              if(ref == 'msb_bck') {
                  var bck = r.msbdata['Meta_background-images'];
                  $('#msb').find('.crsa-id-' + id).each(function(i,e) {
                      var $e = $(e);
                      var d = $e.data('crsa');
                      d.data['Meta_background-images'] = bck;
                      var old = d.data['Meta_background-images'] ? d.data['Meta_background-images'] : [];
                      $e.data('crsa', d);
                      var eventData = {'e': $e, 'fieldid': 'Meta_background-images', 'value': bck, 'oldvalue': old};
                      main_el.trigger('changed.crsa', eventData); 
                      main_el.crsaui('repaintElementIfActive', e.id);     
                      
                      var r = cleanReturned(r.html, $e[0].id);
                      $e.html(r); 
                  });
              }*/
          },
          error: function(jqXHR, textStatus, errorThrown) {
              methods.waitDone();
              console.log(textStatus);
          }
        });    
    };

    
    var onSaveObject = function(event, data) {
        var wid = $(event.currentTarget);
        var ue = $('#' + wid.data('crsaUpdateElement'));
        var showMode = ue.data('crsa') ? ue.data('crsa').showMode : '';
        methods.waitStart();
        $.ajax({
          url: event.crsaSaveUrl + 'mode=' + showMode + '/',
          dataType: 'html',
          data: event.crsaData,
          type: 'POST',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
              //alert(r);
              methods.waitDone();
              var next = wid.data('crsaNext');
              if(next != null) {
                  switch(next) {
                      case 'reload':
                        document.location.reload(true);
                        break;
                  }
              }
              var ue = wid.data('crsaUpdateElement'); 
              var p = wid.parent();
              wid.remove();
              if(p.hasClass('crsa-window')) p.remove();
              r = cleanReturned(r, ue);
              $('#' + ue).html(r);
              methods.repaintTree();
          },
          error: function(a,b,c) {
              //alert(a.responseText);
              methods.waitDone();
              wid.html(a.responseText);
              wirePositionMenus(wid);
              methods.updateItems(wid);
          }
        });        
    };

    var cleanReturned = function(r, ue) {
          var patt=new RegExp('<[^\>]*id=\"' + ue + '\"','i');
          if(r.match(patt)) {
              var rscript = /<script[^>]*>([\s\S]*?)<\/script>/ig;
              var m = r.match(rscript);
              if(m != null) r = r.replace(rscript, '');
              
              var nid = ue + '__clean';
              r = r.replace('id="' + ue + '"', 'id="' + nid + '"');
              var c = $('#crsa-cleaner');
              c.html(r);
              r = c.find('#' + nid).html();
              c.html('');
              
              if(m != null) {
                  $.each(m, function(i,v) {
                      r = r + v;
                  });
              }
              //r = r + rscript;
          }
          return r;
    };

    var onEditPosition = function(event, data) {
        var ids = methods.createWindow('Edit position');
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.edit_position_url + data.id + '/' + data.position,
          dataType: 'json',
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', ids.cid);
          },           
          success: function(r){
              methods.waitDone();
              $w = $('#' + ids.cid);
              $w.html(r.html);
              methods.updateItems($w);
              wirePositionMenus($w);
              

              /*
              var b = '<a href="#" class="crsa-position-action crsa-action-add"></a>';
              $w.find('> .cms_position_title').append(b);
              $w.find('.crsa-action-add').click(function(e) {
                  $w.find('> .cms_gui_menu').show();
                  return false;
              });*/
           //   $('#' + wid).html(html).bind('saveObject.crsa', onSaveObject).data('crsa.updateElement', $e[0].id);
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        });
    };
    
    var wirePositionMenus = function($w) {
          var b = '<a href="#" class="crsa-position-action crsa-action-add"></a>';
          $w.find('.cms_position_title').append(b);
          $w.find('.crsa-action-add').click(function(e) {
              $(e.currentTarget).parent().prev('.cms_gui_menu').show();
              return false;
          });
    }

            
    var onSaveChanges = function(event, data) {
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.save_url,
          dataType: 'json',
          type: "POST",
          data: {changes: JSON.stringify(data)},
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
            methods.waitDone();
            main_el.trigger('changesSaved.crsa', data);
            methods.repaintTree();
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
        });
        if(settings.temp_user && !ur_hidden) methods.userRegistration();
    };
    
    var onCreateValue = function(event, data) {
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.create_value_url,
          dataType: 'json',
          type: "POST",
          data: {value: JSON.stringify(data)},
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
              methods.waitDone();
            main_el.trigger('valueCreated.crsa', r);
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        });
        
    };

    var onCreateRule = function(event, data) {
        methods.waitStart();
        $.ajax({
          url: settings.url_base + settings.create_rule_url,
          dataType: 'json',
          type: "POST",
          data: {value: JSON.stringify(data)},
          beforeSend:function(request) { 
              request.setRequestHeader('X-Update', 'dummy');
          },           
          success: function(r){
              methods.waitDone();
            main_el.trigger('ruleCreated.crsa', r);
          },
          error: function(a,b,c) {
              methods.waitDone();
              alert(a.responseText);
          }          
          
        });
        
    };

    var academy = function() {
        var list = {
            'cal-intro' : {title: 'Create your first Pllop', desc: 'The basics of Pllop. The most important tutorial to watch.', len: '4 minutes', movie: '<iframe src="http://player.vimeo.com/video/31026002?title=0&amp;byline=0&amp;portrait=0" width="601" height="353" frameborder="0" webkitAllowFullScreen allowFullScreen></iframe>'},
        /*    
            'cal-box' : {title: 'Control Boxes', desc: 'The essence of Pllop. You will learn now to control sizes of boxes.', len: '3 minute', movie: '<iframe src="http://player.vimeo.com/video/30343664?title=0&amp;byline=0&amp;portrait=0" width="640" height="512" frameborder="0" webkitAllowFullScreen allowFullScreen></iframe>'}*/
        };
        var b = '<div id="crsa-academy"><h1>Pllop Academy</h1><p class="ca-intro">Learn how to make Pllops by watching tutorial videos.</p><div id="ca-projector"></div><ol>';
        
        var c = 1;
        $.each(list, function(id, def) {
            b += '<li id="' + id + '"><h2>' + def.title + '</h2><p>' + def.desc + '</p><span>Length: ' + def.len + '</span></li>';
        });
        b += '</ol><a class="ca-close" href="#">Go back to practice</a></div>';
        
        $('#cms').append(b);
        var $a = $('#crsa-academy');
        
         $a.overlay({
                mask: {
                    color: '#03abf1',
                    loadSpeed: 200,
                    opacity: 0.75,
                    
                    //color: '#FFFFFF',
//                    color: '#03abf1',
                    loadSpeed: 200,
                    //opacity: 0.93,
                    maskId: 'crsa-mask'
                },
                closeOnClick: false,
                left: 'center',
                top: '8%',
                fixed: false,
                onLoad: function() {
                    //$a.css('position','absolute');
                    //$a.css("left",  ($(window).scrollLeft()  + ($(window).width() + "px");
                },
                onClose: function() {
                    $a.remove();    
                }
         });
         var api = $a.data("overlay");
         api.load();
       /*  $a.css('position','absolute');
         $a.css("left", ( $(window).width() - $a.width() ) / 2+$(window).scrollLeft() + "px");
         $a.css("top", ( $(window).scrollTop() + 40) + "px");*/

        $a.find('a.ca-close').click(function() {
            api.close();
        });
        
        $a.find('ol > li').click(function(e) {
            var lid = e.currentTarget.id;
            $a.find('li').removeClass('selected');
            $(e.currentTarget).addClass('selected');
            $('#ca-projector').html(list[lid].movie);
        });
        $a.find('li').removeClass('selected');
        $('#cal-intro').addClass('selected');
        $('#ca-projector').html(list['cal-intro'].movie);
        
    };
    
    
    
    var getNewId = function() {
        new_el_count++;
        return "ne_" + new_el_count;    
    };
    
    var createNewElement = function(tag, id, parent, aclass) {
        var ne = $(document.createElement(tag));
        ne[0].id = id;        
        if(typeof parent != 'undefined') ne.appendTo(parent);
        if(typeof aclass != 'undefined') ne.addClass(aclass);
    };
    
    var getTypeName = function(t) {
        return t in settings.names ? settings.names[t] : t;
    };

         
    $.fn.crsa = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );