(function( $ ){

    var settings = {
      'dialogs'         : {},
      'element'         : 'crsa-toolbox-menu',
      'elementValues'         : 'crsa-toolbox-values',
      'elementRules'  : 'crsa-toolbox-rules'
    };  
    
    var main_el = null;
    
    var values = {};
    var just_values = {};
    var values_used_in = {};
    
    var rules = {};
    
    var changed = {};
    var changed_rules = {};
        
    var methods = {
       init : function( options ) {
           return this.each(function(i,e){
                if ( options ) { 
                    $.extend( settings, options );
                }
                e = $(e);
                main_el = e;
                main_el.bind('changesSaved.crsa', methods.changesSaved);
                main_el.bind('valueCreated.crsa', methods.onValueCreated);
                main_el.bind('ruleCreated.crsa', methods.onRuleCreated);
                
                $.each(settings.values, function(i, v) {
                     //var v = settings.values[iv];
                     values[v.name.toLowerCase()] = v;
                });
                $.each(values, function(i, vn) {
                    just_values[i] = methods.evaluateValue(vn.value);
                });
                $.each(settings.rules, function(iv, v) {
                     rules[v.name.toLowerCase()] = v;
                });
                
                $('#crsa-palette-tree').click(function() { 
                    $('#crsa-palette-tree').addClass('selected');
                    $('#crsa-palette-values').removeClass('selected'); 
                    $('#crsa-palette-rules').removeClass('selected'); 
                    $('#crsa-tree').show();
                    $('#crsa-toolbox-values').hide();
                    $('#crsa-toolbox-rules').hide();
                });
                $('#crsa-palette-values').click(function() { 
                    $('#crsa-palette-tree').removeClass('selected');
                    $('#crsa-palette-values').addClass('selected'); 
                    $('#crsa-palette-rules').removeClass('selected'); 
                    $('#crsa-tree').hide();
                    $('#crsa-toolbox-values').show();
                    $('#crsa-toolbox-rules').hide();
                });
                $('#crsa-palette-rules').click(function() { 
                    $('#crsa-palette-tree').removeClass('selected');
                    $('#crsa-palette-values').removeClass('selected'); 
                    $('#crsa-palette-rules').addClass('selected'); 
                    $('#crsa-tree').hide();
                    $('#crsa-toolbox-values').hide();
                    $('#crsa-toolbox-rules').show();
                });
                
           });

     },
     paint : function(event) {
         var datas = {};
         var b = '<ul>';
         $.each(settings.elements, function(sid, s) {
             var c = s.type ? s.type.replace('.','-') : 'Root';
             b += '<li class="crsa-menu-section crsa-type-' + c + '"><a href="#">' + s.label + '</a><ul>';
             $.each(s.elements, function(i,e) {
                 var id = 'tb_' + e.id;
                 var c = e.type ? e.type.replace('.','-') : 'Root';
                 b += '<li id="' + id + '" class="crsa-type-' + c + ' aaajstree-draggable crsa-factory-object"><a href="#" class="crsa-tree-node-name">' + e.label + '</a></li>';
                 datas[id] = e;
             });
             b += '</ul></li>';
         });
         b += '</ul>';
         var uiel = $('#' + settings.element);
         uiel.html(b);
         $.each(datas, function(id, idv) {
             $('#' + id).data('crsafactory',datas[id].data).data('crsafactoryLabel',datas[id].label).data('crsaFactoryType', datas[id].type).click(function(event) {
                 main_el.crsa('insertObjectIntoSelected', $(event.currentTarget));
                 return false;
             });//.draggable({connectToSortable: '.ui-sortable', opacity: 0.7, helper: cloneItem });
         });
         
         //paint values
         datas = {};
         b = '<ul class="crsa-values">';
         $.each(values, function(name, v) {
             var id = 'value_' + v.id;
             b += '<li id="' + id + '">' + v.name + ' = ' + v.value + '</li>';
             datas[id] = v;
         });
         b += '</ul>';
         
         b += '<div class="crsa-values-buttons">';
         b += '<a href="#" class="crsa-input-button-link-small crsa-add-value-numeric" >+ Numeric</a>';
         b += '<a href="#" class="crsa-input-button-link-small crsa-add-value-color" >+ Color</a>';
         b += '<a href="#" class="crsa-input-button-link-small crsa-add-value-expression" >+ Expression</a>';
         b += '</div>';
         
         var vel = $('#' + settings.elementValues);
         vel.html(b);
         $.each(datas, function(id, v) {
             $('#' + id).data('crsa', {id: v.id, eid: id, type: 'MsbValue.' + v.type, name: v.name, data: {name: v.name, value: v.value} }).click(function(event) {
                 var eid = event.target.id;
                 $(main_el).trigger('edit.crsa', [eid]);
                 console.log("edit.crsa triggered on value " + eid);                 
             });
         });
         vel.find('a.crsa-add-value-numeric').bind('click', methods.onAddValueNumeric);
         vel.find('a.crsa-add-value-expression').bind('click', methods.onAddValueExpression);
         vel.find('a.crsa-add-value-color').bind('click', methods.onAddValueColor);
         
         //paint rules
         datas = {};
         b = '<ul class="crsa-values">';
         $.each(rules, function(name, v) {
             var id = 'rule_' + v.id;
             b += '<li id="' + id + '">' + v.name + '</li>';
             datas[id] = v;
         });
         b += '</ul>';
        
         b += '<div class="crsa-values-buttons">'; 
         b += '<a href="#" class="crsa-input-button-link-small crsa-add-rule" >+ Rule</a>';
         b += '</div>';
         
         var vel = $('#' + settings.elementRules);
         vel.html(b);
         $.each(datas, function(id, v) {
             $('#' + id).data('crsa', {id: v.id, eid: id, type: 'MsbDef', name: v.name, data: v.data }).click(function(event) {
                 var eid = event.target.id;
                 $(main_el).trigger('edit.crsa', [eid]);
                 console.log("edit.crsa triggered on rule " + eid);                 
             });
         });
         vel.find('a.crsa-add-rule').bind('click', methods.onAddRule);
         
     },
     paintInsertContentMenu : function($dest, left, top, $link) {
         var $m = $link.data('crsaICMenu');
         if($m != null) {
             $m.css('top', top + 'px').css('left', left + 'px');
             return $m;
         }
         var b = '<ul>';
         var datas = {};
         $.each(settings.elements.content.elements, function(i,e) {
             var id = main_el.crsa('getNewId');
             var c = e.type ? e.type.replace('.','-') : 'Root';
             b += '<li id="' + id + '" class="crsa-type-icon-' + c + ' crsa-factory-object"><a href="#" class="crsa-tree-node-name">' + e.label + '</a></li>';
             datas[id] = e;
         });
         b += '</ul>';

         var id = main_el.crsa('getNewId');
         var $m = createNewElement('div', id, $('#cms'), 'crsa-insert-content-menu');         
         $m.css('top', top + 'px').css('left', left + 'px');
         $m.html(b);
         $m.hide();
         
         $.each(datas, function(id, idv) {
             $('#' + id).data('crsafactory',datas[id].data).data('crsafactoryLabel',datas[id].label).data('crsaFactoryType', datas[id].type).click(function(event) {
                 main_el.crsa('insertObjectIntoSelected', $(event.currentTarget), 'last', $dest, datas[id].type);
                 return false;
             });
         });
         $link.data('crsaICMenu', $m);
         
         $m.mouseleave(function() {
             $m.hide();
         });
         return $m;
     },
     updateValuesUsedIn: function(eid, field, expr) {
         if(expr.indexOf("{") >= 0) {
            var m = expr.match(/\{([^\}]*)\}/ig);
            if(m != null) {
                $.each(m, function(i, exo) {
                    var ex = exo.replace("{","").replace("}","").replace(" ","");
                    ex = ex.toLowerCase();
                    var mm = ex.match(/[a-z][a-z0-9]*/ig);
                    if(mm != null) {
                        $.each(mm, function(ii, name) {
                            if(!(name in values_used_in)) values_used_in[name] = [];
                            var found = false;
                            $.each(values_used_in[name], function(iii,iiiv) {
                                if(values_used_in[name][iii].eid == eid && values_used_in[name][iii].field == field) {
                                    found = true;
                                    return false;
                                }
                            });
                            if(!found) {
                                values_used_in[name].push({eid: eid, field: field});
                                console.log('Value ' + name + ' used in ' + eid + '.' + field);
                            }
                        });
                    }
                });
            }
         }         
     },
     setValue: function(name, value) {
         name = name.toLowerCase();
         values[name].value = value;
         just_values[name] = methods.evaluateValue(value);
         changed[name] = true;
         
         if(name in values_used_in) {
             $.each(values_used_in[name], function(i, iv) {
                 var $el = $('#' + iv.eid);
                 var v = $el.data('crsa').data[iv.field];
                 var e = {'e' : $el, value: v, oldvalue : v, fieldid: iv.field};
                 main_el.crsalive('onChanged', null, e);
             });
         }
     },
     evaluateValue: function(expr, depth) {
         if(typeof depth == 'undefined') depth = 0;
         if(depth > 10) {
             alert('Circular reference on value ' + expr);
             return expr;
         }
        
         if(expr.match(/\{/)) {
            var m = expr.match(/\{([^\}]*)\}/ig);
            if(m != null) {
                console.log('Value is used here: ' + m);
                $.each(m, function(i, exo) {
                    var ex = exo.replace("{","").replace("}","").replace(" ","");
                    ex = ex.toLowerCase();
                    var v = ex;
                    if(ex in values) {
                        v = methods.evaluateValue(values[ex].value, depth + 1);
                    } else {
                        v = Parser.evaluate(ex, just_values);
                        //v = methods.evaluateValue(nv, depth + 1);
                    }
                    expr = expr.replace(exo, v);
                });
            }
         }
         return expr;
     },
     getChangedValues: function() {
         var d = {};
         $.each(changed, function(eid, v) {
             var data = values[eid];
             d[eid] = data;
         });
         return d;
     },
     getChangedRules: function() {
         var d = {};
         $.each(changed_rules, function(eid, data) {
             d[eid] = data;
         });
         return d;
     },
     changesSaved: function(event) {
         changed = {};
         changed_rules = {};
     },
     onAddValueNumeric: function() {
         return methods.onAddValue('numeric');
     },
     onAddValueColor: function() {
         return methods.onAddValue('color');
     },
     onAddValueExpression: function() {
         return methods.onAddValue('expression');
     },
     onAddValue: function(type) {
         var def = {numeric:'200', color:'#AAAAAA', expression: '200' };
         var name = "value1";
         var i = 1;
         while(name in values) { i++; name = "value" + i; }
         var d = {name: name, type: type, value: def[type]};
         main_el.trigger('createValue.crsa', d);
         return false;
     },
     onValueCreated: function(event, data) {
         var value = data.value;
         values[value.name] = value;
         just_values[value.name] = methods.evaluateValue(value.value);
         methods.paint();
     },
     onAddRule: function(type) {
         var def = {name: 'rule'};
         var name = def.name;
         var i = 1;
         while(name in rules) { i++; name = "rule" + i; }
         var d = {name: name};
         main_el.trigger('createRule.crsa', d);
         return false;
     },
     onRuleCreated: function(event, data) {
         var value = data.rule;
         rules[''+value.id] = value;
         methods.paint();
     }
    }     

    var cloneItem = function(e) {
        var $e = createNewElement('div', '', $('#cms'), 'crsa-drag-helper');
        $e.html($(e.currentTarget).data('crsafactoryLabel'));
        return $e[0];
    };
    
    var createNewElement = function(tag, id, parent, aclass) {
        var ne = $(document.createElement(tag));
        ne[0].id = id;        
        if(typeof parent != 'undefined') ne.appendTo(parent);
        if(typeof aclass != 'undefined') ne.addClass(aclass);
        return ne;
    };
    
        
    $.fn.crsatoolbox = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );