var PgInsertBorders = function ($ul) {

    var $prevLi = null;
    const topOffset = 6;
    const bottomOffset = 6;
    var _this = this;
    var mousedown = false;

    var mousePosition = null;

    var $insertLine = $('<div class="pg-tree-quick-insert-line"><i class="icon icon-plus-square"></i></div>');

    this.mousePositionVals = {
        MIDDLE: 0,
        TOP: 1,
        BOTTOM: 2
    }

    this.remove = function () {
        $ul
            .off('mousedown',  'li', liMouseDown)
            .off('mouseup',    'li', liMouseUp)
            .off('mouseenter', 'li', liMouseEnter)
            .off('mousemove',  'li', liMouseMoving)
            .off('mouseleave', 'li', liMouseLeave)
            .off('click',      'li', liClicked);

        _this = null;
    }

    var liMouseDown = function () { mousedown = true; }

    var liMouseUp = function () { mousedown = false; }

    var liMouseEnter = function (e) {
        if (!mousedown) mousePosition = _this.mousePositionVals.MIDDLE;
    }

    var liMouseMoving = function (e) {
        if (!mousedown) {
            var $target = $(e.target)
            var $li = $target.closest('li');
            var $div = $li.find('> div');
            if ($prevLi) $prevLi.removeClass('hoverd-middle hoverd-bottom hoverd-top');

            $insertLine.detach();

            var classToAdd = '';
            var mousePositionY = e.offsetY;
            var lineHeight = parseInt($li.css('height'), 10);
            if (mousePositionY < topOffset) {
                mousePosition = _this.mousePositionVals.TOP;
                classToAdd = 'hoverd-top';
            }
            else if (lineHeight - mousePositionY < bottomOffset) {
                mousePosition = _this.mousePositionVals.BOTTOM;
                classToAdd = 'hoverd-bottom';
            }
            else {
                mousePosition = _this.mousePositionVals.MIDDLE;
                classToAdd = 'hoverd-middle';
            }

            if (_this.isAllowed) {
                if (!_this.isAllowed($li, $target, mousePosition)) return;
            }

            if (mousePosition == _this.mousePositionVals.TOP) {
                $li.prepend($insertLine);
            }
            else if (mousePosition == _this.mousePositionVals.BOTTOM) {
                $li.append($insertLine);
            }

            $li.removeClass('hoverd-top hoverd-middle hoverd-bottom').addClass(classToAdd);
            $prevLi = $li;
        }
    }

    var liMouseLeave = function (e) {
        mousedown = false;
        $prevLi = mousePosition = null;
        var $li = $(e.target).closest('li');
        $li.find('> .pg-tree-quick-insert-line').detach();
        $li.removeClass('hoverd-top hoverd-bottom hoverd-middle');
    }

    var liClicked = function (e) {
        var $target = $(e.target);
        var $li = $target.closest('li');
        if (_this.isAllowed) {
            if (!_this.isAllowed($li, $target)) return;
        }
        e.preventDefault();
        if (mousePosition && mousePosition != _this.mousePositionVals.MIDDLE) {
            var after = true;
            if (mousePosition == _this.mousePositionVals.TOP) {
                after = false;
            }

            if (_this.onLiClicked) _this.onLiClicked($li, after);
        }
        liMouseLeave(e);
        return false;
    }

    $ul
        .off('mousedown', 'li', liMouseDown)
        .on('mousedown', 'li', liMouseDown)

        .off('mouseup', 'li', liMouseUp)
        .on('mouseup', 'li', liMouseUp)

        .off('mouseenter', 'li', liMouseEnter)
        .on('mouseenter', 'li', liMouseEnter)

        .off('mousemove', 'li', liMouseMoving)
        .on('mousemove', 'li', liMouseMoving)

        .off('mouseleave', 'li', liMouseLeave)
        .on('mouseleave', 'li', liMouseLeave)

        .off('click', 'li', liClicked)
        .on('click', 'li', liClicked);

}