var PgStylePaneHelper = function (editablePane, $ul, options) {
    this.pgInsertBorders = null;

    var _this = this;

    var initOptions = function () {
        if (!options) options = {};

        options['add-new-placeholder-text'] = options['add-new-placeholder-text'] || 'Add new...';
    }
    initOptions();


    var $newNodePlaceholder = $('<li class="add-new-node placeholder-node">' + options['add-new-placeholder-text'] + '</li>');
    $newNodePlaceholder.data('shown', true);

    var didMakeChangeFor = function (elm) {
        if (elm) {
            $(elm).removeAttr('contenteditable');
        }
        //didMakeChange(pinegrow.getSelectedPage().$iframe);todo30 ???
    }

    var showNewNodePlaceholder = function ($list) {
        $list = $list || $ul;
        var $placeholder = $list.find('li.add-new-node');
        // var $item = $list.find('> ' + editablePane.itemSelector);
        var $item = $list.find('> li:not(.add-new-node)');

        if ($item.length <= editablePane.itemLengthToAddPlaceholder) {
            if ($placeholder.length == 0) {
                //$newNodePlaceholder.appendTo($list);
            }
            $newNodePlaceholder.appendTo($list);
            $newNodePlaceholder.show();
        }
    }

    this.setUl = function ($list) {
        $ul = $list;
    }

    this.addNewNode = function ($el, helperNode, type, insertAfter) {
        editablePane.addingNewNode($el, helperNode);

        var $li = $el.closest('li');
        $li.data('shown', true);
        $li.data('placeholder-item', true);

        $el.attr('contenteditable', 'true');
        $el.focus();
        crsaSelectText($el[0]);

        var escapeFromEditing = function () {
            $ul.data('properties-in-edit-mode', false);
        }

        var nodeChanging = function (e, elm) {
            if (!$(elm).attr('contenteditable')) return;
            var code = e.keyCode || e.which;
            if (code == '13' || code == 9) {
                e.preventDefault();
                editablePane.addNewNodeUI($(elm), helperNode, type, insertAfter);
                showNewNodePlaceholder();
                return true;
            }
            else if (code == 27) {
                e.preventDefault();
                $el.closest('li').remove();
                showNewNodePlaceholder();
                escapeFromEditing(e);
                return true;
            }
        /*  Let default paste work

            else if (code == 86 && (e.ctrlKey || e.metaKey)) {
                if (editablePane.pasteTriggeredForNewField) {
                    editablePane.pasteTriggeredForNewField($(elm));
                    return true;
                }
            }*/
            return false;
        }


        $el
            .blur(function (e) {
                if ($(this).text().length == 0 || !$(this).closest('li').data('node')) {
                    $(this).closest('li').remove();
                    showNewNodePlaceholder();
                }
                escapeFromEditing(e);
                return false;
            })
            .keydown(function (e) {
                if (nodeChanging(e, this)) return false;
            })
            .keyup(function (e) {
                return false;
            })

    }

    var liForAddItemClicked = function (e) {
        if (e.target.tagName != "I") {
            e.preventDefault();
            if ($(e.target).is('span') || $(e.target).is('input')) return;
            _this.addNewNodeInsideOrBesideCurrentNode($(this));
            return false;
        }
    }

    this.addNewNodeInsideOrBesideCurrentNode = function ($li) {
        var $newLi = $('<li><div><span class="crsa-scss-prop"></span></div></li>');

        var currentNode = null;
        if ($li.length == 0) {
            $ul.append($newLi);
        }
        else {
            var nodesLength = null;
            var $oldLi = $li;

            while ($li.hasClass('crsa-cm-placeholder') || $li.hasClass('placeholder') || $li.hasClass('placeholder-node')) $li = $li.next();
            if ($li.length > 0) {
                currentNode = editablePane.getNodeFrom($li);
                if (!currentNode) return;

                if (currentNode.type != "import" && currentNode.nodes) nodesLength = currentNode.nodes.length;
            }
            else {
                $li = $oldLi;
                if ($li.hasClass('crsa-cm-placeholder') || $li.hasClass('placeholder') || $li.hasClass('placeholder-node')) {
                    nodesLength = 0;
                }
            }

            if (nodesLength == 0) {
                var $nested = $li.find('> ul');
                if ($nested.length == 0) {
                    $nested = $('<ul class="nested"></ul>').appendTo($li);
                }
                $newLi.appendTo($nested);
                currentNode = null;
            }
            else {
                $newLi.insertAfter($li);
            }
        }

        var $span = $newLi.find('span');
        this.addNewNode($span, currentNode);
    }

    var nodePropValueChanged = function (e, elm) {
        if (!$(elm).attr('contenteditable')) return;

        var code = e.keyCode || e.which;
        if (code == '13' || code == 9) {
            e.preventDefault();

            var propName = $(elm).data('prop-name');
            if (propName == 'value') {
                if (editablePane.pgStylesheet.isVarValue($(elm).html())) {
                    if (editablePane.pgStylesheet.fileType == 'css') {
                        pinegrow.showQuickMessage('You can\'t use variables on css file');
                        return false;
                    }
                }
            }

            $(elm).trigger('blur');
            var $li = $(elm).closest('li');
            if ($li.data('add-new-node') || $li.attr('data-removed') == "true") {
                _this.addNewNodeInsideOrBesideCurrentNode($(elm).closest('li'));
                $li.data('add-new-node', false);
            }
            return true;
        }
        if (code == 27) {
            e.preventDefault();
            elm.innerHTML = $(elm).data('old-text');
            didMakeChangeFor(elm);
            return true;
        }
        if (code == 86 && (e.ctrlKey || e.metaKey)) {
            if (editablePane.pasteTriggeredForNewField) {
                editablePane.pasteTriggeredForNewField($(elm));
                return true;
            }
        }
    }

    var endEditNode = function (elm) {
        editablePane.nodeEditDone(elm);
        didMakeChangeFor(elm);
    }

    var startEditNode = function (elm) {
        var $elm = $(elm);
        if(editablePane.pgStylesheet && !editablePane.pgStylesheet.canEdit(false, true)) {
            var simpleAutocomplete = $elm.data('simpleAutocomplete');
            if (simpleAutocomplete) simpleAutocomplete.destroy();
            return false;
        }

        $elm.attr('contenteditable', 'true');
        elm.innerHTML = $elm.text().replace(/▼/g, '');
        $elm.data('old-text', $elm.text());
        crsaSelectText(elm);

        $elm.focus();
        $elm.data('focused', true);

        var $li = $elm.closest('li');
        var node = editablePane.getNodeFrom($li);
        if (node) {
            var value = pgcssh.getValuesFromNode(node);
            $li.data('node-last-value', value);
        }

        return true;
    }

    this.editField = function ($el, $li) {

        $li = $li || $el.closest('li');

        if(editablePane.options && editablePane.options['read-only']) {

            var node = editablePane.getNodeFrom($li);
            editablePane.selectRule(node, $li);

            return;
        }
        if (!$el.data('focus-added') && !$li.data('placeholder-item')) {
            //getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.add("Edit CSS rule", false, editablePane.pgStylesheet);todo30 - CSS undo/redo
            $el.data('focus-added', true);
        }
        if (!$el.data('focused')) {
            $el.data('focused', true);
            $ul.data('properties-in-edit-mode', true);
            if (!startEditNode($el[0])) {
                $el.data('focused', false);
                $ul.data('properties-in-edit-mode', false);
            }
        }
    }

    var editLiNode = function (e) {
        if (_this.isDblClickAllowed) {
            if (!_this.isDblClickAllowed($(this))) return false;
        }

        if (editablePane.dblClickCallback) editablePane.dblClickCallback(e);
        var $target = $(e.target)
        if ($target.is('span') && $target.has('crsa-scss-prop')) {
            var $li = $target.closest('li');
            _this.editField($target, $li);
        }
    }

    var isElmAllowed = function ($el, textChecking) {
        if (_this.isAllowed) {
            if (_this.isAllowed($el, textChecking)) return true;
            else return false;
        }
        return true;
    }

    var focusTrigger = function (e) {
        var $el = $(this).closest('.crsa-scss-prop') || $(this);
        $el = $el.length == 0 ? $(this) : $el;
        var $li = $el.closest('li');
        var node = editablePane.getNodeFrom($li);

        if (!node || !node.nodes) {
            if (!isElmAllowed($(this))) {
                if (_this.getSelectableObj) {
                    $el = _this.getSelectableObj($el);
                    if ($el == null || $el.length == 0) return;
                }
            }

            e.preventDefault();
            if (editablePane.focusCallback) editablePane.focusCallback(e);
            if (!node || (node && !node.nodes)) _this.editField($el);

            // $ul.data('properties-in-edit-mode', true);
            return false;
        }
    }

    var blurTrigger = function (e) {
        if (!isElmAllowed($(this))) return;

        liClicksTime = 0;
        var $li = $(this).closest('li');
        $(this).data('focused', false);
        var node = editablePane.getNodeFrom($li);
        if ($li.data('placeholder-item') || !node) return;

        if ($(this).text() == $(this).data('old-text') && !$li.data('placeholder-item')) {
            //getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.remove();todo30 - css undo
        }
        $(this).data('focus-added', false);
        if (editablePane.blurCallback) editablePane.blurCallback(e);

        if (!$li.data('new-added')) {
            endEditNode(this);
        }

        if (editablePane) {
            if (editablePane.editFinishedCallback) editablePane.editFinishedCallback(e);
        }

        if (!editablePane.selectingNextElm) {
        // TODO enhance this
        // if ($ul.find('span[contenteditable="true"]').length == 0) {
            $ul.data('properties-in-edit-mode', false);
        }

        editablePane.selectingNextElm = false;
        return false;
    }

    var keydownTimeout = null;
    var keydownTrigger = function (e) {
        if (!isElmAllowed($(this))) return;
        var _curr_this = this;

        var callback = function (ePane) {
            if (ePane.keydownCallback) {
                if (ePane.keydownCallback(e)) return false;
            }
            var nodeChanged = nodePropValueChanged(e, _curr_this);
            if (nodeChanged) return false;
        }

        var code = e.keyCode || e.which;
        if (code == 13 || code == 9 || code == 27 || code == 38 || code == 40) {
            clearTimeout(keydownTimeout);
            return callback(editablePane);
        }
        if (keydownTimeout !== null) {
            clearTimeout(keydownTimeout);
        }
        keydownTimeout = setTimeout(function (ePane) {
            callback(ePane);
        }, 250, editablePane);
    }

    var keyupTimeout = null;
    var keyupTrigger = function (e) {
        if (!isElmAllowed($(this))) return;

        if (keyupTimeout !== null) {
            clearTimeout(keyupTimeout);
        }
        keyupTimeout = setTimeout(function () {
            if (editablePane.keyupCallback) {
                if (editablePane.keyupCallback(e)) return false;
            }
        }, 250);
    }

    var pasteTrigger = function (e) {
        var $_curr_this = $(this);
        setTimeout(function () {
            $_curr_this.html($_curr_this.text());
        }, 100);
    }

    var newNodePlaceholderTrigger = function (e) {
        var $li = $(e.target).closest('li');
        $li.hide();
        addNewNodeLiClicked([]);
        showNewNodePlaceholder();
    }

    this.onNodeRemoved = function () {
        showNewNodePlaceholder();
    }

    this.addTriggers = function ($el) {
        $el
            .off('click', 'span', focusTrigger)
            .on('click', 'span', focusTrigger)

            .off('focus', 'span', focusTrigger)
            .on('focus', 'span', focusTrigger)

            .off('blur', 'span', blurTrigger)
            .on('blur', 'span', blurTrigger)

            .off('keydown', 'span', keydownTrigger)
            .on('keydown', 'span', keydownTrigger)

            .off('keyup', 'span', keyupTrigger)
            .on('keyup', 'span', keyupTrigger)

            .off('paste', 'span', pasteTrigger)
            .on('paste', 'span', pasteTrigger)


            .off('click', '.add-new-node', newNodePlaceholderTrigger)
            .on('click', '.add-new-node', newNodePlaceholderTrigger)


            .off('dblclick', 'li', editLiNode)
            .on('dblclick', 'li', editLiNode);
    }

    var addNewNodeLiClicked = function ($li, insertAfter, type) {
        var $newLi = $('<li><div><span></span></div></li>');

        var currentNode = null;
        if ($li.length == 0) {
            $ul.append($newLi);
        }
        else {
            var nodesLength = null;
            var placeholder = false;
            var $oldLi = $li;

            while ($li.hasClass('crsa-cm-placeholder') || $li.hasClass('placeholder') || $li.hasClass('placeholder-node')) $li = $li.next();
            if ($li.length > 0) {
                currentNode = editablePane.getNodeFrom($li);
                if (!currentNode) return;

                if (currentNode.type != "import" && currentNode.nodes) nodesLength = editablePane.getLengthWithoutPlaceholders(currentNode);
            }
            else {
                $li = $oldLi;
                if ($li.hasClass('crsa-cm-placeholder') || $li.hasClass('placeholder') || $li.hasClass('placeholder-node')) {
                    placeholder = true;
                    nodesLength = 0;
                }
            }

            if (insertAfter) {
                if (nodesLength == 0 && !placeholder) {
                    editablePane.uncollapseLi($li);
                    var $nested = $li.find('> ul');
                    if ($nested.length == 0) {
                        $nested = $('<ul class="nested"></ul>').appendTo($li);
                    }
                    $newLi.appendTo($nested);
                }
                else {
                    $newLi.insertAfter($li);
                }
            }
            else {
                $newLi.insertBefore($li);
            }
        }

        var $span = $newLi.find('span');
        _this.addNewNode($span, currentNode, type, insertAfter);
    }

    var removeInsertBorders = function () {
        if (this.pgInsertBorders) {
            this.pgInsertBorders.remove();
            this.pgInsertBorders = null;
        }
    }

    this.remove = function () {
        removeInsertBorders();
        editablePane = null;

        $ul
            .off('click',   'span',          focusTrigger)
            .off('focus',   'span',          focusTrigger)
            .off('blur',    'span',          blurTrigger)
            .off('keydown', 'span',          keydownTrigger)
            .off('keyup',   'span',          keyupTrigger)
            .off('paste',   'span',          pasteTrigger)
            .off('click',   '.add-new-node', newNodePlaceholderTrigger)

            .off('dblclick', 'li',           editLiNode);

        _this = null;
    }

    this.supportInsertBorders = function () {
        removeInsertBorders();

        this.pgInsertBorders = new PgInsertBorders($ul);
        this.pgInsertBorders.onLiClicked = addNewNodeLiClicked;
        this.pgInsertBorders.isAllowed = editablePane.isAllowedToAddNewNodeAt;
    }

    this.onListUpdated = function ($list) {
        showNewNodePlaceholder($list);
    }


    var init = function () {
        $newNodePlaceholder.appendTo($ul);

        if (editablePane.pgStylesheet && editablePane.pgStylesheet.getError()) $newNodePlaceholder.hide();
        //if ($ul.find('li').length > 1) $newNodePlaceholder.hide();
    }
    init();
}
