var PgStylesheetFormatting = function () {
    var options = {};
    var lastIndent = '';
    var STYLE_FORMATING = {};

    var getOptionValue = function(key) {
        if (typeof options[key] == "undefined") {
            return STYLE_FORMATING[key];
        }
        else {
            return options[key];
        }
    }

    var init = function () {
        options = options || {};

        options['indent'] = getOptionValue('indent');

        // Decl
        options['before-decl-after-decl']    = getOptionValue('before-decl-after-decl');
        options['before-decl-after-rule']    = getOptionValue('before-decl-after-rule');
        options['before-decl-after-atrule']  = getOptionValue('before-decl-after-atrule');
        options['before-decl-after-import']  = getOptionValue('before-decl-after-import');
        options['before-decl-after-comment'] = getOptionValue('before-decl-after-comment');
        // Decl nested
        options['before-nested-decl-after-decl']    = getOptionValue('before-nested-decl-after-decl');
        options['before-nested-decl-after-rule']    = getOptionValue('before-nested-decl-after-rule');
        options['before-nested-decl-after-atrule']  = getOptionValue('before-nested-decl-after-atrule');
        options['before-nested-decl-after-import']  = getOptionValue('before-nested-decl-after-import');
        options['before-nested-decl-after-comment'] = getOptionValue('before-nested-decl-after-comment');

        // Rule
        options['before-rule-after-decl']    = getOptionValue('before-rule-after-decl');
        options['before-rule-after-rule']    = getOptionValue('before-rule-after-rule');
        options['before-rule-after-atrule']  = getOptionValue('before-rule-after-atrule');
        options['before-rule-after-import']  = getOptionValue('before-rule-after-import');
        options['before-rule-after-comment'] = getOptionValue('before-rule-after-comment');
        // Rule nested
        options['before-nested-rule-after-decl']    = getOptionValue('before-nested-rule-after-decl');
        options['before-nested-rule-after-rule']    = getOptionValue('before-nested-rule-after-rule');
        options['before-nested-rule-after-atrule']  = getOptionValue('before-nested-rule-after-atrule');
        options['before-nested-rule-after-import']  = getOptionValue('before-nested-rule-after-import');
        options['before-nested-rule-after-comment'] = getOptionValue('before-nested-rule-after-comment');
        // Selector
        options['multiple-rule-selector-sep'] = getOptionValue('multiple-rule-selector-sep');

        // Atrule
        options['before-atrule-after-decl']    = getOptionValue('before-atrule-after-decl');
        options['before-atrule-after-rule']    = getOptionValue('before-atrule-after-rule');
        options['before-atrule-after-atrule']  = getOptionValue('before-atrule-after-atrule');
        options['before-atrule-after-import']  = getOptionValue('before-atrule-after-import');
        options['before-atrule-after-comment'] = getOptionValue('before-atrule-after-comment');
        // Atrule nested
        options['before-nested-atrule-after-decl']    = getOptionValue('before-nested-atrule-after-decl');
        options['before-nested-atrule-after-rule']    = getOptionValue('before-nested-atrule-after-rule');
        options['before-nested-atrule-after-atrule']  = getOptionValue('before-nested-atrule-after-atrule');
        options['before-nested-atrule-after-import']  = getOptionValue('before-nested-atrule-after-import');
        options['before-nested-atrule-after-comment'] = getOptionValue('before-nested-atrule-after-comment');


        // Import
        options['before-import-after-decl']    = getOptionValue('before-import-after-decl');
        options['before-import-after-rule']    = getOptionValue('before-import-after-rule');
        options['before-import-after-atrule']  = getOptionValue('before-import-after-atrule');
        options['before-import-after-import']  = getOptionValue('before-import-after-import');
        options['before-import-after-comment'] = getOptionValue('before-import-after-comment');
        // Import nested
        options['before-nested-import-after-decl']    = getOptionValue('before-nested-import-after-decl');
        options['before-nested-import-after-rule']    = getOptionValue('before-nested-import-after-rule');
        options['before-nested-import-after-atrule']  = getOptionValue('before-nested-import-after-atrule');
        options['before-nested-import-after-import']  = getOptionValue('before-nested-import-after-import');
        options['before-nested-import-after-comment'] = getOptionValue('before-nested-import-after-comment');


        // Comment
        options['before-comment-after-decl']    = getOptionValue('before-comment-after-decl');
        options['before-comment-after-rule']    = getOptionValue('before-comment-after-rule');
        options['before-comment-after-atrule']  = getOptionValue('before-comment-after-atrule');
        options['before-comment-after-import']  = getOptionValue('before-comment-after-import');
        options['before-comment-after-comment'] = getOptionValue('before-comment-after-comment');

        // Comment nested
        options['before-nested-comment-after-decl']    = getOptionValue('before-nested-comment-after-decl');
        options['before-nested-comment-after-rule']    = getOptionValue('before-nested-comment-after-rule');
        options['before-nested-comment-after-atrule']  = getOptionValue('before-nested-comment-after-atrule');
        options['before-nested-comment-after-import']  = getOptionValue('before-nested-comment-after-import');
        options['before-nested-comment-after-comment'] = getOptionValue('before-nested-comment-after-comment');

        // Nested
        options['before-first-nested-decl']    = getOptionValue('before-first-nested-decl');
        options['before-first-nested-rule']    = getOptionValue('before-first-nested-rule');
        options['before-first-nested-atrule']  = getOptionValue('before-first-nested-atrule');
        options['before-first-nested-import']  = getOptionValue('before-first-nested-import');
        options['before-first-nested-comment'] = getOptionValue('before-first-nested-comment');

        options['left-comment']  = getOptionValue('left-comment');
        options['right-comment'] = getOptionValue('right-comment');

        options['left-inline-comment']  = getOptionValue('left-inline-comment');
        options['right-inline-comment'] = getOptionValue('right-inline-comment');

        options['after-decl']    = getOptionValue('after-decl');
        options['after-rule']    = getOptionValue('after-rule');
        options['after-atrule']  = getOptionValue('after-atrule');
        options['after-import']  = getOptionValue('after-import');
        options['after-comment'] = getOptionValue('after-comment');

        options['rule-between'] = getOptionValue('rule-between');
    };

    var isNodeType = function (node, type) {
        if (node.type == 'atrule' && node.variable) {
            return type == 'decl';
        }
        else if (type != 'import'){
            return node.type == type;
        }
        else {
            return node.type == type || (node.type == 'atrule' && node.name == 'import');
        }
    }

    var canDetectAfter = function (node) {
        if (node.type == 'rule'   && !node.nodes) return false;
        if (node.type == 'atrule' && !node.nodes) return false;

        return true;
    }

    var getNodeType = function (node) {
        if (node.type == 'atrule' && node.variable) return 'decl';
        if (node.type == 'atrule' && node.name == 'import') return 'import';

        return node.type;
    }

    var isInlineComment = function (node) {
        if (node && node.type == 'comment' && (node.inline || node.raws.inline)) return true;

        return false;
    }

    var getBeforeValue = function (node, nested, i) {
        var before = '';
        if (i == 0) {
            if (nested) before = options['before-first-nested-' + node.type];
        }
        else {
            var prev = node.prev();

            if (nested) {
                before = options['before-nested-' + getNodeType(node) + '-after-' + getNodeType(prev)];
            }
            else {
                before = options['before-' + getNodeType(node) + '-after-' + getNodeType(prev)];
            }
        }

        return before;
    }

    var getFormattedRuleMultiSelectors = function (selector, sep) {
        var str = "";
        var foundComa = false;
        var brOpen = 0;
        for (var i = 0; i < selector.length; i++) {
            var char = selector[i];
            if (char == '(') brOpen++;
            if (char == ')') brOpen--;

            if (foundComa && char == ' ' || char == '\n') {
                continue;
            }
            else {
                foundComa = false;
            }

            if (brOpen == 0 && char == ',') {
                str += (',' + sep);
                foundComa = true;
            }
            else {
                str += char;
            }
        }

        return str;
    }

    var isAllowedToChange = function (node, checkFormatting, stylesheet) {
        if (!checkFormatting && !node.need_formatting && stylesheet) {
            stylesheet.setNodeNeedFormatting(node, false, false);
            return false;
        }

        return true;
    }

    this.updateNodeRaws = function (mainNode, inline, formattingOptions, checkFormatting, stylesheet) {
        STYLE_FORMATING = PG_DEFAULT_STYLESHEET_FORMATTING.default;
        if (inline) STYLE_FORMATING = PG_DEFAULT_STYLESHEET_FORMATTING.inline;
        options = formattingOptions;
        init();

        var forAll = function (nodes, nested) {
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                if (isAllowedToChange(node, checkFormatting, stylesheet)) {
                    if (isNodeType(node, 'decl')) {
                        node.raws.before = getBeforeValue(node, nested, i) + lastIndent;
                        if (node.type == 'atrule') {
                            node.raws.afterName = ': ';
                            node.raws.between = '';
                        }
                        else {
                            node.raws.between = ': ';
                        }
                    }
                    else if (isNodeType(node, 'rule') && node.selector !== null) {
                        var after = options['after-rule'];
                        if (after.indexOf('\n') > -1) {
                            after += lastIndent;
                        }

                        node.raws.after = after;
                        node.raws.before = getBeforeValue(node, nested, i) + lastIndent;
                        node.raws.between = options['rule-between'];

                        var sep = options['multiple-rule-selector-sep'];
                        if (sep && sep.indexOf('\n') > -1) {
                            sep += lastIndent;
                        }

                        if (node.selector.indexOf(',') > -1) {
                            node.selector = getFormattedRuleMultiSelectors(node.selector, sep);
                        }
                    }
                    else if (isNodeType(node, 'import')) {
                        node.raws.before = getBeforeValue(node, nested, i) + lastIndent;
                        node.raws.afterName = ' ';
                    }
                    else if (isNodeType(node, 'atrule')) {
                        var after = options['after-atrule'];
                        if (after.indexOf('\n') > -1) {
                            after += lastIndent;
                        }

                        node.raws.after = after;
                        node.raws.before = getBeforeValue(node, nested, i) + lastIndent;

                        if (node.params) node.raws.afterName = ' ';
                        else             node.raws.afterName = '';
                    }
                    else if (isNodeType(node, 'comment')) {
                        node.raws.before = getBeforeValue(node, nested, i) + lastIndent;
                        node.raws.after  = '';

                        if (isInlineComment(node)) {
                            node.raws.left  = options['left-inline-comment'];
                            node.raws.right = options['right-inline-comment'];
                        }
                        else {
                            var left = options['left-comment'];
                            var right = options['right-comment'];

                            if (options['left-comment'].indexOf('\n') > -1) left += lastIndent;
                            if (options['left-comment'].indexOf('\n') > -1) right += lastIndent;

                            node.raws.left = left;
                            node.raws.right = right;
                        }
                    }
                }

                lastIndent += options['indent'];

                var children = node.nodes;
                if (children && children.length > 0) {
                    forAll(children, true);
                }

                lastIndent = lastIndent.substr(0, lastIndent.length - options['indent'].length);
            }
        }

        lastIndent = '';
        if (mainNode) {
            var currNode = [mainNode];
            if (mainNode.type == 'root') {
                mainNode.raws = mainNode.raws || {};
                mainNode.raws.semicolon = true;
                currNode = mainNode.nodes;
            }
            forAll(currNode, false);
        }
    }

    this.detectFormatting = function (node, nested, index, frOptions) {
        var beforeKey = null;
        var prev = node.prev();

        if (index == 0) {
            if (nested) beforeKey = 'before-first-nested-' + node.type;
        }
        else {
            if (nested) {
                beforeKey = 'before-nested-' + getNodeType(node) + '-after-' + getNodeType(prev);
            }
            else {
                beforeKey = 'before-' + getNodeType(node) + '-after-' + getNodeType(prev);
            }
        }

        if (beforeKey) {
            if (!frOptions[beforeKey]) {
                var before = '';
                if (isInlineComment(prev)) {
                    if (prev.raws.left.indexOf('\n') > -1) {
                        before += prev.raws.left;
                    }
                    else if (prev.raws.right.indexOf('\n') > -1) {
                        before += prev.raws.right;
                    }
                }
                before += node.raws.before;
                if (nested) {
                    var spaces = before.split('\n');
                    before = spaces[0];

                    for (var i = 0; i < spaces.length - 1; i++) {
                        before += '\n';
                    }

                    if (frOptions['indent'] == undefined) {
                        if (spaces.length > 1) {
                            frOptions['indent'] = spaces[spaces.length - 1] || "";
                        }
                        else {
                            frOptions['indent'] = "";
                        }
                    }
                }

                frOptions[beforeKey] = before;
            }
        }

        if (isNodeType(node, 'comment')) {
            var inlineComment = isInlineComment(node);
            var commentKey = '-comment';
            if (inlineComment) commentKey = '-inline-comment';

            if (frOptions['left' + commentKey] == undefined) {
                var left = node.raws.left;
                if (inlineComment) left = left.replace(/\n/g, '');
                frOptions['left' + commentKey] = left;
            }
            if (frOptions['right' + commentKey] == undefined) {
                var right = node.raws.right;
                if (inlineComment) right = '';
                frOptions['right' + commentKey] = right;
            }
        }

        var afterKey = 'after-' + getNodeType(node);
        if (canDetectAfter(node)) {
            if (frOptions[afterKey] == undefined) {
                var afterVal = '';
                var lastNode = node.last;
                if (isInlineComment(lastNode)) {
                    if (lastNode.raws.left.indexOf('\n') > -1) {
                        afterVal += lastNode.raws.left;
                    }
                    else if (lastNode.raws.right.indexOf('\n') > -1) {
                        afterVal += lastNode.raws.right;
                    }
                }
                if (node.raws.after) {
                    var after = node.raws.after;
                    if (node.raws.after.indexOf('\n') > -1) {
                        after = after.replace(/ /g, '');
                    }
                    afterVal += after;
                }
                frOptions[afterKey] = afterVal;
            }
        }

        // multiple rule selector
        if (frOptions['multiple-rule-selector-sep'] == undefined) {
            if (getNodeType(node) == 'rule') {
                if (node.selector.indexOf(',') > -1) {
                    var selector = node.selector;
                    if (selector.indexOf('\n') > -1) {
                        frOptions['multiple-rule-selector-sep'] = '\n';
                    }
                    else if (selector.indexOf(' ') > -1) {
                        frOptions['multiple-rule-selector-sep'] = ' ';
                    }
                }
            }
        }

        return frOptions;
    }
}

var PG_DEFAULT_STYLESHEET_FORMATTING = {
    default: {
        'indent': '    ',

        // Decl
        'before-decl-after-decl':    '\n',
        'before-decl-after-rule':    '\n\n',
        'before-decl-after-atrule':  '\n\n',
        'before-decl-after-import':  '\n\n',
        'before-decl-after-comment': '\n',
        // Decl nested
        'before-nested-decl-after-decl':    '\n',
        'before-nested-decl-after-rule':    '\n\n',
        'before-nested-decl-after-atrule':  '\n\n',
        'before-nested-decl-after-import':  '\n\n',
        'before-nested-decl-after-comment': '\n',

        // Rule
        'before-rule-after-decl':    '\n\n',
        'before-rule-after-rule':    '\n\n',
        'before-rule-after-atrule':  '\n\n',
        'before-rule-after-import':  '\n\n',
        'before-rule-after-comment': '\n',
        'multiple-rule-selector-sep': '\n',
        // Rule nested
        'before-nested-rule-after-decl':    '\n\n',
        'before-nested-rule-after-rule':    '\n\n',
        'before-nested-rule-after-atrule':  '\n\n',
        'before-nested-rule-after-import':  '\n\n',
        'before-nested-rule-after-comment': '\n',

        // Atrule
        'before-atrule-after-decl':    '\n\n',
        'before-atrule-after-rule':    '\n\n',
        'before-atrule-after-atrule':  '\n\n',
        'before-atrule-after-import':  '\n\n',
        'before-atrule-after-comment': '\n',
        // Atrule nested
        'before-nested-atrule-after-decl':    '\n\n',
        'before-nested-atrule-after-rule':    '\n\n',
        'before-nested-atrule-after-atrule':  '\n\n',
        'before-nested-atrule-after-import':  '\n\n',
        'before-nested-atrule-after-comment': '\n',


        // Import
        'before-import-after-decl':    '\n\n',
        'before-import-after-rule':    '\n\n',
        'before-import-after-atrule':  '\n\n',
        'before-import-after-import':  '\n',
        'before-import-after-comment': '\n',
        // Import nested
        'before-nested-import-after-decl':    '\n\n',
        'before-nested-import-after-rule':    '\n\n',
        'before-nested-import-after-atrule':  '\n\n',
        'before-nested-import-after-import':  '\n',
        'before-nested-import-after-comment': '\n',


        // Comment
        'before-comment-after-decl':    '\n\n',
        'before-comment-after-rule':    '\n\n',
        'before-comment-after-atrule':  '\n\n',
        'before-comment-after-import':  '\n\n',
        'before-comment-after-comment': '\n',

        // Comment nested
        'before-nested-comment-after-decl':    '\n\n',
        'before-nested-comment-after-rule':    '\n\n',
        'before-nested-comment-after-atrule':  '\n\n',
        'before-nested-comment-after-import':  '\n\n',
        'before-nested-comment-after-comment': '\n',

        // Nested
        'before-first-nested-decl':    '\n',
        'before-first-nested-rule':    '\n',
        'before-first-nested-atrule':  '\n',
        'before-first-nested-import':  '\n',
        'before-first-nested-comment': '\n',

        'left-comment': ' ',
        'right-comment': ' ',

        'left-inline-comment': ' ',
        'right-inline-comment': '',

        'after-decl':    '',
        'after-rule':    '\n',
        'after-atrule':  '\n',
        'after-import':  '',
        'after-comment': '\n',

        'rule-between': ' '
    },
    inline: {
        'indent': ' ',

        // Decl
        'before-decl-after-decl':    '',
        'before-decl-after-rule':    ' ',
        'before-decl-after-atrule':  ' ',
        'before-decl-after-import':  ' ',
        'before-decl-after-comment': '',
        // Decl nested
        'before-nested-decl-after-decl':    '',
        'before-nested-decl-after-rule':    ' ',
        'before-nested-decl-after-atrule':  ' ',
        'before-nested-decl-after-import':  ' ',
        'before-nested-decl-after-comment': '',

        // Rule
        'before-rule-after-decl':     ' ',
        'before-rule-after-rule':     ' ',
        'before-rule-after-atrule':   ' ',
        'before-rule-after-import':   ' ',
        'before-rule-after-comment':   '',
        'multiple-rule-selector-sep': ' ',
        // Rule nested
        'before-nested-rule-after-decl':    ' ',
        'before-nested-rule-after-rule':    ' ',
        'before-nested-rule-after-atrule':  ' ',
        'before-nested-rule-after-import':  ' ',
        'before-nested-rule-after-comment': '',

        // Atrule
        'before-atrule-after-decl':    ' ',
        'before-atrule-after-rule':    ' ',
        'before-atrule-after-atrule':  ' ',
        'before-atrule-after-import':  ' ',
        'before-atrule-after-comment': '',
        // Atrule nested
        'before-nested-atrule-after-decl':    ' ',
        'before-nested-atrule-after-rule':    ' ',
        'before-nested-atrule-after-atrule':  ' ',
        'before-nested-atrule-after-import':  ' ',
        'before-nested-atrule-after-comment': '',


        // Import
        'before-import-after-decl':    ' ',
        'before-import-after-rule':    ' ',
        'before-import-after-atrule':  ' ',
        'before-import-after-import':  ' ',
        'before-import-after-comment': '',
        // Import nested
        'before-nested-import-after-decl':    ' ',
        'before-nested-import-after-rule':    ' ',
        'before-nested-import-after-atrule':  ' ',
        'before-nested-import-after-import':  ' ',
        'before-nested-import-after-comment': '',


        // Comment
        'before-comment-after-decl':    ' ',
        'before-comment-after-rule':    ' ',
        'before-comment-after-atrule':  ' ',
        'before-comment-after-import':  ' ',
        'before-comment-after-comment': '',

        // Comment nested
        'before-nested-comment-after-decl':    ' ',
        'before-nested-comment-after-rule':    ' ',
        'before-nested-comment-after-atrule':  ' ',
        'before-nested-comment-after-import':  ' ',
        'before-nested-comment-after-comment': '',

        // Nested
        'before-first-nested-decl':    '',
        'before-first-nested-rule':    '',
        'before-first-nested-atrule':  '',
        'before-first-nested-import':  '',
        'before-first-nested-comment': '',

        'left-comment': ' ',
        'right-comment': ' ',

        'left-inline-comment': ' ',
        'right-inline-comment': '',

        'after-decl':    '',
        'after-rule':    ' ',
        'after-atrule':  ' ',
        'after-import':  '',
        'after-comment': '',

        'rule-between': ' '
    }
}