//For PG 3.x


var PgGoogleFontManager = function () {
    var GOOGLE_FONT_KEY = 'AIzaSyCTphlYszhVyhJKDwKgUDdl64PfPaXxXUI';
    var DEFAULT_TEXT_PREVIEW = "Pinegrow web editor, asset manager.";
    var GOOGLE_FONT_BASE_URL = 'https://fonts.googleapis.com/css?family=';
    var VARIANT_NAME = {
        'regular': 'Regular',
        '100': 'Thin',    '200': 'Extra light', '300': 'Light',
        '400': 'Regular', '500': 'Medium',      '600': 'Normal',
        '700': 'Bold',    '800': 'Extra bold',  '900': 'Black'
    }
    const DEFAULT_DISPLAY = 'swap';

    var previewText = DEFAULT_TEXT_PREVIEW;
    var $chached_fonts_ul = null;

    var _this = this;

    var getFullOptionGoogleFontLinkURLFor = function (gFont) {
        var apiUrl = [];
        apiUrl.push(GOOGLE_FONT_BASE_URL);
        apiUrl.push(gFont.family.replace(/ /g, '+'));
        var variants = gFont.variants.map(function (variant) {
            var fontSetting = getFontSettingFromVariant(variant);
            return fontSetting['font-weight'] + (fontSetting['font-style'] == "italic" ? 'italic' : '');
        })
        apiUrl.push(':' + variants.join(','));
        apiUrl.push('&subset=' + gFont.subsets.join(','));

        return apiUrl.join('');
    }

    var getGoogleFontLinkURLFor = function (gFont) {
        var apiUrl = [];
        apiUrl.push(GOOGLE_FONT_BASE_URL);
        apiUrl.push(gFont.family.replace(/ /g, '+'));
        if (gFont.wanted_weights_and_style && gFont.wanted_weights_and_style.length > 0) {
            apiUrl.push(":" + gFont.wanted_weights_and_style.join(','));
        }

        if (gFont.wanted_subsets && gFont.wanted_subsets.length > 0) {
            apiUrl.push("&subset=" + gFont.wanted_subsets.join(','));
        }

        apiUrl.push("&display=" + (gFont.wanted_display ? gFont.wanted_display : DEFAULT_DISPLAY));

        return apiUrl.join('');
    }

    var choosed_fonts = {};
    var included_fonts = [];

    var page_number = 1;
    var fonts_array = [];
    var final_fonts_array = [];
    var hasNoMorePages = false;
    var checkbox_changed = function () {
        var $li = $(this).closest('li');
        var google_font = final_fonts_array[ parseInt($li.attr('data-index')) ];

        if ($(this).is(':checked')) {
            choosed_fonts[google_font.family] = google_font;
            $li.addClass('checked');
        }
        else {
            if (choosed_fonts[google_font.family]) {
                delete choosed_fonts[google_font.family];
            }
            $li.removeClass('checked');
        }
    }

    var getFontSettingFromVariant = function (variant) {
        var matched = variant.match(/([0-9]+)([a-z]*)/);
        var fontSetting = {};
        if (matched) {
            fontSetting['font-weight'] = matched[1];
            fontSetting['font-style'] = (matched[2] ? matched[2] : 'normal');
        }
        else {
            fontSetting['font-weight'] = "400";
            if (variant == 'regular') {
                fontSetting['font-style'] = 'normal';
            }
            else if (variant == 'italic') {
                fontSetting['font-style'] = 'italic';
            }
        }
        var weight = variant;
        if (matched) weight = matched[1];

        if (weight == 'regular' || weight == 'italic') {
            weight = 400;
        }

        fontSetting['text'] = _this.getWeightText(weight, fontSetting['font-style']);

        return fontSetting;
    }

    var getSubsetString = function (subset) {
        var subsetWithExt = subset.split('-');
        return crsaCamelize(subsetWithExt[0]) + (subsetWithExt[1] == 'ext' ? ' Extended' : '' );
    }

    var show_advance_settings = function (e) {
        e.preventDefault();

        var $li = $(this).closest('li');
        var included_font = $li.data('included_font');
        var index = parseInt($li.attr('data-index'));

        var google_font = final_fonts_array[ index ];

        _this.openSettingsFor(google_font, included_font,
            function () {
                // Cancel
            }, function () {
                // Accept
                $li.find('[type="checkbox"]').prop("checked", true).change();
            });
    }

    var updateGoogleFont = function ($ul) {
        var $modal_body = $ul.closest('.modal-body');
        var $modal_body_div = $modal_body.find('> div');
        var $loading_gif = $modal_body.find('.loading-icon');
        var $failedP = $modal_body.find('.load-fonts-failed');
        var $refresh = $failedP.find('> a');

        var nextPage = function () {
            if (hasNoMorePages) return;
            $loading_gif.show();

            var start = 20 * (page_number - 1);
            var end = (20 * page_number);

            if (start >= final_fonts_array.length) {
                hasNoMorePages = true;
                $loading_gif.hide();
                return;
            }

            if (end >= final_fonts_array.length) {
                end = final_fonts_array.length;
                hasNoMorePages = true;
                $loading_gif.hide();
            }

            for (var i = start; i < end; i++) {
                var included_font = _this.getIncludedFont(final_fonts_array[i]);
                var $li = $('<li data-index="' + i + '"></li>').appendTo($ul);
                $li.data('included_font', included_font);

                var $input = $(`<input type="checkbox" ${ included_font ? 'checked' : '' }>`).appendTo($li);
                var $head = $('head');
                $head.append('<link href="'+ getFullOptionGoogleFontLinkURLFor(final_fonts_array[i]) +'" rel="stylesheet">');
                var $h3 = $("<h3 class='font-preview' style='font-family:" + final_fonts_array[i].family + ";'><span>" + previewText + "</span></h3>").appendTo($li);
                var $advance_settings_icon = $('<i class="advance-settings-icon pull-right glyphicon glyphicon-cog"></i>').appendTo($h3);
                $("<p class='more-info'><b>" + final_fonts_array[i].family + "</b>, category: " + final_fonts_array[i].category + "</p>").appendTo($li);

                $input.change(checkbox_changed);
                $advance_settings_icon.click(show_advance_settings);
            }
            $chached_fonts_ul = $ul;
        }

        var failedToLoadResources = function () {
            $loading_gif.hide();
            $failedP.show();
        }

        $modal_body.on('scroll', function () {
            var modalDialogHeight = $modal_body_div.closest('.modal-dialog').height() + 30;

            if ($modal_body_div.height() + $modal_body_div.offset().top < modalDialogHeight && !hasNoMorePages) {
                page_number++;
                nextPage();
            }
        });

        _this.loadFonts(function (err) {
            if (err) {
                pinegrow.showQuickMessage('There is a problem with calling google fonts');
                failedToLoadResources();
            }
            else if (!$chached_fonts_ul) {
                nextPage();
            }
        });


        $refresh.on('click', function (e) {
            $loading_gif.show();
            $failedP.hide();
            loadFontsArray();

            e.preventDefault();
        });
    }

    var addCopyNameIcon = function (data, $el) {
        // var name = getFontNameFromURL(data.url);
        var name = data.info;
        if (name) {
            var $copyIcon = $('<i class="glyphicon glyphicon-copy" title="Copy family name to clipboard"></i>').appendTo($el);
            $copyIcon.click(function (e) {
                e.preventDefault();
                crsaCopyToClipboard(name);
                pinegrow.showQuickMessage("Font name copied to your clipboard...");
            })
        }
    }

    var resetAllVariable = function () {
        page_number = 1;
        hasNoMorePages = false;
        $chached_fonts_ul = null;
        final_fonts_array = fonts_array;
        // previewText = DEFAULT_TEXT_PREVIEW;
    }

    var getFormattedVarient = function (varient) {
        if (varient == "regular") return "400";
        if (varient == "italic") return "400italic";

        return varient;
    }

    var isVarientsSelected = function (varient, included_font) {
        if (included_font) {
            if (included_font.included_varients && included_font.included_varients.length > 0) {
                var formattedVarient = getFormattedVarient(varient);

                if (included_font.included_varients.indexOf(formattedVarient) > -1) {
                    return true;
                }
            }
        }

        return false;
    }

    var isSubsetSelected = function (subset, included_font) {
        if (included_font) {
            if (included_font.included_subset && included_font.included_subset.length > 0) {

                if (included_font.included_subset.indexOf(subset) > -1) {
                    return true;
                }
            }
        }

        return false;
    }

    this.getWeightText = function (weight, style) {
        return `${VARIANT_NAME[weight]} ${weight} ${style == 'italic' ? 'italic' : ''}`;
    }

    this.getIncludedFont = function (gFont) {
        for (var i = 0; i < included_fonts.length; i++) {
            var included_font = included_fonts[i];
            if (gFont.family == included_font.family) return included_font;
        }
        return null;
    }

    this.loadFonts = function (done) {
        if (!fonts_array || fonts_array.length == 0) {
            $.ajax({
                type: 'GET',
                url: 'https://www.googleapis.com/webfonts/v1/webfonts',
                data: {
                    key: GOOGLE_FONT_KEY
                },
                success: function (data) {
                    fonts_array = data.items;
                    final_fonts_array = fonts_array;
                    if (done) done(null, data);
                },
                error: function (err) {
                    if (done) done(err);
                }
            });
        } else {
            if (done) done(null, fonts_array);
        }
    }

    this.openSettingsFor = function (google_font, included_font, cancel, accept) {
        var $advance_settings = $('<div class="advance-settings pg-dialog-fields"></div>');
        var $container = $('<div class="advance-settings-content"></div>').appendTo($advance_settings);

        var $fontStyleSettings = $('<div class="font-style"><h4>Font styles</h4></div>').appendTo($container);
        var $table = $('<table width="100%" style="font-family:' + google_font.family + ';"><tbody></tbody></table>').appendTo($fontStyleSettings);
        var $tbody = $table.find('> tbody');

        var variants = google_font.variants;
        for (var i = 0; i < variants.length; i++) {
            var fontSetting = getFontSettingFromVariant(variants[i]);
            var checked = isVarientsSelected(variants[i], included_font);

            var $tr = $('<tr style="font-weight:' + fontSetting['font-weight'] + ';font-style:' + fontSetting['font-style'] + ';"></tr>').appendTo($tbody);
            var $td = $('<td width="30%"></td>').appendTo($tr);
            $checkbox = $('<input data-font-weight="' + fontSetting['font-weight'] + '" data-font-style="' + fontSetting['font-style'] + '" type="checkbox" ' + (checked ? 'checked' : '') + '>').appendTo($td);
            $('<span> ' + fontSetting['text'] + '</span>').appendTo($td);
            var $td = $('<td width="70%">' + previewText + '</td>').appendTo($tr);

            $checkbox.change(function (e) {
                var fontSettingString = $(this).attr('data-font-weight') + ($(this).attr('data-font-style') == 'italic' ? 'italic' : '');

                if (!google_font.wanted_weights_and_style) {
                    google_font.wanted_weights_and_style = [];
                }

                if ($(this).is(':checked')) {
                    if (google_font.wanted_weights_and_style.indexOf(fontSettingString) < 0) {
                        google_font.wanted_weights_and_style.push(fontSettingString);
                    }
                }
                else {
                    var index = google_font.wanted_weights_and_style.indexOf(fontSettingString);
                    if (index > -1 && index < google_font.wanted_weights_and_style.length) {
                        google_font.wanted_weights_and_style.splice(index, 1);
                    }
                }
            });

            var fontSettingString = fontSetting['font-weight'] + (fontSetting['font-style'] == 'italic' ? 'italic' : '');

            if (google_font.wanted_weights_and_style) {
                if (google_font.wanted_weights_and_style.indexOf(fontSettingString) > -1) {
                    $checkbox.prop("checked", true).change();
                }
            }
        }

        var $fontCharsetSettings = $('<div class="font-charset"><h4>Character sets</h4></div>').appendTo($container);
        pg$Hide($fontCharsetSettings);

        var updateAndGetChoosedCharset = function () {
            var accepted = [];
            var $checkboxes = $fontCharsetSettings.find('[type="checkbox"]');
            $checkboxes.each(function (i, checkbox) {
                if (!$(checkbox).is(':disabled') && $(checkbox).is(':checked')) {
                    accepted.push($(checkbox).attr('data-subset'));
                }
            });

            var $latinCheckbox = $fontCharsetSettings.find('[data-subset="latin"]');
            if (accepted.length > 0) {
                if (accepted.length == 1 && accepted[0] == 'latin') {
                    $latinCheckbox.attr('disabled', '');
                    accepted = [];
                } else if ($latinCheckbox.is(':disabled')) {
                    $latinCheckbox.removeAttr('disabled');
                    if ($latinCheckbox.is(':checked')) {
                        accepted.push('latin');
                    }
                }
            } else {
                $latinCheckbox.prop("checked", true).attr('disabled', '');
            }

            return accepted;
        }

        var subsets = google_font.subsets;
        for (var i = 0; i < subsets.length; i++) {
            var subset = subsets[i];
            var checked = isSubsetSelected(subset, included_font);

            var $span = $('<span class="subset-option"></span>').appendTo($fontCharsetSettings);
            var $checkbox = $('<input data-subset="' + subset + '" type="checkbox" ' + (checked ? 'checked' : '') + '>').appendTo($span);
            var $desc = $('<span> ' + getSubsetString(subset) + ' </span>').appendTo($span);

            $checkbox.change(function (e) {
                google_font.wanted_subsets = updateAndGetChoosedCharset();
            });

            if (google_font.wanted_subsets) {
                if (google_font.wanted_subsets.indexOf(subset) > -1) {
                    $checkbox.prop("checked", true).change();
                }
            }
            else if (subset == "latin") {
                $checkbox.prop("checked", true);
                $checkbox.attr('disabled', '');
            }
        }

        var $fontDisplaySettings = $('<div class="font-display"><h4>Font display</h4></div>').appendTo($container);

        var fontDisplay = new PgPropertyField($fontDisplaySettings, null, 'googlefont.display', {
            type: 'select',
            name: 'Font display',
            action: 'custom',
            show_empty: true,
            options: [
                { name: 'Auto', key: 'auto' },
                { name: 'Block', key: 'block' },
                { name: 'Swap', key: 'swap' },
                { name: 'Fallback', key: 'fallback' },
                { name: 'Optional', key: 'optional' }
            ],
            get_value: function (pgel) {
            },
            set_value: function (pgel, value, values) {
                google_font.wanted_display = value;
            },
            helptext: `<p>Decide what to do while the font is loading:</p><ul>
            <li><p><b>Auto</b> - Text will be hidden until the font is loaded, unless browser decides that the waiting is too long. This is the default behavior.</p></li>
            <li><p><b>Block</b> - The closest available font is used to display the text while the font is loaded. Recommended setting for best performance.</p></li>
            <li><p><b>Swap</b> - Text will be hidden until the font is loaded.</p></li>
            <li><p><b>Fallback</b> - Text is hidden for a very short time and if the font is not loaded till then, the closest available font is used. This is a good alternative to swap if you want to avoid showing unsettled text.</p></li>
            <li><p><b>Optional</b> - Let the browser decide whether to use the font or not.</p></li>
            </ul>`
        }, []);

        fontDisplay.$field.find('label').css('width', 'auto');


        if (google_font.wanted_display) {
            fontDisplay.setValue(google_font.wanted_display);
        }
        else if (included_font && included_font.included_display) {
            fontDisplay.setValue(included_font.included_display);
        }
        else {
             fontDisplay.setValue(DEFAULT_DISPLAY);
        }

        //makeAndShowDialog
        makeModalDialog("Styles", "Cancel", "Accept", $advance_settings, function () {
            if (cancel) cancel();
        }, function () {
            google_font.wanted_display = fontDisplay.getValue();
            var fontObj = getChoosedFontObj(google_font);
            if (accept) accept(google_font, fontObj);
        }, null, true);
    }

    var getChoosedFontObj = function (google_font) {
        return {
            url: getGoogleFontLinkURLFor(google_font),
            name: google_font.family,
            action: addCopyNameIcon,
            category: google_font.category,
            variants: google_font.variants,
            subsets: google_font.subsets,
            wanted_styles: google_font.wanted_weights_and_style
        }
    }

    var getFontSettings = function (url) {
        var fontSettings = {};

        var strSettings = url.replace('https://fonts.googleapis.com/css?', '');
        var settingsArr = strSettings.split('&');
        for (var i = 0; i < settingsArr.length; i++) {
            var setting = settingsArr[i];

            var paramsValue = setting.split('=');
            if (paramsValue[0] == 'family') {
                var nameWeight = paramsValue[1].split(':');
                fontSettings['family'] = nameWeight[0].replace(/\+/g, ' ');

                if (nameWeight[1]) {
                    fontSettings['variants'] = nameWeight[1].split(',');
                }
            }
            else if (paramsValue[0] == 'subset') {
                fontSettings['subset'] = paramsValue[1].split(',');
            }
            else if (paramsValue[0] == 'display') {
                fontSettings['display'] = paramsValue[1];
            }
        }

        var formatedVariants = fontSettings.variants || [];
        for (var i = 0; i < formatedVariants.length; i++) {
            var variant = formatedVariants[i];
            if (variant.endsWith('i')) {
                formatedVariants[i] = variant.replace('i', 'italic');
            }
        }

        return {
            ...fontSettings,
            variants: formatedVariants
        }
    }

    this.getFont = function (fontUrl) {
        var fontSettings = getFontSettings(fontUrl);

        var selectedFont = null;
        for (let i = 0; i < fonts_array.length; i++) {
            var font = fonts_array[i];
            if (font.family == fontSettings.family) {
                selectedFont = font;
                break;
            }
        }

        selectedFont = {
            ...selectedFont,
            wanted_weights_and_style: fontSettings['variants'],
            wanted_subsets: fontSettings['subset'],
            wanted_display: fontSettings['display']
        }

        return selectedFont;
    }

    this.show = function (done) {
        choosed_fonts = {};
        included_fonts = getAttachedGoogleFonts(pinegrow.getSelectedPage());
        var $b = $('<div class="gfonts-modal"><p>Choose fonts you want to add to your page</p></div>');

        var $row = $('<div class="row"></div>').appendTo($b);
        var $col1 = $('<div class="col-sm-6 col-xs-12"></div>').appendTo($row);
        var $col2 = $('<div class="col-sm-6 col-xs-12"></div>').appendTo($row);

        var $searchForm = $('<form class="form-inline font-search"><div class="form-group"><label for="search-for-font">Search:</label><input type="search" class="form-control" placeholder="Search by font name..." style="margin: 10px 2px; min-width: 250px" id="search-for-font"></div></form>').appendTo($col1);
        var $searchInput = $searchForm.find('input');

        var $previewTextForm = $('<form class="form-inline font-preview-text"><div class="form-group"><label for="font-preview-text">Preview text:</label><input type="text" class="form-control" placeholder="Preview text..." style="margin: 10px 2px; min-width: 250px" id="font-preview-text"></div></form>').appendTo($col2);
        var $previewTextInput = $previewTextForm.find('input');

        //makeAndShowDialog
        makeModalDialog("Google fonts", "Close", "Add selected fonts", $b, function () {
            if (done) done([]);
        }, function () {
            if (done) {
                var final_choosed_fonts = [];
                for(var fontName in choosed_fonts) {
                    final_choosed_fonts.push(getChoosedFontObj(choosed_fonts[fontName]));
                }
                done(final_choosed_fonts);

                // if (final_choosed_fonts.length > 0) pinegrow.dispatchEvent('on_google_font_added');
            }
        }, null, true);

        var $ul = $('<ul class="gfonts-list"></ul>').appendTo($b);
        $('<center class="loading-icon"><img src="lib/crsa/images/loading.GIF"></center>').appendTo($b);
        $('<p class="load-fonts-failed text-center text-danger" style="display:none;"><strong>Failed to load fonts, check your internet connection.</strong> <a href="#" class="refresh-content">Refresh</a></div>').appendTo($b);

        resetAllVariable();
        updateGoogleFont($ul);

        var onKeypress = function (e) {
            if (e.keyCode === 13) {
                e.preventDefault();
                return false;
            }
        }

        $searchInput.on('input', function (e) {
            e.preventDefault();
            if (!$searchInput.val()) {
                resetAllVariable();

                final_fonts_array = fonts_array;
            }
            else {
                page_number = 1;
                hasNoMorePages = false;
                $chached_fonts_ul = null;

                final_fonts_array = fonts_array.filter(function(font) {
                    if (font.family) return font.family.toLowerCase().match($searchInput.val().toLowerCase());
                });
            }
            $ul.html('');
            updateGoogleFont($ul);
        });

        $previewTextInput.on('input', function (e) {
            e.preventDefault();
            if (!$previewTextInput.val()) {
                previewText = DEFAULT_TEXT_PREVIEW;
                $ul.find('h3 > span').html(previewText);
            }
            else {
                previewText = $previewTextInput.val();
                $ul.find('h3 > span').html(previewText);
            }
        });

        $searchInput.on('keypress', onKeypress);
        $previewTextInput.on('keypress', onKeypress);
    }

    this.checkForLinks = function (page) {
        var existFonts = getAttachedGoogleFonts(page);
        for (var i = 0; i < existFonts.length; i++) {
            var font = existFonts[i];
            font.action = addCopyNameIcon;
        }
        return existFonts;
        // var existFonts = [];
        // pinegrow.goThroughAllForAttribute(page, 'href', function (el, attr, url) {
        //     var matched = url.match(/fonts.googleapis.com\/css/);
        //     if (el.is('link') && (matched && matched.length > 0)) {
        //         var name = getFontNameFromURL(url);
        //         if (name) {
        //             existFonts.push({
        //                 url: url,
        //                 name: getFontNameFromURL(url),
        //                 action: addCopyNameIcon
        //             });
        //         }
        //     }
        // });
        // return existFonts;
    }

    this.addNotes = function ($container) {
        $('<span>Click on <i class="glyphicon glyphicon-copy"></i> icon to copy the family name to clipboard. Then paste it into the Font family property of the CSS rule.</span>').appendTo($container);
    }

    this.getFontOptions = function (existFonts) {
        var fonts = [];

        for (var i = 0; i < fonts_array.length; i++) {
            var fWithOptions = fonts_array[i];
            for (var j = 0; j < existFonts.length; j++) {
                var existFont = existFonts[j];

                if (existFont.name == fWithOptions.family) {
                    fonts.push({
                        ...existFont,
                        ...fWithOptions
                    });

                    existFonts.splice(j, 1);
                    break;
                }
            }

            if (existFonts.length == 0) break;
        }

        if (fonts.length > 0) {
            return fonts;
        }
        else {
            return existFonts;
        }
    }

    this.init = function () {
        this.loadFonts(function (err) {
            if (err) console.log("Error: Can't load Google fonts");
        });
    }
}

/*
var PgStylesheetManagerView = function() {

    var $element = $('<div class="pg-sm"></div>');

    var view = new PgUIView($element);

    this.view = view;

    var _this = this;

    var onFrameworksChanged = function() {
        view.whenVisible(function() {

        })
    }

    view.onResize = function() {

    }

    //pinegrow.addEventHandler('on_element_selected', onElementSelected);

    view.onDestroy = function() {
        //pinegrow.removeEventHandler('on_element_selected', onElementSelected);
    }
}
*/