var PgCSSRulesView = function(currentCs) {

    //Display list of stylesheets, like we had before on top of the CSS panel. But here we decouple stylesheets view from the rules view

    var $element = $('<div class="crsa-rules aacrsa-panel crsa-stylesheets"></div>');

    var $head = $('<div class="crsa-stylesheets-head"><h3></h3></div>').appendTo($element);

    var $head_title = $head.find('h3');

    var $rule_list_container = $("<div/>", {class: 'rule-list-container'}).appendTo($element);

    var buttonToolbarTop = new PgButtonToolbar();
    buttonToolbarTop.addSection('setting');
    buttonToolbarTop.addSection('actions');
    //buttonToolbarTop.addSection('nav');
    buttonToolbarTop.$element.appendTo($head);

    //remember scroll and cursor position
    if(!currentCs.viewInfo) {
        currentCs.viewInfo = {
            source: false,
            top: 0,
            source_pos: {line: 0, char: 0}
        }
    }

    /*
    var combinedButton = new PgButtonToolbarItem('icon-window', 'Go back to the combined view.');
    buttonToolbarTop.addItem('nav', combinedButton);

    combinedButton.onClick = function() {
        _this.parentView.setActiveCs(null);
    }*/

    var onlyActiveButton = new PgButtonToolbarItem('icon-check', 'Show only rules that are active for the current element.');
    buttonToolbarTop.addItem('setting', onlyActiveButton);

    onlyActiveButton.onClick = function() {
        var val = !this.getActive();

        this.setActive(val);
        _this.setOnlyActive(val, true);
    }

    var onlyVisibleButton = new PgButtonToolbarItem('icon-see', 'Show only rules that are visible for the current page view size.');
    buttonToolbarTop.addItem('setting', onlyVisibleButton);

    onlyVisibleButton.onClick = function() {
        var val = !this.getActive();

        this.setActive(val);
        onlyVisibleInputChnaged(val);
    }

    var pgStylePane = null;


    var sourceButton = new PgButtonToolbarItem('icon-KODA', 'Edit stylesheet source.');
    buttonToolbarTop.addItem('actions', sourceButton);

    sourceButton.onClick = function() {
        pinegrow.stylesheets.editCode(currentCs);
        /*
        var code = !this.getActive();

        this.setActive(code);

        if(code) {
            pinegrow.selectRule(null);
            $source.html('');
            $rule_list_container.hide();
            $source.show();
            removeStylePane();
            _this.showSource($source);
        } else {
            $sourceWarning.hide();
            $source.hide();
            $rule_list_container.show();
            _this.closeSource();
            updateRules();
        }*/
    }

    var $source = $('<div/>', {'class' : 'cm-source'}).hide().appendTo($element);
    var $sourceWarning = $('<div style="display:none;" class="alert alert-info alert-panel-notice">Please exit the code mode to synchronize changes.</div>').appendTo($element);

    var view = new PgUIView($element);
    view.pgStylesheet = currentCs;

    this.quitCodeMode = function () {
        if (sourceButton.getActive()) {
            $source.hide();
            $sourceWarning.show();
        }
    }

    var pgRuleControles = null;

    this.view = view;

    var _this = this;

    var onPageSelected = function(event, page) {
        if (onPageSelected == null) return;

        selectedCrsaPage = page;
        selectedPage = page ? page.$iframe : null;
        iframe = selectedPage ? selectedPage.get(0) : null;

        view.whenVisible(function() {
            _this.refresh();
        })
    }

    $('body')
        .on('crsa-page-selected', onPageSelected);

    view.onDestroy = function() {
        removeStylePane();

        if (crsaSelectBox) {
            crsaSelectBox.remove();
            crsaSelectBox = null;
        }

        $ul[0].innerHTML = '';
        view.pgStylesheet = null;

        pinegrow.removeEventHandler('on_before_save', onBeforeSave);
        pinegrow.removeEventHandler('on_css_source_changed', onRuleChanged);
        pinegrow.removeEventHandler('on_panel_moved_in_another_window', onPanelMovedToAnotherWindow);

        $('body')
            .off('crsa-page-selected', onPageSelected)
            .off('crsa-element-selected', onElementSelected)

            .off('crsa-window-changed', onWindowChanged)
            .off('crsa-stylesheets-changed', onStylesheetsChanged)
            .off('crsa-stylesheets-properties-changed', onStylesheetsPropertiesChanged);


        $onlyActiveInput
            .off('change', onlyActiveInputChanged);

        $onlyVisibleInput
            .off('change', onlyVisibleInputChnaged);

        onPageSelected = null;
        onRuleChanged = null;
        onElementSelected = null;

        onWindowChanged = null;
        onStylesheetsChanged = null;
        onStylesheetsPropertiesChanged = null;

        onSearchTriggered = null;
        onVarBtnClicked = null;
    }

    view.onResize = function() {
        resizeRulesList();
    }

    //refactored from CrsaClassManager
    $dest = $rule_list_container;

    this.filter_set_in_props_mode = false;
    this.only_active_user_choice = false;

    var onlyClasses = false;
    var $refElement = null;

    var $body = $('body');
    var $main_div = $('<div/>', {class: 'crsa-cm-main clearfix'}).appendTo($dest);
    var $rules_div = $('<div/>', {class: 'crsa-cm-rules'}).appendTo($main_div);

    var filter = null;
    var $add_class_help = null;

    var selectedPage = null;
    var selectedCrsaPage = null;
    var iframe = null;
    var show_add_class_help = true;

    var only_active = false;
    var only_visible = false;

    //mtch $('<h2/>').html('Stylesheets').appendTo($rules_div);
    //mtch var $psul = $('<ul/>', {class: 'cm-sslist'}).appendTo($rules_div);

    //mtch var $stylesheet_manage_link = $('<a/>', {class: 'cm-sslist-manage', href:"#"}).html('+ Manage...').appendTo($rules_div);
    var $css_var_contianer = $('<div class="crsa-css-var-header"></div').appendTo($rules_div);
    var $controls = $('<div class="cm-filter-container"></div>').appendTo($rules_div);
    var $ul = $('<ul/>', {'class' : 'crsa-cm-list'}).appendTo($rules_div);
    var $cmSource = null;

    $ul.on('scroll', function(e) {
        currentCs.viewInfo.top = $ul.scrollTop();
    })

    // select box
    var crsaSelectBoxOption = {
        itemClass: 'crsa-node',
        overParentClassName: 'crsa-stylesheet',
        selectorToFindChild: '> .rule-list > ul > li.crsa-node',
        isAllowed: function ($target) {
            if ($target.hasClass('cm-sslist-addrule') || $target.is('i')) return false;
            return true;
        },
        isDraggableElm: function ($target) {
            if ($target.is('.crsa-cm-move')) return true;
            return false;
        }
    }
    var crsaSelectBox = new CrsaSelectBox($ul, crsaSelectBoxOption);


    this.refresh = function() {
        showPageDimensionInfo();
        //mtch updateStylesheetList();
        updateRules();
        showVariables();
        updateUsedClasses();
        resizeRulesList();
    }

    this.setReferenceElement = function($el, skip_refresh) {
        $refElement = $el;
        if(!skip_refresh) {
            updateUsedClasses();
        }
        if($add_class_help) {
            if($refElement) {
                $add_class_help.show();
            } else {
                $add_class_help.hide();
            }
        }
    }

    this.setShowOnlyClasses = function(oc, skip_refresh) {
        onlyClasses = oc;
        if(!skip_refresh) {
            this.refresh();
        }
    }

    this.setSelectedPage = function($p, skip_refresh) {
        selectedPage = $p;
        iframe = selectedPage ? selectedPage.get(0) : null;
        if(!skip_refresh) {
            this.refresh();
        }
    }

    this.resizeRulesList = function() {
        resizeRulesList();
    }

    // this.setSelectedPage($.fn.crsa('getSelectedPage'), true);

    var showPageDimensionInfo = function() {
        var cp = selectedCrsaPage;
        if (cp) {
            $only_visible.find('span').html('Visible at ' + cp.deviceWidth + 'px');
        }
    }

    var resizeRulesList = function() {
        var showAllImportedFiles = function (cs) {
            var forAll = function (importedFiles) {
                for (var i = 0; i < importedFiles.length; i++) {
                    var importedFile = importedFiles[i];
                    if (importedFile.stylePane) {
                        importedFile.stylePane.updateShownNodes();
                    }

                    if (importedFile.importedFiles.length > 0) {
                        forAll(importedFile.importedFiles);
                    }
                }
            }

            forAll(cs.importedFiles);
        }

        if (!currentCs.ignore && !currentCs.loaded) {
            // if (currentCs.stylePane) currentCs.stylePane.updateShownNodes();
            if (pgStylePane) pgStylePane.updateShownNodes();
        }
    }

    var closeAllPropertiyForms = function() {
        $('.crsa-cm-props').html('');
        _this.showListPanel(false);
    }

    var showAddRuleBox = function($el, cs, value) {
        if (cs.getError()) {
            showAlert(cs.name + ' has syntax errors. Fix the errors before adding new rules.', 'Notice');
            return;
        }

        var offset = $el.offset();
        var place = (offset.left > $(window).width() / 2) ? 'left' : 'right';
        var eid = getUniqueIdFast();

        if ($el.data('popover-active')) {
            $el.popover('destroy');
            $el.data('popover-active', null);
            return;
        }

        var ensureRemove = function($e) {
            setTimeout(function() {
                $e.closest('.popover').remove();
            }, 750);
        }

        var pop = $el.popover({
            html: true,
            placement: place,
            trigger: 'manual',
            title: 'Add new CSS rule',
            container: 'body',
            content: '<form id="' + eid + '"><div class="form-group"><input class="form-control" placeholder=".any-css-selector" style="margin-bottom:8px;"/><p class="help-block"></p></p><button class="ok btn">Create</button><button class="ok assign btn btn-link">Create & Assign class</button><button class="closeit btn btn-link">Cancel</button></div></form>'
        })
            .on('shown.bs.popover', function() {
                var $d = $('#' + eid);
                var $i = $d.find('input').focus();
                if (value) $i.val(value);
                var $form = $d;
                var $b = $d.find('button.ok');
                var $a = $d.find('button.assign').css('visibility', 'hidden');
                var $help = $d.find('p.help-block').hide();
                var $bc = $d.find('button.closeit');


                $i.on('input', function() {
                    if(getClassFromSelector($i.val())) {
                        $a.css('visibility', 'visible');
                    } else {
                        $a.css('visibility', 'hidden');
                    }
                });

                if (!$refElement) {
                    $a.hide();
                }

                var doAdd = function(e) {
                    var r = $.trim($i.val());
                    if (!r || r.length == 0) {
                        $d.addClass('has-error');
                        return;
                    }

                    if ($(e.delegateTarget).hasClass('assign')) {
                        if(!getClassFromSelector(r)) {
                            $help.html(r + ' is not a class selector. You can only assign classes (for example .BUTTON) to elements.').show();
                            $d.addClass('has-error');
                            return;
                        }
                    }

                    //getCrsaPageForIframe($.fn.crsa('getSelectedPage')).undoStack.add("Add CSS rule / " + r, false, cs);

                    r += " {";
                    cs.insertRule(pinegrow.pgPostCSSHelper.getNodeFromText(r, null, 'rule', cs));
                    cs.regenerateAndSetCssSource(function() {
                        pinegrow.dispatchEvent('on_css_source_changed', null, {list: [cs]});
                        var rules = cs.getAllRules();
                        r = rules.length > 0 ? rules[rules.length-1] : null;

                        if (r) {
                            if($(e.delegateTarget).hasClass('assign') && $refElement && r.selector && !$refElement.hasClass(r.selector)) {
                                $dest.trigger('crsa-cm-class-add', r.selector);
                                updateUsedClasses();
                            }
                            _this.editRule(r);
                        }
                    });
                    $el.popover('hide');
                    ensureRemove($d);
                }

                $form.on('submit', function(e) {
                    e.preventDefault();
                    doAdd(e);
                });

                $b.on('click', function(e) {
                    e.preventDefault();
                    doAdd(e);
                });

                $bc.on('click', function(e) {
                    $el.popover('hide');
                    e.preventDefault();
                    ensureRemove($d);
                });
            })
            .on('hidden.bs.popover', function() {
                setTimeout(function() {
                    $el.popover('destroy').data('popover-active', null);
                },10);
            });

        $el.popover('show').data('popover-active', true);
    }

    var editorData = null;

    var updateChangedSourceTimer = null;
    var mirror = null;

    var updateChangedSource = function(mirror) {
        if(mirror) {
            currentCs.setSource(mirror.getDoc().getValue());
            pinegrow.dispatchEvent('on_css_source_changed', null, {list: [currentCs]});
        }
        updateChangedSourceTimer = null;
    }

    var forceUpdateChangedSource = function() {
        if(updateChangedSourceTimer) {
            clearTimeout(updateChangedSourceTimer);
            updateChangedSource();
        }
    }

    this.showSource = function ($container) {
        editorData = showCodeEditorUnder($container, getCodeMirrorMode(currentCs.fileType), 'edit-code',
            function (first_change) {
                // on Change

                //first change is triggered by setValue below
                if(!first_change) {
                    //Delayed update
                    if (updateChangedSourceTimer) {
                        clearTimeout(updateChangedSourceTimer);
                    }
                    updateChangedSourceTimer = setTimeout(function () {
                        updateChangedSource(mirror);
                    }, 500)
                }

            }, function () {
                // on Ok
            }, function () {
                // on Cancel
            });

        var mirror = editorData.mirror;

        mirror.getDoc().setValue(currentCs.filterSource(currentCs.getSource(), true));
        mirror.getDoc().clearHistory();
    }

    var onBeforeSave = function() {
        //commit all changes to CSS if CMD + S was pressed before 500ms change timer was triggered
        forceUpdateChangedSource();
    }

    pinegrow.addEventHandler('on_before_save', onBeforeSave);

    this.closeSource = function () {
        //this.show();
        forceUpdateChangedSource();
        mirror = null;

        //This was bad. CSS was not saved until this was called
        //pinegrow.dispatchEvent('on_css_source_changed', null, { list: [currentCs] });

        //$('body').trigger('crsa-element-selected');
        pinegrow.selectedElements.reselect();
        editorData = null;
    }

    var removeStylePane = function() {
        forceUpdateChangedSource();

        if (pgRuleControles) {
            pgRuleControles.remove();
            pgRuleControles = null;
        }

        if (pgStylePane) {
            pgStylePane.remove();
            pgStylePane = null;
        }

        $ul.empty();
    }

    this.onRulesShow = function () {
        // currentCs.stylePane.updateShownNodes();
        if(pgStylePane) {
            pgStylePane.updateShownNodes();
            $ul.scrollTop(currentCs.viewInfo.top);
        }
        if(editorData) {
            editorData.mirror.refresh();
            editorData.mirror.focus();
        }
    }

    var updateRules = function() {
        var profile = new CrsaProfile(true);

        var scrollTop = currentCs.viewInfo.top;
        // $ul.html('');

        profile.show('clean');

        var showRulesFor = function (cs) {
            if (cs.ignore) return true;

            removeStylePane();

            var $li = $('<div/>', {class: 'crsa-stylesheet'}).appendTo($ul).data('cs', cs);
            var $rule_list = $("<div/>", {class: 'rule-list'}).appendTo($li);

            $head_title.empty().text(cs.name);

            var type = cs.fileType;
            if (type != 'css') {
                var $tt = $('<span class="cs-type">' + type + '</span>');
                addTooltip($tt, 'This stylesheet uses ' + type.toUpperCase() + ' parser.')
                $head_title.append($tt);
            }


            var error = cs.getError();
            if (error) {
                var extract = (error.extract ? error.extract.join("\n") : '');
                if (extract.length > 80) extract = extract.substr(0, 80);

                var errorStr  = "";
                errorStr += error.line ? 'Line: ' + error.line + ', ' : '';
                errorStr += error.file ? 'File: ' + error.file + ', ' : '';
                errorStr += error;

                var info = '<div class="cm-error">' + errorStr + '<pre>' + extract + '</pre></div>';
                var $lert = $('<div class="alert alert-info">Stylesheet has one or more ' + cs.fileType.toUpperCase() + ' syntax errors (use <b><i class="icon icon-KODA"></i></b> to fix it): ' + info + '</div>').appendTo($li.find('>div'));
            }

            // cs.stylePane = new PgStylesPane(cs, $li, $li.parent(), null, { 'created-by': 'css' });
            // cs.stylePane.filter = filter;
            // cs.stylePane.show();

            pgStylePane = new PgStylesPane(cs, $li, $li.parent(), null, {
                'created-by': 'css',
                'uncollapse': filter ? true : false
            });
            pgStylePane.filter = filter;
            pgStylePane.show();
            currentCs.stylePane = pgStylePane;

            // pgRuleControles = new PgCSSRuleControls($li, cs.stylePane, {
            pgRuleControles = new PgCSSRuleControls($li, pgStylePane, {
                $scrollParent: $main_div.parent(),
                by: 'css'
            });

            // $ul = $ul.parent().closest('ul');
        }

        showRulesFor(currentCs);

        profile.show('paint css 1');

        if (filter) {
            $ul.find('a.crsa-cm-move').hide();
        } else {
            $ul.find('a.crsa-cm-move').show();
        }
        $ul.trigger('scroll');
        $ul.scrollTop(scrollTop);
    }

    var showVariables = function() {
        $.fn.crsacss('showVariables');
    }

    resizeRulesList();

    var onWindowChanged = function(e, crsaPage) {
        if (onWindowChanged == null) return;

        if(crsaPage == getCrsaPageForIframe(selectedPage)) {
            showPageDimensionInfo();
            if(only_visible) {
                updateUsedClasses();
            }
        }
    }

    var onStylesheetsChanged = function(e, obj) {
        if (onStylesheetsChanged == null) return;

        var pgStylesheet = (obj && obj.cs) ? obj.cs : null;
        if (!pgStylesheet || currentCs.getUniqueName() == pgStylesheet.getUniqueName()) {
            view.whenVisible(function() {
                _this.refresh();
            });
        }
    }

    var onStylesheetsPropertiesChanged = function() {
        if (onStylesheetsPropertiesChanged == null) return;

        closeAllPropertiyForms();
    }

    var onVarBtnClicked = function () {
        if (onVarBtnClicked == null) return;

        event.preventDefault();
        var cs = $(this).closest('.crsa-stylesheets').data('pg-ui-view').pgStylesheet;
        $('body').trigger('pg-ui-add-ss-vars-panel', { cs: cs })
        // $('#crsa-vars-panel').data('panel').show();
    }

    $('body').on('crsa-window-changed', onWindowChanged);

    $('body').on('crsa-stylesheets-changed', onStylesheetsChanged);

    $('body').on('crsa-stylesheets-properties-changed', onStylesheetsPropertiesChanged);


    var $only_active = $('<label class="css-opt-label"><input class="control-label" type="checkbox" value="1">&nbsp;<span>Active</span></label>');//.appendTo($controls);
    var $only_visible = $('<label class="css-opt-label"><input class="control-label" type="checkbox" value="1">&nbsp;<span>Visible</span></label>');//.appendTo($controls);


    var onlyActiveInputChanged = function(e) {
        if (onlyActiveInputChanged == null) return;

        only_active = $(e.delegateTarget).is(':checked');
        _this.only_active_user_choice = only_active;
        updateUsedClasses();
    }

    var $onlyActiveInput = $only_active.find('> input');

    $onlyActiveInput.on('change', onlyActiveInputChanged);

    addTooltip($only_active, 'Show only active rules for the selected element.', {placement: 'top'})

    this.setOnlyActive = function(a, refresh) {
        if (typeof refresh == 'undefined') refresh = true;
        only_active = a;
        if (refresh) {
            updateUsedClasses();
            pgStylePane.updateShownNodes();
        }
    }

    var onlyVisibleInputChnaged = function(val) {
        if (onlyVisibleInputChnaged == null) return;

        only_visible = val;
        updateUsedClasses();
    }

    var $onlyVisibleInput = $only_visible.find('> input');

    $onlyVisibleInput.on('change', onlyVisibleInputChnaged);

    addTooltip($only_visible, 'Show only rules that match the current window size.', {placement: 'top'})

    this.setFilter = function(f, refresh) {
        if (typeof refresh == 'undefined') refresh = true;
        filter = f;
        $input.val(f);
        if (refresh) {
            updateRules();
            updateUsedClasses();
        }
    }

    var list = [];

    var exists = false;

    var filterList = function(rules) {
        var norm_filter = filter ? normalizeSelector(filter) : null;
        exists = false;

        if (!norm_filter && !onlyClasses) return rules;

        var list = [];
        $.each(rules, function(i,r) {
            if (!filter || (r.selector && pinegrow.pgPostCSSHelper.getSelector(r).indexOf(norm_filter) >= 0) || (r.text && r.text.indexOf(filter) >= 0)) {
                list.push(r);
                if(r.type == 'class' && r.class === filter) {
                    exists = true;
                }
            }
        });
        return list;
    }

    var current_rule_index = -1;

    var getRuleForDiv = function($li, cs) {
        if (!$li.attr('data-node-indices')) return null;
        if (!cs) cs = $li.closest('li.crsa-stylesheet').data('cs');
        return pinegrow.pgPostCSSHelper.getNodeByIndices(cs.getRootNode(), $li.attr('data-node-indices').split(','));
    }

    var getRuleForDivFast = function(div, cs) {
        var i = parseInt(div.getAttribute('data-rule-index'));
        return cs.getRuleByIndex(i);
    }

    var editRuleSource = function(rule) {
        $.fn.crsa('editRuleSource', rule);
    }

    this.editRule = function(r) {
        // var rule_obj = getObjectFromRule(r);
        $.fn.crsa('selectRule', r);
    }

    this.showListPanel = function(animated) {
        if (animated) {
            $main_div.animate({left: 0}, 150, function() {
                $main_div.find('button.back').hide();
                $main_div.css('width', 300);
            });
        } else {
            $main_div.css('left', 0);
        }
    }

    this.reloadStylesheet = function(cs, done) {
        var onDone = function() {
            if (done) done();
            crsaQuickMessage(cs.name + " reloaded.");
            $('body').trigger('crsa-stylesheets-changed');
        }

        if (cs.changed) {
            showAlert(cs.name + " has unsaved changes. Do you want to reload the stylesheet and loose these changes?", "Unsaved changes", "Cancel", "Reload", null, function() {
                cs.reload(onDone);
            });
        } else {
            cs.reload(onDone);
        }
    }

    var updateUsedClasses = function() {
        var p = new CrsaProfile(false);

        var script_tag = false;

        if ($refElement) {
            var pgel = getElementPgNode($refElement);
            script_tag = pgel && pgel.script_info;
        }

        if (!$refElement || script_tag) {
            $ul.find('.crsa-cm-apply').hide();
            $ul.find('div.crsa-cm-has-rule').removeClass('crsa-cm-has-rule');
        } else {
            $ul.find('.crsa-cm-apply').show();
        }
        p.show('    - 1');

        // if (!selectedPage) return;

        var media_vis_cache = {};
        // var crsaPage = getCrsaPageForIframe(selectedPage);
        // if (!crsaPage) return;

        // var win = crsaPage.getWindow();

        if (only_visible) {
            $ul.find('.crsa-atrule').removeClass('hide-rule');
        }
        p.show('    - 2');

        if ($refElement) {
            var ref_rules_dir = null

            var node = $refElement.get(0);
            if (node.ownerDocument.defaultView && node.ownerDocument.defaultView.getMatchedCSSRules) {
                var rules = node.ownerDocument.defaultView.getMatchedCSSRules(node, '');
                ref_rules_dir = {};
                if (rules) {
                    var i = rules.length;
                    while (i--) {
                        ref_rules_dir[normalizeSelector(rules[i].selectorText)] = true;
                    }
                }
            }
        }

        $ul.find('.crsa-stylesheet').each(function(i, ul) {
            // Can show them now
            // var $ul = $(ul);
            // var cs = $ul.data('cs');
            // if (cs.ignore) return true;

            // if (cs.stylePane && only_active) {
            //     cs.stylePane.showAllRules();
            //     cs.stylePane.showOnlySelectedRules();
            // }
            // else {
            //     cs.stylePane.showAllRules();
            // }

            if (pgStylePane && only_active) {
                pgStylePane.showAllRules();
                pgStylePane.showOnlySelectedRules();
            }
            else {
                pgStylePane.showAllRules();
            }
        });

        p.show('    - 3');
    }

    this.show = function(f) {
        filter = f;
        updateRules();
        updateUsedClasses();
        //this.onRulesShow();
    }

    this.st = function(t) {
        $ul.scrollTop(t);
    }
    //updateRules();
    //updateUsedClasses();

    var search_timeout = null;
    var error = null;

    var onPanelMovedToAnotherWindow = function() {
        _this.show(filter);
    }

    var onRuleChanged = function(p, obj) {
        if (onRuleChanged == null) return;
        if (obj && obj.by == 'css') return;
        if (!obj || !obj.list) return;
        var list = obj.list;

        var found = false;
        for (var i = 0; i < list.length; i++) {
            if (list[i].getUniqueName() == currentCs.getUniqueName()) found = true;
        }

        if (found || error != currentCs.getError()) {
            // var rules = getCrsaPageStylesForPage(selectedPage).getAllActiveRules();
            error = currentCs.getError();
            updateRules();
            updateUsedClasses();
        }
    }

    var onElementSelected = function(event, pgel) {
        if (onElementSelected == null) return;

        if (pgel) {
            var $el = pgel.get$DOMElement();
            _this.setReferenceElement($el);
        } else {
            _this.setReferenceElement(null);
        }
    }

    this.search = function(f) {
        filter = f;
        updateRules();
    }

    this.researchIfNeeded = function(f) {
        if(f != filter) {
            this.search(f);
        }
    }

    var onSearchTriggered = function(event) {
        filter = $input.val();
        if (filter && filter.length == 0) filter = null;
        if (search_timeout) {
            clearTimeout(search_timeout);
        }
        search_timeout = setTimeout(function() {
            updateRules();
            search_timeout = null;
        }, 300);
    }

    pinegrow.addEventHandler('on_css_source_changed', onRuleChanged);
    pinegrow.addEventHandler('on_panel_moved_in_another_window', onPanelMovedToAnotherWindow);
    $body.on('crsa-element-selected', onElementSelected);
}
