var PgStylesheetVarsView = function (pgStylesheet) {
    var $element = $('<div class="crsa-stylesheet-vars"></div>');

    var view = new PgUIView($element);
    var pgStylesheetList = [];
    // view.pgStylesheet = pgStylesheet;

    this.view = view;

    var $contentContainer = $('<div class="var-content-container"></div>').appendTo($element);

    var updateVarList = function () {
        pgRemoveSpectrum($contentContainer);
        pgRemoveFilePicker($contentContainer);
        pgRemoveMultiselects($contentContainer);

        var oldTop = $element.scrollTop();
        $contentContainer.html('');

        var showVarsFor = function (cs) {
            if (cs.varsPane) {
                cs.varsPane.remove();
                cs.varsPane = null
            }
            var $currVarContainer = $('<div/>').appendTo($contentContainer);
            cs.varsPane = new PgStylesheetVars(cs, $currVarContainer);
            // cs.varsPane.filter = $searchInput.val();
            cs.varsPane.show();
            // pgStylesheetList.push(cs);
        }


        for (var i = 0; i < pgStylesheetList.length; i++) {
            showVarsFor(pgStylesheetList[i]);
        }

        // showVarsFor(pgStylesheet);

        $element.scrollTop(oldTop);
    }


    var setAllStylesheets = function () {
        var addStylesheet = function (cs) {
            pgStylesheetList.push(cs);
        }

        var searchForAllImportedFiles = function (cs) {
            var forAll = function (importedFiles) {
                for (var i = 0; i < importedFiles.length; i++) {
                    var importedFile = importedFiles[i];
                    addStylesheet(importedFile);

                    if (importedFile.importedFiles.length > 0) forAll(importedFile.importedFiles);
                }
            }

            forAll(cs.importedFiles);
        }

        $.each(pinegrow.stylesheets.getAllCrsaStylesheets(), function(i, cs) {
            if (cs.inline || cs.ignore) return true;

            if (cs.compiledFile) cs = cs.sourceStylesheet;

            if (cs.compiledStylesheets.length > 0) {
                cs.compiledStylesheets.forEach(function (compiledStylesheet) {
                    addStylesheet(compiledStylesheet);
                    searchForAllImportedFiles(compiledStylesheet);
                });
            }
        });
    }

    view.whenVisible(function() {
        updateVarList();
    });

    // view.on('crsa-var-updated', function(event) {
    //     view.whenVisible(function() {
    //         updateVarList();
    //     })
    // });

    view.onResize = function() {
        // if (pgStylesheet.varsPane) {
        //     pgStylesheet.varsPane.updateLayout();
        // }

        for (var i = 0; i < pgStylesheetList.length; i++) {
            var pgStylesheet = pgStylesheetList[i];
            if (pgStylesheet.varsPane) {
                pgStylesheet.varsPane.updateLayout();
            }
        }
    }

    view.on('crsa-stylesheets-changed', function(event, obj) {
        view.whenVisible(function() {
            if (obj && obj.by == 'vars') return;
            updateVarList();
        })
    });

    view.onDestroy = function() {
        for (var i = 0; i < pgStylesheetList.length; i++) {
            pgStylesheetList[i].varsPane.remove();
            pgStylesheetList[i].varsPane = null;
        }
        pgStylesheetList = [];
        // pgStylesheet.varsPane.remove();
        // view.pgStylesheet = null;
    }
}