$(function () {

    if(!pgf.class_styles) return;

    var makeSlug = function(name) {
        return pgMakeSlug(name);
    }

    window.PgPropStylesControl = function() {
        this.$element = $('<div class="pg-dm-style-control"></div>');

        var $pills = $('<div class="pg-dm-style-control-pills"></div>').appendTo(this.$element);

        var pills = [];

        $pills.on('click', '.style', function(e) {
            e.preventDefault();
            var $pill = $(this);
            var key = $pill.attr('data-id');
            pinegrow.classStyles.setCurrentStyleByKey(key, true /* remember */);
            //var style = pgDmStore.findStyleByName($pill.attr('data-id'));
            //pgDmStore.setCurrentStyle(style);
            //pgDmStore.rememberSelectedStyleForSelectedElements(style);
        })

        $pills.on('contextmenu', '.style', function(e) {
            e.preventDefault();
            var $el = $(this);
            var key = $el.attr('data-id');
            var style = pinegrow.classStyles.findStyleByKey(key);

            pinegrow.classStyles.showStyleContextMenu(style, $el, e);
            return false;

        })

        $pills.on('click', '.direct', function(e) {
            e.preventDefault();
            var $pill = $(this);
            if(!$pill.hasClass('editing')) {
                pinegrow.classStyles.setCurrentStyleByKey(null, true);
            }
        })

        $pills.on('click', '.remove', function(e) {
            e.preventDefault();
            var $pill = $(this).closest('.style');
            var key = $pill.attr('data-id');
            pinegrow.classStyles.removeStyleFromPgel(pinegrow.classStyles.findStyleByKey(key));
            return false;
        })

        var cancelEdit = function($b) {
            $b.closest('.pg-dm-style-pill').removeClass('editing');
            $b.text('Inline');
            $b.removeAttr('contentEditable');
            //var $ok = $b.find('button');
            //pg$Hide($ok);
        }

        var getScopeHTML = function(scope_style, editing) {
            if(scope_style) {
                return `${scope_style.display_name} <i class="icon icon-right"></i>`;
            } else if(editing) {
                return `<i class="icon icon-279"></i>`;
            } else {
                return null;
            }
        }

        $pills.on('click', '.create-new,.aaapg-dm-style-control-new', function(e) {
            e.preventDefault();

            if(!pinegrow.getCurrentProject()) {
                pinegrow.showQuickError('Styles require a project. Please open the page as a project first.');
                return;
            }
            var $i = $(this).closest('.pg-dm-style-pill');
            var $b = $i.find('span');
            if($b.attr('contentEditable') == 'true') return false;

            $i.addClass('editing');
            $b.text('');
            $b.attr('contentEditable', 'true');
            $b.get(0).focus();
            var $ok = $i.find('button');

            var scope_style = null;

            var pgel = pinegrow.selectedElements.getLastSelected();
            var scopes = pinegrow.classStyles.findParentScopes(pgel);

            var $scope = $i.find('stylescope');
            addTooltip($scope, 'Select scope');

            var updateScope = function() {
                return; //disable for now
                if(scope_style) {
                    $scope.html(getScopeHTML(scope_style));
                    $scope.attr('title', `Sub-style of ${scope_style.display_name}. Click to change to global or select a different parent.`);
                } else {
                    $scope.html(getScopeHTML(null, true));
                    $scope.attr('title', 'Global style. Click to select the parent and create a sub-style.');
                }
                pg$Show($scope, 'inline-flex');
                $b.get(0).focus();
            }

            //Give good default value based on past usage
            scopes.forEach(function(s) {
                if(s.usedAsScope && !scope_style) {
                    scope_style = s;
                }
            })

            updateScope();

            $scope.on('click', function(e) {
                e.preventDefault();
                var a = scopes.map(function(s) {
                    return {
                        label: s.display_name,
                        action: function() {
                            scope_style = s;
                            updateScope();
                        },
                        check: scope_style === s
                    }
                })

                a.splice(0, 0,
                    {
                        label: 'Select style scope',
                        type: 'header'
                    },
                    {
                        label: 'Global style',
                        action: function() {
                            scope_style = null;
                            updateScope();
                        },
                        check: scope_style === null
                    },
                    {
                        type: 'divider'
                    }
                    )

                var m = new CrsaContextMenu(a, $scope);
                m.showForElement($scope);
                return false;
            })
            //pg$Show($ok);

            var create = function() {
                var name = $b.text().trim();

                var key = makeSlug(name);

                closeAllTooltips(100);

                var active_styles = pinegrow.classStyles.getStylesForPgel(pgel);
                var parent_style = active_styles.length ? active_styles[active_styles.length - 1] : null;

                var error = pinegrow.classStyles.validateNameForANewStyle(name, null, parent_style);
                if(error) {
                    pinegrow.showQuickError(error);
                    $b.get(0).focus();
                    return;
                }

                var doCreate = function() {
                    $i.removeClass('editing');

                    //Remember if scope was used
                    scopes.forEach(function(s) {
                        s.usedAsScope = s === scope_style;
                    })

                    pinegrow.classStyles.createStyle(name, parent_style, null, scope_style);


                    //pg$Hide($ok);
                }

                if(pinegrow.classStyles.findDeletedStyleByKey(key)) {
                    pinegrow.showAlert(`<p>A style with the same key <code>${key}</code> was recently deleted but the whole project was not updated yet. The project needs to be updated first.</p>`, 'The project needs to be updated', 'Cancel', 'Update project &amp; Create', function() {
                        cancelEdit($b);
                    }, function() {
                        pinegrow.classStyles.updateProject(function() {
                            doCreate();
                        })
                    })
                    return;
                } else {
                    doCreate();
                }

            }

            $b.on('keydown', function(e) {
                switch(e.key) {
                    case 'Enter':
                        e.preventDefault();
                        create();
                        break;
                    case 'Escape':
                        e.preventDefault();
                        cancelEdit($b)
                        return false;
                        break;
                }
            })

            $ok.on('click', function(e) {
                //$b.attr('contentEditable', '');
                create();
                return false;
            })

            return false;
        })

        $pills.on('click', '.add-style', function(e) {
            e.preventDefault();
            var $i = $(this);

            var addStyle = function() {
                addStyleWithKey(this.data.key);
            }

            var pgel = pinegrow.selectedElements.getLastSelected();
            var active_styles = pinegrow.classStyles.getStylesForPgel(pgel);

            var actions = [
            ]

            var addSubmenu = function(s) {
                if(s.children.length) {
                    var sub = []
                    s.children.forEach(function(cs) {
                        addAction(sub, cs);
                    })
                    return sub;
                } else {
                    return null;
                }
            }

            var addAction = function(actions, s, display_name) {
                actions.push({
                    label: display_name ? s.display_name : s.name,
                    data: s,
                    action: addStyle,
                    check: active_styles.indexOf(s) >= 0,
                    submenu: addSubmenu(s)
                })
            }

            actions.push({
                type: 'header',
                label: 'Options'
            })

            actions.push({
                label: 'Keep inline classes',
                action: function() {
                    var val = pinegrow.getSetting('class-styles-keep-inline', '0') === '1';
                    val = !val;
                    pinegrow.setSetting('class-styles-keep-inline', val ? '1' : '0');
                    pinegrow.showMode('Keep inline classes that are not a part of the assigned style', val);
                },
                check: pinegrow.getSetting('class-styles-keep-inline', '0') === '1',
                helptext: `When assigning the class style, keep existing inline classes that are not a part of the assigned style`
            })

            actions.push({
                type: 'divider'
            })

            var recent = pinegrow.classStyles.getRecentlyUsed();

            if(recent.length) {
                actions.push({
                    type: 'header',
                    label: 'Recently used'
                })
                recent.forEach(function(r) {
                    addAction(actions, r, true);
                })
                actions.push({
                    type: 'divider'
                })
                /*
                actions.push({
                    type: 'header',
                    label: 'All styles'
                })*/
            }

            actions.push({
                type: 'divider'
            })

            actions.push({
                label: 'Show style manager',
                action: function() {
                    pinegrow.showUIPanel('classstyles', false, false, true);
                }
            })

            var all_styles = pinegrow.classStyles.getStyles();

            if(all_styles.length) {
                actions.push({
                    type: 'header',
                    label: 'All styles'
                })

                all_styles.forEach(function (s) {
                    if (s.parent === null) {
                        addAction(actions, s);
                    }
                })
            }

            var menu = new CrsaContextMenu(actions, $i);
            menu.showForElement($i);
            return false;
        })

        var ac = null;
        var ac_mover = null;

        this.show = function(pgel) {
            this.showControl();

            pills = [];
            $pills.get(0).innerHTML = '';

            var html = '';

            var cs = null;//pgDmStore.getCurrentStyle();

            var current = pinegrow.classStyles.getCurrentStyle();
            var styles = pinegrow.classStyles.getStylesForPgel(pgel);

            //html += `<div class="pg-dm-style-pill direct ${current === null ? 'active' : ''}">No style</div>`;

            var first = true;

            styles.forEach(function(style) {
                if(!first) {
                    //html += '<i class="icon icon-right spacer"></i>';
                    //html += '<span class="spacer"> &ndash; </span>';
                }
                html += `<div class="pg-dm-style-pill style ${current === style ? 'active' : ''} ${style.scopeParent ? 'with-scope' : ''}" data-id="${style.key}">`;

                if(style.scopeParent) {
                    html += `<stylescope>${getScopeHTML(style.scopeParent)}</stylescope>`;
                }

                html += `${style.name}<i class="remove icon icon-close"></i></div>`;

                first = false;
               /*
                var pill = new PgClassStylePill(style);
                pills.push(pill);
                $pills.append(pill.$element);
                if(style === cs) {
                    pill.setActive(true);
                }*/
            })

            if(!first) {
                //html += '<span class="spacer"> &ndash; </span>';
                //html += '<i class="icon icon-right spacer"></i>';
            }

            html += `<div class="pg-dm-style-pill direct pg-dm-style-control-new ${current === null ? 'active' : ''}">`;

            if(first) {
                html += `<stylescope style="display:none;"></stylescope>`;
            }
            html += `<span>Inline</span><i class="icon icon-Editable create-new"></i><button style="" class="pg-button">Ok</button></div>`

            html += '<div class="add-style"><i class="icon icon-down"></i></div>';

            //html += '<div class="add-style-field"></div>';

            $pills.get(0).innerHTML = html;

            addTooltip($pills.find('.create-new'), `Create a new ${styles.length ? 'substyle' : 'style'}.`);

            addTooltip($pills.find('.remove'), `Remove the style from the selected element.`);

            addTooltip($pills.find('.direct button'), `Click or ${pgShowKbd('Enter')} to create, ${pgShowKbd('Esc')} to cancel.`);

            /*
            var $field_c = $pills.find('.add-style-field');

            ac && ac.remove();
            ac_mover && ac_mover.destroy();

            var ac = PgAutoComplete($field_c, {
                mode: 'input',
                getItems: function() {
                    return pinegrow.classStyles.getStyles().slice(0);
                },
                openListOnFocus: true,
                fillListOnOpen: true,
                onDropdownOpen: function($list) {
                    ac_mover = new PgArrowsMover(ac.$input, $list, 'li');

                    ac_mover.onEnter = function($item) {
                        var key = $item.attr('data-key');
                        ac.$input.val(key);
                        ac.$input.trigger('change');
                    }
                },
                onDropdownClose: function() {
                    ac_mover.destroy();
                    ac_mover = null;
                }
            });

            ac.$input.on('change', function(e) {
                addStyleWithKey(ac.$input.val());
                //ac.remove();
                //ac = null;
            })
            */
        }

        var shown = true;

        this.showControl = function() {
            if(!shown) {
                pg$Show(this.$element)
                shown = true;
            }
        }

        this.hideControl = function() {
            if(shown) {
                pg$Hide(this.$element)
                shown = false;
            }
        }

        var addStyleWithKey = function(key) {
            var style = pinegrow.classStyles.findStyleByKey(key);
            if(!style) {
                pinegrow.showQuickError(`Style <b>${key}</b> does not exist.`);
            } else {
                pinegrow.classStyles.assignStyle(style, null, pinegrow.getSetting('class-styles-keep-inline', '0') === '1');
            }
        }
    }

    var PgClassStylePill = function(style) {

        this.$element = $(`<div class="pg-dm-style-pill" data-id="${style.key}">${style.name}</div>`);
    }

    PgClassStylePill.prototype.setActive = function(a) {
        if(a) {
            this.$element.addClass('active');
        } else {
            this.$element.removeClass('active');
        }
    }


    var sortStyleList = function(list) {
        list.sort(function(a, b) {
            if(a.scopeParent && !b.scopeParent) {
                return 1;
            } else if(!a.scopeParent && b.scopeParent) {
                return -1;
            } else {
                return a.name.localeCompare(b.name);
            }
        })
    }

    window.PgClassStyle = function(name_or_node) {
        this.children = [];
        this.parent = null; //for variant sub styles
        this.scopeParent = null; //for scoped sub styles
        this.level = 0;
        this.expanded = false;
        this.locked = false;
        this.count = 0;
        this.deleted = false;

        if(name_or_node instanceof pgParserNode) {
            this.db_node = name_or_node;
            this.updateFromNode();
        } else {
            this.name = this.display_name = name_or_node;
            this.key = makeSlug(this.name);
            this.classes = [];
            this.db_node = null;
        }
    }

    PgClassStyle.prototype.updateFromNode = function() {
        this.key = this.db_node.getAttr('key');
        this.name = this.display_name = this.db_node.getAttr('name');
        this.classes = (this.db_node.getAttr('class') || '').split(/\s+/).filter(function(v) {
            return v.length > 0;
        });
        this.expanded = this.db_node.hasAttribute('expanded');
        this.locked = this.db_node.hasAttribute('locked');
        this.count = parseInt(this.db_node.getAttribute('count') || '0');
    }

    PgClassStyle.prototype.updateToNode = function(db) {
        if(!this.db_node) {
            this.db_node = db.createNode('classstyle', {
            }, false)
        }
        this.db_node.setAttr('key', this.key);
        this.db_node.setAttr('name', this.name);
        this.db_node.setAttr('class', this.classes.join(' '))
        this.expanded ? this.db_node.setAttribute('expanded', null) : this.db_node.removeAttribute('expanded');
        this.locked ? this.db_node.setAttribute('locked', null) : this.db_node.removeAttribute('locked');
        this.db_node.setAttribute('count', this.count);
    }



    PgClassStyle.prototype.destroy = function() {
        this.db_node = null;
    }

    PgClassStyle.prototype.setParent = function(p, sort) {
        this.parent = p;
        if(p) {
            p.children.push(this);
            if(sort) {
                sortStyleList(p.children);
            }
        }
    }

    PgClassStyle.prototype.setScopeParent = function(p, sort) {
        this.scopeParent = p;
        if(p) {
            p.children.push(this);
            if(sort) {
                sortStyleList(p.children);
            }
        }
    }

    PgClassStyle.prototype.updateKeyAndDisplayName = function() {
        this.key = makeSlug(this.name);
        this.display_name = this.name;

        if(this.parent) {
            this.display_name = this.parent.display_name + ' - ' + this.name;
            this.key = this.parent.key + '.' + this.key;

        } else if(this.scopeParent) {
            this.display_name = this.scopeParent.display_name + ' &gt; ' + this.name;
            this.key = this.scopeParent.key + ':' + this.key;
        }
    }

    PgClassStyle.prototype.remove = function(p) {
        if(this.parent) {
            var idx = this.parent.children.indexOf(this);
            if(idx >= 0) {
                this.parent.children.splice(idx, 1);
                this.parent = null;
            }
        }
        this.db_node.remove();
        this.deleted = true;
    }

    PgClassStyle.prototype.getClasses = function() {
        return this.classes;
    }

    PgClassStyle.prototype.hasClass = function(cls) {
        return this.classes.indexOf(cls) >= 0;
    }

    PgClassStyle.prototype.addClass = function(cls) {
        var idx = this.classes.indexOf(cls);
        if(idx < 0) {
            this.classes.push(cls);
        }
        if(this.db_node) {
            this.db_node.setAttribute('class', this.classes.join(' '));
        }
    }

    PgClassStyle.prototype.removeClass = function(cls) {
        var idx = this.classes.indexOf(cls);
        if(idx >= 0) {
            this.classes.splice(idx, 1);
        }
        if(this.db_node) {
            this.db_node.setAttribute('class', this.classes.join(' '));
        }
    }

    PgClassStyle.prototype.setExpanded = function(val) {
        this.expanded = val;
        this.db_node.withoutEvents(function() {
            val ? this.setAttribute('expanded', null) : this.removeAttribute('expanded');
        })
    }

    PgClassStyle.prototype.setLocked = function(val) {
        this.locked = val;
        this.db_node.withoutEvents(function() {
            val ? this.setAttribute('locked', null) : this.removeAttribute('locked');
        })
    }

    PgClassStyle.prototype.setUsageCount = function(val) {
        var _this = this;
        this.count = val;
        this.db_node.withoutEvents(function() {
            this.setAttribute('count', _this.count);
        });
    }

    var PgClassStylesManager = function() {

        var _this = this;

        var db = null;

        var data_pg_styles = 'data-pg-class-style';
        var data_pg_inline = 'data-pg-class-style-inline';

        var delayedTasks = new PgDelayedTasks();

        var class_to_prop_map = {}

        this.addClassToPropMap = function(map) {
            $.each(map, function(cls, prop) {
                class_to_prop_map[cls] = prop;
            })
        }

        var addClassToList = function (classes, cls, prop_map, class_to_prop_map) {
            var prop = class_to_prop_map[cls] || null;
            if (prop) {
                //already set?
                if (prop_map[prop] && prop_map[prop] !== cls) {
                    var idx = classes.indexOf(prop_map[prop]);
                    if (idx >= 0) {
                        classes.splice(idx, 1);
                    }
                }
                prop_map[prop] = cls;
            }
            var idx = classes.indexOf(cls);
            if (idx < 0) {
                classes.push(cls);
            }
        }

        //return list of style keys for parent and substyles
        var getStylesStackKeys = function(combo) {
            var a = combo.split('.');
            var r = [];
            var key = null;
            for(var i = 0; i < a.length; i++) {
                key = (i === 0 ? '' : (key + '.')) + a[i];
                r.push(key);
            }
            return r;
        }

        var getClassesForStyle = function(style) {
            var classes = [];
            var prop_map = {};

            var list = getStylesStackKeys(style.key);

            for(var i = 0; i < list.length; i++) {
                var s = list[i];
                var def = getStyleDef(s);
                if (!def) {
                    //unknown style, abort
                } else {
                    def.getClasses().forEach(function (cls) {
                        addClassToList(classes, cls, prop_map, class_to_prop_map);
                    })
                }
            }
            return classes;
        }

        var applyStyles = function (pgel, page, count) {
            var styles = pgel.getAttr(data_pg_styles);
            if (styles) {
                //page = page || pgel.getPage();

                //var class_to_prop_map = page.classStylesClassToPropMap || {};

                var classes = [];

                var prop_map = {};

                //var list = styles.split(/\s+/);

                var list = getStylesStackKeys(styles.trim());

                for(var i = 0; i < list.length; i++) {
                    var s = list[i];
                    var def = getStyleDef(s);
                    if (!def) {
                        //unknown style, abort
                        //return false;
                    } else {
                        def.getClasses().forEach(function (cls) {
                            addClassToList(classes, cls, prop_map, class_to_prop_map);
                        })
                        if(count) def.count++;
                    }
                }

                var inline = pgel.getAttr(data_pg_inline);
                if (inline) {
                    inline.split(/\s+/).forEach(function (cls) {
                        if(cls.length) {
                            addClassToList(classes, cls, prop_map, class_to_prop_map);
                        }
                    })
                }

                var orig_classes = pgel.getAttr('class') || '';
                var new_classes = classes.join(' ');

                if (orig_classes !== new_classes) {
                    if (new_classes) {
                        pgel.setAttr('class', new_classes);
                    } else {
                        pgel.removeAttr('class');
                    }
                    return true; //changed
                }
            } else {
                //if it has inline classes, let's move them to class
                var changed = false;

                if(pgel.hasAttribute(data_pg_styles)) {
                    pgel.removeAttribute(data_pg_styles);
                    changed = true;
                }
                if(pgel.hasAttr(data_pg_inline)) {
                    var inline = pgel.getAttr(data_pg_inline);
                    inline ? pgel.setAttr('class', inline) : pgel.removeAttribute('class');
                    pgel.removeAttribute(data_pg_inline);
                    changed = true;
                }
                return changed;
            }
            return false; //not changed
        }

        var applyStylesOnPage = this.applyStylesOnPage = function(page, style, skip_pgel, count) {
            var changed = false;

            page.sourceNode.walk(function(pgel) {
                if(pgel.isElement && pgel !== skip_pgel) {
                    if(pgel.hasAttr(data_pg_inline) || pgel.hasAttr(data_pg_styles)) {
                        if(style) {
                            var styles = _this.getStylesForPgel(pgel);
                            if(styles.indexOf(style) >= 0) {
                                changed = applyStyles(pgel, page, count) || changed;
                            }
                        } else {
                            changed = applyStyles(pgel, page, count) || changed;
                        }
                    }
                }
                return true;
            })

            return changed;
        }

        var applyStylesOnAllOpenPages = function(style, skip_pgel) {
            pinegrow.getAllPages().forEach(function(page) {
                if(useClassStylesOnPage(page)) {
                    if(applyStylesOnPage(page, style, skip_pgel)) {
                        //changed, do something
                    }
                }
            })
        }

        this.resetUsageCounts = function() {
            styles.forEach(function(s) {
                s.count = 0;
            })
        }

        this.rememberUsageCounts = function() {
            styles.forEach(function(s) {
                s.setUsageCount(s.count)
            })
        }

        var changed_styles_list = []

        var triggerStylesChanged = function(list, delayed) {
            list.forEach(function(s) {
                var idx = changed_styles_list.indexOf(s);
                if(idx < 0) {
                    changed_styles_list.push(s);
                }
            })

            if(delayed) {
                delayedTasks.run('classStylesTriggerChanged', function() {
                    pinegrow.dispatchEvent('on_class_styles_changed', null, changed_styles_list);
                    changed_styles_list = [];
                }, 100)
            } else {
                delayedTasks.cancel('classStylesTriggerChanged');
                pinegrow.dispatchEvent('on_class_styles_changed', null, changed_styles_list);
                changed_styles_list = [];
            }
        }

        var styleWasChanged = function(pgel, just_pgel, style) {
            style = style || current_style;
            if(just_pgel) {
                applyStyles(pgel);
            } else {
                if(!style) {
                    applyStyles(pgel);
                } else {
                    //applyStylesOnAllOpenPages(current_style);
                    applyStyles(pgel);
                    apply_changes_on_next_change_done = pgel;
                }
            }
            if(style) {
                triggerStylesChanged([style], true)
            }
            db.is_changed = true; //need this so that the db gets saved on changes
        }

        var current_style = null;
        var apply_changes_on_next_change_done = null;

        var styles = [];
        var styles_map = {}

        var getStyleDef = function(key) {
            if(!key) return null;
            return styles_map[key] || null;
        }


        this.getStyles = function() {
            return styles;
        }

        this.findStyleByKey = function(key) {
            return getStyleDef(key);
        }

        this.findStyleByName = function(name, parent_style) {
            name = name.toLowerCase();
            for(var i = 0; i < styles.length; i++) {
                if(styles[i].name.toLowerCase() === name && (!parent_style || styles[i].parent === parent_style)) {
                    return styles[i]
                }
            }
            return null;
        }

        this.findDeletedStyleByKey = function(key) {
            var db_styles = db.getDBNode('classstyles');
            if(!db_styles) return null;
            return db_styles.findOne(`deleted[key="${key}"]`);
        }

        var last_locked = false;
        var last_expanded = false;

        this.setLastLocked = function(v) {
            last_locked = v;
        }

        this.setLastExpanded = function(v) {
            last_expanded = v;
        }

        this.validateNameForANewStyle = function(name, my_style, parent_style) {
            if(!name) {
                return 'Style name can not be empty.';
            }
            if(!name.match(/^[a-z0-9\s_]+$/i)) {
                return `Style name can only contain letters, numbers, _ and spaces.`
            }
            if(this.findStyleByName(name, parent_style)) {
                return `Style ${name} already exists!`;
            }
            var key = makeSlug(name);

            if(parent_style) {
                key = parent_style.key + '.' + key;
            }
            var style = this.findStyleByKey(key)
            if(style && (!my_style || style !== my_style)) {
                return `Style with the id ${key} already exists!`;
            }
            return null;
        }

        this.findParentScopes = function(pgel) {
            var r = [];
            var p = pgel.parent;
            while(p !== null) {
                var styles = _this.getStylesForPgel(p);
                if(styles.length) {
                    r.push(styles[0]);
                }
                p = p.parent;
            }
            return r;
        }

        this.getStyleScope = function(style) {
            var a = style.key.split(':');
            if(a.length > 1) {
                return this.findStyleByKey(a[0]);
            }
            return null;
        }

        this.createStyle = function(name, parent_style, done, scope_style) {

            pinegrow.requireProjectDB(function(db) {
                var pgel = pinegrow.selectedElements.getLastSelected();
                var pgel_styles = _this.getStylesForPgel(pgel);

                var classes;

                if(pgel_styles.length) {
                    classes = (pgel.getAttr(data_pg_inline) || '').split(/\s+/).filter(function(v) {
                        return v.length > 0;
                    });
                } else {
                    classes = pgel.getClasses().slice(0);
                }

                var s = new PgClassStyle(name);
                s.classes = classes;

                if(parent_style) {
                    //s.key = parent_style.key + '.' + s.key;
                    s.setParent(parent_style, true /* sort */);
                    //s.display_name = parent_style.display_name + ' - ' + s.name;
                }

                if(scope_style) {
                    //s.key = scope_style.key + ':' + s.key;
                    s.setScopeParent(scope_style);
                }

                s.updateKeyAndDisplayName();

                styles.push(s);
                styles_map[s.key] = s;

                var db_styles = db.getDBNode('classstyles');
                var db_style = db.createNode('classstyle', {
                    name: s.name,
                    key: s.key,
                    'class': s.classes.join(' ')
                }, false)

                s.db_node = db_style;

                //s.setLocked(last_locked);
                s.setExpanded(last_expanded);

                if(parent_style) {
                    parent_style.db_node.append(db_style);
                    s.level = parent_style.level + 1;
                } else {
                    if(scope_style) {
                        scope_style.db_node.append(db_style);
                        s.level = scope_style.level + 1;
                    } else {
                        db_styles.append(db_style);
                    }
                }
                db.changed(new PgCollection(db_styles), {
                    source: 'class_styles'
                }); //todo

                //db.save();

                updateFlatStylesList(true);

                triggerStylesChanged([s]);

                pgel.removeAttr(data_pg_inline);

                _this.assignStyle(s, 'Create style ');

                done && done(s);
            })
        }

        var recent = [];
        var max_recent = 4;

        this.getRecentlyUsed = function() {
            var r = [];
            recent.forEach(function(key) {
                var s = getStyleDef(key)
                s && r.push(s)
            })
            return r;
        }

        var assignStyleInternal = function(pgel, style, keep_inline) {
            var defs = _this.getStylesForPgel(pgel);

            var idx = defs.indexOf(style);
            if (idx < 0) {
                defs.push(style);
            }

            //just one
            defs = [style];

            var inline = [];

            if(keep_inline) {
                //keep inline classes that are not set in the style as inline classes
                var style_classes = style.getClasses();

                var classes;

                if(pgel.hasAttribute(data_pg_styles)) {
                    classes = getInlineClasses(pgel);
                } else {
                    classes = pgel.getClasses();
                }

                classes.forEach(function(cls) {
                    if(style_classes.indexOf(cls) < 0) {
                        inline.push(cls);
                    }
                })
            }

            if(inline.length) {
                pgel.setAttribute(data_pg_inline, inline.join(' '));
            }

            pgel.setAttribute(data_pg_styles, defs.map(function (s) {
                return s.key;
            }).join(' '));

            style.count++;
            applyStyles(pgel);
        }

        this.assignStyle = function(style, action_name, keep_inline) {
            var idx = recent.indexOf(style.key);
            if(idx >= 0) {
                recent.splice(idx, 1)
            }
            if(recent.length >= max_recent) {
                recent.pop();
            }
            recent.unshift(style.key);

            var col = pinegrow.getCollection();

            if(col.getLength()) {
                pinegrow.makeChanges(col, (action_name || 'Assign style ') + style.display_name, function () {
                    col.forEachElement(function (pgel) {
                        assignStyleInternal(pgel, style, keep_inline)
                    })
                })
            }
            pinegrow.classStyles.setCurrentStyle(style, true); //will trigger event and update
        }

        var removeStyleFromPgelInternal = function(pgel, style, defs, leave_classes) {
            var idx = defs.indexOf(style);
            if(idx >= 0) {
                defs.splice(idx, defs.length - idx)
            }
            if(defs.length) {
                pgel.setAttribute(data_pg_styles, defs[defs.length - 1].key);
            } else {
                pgel.removeAttribute(data_pg_styles);
            }
            if(!leave_classes) {
                pgel.removeAttribute('class');
            } else {
                pgel.removeAttribute(data_pg_inline);
            }
            (style.count > 0) && style.count--;
            applyStyles(pgel);
        }

        this.removeStyleFromPgel = function(style, leave_classes) {

            var col = pinegrow.getCollection();

            var next_style = null;

            pinegrow.makeChanges(col, ('Remove style ') + style.display_name, function() {
                col.forEachElement(function(pgel, i, total) {
                    var defs = _this.getStylesForPgel(pgel);

                    removeStyleFromPgelInternal(pgel, style, defs, leave_classes);

                    if(i === total - 1) {
                        //last
                        next_style = defs.length ? defs[defs.length - 1] : null
                    }
                })
            })

            if(style === current_style) {
                _this.setCurrentStyleByKey(next_style, true);
            } else {
                _this.setCurrentStyleByKey(current_style, true);//trigger update
            }
        }

        var removeStyleFromPageByKey = function(page, key, leave_classes) {
            var changed = false;
            var re = new RegExp(`^${escapeRegExp(key)}(\.|$)`);
            var a = key.split('.');

            page.sourceNode.walk(function(pgel) {
                if(pgel.isElement) {
                    var styles = pgel.getAttribute(data_pg_styles);
                    if(styles) {
                        styles = styles.trim();
                        if(styles.match(re)) {

                            var b = styles.split('.');
                            //text.big.red len=3
                            //remove text.big.red
                            // -> text.big

                            b.splice(a.length - 1, b.length - a.length + 1);

                            if(b.length === 0) {
                                pgel.removeAttribute(data_pg_styles);
                            } else {
                                pgel.setAttribute(data_pg_styles, b.join('.'));
                            }
                            if(!leave_classes) {
                                pgel.removeAttribute('class');
                            }

                            applyStyles(pgel, page);
                            changed = true;
                        }
                    }
                }
                return true;
            })
            return changed;
        }

        var saveDBIfOnlyProjectOpen = function() {
            if(pinegrow.getAllPages().length === 0 && isApp()) {
                db && db.save();
            }
        }

        this.addStyleToMatchingElements = function(style, page) {

            var col = new PgCollection();

            var classes = getClassesForStyle(style);

            var map = {}

            classes.forEach(function(cls) {
                map[cls] = true;
            })

            if(classes.length === 0) {
                pinegrow.showQuickError('The style does not have any properties.');
                return null;
            }

            var hasSameClasses = function(pgel) {
                var list = pgel.getClasses();
                if(list.length !== classes.length) return false;

                for(var i = 0; i < list.length; i++) {
                    if(!map[list[i]]) return false;
                }
                return true;
            }

            page.sourceNode.walk(function(pgel) {
                if(pgel.isElement) {
                    if(hasSameClasses(pgel)) {
                        col.add(pgel)
                    }
                }
                return true;
            })

            if(col.getLength() === 0) {
                pinegrow.showQuickError('No elements with the same properties as the style were found.');
                return null;
            }

            pinegrow.makeChanges(col, `Add ${style.display_name} to matched`, function() {
                col.forEachElement(function(pgel) {
                    assignStyleInternal(pgel, style)
                })
            })

            pinegrow.showQuickMessage(`Style ${style.display_name} was added to ${col.getLength()} element${col.getLength() > 1 ? 's' : ''} on the page.`);
            return col;
        }

        this.deleteStyle = function(style, leave_classes) {
            var style_col = new PgCollection(style.db_node);

            var changed = []

            var remove = [];

            pinegrow.requireProjectDB(function(db) {
                pinegrow.makeChanges(style.db_node.getPage(), ('Delete style ') + style.display_name, function () {
                    var db_styles = db.getDBNode('classstyles');

                    var deleteStyle = function(style) {
                        var deleted = db.createNode('deleted', {
                            key: style.key,
                        }, false)


                        leave_classes && deleted.setAttribute('leave-classes');
                        db_styles.append(deleted);

                        style_col.add(deleted);
                        style_col.add(style.db_node);

                        remove.push(style);

                        style.children.forEach(deleteStyle);

                        changed.push(style);
                    }

                    deleteStyle(style);

                    db.changed(style_col, {
                        source: 'class_styles'
                    })

                    pinegrow.getAllPages().forEach(function(page) {
                        if(useClassStylesOnPage(page)) {
                            removeStyleFromPageByKey(page, style.key, leave_classes);
                        }
                    })

                    remove.forEach(function(style) {
                        var idx = styles.indexOf(style);
                        (idx >= 0) && styles.splice(idx, 1);

                        style.remove();
                    })
                    updateFlatStylesList(false);
                })

                triggerStylesChanged(changed);

                saveDBIfOnlyProjectOpen();

                pinegrow.showQuickMessage(`Style <b>${style.display_name}</b> was deleted. Use Undo to restore. Update the whole project to apply to all pages.`)
            })

            pinegrow.selectedElements.reselect();
        }

        this.duplicateStyle = function(style, new_name, mode_with, mode_as, done) {
        /*

            bubi -> koli, create new with same classes
            bubi.misko -> bubi.koli -> same

            bubi -> koli, bubi.misko -> koli.misko

            forStyleAndSubstyles do duplicate

             */
            var list = []
            var ns;

            pinegrow.makeChanges(style.db_node, `Duplicate style ${style.display_name}`, function() {

                var col = new PgCollection();

                var db_styles = db.getDBNode('classstyles');

                ns = new PgClassStyle(new_name);

                if(mode_as === 'as_substyle') {
                    ns.setParent(style.parent);
                    ns.classes = style.classes.slice(0);
                } else {
                    ns.setParent(null);
                    ns.classes = getClassesForStyle(style)
                }
                ns.updateKeyAndDisplayName();
                ns.updateToNode(db);

                (ns.parent ? ns.parent.db_node : db_styles).append(ns.db_node);

                col.add(ns.db_node.parent);
                col.add(ns.db_node);

                styles.push(ns);
                list.push(ns);

                var np = ns;

                var duplicateChild = function(cs, np) {

                    var ncs = new PgClassStyle(cs.name);
                    ncs.classes = cs.classes.slice(0);
                    ncs.setParent(np);
                    ncs.updateKeyAndDisplayName();
                    ncs.updateToNode(db);

                    cs.children.forEach(function(s) {
                        duplicateChild(s, ncs);
                    });

                    np.db_node.append(ncs.db_node);
                    col.add(ncs.db_node);

                    styles.push(ncs);
                    list.push(ncs);
                }

                if(mode_with === 'with_substyles') {

                    style.children.forEach(function (cs) {
                        duplicateChild(cs, np)
                    })
                }

                db.changed(col, {
                    source: 'class_styles'
                })

                updateFlatStylesList(true);

                saveDBIfOnlyProjectOpen();
            })

            triggerStylesChanged(list);

            done && done(ns);

            return ns;

        }


        this.renameStyle = function (style, new_name, done) {
            var style_col = new PgCollection(style.db_node);

            pinegrow.requireProjectDB(function (db, project) {

                var old_key = style.key;
                style.name = style.display_name = new_name;

                var changed = [];

                var updateStyle = function (style) {
                    /*
                    style.key = (style.parent ? (style.parent.key + '.') : '') + makeSlug(style.name);

                    if (style.parent) {
                        style.display_name = style.parent.display_name + ' - ' + style.name;
                    }
                    */
                    style.updateKeyAndDisplayName();

                    style.db_node.setAttr('key', style.key);
                    style.db_node.setAttr('name', style.name);

                    changed.push(style)

                    style.children.forEach(updateStyle);
                }

                updateStyle(style);

                updateFlatStylesList(true);

                var re = new RegExp(`^${escapeRegExp(old_key)}(\.|$)`, 'i');

                //_this.resetUsageCounts();
                style.count = 0;

                project.forEachEditableFile(function (page, pageDone, status) {

                    //status.changed = _this.applyStylesOnPage(page, null, null, true) || status.changed;
                    pinegrow.undoManager.getActiveHistory().ignore(function () {

                        status.skip_refresh = true;

                        page.sourceNode.walk(function (pgel) {
                            if (pgel.isElement) {
                                var styles = pgel.getAttr(data_pg_styles);
                                if (styles && styles.match(re)) {
                                    styles = styles.replace(re, `${style.key}$1`);
                                    pgel.setAttribute(data_pg_styles, styles);
                                    status.changed = true;
                                    status.save = true;
                                    style.count++;
                                }
                            }
                            return true;
                        })
                    })
/*
                    if (status.changed) {
                        page.save();
                    }*/
                    pageDone(page, status);

                }, function () {
                    //on done
                    _this.rememberUsageCounts();

                    pinegrow.undoManager.getActiveHistory().changeDone(`Rename style to ${style.display_name}`, null, 'class_styles', {}, 'Project (no undo)');

                    db.changed(style_col, {
                        source: 'class_styles'
                    })

                    isApp() && db.save();

                    pinegrow.selectedElements.reselect();

                    //cut forward undo histories

                    triggerStylesChanged(changed)

                    done && done();
                }, 'Renaming style...')

            })
        }

        this.setCurrentStyle = function(style, remember, source) {
            current_style = style

            if(remember) {
                pinegrow.getCollection().forEachElement(function(pgel) {
                    pgel._rememberCurrentClassStyle = current_style ? current_style : 'direct';
                })
            }
            var info = {
                source: source || 'none'
            }
            pinegrow.dispatchEvent('on_current_class_style_changed', pinegrow.getSelectedPage(), current_style, info);
        }

        this.setCurrentStyleByKey = function(key, remember, source) {
            this.setCurrentStyle( getStyleDef(key), remember, source);
        }

        this.getCurrentStyle = function() {
            return current_style;
        }

        this.getStylesForPgel = function(pgel) {
            var r = [];
            var styles = pgel.getAttr(data_pg_styles);
            if (styles) {

                var list = getStylesStackKeys(styles);

                //var list = styles.split(/\s+/);
                list.forEach(function(s) {
                    var def = getStyleDef(s);
                    if (!def) {
                        //unknown style
                    } else {
                       r.push(def);
                    }
                })
            }
            return r;
        }

        this.getInlineClassesForPgel = function(pgel) {
            return (pgel.getAttr(data_pg_inline) || '').split(/\s+/).filter(function(v) {
                return v.length > 0;
            });
        }

        this.ensureStyleWithClassIsSelected = function(pgel, cls) {
            var page = pgel.getPage();

            if(useClassStylesOnPage(page)) {
                var styles = pinegrow.classStyles.getStylesForPgel(pgel);
                if (styles.length) {
                    var style = null;

                    //check inline
                    if (pinegrow.classStyles.getInlineClassesForPgel(pgel).indexOf(cls) >= 0) {

                    } else {
                        //has styles, select the correct style if needed
                        for (var i = styles.length - 1; i >= 0; i--) {
                            if (styles[i].getClasses().indexOf(cls) >= 0) {
                                //this is the style
                                style = styles[i];
                                break;
                            }
                        }
                    }
                    if (style !== pinegrow.classStyles.getCurrentStyle()) {
                        pinegrow.classStyles.setCurrentStyle(style, true, 'click_on_class');
                    }
                }
            }
        }

        this.isStyleOnPgel = function(pgel, style) {
            var list = this.getStylesForPgel(pgel);
            return list.indexOf(style) >= 0;
        }

        this.updateUsageCounts = function(done) {
            pinegrow.requireProjectDB(function(db, project) {

                _this.resetUsageCounts();

                project.forEachEditableFile(function (page, pageDone, status) {

                    page.sourceNode.walk(function(pgel) {
                        if(pgel.isElement) {
                            _this.getStylesForPgel(pgel).forEach(function(s) {
                                s.count++;
                            })
                        }
                        return true;
                    })
                    pageDone(page, status);

                }, function () {
                    //on done
                    _this.rememberUsageCounts();
                    done && done();
                }, 'Updating usage counts...')
            })
        }

        this.updateProject = function(done) {
            pinegrow.requireProjectDB(function(db, project) {

                _this.resetUsageCounts();

                var db_styles = db.getDBNode('classstyles');
                var deleted = db_styles.find('deleted');

                project.forEachEditableFile(function (page, pageDone, status) {

                    deleted.forEach(function(n) {
                        var key = n.getAttribute('key');
                        if(key) {
                            status.changed = removeStyleFromPageByKey(page, key, n.hasAttribute('leave-classes')) || status.changed;
                        }
                    })

                    status.changed = _this.applyStylesOnPage(page, null, null, true) || status.changed;
                    if(status.changed) {
                        status.save = true;
                    }
                    pageDone(page, status);

                }, function () {
                    //on done
                    _this.rememberUsageCounts();

                    deleted.forEach(function(n) {
                        n.remove();
                    })
                    isApp() && project.db.save();
                    done && done();
                }, 'Updating styles...')
            })
        }

        var getCurrentStyleForPgel = this.getCurrentStyleForPgel = function(pgel) {
            var s = null;

            if(!pgel) {
                return null;
            }

            if(pgel._rememberCurrentClassStyle && pgel._rememberCurrentClassStyle === 'direct') {
                s = null;
            } else {
                var styles = _this.getStylesForPgel(pgel);
                if (styles.length) {
                    if (pgel._rememberCurrentClassStyle && styles.indexOf(pgel._rememberCurrentClassStyle) >= 0) {
                        s = pgel._rememberCurrentClassStyle;
                    } else {
                        s = styles[0];
                    }
                } else {
                    s = null;
                }
            }
            return s;
        }

        //top level functions for class styles manipulation (without change event and checking)
        this.addClassToStyle = function(pgel, style, cls, remove_cls) {
            if(style) {
                if (remove_cls) {
                    style.removeClass(remove_cls);
                }
                style.addClass(cls);
                styleWasChanged(pgel, null, style);
            } else {
                //inline class
                if(remove_cls) {
                    removeInlineClass(pgel, remove_cls)
                }
                addInlineClass(pgel, cls);
                applyStyles(pgel);
            }
        }

        this.removeClassFromStyle = function(pgel, style, remove_cls) {
            if(style) {
                style.removeClass(remove_cls);
                styleWasChanged(pgel, null, style);
            } else {
                //inline class
                removeInlineClass(pgel, remove_cls)
                applyStyles(pgel);
            }
        }

        //class setters
        var getInlineClasses = function(pgel) {
            return (pgel.getAttr(data_pg_inline) || '').split(/\s+/).filter(function(v) {
                return v.length > 0;
            });
        }

        var setInlineClasses = function(pgel, r) {
            if(r.length) {
                pgel.setAttr(data_pg_inline, r.join(' '));
            } else {
                pgel.removeAttribute(data_pg_inline);
            }
        }

        var addInlineClass = function(pgel, cls) {
            var r = getInlineClasses(pgel);
            var idx = r.indexOf(cls);
            if(idx < 0) {
                r.push(cls);
            }
            setInlineClasses(pgel, r);
        }

        var removeInlineClass = function(pgel, cls) {
            var r = getInlineClasses(pgel);
            var idx = r.indexOf(cls);
            if(idx >= 0) {
                r.splice(idx, 1);
            }
            setInlineClasses(pgel, r);
        }

        this.hasClass = function(pgel, cls) {
            if(typeof cls === 'string' && cls.length) {
                if(current_style) {
                    return current_style.hasClass(cls);
                } else {
                    if(pgel.getAttr(data_pg_styles)) {
                        var inline = pgel.getAttribute(data_pg_inline) || '';
                        return (' ' + inline + ' ').indexOf(' ' + cls + ' ') >= 0;
                    } else {
                        return pgel.hasClass(cls);
                    }
                }
            } else {
                return false;
            }
        }

        //optimize apply class, addClass and such can be called in batches...

        this.addClass = function(pgel, cls, sorter) {
            if(typeof cls === 'string' && cls.length) {
                if (current_style) {
                    current_style.addClass(cls);
                    //applyStyles(pgel);
                    styleWasChanged(pgel);
                } else {
                    if (pgel.getAttr(data_pg_styles)) {
                        //has styles, we need to set inline styles
                        addInlineClass(pgel, cls);
                        //applyStyles(pgel);
                        styleWasChanged(pgel, true);
                    } else {
                        pgel.addClass(cls, sorter);
                    }
                }
            }
        }

        this.removeClass = function(pgel, cls, sorter) {
            if(typeof cls === 'string' && cls.length) {
                if(current_style) {
                    current_style.removeClass(cls);
                    //applyStyles(pgel);
                    styleWasChanged(pgel);
                } else {
                    if(pgel.getAttr(data_pg_styles)) {
                        //has styles, we need to edit inline styles
                        removeInlineClass(pgel, cls);
                        styleWasChanged(pgel, true);
                        //applyStyles(pgel);
                    } else {
                        pgel.removeClass(cls, sorter);
                    }
                }
            }
        }

        this.canRemoveClass = function(pgel, cls) {
            return true;//
            //return pgel.canRemoveClass(cls);
        }

        this.getClasses = function(pgel) {
            if(current_style) {
                return current_style.getClasses();
            } else {
                var inline = pgel.getAttr(data_pg_inline);
                if(inline !== null) {
                    return inline.split(/\s+/).filter(function(v) {
                        return v.length > 0;
                    });
                } else {
                    return pgel.getClasses();
                }
            }
        }

        //end of class setters
        var useClassStylesOnPage = function(page) {
            return (page && page.classSetter === _this);
        }

        var projectHasClassStyles = function() {
            return _this.getStyles().length > 0;
        }

        var updateStylesFromDB = function() {

            if(!db) return;

            var dbnode_to_style_map = new WeakMap();

            styles.forEach(function(s) {
                s.destroy();
            })

            styles = [];
            styles_map = {}

            var db_styles = db.findOne('> classstyles');

            if(db_styles) {
                db_styles.find('classstyle').forEach(function(node) {
                    var s = new PgClassStyle(node)
                    styles.push(s);
                    styles_map[s.key] = s;
                    dbnode_to_style_map.set(node, s);

                    if(node.parent.tagName === 'classstyle') {
                        var pn = dbnode_to_style_map.get(node.parent);

                        //Is this variant or scoped substyle?
                        if(s.key.startsWith(pn.key + ':')) {
                            //Scoped
                            s.setScopeParent(pn);
                            s.level = pn.level + 1;
                            //s.display_name = pn.display_name + ': ' + s.name;
                        } else {
                            //Variant
                            s.setParent(pn);
                            s.level = pn.level + 1;
                            //s.display_name = s.parent.name + ' - ' + s.name;
                        }

                        s.updateKeyAndDisplayName();
/*
                        if(!s.parent) {
                            console.error('Should not happen!!!');
                        }*/
                    }
                })
            }

            updateFlatStylesList(true /* sort */);

            _this.setCurrentStyleByKey(current_style ? current_style.key : null);

            pinegrow.dispatchEvent('on_class_styles_updated_from_db');

            dbnode_to_style_map = null;
        }

        var updateFlatStylesList = function(sort) {
            var r = [];

            var addChildren = function(s) {
                if(sort && s.children.length) {
                    sortStyleList(s.children);
                }
                s.children.forEach(function(cs) {
                    r.push(cs);
                    addChildren(cs);
                })
            }

            var top = []

            styles_map = {}

            styles.forEach(function(s) {
                if(s.parent === null && s.scopeParent === null) {
                    top.push(s);
                }
                styles_map[s.key] = s;
            })

            if(sort) {
                sortStyleList(top);
            }

            top.forEach(function(s) {
                if(s.parent === null && s.scopeParent === null) {
                    r.push(s);
                    addChildren(s);
                }
            })

            styles = r;
        }

        this.expandStyle = function(style, val) {
            style.setExpanded(val)
            db.is_changed = true;
            saveDBIfOnlyProjectOpen()
        }

        this.lockStyle = function(style, val) {
            style.setLocked(val)
            db.is_changed = true;
            saveDBIfOnlyProjectOpen()
        }

        this.expandAll = function(val) {
            this.getStyles().forEach(function(s) {
                s.setExpanded(val);
            })
            this.setLastExpanded(val)
            db.is_changed = true;
            saveDBIfOnlyProjectOpen()
        }

        this.lockAll = function(val) {
            this.getStyles().forEach(function(s) {
                s.setLocked(val);
            })
            this.setLastLocked(val)
            db.is_changed = true;
            saveDBIfOnlyProjectOpen()
        }

        this.showStyleContextMenu = function(style, $el, event) {
            var pgel = pinegrow.selectedElements.getLastSelected();

            var actions = []

            if(pgel) {
                if(pinegrow.classStyles.isStyleOnPgel(pgel, style)) {
                    actions.push({
                        type: 'header',
                        label: 'Remove style'
                    })
                    actions.push({
                        label: 'Remove from selected element',
                        action: function () {
                            pinegrow.classStyles.removeStyleFromPgel(style);
                        }
                    })
                    actions.push({
                        label: 'Remove &amp; leave classes ' + pinegrow.selectedElements.getName(),
                        action: function () {
                            pinegrow.classStyles.removeStyleFromPgel(style, true);
                        }
                    })
                } else {
                    actions.push({
                        type: 'header',
                        label: 'Add style'
                    })

                    actions.push({
                        label: 'Add to selected element',
                        action: function () {
                            pinegrow.classStyles.assignStyle(style);
                        }
                    })

                    actions.push({
                        label: 'Add to selected element &amp; keep inline',
                        action: function () {
                            pinegrow.classStyles.assignStyle(style, null, true);
                        }
                    })
                }
            }
/*
            actions.push({
                type: 'divider'
            })
*/
            actions.push({
                label: 'Add style to all matching elements',
                action: function () {
                    var page = pinegrow.getSelectedPage();
                    if(page) {
                        pinegrow.classStyles.addStyleToMatchingElements(style, page);
                    } else {
                        pinegrow.showQuickError('Please open a page first.')
                    }
                }
            })

            actions.push({
                type: 'divider'
            })

            actions.push({
                label: 'Duplicate style...',
                action: function() {

                    var mode_with = style.children.length === 0 ? 'without_substyles' : null;
                    var mode_as = style.parent === null ? 'as_top' : null;

                    var fields = {}

                    if(!mode_with) {
                        fields.mode_with = {
                            name: 'Duplicate',
                            type: 'select',
                            value: 'with_substyles',
                            show_empty: false,
                            options: [
                                {key: 'with_substyles', name:'with sub-styles'},
                                {key: 'without_substyles', name: `without sub-styles`}
                            ]
                        }
                    }

                    if(!mode_as) {
                        fields.mode_as = {
                            name: 'Duplicate as',
                            type: 'select',
                            value: 'as_substyle',
                            show_empty: false,
                            options: [
                                {key: 'as_substyle', name: `Sub-style of ${style.parent.display_name}`},
                                {key: 'as_top', name:'Top level style'}]
                        }
                    }

                    fields.old_name = {
                        name: 'Current name',
                        type: 'displayhtmlwithlabel',
                        html: style.name
                    }

                    fields.name = {
                        name: 'New name',
                        validate: function(obj, prop, value) {
                            return pinegrow.classStyles.validateNameForANewStyle(value);
                        }
                    }

                    pinegrow.showQuickDialog(`Duplicate style ${style.display_name}`, 'Style information', `<p>Enter the new name for the new style:</p>`, fields, 'Cancel', 'Duplicate', null, function(values) {

                        mode_with = values.mode_with || mode_with;
                        mode_as = values.mode_as || mode_as;

                        pinegrow.classStyles.duplicateStyle(style, values.name, mode_with, mode_as, function() {
                            //_this.show();
                        })
                    })
                }
            })

            actions.push({
                label: 'Rename style...',
                action: function() {
                    pinegrow.showQuickDialog(`Rename style ${style.display_name}`, 'Style information', `<p>Enter the new name for the style and click on Rename &amp; Update.</p><p>Please note that all changed files in the project will be saved. This operation can not be undone.</p>`, {
                        old_name: {
                            name: 'Current name',
                            type: 'displayhtmlwithlabel',
                            html: style.name
                        },
                        name: {
                            name: 'New name',
                            validate: function(obj, prop, value) {
                                return pinegrow.classStyles.validateNameForANewStyle(value, style);
                            }
                        }
                    }, 'Cancel', 'Rename &amp; Update project', null, function(values) {
                        pinegrow.classStyles.renameStyle(style, values.name, function() {
                            //_this.show();
                        })
                    })
                }
            })

            actions.push({
                type: 'divider'
            })

            actions.push({
                type: 'header',
                label: 'Delete style from the project'
            })

            var doDelete = function(keep_classes) {
               // if(!pinegrow.getSelectedPage()) {
               //     pinegrow.showQuickError('Please open a page first.')
               // } else {
                    pinegrow.classStyles.deleteStyle(style, keep_classes);
               // }
                //_this.show();
            }

            actions.push({
                label: 'Delete style',
                action: function() {

                    doDelete(false);
                }
            })

            actions.push({
                label: 'Delete style &amp; keep classes on elements',
                action: function() {
                    doDelete(true);
                }
            })



            var m = new CrsaContextMenu(actions, $el);
            event ? m.showAt(event.pageX, event.pageY) : m.showForElement($el);
        }

        pinegrow.addEventHandler('on_can_make_change', function(page, pgel, action, data) {
            //another framework already prevented it
            if(page && page.getCurrentFrameworkHandlerReturnValue('on_can_make_change')) return page.getCurrentFrameworkHandlerReturnValue('on_can_make_change');

            if(useClassStylesOnPage(page) && current_style) {
                if(action === 'add_class' || action === 'remove_class') {
                    if (current_style.locked) {
                        return new PgEditException(`<p>The selected style <b>${current_style.name}</b> is locked.</p><p>Unlock it in the Class Styles panel or edit the classes directly in the Properties panel.</p>`, 'This style is locked');
                    }
                }
            }
        });

        pinegrow.addEventHandler('on_element_selected', function(page, pgel, info) {
            if(useClassStylesOnPage(page)) {
                var s = current_style = getCurrentStyleForPgel(pgel);
                _this.setCurrentStyle(s, true, 'element_selected');
            }
        });

        pinegrow.addEventHandler('on_before_changes_done', function(pagenull, col, info) {
            if(apply_changes_on_next_change_done) {
                applyStylesOnAllOpenPages(null, apply_changes_on_next_change_done);
            }
            apply_changes_on_next_change_done = false;
        });

        pinegrow.addEventHandler('on_project_loaded', function(pagenull, project) {
            project.requireDB(function(pdb) {
                //to do, only if exists
                db = pdb;

                updateStylesFromDB();

            }, false /* skip create */)
        });

        pinegrow.addEventHandler('on_project_closed', function(pagenull, project) {

           styles = [];
            updateFlatStylesList();
            pinegrow.dispatchEvent('on_class_styles_updated_from_db');
        });

        pinegrow.addEventHandler('on_projectdb_changed', function(pagenull, col, info) {
            if (info && info.source === 'undo') {
                updateStylesFromDB();
            }
        });

        pinegrow.addEventHandler('on_page_parsed_in_proxy', function(page) {
            if(projectHasClassStyles()) {
                applyStylesOnPage(page);
            }
        })

        /*
       Moved to project.db itself

        pinegrow.addEventHandler('on_page_saved', function(page) {
            if(useClassStylesOnPage(page)) {
                var p = pinegrow.getCurrentProject();
                if(p && p.db && p.db.is_changed) {
                    p.db.save();
                }
            }
        })
*/

    }


    window.PgClassStylesView = function() {

        var _this = this;

        this.$element = $('<div class="pg-dm-style-list"></div>');

        var $header = $('<div class="pg-dm-style-list-header"></div>').appendTo(this.$element);

        var search = new PgSearchBox({
            toolbar_on: true,
            placeholder: 'search',
            placeholder_active: 'search by style name'
        });

        var search_filter = null;

        search.onSearch = function(filter) {
            if(filter) {
                search_filter = new RegExp(escapeRegExp(filter), 'i');
            } else {
                search_filter = null;
            }
            _this.show();
        }

        var toolbar = this.toolbar = search.getToolbar();
        toolbar.addSection('settings');

        //var lockButton = new PgButtonToolbarItem('<i class="fa fa-lock"></i>', 'Lock or unlock all styles.');
        //toolbar.addItem('settings', lockButton);

        var expandAll = function(val) {
            pinegrow.classStyles.expandAll(val)
            _this.show();
            scrollToStyle();
        }

        var lockAll = function(val) {
            pinegrow.classStyles.lockAll(val)
            _this.show();
        }

        var expandButton = new PgButtonToolbarItem('icon-down', 'Lock, expand styles, update project...');
        toolbar.addItem('settings', expandButton);
        expandButton.onClick = function() {
            var a = [
                {
                    type: 'header',
                    label: 'Expand / collapse styles'
                },
                {
                    label: 'Expand all',
                    action: function() {
                        expandAll(true)
                    }
                },
                {
                    label: 'Collapse all',
                    action: function() {
                        expandAll(false)
                    }
                },
                {
                    type: 'divider'
                },
                {
                    type: 'header',
                    label: 'Lock / unlock styles'
                },
                {
                    label: 'Lock all',
                    action: function() {
                        lockAll(true)
                    }
                },
                {
                    label: 'Unlock all',
                    action: function() {
                        lockAll(false)
                    }
                },
                {
                    type: 'divider'
                },
                {
                    type: 'header',
                    label: 'Update'
                },
                {
                    label: 'Update usage counts',
                    action: function() {
                        pinegrow.classStyles.updateUsageCounts(function() {
                            _this.show();
                        });
                    }
                },
                {
                    label: 'Update whole project & save changes',
                    action: function() {
                        pinegrow.classStyles.updateProject(function() {
                            _this.show();
                        });
                    }
                }
            ]

            var m = new CrsaContextMenu(a, this.$element);
            m.showForElement(this.$element);
            return false;
        }

        search.$element.appendTo(this.$element);

        var spacer = new PgSearchBoxSpacer();
        spacer.$element.appendTo(this.$element);

        var notice = new PgPanelNotice();
        notice.$element.appendTo(this.$element);

        var $items = $('<div class="pg-dm-style-list-items"></div>').appendTo(this.$element);

        var view = this.view = new PgUIView(this.$element, 'classstyles');

        view.tabIcon = 'icon-classes';

        var style_items = new WeakMap();
        var style_items_list = [];

        var active_item = null;
        var class_filter = null;

        var delayedTasks = new PgDelayedTasks();

        $items.on('click', '.name', function(e) {
            e.preventDefault();
            var $item = $(this).closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);

            var pgel = pinegrow.selectedElements.getLastSelected();
            if(pgel) {
                var list = pinegrow.classStyles.getStylesForPgel(pgel);
                var idx = list.indexOf(style);
                if(idx >= 0) {
                    pinegrow.classStyles.removeStyleFromPgel(style);
                    pinegrow.showQuickMessage(`Style <b>${style.display_name}</b> was removed from selected elements.`)
                } else {
                    pinegrow.classStyles.assignStyle(style);
                    pinegrow.showQuickMessage(`Style <b>${style.display_name}</b> was added to selected elements.`)
                }
            } else {
                pinegrow.showQuickError('Please select the element first.');
            }

            //pgDmStore.assignStyleToSelectedElements(item.style);
            //pgDmStore.setCurrentStyle(item.style);
            //pgDmStore.triggerCurrentStyleChanged();
        })

        $items.on('contextmenu', '.pg-dm-style-list-item', function(e) {
            e.preventDefault();
            var $el = $(this);
            var $item = $el.closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);

            pinegrow.classStyles.showStyleContextMenu(style, $(e.target), e);
            return false;

        })

        $items.on('click', 'i.open', function(e) {
            e.preventDefault();
            var $item = $(this).closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);
            pinegrow.classStyles.expandStyle(style, true);
            $item.addClass('open');
            pinegrow.classStyles.setLastExpanded(true)
            return false;
        })

        $items.on('click', 'i.collapse', function(e) {
            e.preventDefault();
            var $item = $(this).closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);
            pinegrow.classStyles.expandStyle(style, false);
            $item.removeClass('open');
            pinegrow.classStyles.setLastExpanded(false)
            return false;
        })

        $items.on('click', 'i.lock', function(e) {
            e.preventDefault();
            var $item = $(this).closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);
            val = !style.locked;
            pinegrow.classStyles.lockStyle(style, val);
            val ? $item.addClass('locked') : $item.removeClass('locked');
            pinegrow.showMode('Style is locked', val);
            pinegrow.classStyles.setLastLocked(val)
            return false;
        })

        $items.on('click', '.pg-tree-class', function(e) {
            e.preventDefault();
            var $item = $(this).closest('.pg-dm-style-list-item');
            var key = $item.attr('data-key');
            var style = pinegrow.classStyles.findStyleByKey(key);

            var $cls = $(this);
            var cls = $cls.attr('data-class');

            var pgel = pinegrow.selectedElements.getLastSelected();
            if(pgel) {
                var styles = pinegrow.classStyles.getStylesForPgel(pgel);
                if(styles.indexOf(style) >= 0) {
                    pinegrow.dispatchEvent('on_class_style_property_clicked', pgel.getPage(), style, cls);
                } else {
                    pinegrow.showQuickError(`Selected element does not have the style <b>${style.display_name}</b>.`)
                }
            } else {
                pinegrow.showQuickError('Select the element with this style first.')
            }
            return false;
        })

        $items.on('click', '.count', function(e) {
            e.preventDefault();
            pinegrow.classStyles.updateUsageCounts(function() {
                _this.show();
            });

        })


        var getStyleHtml = function(style, active, has) {
            return `<div class="pg-dm-style-list-item${active ? ' active' : ''}${has ? ' used' : ''}${style.expanded ? ' open' : ''}${style.locked ? ' locked' : ''} level-${style.level} ${style.children.length > 0 ? 'has-kids' : 'no-kids'}" data-key="${style.key}" style="margin-left:${style.level * 20}px;">${getStyleInnerHtml(style)}</div>`;
        }

        var getStyleInnerHtml = function(style) {
            var c = '';

            if(class_filter) {
                var i = class_filter(style);
                c = i.html;
                c = c.replace('ALT click', 'Click');
            } else {
                style.getClasses().forEach(function (cls) {
                    c += `<span class="pg-tree-class" data-class="${cls}" title="Click to jump to property.">${cls}</span>`;
                })
            }
            return `<div class="info"><span class="name" title="Click to add or remove from the selected element, right-click for options.">${style.scopeParent ? '&gt; ' : ''}${style.name}</span><span class="count" title="Used ${style.count} times in the project. Click to update counts.">${style.count}</span><i class="lock icon icon-Lock_open" title="Unlock the style for editing."></i><i class="lock icon icon-Lock_closed" title="Lock the style."></i><i class="collapse-expand collapse icon icon-down"></i><i class="collapse-expand open icon icon-right"></i></div><div class="classes">${c}</div>`;
        }

        var findItemNode = function(style) {
            var node = $items.get(0).querySelector(`[data-key="${style.key}"]`);
            return node;
        }

        var getClassFilter = function() {
            var page = pinegrow.getSelectedPage();
            return page ? page.getShowNameClassesFilter() : null;
        }

        this.show = function() {
            view.whenVisible(function() {

                var cs = pinegrow.classStyles.getCurrentStyle();

                var list = null;

                var pgel = pinegrow.selectedElements.getLastSelected();
                if(pgel) {
                    list = pinegrow.classStyles.getStylesForPgel(pgel);
                }

                var html = '';

                pinegrow.classStyles.getStyles().forEach(function(style) {
                    if(!search_filter || search_filter.test(style.display_name)) {
                        html += getStyleHtml(style, cs === style, list ? list.indexOf(style) >= 0 : false)
                    }
                })

                $items.get(0).innerHTML = html;

                if(!html) {
                    notice.show('No Class Styles are defined. Class Styles are a part of Tailwind Visual Editor and only work when a project is loaded.');
                } else {
                    notice.show(null);
                }
            })

            view.clearWhenVisible('setActiveStyle')
            view.clearWhenVisible('updateUsed')
            view.clearWhenVisible('updateSingleClassStyle')
        }

        this.show();

        var onStyleAdded = function(pagenull, style) {
            _this.show();
        }

        var onRepaintList = function() {
            _this.show();
        }

        var onStylesChanged = function(pagenull, style_list) {
            var style = null;

            var updated = false;

            if(style_list && style_list.length === 1) {
                view.whenVisible(function () {
                    //console.log('Quick style update')
                    var cs = pinegrow.classStyles.getCurrentStyle();

                    var list = null;

                    var pgel = pinegrow.selectedElements.getLastSelected();
                    if(pgel) {
                        list = pinegrow.classStyles.getStylesForPgel(pgel);
                    }

                    style_list.forEach(function(style) {
                        var n = findItemNode(style);

                        if(n) {
                            if(style.deleted) {
                                n.parentNode && n.parentNode.removeChild(n);
                            } else {
                                var html = getStyleHtml(style, cs === style, list ? list.indexOf(style) >= 0 : false)
                                n.outerHTML = html;
                                updated = true;
                            }
                        }
                    })

                    if(!updated) {
                        _this.show();
                    }
                }, 'updateSingleClassStyle')
            } else {
                //console.log('Big style update')
                _this.show();
            }
        }

        var resetUsedAndActive = function() {
            $items.get(0).querySelectorAll('.pg-dm-style-list-item.used,.pg-dm-style-list-item.active').forEach(function(n) {
                n.classList.remove('used');
                n.classList.remove('active');
            })
        }

        var scrollToStyle = function(style) {
            if(style) {
                var n = findItemNode(style);
                if(n) {
                    var $n = $(n);
                    pgScrollToItemInContainer($n, $n.parent());
                }
            }
        }

        var onStyleSelected = function(pagenull, style) {
            view.whenVisible(function() {
                resetUsedAndActive();

                updateUsedAndActive();

                scrollToStyle(style);

            }, 'setActiveStyle', 1)
        }

        var onFrameworksChanged = function(page) {
            if(page) {
                class_filter = page.getShowNameClassesFilter();
                delayedTasks.run('updateAfterFrameworksChanged', function() {
                    _this.show();
                }, 500);
            }
        }

        var updateUsedAndActive = function() {
            var pgel = pinegrow.selectedElements.getLastSelected();
            var cs = pinegrow.classStyles.getCurrentStyle();

            if(pgel) {
                var list = pinegrow.classStyles.getStylesForPgel(pgel);
                list.forEach(function(s) {
                    var n = findItemNode(s);
                    if(n) {
                        n.classList.add('used');
                        if(s === cs) {
                            n.classList.add('active');
                        }
                    }
                })
            }
        }

        var onSelectedElementsChanged = function(pagenull) {
            view.whenVisible(function() {

                resetUsedAndActive();
                updateUsedAndActive();

            }, 'updateUsed')
        }

        //pinegrow.addEventHandler('on_dm_style_added', onStyleAdded);
        //pinegrow.addEventHandler('on_dm_project_loaded', onRepaintList);
       //pinegrow.addEventHandler('on_dm_style_changed', onStyleChanged);
        pinegrow.addEventHandler('on_current_class_style_changed', onStyleSelected);
        pinegrow.addEventHandler('on_class_styles_changed', onStylesChanged);
        pinegrow.addEventHandler('on_page_frameworks_changed', onFrameworksChanged);
        pinegrow.addEventHandler('on_class_styles_updated_from_db', onStylesChanged);
        pinegrow.addEventHandler('on_selected_elements_changed', onSelectedElementsChanged);

        view.onDestroy = function() {
            //pinegrow.removeEventHandler('on_dm_style_added', onStyleAdded);
            //pinegrow.removeEventHandler('on_dm_project_loaded', onRepaintList);
            //pinegrow.removeEventHandler('on_dm_style_changed', onStyleChanged);
            pinegrow.removeEventHandler('on_current_class_style_changed', onStyleSelected);
            pinegrow.removeEventHandler('on_class_styles_changed', onStylesChanged);
            pinegrow.removeEventHandler('on_page_frameworks_changed', onFrameworksChanged);
            pinegrow.removeEventHandler('on_class_styles_updated_from_db', onStylesChanged);
            pinegrow.removeEventHandler('on_selected_elements_changed', onSelectedElementsChanged);

            delayedTasks.destroy();
        }
    }


    $('body').one('pinegrow-ready', function (e, pinegrow) {

        pinegrow.classStyles = new PgClassStylesManager();

        //pinegrow.addEventHandler('')
    });
});