var loadInlineAsStylesheetAndGetRules = function(pgel, done) {
    var inline = []

    var elementPgStylesheet = PgCSSStylesheet();
    elementPgStylesheet.elementStyle = true
    elementPgStylesheet.element = pgel;
    elementPgStylesheet.index = 'style';

    //loading inline is done with sync, even if it has callback
    elementPgStylesheet.load(null, function () {
        var source_inline = elementPgStylesheet.getRootNode().nodes[0];
        source_inline.inline = 'source';
        source_inline.inline_for_pgel = pgel;

        /*
        if(matchedRulesObj.inlineStyle) {
            var nodes = parseInlineStyle(matchedRulesObj.inlineStyle.cssText);
            nodes = filterDOMInlineStyles(source_inline.nodes, nodes);
            if(nodes.length) {
                var dom_inline = {
                    type: 'rule',
                    inline: 'dom',
                    selector: 'Inline style (DOM)',
                    nodes: nodes,
                    inline_for_pgel: pgel
                }
                source_inline.selector += ' (Source)';
                inline.push(dom_inline);

                dom_inline.nodes.forEach(function(node) {
                    node.parent = dom_inline;
                })
            }
        }*/

        inline.push(source_inline)

        done(inline, elementPgStylesheet)
    })
}

var PgChromeDevTools = function() {

    var _this = this;

    var browser = !isApp();

    var pgChromeIframes = [];
    var pgChromeTabId = -1;

    var allPostcssLib = require('postcss');

    var postcss = allPostcssLib.postcss;
    var cssSyntax = allPostcssLib.postcssSafeParser;

    this.setChromeIframes = function (chromeIframes) {
        pgChromeIframes = chromeIframes;
    }

    this.setChromeTabId = function (chromeTabId) {
        pgChromeTabId = chromeTabId;
    }

    var parseInlineStyle = function(css) {
        var p = new CrsaProfile();
        var syntaxRes = postcss([]).process(css, { parser: cssSyntax });

        if(typeof css !== 'string') return [];

        try {
            var result = syntaxRes.result;
            //console.log(result);
            return result.root.nodes;
        } catch (err) {
        }
        return [];
    }

    var filterDOMInlineStyles = function(source, dom) {
        var r = [];
        var map = {}
        var dom_map = {};

        source.forEach(function(decl) {
            map[decl.prop] = decl.value + (decl.important ? ' !important' : '');
        })
        dom.forEach(function(decl) {
            var val = decl.value + (decl.important ? ' !important' : '');
            dom_map[decl.prop] = val;

            if(map[decl.prop]) {
                if(map[decl.prop] !== val) {
                    r.push(decl);
                }
            } else {
                r.push(decl);
            }
        })

        source.forEach(function(decl) {
            if(!dom_map[decl.prop]) {
                r.push({
                    type: 'decl',
                    removed: true,
                    prop: decl.prop,
                    value: 'Removed'
                })
            }
        })
        return r;
    }


    this.runDummyGetMatchedCSSRules = function(selectedChIframe, done) {
        var chromeTabId = pgChromeTabId;

        chrome.debugger.sendCommand({ tabId: chromeTabId }, 'DOM.querySelector', {
            nodeId: selectedChIframe.contentDocument.nodeId,
            selector: `body`
        }, function (nodeIdObj) {
            if(nodeIdObj) {
                chrome.debugger.sendCommand({tabId: chromeTabId}, 'CSS.getMatchedStylesForNode', nodeIdObj,
                    function (matchedRulesObj) {
                        done(matchedRulesObj);
                    })
            } else {
                done();
            }
        });
    }

    this.getMatchedCSSRuleForChromeNode = function(selectedChIframe, pgel, done) {

        if(css_disabled_level > 0) {
            get_matched_waiting_line.push(function() {
                _this.getMatchedCSSRuleForChromeNode(selectedChIframe, pgel, done);
            })
            console.log('getMatchedCSSRuleForChromeNode: will wait for CSS enable')
            return;
        }
        var chromeTabId = pgChromeTabId;

        chrome.debugger.sendCommand({ tabId: chromeTabId }, 'DOM.querySelector', {
            nodeId: selectedChIframe.contentDocument.nodeId,
            selector: `[data-pg-id="${pgel.pgId}"]`
        }, function (nodeIdObj) {
            chrome.debugger.sendCommand({ tabId: chromeTabId }, 'CSS.getMatchedStylesForNode', nodeIdObj,
                function (matchedRulesObj) {
                    if (!matchedRulesObj) {
                        if (done) done([], [], []);
                        return;
                    }

//                    console.log(pgel.getName(), matchedRulesObj)

                    var selectors = [];

                    var map = {};
                    var addNewSelector = function (selector, unshift, use_map, use_list) {
                        use_map = use_map || map;
                        use_list = use_list || selectors;

                        if (!use_map[selector.text]) {
                            use_map[selector.text] = selector;
                            if (unshift) {
                                use_list.unshift(selector);
                            } else {
                                use_list.push(selector);
                            }
                        }
                    }

                    var matchedCSSRules = matchedRulesObj.matchedCSSRules;
                    for (var i = 0; i < matchedCSSRules.length; i++) {
                        var matchedCSSRule = matchedCSSRules[i];
                        var rule = matchedCSSRule.rule;

                        var csurl = null;
                        if(rule.styleSheetId && stylesheet_map_id_to_url[rule.styleSheetId]) {
                            csurl = pinegrow.getOriginalUrl(stylesheet_map_id_to_url[rule.styleSheetId]);
                            rule.selectorList.csurl = csurl;
                        }
                        addNewSelector(rule.selectorList, false, false, false);
                    }

                    var pseudoElements = matchedRulesObj.pseudoElements;
                    for (var i = 0; i < pseudoElements.length; i++) {
                        var pseudo = pseudoElements[i];
                        var matchedCSSRules = pseudo.matches;

                        for (var j = matchedCSSRules.length - 1; j >= 0 ; j--) {
                            //for (var j = 0; j < matchedCSSRules.length; j++) {
                            var matchedCSSRule = matchedCSSRules[j];
                            var rule = matchedCSSRule.rule;

                            addNewSelector(rule.selectorList, true);
                        }
                    }

                    var inherited = [];

                    var $el = pgel.get$DOMElement();

                    if(matchedRulesObj.inherited && $el) {

                        matchedRulesObj.inherited.forEach(function(eldata) {
                            $el = $el.parent();
                            var parent_pgel = getElementPgNode($el);
                            if(parent_pgel) {
                                var rules = [];
                                var map = {};
                                eldata.matchedCSSRules.forEach(function(ruledata) {
                                    addNewSelector(ruledata.rule.selectorList, false, map, rules);
                                })
                                inherited.push({
                                    pgel: parent_pgel,
                                    selectors: rules
                                })
                            }
                        })
                    }

                    var inline = [];

                    /*
                    var source_inline = {
                        type: 'rule',
                        inline: 'source',
                        selector: 'Inline style',
                        nodes: parseInlineStyle(pgel.getAttribute('style')),
                        inline_for_pgel: pgel
                    }

                    source_inline.nodes.forEach(function(node) {
                        node.parent = source_inline;
                    })

                     */


                    loadInlineAsStylesheetAndGetRules(pgel, function(inline) {
                        if (done) done(selectors, inherited, inline);
                    })
                }
            );
        })
    }

    this.getChromeTabId = function(done) {
        if(browser) {
            done && done('1');
            return;
        }
        chrome.tabs.getCurrent(function (tab) {
            chrome.debugger.attach({ tabId: tab.id }, '1.2');
            if (done) done(tab.id);
        });
    }

    this.detach = function(done) {
        chrome.tabs.getCurrent(function (tab) {
            chrome.debugger.detach({ tabId: tab.id }, done);
        });
    }

    var stylesheets_map = {}
    var stylesheet_map_id_to_url = {}

    this.setCookies = function(cookies) {
        chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'Storage.setCookies', { cookies: cookies }, function(a,b,c) {
            console.log('Storage.setCookies done', a, b, c);
        });
    }

    this.setStylesheetContent = function(url, content, pv) {
        var debug = pgIsDev();

        url = pinegrow.getProxyUrl(url);

        var frameId = pv ? this.getFrameIdForPageView(pv) : null;

        if(stylesheets_map[url]) {
            var done = false;
            stylesheets_map[url].forEach(function(o) {
                if(frameId && frameId !== o.frameId) return;

                var sid = o.sid;
                debug && console.log('setStylesheetContent: Set text of ' + sid + ' - ' + url);
                done = true;
                chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'CSS.setStyleSheetText', { styleSheetId: sid, text: content }, function(a,b,c) {
                    //console.log('CSS.setStyleSheetText done', a, b, c, content);

                });
            })
            return done;
        } else {
            //console.log('setStylesheetContent: Stylesheet ' + url + ' not found.');
            return false;
        }
    }


    //Disable because it doesn't work well with @imports
    if(!browser) {
        var findStylesheetMapIds = function(url, sid) {
            for(var i = 0; i < stylesheets_map[url].length; i++) {
                if(stylesheets_map[url][i].sid === sid) return i;
            }
            return -1;
        }

        chrome.debugger.onEvent.addListener(function (source, method, params) {
            if (method === 'CSS.styleSheetAdded' && params.header.sourceURL) {
                if (!stylesheets_map[params.header.sourceURL]) {
                    stylesheets_map[params.header.sourceURL] = [];
                }
                var idx = findStylesheetMapIds(params.header.sourceURL, params.header.styleSheetId);

                if (idx < 0) {
                    stylesheets_map[params.header.sourceURL].push({
                        sid: params.header.styleSheetId,
                        frameId: params.header.frameId
                    }
                    );
                }

                stylesheet_map_id_to_url[params.header.styleSheetId] = params.header.sourceURL;

                pgIsDev() && console.log('CSS.styleSheetAdded: Stylesheet ' + params.header.sourceURL);
            } else if (method === 'CSS.styleSheetRemoved') {

                var debug = pgIsDev();

                debug && console.log('CSS.styleSheetRemoved: Stylesheet ' + params.styleSheetId);

                var url = stylesheet_map_id_to_url[params.styleSheetId] || null;
                if (url) {
                    if (stylesheets_map[url]) {
                        var idx = findStylesheetMapIds(url, params.styleSheetId);
                        if (idx >= 0) {
                            stylesheets_map[url].splice(idx, 1);
                            debug && console.log('CSS.styleSheetRemoved: Removed from the map!');
                        }
                    }
                    delete stylesheet_map_id_to_url[params.styleSheetId];
                } else {
                    //debug && console.log('CSS.styleSheetRemoved: Not found in map or inline!');
                }
            }
        });
    }

    var css_disabled_level = 0;
    var get_matched_waiting_line = [];

    this.withDisabledCSS = function(func, done) {
        func();
        done && done();
        return;

        css_disabled_level++;

        chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'CSS.disable', function() {
            setTimeout(function() {
                func();
                css_disabled_level--;
                if(css_disabled_level <= 0) {
                    css_disabled_level = 0;
                    chrome.debugger.sendCommand({tabId: pgChromeTabId}, 'CSS.enable', function () {
                        done && done();
                        console.log('withDisabledCSS: CSS.enabled')

                        get_matched_waiting_line.forEach(function(f) {
                            console.log('withDisabledCSS: Running waiting getMatchedRules')
                            f();
                        })
                        get_matched_waiting_line = [];
                    });
                } else {
                    console.log('Another withDisabledCSS is in progress...')
                    done && done();
                }
            }, 1000)
        });
    }

    this.getChromeIframes = function(chromeTabId, done) {

        chrome.debugger.sendCommand({ tabId: chromeTabId }, 'DOM.getFlattenedDocument', function (nodeObj) {
            var iframes = []
            var nodes = nodeObj.nodes;
            for (var i = 0; i < nodes.length; i++) {
                var node = nodes[i];
                if (node.nodeType == 1 && node.attributes.indexOf("content-iframe") > -1) {
                    iframes.push(node);
                }
            }

            if (done) done(iframes);
        });
    }

    this.getSelectedChromeIframe = function(page) {
        return page ? this.getChromeIframeFor$Iframe(page.$iframe) : null;
    }

    this.getFrameIdForPageView = function(pv) {
        var o = this.getChromeIframeFor$Iframe(pv.get$Iframe());
        if(o) {
            return o.frameId || null;
        }
        return null;
    }

    this.getChromeIframeFor$Iframe = function($iframe) {
        var chIframes = pgChromeIframes;

        for (var i = 0; i < chIframes.length; i++) {
            var iframe = chIframes[i];
            var page_pv_id = $iframe.attr('data-pv-id');
            var idx = iframe.attributes.indexOf('data-pv-id');
            if(idx >= 0) {
                if(iframe.attributes[idx + 1] == page_pv_id) {
                    return iframe;
                }
            }
        }

        return null;
    }

    this.updateIframes = function(done) {
        if(!pgf.edit_css || !isApp()) return;

        this.getChromeIframes(pgChromeTabId, function (iframes) {
            _this.setChromeIframes(iframes);
            done && done();
        });
    }


    this.unregisterServiceWorkers = function() {
        if(!isApp()) return;
        return; //not supported at the moment in NWJS SDK
       // pinegrow.devTools.getChromeTabId(function(cid) {
           // chrome.debugger.sendCommand({ tabId: cid }, 'ServiceWorker.enable', function() {
                chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'ServiceWorker.unregister', {
                    scopeURL: pinegrow.getApiUrl()
                }, function() {})
           // });
      //  })
    }

    this.forcePseudoStates = function(pgel, states, done) {
        var p = new CrsaProfile();

        if(!isApp()) {
            done && done();
            return;
        }

        this.withPgelNodeIds(pgel, function(list) {
            p.show('Got NodeIds')
            var count = 0;
            list.forEach(function(nodeid) {
                chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'CSS.forcePseudoState', {
                    nodeId: nodeid,
                    forcedPseudoClasses: states
                }, function() {
                    count++;
                    if (count === list.length && done) {
                        p.show('Pseudos set')
                        done();
                    }
                });
            })
        })

    }

    this.withPgelNodeIds = function(pgel, done) {
        var page = pgel.getPage();
        var $els = pgel.get$DOMElements(page);

        var list = [];

        if($els.length === 0) {
            if(done) done(list)
            return;
        }

        $els.forEach(function($el) {
            var $iframe = $el.pgPageView.get$Iframe();
            var iframe = _this.getChromeIframeFor$Iframe($iframe);

            chrome.debugger.sendCommand({ tabId: pgChromeTabId }, 'DOM.querySelector', {
                nodeId: iframe.contentDocument.nodeId,
                selector: `[data-pg-id="${pgel.pgId}"]`
            }, function (nodeIdObj) {
                list.push(nodeIdObj);
                if(list.length === $els.length) {
                    if(done) {
                        var r = []
                        list.forEach(function(id) {
                            if(id !== null) {
                                r.push(id.nodeId);
                            }
                        })
                        done(r);
                    }
                }
            })
        })
    }

    if(pgf.edit_css) {

        this.getChromeTabId(function (tabId) {
            _this.setChromeTabId(tabId);
            //_this.updateIframes();

            if(!browser) {
                chrome.debugger.sendCommand({tabId: tabId}, 'DOM.enable');
                chrome.debugger.sendCommand({tabId: tabId}, 'CSS.enable');
                //Not included in the recent NWJS SDK
                //chrome.debugger.sendCommand({tabId: tabId}, 'ServiceWorker.enable');
            }

            //_this.updateIframes();
            /*

             chrome.debugger.onEvent.addListener(function(source, method, params) {
             console.log('CHROME EVENT', source, method, params);
             }) */
        });
    }

    this.getCSSPropsInfo = function() {
        return css_props_info
    }

    this.getCSSPropsInfoSection = function(section) {
        return css_props_info[section]
    }



    var css_info;

    var css_props_info = {
        dimension: {
            name: 'Dimension',
            icon: 'icon-Pin16',
            props: ['width', 'min-width', 'max-width', 'height', 'min-height', 'max-height'],
            re: /_(width|height|min\-width|max\-width|min\-height|max\-height)_/i
        },
        margin_padding: {
            name: 'Margin &amp; Padding',
            icon: 'icon-Pin16',
            props: ['margin', 'margin-top', 'margin-right', 'margin-bottom', 'margin-left', 'padding', 'padding-top', 'padding-right', 'padding-bottom', 'padding-left'],
            re: /_margin|_padding/i
        },
        position: {
            name: 'Position',
            icon: 'icon-Pin17',
            props: ['position', 'top', 'right', 'bottom', 'left', 'z-index'],
            re: /_(top|right|bottom|left|position|z\-index)_/i
        },
        display: {
            name: 'Display',
            icon: 'icon-Pin17',
            props: ['display', 'visibility', 'vertical-align', 'overflow', 'float', 'clear', 'opacity', 'object-fit', 'object-position', 'mask-image', 'zoom'],
            re: /display|vertical\-align|overflow|float|clear|opacity|object\-fit|object\-position|mask\-image|visibility|zoom/i
        },
        border: {
            name: 'Border &amp; Outline',
            icon: 'icon-Pin20',
            props: ['border', 'border-top', 'border-right', 'border-bottom', 'border-left', 'border-radius','outline','outline-offset'],
            re: /border|outline/i
        },
        text: {
            name: 'Text',
            icon: 'icon-Pin18',
            props: ['font', 'font-family', 'font-size', 'font-style', 'font-weight', 'line-height', 'color', 'letter-spacing', 'text-align', 'text-decoration', 'text-indent', 'text-transform', 'white-space', 'word-break', 'direction'],
            re: /font|line-height|_color_|letter-spacing|text-decoration|text-align|text-transform|white-space|word-break|_direction_|text-indent|_text-|_word-/i
        },
        background: {
            name: 'Background',
            icon: 'icon-Pin21',
            props: ['background', 'background-color', 'background-image', 'background-origin', 'background-position', 'background-repeat', 'background-size'],
            re: /background/i
        },
        flex_container: {
            name: 'Flex container',
            icon: 'icon-Pin22',
            props: ['flex-direction', 'flex-flow', 'flex-wrap', 'justify-content', 'align-items', 'align-content'],
            re: /flex\-direction|flex\-wrap|flex\-flow|justify\-content|align\-items|align\-content|_gap_|row-gap|column-gap/i
        },
        flex_child: {
            name: 'Flex child',
            icon: 'icon-Pin22',
            props: ['flex', 'flex-grow', 'flex-shrink', 'flex-basis', 'order', 'align-self'],
            re: /_(order|flex\-grow|flex\-shrink|flex\-basis|flex|align\-self)_/i
        },
        visual: {
            name: 'Visual effects',
            icon: 'icon-Pin23',
            props: ['box-shadow', 'text-shadow', 'transform', 'perspective', 'transition', 'transition-property', 'transition-duration', 'transition-delay'],
            re: /box\-shadow|text\-shadow|transform|perspective|transition|animation/i
        },
        list: {
            name: 'List',
            icon: 'icon-Pin25',
            props: ['list-style', 'list-style-type', 'list-style-position', 'list-style-image'],
            re: /list/i
        },
        grid_container: {
            name: 'Grid container',
            icon: 'icon-grid',
            props: ['grid', 'grid-template', 'grid-template-columns', 'grid-template-rows', 'grid-template-areas', 'grid-gap', 'grid-column-gap', 'grid-row-gap', 'grid-auto-columns', 'grid-auto-rows', 'grid-auto-flow'],
            re: /_(grid|grid\-template|grid\-template\-areas|grid\-template\-rows|grid\-template\-columns|_gap_|row-gap|column-gap|grid\-auto\-rows|grid\-auto\-columns|grid\-auto\-flow)_/i
        },
        grid_item: {
            name: 'Grid item',
            icon: 'icon-grid',
            props: ['grid-area', 'grid-column', 'grid-column-start', 'grid-column-end', 'grid-row', 'grid-row-start', 'grid-row-end','align-self'],
            re: /_(grid\-area|grid\-row|grid\-column|grid\-row\-start|grid\-row\-end|grid\-column\-start|grid\-column\-end|align\-self)_/i
        },
        columns: {
            name: 'Columns',
            icon: 'icon-Pin18',
            props: ['columns', 'column-count', 'column-gap', 'column-rule', 'column-span', 'column-width', 'break-before', 'break-inside', 'break-after'],
            re: /_(column)|(_(columns|column\-gap|column\-rule|column\-fill|break\-before|break\-inside|break\-after)_)/i
        },
        pointer: {
            name: 'Cursor &amp; Interactivity',
            icon: 'icon-grid',
            props: [],
            re: /pointer-events|_scroll-|cursor|caret-color|user-select/i
        }/*,
        a: {
            icon: '',
            props: ['', '', '', '', '', '', '', '', '', '', ''],
            re:
        },
        a: {
            icon: '',
            props: ['', '', '', '', '', '', '', '', '', '', ''],
            re:
        },
        a: {
            icon: '',
            props: ['', '', '', '', '', '', '', '', '', '', ''],
            re:
        },
        a: {
            icon: '',
            props: ['', '', '', '', '', '', '', '', '', '', ''],
            re:
        },
        a: {
            icon: '',
            props: ['', '', '', '', '', '', '', '', '', '', ''],
            re:
        }*/
    }

    var css_props_options = null;
    var css_props;
    var mdn_css_props_options = null;
    var mdn_css_props_options_map = {}
    var mdn_syntaxes = {}

    var loadCSSInfo = function() {
        if(browser) return;

        var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/css_info.json');
        try {
            var str = require('fs').readFileSync(file, {encoding: 'utf8'});
            css_info = JSON.parse(str)

            css_props_options = []
            $.each(css_info.properties, function(key, def) {
                if(key.length && !key.startsWith('-')) {
                    css_props_options.push({
                        key: key,
                        name: key
                    })
                }
            })

            css_props = css_info.properties;

            $.each(css_info.sections, function(key, def) {
                css_props_info[key].props = def.list;
                css_props_info[key].sub = def.tree;
            })

            var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/css_desc.json');

            var str = require('fs').readFileSync(file, {encoding: 'utf8'});
            css_desc = JSON.parse(str)

            $.each(css_desc, function(prop, def) {
                if(css_props[prop]) {
                    if (def.desc) {
                        css_props[prop].desc = def.desc;
                    }
                    if (def.examples) {
                        css_props[prop].examples = def.examples;
                    }
                }
            })

            //fill missing
            css_props['overflow'].values = css_props['overflow-x'].values;

            //Official MDN props
            var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/mdn.syntaxes.json');

            var str = require('fs').readFileSync(file, {encoding: 'utf8'});
            mdn_syntaxes = JSON.parse(str)

            var getSyntaxValues = function(s) {
                var r = [];
                var a = s.split(/[\|\?]/);
                for(var i = 0; i < a.length; i++) {
                    a[i] = a[i].replace(/[\[\]\#\&]/g, '').trim();
                    if(a[i].length) {
                        if (a[i].indexOf('(') >= 0) {
                            //ignore functions
                        } else if (a[i].indexOf('<') >= 0) {
                            var s = a[i].replace(/[\<\>\#\?]/g, '').trim();
                            if(s !== 'named-color') {
                                if (mdn_syntaxes[s]) {
                                    getSyntaxValues(mdn_syntaxes[s].syntax).forEach(function (v) {
                                        if (r.indexOf(v) < 0) {
                                            r.push(v);
                                        }
                                    })
                                }
                            }
                        } else {
                            if(r.indexOf(a[i]) < 0 && a[i].charCodeAt(0) >= 97) {
                                r.push(a[i]);
                            }
                        }
                    }
                }
                r.sort();
                return r;
            }


            var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/mdn.css.props.json');

            var str = require('fs').readFileSync(file, {encoding: 'utf8'});
            var props = JSON.parse(str)

            mdn_css_props_options = []
            mdn_css_props_options_map = {}

            $.each(props, function(prop, def) {
                /*
                if(prop === 'display') {
                    debugger;
                }

                 */
                var values = getSyntaxValues(def.syntax);

                var pd = {
                    key: prop,
                    prop: prop,
                    values: values.length ? values : null,
                    mdn_url: def.mdn_url,
                    inherited: def.inherited,
                    group: def.groups[0]
                }

                mdn_css_props_options.push(pd)

                mdn_css_props_options_map[prop] = pd;
            })

            //console.log(mdn_css_props_options)

       } catch(err) {
            console.error(err)
           //pinegrow.showAlert('Can not load CSS info file.', 'Error');
          css_info = null;
        }
    }

    loadCSSInfo();

    //this.

    this.getCSSPropertiesOptions = function() {
        return mdn_css_props_options;
        return css_props_options;
    }

    this.getCSSPropertyValues = function(prop) {
        if(mdn_css_props_options_map[prop]) {
            return mdn_css_props_options_map[prop].values || null;
        }
        return null;
    }

    this.getCSSPropertyValuesRegEx = function(prop) {
        if(mdn_css_props_options_map[prop]) {
            if(!mdn_css_props_options_map[prop].values) return null;
            if(mdn_css_props_options_map[prop].values_regex) return mdn_css_props_options_map[prop].values_regex;
            var t = '';
            for(var i = 0; i < mdn_css_props_options_map[prop].values.length; i++) {
                if(t.length) t += '|';
                t += pgParserEscapeRegExp(mdn_css_props_options_map[prop].values[i]);
            }
            t = '(^|\\s)(' + t + ')(?=\\s|$)';
            var re = new RegExp(t, 'ig');
            mdn_css_props_options_map[prop].values_regex = re;
            return re;
        }
        return null;
    }

    this.getCSSPropertyInfo = function(prop) {
        var i = css_props[prop] || {};
        //i.desc = `The gap CSS property sets the gaps (gutters) between rows and columns. It is a shorthand for row-gap and column-gap.`
        i.desc_html = `<div class="pg-css-prop-desc"><div>${i.desc}</div><p class="pg-css-prop-desc-more"><a href="#" class="external">Learn more on MDN</a></p></div>`;
        return i;
    }

    var getLonghandLevel = function(a, b) {
        if(!b.startsWith(a)) return 0;
        var aa = a.split('-');
        var bb = b.split('-');
        if(aa[0] !== bb[0]) return 0;
        var idx = 1;
        while(aa.length > idx && bb.length > idx && aa[idx] === bb[idx]) {
            idx++;
        }
        return (aa.length - idx) - (bb.length - idx);
    }

    var getShorthandList = function(list, for_prop) {
        var r = [];
        var prev_level = 0;
        var prev_prop = "dummybubi";

        list.forEach(function(prop) {
            if(!for_prop || (prop.startsWith(for_prop + '-'))) {
                var lev = getLonghandLevel(prev_prop, prop);
                if (lev === 0) {
                    r.push(prop);
                    prev_prop = prop;
                }
            }
        })
        return r;
    }

    this.getCSSPropertiesForSection = function(sec, for_prop) {
        return getShorthandList(css_props_info[sec].props, for_prop);
    }

    //debugger;
    //console.log('BUBI TEST', this.getCSSPropertiesForSection('border'))
    //console.log('BUBI TEST', this.getCSSPropertiesForSection('border', 'border'))
}