window.pgDevVersion = true;

window.pgTestMode = false;

var win = require('nw.gui').Window.get();
win.showDevTools();

$(function() {

    /*
    $('body').one('pinegrow-ready', function (e, pinegrow) {

        setTimeout(function() {
            var t = new PgSmartCSSPropsMatcher();
            t.runTests();

            var q = PgQuickClassTree()
        }, 4000)


    });

*/

    $('body').one('pinegrow-ready', function (e, pinegrow) {

        if(pgTestMode) {
            pinegrow.addEventHandler('on_undo_state_added', function () {
                //undo - redo each operation
                pinegrow.undoManager.undo();
                pinegrow.undoManager.redo();
            });
        }

        $(window).on('aaaaresize', function() {
            var w = $('body').width();
            var h = (w / 16 * 9) - 36;
            $('#layout-container').css('height', h + 'px');
        })

        pinegrow.showQuickMessage('DEV MODE - Will look for live changes to edit.css', 3000);

        var theme = pinegrow.getWorkspaceTheme();

        var path = require('path');
        var fs = require('fs');
        var file = 'lib/crsa/edit.theme.' + theme + '.css';
        file = path.join( process.cwd(), file);

        fs.watchFile(file, {interval: 2000}, function() {
            var str = fs.readFileSync(file, {encoding: 'utf8'});
            var ss = $('link[href="lib/crsa/edit.theme.' + theme + '.css"],.live-css');
            ss.replaceWith($('<style class="live-css">' + str + '</style>'));
        })


        var generatePageThumb = function() {
            var page = pinegrow.getSelectedPage();
            page.activeView.setDeviceSize(1024, 1024);

            var path = require('path');
            var filePath = path.resolve( path.dirname(page.localFile), '../screenshots/' + path.basename(pinegrow.getCurrentProject().getDir()) + '.' + path.basename(page.localFile) + '.jpg');

            console.log(filePath);

            page.get$Html().find('body').css('overflow', 'hidden');

            pinegrow.takePhotoOfPage(page, filePath, function() {
                pinegrow.showQuickMessage('Image generated in ' + filePath);
            }, 600)
        }


        pinegrow.addEventHandler('on_key_pressed', function(page, e, status) {
            if (status.key == '/' && status.ctrl) {
                status.done = true;
                generatePageThumb();
                return;
            } else if (status.key == '-' && status.ctrl) {

                //var func = new Function(`return { a: 'b'}}`);
                var $d = pinegrow.showAlert(`<div class="test"></div>`, 'Composer test');
                var ct = new PgComposerTester($d.find('.test').get(0));
                return;


                var test = new PgSimpleJsParserTest();
                test.test3();
                return;

                var q = PgQuickFloatingToolsWindow();
                status.done = true;
                return;

                var React = require('react');
                var ReactDOMServer = require('react-dom/server');

                /*
                lib.components = {}

                1. Insert from LIB to page

                Simple, just get HTML

                2. Customize

                Edit props
                How to save the props?
                    //- JSON in comment
                    - JSON in attr
                    //- Include React comp in HTML - But than need .html export
                    - Implement .getData function
*/
var react_comp = `
               
                class MyComponent extends React.Component {
                    render() {
                     
                        return (
                            <button onClick={() => this.setState({ liked: true })}>
                                Like
                            </button>
                        );
                    }
                }
                
                window.MyComponent = MyComponent;
`;



                var js = Babel.transform(react_comp, {
                    plugins: ["transform-react-jsx"]
                });

                console.log(js);

                var geval = eval;

                eval(js.code);

                console.log(ReactDOMServer.renderToString(React.createElement(MyComponent)));

                status.done = true;
                //var q = PgAnimationEditorQuickView();
                //pgShowQuickImageBrowser();
            } else if(false && status.key === ',' && status.ctrl) {
                //return;

                var page = pinegrow.getSelectedPage();
                var c = 0;
                var nos = 0;
                page.sourceNode.walk(function(pgel) {
                    if(pgel.isElementOrScript) {
                        var list = pgel.getUniqueSelectors(0, 2, true)
                        if (list.length) {
                            list.forEach(function (sel) {
                                if (page.sourceNode.findOne(sel) !== pgel) {
                                    console.error('Selector issue', sel, pgel)
                                }
                            })
                        } else {
                            nos++;
                            console.log('No selector for', pgel)
                        }
                        c++;
                        if (c % 100 === 0) console.log(c)
                    }
                    return true;
                })
                console.log(`Did ${c} elements, ${nos} without selectors`)
            }
        })



        var getCSSPropsTree = function(done) {
            fetch('/lib/crsa/dev/css_tree.txt')
                .then(function(response) {
                    return response.text();
                })
                .then(function(text) {

                    var top = {}

                    var c_level = 0;
                    var c_parent = null;
                    var c_list = null;
                    var c_section = null;
                    var c_prev_item = null;
                    var c_parent = null;

                    var lines = text.split("\n");
                    lines.forEach(function(line) {
                        line = line.replace(/    /g, "\t");
                        var level = 0;
                        line = line.replace(/\t+/g, function(m) {
                            level = m.length;
                            return "";
                        })
                        line = line.trim();

                        //console.log(`${level} ${line}`)

                        if(level === 0) {
                            c_section = line;
                            c_list = [];
                            top[c_section] = {
                                sub: c_list,
                                level: 0,
                                parent: null
                            }
                            c_prev_item = top[c_section]
                            c_parent = top[c_section]
                            c_level = 0
                        } else {
                            if(c_level === level) {
                                var d = {
                                    name: line,
                                    level: level,
                                    parent: c_parent,
                                    sub: []
                                }
                                c_list.push(d)
                                c_prev_item = d;

                            } else if(c_level < level) {
                                c_parent = c_prev_item;
                                c_list = c_parent.sub

                                var d = {
                                    name: line,
                                    level: level,
                                    parent: c_parent,
                                    sub: []
                                }
                                c_list.push(d)
                                c_prev_item = d;

                            } else if(c_level > level) {
                                while(c_parent.level >= level) {
                                    c_parent = c_parent.parent;
                                    c_list = c_parent.sub;
                                }

                                var d = {
                                    name: line,
                                    level: level,
                                    parent: c_parent,
                                    sub: []
                                }
                                c_list.push(d)
                                c_prev_item = d;
                            }
                        }
                        c_level = level;
                    })



                    var clean = function(list) {
                        list.forEach(function(item) {
                            delete item.parent;
                            delete item.level;
                            if(item.sub.length) {
                                clean(item.sub);
                            } else {
                                delete item.sub;
                            }
                        })
                    }

                    $.each(top, function(key, def) {
                        clean(def.sub);
                    })

                    //console.log('tree map', top)

                    done(top)
                })
        }

        var getMDNInfoForCSSProp = function(prop, done) {
            var data = {
                name: prop,
                examples: [],
                desc: null
            }

            console.log('Getting ' + prop + '...')
            fetch('https://developer.mozilla.org/en-US/docs/Web/CSS/' + prop)
                .then(function(response) {
                    return response.text();
                })
                .then(function(text) {
                    console.log('Got ' + prop + '.')
                    var p = new pgParser();
                    p.assignIds = false;
                    p.parse(text);

                    var article = p.rootNode.findOne('#wikiArticle');

                    if(!article) {
                        done(null)
                        return;
                    }
                    var ps = article.find('>p');

                    var pdesc = null;
                    for(var i = 0; i < ps.length; i++) {
                        if(ps[i].html().length) {
                            pdesc = ps[i];

                            pdesc.find('a').forEach(function(a) {
                                a.setAttribute('href', 'https://developer.mozilla.org' + a.getAttribute('href'));
                                a.addClass('external');
                            })
                            data.desc = pdesc.html();
                            break;
                        }
                    }

                    var examples = article.findOne('iframe');
                    if(examples) {
                        var src = examples.getAttribute('src');

                        console.log('Getting example for ' + prop + '...')

                        fetch(src)
                            .then(function(response) {
                                return response.text();
                            })
                            .then(function(text) {
                                console.log('Got example for ' + prop + '.')
                                var p = new pgParser();
                                p.assignIds = false;
                                p.parse(text);

                                var list = p.rootNode.find('.example-choice');
                                list.forEach(function(ec) {
                                    var code = ec.findOne('code').text();
                                    //code = code.replace(prop + ': ', '');
                                    data.examples.push(code);
                                })
                                done(data)
                            })
                    } else {
                        done(data)
                    }
                })
        }

        var fillMDNInfo = function() {

            var version = 1;

            var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/css_desc.json');

            try {
                var txt = require('fs').readFileSync(file, {encoding: 'utf8'});
                var css_info = JSON.parse(txt);
            } catch(err) {
                var txt = require('fs').readFileSync(pgGetAppFilePath('/lib/crsa/pgeditor/resources/css_info.json'), {encoding: 'utf8'});
                var css_all_info = JSON.parse(txt);
                var css_info = {}

                $.each(css_all_info.properties, function(prop, def) {
                    css_info[prop] = {};
                })
            }

            var save = function() {
                require('fs').writeFileSync(file, JSON.stringify(css_info), {encoding: 'utf8'});
            }

            var doOne = function() {
                var prop = null;
                var prop_name = null;
                $.each(css_info, function(key, def) {
                    if(!def.v || def.v != version) {
                        prop = def;
                        prop_name = key;
                        return false;
                    }
                })
                if(prop) {
                    getMDNInfoForCSSProp(prop_name, function(data) {
                        if(data) {
                            prop.desc = data.desc;
                            prop.examples = data.examples;
                        }
                        prop.v = version;
                        save();
                        console.log(data)
                        doOne();
                    })
                }
            }

            doOne();
        }

        var exportCSSPropsTree = function() {

            return;

            var html = '';

            var doLevel = function(key, for_prop, indent) {
                var list = pinegrow.devTools.getCSSPropertiesForSection(key, for_prop)
                list.forEach(function(prop) {
                    html += indent + prop + "\n";

                    doLevel(key, prop, indent + "\t");
                })
            }

            $.each(pinegrow.devTools.getCSSPropsInfo(), function(key, def) {
                html += key + "\n";
                doLevel(key, null, "\t");
            })

            var file = pgGetAppFilePath('/lib/crsa/dev/css_tree.txt');
            require('fs').writeFileSync(file, html, {encoding: 'utf8'});

        }



        var getCSSInfo = function() {

            //https://chromium.googlesource.com/chromium/src/+/master/third_party/blink/renderer/core/css/css_properties.json5

            var css_info = {
                properties: {

                },
                inherited: [],
                sections: {

                }
            }

            var save = function() {
                var file = pgGetAppFilePath('/lib/crsa/pgeditor/resources/css_info.json');
                require('fs').writeFileSync(file, JSON.stringify(css_info), {encoding: 'utf8'});
            }

            var no_section = []

            fetch('/lib/crsa/dev/chromium_css_info.js')
                .then(function(response) {
                    return response.text();
                })
                .then(function(text) {
                    var data = JSON5.parse(text)
                    console.log(data);

                    //properties
                    var list = []

                    var sections = pinegrow.devTools.getCSSPropsInfo();

                    var getSection = function(prop) {
                        $.each(sections, function(key, def) {
                            if(('_' + prop.name + '_').match(def.re)) {
                                if(!css_info.sections[key]) {
                                    css_info.sections[key] = {
                                        list: []
                                    }
                                }
                                css_info.sections[key].list.push(prop.name)
                                prop.section = key;
                                return false;
                            }
                        })
                    }

                    data.data.forEach(function(prop) {
                        if(!prop.name.startsWith('-') && !prop.svg) {
                            var d = {
                                name: prop.name,
                                inherited: prop.inherited || false
                            }
                            if (prop.alias_for) {
                                d.alias_for = prop.alias_for;
                            }
                            if (prop.longhands) {
                                d.longhands = prop.longhands;
                            }
                            if (prop.keywords) {
                                d.values = prop.keywords;
                            }
                            list.push(d)

                            if (d.inherited) {
                                css_info.inherited.push(d.name)
                            }

                            getSection(d)
                        }
                    })

                    list.sort(function(a, b) {
                        return a.name.localeCompare(b.name)
                    })

                    list.forEach(function(d) {
                        css_info.properties[d.name] = d;

                        if(!d.section) {
                            no_section.push(d.name)
                        }
                    })

                    $.each(css_info.sections, function(key, def) {
                        def.list.sort();
                    })

                    getCSSPropsTree(function(top) {

                        $.each(top, function(key, def) {
                            css_info.sections[key].tree = def.sub;
                        })

                        save()

                        console.log('NO SECTION:', no_section)
                    })


                });

            return;

            var inherit = [];

            var pb = new PgPluginBuilder();
            var url = 'https://developer.mozilla.org/en-US/docs/Web/CSS/Reference?raw&macros'
            pb.getSourceNode(url, function(html) {
                var index = html.findOne('.index');
                index.find('a').forEach(function(a) {
                    var txt = a.text();
                    if(txt.startsWith(':') || txt.startsWith('@') || txt.indexOf('(') >= 0) {
                        //skip
                    } else {
                        var aurl = a.getAttribute('href') + '?raw&section=Specifications&macros';
                        if(!crsaIsAbsoluteUrl(aurl)) {
                            aurl = 'https://developer.mozilla.org' + aurl;
                        }
                        pb.getSourceNode(aurl, function(node) {
                            if(!node) {
                                console.log(`${aurl} not loaded`)
                                return
                            }
                            node.find('td').forEach(function(td) {
                                if(td.text() == 'yes') {
                                    inherit.push(txt);
                                    console.log(inherit)
                                }
                            })
                        })
                    }
                })
            });

        }


        //Debug toString Issues
        /*
        var $debug = null;
        var q = new PgQuickDialog('BUBI DEBUGGER', function($element) {
            $debug = $element;
            return '';
        }, {width:480})

        pinegrow.addEventHandler('on_element_selected', function(page, pgel) {
            $debug.html(pgel.toDebug() + '<pre>' + escapeHtmlCode(pgel.toStringOriginal()) + '</pre>');
            q.win.autoSize();
        })
        */



        return;

        setTimeout(function() {
            var io = require('socket.io-client');
            var pinegrow_url = 'http://localhost:40001/editor';
            var editor_api = null;

            editor_api = io.connect(pinegrow_url);

            editor_api.on('connect', function () {
                pinegrow.showQuickMessage('Connected');
            });

            editor_api.on('disconnect', function () {
                pinegrow.showQuickMessage('Dis-Connected');
            });

            editor_api.on('error', function () {
                pinegrow.showQuickMessage('Error');
            });

            editor_api.on('connect_error', function () {
                pinegrow.showQuickMessage('Connect error');
            });

            editor_api.on('codeChanged', function (data) {
                //console.log('code changed');
                pinegrow.showQuickMessage('Code changed');
            });

            editor_api.on('elementSelectedInPreview', function (data) {
                pinegrow.showQuickMessage('elementSelectedInPreview');
            });

            editor_api.on('listOfOpenFiles', function(data) {
                pinegrow.showQuickMessage('listOfOpenFiles');
            })
        }, 1000)

    })
})
