$(function () {

    var init = function() {

        var dumpObserver = function() {
            //Looking for crashdumps
            console.log('LIVE: Setting up the dump observer...');
            try {
                var gui = require('nw.gui');
                var data_path = gui.App.dataPath;
                var path = require('path');
                var dir;
                if (is_mac) {
                    dir = path.join(data_path, '../Crashpad/completed')
                } else if (is_windows) {
                    dir = path.join(data_path, 'User Data/CrashPad/completed');
                } else {
                    dir = path.join(data_path, 'Crash Reports/completed');
                }
                var list = []
                var dialog_shown = false;
                var fs = require('fs');
                fs.watch(dir, {persistent: true}, function (event, name) {
                    console.log('LIVE Dump watcher: a crash report was generated ' + name + ', ' + event);
                    var t = Date.now();
                    list.push({time: t, name: name});
                    var cut = t - 30 * 1000; //how many in 10 seconds
                    var cut_idx = -1;
                    for (var i = 0; i < list.length; i++) {
                        if (list[i].time < cut) {
                            cut_idx = i;
                        } else {
                            break;
                        }
                    }
                    if (cut_idx >= 0) {
                        list.splice(0, cut_idx + 1);
                    }
                    if (list.length > 5 && !dialog_shown) {
                        dialog_shown = true;

                        pinegrow.showAlert(`<p>A large number of crash dumps (${list.length} in the last 20s) are being created in <code>${dir}</code> folder. This usually happens in connection with embeded browser rendered crashes.</p><p>Sorry about this! We are working on a better solution. For now, please save your work and restart Pinegrow. You might also want to delete all files in the above mentioned folder.</p><p>Please contact our support on support@pinegrow.com if this happens often.</p>`, 'Too many crash dumps generated');
                    }

                    if(pgIsDev()) {
                        pinegrow.showQuickError(`DEV: Crash dump created!`);
                    }
                })
                console.log(`LIVE: Dump observer is watching ` + dir);
            } catch(err) {
                console.warn(`LIVE: Unable to launch the dump observer.`, err);
            }
        }

        dumpObserver();

    }

    //This could be loaded with async. Perhaps pinegrow is already initialized?
    if(typeof pinegrow !== 'undefined' && pinegrow.ready) {
        init();
    } else {
        $('body').one('pinegrow-ready', function (e, pinegrow) {
            init()
        })
    }
})