
var PgQuickProperties = function(sections, pgel, $el, title, h, just_obj, add_autosize, force_defs) {

    if(h === undefined) {
        h = Math.floor($('body').height() * 0.75);
    }
    var view = new PgPropertiesView(sections, true, force_defs);

    var win = this.win = new PgQuickWindow(title || 'Quick Properties', view, 'quickProperties', 400, h, false);

    win.noRightEdge();

    win.showFor$El($el);

    view.quickWin = win;
    view.setQuickWinTitle = !title;

    view.show(pgel, just_obj);

    if(sections) {
        win.autoSize(add_autosize);
    }

    win.onDestroy = function() {
    }
}

var PgPropertiesView = function(only_sections, in_quick_win, force_defs) {

    //View implementation is responsible for creating DOM and adding it to document.

    var $element = $('<div class="crsa-panel crsa-properties"></div>');

    if(only_sections) $element.addClass('crsa-properties-compact');

    var view = new PgUIView($element, 'prop', 'Props');

    this.view = view;

    this.just_obj = false;


    view.tabIcon = 'icon-settings';

    var _this = this;
    var current_pgel = null;

    var show_props = new PgShowProperties($element);

    show_props.scrollParentSelector = '.pg-grid';

    show_props.onlySections = only_sections;
    show_props.forceDefinitions = force_defs;

    //show_props.show(null);

    if(!only_sections) {
        var show_general = new PgShowProperties($element);
        show_general.showCustomSections = false;

        show_general.scrollParentSelector = '.pg-combined-panel-master';

        var combo = new PgCombinedPanelView('propertiesCombo4' + (in_quick_win ? 'Quick' : ''), show_general.view, show_props.view, null, 75);

        show_props.showName = false;

        $element.append(combo.view.get$Element());

        //show_general.show(null);

        var general_sections = ['attributes', 'pg-classes', 'pg-info', 'pg-attributes'];

        show_props.filterSection = function(key, def) {
            if(last_prop_options.filter_sections) {
                var r = last_prop_options.filter_sections(key, false);
                if(r === false || r === true) return r;
            }
            return general_sections.indexOf(key) < 0 && (key !== 'pg-classes');
        }

        show_general.filterSection = function(key, def) {
            if(last_prop_options.filter_sections) {
                var r = last_prop_options.filter_sections(key, true);
                if(r === false || r === true) return r;
            }
            return general_sections.indexOf(key) >= 0;
        }
    } else {
        show_props.view.get$Element().appendTo($element);
    }

    if(in_quick_win) {
        show_props.showName = false;
        if(show_general) show_general.showName = false;
    }

    var onElementSelected = function(page) {
        if(!_this.just_obj) {
            var pgel = pinegrow.selectedElements.getLastSelected();
            _this.show(pgel, null, _this.just_obj);
        }
    }

    var last_prop_options = null;
    var first_show = false;

    this.show = function(pgel, just_obj) {
        this.just_obj = just_obj;
        view.whenVisible(function() {

            general_sections = ['pg-classes', 'pg-info', 'pg-attributes'];

            if(pgf.kids) {
                general_sections.pop();
            }

            first_show = true;

            if(pgel) {

                var page = pgel.getPage();

                if(page) {

                    //Using class styles hack
                    if (page.classSetter === pinegrow.classStyles) {
                        general_sections.shift();//remove classes
                        general_sections.unshift('attributes');
                        general_sections.unshift('html.page');
                    }

                    if(pgf.kids) {
                        general_sections.unshift('pg.html.link');
                        general_sections.unshift('attributes');
                        general_sections.unshift('html.page');
                    }

                    var prop_options = {
                        show_device_size_control: false,
                        show_styles_control: false,
                        show_classes_control: false,
                        filter_sections: null,
                        show_custom_sections_in_general: false
                    }

                    pinegrow.dispatchEvent('on_before_properties_shown', page, show_props, prop_options);

                    last_prop_options = prop_options;

                    if (prop_options.show_custom_sections_in_general) {
                        show_general && (show_general.showCustomSections = true);
                        show_props.showCustomSections = false;
                    } else {
                        show_general && (show_general.showCustomSections = false);
                        show_props.showCustomSections = true;
                    }
                }
            }
            if(show_general) {
                show_general.show(pgel, null, just_obj);

                if(!pgel || pgf.kids) {
                    combo.hideSecondPanel();
                } else {
                    combo.showSecondPanel();
                }
            }
            show_props.show(pgel, null, just_obj, prop_options);
        })
        current_pgel = pgel;

        if(this.quickWin && this.setQuickWinTitle) {
            if(pgel) {
                var page = pgel.getPage();
                var def = page ? page.getMainType(null, pgel) : null;
                this.quickWin.setTitle('Properties for ' + pinegrow.selectedElements.getName({short: true, def: def, num_classes: -1}));
            } else {
                this.quickWin.setTitle('Element properties');
            }
        }
    }

    if(!in_quick_win) {
        this.show(null);
    }

    var onFrameworksChanged = function() {
        if(pinegrow.getSelectedPage()) {
            _this.show(current_pgel, _this.just_obj);

            /*
            view.whenVisible(function () {
                show_props.show(current_pgel, null, _this.just_obj, last_prop_options);
                if(show_general) show_general.show(current_pgel);
            })*/
        }
    }

    view.onAddedToLayout = function(c) {
        if(combo) {
            combo.onAddedToLayout();
        }
    }

    view.onResize = function() {
        if(combo) combo.view.onResize();
        show_props.updateLayout();
        if(show_general) show_general.updateLayout();
    }

    $('body')
    //.on('crsa-element-selected', onElementSelected)
        .on('crsa-frameworks-changed', onFrameworksChanged);

    //this event is triggered by fields on change. We use it to dispatch another event used for syncing changes across diff Prop windows
    $element.on('crsa-field-value-changed', function(event) {
        pinegrow.dispatchEventDelayedForObject(current_pgel, 'on_prop_field_changed', null, current_pgel, {source: _this})
        return false;
    })

    $element.on('crsa-refresh-properties', function(event) {
        _this.show(current_pgel, _this.just_obj);
        return false;
    })

    var onPropFieldChanged = function(page, pgel, info) {
        if(info && info.source && info.source == _this) {
            show_props.updateHasDataDelayed();
            if(show_general) show_general.updateHasDataDelayed();
            return;
        }
        onElementSelected();
    }

    pinegrow.addEventHandler('on_prop_field_changed', onPropFieldChanged);

    pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);

    var onClassesChanged = function(page, col, info) {
        var control = show_general?.classes_control || show_props?.classes_control;

        if(control && info && info?.source === control) {
            control.ignore_update = true;
        }
        onElementSelected();

        if(control && info && info?.source === control) {
            control.ignore_update = false;
        }
    }

    pinegrow.addEventHandler('on_element_classes_changed', onClassesChanged);

    view.onDestroy = function() {
        show_props.show(null);
        if(show_general) show_general.show(null);

        pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);
        pinegrow.removeEventHandler('on_prop_field_changed', onPropFieldChanged);
        pinegrow.removeEventHandler('on_element_classes_changed', onClassesChanged);
        $('body')
        //.off('crsa-element-selected', onElementSelected)
            .off('crsa-frameworks-changed', onFrameworksChanged);
    }
}


var PgShowProperties = function() {

    var current_prop_obj;
    var current_just_obj;
    var current_prop_options;

    this.showCustomSections = true;
    this.showName = true;
    this.forceDefinitions = null;

    this.scrollParentSelector = '.pg-show-properties';

    this.onGetValues = function(pgel, sections_array) {
        return getValuesForObject(pgel, sections_array);
    }

    this.delayedTasks = new PgDelayedTasks();

    var $element = $('<div class="pg-show-properties"></div>');

    var $name = null;

    var view = new PgUIView($element);
    this.view = view;

    this.filterSection = null;

    var grid = new PgUISectionGrid();

    var _this = this;

    this.onlySections = null;

    var notice = new PgPanelNotice();

    notice.$element.appendTo($element);

    $element.append(grid.$element);

    this.show_device_sizes_control = true;
    var device_size_control = null;
    var styles_control = null;
    var classes_control = null;
    var device_size_control_redraw_on_update = false;
    var section_nav_control = null;

    var fields = {};

    this.forgetFields = function() {
        $.each(fields, function(fn, field) {
            field.destroy();
        })
        fields = {}
    }

    var showMessage = function(msg) {
        notice.show(msg);
    }

    this.showMessage = showMessage;

    this.updateLayout = function() {
        grid.updateLayout();
    }

    var values;

    var getValues = function() {
        return values
    }

    this.updateShow = function() {
        this.show(current_prop_obj, null, current_just_obj, current_prop_options);
    }

    var section_map = {}

    var onCurrentDeviceSizeChanged = function(page, def) {
        if(device_size_control) {
            _this.updateShow();
        }
    }

    pinegrow.addEventHandler('on_current_device_size_changed', onCurrentDeviceSizeChanged);


    var onCurrentClassStyleChanged = function(page, style, info) {
        if(styles_control && info.source !== 'element_selected' /* Prop panel will be anyway re-shown if el selected */) {
            _this.updateShow();
        }
    }

    pinegrow.addEventHandler('on_current_class_style_changed', onCurrentClassStyleChanged);

    var onBreakpointsChanged = function(page) {
        device_size_control_redraw_on_update = true;
        _this.updateShow();
    }

    pinegrow.addEventHandler('on_page_frameworks_changed', onBreakpointsChanged);

    var has_data_map = {}

    var open_sections_map = {};

    this.show = function(obj, def, just_obj, prop_options) {

        current_prop_options = prop_options = prop_options || {};

        var profile = new CrsaProfile();

        //selectedCrsaPage && selectedCrsaPage.callFrameworkHandler('on_get_property_panel_options', prop_options, this);


        if(prop_options.show_device_size_control) {
            var states_options = {
                onUpdateDisplay: null,
                onShowMenu: null
            }

            if(prop_options.states_options) {
                states_options = prop_options.states_options;
            }

            if (!device_size_control) {
                device_size_control = new PgDeviceSizesControl();

                device_size_control.setStatesOptions(states_options);

                device_size_control.onDeviceSizeChanged = function(page, def) {
                    //Moved to event handler so that multiple props windows are in sync
                    //_this.updateShow();
                }

                $element.prepend(device_size_control.$element);
                device_size_control.show();
            } else {
                device_size_control.setStatesOptions(states_options);

                if(device_size_control_redraw_on_update) {
                    device_size_control_redraw_on_update = false;
                    device_size_control.show();
                } else {
                    device_size_control.update();
                }
            }

        } else {
            if(device_size_control) {
                device_size_control.hide();
            }
        }

        if(prop_options.show_styles_control) {
            if (!styles_control) {
                styles_control = new PgPropStylesControl();

                $element.prepend(styles_control.$element);
            }
            styles_control.show(obj);
        } else {
            if(styles_control) {
                styles_control.hideControl();
            }
        }

        if(prop_options.show_classes_control) {
            if (!classes_control) {
                this.classes_control = classes_control = new PgElementClassesControl();

                $element.prepend(classes_control.$element);
            }
            classes_control.show(obj);
        } else {
            if(classes_control) {
                classes_control.hide();
            }
        }



        var $dest = grid.$element;

        var $scrollParent = $dest.closest(this.scrollParentSelector);

        var current_scroll_top = $scrollParent.scrollTop();

        $.each(fields, function(fn, field) {
            field.detach();
        })

        grid.clear();

        if(this.onlySections) {
            grid.$element.addClass('pg-grid-compact');
        }

        var same_element = current_prop_obj == obj;

        //var current_scroll_top = same_element ? $scrollParent.scrollTop() : 0;

        current_prop_obj = obj;
        current_just_obj = just_obj;

        $dest.find('.crsa-input-color-picker').spectrum('destroy');

        $dest.addClass('clearable-area');

        pgRemoveMultiselects($dest);
        $dest.trigger('crsa-will-clear-area');
        //$dest.html('');

        notice.show();

        if(!obj) {
            showMessage('Select one or more elements on the page to edit their properties.');
            if($name) pg$Hide($name);
            return;
        } else {

        }

        if(!def && _this.forceDefinitions) {
            def = _this.forceDefinitions[0]
        }

        if(!def) def = getDefinitionForObject(obj, true);

        if(!def) return;

        if(this.showName) {
            if(!$name) {
                $name = $('<div class="pg-show-properties-name"></div>').prependTo($element);
            }
            $name.get(0).innerHTML = `<span>${pgf.kids ? 'Attributes of' : 'Properties for'}</span><name>` + pinegrow.selectedElements.getName({short: true, def: def, num_classes: -1}) + '</name>';
            pg$Show($name);
        }


        //var sections = {};
        var sections_array = [];
        var pgel = null;
        var $el = null;

        var findSectionIndex = function(sections_array, key) {
            for(var i = 0; i < sections_array.length; i++) {
                if(sections_array[i].section_key == key) return i;
            }
            return -1;
        }

        var defs = null;

        if(obj instanceof pgParserNode) {
            pgel = obj;
            $el = pgel.get$DOMElement();

            var selectedCrsaPage = pgel.getPage();

            if(!def.sections) def.sections = {};

            var collection = pinegrow.getCollection(just_obj ? obj : null);

            collection.forEachElement(function(pgel, si, total) {
                defs = _this.forceDefinitions || selectedCrsaPage.getAllTypes(null, pgel, true); //skip actions
                if (defs) {
                    var current_sections = [];
                    for (var i = 0; i < defs.length; i++) {
                        var d = defs[i];
                        if (d.sections) {
                            $.each(d.sections, function (seckey, secdef) {

                                if(_this.onlySections) {
                                    var show = secdef.hasOwnProperty("show") ? secdef.show : true;
                                    if(_this.onlySections.indexOf(secdef) < 0 && show ) {
                                        return true;
                                    }
                                }

                                if(_this.filterSection && !_this.filterSection(seckey, secdef)) return true;

                                secdef.section_key = seckey;
                                secdef.component_definition = d;
                                if (!secdef.framework) secdef.framework = d.framework;

                                if(si == 0) {

                                    var idx = findSectionIndex(sections_array, seckey);
                                    if (idx < 0) {
                                        if ('position' in secdef && secdef.position < sections_array.length) {
                                            sections_array.splice(secdef.position, 0, secdef);
                                        } else {
                                            sections_array.push(secdef);
                                        }
                                    } else {
                                        if (sections_array[idx].inherit) {
                                            sections_array[idx] = secdef;
                                        }
                                    }
                                }
                                current_sections.push(secdef);

                                /*
                                 if(!(seckey in sections) || sections[seckey].inherit) {
                                 sections[seckey] = secdef;
                                 if(!secdef.framework) secdef.framework = d.framework;
                                 }*/
                            });
                        }
                    }
                }
                if(si > 0) {
                    var common_sections = [];
                    sections_array.forEach(function(s) {
                        if(findSectionIndex(current_sections, s.section_key) >= 0) {
                            common_sections.push(s);
                        }
                    })
                    sections_array = common_sections;
                }
            })

            if(collection.length > 1) {

            }

        } else {
            //sections = def.sections ? def.sections : {};
            if(def.sections) {
                $.each(def.sections, function(key, secdef) {
                    sections_array.push(secdef);
                    secdef.section_key = key;
                    secdef.component_definition = def;
                })
            }
        }

        if(obj instanceof pgParserNode) {

            var pgEl = pgel;

            if(!pgEl) {
                showMessage('This is a dynamic element created by JavaScript code. Edit that code to change the element.');

                return;
            }
            var locked = pinegrow.isElementLocked(pgEl);
            if(locked) {
                showMessage('The element is locked: ' + locked);

                return;
            }

            if(pgEl.script_info) {
                showMessage('The element is a server-side script tag. Use Actions -&gt; Edit code (or double click on the element) to edit its code.');
                return;
            }

            if((prop_options.show_device_size_control || this.showCustomSections)  && selectedCrsaPage) {
                selectedCrsaPage.callFrameworkHandler('on_show_properties', sections_array, pgEl, defs, _this);
            }
        }

        if(sections_array.length == 0) {
            showMessage('No other properties are available for the selected element.');
            return;
        }

        values = {};
        var has_multiple_values = {};

        //Pre-create custom cotrols so that definition is done before we get values
        $.each(sections_array, function(i, s) {
            $.each(s.fields, function (fn, fdef) {
                if (fdef.type == 'custom') {
                    if (fdef.control && !fdef.control_defined) {
                        var control = fdef.control();
                        var section = control.define(s.component_definition);
                        if(section) sections_array.push(section);
                        fdef.control_defined = true;
                    }
                }
            })
        })

        if(obj instanceof pgParserNode) {
            //get values for multiple objects
            var common_values = {};

            collection.forEachElement(function(pgel, si, total) {
                var current_values = _this.onGetValues(pgel, sections_array);
                if(total == 1) {
                    common_values = current_values;
                } else {
                    $.each(current_values, function(fn, val) {
                        if(fn == 'bsbckcontext') {
                            //debugger;
                        }
                        if(!(fn in common_values)) {
                            if(!(fn in has_multiple_values)) {
                                common_values[fn] = val;
                            } else {
                                if(has_multiple_values[fn].indexOf(val) < 0) {
                                    has_multiple_values[fn].push(val);
                                }
                            }
                        } else if(common_values[fn] !== val) {
                            if(!(fn in has_multiple_values)) {
                                has_multiple_values[fn] = [common_values[fn]];
                            }
                            if(has_multiple_values[fn].indexOf(val) < 0) {
                                has_multiple_values[fn].push(val);
                            }
                            common_values[fn] = null;
                        } else {
                            //nothing to do
                        }
                    })
                }
            })

            values = common_values;

        } else {
            values = _this.onGetValues(obj, sections_array);
        }

       // console.error(values)

        var on_fields_created = [];

        //var $list = $('<ul/>').appendTo($dest);

        var domobj = obj;

        if(prop_options.show_section_nav_control) {
            if(!section_nav_control) {
                section_nav_control = new PgSectionNavigator();
                device_size_control ? section_nav_control.$element.insertAfter(device_size_control.$element) : $element.prepend(section_nav_control.$element);
            }
            section_nav_control.setGrid({
                hasData: function(key) {
                    return  has_data_map[key] || false;
                },
                scrollTo: function(keys) {
                    keys.forEach(function(key) {
                        section_map[key] && section_map[key].openClose(true);
                    })
                    var sec = section_map[keys[0]] || null;
                    if(sec) {
                        sec.scrollTo();
                    }
                }
            })

            var slist = []
            pinegrow.dispatchEvent('on_get_sections_for_prop_section_nav', selectedCrsaPage, slist);
            section_nav_control.show(slist);
        } else {
            section_nav_control && section_nav_control.hide();
        }


        has_data_map = {}

        $.each(sections_array, function(i, s) {
            var key = s.section_key;
            if (s.show_if) {
                var showSection = typeof s.show_if === 'function' ? s.show_if(obj) : s.show_if;
                if (!showSection) return true;
            }

            if((s.hasOwnProperty("show") && !s.show) || !s.name) return true;

            var force_open = _this.onlySections;

            if(pgf.kids) {
                s.is_closable = false;
            }

            if(s.force_open) {
                force_open = typeof s.force_open === 'function' ? s.force_open(obj) : s.force_open;
            }

            var pgsec = new PgUISection(s.name, (s.framework && !pgf.kids) ? (s.framework.no_prop_section_subtitles ? null : (s.framework.name_short || s.framework.name)) : null, s, null, force_open);

            grid.addSection(pgsec);

            section_map[key] = pgsec;

            var has_repeat_items = false;
            var add_repeat_item_label = 'Add field';
            var on_create_repeat_item_button = null;
            var $repeat_items = [];

            pgsec._propData = {
                controls: [],
                fields: []
            }

            var has_data = false;

            var $c;

            $c = pgsec.$content;

            var $addto = $c;
            var ri = 0;
            var field_list;

            var $prev_addto = null;
            var in_section = false;
            var section_has_value = false;
            var $section = null;

            $.each(s.fields, function(fn, fdef) {

                var $field;
                var field_in_section = false;
                var $s = null;

                var $append_to = fdef.append_to ? $c.find(fdef.append_to) : ($addto || $c)

                if(fdef.hasOwnProperty("show") && !fdef.show) return true;

                if(fdef.show_button_in_section_title) {
                    var show_button_in_section = typeof fdef.show_button_in_section_title === 'function' ? fdef.show_button_in_section_title(obj) : fdef.show_button_in_section_title;
                    if(show_button_in_section) {
                        $append_to = pgsec.$title;
                        pgsec.$title.addClass('has-button');
                    }
                }

                if(fdef.start_repeat_item) {
                    if(fdef.add_repeat_item_label) {
                        add_repeat_item_label = fdef.add_repeat_item_label;
                    }
                    if(fdef.on_create_repeat_item_button) {
                        on_create_repeat_item_button = fdef.on_create_repeat_item_button;
                    } else {
                        on_create_repeat_item_button = null;
                    }
                    ri++;
                    $addto = $('<div class="pg-action-repeat-item" data-repeat-item="' + ri + '"><h5>' + fdef.start_repeat_item + '</h5></div>').appendTo($c);

                    $repeat_items.push($addto);

                    has_repeat_items = true;
                    if(ri > 1 && !fdef.repeat_item_open) {
                        $('<i class="icon icon-bin remove-repeat-item"></i>').appendTo($addto);
                    }
                    field_list = [];
                    $addto.data('repeat-item-fields', field_list)
                    $addto.data('repeat-item-fdef', fdef)

                    if(fdef.repeat_item_open) {
                        $addto.addClass('pg-repeat-item-open');
                    }

                    if(!fdef.append_to) {
                        $append_to = $addto;
                    }
                }

                if(fdef.end_section) {
                    $append_to = $addto = $prev_addto || $c;
                    in_section = false;
                }

                if(fdef.start_section) {
                    $prev_addto = $addto = $append_to;

                    var section_key = `${fn}.${fdef.start_section}`;

                    $s = $(`<div class="pg-action-section ${open_sections_map[key] ? 'open' : ''}"><h6><i class="icon icon-right"></i><i class="icon icon-down"></i> ${fdef.start_section}</h6><div class="fields"></div></div>`).appendTo($addto);
                    $append_to = $addto = $s.find('.fields');

                    in_section = true;
                    section_has_value = false;

                    $s.on('click', 'h6', function(e) {
                        e.preventDefault();

                        if($s.hasClass('open')) {
                            $s.removeClass('open');
                            open_sections_map[key] = false;
                        } else {
                            $s.addClass('open');
                            open_sections_map[key] = true;
                        }
                    })

                    $section = $s;
                }

                field_in_section = in_section;

                var recycled = false;

                if(fdef.type == 'custom') {
                    if(fdef.control) {
                        //recycle control
                        var control;

                        if(fields[fn]) {
                            control = fields[fn];
                            control.setObject(obj);
                            control.setValues(values, has_multiple_values);
                            $append_to.append(control.$element);
                            recycled = true;
                        } else {
                            control = fdef.control();
                            control.setObject(obj);
                            control.setValues(values, has_multiple_values);
                            control.show($scrollParent);
                            $append_to.append(control.$element);

                            fields[fn] = control;


                        }
                        $field = control.$element;
                        pgsec._propData.controls.push(control);
                        has_data = has_data || control.hasData();
                    } else {
                        //.show controls are not recyclable
                        $field = fdef.show($c, obj, fn, fdef, values, $scrollParent, has_multiple_values);
                    }
                } else {
                    var field;

                    //recycle fields
                    if(fields[fn] && !fdef.recreate_on_show) {
                        field = fields[fn];
                        field.setValue((fn in values) ? values[fn] : null);
                        field.appendTo($append_to);
                        //$c.append(field.$field);
                        recycled = true;
                    } else {
                        field = new PgPropertyField($append_to, function () {
                            return current_prop_obj;
                        }, fn, fdef, getValues /*values*/, $scrollParent);
                        fields[fn] = field;
                    }
                    $field = field.$field;

                    field.setHasMultipleValues(has_multiple_values[fn] || false);
                    field.grid_section = pgsec;

                    has_data = has_data || field.hasData();

                    pgsec._propData.fields.push(field)
                }

                if(field_list) field_list.push(fn);

                if (!fdef.without_icon) {
                    if (s.icons) {
                        $field.addClass('with-icons');
                        $('<i class="field-icon icon-' + fn + '"></i>').insertAfter($field.find('>label'));
                        //$('<i class="field-icon icon-' + fn + '"></i>').appendTo($field.find('>label'));
                    }
                }
                if(fdef.on_fields_created) {
                    on_fields_created.push({func: fdef.on_fields_created, obj: obj, field: $field, def: fdef, name: fn, default_value: fdef.default_value || null, recycled: recycled, propField: control || field});
                }
                if(fdef.validate) {
                    pinegrow.validateField(obj, fn, values.hasOwnProperty(fn) ? values[fn] : null, fdef, $field, values);
                }

                if(fdef.show_if) {
                    var show = typeof fdef.show_if == 'function' ? fdef.show_if( values, obj) : crsaEvaluateShowIfString(fdef.show_if, values, fdef, obj);

                  /*  if($field.is(':visible') !== show) {*/
                        if(show) {
                            pg$Show($field, fdef.control ? 'block' : 'flex');
                        } else {
                            pg$Hide($field);
                        }
                  //  }
                }

                if(fdef.on_field_updated) {
                    fdef.on_field_updated(obj, $field, fdef, control, fn, field);

                    if(control && control.shown_fields) {
                        $.each(control.shown_fields, function(key, field) {
                            fdef.on_field_updated(obj, field.$field, field.def, null, key, field);
                        })
                    }
                }

            });

            if(has_repeat_items) {
                $c.on('click', '.remove-repeat-item', function(e) {
                    var $item = $(this).closest('.pg-action-repeat-item');
                    var idx = $item.attr('data-repeat-item');
                    var fdef = $item.data('repeat-item-fdef');
                    if(fdef.on_repeat_item_removed) {
                        fdef.on_repeat_item_removed(_this, $item, fdef);
                    }
                    //removeRepeatItem($item);
                })

                if(add_repeat_item_label !== 'none') {
                    var $add = $(`<div class="pg-action-repeat-item-add"><button class="pg-button add-repeat-item"><i class="icon icon-plus"></i> ${add_repeat_item_label}</button></div>`).appendTo($c);
                    $add.on('click', 'button.add-repeat-item', function (e) {
                        e.preventDefault();
                        var $unused = $c.find('.pg-action-repeat-item').not('.pg-repeat-item-open,.has-value,[data-repeat-item="1"]');
                        if ($unused.length) {
                            $unused.first().addClass('has-value');
                        } else {
                            pinegrow.showQuickError('Sorry, can not add more items.');
                        }
                    })

                    if(on_create_repeat_item_button) {
                        on_create_repeat_item_button($add);
                    }
                }

                //open items with data
                $repeat_items.forEach(function($ri) {
                    if($ri.get(0).querySelector('.has-value')) {
                        $ri.addClass('has-value');
                    }
                })
            }

            if(s.on_section_shown) {
                s.on_section_shown(s, pgsec);
            }

            pgsec.setHasData(has_data);
            has_data_map[key] = has_data;
        });
//        console.log(has_data_map);
        section_nav_control && section_nav_control.updateHasData();

        var updateUsage = function ($div) {
            if (!$div) {
                $div = $dest;
                $div.find('li.has-data').removeClass('has-data');
            }
            else {
                $div.removeClass('has-data');
            }

            $div.find('input, checkbox, select').each(function(i, a) {
                var $input = $(a);
                if (($input.attr('type') == "checkbox" && $input.is(':checked')) ||
                    ($input.attr('type') != "checkbox" && $input.val())) {
                    $input.closest('.section').addClass('has-data');
                }
            });
        }
/*
        var collapsibleSections = new CrsaCollapsibleSections($list, $dest);
        collapsibleSections.show(function ($section) {
            return $section.data('section_def');
        }, updateUsage);
        */

        for(var i = 0; i < on_fields_created.length; i++) {
            var val = values.hasOwnProperty(on_fields_created[i].name) ? values[on_fields_created[i].name] : null;
            if(val === null && on_fields_created[i].default_value) val = on_fields_created[i].default_value;
            on_fields_created[i].func(//todo30 - on_fields_created pgel obj
                on_fields_created[i].obj,
                on_fields_created[i].name,
                val,
                on_fields_created[i].def,
                on_fields_created[i].field,
                values,
                on_fields_created[i].recycled,
                on_fields_created[i].propField);

        }
        on_fields_created = null;

        grid.updateLayout();

        $scrollParent.scrollTop(current_scroll_top);

        profile.show('showProperties');
    }

    var removeRepeatItem = function($item) {
        var $li = $item.parent();
        var pos_top = $li.position().top;
        var idx = $item.attr('data-repeat-item');
        var ri_fields = $item.data('repeat-item-fields');
        var max_items = 10;

        ri_fields.forEach(function(rif) {
            selectedPgel.removeAttribute(rif);
        })

        collection.forEachElement(function (selectedPgel, i, total) {

            var elname = selectedPgel.getName();
            var problems = new pgParserSourceProblem(selectedPgel, null, def.ignore_lock ? true : false);
            var selectedCrsaPage = selectedPgel.getPage();

            var can_add = true;
            if (def.on_can_add_action) {
                if (!def.on_can_add_action(selectedPgel, selectedCrsaPage, def)) {//todo30 - check handlers, last $el arg removed
                    can_add = false;
                }
            }
            if (can_add) {
                if (!canMakeChange(selectedPgel, 'add_action', def)) return;

                willMakeChange(selectedCrsaPage, "Edit action / " + elname);

                var opname = "Edit action / " + def.name;

                ri_fields.forEach(function(rif) {
                    selectedPgel.removeAttribute(rif);
                })

                //compact list, dummy implementation, can be optimized
                var did_move = false;
                while(true) {
                    did_move = false;
                    for (var ri = 2; ri < max_items; ri++) {
                        var has = false;

                        ri_fields.forEach(function (rif) {
                            rif = rif.replace(/[0-9]+/, '');
                            if (selectedPgel.hasAttribute(`${rif}${ri}`)) {
                                has = true;
                            }
                        })

                        if (!has) {
                            ri_fields.forEach(function (rif) {
                                rif = rif.replace(/[0-9]+/, '');
                                if (selectedPgel.hasAttribute(`${rif}${ri + 1}`)) {
                                    selectedPgel.setAttribute(`${rif}${ri}`, selectedPgel.getAttribute(`${rif}${ri + 1}`));
                                    selectedPgel.removeAttribute(`${rif}${ri + 1}`);
                                    did_move = true;
                                }
                            })
                        }
                    }
                    if(!did_move) break;
                }

                showFields(selectedPgel, def, $li, $li.closest('.content'));

                changed_collection.add(selectedPgel);
            }
        })

        if(_this.showAssignedActions) {
            if ($li.closest('.assigned-actions').length) {
                updateAssignedActions();
            } else {
                updateUsage();
            }
        }
        var new_top = $li.position().top;
        var $content = grid.$element;
        var st = $content.scrollTop();
        st = st - (pos_top - new_top);
        $content.scrollTop(st);

        if(changed_collection.getLength() > 0) {
            pinegrow.changeManager.didChange(collection, opname);
        }
    }

    var updateHasData = function() {
        _this.delayedTasks.cancel('updateHasData');

        grid.sections.forEach(function(pgsec) {
            var has = false;
            for(var i = 0; i < pgsec._propData.controls.length; i++) {
                if(pgsec._propData.controls[i].hasData()) {
                    has = true;
                    break;
                }
            }
            if(!has) {
                for(var i = 0; i < pgsec._propData.fields.length; i++) {
                    if(pgsec._propData.fields[i].hasData()) {
                        has = true;
                        break;
                    }
                }
            }
            pgsec.setHasData(has);
        })
    }

    this.updateHasDataDelayed = function() {
        this.delayedTasks.run('updateHasData', updateHasData, 1000);
    }

    this.scrollToSection = function(sec_or_id, open) {
        if(!sec_or_id) return;
        var sec = typeof sec_or_id === 'string' ? (section_map[sec_or_id] || null) : sec_or_id;
        if(sec) {
            if(open && !sec.open) {
                sec.toggle(null, true);
                sec.sec_def && (sec.sec_def.closed = false);
            }
            sec.scrollTo();
        }
    }

    view.onDestroy = function() {
        pinegrow.removeEventHandler('on_current_device_size_changed', onCurrentDeviceSizeChanged);
        pinegrow.removeEventHandler('on_current_class_style_changed', onCurrentClassStyleChanged);
        pinegrow.removeEventHandler('on_page_frameworks_changed', onBreakpointsChanged);
        _this.delayedTasks.destroy();
    }

}

var PgPropertyField = function($c, obj, fn, fdef, values, $scrollParent) {

    this.$field = $.fn.crsa('addInputField', $c, obj, fn, fdef, values, false, $scrollParent);
    this.$input = this.$field.find('input.crsa-input');
    this.def = fdef;
    this.field_key = fn;

    this.$field.data('propertyField', this);

    var input_div = this.$field.get(0).querySelector('div.crsa-input');

    var pgControl = this.$field.data('pgControl');

    if(pgControl) {
        this.$input = pgControl.get$input();
    }

    if(this.$input.length == 0) {
        this.$input = this.$field.find('.crsa-input');
    }

    var onInputValueUpdated = function ($input, value) {
        var $field = $input.closest('.crsa-field');

        var $parent = $input.parent();
        if (value) {
            $parent.addClass('has-value');
        }
        else  {
            $parent.removeClass('has-value');
        }

        if ($field.hasClass('crsa-field-color')) {
            var $colorPlaceholder = $field.find('.color-value-placeholder');
            var spectrumVal = getStylePropWithoutImportant(value);

            var $colorInput = $input.data('color-input');
            if ($colorInput && $colorInput.length > 0) {
                $colorInput.spectrum("set", spectrumVal, false);
            }

            $colorPlaceholder.css('background-color', 'black')
                .css('background-color', spectrumVal);
        }

        if (fdef.type == 'image' || fdef.file_picker || fdef.colors) {
            $input.trigger('pg-on-value-updated');
        }

        if (fdef.rich) {
            var $crsaSelectVal = $input.siblings('.crsa-select-val');
            var crsaSelect = $crsaSelectVal.data('crsa-select');
            crsaSelect.paintVal();
        }
        current_val = value;
    }

    this.$input.on('input change', function (e) {
        onInputValueUpdated($(this), $(this).val());
    });

    var current_val = null;
    if(values) {
        if(typeof values == 'function') values = values();
        current_val = (fn in values) ? values[fn] : null;
    }

    onInputValueUpdated(this.$input, current_val /* this.$input.val() */);

    this.on = function(event, func) {
        this.$input.on(event, func);
    }

    this.setValue = function(value, trigger_event) {

        if(fdef.on_set_field_value) {
            value = fdef.on_set_field_value(value);
        }

        if(pgControl) {
            pgControl.setValue(value);
        } else {
            if(fdef.type === 'checkbox') {
                if(value == fdef.value || (!value && fdef.default_value && fdef.default_value == fdef.value)) {
                    this.$input.prop('checked', true);
                } else {
                    this.$input.prop('checked', false);
                }
            } else {
                this.$input.val(value);
                onInputValueUpdated(this.$input, value);
            }
        }
        current_val = value;

        if(trigger_event) {
            this.$input.trigger('change');
        }
    }

    this.getCurrentValueQuick = function() {
        return current_val;
    }

    this.getValue = function() {
        if(pgControl) {
            return pgControl.getValue();
        } else {
            return fdef.type === 'checkbox' ? (this.$input.prop('checked') ? fdef.value : null) : this.$input.val();
        }
    }

    this.appendTo = function($c) {
        this.$field.appendTo($c);
        this.$field.data('pgDetached', false);
    }

    /* Use CSS instead for PgInput */

    this.setWidth = function(w) {
        this.$input.find('.selector-container').css('width', w + 'px');
    }

    this.detach = function() {
        this.$field.data('pgDetached', true);
        this.$field.detach();
    }

    this.destroy = function() {
        this.$field.remove();
    }

    var has_multiple_values = false;

    this.setHasMultipleValues = function(has) {
        if(has_multiple_values != has) {
            if(has) {
                this.$field.addClass('has-multiple-vals');
            } else {
                this.$field.removeClass('has-multiple-vals');
            }
            has_multiple_values = has;
        }
        if(pgControl && pgControl.setMultipleValues) {
            pgControl.setMultipleValues(has);
        }
    }

    this.hasData = function() {
        if(current_val && Array.isArray(current_val)) return current_val.length > 0;
        return has_multiple_values || (current_val !== null && current_val !== '' && current_val !== false);
    }

    var inherited_value = null;
    var responsive_label = null;
    var value_label = null;

    this.setInheritedValue = function(val, resp_label, key) {
        var field = this.$field.get(0);

        if(pgControl) {
            pgControl.setInheritedValue(key, resp_label);
        } else {

            if (val === null) {
                if (field.classList.contains('has-inherited-value')) {
                    field.classList.remove('has-inherited-value');
                }
            } else {

                if (!inherited_value) {
                    inherited_value = document.createElement("div");
                    inherited_value.classList.add('inherited-value');

                    responsive_label = document.createElement("span");
                    responsive_label.classList.add('responsive-label');
                    inherited_value.append(responsive_label);

                    value_label = document.createElement("span");
                    value_label.classList.add('value-label');
                    inherited_value.append(value_label);

                    if(fdef.type === 'checkbox') {
                        var label = this.$field.get(0).querySelector('label');
                        label && label.append(inherited_value);

                    } else if (input_div) {
                        input_div.append(inherited_value);
                    }
                }

                responsive_label.innerText = resp_label;

                if(fdef.type === 'checkbox') {
                    value_label.innerHTML = '<i class="icon icon-check"></i>';
                } else {
                    value_label.innerText = fdef.colors ? key : val;
                }

                field.classList.add('has-inherited-value');
            }
        }
    }
}

var pgCustomControlCount = 0;

var PgCustomPropertyControl = function(control_id) {

    var _this = this;

    this.control_id = control_id;

    this.obj;
    this.values;
    this.hasMultipleValues;
    this.$scrollParent;
    this.$element;
    this.$field;

    this.onDefine = null;
    this.onShow = null;
    this.onSetObject = null;
    this.onSetValues = null;
    this.onDestroy = null;

    this.destroyed = false;

    this.fields = null;
    this.shown_fields = {};

    this.shown = false;

    //Internal funcs, called by PG
    this.setObject = function(obj) {
        this.obj = obj;

        $.each(this.shown_fields, function(fkey, field) {
            if(field instanceof PgCustomPropertyControl) {
                field.setObject(obj);
            }
        })

        if(this.onSetObject) this.onSetObject.call(this);
    }

    this.setValues = function(values, has_multiple_values) {
        this.values = values;
        this.hasMultipleValues = has_multiple_values || [];

        $.each(this.shown_fields, function(fkey, field) {
            if(field instanceof PgCustomPropertyControl) {
                field.setValues(values, has_multiple_values);
            } else {
                field.setValue(values[fkey] || null);
                field.setHasMultipleValues(has_multiple_values && (fkey in has_multiple_values));
            }
        })

        if(this.shown && this.onSetValues) this.onSetValues.call(this);
    }

    this.define = function(def) {
        if(this.onDefine) this.onDefine.call(this);

        if(!this.fields) return null;

        var section = {
            name: 'Custom',
            show: false,
            fields: this.fields
        }
        if(!def.sections) def.sections = {};

        def.sections[control_id + '.control_fields'] = section;

        return section;
    }

    this.show = function($scrollParent) {
        this.$scrollParent = $scrollParent;
        this.$field = this.$element = this.onShow.call(this);
        this.shown = true;
        if(this.onSetValues) this.onSetValues.call(this);
        return this.$element;
    }

    var getObj = function() {
        return _this.obj;
    }

    this.detach = function() {
        this.$element.detach();
    }

    this.hasData = function() {
        if(this.onHasData) return this.onHasData.call(this);

        if(this.hasMultipleValues && this.hasMultipleValues.length) return true;

        var has = false;
        $.each(this.shown_fields, function(fkey, field) {
            if(field.hasData()) {
                has = true;
                return false;
            }
        })
        return has;
    }

    //funcs that can be used in onDefine
    this.registerInputField = function(key, fdef) {
        if(!this.fields) this.fields = {};
        this.fields[key] = fdef;
    }

    this.registerInputFields = function(fields) {
        this.fields = fields;
    }

    //used in onShow
    this.showInputField = function($c, field, fdef) {
        if(fdef.control) {
            var control = fdef.control();
            control.setObject(getObj());
            control.setValues(this.values, this.hasMultipleValues);
            control.show(this.$scrollParent);
            $c.append(control.$element);
            f = control;
        } else {
            var f = new PgPropertyField($c, getObj, field, fdef, function () {
                return _this.values
            }, this.$scrollParent);
            if (this.hasMultipleValues && (field in this.hasMultipleValues)) {
                f.setHasMultipleValues(true);
            }
        }
        this.shown_fields[field] = f;
        return f;
    }

    this.get$Field = function(field_key) {
        return this.$element.find('.crsa-field-' + field_key.replace(/\./g, '-'));
    }

    this.destroy = function() {
        if(this.onDestroy) {
            this.onDestroy();
        }
        this.destroyed = true;
    }

}