

/*
border-top: 10px solid

bot10s

border-top: thin solid currentColor;
botthinsc

border-top: 10cm solid var(--border-color)
bot10cms--bo

b

:
border
background



State selector
---

dark hover active
---
list most common
more




Class tree
—

Inline
    md:text-pink

Button
    size-lg
    bg-pink
    hover:bg-purple
    md:hover:shadow-1
    md:size-xl

    Big
        md:size-xl9




Inline [ Make style ]
    md:text-pink
    size-lg
    bg-pink
    hover:bg-purple
    md:hover:shadow-1
    md:size-xl

    [All]
        size-lg
        bg-pink

        [hover]
            bg-purple

        [hover, active]
            outline-none

        [ add state ] [ add class ]

    [SM]
    [MD]
        text-pink
        size-xl

        [hover]
            shadow-1

    [LG] [XL] [XXL]


STYLES:

INLINE [ Make sub-style ]

BUTTON.BIG
    [All]
        text-9xl

BUTTON
    [All]
        size-lg
        bg-pink

        [hover]
            bg-purple

        [hover, active]
            outline-none

        [ add state ] [ add class ]

    [SM]
    [MD]
        text-pink
        size-xl

        [hover]
            shadow-1

    [LG] [XL] [XXL]

 */

//Get active classes tree for Pgel

class PgActiveClassesForPgel_Abstract {
    constructor() {
    }

    getTreeChildren() {
        return null;
    }

    populateTreeFata(fata) {

    }

    populateDataItem(data) {

    }

    getCellWidth() {
        return 0;
    }
}

class PgActiveClassesForPgel extends PgActiveClassesForPgel_Abstract {
    constructor(pgel) {

        /*
        Pgel
            Inline
                Class
                Size
                    Class
                    State

            ClassStyle
                Class
                Size
                    State
            ClassStyle
         */
        super();
        var _this = this;

        this.pgel = pgel;

        this.device_sizes_and_states = {}
        pgel.getPage().activeView.getDeviceSizes(this.device_sizes_and_states);

        this.inline = new PgActiveClassesForPgel_ClassStyle(null, this);
        this.styles = [this.inline]
        this.styles_map = {}

        var info = {
            done: false,
            list: []
        }

        pinegrow.dispatchEvent('on_get_active_classes_for_pgel', pgel.getPage(), pgel, info);

        info.list.forEach(function(i) {
            var style;
            if(i.classStyle) {
                style = _this.getStyleContainer(i.classStyle)
            } else {
                style = _this.inline;
            }
            style.addClass(i.size, i.state || 'all', i.class, i);
        })

        this.parent = (pgel.parent && pgel.parent.isElement) ? new PgActiveClassesForPgel(pgel.parent) : null;
    }

    getAvailableStates() {
        return this.device_sizes_and_states.states;
    }

    getStyleContainer(cs) {
        if(!this.styles_map[cs.key]) {
            var c = new PgActiveClassesForPgel_ClassStyle(cs, this);
            this.styles_map[cs.key] = c;
            this.styles.push(c);
            return c;
        }
        return this.styles_map[cs.key];
    }

    toString() {
        var r = `Active classes for ${this.pgel.tagName}:`
        this.styles.forEach(function(s) {
            r += "\n    " + s.toString();
        })
        if(this.parent) {
            r += "\n" + this.parent.toString()
        }
        return r;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'pgel';
    }

    getTreeChildren() {
        return this.styles;
    }

    getParents() {
        var r = []
        var p = this.parent;
        while(p) {
            r.push(p)
            p = p.parent;
        }
        return r;
    }
}



class PgActiveClassesForPgel_ClassStyle extends PgActiveClassesForPgel_Abstract {
    constructor(cs, pgel_obj) {
        super();
        this.sizes = []
        this.sizes_map = {}
        this.classStyle = cs;
        this.parent_pgel_obj = pgel_obj;

        var _this = this;
        var sizes = this.parent_pgel_obj.device_sizes_and_states.sizes;

        for(var i = sizes.length - 1; i >= 0; i--) {
            this.addSize(sizes[i].size);
        }
    }

    addSize(size) {
        var s = new PgActiveClassesForPgel_Size(size, this);
        this.sizes.push(s)
        this.sizes_map[size] = s;
        return s;
    }

    getSize(size) {
        if(this.sizes_map[size]) return this.sizes_map[size];
        return this.addSize(size);
    }

    addClass(size, state, cls, info) {
        this.getSize(size).addClass(state, cls, info);
    }

    toString() {
        var r = `${this.classStyle ? this.classStyle.key : '(inline)'}`;
        this.sizes.forEach(function(s) {
            r += "\n        " + s.toString();
        })
        return r;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'classstyle';
        if(this.classStyle) {
            fata.search_string += this.classStyle.key;
        }
    }

    getTreeChildren() {
        return this.sizes;
    }
}

class PgActiveClassesForPgel_Size extends PgActiveClassesForPgel_Abstract {
    constructor(size, class_style) {
        super();
        this.size = size;

        this.states = []
        this.states_map = {}
        this.parent_class_style = class_style;

        this.add_state = new PgActiveClassesForPgel_AddState(this)
        this.add_class = new PgActiveClassesForPgel_AddClass(this)
    }

    addClass(state, cls, info) {
        this.getState(state).addClass(cls, info);
    }

    addState(state) {
        var s = new PgActiveClassesForPgel_State(state, this);
        this.states.push(s)
        this.states_map[state] = s;
        return s;
    }

    getState(state) {
        if(this.states_map[state]) return this.states_map[state];
        return this.addState(state);
    }

    toString() {
        var r = `${this.size}`;
        this.states.forEach(function(s) {
            r += "\n            " + s.toString();
        })
        return r;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'size';
    }

    getTreeChildren() {
        return this.states.concat([this.add_class, this.add_state]);
    }

    getClassWithSizeAndState(cls) {
        return this.size !== 'all' ? (this.size + ':' + cls) : cls;
    }

    getPgel() {
        return this.parent_class_style.parent_pgel_obj.pgel;
    }

    getStyle() {
        return this.parent_class_style.classStyle;
    }

    getClassPrefix() {
        return this.getClassWithSizeAndState('');
    }
}

class PgActiveClassesForPgel_State extends PgActiveClassesForPgel_Abstract {
    constructor(state, size) {
        super();
        this.state = state;
        this.classes = []
        this.parent_size = size;
        this.add_class = new PgActiveClassesForPgel_AddClass(this);
    }

    addClass(cls, info) {
        var c = new PgActiveClassesForPgel_Class(cls, info, this)
        this.classes.push(c)
    }

    toString() {
        var r = `${this.state}`;
        this.classes.forEach(function(s) {
            r += "\n            - " + s.toString();
        })
        return r;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'state';
    }

    getTreeChildren() {
        return this.classes.concat([this.add_class]);
    }

    getClassWithSizeAndState(cls) {
        return this.parent_size.getClassWithSizeAndState(this.state !== 'all' ? (this.state + ':' + cls) : cls)
    }

    getPgel() {
        return this.parent_size.parent_class_style.parent_pgel_obj.pgel;
    }

    getStyle() {
        return this.parent_size.parent_class_style.classStyle;
    }

    getClassPrefix() {
        return this.getClassWithSizeAndState('');
    }
}

class PgActiveClassesForPgel_Class extends PgActiveClassesForPgel_Abstract {
    constructor(cls, info, state) {
        super();
        this.class = cls;
        this.info = info;
        this.parent_state = state;
    }

    toString() {
        return this.class;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'class';
        fata.search_string += this.class;
    }

    getTreeChildren() {
        return null;
    }

    getCellWidth() {
        return 0;
        var w = pgMeasureTextWidth(this.class) + 30;
        return w;
    }

    getPgel() {
        return this.parent_state.parent_size.parent_class_style.parent_pgel_obj.pgel;
    }

    getClassWithSizeAndState(cls) {
        if(cls === undefined) cls = this.class;
        return this.parent_state.getClassWithSizeAndState(cls)
    }

    getClassPrefix() {
        return this.getClassWithSizeAndState('');
    }

    getState() {
        return this.parent_state;
    }

    getSize() {
        return this.parent_state.parent_size;
    }

    getClassStyle() {
        return this.parent_state.parent_size.parent_class_style;
    }

    changeClassTo(cls, done) {
        var pgel = this.getPgel();
        var current_cls = this.getClassWithSizeAndState(this.class);
        var new_cls = this.getClassWithSizeAndState(cls);
        var style = this.getClassStyle();

        if(style.classStyle) {
            if(style.classStyle.locked) {
                pinegrow.showQuickError('The style is locked.')
                done && done(false);
                return;
            } else {
                pinegrow.makeChanges(pgel, 'Set ' + cls, function () {
                    pinegrow.classStyles.addClassToStyle(pgel, style.classStyle, new_cls, current_cls);
                })
            }
        } else {
            var styles = pinegrow.classStyles.getStylesForPgel(pgel);
            if(styles.length) {
                //this is inline class
                pinegrow.makeChanges(pgel, 'Set ' + cls, function () {
                    pinegrow.classStyles.addClassToStyle(pgel, null, new_cls, current_cls);
                })
            } else {
                var api = new PgApi();
                api.addClass(pinegrow.getCollectionForElement(pgel), [new_cls], null, [current_cls]);
            }
        }
        this.class = cls;
        done && done(true);
    }


    removeClass(done) {
        var pgel = this.getPgel();
        var current_cls = this.getClassWithSizeAndState(this.class);
        var style = this.getClassStyle();

        if(style.classStyle) {
            if(style.classStyle.locked) {
                pinegrow.showQuickError('The style is locked.')
                done && done(false);
                return;
            } else {
                pinegrow.makeChanges(pgel, 'Remove ' + current_cls, function () {
                    pinegrow.classStyles.removeClassFromStyle(pgel, style.classStyle, current_cls);
                })
            }
        } else {
            var styles = pinegrow.classStyles.getStylesForPgel(pgel);
            if(styles.length) {
                //this is inline class
                pinegrow.makeChanges(pgel, 'Remove ' + current_cls, function () {
                    pinegrow.classStyles.removeClassFromStyle(pgel, null, current_cls);
                })
            } else {
                var api = new PgApi();
                api.removeClass(pinegrow.getCollectionForElement(pgel), [current_cls]);
            }
        }
        //this.class = null;
        done && done(true);
    }
}

class PgActiveClassesForPgel_AddClass extends PgActiveClassesForPgel_Abstract {
    constructor(parent) {
        super();
        this.parent = parent;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'add_class';
    }

    getTreeChildren() {
        return null;
    }

    getCellWidth() {
        return 0;
        var w = pgMeasureTextWidth(this.class) + 30;
        return w;
    }

    getPgel() {
        return this.parent.getPgel();
    }

    getStyle() {
        return this.parent.getStyle();
    }
}

class PgActiveClassesForPgel_AddState extends PgActiveClassesForPgel_Abstract {
    constructor(parent) {
        super();
        this.parent = parent;
    }

    populateTreeFata(fata) {
        fata.node = this;
        fata.template_type = 'add_state';
    }

    getTreeChildren() {
        return null;
    }

    getCellWidth() {
        return 0;
        var w = pgMeasureTextWidth(this.class) + 30;
        return w;
    }

    getPgelObj() {
        return this.parent.parent_class_style.parent_pgel_obj;
    }

    getAvailableStates() {
        return this.getPgelObj().getAvailableStates();
    }
}


var PgQuickClassTree = function() {

    var v = new PgClassTreeView();

    var win = new PgQuickWindow('Class tree', v, 'quickClassTree', 400, 700);

    win.showAtPosition(800, 0);

    v.show();

    win.onDestroy = function() {
    }
}


class PgClassTreeCellPgel extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-pgel"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name>
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to select the element.')

        this.on('cell', 'click', this.onClick.bind(this));
    }

    onPopulate() {
        const pgel = this.data.node.pgel;
        this.setHtml('name', pgel.getName({short: true}))
    }

    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
        pinegrow.selectElement(this.data.node.pgel)
    }

}

class PgClassTreeCellClassStyle extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-classstyle"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name>
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to select the element.')

        this.on('cell', 'click', this.onClick.bind(this));
    }

    onPopulate() {
        this.setHtml('name', this.data.node.classStyle ? this.data.node.classStyle.key : '(inline)')
    }

    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
    }
}


class PgClassTreeCellSize extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-size"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name>
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to select the element.')

        this.on('cell', 'click', this.onClick.bind(this));
    }

    onPopulate() {
        this.setHtml('name', this.data.node.size)
    }

    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
    }
}


class PgClassTreeCellState extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-state"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name>
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to select the element.')

        this.on('cell', 'click', this.onClick.bind(this));
    }

    onPopulate() {
        this.setHtml('name', this.data.node.state)
    }

    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
    }
}


class PgClassTreeCellClass extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-class"><input data-element="check" type="checkbox" checked><name data-element="name"></name>
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to select the element.')

        this.on('cell', 'click', this.onClick.bind(this));
        this.on('check', 'change', this.onCheck.bind(this));
        this.on('check', 'click', this.onStopEvent.bind(this));
    }

    onPopulate() {
        this.setHtml('name', this.data.node.class);
        this.getElement('check').checked = this.data.node.disabled !== true;
    }

    onCheck(event) {
        event.preventDefault();
        event.stopPropagation();

        var checked = this.getElement('check').checked;

        /*
        if(!this.canEdit()) {
            this.getElement('check').checked = !this.getElement('check').checked;
            return;
        }*/

        const _this = this;
        if(checked) {
            _this.data.node.changeClassTo(_this.data.node.class, function() {
                _this.data.node.disabled = false;
                _this.onPopulate();
            })
        } else {
            //disable class
            _this.data.node.removeClass(function() {
                _this.data.node.disabled = true;
                _this.onPopulate();
            })
        }
    }

    onStopEvent(event) {
        event.stopPropagation()
    }


    onClick(event) {
        event.preventDefault();
        event.stopPropagation();

        var _this = this;

        var setValue = function() {
            classPreview.destroy();

            _this.data.node.changeClassTo(this.class, function() {
                _this.onPopulate();
            })
        }

        var clearValue = function() {
            classPreview.destroy();

            _this.data.node.removeClass(function() {
                _this.classTreeView.refresh()
            })
        }

        if(this.data.node.info.values) {
            var actions = []
            this.data.node.info.values.forEach(function(v) {
                actions.push({
                    label: v.name,
                    class: v.key,
                    action: setValue,
                    check: v.key === _this.data.node.class,
                    on_mouseenter: function() {
                        classPreview.setClass(v.key, _this.data.node.info.values);
                    },
                    on_mouseleave: function() {
                        classPreview.restore();
                    }
                })
            })
        }

        actions.push({ type: 'divider' })

        actions.push({
            label: '<i class="icon icon-close" style="color:white;margin-right:8px;"></i> Clear',
            action: clearValue,
            on_mouseenter: function() {
                classPreview.setClass(null, _this.data.node.info.values);
            },
            on_mouseleave: function() {
                classPreview.restore();
            }
        })

        var $e = $(event.target);
        var m = new CrsaContextMenu(actions, $e)
        m.showAt(event.pageX, event.pageY, $(event.target).closest('.pg-tree-container'));

        m.onClosed = function() {
            classPreview.destroy();
        }

        var classPreview = new PgFastDOMClassPreviewForPgel(this.data.node.getPgel(), this.data.node.getClassPrefix());
    }
}


class PgClassTreeCellAddClass extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-add-class" >
<i data-element="add" class="icon icon-plus"></i> Add class
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to add a CSS property.')
        this.on('cell', 'click', this.onClick.bind(this));
    }

    onClick(event) {
        var _this = this;
        event.preventDefault();
        event.stopPropagation();

        const menu = new PgAddClassContextMenu(this.data.node.getPgel(), this.data.node.getStyle(), this.data.node.parent.getClassPrefix());

        menu.onClassSet = function() {
            _this.classTreeView.refresh();
        }

        menu.showForEvent(event);
    }
}

class PgClassTreeCellAddState extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-class-tree-add-state" >
<i data-element="add" class="icon icon-plus"></i> Add state
</div>`, type, no_drag);

        this.tooltip('cell', 'Click to add a CSS property.')
        this.on('cell', 'click', this.onClick.bind(this));
    }

    onClick(event) {
        var _this = this;
        event.preventDefault();
        event.stopPropagation();

        var actions = []

        this.data.node.getAvailableStates().forEach(function(s) {
            actions.push({
                label: s,
                action: function() {

                }
            })
        })

        const menu = new CrsaContextMenu(actions, this.$element);
        menu.showAt(event.pageX, event.pageY);
    }
}


var PgClassTreeView = function() {

    pinegrow.registerTreeView(this);

    var $element = $('<div/>', {id: 'pg-tree', class: 'pg-tree pg-css-tree pg-class-tree' });

    var api = new PgApi();

    var search = new PgSearchBox({
        toolbar_on: true
    });

    var toolbar = this.toolbar = search.getToolbar();

    var $toolbar_section = toolbar.addSection('settings').$element;

    var stylesButton = new PgButtonToolbarItem('icon-filter', 'Select what kind of elements to show in the tree.');

    toolbar.addItem('settings', stylesButton);

    var filters = {
        position: {
            label: 'Position',
            desc: 'Show only the elements with inline styles',
            re: /_(top|right|bottom|left|position|z\-index)_/i
        },
        text: {
            label: 'Text',
            desc: 'Show only images',
            re: /font|line-height|_color_|letter-spacing|text-decoration|text-align|text-transform|white-space|word-break|_direction_|text-indent/i
        }
    }

    var default_filter_options = {};

    $.each(filters, function(key, name) {
        default_filter_options[key] = false;
    })

    var filter_options = default_filter_options;

    stylesButton.onClick = function () {

        var menu = new CrsaContextMenu(null, this.$element);

        menu.add({
            type: 'header',
            label: 'Show only:'
        });

        $.each(filters, function(key, info) {
            menu.add({
                label: info.label,
                action: function() {
                    var on = !(filter_options[key] === true);
                    _this.setFilterOption(on ? key : null);
                },
                check: filter_options[key] === true
            })
        })

        menu.add({
            type: 'divider'
        });

        menu.add({
            label: 'Clear filter',
            action: function() {
                _this.setFilterOption(null);
            }
        })

        menu.showForElement(this.$element, null, 8);
    }

    this.setFilterOption = function(key, skip_update) {
        filter_options = $.extend({}, default_filter_options);
        if(key) {
            var info = filters[key];
            filter_options[key] = true;
            stylesButton.setActive(true);
            pinegrow.showMode(info.desc, true);
            setFilterMessage(info.label);
        } else {
            stylesButton.setActive(false);
            setFilterMessage();
        }
        class_tree.setFilterOptions(filter_options);
        if(!skip_update) {
            class_tree.research(true);
        }
    }

    //search.$element.appendTo($element);

    var $selects = search.$element.find('.pg-button-toolbar-section.icons');

    //var spacer = new PgSearchBoxSpacer();
    //spacer.$element.appendTo($element);

    search.onSearch = function(filter) {
        var p = new CrsaProfile();
        if(class_tree) class_tree.search(filter);

        if(filter.length) {
            pg$Show($selects, 'inline-block');
        } else {
            pg$Hide($selects);
        }

        p.show('SEARCH');
    }

    pg$Hide($selects);

    var $filterMsg = $('<div class="pg-tree-filter-msg"><div>Show only: <span></span><i class="close icon icon-close"></i></div></div>').appendTo($element);

    pg$Hide($filterMsg);

    $filterMsg.on('click', function(e) {
        e.preventDefault();
        _this.setFilterOption(null);
    })

    var setFilterMessage = function(msg) {
        if(msg) {
            $filterMsg.find('span').html(msg);
            pg$Show($filterMsg);
            $element.addClass('with-filter-msg');
        } else {
            pg$Hide($filterMsg);
            $element.removeClass('with-filter-msg');
        }
    }

    var $tree = $('<div/>', {class: 'pg-tree-container'}).appendTo($element);

    var view = this.view = new PgUIView($element, 'tree', 'Class Tree');

    var view_prefix = `pg_ct${view.getId()}_`;

    var flag_overriden = view_prefix + 'ov';
    var flag_inherited = view_prefix + 'inh';
    var flag_not_inherited = view_prefix + 'ninh';

    view.classForContainer = 'pg-tree-panel-container';

    var _this = this;

    view.tabIcon = 'icon-Pin11';

    var currentPage;

    view.onShow = function() {

    }


    var menuItems = [
        {
            icon: 'icon-bin',
            name: 'Delete',
            func: function(data) {

            }
        },
        {
            icon: 'icon-duplicate',
            name: 'Duplicate',
            func: function(data) {

            }
        },
        {
            icon: 'icon-hide',
            name: 'Hide / show in Pinegrow',
            key: 'hide',
            func: function(data, $item) {

            }
        },
        {
            icon: '<i class="icon icon-Ins_before"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert before',
            func: function(data) {

            }
        },
        {
            icon: '<i class="icon icon-Ins_after"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert after',
            func: function(data) {
                //showQuickInsertIntoTree(data, 'insertAfter');
            }
        },
        {
            icon: '<i class="icon icon-Append"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert into at beginning (prepend)',
            func: function(data) {

            }
        },
        {
            icon: '<i class="icon icon-Prepend"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert into at end (append)',
            func: function(data) {

            }
        }
    ]

    var menu = new PgTreeNodeMenu(menuItems);

    menu.hide();

    var dimension;

    var tableGrid = new PgTableGrid({
        highlightLevels: false
    });

    tableGrid.variableHeight = true;

    tableGrid.getCellWidthForData = function(data) {
        return data.node.getCellWidth();

        if(data.node.type === 'decl') {
            if(data.node[flag_expanded]) {
                return 0;
            }
            if(!data.cellWidth) {
                data.cellWidth = Math.round(pgMeasureTextWidth(data.node.prop + data.node.value) + 30 + data.html_val_count_colors * 18);
            }
            return data.cellWidth;
        }
        if(data.node.type === 'comment') {
            if(!data.cellWidth) {
                data.cellWidth = Math.round(pgMeasureTextWidth(data.node.text)) + 30;
            }
            return data.cellWidth;
        }
        if(data.node.type === 'add_prop') {
            if(data.fields_shown) {
                data.cellWidth = 200;
            } else {
                data.cellWidth = 22;
            }
            return data.cellWidth;
        }
        return 0;
    }

    tableGrid.getCellHeightForData = function(data) {
        return tableGrid.cellHeight;
    }

    var quickInsertConnector = null;

    tableGrid.onScroll = function() {
        if(quickInsertConnector) {
            quickInsertConnector.updatePosition();
        }
        updateMenuPosition();
    }

    $tree.append(tableGrid.$element);

    menu.$element.appendTo($element);

    //TODO SET templates
    tableGrid.setTemplate(PgClassTreeCellPgel, 'pgel');
    tableGrid.setTemplate(PgClassTreeCellClassStyle, 'classstyle');
    tableGrid.setTemplate(PgClassTreeCellSize, 'size');
    tableGrid.setTemplate(PgClassTreeCellState, 'state');
    tableGrid.setTemplate(PgClassTreeCellClass, 'class');
    tableGrid.setTemplate(PgClassTreeCellAddClass, 'add_class');
    tableGrid.setTemplate(PgClassTreeCellAddState, 'add_state');

    tableGrid.onSetDataToCell = function(data, cell) {
        if(this.data) {
            this.data.cell = null;
        }
        data.cell = cell;

        cell.classTreeView = _this;
        class_tree.populateDataItem(data);

        var node = data.node;

        if(tableGrid.hasChildren(data)) {
            //cell.removeClass('icon', 'noicon');
            if (data.collapsed) {
                cell.addClass('icon', 'icon-right');
                cell.removeClass('icon', 'icon-minus', 'icon-down');
                cell.$element.addClass('collapsed');
            } else {
                cell.removeClass('icon', 'icon-minus', 'icon-right');
                cell.addClass('icon', 'icon-down');
                cell.$element.removeClass('collapsed');
            }
        } else {
            cell.removeClass('icon', 'icon-down', 'icon-right');
            cell.addClass('icon', 'icon-minus');
            cell.$element.removeClass('collapsed');
        }

        var search = data.search || 0;
        cell.$element.removeClass('search-1 search-2 search-0').addClass('search-' + search);

        cell.onPopulate();
    }

    tableGrid.onRepaint = function() {
        menu.setBottom(tableGrid.getHScrollBarSize());
        menu.setRight(tableGrid.getVScrollBarSize());
        updateMenuPosition();
    }


    this.scrollToNode = function(node) {
        var data = getDataForNode(node)
        if(data) {
            tableGrid.scrollTo(data)
        }
    }

    var scrubValue = null;
    var colorValue = null;
    var editValue = null;

    var get$ValueElementValue = function($num) {
        var $value = $num.closest('value,name');
        var text = '';

        var node = $value.get(0);

        for (var i = 0; i < node.childNodes.length; i++) {
            var cn = node.childNodes[i];
            if(cn.nodeType === 3) {
                text += cn.textContent;
            } else if(cn.nodeType === 1) {
                if(cn.tagName === 'COLOR') {
                    text += $(cn).find('> span').text();
                } else {
                    text += cn.textContent;
                }
            }
        }
        return text;
    }

    var refreshDataItem = function(data) {
        if(data) {
            data.populated = false;
            if(tableGrid) {
                tableGrid.updateItem(data);
            }
        }
    }

    var refreshDataItems = function(datas) {
        datas.forEach(function(data) {
            data.populated = false;
        })
        if(tableGrid) {
            tableGrid.updateItems(datas);
        }
    }

    var refreshGrid = function(done) {
        nextFrame.do('refreshGrid', function() {
            //_this.research();
            if(tableGrid) {
                tableGrid.refresh();

                if(!view.isVisible()) {
                    view.whenVisible(function() {
                        tableGrid.show();
                        if(done) done();
                    })
                } else {
                    if(done) done();
                }
            }
        })
    }

    this.updateLayout = function() {
        refreshGrid();
    }


    var onNodeSelectedDeselected = function(pagenull, nodes, info) {
        var datas;
        if(info.source === _this && info.datas) {
            datas = info.datas;
        } else {
            datas = getDatasForNodes(nodes);
        }
        refreshDataItems(datas);
    }





    var wireTreeElements = function() {
/*
        var onChangeValue = function($num, value, is_done) {
            if(value === undefined) value = get$ValueElementValue($num);
            var event = is_done || false;
            var data = getDataForTree$Element($num)
            var node = data ? data.node : null;
            if(node) {
                data.cell.onValueEdited($num.parent().get(0).tagName, value, is_done, 'scrub');
            }
        }

        scrubValue = new PgCSSEditableValue(tableGrid.$container, 'num');

        scrubValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        scrubValue.onChange = function($num, val, is_done) {
            onChangeValue($num, undefined, is_done);
        }

        colorValue = new PgCSSEditableColor(tableGrid.$container, 'colorbox');

        colorValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        colorValue.onChange = function($color, is_done) {
            onChangeValue($color, undefined, is_done);
        }
*/

        tableGrid.$container
            .on('mouseover', '.pg-table-grid-cell', function (event) {
                if(!tableGrid.inScroll) {
                    var data = getDataForEvent(event);

                    if (!pinegrow.getDragMenu()) {

                    }

                }
                event.stopImmediatePropagation();
            })
            .on('mouseout', '.pg-table-grid-cell', function (event) {
                if(!tableGrid.inScroll) {
                    if (!pinegrow.getDragMenu()) {

                    }

                }
                event.stopImmediatePropagation();
            })
            .on('click', 'i.collapse-icon', function (event) {

                var data = getDataForEvent(event);

                data.collapsed = !(data.collapsed || false);

                if(event.altKey) {
                    tableGrid.forEachVisibleSibling(data, function(ch) {
                        ch.collapsed = data.collapsed;

                    })
                }

                tableGrid.refresh();
                event.preventDefault();
                event.stopPropagation();
            })
            .on('click', function(event) {
                if(quickInsertPosition) {
                    event.preventDefault();
                    event.stopPropagation();
                    event.stopImmediatePropagation();

                    //show insert prop menu
                    //repaint the tree
                    var node = quickInsertPosition.data.node;
                    if(node.type === 'add_prop') {
                        node = node.target_node;
                    }
                    var rule = pgcssh.getRuleForNode(node);

                    const $e = $(event.currentTarget);
                    const api = new PgCSSApi();
                    const m = new CrsaContextMenu(api.getInsertCSSPropMenu(function(prop, value) {
                        api.addRuleProperty(rule, prop, value || '', function() {
                            _this.refresh();
                        }, {
                            insertAtIndex: rule.nodes.indexOf(node) + 1
                        })
                    }), $e);
                    m.showAt(event.pageX, event.pageY, tableGrid.$container);
                }
            })
            .on('click', '.pg-table-grid-cell', function (event) {

                //event.stopImmediatePropagation();
                //event.preventDefault();

                var $node = $(this);
                var data = getDataForTree$Element($node);

                if(quickInsertPosition) {
                    return;
                }

                // addGridLine(data);
                // return;

                if(data && data.node && data.node.type !== 'add_prop') {

                    var rule = pgcssh.getRuleForNode(data.node);

                    if(rule) {
                        if(!pinegrow.isSelectedRule(rule)) {
                            pinegrow.selectRule(rule);
                        }
                        cssApi.highlightNodeInCode(rule);
                    }

                    var selected_done = false;

                    if(!selected_done) {
                        pinegrow.selectedCSSNodes.clear({
                            source: _this
                        })
                        pinegrow.selectedCSSNodes.select(data.node);
                        pinegrow.selectedCSSNodes.dispatchEvent([data.node], {
                            source: _this,
                            datas: [data]
                        })
                    }

                }

            });

    }


    var getDataForEvent = function(event) {
        var div = $(event.currentTarget).closest('div');
        return tableGrid.visibleData[parseInt(div.attr('data-visible-idx'))];
    }

    var getDataForTree$Element = function($el) {
        var div = $el.closest('div');
        return tableGrid.visibleData[parseInt(div.attr('data-visible-idx'))];
    }

    var getDataForNode = function(node) {
        var list = tableGrid.data;
        for(var i = 0; i < list.length; i++) {
            if(list[i].node === node) return list[i];
        }
        return null;
    }

    var getDatasForNodes = function(nodes) {
        var list = tableGrid.data;
        var r = []
        for(var i = 0; i < list.length; i++) {
            if(nodes.indexOf(list[i].node) >= 0) {
                r.push(list[i])
            }
        }
        return r;
    }

    this.isOverTree = function(event, drag_menu) {

        if(drag_menu && drag_menu.dragType !== 'css') return null;

        if(view.getWindow() !== event.view) return null;

        if(view.isVisible() && event.pageX >= dimension.left && event.pageX <= dimension.right - (menu.isHidden() ? 0 : (menu.width + (tableGrid.getVScrollBarSize()))) && event.pageY >= dimension.top && event.pageY <= dimension.bottom) {
            return {left: event.pageX - dimension.left, top: event.pageY - dimension.top};
        }
        return null;
    }

    this.getDropPositionInfo = function(event, menu, tree_pos) {

        var info = tableGrid.dragOver(tree_pos);

        tableGrid.showInsertionPoint(info);

        return info;
    }


    wireTreeElements();

    var dragHelper = new PgDragHelper($element, '.disable---pg-table-grid-cell', null, true);

    var dragMenu;

    dragHelper.onGetDragImage = function() {
        return 'none';
    }

    dragHelper.onBefore = function($el) {
        var data = getDataForTree$Element($el)
        if(data.no_sort) return false;
        return true;
    }

    dragHelper.on( 'dragStart', function(x, y, event) {
        $.fn.crsapages('showOverlays');

        var data = getDataForTree$Element(dragHelper.movedElement);

        var def = {
            name: 'Props'
        }

        var pgel = pgCreate('<div>Dummy</div>');

        dragMenu = new PgDragMenu(def, true, true, null, pgel, {
            dragType: 'css'
        });

        dragMenu.draggedNodes = pinegrow.selectedCSSNodes.getNormalizedListForNode(data.node)

        var cloned_cont = $('<div class="pg-tree-drag-container with-tree"></div>');

        var num_desc = tableGrid.getNumberOfDescendants(data.idx, tableGrid.data) + 1;

        //if(num_desc > 3) num_desc = 3;

        var first_level = data.level;

        for(var i = 0; i < num_desc; i++) {
            if(i == 4) break;
            var cell = tableGrid.createCellForData(tableGrid.data[data.idx + i]);
            cell.setData(tableGrid.data[data.idx + i]);
            tableGrid.onSetDataToCell(tableGrid.data[data.idx + i], cell);
            cell.showAt((cell.data.level - first_level) * tableGrid.levelPadding, i * tableGrid.cellHeight, cloned_cont);
        }
        if(num_desc > 4) {
            $('<div class="pg-table-grid-cell"><name>+ ' + (num_desc - 4) + ' more</name></div>').appendTo(cloned_cont).css({
                top: (4 * tableGrid.cellHeight) + 'px',
                left: ((tableGrid.data[data.idx + 4].level + 1 - first_level) * tableGrid.levelPadding) + 'px'
            });
        }
        cloned_cont.css('height', Math.min(num_desc, 5) * tableGrid.cellHeight);

        dragMenu.addElement(cloned_cont);
        dragMenu.movedPgel = pgel;
        dragMenu.pgel = pgel;

        tableGrid.dragStarted(data);

        dragMenu.handleMoveEvent(event, dragMenu);

        menu.hide();

    }, this );

    dragHelper.on( 'drag', function(x, y, event) {

        dragMenu.handleMoveEvent(event, dragMenu);
    }, this );

    dragHelper.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);

        tableGrid.dragStopped();

        console.log(dragMenu.treeDropPosition)

        var cs_list = []

        var pos = dragMenu.treeDropPosition;

        var dest_node = pos.data.node;

        var clone = dragMenu.clone;
        var deep = true;

        var nodes = dragMenu.draggedNodes;

        var updateCsList = function(node) {
            var cs = pgcssh.getStylesheetForNode(node);
            if(cs) {
                var idx = cs_list.indexOf(cs);
                if(idx < 0) {
                    cs_list.push(cs)
                }
            }
        }

        var remove_list = []
        var add_ids = []

        var partial_move = false;

        var copyNode = function(node) {
            var n = pgcssh.copyNode(node);

            var cs = pgcssh.getStylesheetForNode(node);

            add_ids.push(n)

            var copySubnodes = function(new_node, orig_node) {
                if(orig_node.nodes) {

                    var only_selected = false;

                    if(pinegrow.selectedCSSNodes.isSelected(orig_node)) {
                        //if any children selected, just copy selected, if none, copy all
                        var num_selected = 0;

                        for (var i = 0; i < orig_node.nodes.length; i++) {
                            if(orig_node.nodes[i].pg_selected) {
                                only_selected = true;
                                num_selected++;
                            }
                        }

                        partial_move = partial_move || (only_selected && num_selected < orig_node.length);
                    }
                    for (var i = 0; i < orig_node.nodes.length; i++) {
                        if(only_selected && !orig_node.nodes[i].pg_selected) continue;

                        var n = pgcssh.copyNode(orig_node.nodes[i]);
                        pgcssh.insertNodeAt(n, new_node, new_node.nodes.length);
                        add_ids.push(n);

                        copySubnodes(n, orig_node.nodes[i]);
                    }
                }
            }

            if(deep) {
                copySubnodes(n, node);
            }

            if(!clone) {
                if(pinegrow.selectedCSSNodes.isSelected(node)) {
                    pinegrow.selectedCSSNodes.deselect(node)
                    pinegrow.selectedCSSNodes.select(n)
                }
            }

            if(!clone) {
                remove_list.push(node)
            }
            return n;
        }

        updateCsList(dest_node)

        switch(pos.position) {
            case 'bottom':
                for(var i = nodes.length - 1; i >= 0; i--) {
                    pgcssh.insertNodeAfter(copyNode(nodes[i]), dest_node);
                }
                break;
            case 'top':
                for(var i = 0; i < nodes.length; i++) {
                    pgcssh.insertNodeBefore(copyNode(nodes[i]), dest_node);
                }
                break;
            case 'inside-top':
                for(var i = nodes.length - 1; i >= 0; i--) {
                    pgcssh.insertNodeAt(copyNode(nodes[i]), dest_node, 0);
                }
                break;
            case 'inside-bottom':
                for(var i = 0; i < nodes.length; i++) {
                    pgcssh.insertNodeAt(copyNode(nodes[i]), dest_node.nodes.length);
                }
                break;
        }

        if(partial_move) {
            clone = true;
            remove_list = []
        }

        remove_list.forEach(function(node) {
            updateCsList(node)
            pgcssh.removeNodeFrom(node);
        })

        add_ids.forEach(function(n) {
            var cs = pgcssh.getStylesheetForNode(n);
            if(cs) {
                cs.addIdsToNodes([n]);
            }
        })

        pinegrow.selectedCSSNodes.update(); //remove deleted nodes from the list

        $('body').trigger('crsa-rules-changed', {list: cs_list});

        cs_list.forEach(function(cs) {
            pinegrow.stylesheets.applyToPages(cs);
        })

        //dragMenu.insert();
        dragMenu.destroy();
        dragMenu = null;

        crsaFuncs.showInsertionLine(null);
        pinegrow.highlightElement(null);




    }, this );


    view.onResize = function() {
    }

    var onResize = function() {
        dimension = tableGrid.$element.get(0).getBoundingClientRect();
        tableGrid.onRepaint();
        tableGrid.updateLayout()
        tableGrid.updateContainerSize()
        tableGrid.refresh()
        //tableGrid.show();
        menu.updateLayout();
    }

    const resizeObserver = new ResizeObserver(function() {
        if(!ignore_resize_event) {
            onResize()
        } else {
            ignore_resize_event = false;
        }
    });
    resizeObserver.observe(tableGrid.$element.get(0));

    dimension = tableGrid.$element.get(0).getBoundingClientRect();

    view.onDestroy = function() {
        resizeObserver.disconnect();

        pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);

        pinegrow.removeEventHandler('on_page_changed', onPageChanged);
        pinegrow.removeEventHandler('on_page_loaded', onPageLoaded);
        pinegrow.removeEventHandler('on_page_refreshed', onPageLoaded);
        pinegrow.removeEventHandler('on_page_selected', onPageSelected);
        pinegrow.removeEventHandler('on_drag_drop_operation_done', onDragDropDone);
        pinegrow.removeEventHandler('on_page_frameworks_changed', onPageFrameworksChanged);
        pinegrow.removeEventHandler('on_element_isolated', onElementIsolated);

        tableGrid.$element.off('mousemove', onMouseMoved);
        tableGrid.$element.off('mouseleave', onMouseOut);
        tableGrid.$element.off('mouseenter', onMouseIn);
        //$element.off('mouseenter mouseleave', noop);
    }

    var onPageChanged = function(page, pgel, info) {
    }

    var showTree = function(cs_tree) {
        tableGrid.showInsertionLineAt(-1);
        tableGrid.setEmptyLineAt(-1);
        tableGrid.borderItem(null);

        if(cs_tree) {
            cs_tree.setFilterOptions(filter_options);
            cs_tree.setTreeView(_this);
            cs_tree.setTableGrid(tableGrid);

        } else {
            currentMenuData = null;
            tableGrid.setData([]);
            menu.hide();
        }
        menu.updateLayout();
    }

    var class_tree = null;
    var ignore_resize_event = false;

    this.show = function(done) {
        showTreeForActive(done)
    }

    this.refresh = function () {
        this.show()
    }

    var onElementSelected = function() {
        showTreeForActive();
    }

    var showTreeForActive = function(done) {

        view.whenVisible(function() {
            dimension = tableGrid.$element.get(0).getBoundingClientRect();
            var pgel = pinegrow.selectedElements.getLastSelected();
            currentPage = pinegrow.getSelectedPage();

            if (pgel) {
                var p = new CrsaProfile(true, 'Show active classes');

                var rootNode = new PgActiveClassesForPgel(pgel);

                class_tree = new PgClassTree();
                class_tree.create(rootNode);
                showTree(class_tree);

                p.show('Tree shown')

                done && done();

            }
        })
    }

    var onPageLoaded = function(page) {

    }

    var onPageFrameworksChanged = function(page) {

    }

    var onElementIsolated = function(page, pgel) {

    }

    var onPageSelected = function(page) {

    }

    var onDragDropDone = function(page, drag_menu) {
        return;

        if(tableGrid) {
            tableGrid.dragStopped();
        }
    }

    var noop = function() {}

    var currentMenuData = null;

    var hoveredCell = null;

    var mouseSpeed = new PgMouseSpeed();

    var quickInsertPosition = null;
    var quickInsertPositionTimer = null;

    var onMouseMoved = function(event) {
        //var pos = _this.isOverTree(event);
        dimension = tableGrid.$element.get(0).getBoundingClientRect();
        var pos = {left: event.pageX - dimension.left, top: event.pageY - dimension.top - 0};

        //console.log(pos)

        mouseSpeed.track(event);

        if(currentMenuData && menu.isHidden()) menu.show();


        //tableGrid.quickInsertLine.show(null);

        if(quickInsertPositionTimer) {
            clearTimeout(quickInsertPositionTimer);
            quickInsertPositionTimer = null;
        }

        if(pos && currentPage) {
            var grid = tableGrid;

            var so = grid.getScrollOffset();
            pos.top += so.top;
            pos.left += so.left;

            var edge_y = 3;
            var edge_x = 5;

            var idx = grid.getVisibleDataIndexForY(pos.top, true);

            if(idx >= 0) {
                var idx_y = grid.getYForVisibleDataIndex(idx);
                var next_idx = idx;
                while(next_idx < grid.visibleData.length) {
                    var y = grid.getYForVisibleDataIndex(next_idx);
                    if(y > idx_y) break;

                    var node = grid.visibleData[next_idx].node;
                    if(node.type !== 'rule' && node.type !== 'decl' && node.type !== 'add_prop' && !(node.type === 'comment' && node.parent.type === 'rule')) {
                        break;
                    }

                    var x = grid.getXForVisibleData(grid.visibleData[next_idx]);
                    var w = grid.getCellWidthForData(grid.visibleData[next_idx]);
                    var next_x = 0;
                    //console.log(`${next_idx} x ${x}, pos.left ${pos.left}, pos.top ${pos.top}, w ${w}`)

                    var is_last_in_line = true;
                    var x_boundary = x + w + 9999;

                    if(w !== 0 && grid.visibleData.length > next_idx + 1 && grid.getYForVisibleDataIndex(next_idx + 1) === y) {
                        is_last_in_line = false;
                        next_x = grid.getXForVisibleData(grid.visibleData[next_idx + 1]);
                        x_boundary = next_x;
                    }

                    if(x <= pos.left && pos.left <= x_boundary) {
                        var on_edge = false;
                        //console.log(grid.visibleData[next_idx])
                        var line_pos = 'bottom';
                        if(!is_last_in_line) {
                            //has next in the same line
                            line_pos = 'right';

                            if(x + w - edge_x <= pos.left || pos.left >= x + w) {
                                on_edge = true;
                            }


                        } else {

                            var cell_h = grid.getCellHeightForData(grid.visibleData[next_idx]);
                            if(y + cell_h - edge_y <= pos.top || (w !== 0 && pos.left > x + w - edge_x)) {
                                on_edge = true;
                            }


                        }
                        if(on_edge) {
                            grid.quickInsertLine.show(grid.visibleData[next_idx], grid.visibleData[next_idx].level, line_pos);

                            if(!quickInsertPosition) {
                                tableGrid.$container.addClass('with-insert-position')
                            }
                            quickInsertPosition = {
                                data: grid.visibleData[next_idx],
                                pos: line_pos
                            }
                            return;
                        } else {
                            //grid.quickInsertLine.show(null)
                        }
                        break;
                    }
                    next_idx++;
                }
            }
            if(quickInsertPosition) {
                tableGrid.$container.removeClass('with-insert-position')
            }
            quickInsertPosition = null;
            grid.quickInsertLine.show(null)
            return;
        }
    }

    var onMouseOut = function(event) {
        tableGrid.highlightLevel(-1);
        tableGrid.quickInsertLine.hide();
        if(quickInsertPositionTimer) {
            clearTimeout(quickInsertPositionTimer);
            quickInsertPositionTimer = null;
        }
        menu.hide();
        if (hoveredCell) {
            hoveredCell.$element.removeClass('hovered');
        }
        hoveredCell = null;
    }

    var onMouseIn = function(event) {
        if(currentMenuData) menu.show();
    }

    tableGrid.$element.on('mousemove', onMouseMoved);
    tableGrid.$element.on('mouseleave', onMouseOut);
    tableGrid.$element.on('mouseenter', onMouseIn);

    pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);

    pinegrow.addEventHandler('on_page_changed', onPageChanged);
    pinegrow.addEventHandler('on_page_loaded', onPageLoaded);
    pinegrow.addEventHandler('on_page_refreshed', onPageLoaded);
    pinegrow.addEventHandler('on_page_selected', onPageSelected);
    pinegrow.addEventHandler('on_drag_drop_operation_done', onDragDropDone);
    pinegrow.addEventHandler('on_element_isolated', onElementIsolated);

    pinegrow.addEventHandler('on_page_frameworks_changed', onPageFrameworksChanged);

    var updateMenuPosition = function() {
        if(currentMenuData) {
            var so = tableGrid.getScrollOffset();
            var top = tableGrid.getYForVisibleDataIndex(currentMenuData.visible_idx) - so.top;

            menu.showFor(top, top + tableGrid.cellHeight, currentMenuData.selected || false, currentMenuData);
        }
    }

    this.onSelected = function(data) {

        currentMenuData = data;

        var pgel = this.getPgel(data);

        if(pgel) {
            var $item = menu.find('hide');
            $item.find('i').removeClass('icon-hide icon-see').addClass(pgel.isHidden() ? 'icon-see' : 'icon-hide');
        }
        updateMenuPosition();
    }

    this.onDeselected = function(data) {
        //if(currentMenuData === data) setClassesForMenu(data);
        if(!pinegrow.selectedElements.hasSelection()) {
            currentMenuData = null;
            menu.hide();
        }
    }
}







var PgClassTree = function() {

    var _this = this;

    var filter_options = {
        styles: false,
        images: false
    }

    var has_filter_options = false;

    var treeData = [];
    var treeData_PgIdMap = {};
    var helper;

    this.flag_expanded = null;
    this.flag_related = null;

    this.setFilterOptions = function(opt) {
        var o = has_filter_options;
        has_filter_options = false;
        $.each(opt, function(key, val) {
            if(val) {
                has_filter_options = true;
                return true;
            }
        })
        filter_options = opt;
        research_on_show = o !== has_filter_options;
    }

    var treeView;

    this.setTreeView = function(tv) {
        treeView = tv;
    }

    var tableGrid = null;

    this.setTableGrid = function(tg) {
        tableGrid = tg;
        this.$element = tableGrid.$element;
        tg.setData(treeData);

        if(research_on_show) {
            this.research();
        }
    }

    var treeTop = $('<div/>').addClass('crsa-tree-branch pg-tree-ul');

    this.$element = null;

    this.highlightOnMouseOver = true;

    this.destroy = function() {
        nextFrame.cancelAll();
        tableGrid = null;
        treeView = null;
        if(helper) helper.destroy();
        helper = null;
        treeData = null;
        treeData_PgIdMap = null;
        _this = null;
    }

    this.getDataFor$Element = function($el) {
        return tableGrid.getDataFor$Element($el);
    }

    this.updatePgIdMap = function() {
        var p = new CrsaProfile();
        treeData_PgIdMap = {};
        treeData.forEach(function(data) {
            if(data.pgid) {
                treeData_PgIdMap[data.pgid] = data;
            }
        })
        p.show('updatePgIdMap');
    }

    var removeItemPgidMap = function(data) {
        if(data && data.pgid) delete treeData_PgIdMap[data.pgid];
    }

    var removeItemAndChildrenFromPgidMap = function(data) {
        helper.withDataAndChildren(data, removeItemPgidMap);
    }

    var getTreeDataItemForPgId = function(pgid) {
        return treeData_PgIdMap[pgid] || null;
    }

    this.getTreeDataItemForPgId = function(pgid) {
        return getTreeDataItemForPgId(pgid);
    }

    var getDataItemsForPgIdAndDescendants = function(pgid) {
        var data = getTreeDataItemForPgId(pgid);
        if(data) {
            var list = [data];
            var num = data.idx + helper.getNumberOfDescendants(data.idx, treeData);
            for(var i = data.idx + 1; i <= num; i++) {
                list.push(treeData[i]);
            }
            return list;
        }
        return null;
    }

    var createDataItemsForPgEl = function(pgel, level) {
        var list = [];
        createDataItemForPgEl(list, pgel, false, level);
        return list;
    }

    var refreshGrid = function() {
        nextFrame.do('refreshGrid', function() {
            _this.research();
            if(tableGrid) {
                tableGrid.refresh();

                if(treeView && !treeView.view.isVisible()) {
                    treeView.view.whenVisible(function() {
                        tableGrid.show();
                    })
                }
            }
        })
    }

    var previous_selector_was_invalid = false;

    const SEARCH_IN = 1;
    const SEARCH_OUT = 3;
    const SEARCH_HAS_CHILD = 2;

    var currentFilter = null;

    this.research = function(force) {
        var obj = {
            selected_ids: {},
            changed: false
        }

        if(currentFilter || obj.changed || has_filter_options || force) this.search(currentFilter, true, obj);
    }

    var research_on_show = false;

    this.search = function(filter, research, custom_obj) {
        if(!treeView) {
            research_on_show = true;
            return;
        }

        research_on_show = false;

        if(filter === null) filter = '';
        var re = (filter.length > 0) ? new RegExp(escapeRegExp(filter), 'i') : null;

        var force_sel = false;
        var new_filter = filter;

        //try searching for selector
        var selected_ids = {};

        currentFilter = filter;

        var obj;

        if(custom_obj) {
            obj = custom_obj;
        } else {
            var obj = {
                selected_ids: {},
                changed: false
            }
            //page.callFrameworkHandler('on_custom_tree_filter', obj);
        }

        var custom_ids = obj.selected_ids;
        var custom_filter = obj.changed;

        if(!filter && !custom_filter && !has_filter_options) {
            treeData.forEach(function(data) {
                data.search = 0;
                data.force_search = false;
                if(data.peek_in) {
                    data.collapsed = true;
                    data.peek_in = false;
                }
            })
            tableGrid.refresh();
            return;
        }

        if(!helper) return;

        treeData.forEach(function(data) {
            data.search = 0;
            if(data.peek_in) {
                data.collapsed = true;
                data.peek_in = false;
            }
        })

        helper.forEachWithParents(function(data, parents) {

            var inc = false;

            if(!re || data.search_string.match(re)) {
                inc = true;
            }

            if(has_filter_options) {
                var only_type = 'decl';

                if(filter_options.position) {
                    if(data.node.type === 'decl') {
                        inc = inc && (('_' + data.node.prop + '_').match(/_(top|right|bottom|left|position|z\-index)_/i) !== null);
                    } else {
                        inc = false;
                    }
                }
            }

            if(inc) {
                //selected_ids[data.pgid] = true;
                data.search = SEARCH_IN;

                for(var i = parents.length - 1; i >= 0; i--) {
                    if(parents[i].search === SEARCH_OUT) {
                        parents[i].search = SEARCH_HAS_CHILD;
                        if(parents[i].collapsed) {
                            parents[i].peek_in = true;
                            //data.peeked = true;
                        }
                        parents[i].collapsed = false;
                    } else {
                        break;
                    }
                    //parents[i].collapsed = false;
                }
            } else {
                if(false && data.force_search && research) {
                    for(var i = parents.length - 1; i >= 0; i--) {
                        if(parents[i].search === SEARCH_OUT) {
                            parents[i].search = SEARCH_HAS_CHILD;
                        } else {
                            break;
                        }
                        //parents[i].collapsed = false;
                    }
                } else {
                    data.search = SEARCH_OUT;
                }
            }
        })

        tableGrid.refresh();
    }

    var unpopulateDataItem = function(data) {
        if(data) {
            data.populated = false;
            data.def = null;
        }
    }

    var updateBranchForPgel = function(pgel, data) {
        if(data === undefined) {
            data = getTreeDataItemForPgId(pgel.getId())
        }
        var list = createDataItemsForPgEl(pgel);
        helper.replaceWith(data, list);
    }

    var updateSelectedItems = function() {
        pinegrow.selectedElements.forEachElement(function(pgel) {
            var data = getTreeDataItemForPgId(pgel.getId());
            if(data) data.selected = true;
        })
    }

    var forceDisplayInSearch = function(list_or_data, val) {
        if(Array.isArray(list_or_data)) {
            list_or_data.forEach(function(data) {
                data.force_search = val;
            })
        } else {
            list_or_data.force_search = val;
        }
    }

    this.scrollToSelected = null;

    this.create = function(rootNode) {

        treeData = [];
        treeData_PgIdMap = {};

        var treeRoot = rootNode;

        var profile = new CrsaProfile(true);

        createDataItem(treeData, treeRoot);

        treeRoot.getParents().forEach(function(p) {
            createDataItem(treeData, p);
        })

        profile.show('create Class Tree ' + treeData.length + ' tree data items');

        helper = new PgTreeDataHelper(treeData);

        helper.reindexData();

        this.research();
    }


    this.populateDataItem = function(data) {
        if(data.populated) return;
        data.node.populateDataItem(data);
        data.populated = true;
    }


    var createDataItem = this.createDataItem = function (treeData, node, level) {
        if (!level) level = 0;

        var cls = 'sort';
        var no_sort = false;

        var fata = {shown: true, level: level, tags: '', search_string: ''};

        node.populateTreeFata(fata);

        fata.classes = cls;
        fata.collapsed = isNodeCollapsed(node);
        fata.no_sort = no_sort;

        treeData.push(fata);

        var children = node.getTreeChildren();

        if(children) {
            children.forEach(function(c) {
                createDataItem(treeData, c, level + 1);
            })
        }
    }


    var isNodeCollapsed = function(node) {
        return false;
    }

    var isCollapsed = function (e) {
        if (e.tagName == 'HEAD') return !page.show_head_in_tree;
        return e.getAttribute('data-pg-collapsed') === '';
    }

    var selectElement = function(pgid) {
        var $li = getTreeNodeForPgel(pgid);
        if($li) {
            $li.addClass('crsa-tree-node-selected');
            scrollToTreeNode($li);
        }
    }

    var deselectElement = function(pgid) {
        var $li = getTreeNodeForPgel(pgid);
        if($li) {
            $li.removeClass('crsa-tree-node-selected');
        }
    }

    var scrollToTreeNode = function($li) {
        var test = $li.get(0).getBoundingClientRect();
        var test2 = treeTop.get(0).getBoundingClientRect();

        var lip = {left: test.left - test2.left, top: test.top - test2.top};
        //var lip = $li.position();
        var $tree = treeTop.closest('.tree-container');

        var tree_h = $tree.height();
        var li_h = 20;//$li.height();
        var tree_st = $tree.scrollTop();

        if (lip.top >= 0 && lip.top < tree_h - li_h) {

        } else {
            var y = lip.top + tree_st - 100;
            if (y < 0) y = 0;
            $tree.stop().animate({scrollTop: y}, 150);
        }

    }
}

class PgFastDOMClassPreviewForElement {

    constructor(el, prefix) {
        this.el = el;
        this.original = this.el.getAttribute('class');
        this.prefix = prefix || '';
    }

    setClass(cls, values, custom_set) {
        var _this = this;

        this.restore();

        if(custom_set) {
            custom_set($(this.el), _this.prefix + cls);
        } else {
            if(values) {
                values.forEach(function(cls) {
                    if(_this.el.classList.contains(_this.prefix + cls.key)) {
                        _this.el.classList.remove(_this.prefix + cls.key);
                    }
                })
            }
            if(cls) {
                cls.split(/\s+/).forEach(function(cls) {
                    cls && _this.el.classList.add(_this.prefix + cls);
                })
            }
        }
    }

    restore() {
        this.el.setAttribute('class', this.original);
    }

    remember() {
        this.original = this.el.getAttribute('class');
    }
}

class PgFastDOMClassPreviewForPgel {
    constructor(pgel, prefix) {
        this.pgel = pgel;
        this.page = pgel.getPage();
        this.$elements = pgel.get$DOMElements();
        this.list = this.$elements.map(function($el) {
            return new PgFastDOMClassPreviewForElement($el.get(0), prefix)
        })
        this.destroyed = false;
        this.hidden_menus = false;
        this.prefix = prefix || '';

        pinegrow.dispatchEvent('on_fast_dom_class_preview_start', this.page, this.pgel);
    }

    triggerPreviewEvent(cls, values) {
        var _this = this;
        var list = values.map(function(d) { return _this.prefix + d.key })
        list.push(this.prefix + cls);
        pinegrow.dispatchEvent('on_fast_dom_class_preview', this.page, this.pgel, this.prefix + cls, list);
    }

    setClass(cls, values, custom_set) {
        var _this = this;
        if(this.destroyed) return;
        if(!this.hidden_menus) {
            pinegrow.selectedElements.temporaryHideMenus(true);
            this.hidden_menus = true;
        }

        this.list.forEach(function(i) {
            i.setClass(cls, values, custom_set);
        })

        if(cls) {
            this.triggerPreviewEvent(cls, values)
        }
    }

    remember() {
        if(this.destroyed) return;

        this.list.forEach(function(i) {
            i.remember();
        })
    }

    showMenus() {
        if(this.hidden_menus) {
            pinegrow.selectedElements.restoreShowMenus(true);
            this.hidden_menus = false;
        }
    }

    restore() {
        if(this.destroyed) return;

        this.list.forEach(function(i) {
            i.restore();
        })

        this.showMenus()
    }

    destroy(skip_restore) {
        if(this.destroyed) return;
        if(!skip_restore) this.restore();
        this.showMenus();
        pinegrow.dispatchEvent('on_fast_dom_class_preview_end', this.page, this.pgel);
        this.destroyed = true;
    }
}


