$(function() {

    $('body').one('pinegrow-ready', function (e, pinegrow) {

        /*
        pinegrow.addEventHandler('on_key_pressed', function(page, e, status) {
            if(status.key === '/' && !status.input && !status.edit) {
                var api = new PgCSSApi();
                var pgel = pinegrow.selectedElements.getLastSelected();
                if(!pgel) {
                    pinegrow.showQuickError('Please select the HTML element that you wish to style.')
                } else {
                    pinegrow.getSelectedRuleForPgel(pgel, function(rule) {
                        //console.log(rule)
                        api.showInsertCSSPropMenuForRule(rule, null, pgel);
                    });
                }
                status.done = true;
            }
        })

         */

    });
});

    var PgSelectedCSSNodes = function() {

    var list = []

    this.select = function(node) {
        var idx = list.indexOf(node);
        if(idx < 0) {
            list.push(node);
        }
        node.pg_selected = true;
    }

    this.deselect = function(node) {
        var idx = list.indexOf(node);
        if(idx >= 0) {
            list.splice(idx, 1)
        }
        node.pg_selected = false;
    }

    this.clear = function(event_options) {
        var nodes = list;

        list.forEach(function(node) {
            node.pg_selected = false;
        })
        list = [];
        if(event_options) {
            this.dispatchEvent(nodes, event_options)
        }
    }

    this.update = function() {
        var r = [];
        list.forEach(function(node) {
            if(!node.is_removed) {
                r.push(node)
            }
        })
        list = r;
    }

    this.toggle = function(node) {
        if(this.isSelected(node)) {
            this.deselect(node)
        } else {
            this.select(node)
        }
    }

    this.isSelected = function(node) {
        return node.pg_selected;
    }

    this.getSelected = function() {
        return list;
    }

    this.getLastSelected = function() {
        return list.length ? list[list.length - 1] : null;
    }

    this.dispatchEvent = function(nodes, options) {
        pinegrow.dispatchEvent('on_css_node_selected_deselected', null, nodes, options)
    }

    this.getListForNode = function(node) {
        if(this.isSelected(node)) {
            return list.slice(0);
        } else {
            return [node]
        }
    }

    this.getNormalizedListForNode = function(node) {

        var getDepth = function(node) {
            var d = 0;
            while(node.parent) {
                d++;
                node = node.parent;
            }
            return d;
        }

        var contains = function(top, node) {
            while(node) {
                if(node === top) return true;
                node = node.parent || null;
            }
            return false;
        }

        var list = this.getListForNode(node);

        list.sort(function(a, b) {
            return getDepth(a) - getDepth(b);
        })

        var r = []

        list.forEach(function(node) {
            var has = false;
            for(var i = 0; i < r.length; i++) {
                if(contains(r[i], node)) {
                    has = true;
                    break;
                }
            }
            if(!has) {
                r.push(node)
            }
        })

        return r;

    }
}

var PgCSSTreeActiveCommandsView = function() {

    var _this = this;

    this.onStateChanged = null;

    var selectedElement = null;
    var selectedElementPage = null;
    var shownCs = null;

    var $element = $('<div/>', {class: 'pg-css-active-controls'});
    var view = this.view = new PgUIView($element);

    var $name = $('<div class="pg-show-properties-name"><span>Styles for</span> <name></name></div>').prependTo($element);
    var $name_name = $name.find('name');

    var cssStates = ['active', 'hover', 'focus', 'visited'];

    var $psudoContainer = $('<div class="pseudo-container"></div>').appendTo($name);

    var $createContainer = $('<div class="pg-css-tree-create"></div>').appendTo($element);

    var updateStateClasses = function(pgel) {

        pgel.get$DOMElements().forEach(function($el) {
            cssStates.forEach(function(state) {
                var cls = `pg-state-${state}`;
                if(_this[state]) {
                    $el.addClass(cls);
                } else {
                    $el.removeClass(cls);
                }
            })
        })
    }

    for (var i = 0; i < cssStates.length; i++) {
        var cssState = cssStates[i];
        this[cssState] = false;

        var $input  = $('<div class="pseudo-state" data-css-state="' + cssState + '"><label>:' + cssState.substr(0, 3) + '</label><input type="checkbox"></div>').appendTo($psudoContainer);

        $input.click(function (e) {
            e.preventDefault();

            var $this = $(this);
            var currCssState = $this.data('cssState');

            if (!_this[currCssState]) {
                _this[currCssState] = true;
                $this.addClass('checked');
            } else {
                _this[currCssState] = false;
                $this.removeClass('checked');
            }

            var states = [];

            cssStates.forEach(function(state) {
                if(_this[currCssState]) {
                    states.push(state);
                }
            })

            var col = pinegrow.getCollection();

            col.forEachElementAsync(function(pgel, ondone) {
                pinegrow.devTools.forcePseudoStates(pgel, states, ondone);
                updateStateClasses(pgel);
            }, function(results) {
                _this.onStateChanged();
            })
        });

        /*

        var $el = selectedElement.get$DOMElement();
        if ($el && $el.hasClass('pg-state-' + cssState)) {
            _this[cssState] = true;
            //$input_chk.prop("checked", true);
            $input.addClass('checked');
        }
        */
        addTooltip($input, 'Show selected element in <b>:' + cssState + '</b> state.');
    }

    var onNewRuleCreated = function (elementSelector, selectedFileUrl, mediaParams, done) {
        var stylesheet = pinegrow.getStylesheetByUrl(selectedFileUrl);

        var insertRule = false;
        var rootNode = stylesheet.getRootNode();
        var addNodeTo = rootNode;

        var ruleNode = pinegrow.pgPostCSSHelper.createNode("rule", elementSelector);
        var ruleIndices = [rootNode.nodes.length];
        var toCheckIndices = [rootNode.nodes.length];

        var parentNode = ruleNode;
        if (mediaParams) {
            var lastNode = rootNode.last;
            if (lastNode && lastNode.params && lastNode.params == mediaParams) {
                addNodeTo = lastNode;
                ruleIndices = [rootNode.nodes.length - 1];
                toCheckIndices = [rootNode.nodes.length - 1, lastNode.nodes.length];
                insertRule = true;
            }
            else {
                var mediaNode = pinegrow.pgPostCSSHelper.createNode("atrule", "media", mediaParams);
                pinegrow.pgPostCSSHelper.insertNodeInside(ruleNode, mediaNode);
                parentNode = mediaNode;
                // ruleIndices.push(0);
                toCheckIndices.push(0);
            }
        }

        pinegrow.pgPostCSSHelper.insertNodeAt(parentNode, addNodeTo, addNodeTo.nodes.length);

        stylesheet.setSourceForRules(rootNode, function () {
            if (done) done(stylesheet, ruleIndices, toCheckIndices, insertRule);
        });
    }

    var onSelectorMakerCreate = function(maker) {
        var elementSelector = maker.getSelector();
        var selectedFileUrl = maker.getStylesheet();

        if(shownCs && shownCs.url) {
            selectedFileUrl = shownCs.url;
        }

        var add_classes = maker.getAddClasses();
        var save_inline = maker.getSaveInline();

        var doTask = function() {

            if (add_classes.length) {
                var col = pinegrow.getCollectionForElement(selectedElement);
                var api = new PgApi();
                api.addClass(col, add_classes);
            }

            onNewRuleCreated(elementSelector, selectedFileUrl, maker.getMediaQuery(), function (stylesheet, ruleIndices, toCheckIndices, insertRule) {
                var node = pinegrow.pgPostCSSHelper.getNodeByIndices(stylesheet.getRootNode(), ruleIndices);
                var nodeToCheck = pinegrow.pgPostCSSHelper.getNodeByIndices(stylesheet.getRootNode(), toCheckIndices);
                if (insertRule) {
                    pinegrow.dispatchEvent('on_css_node_added', null, {node: nodeToCheck, stylesheet: stylesheet});
                }
                else {
                    pinegrow.dispatchEvent('on_css_node_added', null, {node: node, stylesheet: stylesheet});
                }

                var target_rule = null;

                if (node.type == 'atrule') {
                    target_rule = node.nodes[node.nodes.length - 1];
                }
                else {
                    target_rule = node;
                }

                if(maker.getOptions().save_inline_source_rule) {
                    try {
                        var rule = maker.getOptions().save_inline_source_rule;

                        var r = target_rule;

                        var cs = pgcssh.getStylesheetForNode(r);

                        var last_decl = 0;

                        for(var i = 0; i < rule.nodes.length; i++) {
                            if(rule.nodes[i].type == 'decl') {
                                last_decl = i;
                            }
                        }
                        for(i = 0; i < rule.nodes.length; i++) {
                            if(rule.nodes[i].type === 'decl') {
                                cs.ruleValueChanged(target_rule, rule.nodes[i].prop, rule.nodes[i].value, null, false, 'gui', i === last_decl, null);
                            }
                        }

                        var col = pinegrow.getCollectionForElement(selectedElement);
                        col.forEachElement(function (pgel) {
                            pgel.removeAttr('style');
                        });
                        pinegrow.changeManager.didChange(col, 'Remove style attribute');

                    } catch(err) {}
                }


                pinegrow.selectRule(target_rule);
                _this.cssTreeView.scrollToNode(target_rule)

                createRuleView.setSelector('');

                pinegrow.showQuickMessage('Rule <b>' + elementSelector + '</b> created in <b>' + crsaGetNameFromUrl(selectedFileUrl) + '</b>.')
            });
        }

        if(selectedFileUrl) {
            doTask();
        } else {
            pinegrow.getDefaultStylesheet(selectedElement.getPage(), function(cs) {

                if(cs) {
                    selectedFileUrl = cs.url;
                    doTask();
                } else {
                    pinegrow.showQuickError('Please choose or add stylesheet for the new CSS rule.');
                }
            }, true /* show error */)
        }
    }

    var fillStylesheetsArray = function () {
        var selectedPage = selectedElement.getPage();
        var pageStylesheets = selectedPage.getStylesheets();
        var allSheets = pageStylesheets.getAllCrsaStylesheets();

        var stylesheets = [];
        for (var i = 0; i < allSheets.length; i++) {
            stylesheets = stylesheets.concat(pgStylesheetHelper.getAllStylesheetsFor(allSheets[i]));
        }

        var filesArr = [];
        for (var i = 0; i < stylesheets.length; i++) {
            if(stylesheets[i].url) {
                filesArr.push(stylesheets[i].url);
            }
        }
        return filesArr;
    }

    this.openCreateNewRuleDialog = function(selector, media, stylesheet, select_class, simple, $target, options) {

        var files = fillStylesheetsArray();

        var opts = $.extend({}, {
            stylesheets: files,
            $position: $createNewRule,
            selector_value: selector,
            stylesheet_value: stylesheet,
            media_value: media,
            select_class: select_class,
            simple: simple,
            $position: $target
        }, options || {})

        var selector_maker = new PgQuickSelectorMaker(selectedElement, null, opts);

        if(opts.save_inline_source_rule) {
            //selector_maker.maker.setSaveInline(true);
        }

        selector_maker.onCreate = onSelectorMakerCreate;
    }

    //var $addRuleContainer = $('<div class="pg-active-add-rule"></div>').appendTo($element);

    var $createNewRule;
    var createRuleView;

    this.showCreateCssRule = function(sel) {
        if(!createRuleView) return;

        createRuleView.setSelector(sel);
        $list_container.scrollTop(0);
        createRuleView.onShown(); //will focus field
        addTooltip(createRuleView.getInput().$field, 'Input the selector and press ' + pgShowKbdCombo('Enter') + '', {
            trigger: 'manual'
        })
    }


    var $classesWithoutRules = $('<div class="classes-whithout-rules"><classlist></classlist></div>');//.appendTo($createContainer);

    $classesWithoutRules.on('click','[data-class]', function(e) {
        e.preventDefault();
        var cls = $(this).attr('data-class');
        _this.openCreateNewRuleDialog('.' + cls, null, null, null, true /* simple */, $(e.target));
    })

    var updateClassesWithoutRules = function() {
        var pgel = selectedElement;
        var rules = pinegrow.pgActiveRules.matched_rules || [];

        var $ul = $classesWithoutRules.find('classlist');
        var html = '';
        var all = [];
        for(var im = 0; im < rules.length; im++) {
            if(rules[im].text) {
                var list = pgcssh.getClassesFromSelector(rules[im].text);
                list.forEach(function(cls) {
                    if(all.indexOf(cls) < 0) {
                        all.push(cls);
                    }
                })
            }
        }

        $.each(pgel.getClasses(), function (i, cls) {
            var isClass = true;
            html += '<li class="pg-button pg-class-button crsa-input-rule' + (all.indexOf(cls) < 0 ? ' class-off' : '') + '" data-class="' + cls + '">' + escapeHtmlCode(cls) + '&nbsp;<!--<i class="icon icon-close crsa-input-rule-remove"></i>--></li>';
        });

        if(html.length) {
            $ul.get(0).innerHTML = html;
            pg$Show($classesWithoutRules);
        } else {
            pg$Hide($classesWithoutRules);
        }

        addTooltip($ul.find('[data-class]:not(.class-off)'), 'Select the first CSS rule for this class.');
        addTooltip($ul.find('[data-class].class-off'), 'Create the CSS rule for this class.');
    }

    this.update = function(pgel) {
        var states = [];

        selectedElement = pgel;
        selectedElementPage = pgel ? selectedElement.getPage() : null;

        if(pgel) {
            //name
            $name_name.get(0).innerHTML = pinegrow.selectedElements.getName({short: true, num_classes: -1});

            //update states
            var $el = pgel.get$DOMElement();
            cssStates.forEach(function(state) {
                var cls = `pg-state-${state}`;
                _this[state] = $el.hasClass(cls);

                var $b = $element.find(`[data-css-state="${state}"]`);
                if(_this[state]) {
                    $b.addClass('checked');
                } else {
                    $b.removeClass('checked');
                }
            })

            pgUIViewManager.destroyViewsInArea($createContainer);

            $createContainer.find('.pg-active-add-rule').remove();

            var $addRuleContainer = $('<div class="pg-active-add-rule"></div>').prependTo($createContainer);

            var withDefaultCs = function(defaultCs, detected) {
                createRuleView = new PgSelectorMakerView(selectedElement, null, {
                    simple: true,
                    labels: false,
                    media_query: false,
                    stylesheets: false,
                    compact: true,
                    save_inline: true,
                    default_cs: defaultCs
                })

                if(!defaultCs) {
                    detected = true; //force dialog
                }

                createRuleView.view.setAlwaysVisible(true);

                if(detected) {
                    createRuleView.onCreate = function(maker) {
                        var selectDefault = new PgSelectDefaultStylesheet(selectedElementPage, defaultCs);
                        selectDefault.show(function(cs, canceled) {
                            if(!canceled && cs) {
                                onSelectorMakerCreate(maker);
                            }
                        })

                    }
                } else {
                    createRuleView.onCreate = onSelectorMakerCreate;
                }

                createRuleView.onCreateWithoutSelector = function(maker, e) {
                    _this.openCreateNewRuleDialog(createRuleView ? createRuleView.getSelector() : null, null, shownCs ? shownCs.url : null, null, false, $(e.target));
                    return true;
                }

                $addRuleContainer.append(createRuleView.view.get$Element());

                var $button = $addRuleContainer.find('button.create');

                var def_name = defaultCs ? crsaGetNameFromUrl(defaultCs.url) : 'default stylesheet';

                addTooltip($button, `Create a new CSS rule:<ul>
<li>Quick mode - enter the selector and click on Create or press ${pgShowKbdCombo('Enter')} to create a new rule in <b>${def_name}</b></li>
<li>Selector builder mode - leave the selector empty and click on Create to open selector builder and choose media query and stylesheet.</li></ul>`);

                //$createNewRule = $('<button class="pg-button create-dialog">...</button>').insertAfter($button);

                //addTooltip($addRuleContainer.find('button.create-dialog'), 'Create new CSS rule with selector builder, media query control and stylesheet chooser.')
            }

            if(shownCs) {
                withDefaultCs(shownCs, false);
            } else {
                pinegrow.getDefaultStylesheet(selectedElementPage, withDefaultCs)
            }
            //updateClassesWithoutRules();
        }
    }

    this.setShowActive = function(cs, pgel) {
        shownCs = cs;
        this.update(pgel || selectedElement)
        if(!cs) {
            pg$Show($name, 'flex');
        } else {
            pg$Hide($name);
        }
    }
}

var PgCSSTreeItemDialogView = function() {
    var $element = $('<div class="pg-css-tree-dialog-view"></div>');

    var view = new PgUIView($element);

    this.view = view;

    var _this = this;

    view.onResize = function() {
    }

    view.onDestroy = function() {
    }
}

class PgCSSTreeItemDialog {
    constructor(cell, data, name) {
        var _this = this;
        this.cell = cell;
        this.data = data;
        this.dialogView = new PgCSSTreeItemDialogView();
        this.win = new PgQuickWindow(name, this.dialogView, 'quickCSSTree_' + name, 480, 200);

        this.win.onDestroy = function() {
            _this.focus_shown && pinegrow.focusRect.hide();
        }
    }

    show() {
        var _this = this;
        pinegrow.focusRect.showFor$El(pinegrow.getSelectedPage().view.view.get$Element(), function() {
            _this.win.close();
            _this.focus_shown = false;
        })
        this.focus_shown = true;

        this.onShow(this.dialogView.view.get$Element(), this.cell.data, this.cell)
        this.win.showFor$El(this.cell.$element, null, 0, 'down');
        this.win.autoSize(60);
    }

    onShow($element, data, cell) {

    }
}

class PgCSSTreeItemDialogMediaQuery extends PgCSSTreeItemDialog {
    constructor(cell, data) {
        super(cell, data, 'Edit media query')
    }

    onShow($element, data, cell) {
        var _this = this;
        var mq_input = new PgInputField('mq', {
            type: 'text',
            show_empty: false,
            name: 'Media query',
            without_text: false,
            slider_def_unit: ''
        });

        mq_input.appendTo($element);

        data && mq_input.setValue(`@${data.node.name} ${data.node.params}`)

        mq_input.on('input', function(e) {

        })

        mq_input.on('change', function(e) {
            _this.cell.onSetMediaQuery(mq_input.getValue(), true)
        })

        var mqHelper = new PgMediaQueryHelperView(mq_input.$input, pinegrow.getSelectedPage(), false, true);
        mqHelper.showFieldAndSelectors();
        mqHelper.view.get$Element().appendTo($element);
    }
}



class PgCSSTreeCellEditable extends PgTableGridCell {
    constructor(template, type, no_drag) {
        super(template, type, no_drag)
        this.edited_field = null;
        this.edited_field_control = null;

        this.on('cell', 'contextmenu', this.onContextMenu.bind(this))
        //this.on('value', 'click', this.onValueClick.bind(this))
    }

    addContextMenuActions(actions) {
    }

    onValueClick(event) {

    }

    onContextMenu(event) {
        event.preventDefault();
        event.stopPropagation();

        var actions = [];
        this.addContextMenuActions(actions);
        if(actions.length === 0) return;
        var m = new CrsaContextMenu(actions, this.$element)
        m.showForElement(this.$element)
        return false;
    }

    getValueHTML(value) {
        return pgCSSTreeValueHTMLMaker.getHTML(value, this.data, this.data.node.prop ? pinegrow.devTools.getCSSPropertyValuesRegEx(this.data.node.prop) : null);
    }

    onValueEditStart(tagName, control) {
        this.addClass('cell', 'text-is-edited');
        this.edited_field = tagName;
        this.edited_field_control = control;
    }

    onValueEditDone() {
        this.data.cellWidth = 0;
        this.removeClass('cell', 'text-is-edited');
        this.edited_field = null;
        this.edited_field_control = null;
        this.cssTreeView.refreshDisplayOnly()
    }

    onPopulate() {
        super.onPopulate();
        this.edited_field = null;
        this.edited_field_control = null;
    }

    displayField(name, value) {
        if(this.edited_field === name) {
            this.edited_field_control.setValue(value);
        } else {
            value = this.data.value_html = this.getValueHTML(value);
            this.setHtml(name.toLowerCase(), value);
        }
    }

    onGetValueOptions(tag) {
        return null;
    }

    onListItemHighlighted(tag, item) {

    }

    canEdit(silent, rule_notice) {
        if(this.data.node.type === 'rule' && this.data.node.inline) {
            return canMakeChange(this.data.node.inline_for_pgel, 'attr', 'style', silent)
        }
        var cs = pgcssh.getStylesheetForNode(this.data.node);
        if (cs) {
            return cs.canEdit(silent, rule_notice)
        }
        return true;
    }
}

class PgCSSTreeCellWithTools extends PgCSSTreeCellEditable {
    constructor(template, type, no_drag, tools_opt) {
        tools_opt = $.extend({
            'comment': true,
            'delete': true
        }, tools_opt);

        var tools = '<div class="tools">';
        if(tools_opt.comment) {
            tools += '<input data-element="check" type="checkbox" checked>';
        }
        if(tools_opt.delete) {
            //tools += '<i class="icon icon-bin" data-element="delete"></i>';
        }
        tools += '</div>';

        template = template.replace('#TOOLS#', tools)
        super(template, type, no_drag);

        if(tools_opt.comment) {
            this.on('check', 'change', this.onUncheck.bind(this));
            this.on('check', 'click', this.onStopEvent.bind(this));
        }
        if(tools_opt.delete) {
            //this.on('delete', 'click', this.onDelete.bind(this));
        }
    }

    getNode() {
        return this.data.node;
    }

    onPopulate() {
        this.getElement('check').checked = this.getNode().type !== 'comment';
    }

    onStopEvent(event) {
        event.stopPropagation()
    }

    onUncheck(event) {
        event.preventDefault();
        event.stopPropagation();

        if(!this.canEdit()) {
            this.getElement('check').checked = !this.getElement('check').checked;
            return;
        }

        const _this = this;
        const api = new PgCSSApi();
        if(this.getNode().type === 'comment') {
            api.uncommentNode(this.getNode(), function () {
                //_this.update();
            })
        } else {
            api.commentNode(this.getNode(), function () {
                //_this.update();
            })
        }
    }

    onDelete(event) {
        event.preventDefault();
        event.stopPropagation();

        if(!this.canEdit()) return;

        const _this = this;
        const api = new PgCSSApi();
        api.deleteNode(this.getNode(), function () {
            //_this.update();
        })
    }
}

class PgCSSTreeCellStylesheet extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-css-tree-stylesheet"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name>
<i data-element="open" class="icon icon-align-left"></i>
<i data-element="code" class="icon icon-KODA"></i>
<i data-element="ignore" class="icon icon-hide"></i>
<i data-element="lock" class="icon icon-Lock_closed"></i>
</div>`, type, no_drag);

        this.tooltip('open', 'Open the stylesheet in a separate panel.')
        this.tooltip('code', 'Edit stylesheet code.')
        this.tooltip('ignore', 'Ignore the stylesheet in the Active tab.')
        this.tooltip('lock', 'Click to lock the stylesheet.')

        this.on('open', 'click', this.onOpen.bind(this));
        this.on('code', 'click', this.onCode.bind(this));
        this.on('ignore', 'click', this.onIgnore.bind(this));
        this.on('lock', 'click', this.onLock.bind(this));
    }

    getStylesheet() {
        return this.data.node.pgStylesheet;
    }

    onPopulate() {
        const cs = this.getStylesheet();
        if(cs.canEdit(true)) {
            this.tooltip('lock', 'Click to lock the stylesheet.')
            this.removeClass('lock', 'pg-css-locked', 'icon-Lock_open');
            this.addClass('lock', 'icon-Lock_closed')
        } else {
            this.addClass('lock', 'pg-css-locked', 'icon-Lock_open');
            this.removeClass('lock', 'icon-Lock_closed')
            this.tooltip('lock', `The stylesheet is locked. ${cs.lockedReason || ''} Click to unlock.`);
        }

        if(cs.ignore) {
            this.tooltip('ignore', 'Rules from this stylesheet are not shown in the Active tab. Click to show its rules in the Active tab.')
            this.addClass('ignore', 'icon-hide');
            this.removeClass('ignore', 'icon-see');
        } else {
            this.tooltip('ignore', 'Rules from this stylesheet are shown in the Active tab. Click to hide its rules in the Active tab.')
            this.removeClass('ignore', 'icon-hide');
            this.addClass('ignore', 'icon-see');
        }
        if(this.cssTreeView.isActive()) {
            this.showElement('open', 'inline')
        } else {
            this.hideElement('open')
        }
    }

    onOpen(event) {
        event.preventDefault();
        event.stopPropagation();
        this.cssTreeView.combinedView.setActiveCs(this.getStylesheet());
    }

    onCode(event) {
        event.preventDefault();
        event.stopPropagation();
        pinegrow.stylesheets.editCode(this.getStylesheet());
    }

    onIgnore(event) {
        event.preventDefault();
        event.stopPropagation();
        const cs = this.getStylesheet();
        if(cs.ignore) {
            cs.loadAndShowInActive();
        } else {
            cs.ignoreInActive();
        }
        this.cssTreeView.refresh()
    }

    onLock(event) {
        event.preventDefault();
        event.stopPropagation();
        const cs = this.getStylesheet();
        if (cs.canEdit(true)) {
            cs.setLocked(true, '');
            pinegrow.selectedElements.reselect();
            pinegrow.showQuickMessage('Stylesheet is locked.');
        } else {
            cs.unlockWithAsk();
        }
        this.update();
    }

    destroy() {
        super.destroy();
    }
}

class PgCSSTreeCellProperty extends PgCSSTreeCellWithTools {
    constructor(type, no_drag) {
        super(`<div class="pg-css-tree-decl pg-css-tree-with-tools" data-element="cell">#TOOLS#
<name data-element="name" class="not-editable"></name> <value data-element="value"></value>
</div>`, type, no_drag);

        //this.on('value', 'click', this.onValueClick.bind(this));
        //this.tooltip('check', 'Open the stylesheet in a separate panel.')
    }

    onValueEdited(tagName, new_value, is_done, action) {
        var prop, value, old_value;
        if(tagName === 'VALUE') {
            old_value = this.data.node.value;
            value = new_value;
            prop = this.data.node.prop;
        } else if(tagName === 'NAME') {
            value = this.data.node.value;
            old_value = this.data.node.prop;
            prop = new_value;
        }

        if(tagName === 'VALUE') {
            this.data.value_html = this.getValueHTML(new_value)
            if(is_done) {
                //setting html here because only text value was set from PgCSSEditableText done
                this.setHtml('value', this.data.value_html)
            }
        }

        //only update is value changed. event can be triggered by non-editable key input as well, so filter those out here

        if(old_value !== new_value || is_done) {
            this.stylePreview && this.stylePreview.restore();

            if (prop.length) {
                const api = new PgCSSApi();
                api.setRuleProperty(this.data.node, prop, value, function () {

                }, {
                    dispatchEvent: is_done || false,
                    edited_by: action === 'scrub' ? this.cssTreeView : null
                })
            }
        }
    }

    onListItemHighlighted(tag, item) {
        if(tag === 'VALUE') {
            if(item) {
                this.stylePreview && this.stylePreview.setStyle(this.data.node.prop, item.key)
            } else {
                this.stylePreview && this.stylePreview.restore()
            }
        }
    }

    onValueClick(event) {
        //is simple drop value?
    }

    onGetValueOptions(tag) {
        if(tag === 'NAME') {
            return function() {
                return pinegrow.devTools.getCSSPropertiesOptions();
            }
        } else if(tag === 'VALUE') {
            var prop = this.data.node.prop;
            var values = pinegrow.devTools.getCSSPropertyValues(prop);
            if(values) {
                //10px solid |
                var val = this.data.node.value;
                if(val !== '' && values.indexOf(val) < 0) {
                    return null;
                }

                return function() {
                    if(values) {
                        return values.map(function(d) {
                            return {key: d, name: d}
                        })
                    }
                    return null;
                }
            }
            return null;
        }
    }

    getListOfValues($num) {
        var prop = this.data.node.prop;
        var values = pinegrow.devTools.getCSSPropertyValues(prop);
        return values || [];
    }

    onValueEditStart(tagName, control) {
        super.onValueEditStart(tagName, control);
        if(tagName === 'VALUE') {
            var pgel = this.data.target_pgel || pinegrow.selectedElements.getLastSelected();
            if(pgel) {
                this.stylePreview = new PgFastDOMStylePreviewForPgel(pgel);
            }
        }
    }

    onValueEditDone() {
        super.onValueEditDone();
        if(this.stylePreview) {
            this.stylePreview.destroy();
            this.stylePreview = null;
        }
    }

    destroy() {
        super.destroy();
        this.stylePreview && this.stylePreview.destroy();
    }

}


class PgCSSTreeCellPropertyComponent extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-css-tree-decl pg-css-tree-with-tools">
<name data-element="name"></name> <value data-element="value"></value>
</div>`, type, no_drag);

        //this.tooltip('check', 'Open the stylesheet in a separate panel.')
    }

    getNode() {
        return this.data.node;
    }

    onPopulate() {
    }

}


class PgCSSTreeCellComment extends PgCSSTreeCellWithTools {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-css-tree-comment pg-css-tree-with-tools">#TOOLS#
<name data-element="name"></name>
</div>`, type, no_drag);

    }

}

class PgCSSTreeCellAtRule extends PgCSSTreeCellEditable {
    constructor(type, no_drag) {
        super(`<div class="pg-css-tree-atrule" data-element="cell"><i data-element="icon" class="collapse-icon icon-down"></i>@<name class="not-editable" data-element="name"></name> <span data-element="value"></span></div>`, type, no_drag);

        this.on('cell', 'click', this.onClick.bind(this))
    }

    onClick(event) {
        if(event.target.classList.contains('collapse-icon')) return;
        var dialog = new PgCSSTreeItemDialogMediaQuery(this, this.data)
        dialog.show();
    }

    getValueHTML(value) {
        if(this.data.node.name === 'import' || this.data.node.name === 'media') {
            return value;
        } else {
            super.getValueHTML(value)
        }
    }

    onSetMediaQuery(value, is_done) {
        //if(value) {
            this.onValueEdited('VALUE', value, is_done);
            value && this.displayField('VALUE', value);
        //}
    }

    onValueEdited(tagName, value, is_done) {
        var _this = this;
        if(tagName === 'VALUE') {
            const api = new PgCSSApi();
            if(value) {
                api.changeMediaQuery(this.data.node, value, function (new_node) {
                    _this.data.node = new_node;
                }, {
                    dispatchEvent: is_done ? 'Set ' + this.data.node.name : false,
                    edited_by: _this.cssTreeView
                    //edited_by: dispatchEvent ? null : this.cssTreeView
                })
            } else {
                if(is_done) {
                    api.deleteNodeAndKeepChildren(this.data.node)
                }
            }

        }
    }

}



class PgCSSTreeCellRule extends PgCSSTreeCellEditable {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-css-tree-stylesheet-rule aapg-css-tree-with-tools">
<i data-element="icon" class="collapse-icon icon-down"></i>
<name data-element="name"></name>
<count><span data-element="count"></span></count>
<i class="icon icon-plus-square" data-element="save"></i>
<i class="icon icon-repeat-Y" data-element="more"></i>
</div>`, type, no_drag, {
            comment: false
        });

        this.tooltip('count', 'The number of matched elements on the current page view. Click to select one of the elements.')

        this.on('save', 'click', this.onSave.bind(this));
        this.tooltip('save', 'Save inline style as a CSS rule.')

        this.on('more', 'click', this.onMore.bind(this));
        this.tooltip('more', 'Show context menu.')
        this.on('count', 'click', this.onCount.bind(this));
    }

    onCount(event) {
        var sel = this.data.node.selector.replace(/::?(hover|focus|active|visited|after|before)/g, '');
        try {
            var elements = pinegrow.getSelectedPage().getDocument().querySelectorAll(sel);
            var c = new PgCSSCountHandler($(event.target), elements)
        } catch(err) {
            pinegrow.showQuickError('Unable to find elements on the page.')
        }
        this.onStopEvent(event)
    }

    onMore(event) {
        this.onContextMenu(event);
    }

    onSetMediaQuery(value, is_done) {
        var mq_node = pgcssh.getMediaNode(this.data.node);
        var api = new PgCSSApi()
        api.changeMediaQueryForRule(this.data.node, value, function() {

        }, {
            edited_by: (mq_node || !is_done) ? this.cssTreeView : null
        })
    }

    addContextMenuActions(actions) {
        var _this = this;
        super.addContextMenuActions(actions);

        var api = new PgCSSApi();
        api.getContextMenuActionsForRule(this.data.node, this.$element).forEach(function(a) {
            actions.push(a);
        })

        var mq_node = pgcssh.getMediaNode(this.data.node);

        if(!mq_node) {
            actions.push({
                label: 'Media query',
                submenu: [
                    {
                        label: 'Edit...',
                        action: function () {
                            var dialog = new PgCSSTreeItemDialogMediaQuery(_this, _this.data)
                            dialog.show();
                        }
                    }
                ]
            })
        }
    }

    onClick(event) {
        var dialog = new PgCSSTreeItemDialogMediaQuery(this, this.data)
        dialog.show();
    }

    getNode() {
        return this.data.node;
    }

    onPopulate() {
        super.onPopulate();
        if(this.data.node.inline && this.data.node.nodes.length) {
            this.showElement('save', 'inline')
        } else {
            this.hideElement('save')
        }
        if(this.data.node.inline) {
            this.hideElement('count')
        } else {
            this.showElement('count', 'inline')
        }
    }

    onSave(e) {
        e.preventDefault();
        e.stopPropagation();

        var _this = this;

        var $target = $(e.target);
        var rule = this.getNode();
        var elm = pinegrow.selectedElements.getLastSelected();

        var copyToNewRule = function() {
            _this.cssTreeView.activeControls.openCreateNewRuleDialog(null, null, null, null, false, $target, {
                title: 'Save the inline style into a proper CSS rule',
                save_inline_source_rule: _this.getNode()
            });
        }

        var add_to_rules = pinegrow.pgActiveRules.getShownNodes().filter(function(r) {
            var cs = pgcssh.getStylesheetForNode(r);
            if(cs && !cs.canEdit(true)) return false;
            return true;
        })

        if(add_to_rules.length === 0) {
            copyToNewRule();
        } else {
            var actions = [
                {
                    label: 'Create new rule...',
                    action: function() {
                        copyToNewRule();
                    }
                },
                {
                    type: 'divider'
                },
                {
                    type: 'header',
                    label: 'Add to existing rule:'
                }
            ]

            add_to_rules.forEach(function(r) {

                var name = pgcssh.getRuleDisplayName(r);

                name += ' <small>' + pgcssh.getStylesheetForNode(r).name + '</small>';

                actions.push(
                    {
                        label: name,
                        action: function() {
                            var cs = pgcssh.getStylesheetForNode(r);

                            var last_decl = 0;

                            for(var i = 0; i < rule.nodes.length; i++) {
                                if(rule.nodes[i].type === 'decl') {
                                    last_decl = i;
                                }
                            }

                            var col = pinegrow.getCollectionForElement(elm);
                            col.forEachElement(function (pgel) {
                                pgel.removeAttr('style');
                            });

                            for(i = 0; i < rule.nodes.length; i++) {
                                if(rule.nodes[i].type === 'decl') {
                                    cs.ruleValueChanged(r, rule.nodes[i].prop, rule.nodes[i].value, null, false, 'gui', i === last_decl, null);
                                }
                            }

                            pinegrow.changeManager.didChange(col, 'Remove style attribute');

                            //Needs this to properly update
                            pinegrow.dispatchEvent('on_css_node_updated', null, {node: r, stylesheet: cs});

                            $.fn.crsa('selectRule', r, _this.cssTreeView);
                            //pinegrow.reselectElement();
                        }
                    }
                )
            })

            var menu = new CrsaContextMenu(actions, $target);
            menu.showForElement($target);
        }
    }

    onStopEvent(event) {
        event.stopPropagation()
    }

}


class PgCSSTreeCellAddProp extends PgTableGridCell {
    constructor(type, no_drag) {
        super(`<div data-element="cell" class="pg-css-tree-add-prop" >
<i data-element="add" class="icon icon-plus"></i>
<div data-element="name"></div>
<div data-element="value"></div>
</div>`, type, no_drag);

        this.ni = null;
        this.vi = null;

        this.tooltip('cell', 'Click to add a CSS property.')

        //this.on('check', 'change', this.onUncheck.bind(this));
        this.on('add', 'click', this.onClick.bind(this));
        //this.on('value', 'blur', this.onValueBlur.bind(this));
        //this.on('value', 'keypress', this.onValueKey.bind(this));
        //this.on('value', 'input', this.onValueInput.bind(this));
    }

    areFieldsShown() {
        return this.data.fields_shown;
    }

    createFields() {
        if(!this.ni && !this.vi) {
            this.ni = new PgInputField('name', {
                type: 'text',
                show_empty: false,
                name: 'Search',
                without_text: true,
                slider_def_unit: '',
                placeholder: 'name',
                auto_resize: true
            });

            this.ni.appendTo($(this.getElement('name')));

            this.vi = new PgInputField('value', {
                type: 'text',
                show_empty: false,
                name: 'Search',
                without_text: true,
                slider_def_unit: '',
                placeholder: 'value',
                auto_resize: true
            });

            this.vi.appendTo($(this.getElement('value')));

            this.vi.on('blur', this.onValueBlur.bind(this))
            this.vi.on('keypress', this.onValueKey.bind(this))
            this.vi.on('input', this.onValueInput.bind(this))
        } else {
            this.ni.show();
            this.vi.show();
        }
        this.addClass('add', 'hide');
        this.data.fields_shown = true;
        this.tableGrid.cellSizeForDataChanged(this.data);
        this.tableGrid.showCells();
    }

    changeRule(prop, value, dispatchEvent) {
        const rule = this.data.node.target_node;
        if(prop.length && value.length) {
            const api = new PgCSSApi();
            if (this.prop_node) {
                api.setRuleProperty(this.prop_node, prop, value, function () {

                }, {
                    dispatchEvent: dispatchEvent || false,
                    //edited_by: dispatchEvent ? null : this.cssTreeView
                })
            } else {
                this.prop_node = api.addRuleProperty(rule, prop, value, function () {

                }, {
                    dispatchEvent: dispatchEvent || false,
                    //edited_by: dispatchEvent ? null : this.cssTreeView
                })
            }
        }
    }

    onAdd(rule, prop, value) {
        const api = new PgCSSApi();
        if(prop && value !== '') {
            this.prop_node = api.addOrSetRuleProperty(rule, prop, value, function() {

            })
        } else if(prop) {
            this.createFields();
            this.ni.setValue(prop);
            this.vi.focus();
        }
    }

    onValueBlur(event) {
        this.changeRule(this.ni.getValue(), this.vi.getValue(), true);
    }

    onValueKey(event) {
        if(event.key === 'Enter') {
            this.vi.blur();
            //this.onValueBlur();
        }
    }

    onValueInput(event) {
        this.changeRule(this.ni.getValue(), this.vi.getValue(), false);
    }

    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
        const _this = this;
        const $e = $(event.currentTarget);
        const rule = this.data.node.target_node;

        var name = pgcssh.getRuleDisplayName(rule);

        var actions = [
            {
                type: 'html',
                html: `<p style="margin-bottom:0;padding: 5px 10px 0px;"><span style="color:rgba(255,255,255,0.70);">Set property for</span> <span style="color:rgba(255,255,255,1)">${name}</span></p>`
            },
            {
                type: 'divider'
            }
        ]

        var stylePreview = null;
        var pgel = this.data.target_pgel || pinegrow.selectedElements.getLastSelected();
        if(pgel) {
            stylePreview = new PgFastDOMStylePreviewForPgel(pgel);
        }

        const api = new PgCSSApi();
        const m = new CrsaContextMenu(actions.concat(api.getInsertCSSPropMenu(function(prop, value) {
            stylePreview.restore();
            _this.onAdd(rule, prop, value)
            if(value === null || value === '') {
                //if no value, we close the menu and let the user enter the value
                m.close();
            }
        }, stylePreview)), $e);
        m.showForElement($e, null, 4);

        m.onClosed = function() {
            stylePreview.destroy();
        }
        m.keepOpenOnClick = true;
    }

    setData(data) {
        if(data === null && this.data) {
            this.data.fields_shown = false;
        }
        this.removeClass('add', 'hide');
        super.setData(data);
    }

    onPopulate() {
        super.onPopulate();
        this.prop_node = null;
        this.ni && this.ni.hide();
        this.vi && this.vi.hide();
    }
}


var PgCSSTreeView = function(active) {

    pinegrow.registerTreeView(this);

    var $element = $('<div/>', {id: 'pg-tree', class: 'pg-tree pg-css-tree' + (active ? ' pg-css-tree-active' : '')});

    var api = new PgApi();
    var cssApi = new PgCSSApi();

    var search = new PgSearchBox({
        toolbar_on: true
    });

    var shownCs = null;

    var isActive = this.isActive = function() {
        return shownCs === null;
    }

    var toolbar = this.toolbar = search.getToolbar();

    var $toolbar_section = toolbar.addSection('settings').$element;

    var stylesButton = new PgButtonToolbarItem('icon-filter', 'Select what kind of elements to show in the tree.');

    toolbar.addItem('settings', stylesButton);

    var filters = {
        position: {
            label: 'Position',
            desc: 'Show only the elements with inline styles',
            re: /_(top|right|bottom|left|position|z\-index)_/i
        },
        text: {
            label: 'Text',
            desc: 'Show only images',
            re: /font|line-height|_color_|letter-spacing|text-decoration|text-align|text-transform|white-space|word-break|_direction_|text-indent/i
        }
    }

    var default_filter_options = {};

    $.each(filters, function(key, name) {
        default_filter_options[key] = false;
    })

    var filter_options = default_filter_options;

    stylesButton.onClick = function () {

        var menu = new CrsaContextMenu(null, this.$element);

        menu.add({
            type: 'header',
            label: 'Show only:'
        });

        $.each(filters, function(key, info) {
            menu.add({
                label: info.label,
                action: function() {
                    var on = !(filter_options[key] === true);
                    _this.setFilterOption(on ? key : null);
                },
                check: filter_options[key] === true
            })
        })

        menu.add({
            type: 'divider'
        });

        menu.add({
            label: 'Clear filter',
            action: function() {
                _this.setFilterOption(null);
            }
        })

        menu.showForElement(this.$element, null, 8);
    }

    this.setFilterOption = function(key, skip_update) {
        filter_options = $.extend({}, default_filter_options);
        if(key) {
            var info = filters[key];
            filter_options[key] = true;
            stylesButton.setActive(true);
            pinegrow.showMode(info.desc, true);
            setFilterMessage(info.label);
        } else {
            stylesButton.setActive(false);
            setFilterMessage();
        }
        cs_tree.setFilterOptions(filter_options);
        if(!skip_update) {
            cs_tree.research(true);
        }
    }

    //search.$element.appendTo($element);

    var $selects = search.$element.find('.pg-button-toolbar-section.icons');

    //var spacer = new PgSearchBoxSpacer();
    //spacer.$element.appendTo($element);

    search.onSearch = function(filter) {
        var p = new CrsaProfile();
        if(cs_tree) cs_tree.search(filter);

        if(filter.length) {
            pg$Show($selects, 'inline-block');
        } else {
            pg$Hide($selects);
        }

        p.show('SEARCH');
    }

    pg$Hide($selects);

    var $filterMsg = $('<div class="pg-tree-filter-msg"><div>Show only: <span></span><i class="close icon icon-close"></i></div></div>').appendTo($element);

    pg$Hide($filterMsg);

    $filterMsg.on('click', function(e) {
        e.preventDefault();
        _this.setFilterOption(null);
    })

    var setFilterMessage = function(msg) {
        if(msg) {
            $filterMsg.find('span').html(msg);
            pg$Show($filterMsg);
            $element.addClass('with-filter-msg');
        } else {
            pg$Hide($filterMsg);
            $element.removeClass('with-filter-msg');
        }
    }

    var $tree = $('<div/>', {class: 'pg-tree-container'}).appendTo($element);

    var $content = $element.find('.editor');

    var view = this.view = new PgUIView($element, 'tree', 'Tree');

    var view_prefix = `pg_ct${view.getId()}_`;

    var flag_overriden = view_prefix + 'ov';
    var flag_inherited = view_prefix + 'inh';
    var flag_not_inherited = view_prefix + 'ninh';
    var flag_expanded = view_prefix + 'exp';
    var flag_related = view_prefix + '_rel';

    view.classForContainer = 'pg-tree-panel-container';

    var _this = this;

    view.tabIcon = 'icon-Pin11';

    var currentPage;

    if(active) {
        var activeControls = this.activeControls = new PgCSSTreeActiveCommandsView();
        activeControls.cssTreeView = this;
        $element.prepend(activeControls.view.get$Element());

        activeControls.onStateChanged = function() {
            onElementSelected();
        }
    }

    view.onShow = function() {

    }


    var menuItems = [
        {
            icon: 'icon-bin',
            name: 'Delete',
            func: function(data) {

            }
        },
        {
            icon: 'icon-duplicate',
            name: 'Duplicate',
            func: function(data) {

            }
        },
        {
            icon: 'icon-hide',
            name: 'Hide / show in Pinegrow',
            key: 'hide',
            func: function(data, $item) {

            }
        },
        {
            icon: '<i class="icon icon-Ins_before"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert before',
            func: function(data) {

            }
        },
        {
            icon: '<i class="icon icon-Ins_after"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert after',
            func: function(data) {
                //showQuickInsertIntoTree(data, 'insertAfter');
            }
        },
        {
            icon: '<i class="icon icon-Append"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert into at beginning (prepend)',
            func: function(data) {

            }
        },
        {
            icon: '<i class="icon icon-Prepend"><span class="path1"></span><span class="path2"></span></i>',
            name: 'Insert into at end (append)',
            func: function(data) {

            }
        }
    ]


    var menu = new PgTreeNodeMenu(menuItems);

    menu.hide();

    var dimension;

    var hasHScrollBar = true;
    var hasVScrollBar = true;

    var tableGrid = new PgTableGrid({
        highlightLevels: false
    });

    tableGrid.variableHeight = true;

    tableGrid.getCellWidthForData = function(data) {
        if(data.node.type === 'decl') {
            if(data.node[flag_expanded]) {
                return 0;
            }
            if(!data.cellWidth) {
                data.cellWidth = Math.round(pgMeasureTextWidth(data.node.prop + data.node.value) + 30 + data.html_val_count_colors * 18);
            }
            return data.cellWidth;
        }
        if(data.node.type === 'comment') {
            if(!data.cellWidth) {
                data.cellWidth = Math.round(pgMeasureTextWidth(data.node.text)) + 30;
            }
            return data.cellWidth;
        }
        if(data.node.type === 'add_prop') {
            if(data.fields_shown) {
                data.cellWidth = 200;
            } else {
                data.cellWidth = 22;
            }
            return data.cellWidth;
        }
        return 0;
    }

    tableGrid.getCellHeightForData = function(data) {
        return tableGrid.cellHeight;
    }

    var quickInsertConnector = null;

    tableGrid.onScroll = function() {
        if(quickInsertConnector) {
            quickInsertConnector.updatePosition();
        }
        updateMenuPosition();
    }

    $tree.append(tableGrid.$element);

    menu.$element.appendTo($element);

    tableGrid.setTemplate('<div class="pg-css-tree-stylesheet-default"><i data-element="icon" class="collapse-icon icon-down"></i><name data-element="name"></name></div>')

    tableGrid.setTemplate('<div class="pg-css-tree-inherited">Inherited from <name data-element="name"></name></div>', 'inherited_pgel');

    tableGrid.setTemplate(PgCSSTreeCellRule, 'rule')

    tableGrid.setTemplate(PgCSSTreeCellStylesheet, 'stylesheet');

    tableGrid.setTemplate(PgCSSTreeCellProperty, 'decl');
    tableGrid.setTemplate(PgCSSTreeCellPropertyComponent, 'component');

    tableGrid.setTemplate(PgCSSTreeCellAtRule, 'atrule');

    tableGrid.setTemplate(PgCSSTreeCellComment, 'comment');
    tableGrid.setTemplate(PgCSSTreeCellAddProp, 'add_prop');

    tableGrid.onSetDataToCell = function(data, cell) {
        if(this.data) {
            this.data.cell = null;
        }
        data.cell = cell;

        cell.cssTreeView = _this;
        cs_tree.populateDataItem(data, currentPage);

        var node = data.node;

        switch(node.type) {
            case 'root':
                cell.setHtml('name', node.pgStylesheet.name);
                break;
            case 'stylesheet':
                cell.setHtml('name', node.pgStylesheet.name);
                break;
            case 'inherited_pgel':
                cell.setHtml('name', node.name);
                break;
            case 'comment':
                cell.setHtml('name', node.text);
                break;
            case 'rule':
                cell.setHtml('name', data.node.selector);
                cell.setHtml('count', data.use_count);
                if(node[flag_related]) {
                    cell.addClass('cell', 'related');
                } else {
                    cell.removeClass('cell', 'related');
                }
                break;
            case 'atrule':
                cell.setHtml('name', data.node.name);
                cell.setHtml('value', data.params_html);
                if(node[flag_related]) {
                    cell.addClass('cell', 'related');
                } else {
                    cell.removeClass('cell', 'related');
                }
                break;
            case 'decl':
                cell.setHtml('name', node.prop);
                cell.setHtml('value', data.value_html);
                if(node.important) {
                    cell.addClass('important', 'on');
                } else {
                    cell.removeClass('important', 'on');
                }
                if(node[flag_overriden]) {
                    cell.addClass('cell','overriden');
                } else {
                    cell.removeClass('cell','overriden');
                }
                if(node[flag_not_inherited]) {
                    cell.addClass('cell', 'not-inherited');
                } else {
                    cell.removeClass('cell', 'not-inherited');
                }
                if(node[flag_related]) {
                    cell.addClass('cell', 'related');
                } else {
                    cell.removeClass('cell', 'related');
                }
                break;
            case 'component':
                cell.setHtml('name', node.prop);
                cell.setHtml('value', data.value_html);
                break;
            case 'add_prop':
                break;
            default:
                cell.setHtml('name', data.node.type);
        }



        if((node.pg_selected || false) !== (cell.isSelected || false)) {
            if (node.pg_selected) {
                cell.$element.addClass('selected');
            } else {
                cell.$element.removeClass('selected');
            }
            cell.isSelected = node.pg_selected || false;
        }
        if(tableGrid.hasChildren(data)) {
            //cell.removeClass('icon', 'noicon');
            if (data.collapsed) {
                cell.addClass('icon', 'icon-right');
                cell.removeClass('icon', 'icon-minus', 'icon-down');
                cell.$element.addClass('collapsed');
            } else {
                cell.removeClass('icon', 'icon-minus', 'icon-right');
                cell.addClass('icon', 'icon-down');
                cell.$element.removeClass('collapsed');
            }
        } else {
            cell.removeClass('icon', 'icon-down', 'icon-right');
            cell.addClass('icon', 'icon-minus');
            cell.$element.removeClass('collapsed');
        }

        if(data.focused) {
            cell.$element.addClass('focused');
        } else {
            cell.$element.removeClass('focused');
        }

        var search = data.search || 0;
        cell.$element.removeClass('search-1 search-2 search-0').addClass('search-' + search);

        cell.onPopulate();
    }

    tableGrid.onRepaint = function() {
        menu.setBottom(tableGrid.getHScrollBarSize());
        menu.setRight(tableGrid.getVScrollBarSize());
        updateMenuPosition();
    }


    this.scrollToNode = function(node) {
        var data = getDataForCSSNode(node)
        if(data) {
            tableGrid.scrollTo(data)
        }
    }

    var scrubValue = null;
    var colorValue = null;
    var editValue = null;
    var scrubListValue = null;

    var get$ValueElementValue = function($num) {
        var $value = $num.closest('value,name');
        var text = '';

        var node = $value.get(0);

        for (var i = 0; i < node.childNodes.length; i++) {
            var cn = node.childNodes[i];
            if(cn.nodeType === 3) {
                text += cn.textContent;
            } else if(cn.nodeType === 1) {
                if(cn.tagName === 'COLOR') {
                    text += $(cn).find('> span').text();
                } else {
                    text += cn.textContent;
                }
            }
        }
        return text;
    }

    var refreshDataItem = function(data) {
        if(data) {
            data.populated = false;
            if(tableGrid) {
                tableGrid.updateItem(data);
            }
        }
    }

    var refreshDataItems = function(datas) {
        datas.forEach(function(data) {
            data.populated = false;
        })
        if(tableGrid) {
            tableGrid.updateItems(datas);
        }
    }

    var refreshGrid = function(done) {
        nextFrame.do('refreshGrid', function() {
            //_this.research();
            if(tableGrid) {
                tableGrid.refresh();

                if(!view.isVisible()) {
                    view.whenVisible(function() {
                        tableGrid.show();
                        if(done) done();
                    })
                } else {
                    if(done) done();
                }
            }
        })
    }

    this.updateLayout = function() {
        refreshGrid();
    }

    var addGridLine = function(data, position) {
        var node = pinegrow.pgPostCSSHelper.createNode("decl", 'color', 'red', data.node.parent);

        var add_level = 0;

        switch(position) {
            case 'insertAfter':
                pinegrow.pgPostCSSHelper.insertNodeAfter(node, data.node);
                break;
            case 'insertBefore':
                pinegrow.pgPostCSSHelper.insertNodeBefore(node, data.node);
                break;
            case 'prepend':
                pinegrow.pgPostCSSHelper.insertNodeAt(node, data.node, 0);
                add_level = 1;
                break;
        }

        var list = [];
        cs_tree.createDataItemForCSSNode(list, node, false, data.node.level + add_level);

        pinegrow.dispatchEvent('on_css_node_added', null, {
            node: node,
            stylesheet: pgcssh.getStylesheetForNode(data.node),
            edited_by: _this,
            undoIgnore: true
        });

        var nd = list[0];
        nd.inserted = true;

        var helper = tableGrid.getHelper();

        switch(position) {
            case 'insertAfter':
                helper.insertAfter(data, [nd]);
                break;
            case 'insertBefore':
                helper.insertBefore(data, [nd]);
                break;
            case 'prepend':
                helper.insertAfter(data, [nd]);
                break;
        }

        helper.reindexData();
        refreshGrid(function() {
            tableGrid.scrollTo(nd);
            var cell = tableGrid.getCellForData(nd);

            if(cell) {
                cell.$element.find('name').trigger('click');
            }
        });
    }


    var activeInlineToMatchedInline = function(rule) {
        if(rule.selector === 'Style attribute') {
            var pgel = rule.inline_for_pgel || pinegrow.selectedElements.getLastSelected();
            var list = tableGrid.data;
            for(var i = 0; i < list.length; i++) {
                if(list[i].node.inline_for_pgel === pgel && list[i].node.inline === 'source') {
                    return list[i].node;
                }
            }
        }
        return rule;
    }

    view.on('crsa-rule-selected', function(event, obj) {
        view.whenVisible(function() {
            if(obj) {
                var rules = [];
                if(obj.previous_rule) {
                    var pr = activeInlineToMatchedInline(obj.previous_rule);
                    pr.pg_selected = false;
                    rules.push(pr);
                }
                if(obj.rule) {
                    var r = activeInlineToMatchedInline(obj.rule);
                    rules.push(r);
                    r.pg_selected = true;
                }

                var datas = getDatasForCSSNodes(rules);
                refreshDataItems(datas);


                //showCssGui(obj.rule, obj.options);
                //selectedRule = obj.rule;
            }
        })
    });



    view.on('crsa-rules-changed', function(event, info) {
        onElementSelected();
        onPageStylesheetsLoaded(currentPage);
    });

    var onNodeSelectedDeselected = function(pagenull, nodes, info) {
        var datas;
        if(info.source === _this && info.datas) {
            datas = info.datas;
        } else {
            datas = getDatasForCSSNodes(nodes);
        }
        refreshDataItems(datas);
    }

    pinegrow.addEventHandler('on_css_node_selected_deselected', onNodeSelectedDeselected);

    var onNodeChanged = function(pagenull, obj) {
        if(obj.edited_by !== _this && cs_tree) {
            cs_tree.create();
            showTree(cs_tree);
            //refreshGrid();
            return;
            var node = obj.node;
            var data = getDataForCSSNode(node);
            if(data) {
                refreshDataItem(data);
            }
        }
    }

    var onNodeDeleted = function(pagenull, obj) {
        if(obj.edited_by !== _this) {
            if(isActive()) {
                onElementSelected();
            } else {
                if(pgcssh.getStylesheetForNode(obj.node) === shownCs) {
                    showTreeForStylesheet()
                }
            }
        }
    }

    var onNodeAdded = function(pagenull, obj) {
        onNodeDeleted(pagenull, obj)
    }

    var onAttributeStyleChanged = function(pagenull, pgel, info) {
        if(!info || info.edited_by !== _this) {
            if(isActive()) {
                onElementSelected();
            }
        }
    }

    var onCSSSourceChanged = function(pagenull, info) {
        if(info.edited_by !== _this) {
            if(isActive()) {
                onElementSelected();
            } else {
                if(info.list.indexOf(shownCs) >= 0) {
                    showTreeForStylesheet()
                }
            }
        }
    }

    var onRuleChangedInEditor = function(pagenull, info) {
        onNodeDeleted(pagenull, info)
    }

    pinegrow.addEventHandler('on_css_node_deleted', onNodeDeleted);
    pinegrow.addEventHandler('on_css_node_updated', onNodeChanged);
    pinegrow.addEventHandler('on_css_node_added', onNodeAdded);
    pinegrow.addEventHandler('on_css_attribute_style_changed', onAttributeStyleChanged);
    pinegrow.addEventHandler('on_css_source_changed', onCSSSourceChanged);
    pinegrow.addEventHandler('on_css_rule_changed_in_code_editor', onRuleChangedInEditor);

    var getInsertCSSPropMenu = function() {
        const api = new PgCSSApi();
        return api.getInsertCSSPropMenu();
    }

    var wireTreeElements = function() {

        var onChangeValue = function($num, value, is_done) {
            if(value === undefined) value = get$ValueElementValue($num);
            var event = is_done || false;
            var data = getDataForTree$Element($num)
            var node = data ? data.node : null;
            if(node) {
                data.cell.onValueEdited($num.parent().get(0).tagName, value, is_done, 'scrub');
            }
        }

        var onChangeProp = function($name) {

        }

        scrubValue = new PgCSSEditableValue(tableGrid.$container, 'num');

        scrubValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        scrubValue.onChange = function($num, val, is_done) {
            onChangeValue($num, undefined, is_done);
        }


        scrubListValue = new PgCSSEditableListValue(tableGrid.$container, 'numlist');

        scrubListValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        scrubListValue.onGetList = function($num) {
            var data = getDataForTree$Element($num)
            return data.cell.getListOfValues($num);
        }

        scrubListValue.onStart = function($name) {
            var data = getDataForTree$Element($name)
            data && data.cell.onValueEditStart($name.parent().get(0).tagName);
        }

        scrubListValue.onDone = function($name) {
            var data = getDataForTree$Element($name)
            //tree is already updated at this point
            //data && data.cell.onValueEditDone();
        }

        scrubListValue.onChange = function($num, val, is_done) {
            onChangeValue($num, undefined, is_done);
        }

        scrubListValue.onListItemHighlighted = function($num, val) {
            var data = getDataForTree$Element($num)
            data.cell.onListItemHighlighted('VALUE', val === null ? val : {key: val});
        }


        colorValue = new PgCSSEditableColor(tableGrid.$container, 'colorbox');

        colorValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        colorValue.onChange = function($color, is_done) {
            onChangeValue($color, undefined, is_done);
        }

        editValue = new PgCSSEditableText(tableGrid.$container, 'name:not(.not-editable),value');
        editValue.onGetValue = function($el) {
            return $el.text();
        }

        editValue.onCanEdit = function($name) {
            var data = getDataForTree$Element($name)
            return data.cell.canEdit();
        }

        editValue.onStart = function($name, control) {
            var data = getDataForTree$Element($name)
            data && data.cell.onValueEditStart($name.get(0).tagName, control);
        }

        editValue.onDone = function($name) {
            var data = getDataForTree$Element($name)
            data && data.cell.onValueEditDone();
        }

        editValue.onChange = function($name, is_done, value) {
            var data = getDataForTree$Element($name)
            var node = data ? data.node : null;
            if(node) {
                data.cell.onValueEdited($name.get(0).tagName, value, is_done, 'textedit');
            }
            if(is_done) {
                _this.refresh();
                //refreshGrid()
                //refreshDataItem(data)
            }
        }
        editValue.onGetOptions = function($field) {
            var data = getDataForTree$Element($field)
            var node = data ? data.node : null;
            if(node) {
                return data.cell.onGetValueOptions($field.get(0).tagName);
            }
            return null;

            if($field.get(0).tagName === 'NAME') {
                return function() {
                    return pinegrow.devTools.getCSSPropertiesOptions();
                }
            } else if($field.get(0).tagName === 'VALUE') {

            }
            return null;
        }

        editValue.onListItemHighlighted = function(item, $name) {
            var data = getDataForTree$Element($name)
            var node = data ? data.node : null;
            if(node) {
                return data.cell.onListItemHighlighted($name.get(0).tagName, item);
            }
        }
        //return;



        tableGrid.$container
            .on('aaacontextmenu', '.pg-table-grid-cell', function (event) {
                event.preventDefault();
                event.stopPropagation();

                var $el = $(this)
                var data = getDataForTree$Element($el);

                var actions = []

                var cmds = {
                    insert_prop: {
                        label: 'Insert property',
                        submenu: function() {
                            return getInsertCSSPropMenu()
                        }
                    },
                    insert_rule: {
                        label: 'Insert rule',
                        action: function() {}
                    },
                    important: {
                        label: 'Important',
                        action: function() {},
                        check: data.node.important || false
                    },
                    override: {
                        label: 'Override',
                        action: function() {}
                    },
                    override_in: {
                        label: 'Override in',
                        action: function() {}
                    },
                    duplicate: {
                        label: 'Duplicate',
                        action: function() {}
                    },
                    duplicate_in: {
                        label: 'Duplicate in',
                        action: function() {}
                    },
                    media_query: {
                        label: 'Media query',
                        action: function() {}
                    },
                    supports: {
                        label: 'Supports',
                        action: function() {}
                    },
                    div: {
                        type: 'divider'
                    }
                }

                if(data.node) {
                    switch(data.node.type) {
                        case 'decl':
                            actions.push(cmds.insert_prop)
                            actions.push(cmds.div)
                            actions.push(cmds.important)
                            break;
                        case 'rule':
                            actions.push(cmds.insert_prop)
                            actions.push(cmds.div)
                            actions.push(cmds.insert_rule)
                            actions.push(cmds.div)
                            actions.push(cmds.media_query)
                            actions.push(cmds.supports)
                            actions.push(cmds.div)
                            actions.push(cmds.override)
                            actions.push(cmds.override_in)
                            actions.push(cmds.duplicate)
                            actions.push(cmds.duplicate_in)
                            break;
                    }
                }

                if(actions.length) {
                    var menu = new CrsaContextMenu(actions, $el);
                    menu.showForElement($el)
                }
                return false;
            })
            .on('mouseover', '.pg-table-grid-cell', function (event) {
                if(!tableGrid.inScroll) {
                    var data = getDataForEvent(event);

                    if (!pinegrow.getDragMenu()) {

                    }

                }
                event.stopImmediatePropagation();
            })
            .on('mouseout', '.pg-table-grid-cell', function (event) {
                if(!tableGrid.inScroll) {
                    if (!pinegrow.getDragMenu()) {

                    }

                }
                event.stopImmediatePropagation();
            })
            .on('click', 'i.collapse-icon', function (event) {

                var data = getDataForEvent(event);

                data.collapsed = !(data.collapsed || false);

                if(event.altKey) {
                    tableGrid.forEachVisibleSibling(data, function(ch) {
                        ch.collapsed = data.collapsed;

                    })
                }

                tableGrid.refresh();
                event.preventDefault();
                event.stopPropagation();
            })
            .on('click', 'i.show-hide', function (event) {

                var data = getDataForEvent(event);
                showItem(data);
                event.preventDefault();
                event.stopPropagation();
            })
            .on('click', function(event) {
                if(quickInsertPosition) {
                    event.preventDefault();
                    event.stopPropagation();
                    event.stopImmediatePropagation();

                    //show insert prop menu
                    //repaint the tree
                    var node = quickInsertPosition.data.node;
                    if(node.type === 'add_prop') {
                        node = node.target_node;
                    }
                    var rule = pgcssh.getRuleForNode(node);

                    var name = pgcssh.getRuleDisplayName(rule);

                    var actions = [
                        {
                            type: 'html',
                            html: `<p style="margin-bottom:0;padding: 5px 10px 0px;"><span style="color:rgba(255,255,255,0.70);">Set property for</span> <span style="color:rgba(255,255,255,1)">${name}</span></p>`
                        },
                        {
                            type: 'divider'
                        }
                    ]

                    var stylePreview = null;
                    var pgel = quickInsertPosition.data.target_pgel || pinegrow.selectedElements.getLastSelected();
                    if(pgel) {
                        stylePreview = new PgFastDOMStylePreviewForPgel(pgel);
                    }

                    const $e = $(event.currentTarget);
                    const api = new PgCSSApi();
                    const m = new CrsaContextMenu(actions.concat(api.getInsertCSSPropMenu(function(prop, value) {
                        stylePreview.restore();
                        api.addRuleProperty(rule, prop, value || '', function() {
                            _this.refresh();
                        }, {
                            insertAtIndex: rule.nodes.indexOf(node) + 1
                        })
                    }, stylePreview)), $e);

                    m.onClosed = function() {
                        stylePreview.destroy();
                    }
                    m.keepOpenOnClick = true;

                    m.showAt(event.pageX, event.pageY, tableGrid.$container);
                }
            })
            .on('click', '.pg-table-grid-cell', function (event) {

                //event.stopImmediatePropagation();
                //event.preventDefault();

                var $node = $(this);
                var data = getDataForTree$Element($node);

                if(quickInsertPosition) {
                    return;
                }

               // addGridLine(data);
               // return;

                if(data && data.node) {

                    var rule = pgcssh.getRuleForNode(data.node);

                    if(rule) {
                        if(!pinegrow.isSelectedRule(rule)) {
                            pinegrow.selectRule(rule);
                        }
                        cssApi.highlightNodeInCode(rule);
                    } else {
                        return;
                    }

                    return;

                    var selected_done = false;

                    if(event.shiftKey) {

                        var selected = [];
                        var selected_datas = [];
                        var last_node = pinegrow.selectedCSSNodes.getLastSelected();

                        if (last_node) {
                            var last_data = getDataForCSSNode(last_node);
                            if(last_data) {
                                var inc = last_data.visible_idx > data.visible_idx ? -1 : 1;

                                for (var i = last_data.visible_idx + inc; i !== data.visible_idx + inc; i = i + inc) {
                                    if (tableGrid.visibleData[i].level == last_data.level) {
                                        var node = tableGrid.visibleData[i].node;
                                        if(!pinegrow.selectedCSSNodes.isSelected(node)) {
                                            pinegrow.selectedCSSNodes.select(node);
                                            selected.push(node);
                                            selected_datas.push(tableGrid.visibleData[i]);
                                        }
                                    }
                                }
                            }

                            if(selected.length) {
                                selected_done = true;
                                pinegrow.selectedCSSNodes.dispatchEvent(selected, {
                                    datas: selected_datas,
                                    source: _this
                                })
                            } else {
                                selected_done = true;
                                pinegrow.showQuickError('SHIFT + Click can only select elements on the same level.');
                            }
                        }

                    } else if(crsaIsCmdPressed(event)) {
                        pinegrow.selectedCSSNodes.toggle(data.node);

                        pinegrow.selectedCSSNodes.dispatchEvent([data.node], {
                            source: _this,
                            datas: [data]
                        })

                        selected_done = true;

                    }
                    if(!selected_done) {
                        pinegrow.selectedCSSNodes.clear({
                            source: _this
                        })
                        pinegrow.selectedCSSNodes.select(data.node);
                        pinegrow.selectedCSSNodes.dispatchEvent([data.node], {
                            source: _this,
                            datas: [data]
                        })
                    }

                }

                return;
                //selectNode(node);

                var rule = pgcssh.getRuleForNode(node)

                if(rule) {
                    pinegrow.selectRule(rule);
                }
                return;

                if(pgel) {
                    if(quickInsertPosition) {
                        showQuickInsertIntoTree(data, quickInsertPosition);
                    } else {
                        var sel_done = false;

                        if (event.shiftKey) {
                            var selected = false;
                            var last_pgel = pinegrow.selectedElements.getLastSelectedOnPage(currentPage);
                            if (last_pgel) {
                                var last_data = currentPage.tree.getTreeDataItemForPgId(last_pgel.getId());
                                var inc = last_data.visible_idx > data.visible_idx ? -1 : 1;
                                var col = new PgCollection();
                                for (var i = last_data.visible_idx + inc; i !== data.visible_idx + inc; i = i + inc) {
                                    if(tableGrid.visibleData[i].level == last_data.level) {
                                        var cpgel = _this.getPgelOfDataItem(tableGrid.visibleData[i]);
                                        if (cpgel) {
                                            //pinegrow.selectedElements.add(cpgel);
                                            col.add(cpgel);
                                            selected = true;
                                        }
                                    }
                                }
                                pgel.scrollTo();
                                if(selected) {
                                    pinegrow.selectedElements.selectMany(col);
                                }
                                sel_done = true;

                                if(!selected) {
                                    pinegrow.showQuickMessage('SHIFT + Click can only select elements on the same level.');
                                }
                            }
                        }
                        if (!sel_done) {
                            pinegrow.selectElement(pgel, 'tree', crsaIsCmdPressed(event));
                            pgel.scrollTo();

                            if($(event.target).is('.inline-styles')) {
                                pinegrow.showUIPanel('style', false);
                                //console.log(pinegrow.pgActiveRules.getActiveNodes());
                                pinegrow.activeCSSView.updateRulesDisplayOnElementSelect(true);
                            }
                        }
                    }
                } else {
                    //todo30 - handle dyn el select
                    pgDynElementMessage(quickInsertPosition ? 'Can\'t edit dynamic elements.' : 'Can\'t select a dynamic element.');
                }

                $('body').trigger('click');
                // return false;
            });

    }


    var getDataForEvent = function(event) {
        var div = $(event.currentTarget).closest('div');
        return tableGrid.visibleData[parseInt(div.attr('data-visible-idx'))];
    }

    var getDataForTree$Element = function($el) {
        var div = $el.closest('div');
        return tableGrid.visibleData[parseInt(div.attr('data-visible-idx'))];
    }

    var getCSSNodeForTree$Element = function($el) {
        var data = getDataForTree$Element($el);
        return data ? data.node : null;
    }

    var getDataForCSSNode = function(node) {
        var list = tableGrid.data;
        for(var i = 0; i < list.length; i++) {
            if(list[i].node === node) return list[i];
        }
        return null;
    }

    var getDatasForCSSNodes = function(nodes) {
        var list = tableGrid.data;
        var r = []
        for(var i = 0; i < list.length; i++) {
            if(nodes.indexOf(list[i].node) >= 0) {
                r.push(list[i])
            }
        }
        return r;
    }

    var getPgElForEvent = function(event) {
        var data = getDataForEvent(event);
        return _this.getPgelOfDataItem(data);
    }


    var getElementOfTreeNode = function ($li, $html) {
        if (!$html) $html = currentPage.get$Html();
        var el = getElementOfTreeNodeFast($li.get(0), $html.get(0));
        return el ? $(el) : null;
    }

    var getElementOfTreeNodeFast = function (data, html) {
        html = html || currentPage.get$Html().get(0);
        var el;
        var liid = data.treeId;
        if (liid && html) {
            if (html.getAttribute('data-pg-tree-id') == liid) return html;
            el = html.querySelector('[data-pg-tree-id="' + liid + '"]');
        }
        if(data.pgid) {
            if (html.getAttribute('data-pg-id') == data.pgid) return html;
            el = html.querySelector('[data-pg-id="' + data.pgid + '"]');
        }
        return el;
    }

    var getPgelOfTreeNode = function ($li) {
        return getPgelOfTreeNodeFast($li.get(0));
    }

    var getPgelOfTreeNodeFast = function (li) {
        var pgid = li.getAttribute('data-pg-id');
        if (pgid) {
            return getPgNodeByPgId(pgid);
        } else {
            return null;
        }
    }

    var getTreeNodeForPgel = function(pgel) {
        var pgid = pgel instanceof pgParserNode ? pgel.getId() : pgel;
        var node = treeTop.find('[data-pg-id="' + pgid + '"]');
        if(node.length) return node;
        return null;
    }




    /*
     var getOrCreateTreeNodeForPgel = function(pgid) {
     return getTreeNodeForPgel(pgid) || createTreeNodeForPgel(pgid);
     }*/

    this.isOverTree = function(event, drag_menu) {

        if(drag_menu && drag_menu.dragType !== 'css') return null;

        if(view.getWindow() !== event.view) return null;

        if(view.isVisible() && event.pageX >= dimension.left && event.pageX <= dimension.right - (menu.isHidden() ? 0 : (menu.width + (tableGrid.getVScrollBarSize()))) && event.pageY >= dimension.top && event.pageY <= dimension.bottom) {
            return {left: event.pageX - dimension.left, top: event.pageY - dimension.top};
        }
        return null;
    }

    this.getDropPositionInfo = function(event, menu, tree_pos) {

        var info = tableGrid.dragOver(tree_pos);

        tableGrid.showInsertionPoint(info);

        return info;
    }


    wireTreeElements();

    var dragHelper = new PgDragHelper($element, '.disable---pg-table-grid-cell', null, true);

    var dragMenu;

    dragHelper.onGetDragImage = function() {
        return 'none';
    }

    dragHelper.onBefore = function($el) {
        var data = getDataForTree$Element($el)
        if(data.no_sort) return false;
        return true;
    }

    dragHelper.on( 'dragStart', function(x, y, event) {
        $.fn.crsapages('showOverlays');

        var data = getDataForTree$Element(dragHelper.movedElement);

        var def = {
            name: 'Props'
        }

        var pgel = pgCreate('<div>Dummy</div>');

        dragMenu = new PgDragMenu(def, true, true, null, pgel, {
            dragType: 'css'
        });

        dragMenu.draggedNodes = pinegrow.selectedCSSNodes.getNormalizedListForNode(data.node)

        var cloned_cont = $('<div class="pg-tree-drag-container with-tree"></div>');

        var num_desc = tableGrid.getNumberOfDescendants(data.idx, tableGrid.data) + 1;

        //if(num_desc > 3) num_desc = 3;

        var first_level = data.level;

        for(var i = 0; i < num_desc; i++) {
            if(i == 4) break;
            var cell = tableGrid.createCellForData(tableGrid.data[data.idx + i]);
            cell.setData(tableGrid.data[data.idx + i]);
            tableGrid.onSetDataToCell(tableGrid.data[data.idx + i], cell);
            cell.showAt((cell.data.level - first_level) * tableGrid.levelPadding, i * tableGrid.cellHeight, cloned_cont);
        }
        if(num_desc > 4) {
            $('<div class="pg-table-grid-cell"><name>+ ' + (num_desc - 4) + ' more</name></div>').appendTo(cloned_cont).css({
                top: (4 * tableGrid.cellHeight) + 'px',
                left: ((tableGrid.data[data.idx + 4].level + 1 - first_level) * tableGrid.levelPadding) + 'px'
            });
        }
        cloned_cont.css('height', Math.min(num_desc, 5) * tableGrid.cellHeight);

        dragMenu.addElement(cloned_cont);
        dragMenu.movedPgel = pgel;
        dragMenu.pgel = pgel;

        tableGrid.dragStarted(data);

        dragMenu.handleMoveEvent(event, dragMenu);

        menu.hide();

    }, this );

    dragHelper.on( 'drag', function(x, y, event) {

        dragMenu.handleMoveEvent(event, dragMenu);
    }, this );

    dragHelper.on( 'dragStop', function(x, y) {
        $.fn.crsapages('showOverlays', true);

        tableGrid.dragStopped();

        console.log(dragMenu.treeDropPosition)

        var cs_list = []

        var pos = dragMenu.treeDropPosition;

        var dest_node = pos.data.node;

        var clone = dragMenu.clone;
        var deep = true;

        var nodes = dragMenu.draggedNodes;

        var updateCsList = function(node) {
            var cs = pgcssh.getStylesheetForNode(node);
            if(cs) {
                var idx = cs_list.indexOf(cs);
                if(idx < 0) {
                    cs_list.push(cs)
                }
            }
        }

        var remove_list = []
        var add_ids = []

        var partial_move = false;

        var copyNode = function(node) {
            var n = pgcssh.copyNode(node);

            var cs = pgcssh.getStylesheetForNode(node);

            add_ids.push(n)

            var copySubnodes = function(new_node, orig_node) {
                if(orig_node.nodes) {

                    var only_selected = false;

                    if(pinegrow.selectedCSSNodes.isSelected(orig_node)) {
                        //if any children selected, just copy selected, if none, copy all
                        var num_selected = 0;

                        for (var i = 0; i < orig_node.nodes.length; i++) {
                            if(orig_node.nodes[i].pg_selected) {
                                only_selected = true;
                                num_selected++;
                            }
                        }

                        partial_move = partial_move || (only_selected && num_selected < orig_node.length);
                    }
                    for (var i = 0; i < orig_node.nodes.length; i++) {
                        if(only_selected && !orig_node.nodes[i].pg_selected) continue;

                        var n = pgcssh.copyNode(orig_node.nodes[i]);
                        pgcssh.insertNodeAt(n, new_node, new_node.nodes.length);
                        add_ids.push(n);

                        copySubnodes(n, orig_node.nodes[i]);
                    }
                }
            }

            if(deep) {
                copySubnodes(n, node);
            }

            if(!clone) {
                if(pinegrow.selectedCSSNodes.isSelected(node)) {
                    pinegrow.selectedCSSNodes.deselect(node)
                    pinegrow.selectedCSSNodes.select(n)
                }
            }

            if(!clone) {
                remove_list.push(node)
            }
            return n;
        }

        updateCsList(dest_node)

        switch(pos.position) {
            case 'bottom':
                for(var i = nodes.length - 1; i >= 0; i--) {
                    pgcssh.insertNodeAfter(copyNode(nodes[i]), dest_node);
                }
                break;
            case 'top':
                for(var i = 0; i < nodes.length; i++) {
                    pgcssh.insertNodeBefore(copyNode(nodes[i]), dest_node);
                }
                break;
            case 'inside-top':
                for(var i = nodes.length - 1; i >= 0; i--) {
                    pgcssh.insertNodeAt(copyNode(nodes[i]), dest_node, 0);
                }
                break;
            case 'inside-bottom':
                for(var i = 0; i < nodes.length; i++) {
                    pgcssh.insertNodeAt(copyNode(nodes[i]), dest_node.nodes.length);
                }
                break;
        }

        if(partial_move) {
            clone = true;
            remove_list = []
        }

        remove_list.forEach(function(node) {
            updateCsList(node)
            pgcssh.removeNodeFrom(node);
        })

        add_ids.forEach(function(n) {
            var cs = pgcssh.getStylesheetForNode(n);
            if(cs) {
                cs.addIdsToNodes([n]);
            }
        })

        pinegrow.selectedCSSNodes.update(); //remove deleted nodes from the list

        $('body').trigger('crsa-rules-changed', {list: cs_list});

        cs_list.forEach(function(cs) {
            pinegrow.stylesheets.applyToPages(cs);
        })

        //dragMenu.insert();
        dragMenu.destroy();
        dragMenu = null;

        crsaFuncs.showInsertionLine(null);
        pinegrow.highlightElement(null);




    }, this );


    view.onResize = function() {
    }

    var onResize = function() {
        dimension = tableGrid.$element.get(0).getBoundingClientRect();
        tableGrid.onRepaint();
        tableGrid.updateLayout()
        tableGrid.updateContainerSize()
        tableGrid.refresh()
        //tableGrid.show();
        menu.updateLayout();
    }

    const resizeObserver = new ResizeObserver(function() {
        if(!ignore_resize_event) {
            onResize()
        } else {
            ignore_resize_event = false;
        }
    });
    resizeObserver.observe(tableGrid.$element.get(0));

    dimension = tableGrid.$element.get(0).getBoundingClientRect();

    view.onDestroy = function() {
        resizeObserver.disconnect();

        pinegrow.removeEventHandler('on_css_loaded', onCSSLoaded);
        pinegrow.removeEventHandler('on_selected_elements_changed', onElementSelected);
        //pinegrow.removeEventHandler('on_page_stylesheets_loaded', onPageStylesheetsLoaded);

        pinegrow.removeEventHandler('on_css_node_selected_deselected', onNodeSelectedDeselected);
        pinegrow.removeEventHandler('on_css_node_deleted', onNodeDeleted);
        pinegrow.removeEventHandler('on_css_node_updated', onNodeChanged);
        pinegrow.removeEventHandler('on_css_node_added', onNodeAdded);
        pinegrow.removeEventHandler('on_css_source_changed', onCSSSourceChanged);
        pinegrow.removeEventHandler('on_css_rule_changed_in_code_editor', onRuleChangedInEditor);

        pinegrow.removeEventHandler('on_page_changed', onPageChanged);
        pinegrow.removeEventHandler('on_page_loaded', onPageLoaded);
        pinegrow.removeEventHandler('on_page_refreshed', onPageLoaded);
        pinegrow.removeEventHandler('on_page_selected', onPageSelected);
        pinegrow.removeEventHandler('on_drag_drop_operation_done', onDragDropDone);
        pinegrow.removeEventHandler('on_page_frameworks_changed', onPageFrameworksChanged);
        pinegrow.removeEventHandler('on_element_isolated', onElementIsolated);
        pinegrow.removeEventHandler('on_page_view_resized', onElementSelected);

        tableGrid.$element.off('mousemove', onMouseMoved);
        tableGrid.$element.off('mouseleave', onMouseOut);
        tableGrid.$element.off('mouseenter', onMouseIn);
        //$element.off('mouseenter mouseleave', noop);
    }

    var onPageChanged = function(page, pgel, info) {
    }

    var showTree = function(cs_tree) {
        tableGrid.showInsertionLineAt(-1);
        tableGrid.setEmptyLineAt(-1);
        tableGrid.borderItem(null);

        if(cs_tree) {
            var has_isolated = false;

            cs_tree.setFilterOptions(filter_options);
            cs_tree.setTreeView(_this);
            cs_tree.setTableGrid(tableGrid);

        } else {
            currentMenuData = null;
            tableGrid.setData([]);
            menu.hide();
        }
        menu.updateLayout();
    }

    var cs_tree = null;
    var ignore_resize_event = false;

    var onCSSLoaded = function(pagenull, cs) {

    }

    var clearNodes = function(node, skip_kids) {
        if(node.type === 'decl') {
            node[flag_not_inherited] = false;
            node[flag_overriden] = false;
            node[flag_expanded] = false;
            node[flag_related] = false;
        } else {
            node[flag_related] = false;
        }
        if(!skip_kids && node.nodes) {
            node.nodes.forEach(function(node) {
                clearNodes(node);
            })
        }
        return node;
    }

    var onPageStylesheetsLoaded = function(page) {

        if(active) return;

        view.whenVisible(function() {
            if (page && page === pinegrow.getSelectedPage()) {

                currentPage = page;

                var ps = page.stylesheets;

                var csdata = {
                    rootNode: {
                        type: 'root',
                        pgStylesheet: {
                            name: 'All'
                        },
                        nodes: []
                    }
                }

                var p = new CrsaProfile(true, 'Show ALL rules');

                ps.getAllCrsaStylesheets().forEach(function (cs) {
                    if (cs.sourceStylesheet) {
                        cs = cs.sourceStylesheet;
                    }

                    var nodes = cs.rootNode ? cs.rootNode.nodes : [];

                    if (cs.rootNode) {
                        clearNodes(cs.rootNode)
                    }

                    csdata.rootNode.nodes.push({
                        type: 'root',
                        pgStylesheet: cs,
                        nodes: nodes
                    });
                })

                cs_tree = new PgStylesheetTree(csdata);
                cs_tree.showRoot = true;
                cs_tree.flag_expanded = flag_expanded;
                cs_tree.flag_related = flag_related;
                cs_tree.create();
                showTree(cs_tree);

                p.show('Tree updated')
            }
        })
    }

    var showTreeForStylesheet = function(done) {

        view.whenVisible(function() {
            dimension = tableGrid.$element.get(0).getBoundingClientRect();

            ignore_resize_event = true;

            //without this the flag is stuck
            setTimeout(function() {
                ignore_resize_event = false;
            }, 200)

            activeControls.setShowActive(shownCs, pinegrow.selectedElements.getLastSelected());

            var cs = shownCs;

            currentPage = pinegrow.getSelectedPage();

            var p = new CrsaProfile(true, 'Show ALL rules');

            if (cs.sourceStylesheet) {
                cs = cs.sourceStylesheet;
            }

            var nodes = cs.rootNode ? cs.rootNode.nodes : [];

            if (cs.rootNode) {
                clearNodes(cs.rootNode)
            }

            var csdata = {
                rootNode: {
                    type: 'root',
                    pgStylesheet: {
                        name: 'All'
                    },
                    nodes: []
                }
            }

            csdata.rootNode.nodes.push({
                type: 'root',
                pgStylesheet: cs,
                nodes: nodes
            });

            cs_tree = new PgStylesheetTree(csdata);
            cs_tree.showRoot = false;
            cs_tree.showRuleParents = false;
            cs_tree.flag_expanded = flag_expanded;
            cs_tree.flag_related = flag_related;
            cs_tree.create();
            showTree(cs_tree);

            p.show('Tree updated')

            done && done();
        })
    }
    
    var inherited_props = [
        "border-spacing", "border-collapse" , "color-adjust" , "empty-cells" , "caret-color" , "font-variant-ligatures" , "font" , "caption-side" , "font-style" , "list-style-image" , "color" , "object-position" , "font-family" , "letter-spacing" , "line-height" , "font-stretch" , "font-variant-numeric" , "rotate" , "list-style-position" , "font-size" , "font-optical-sizing" , "font-weight" , "pointer-events" , "perspective" , "text-align" , "overflow-wrap" , "text-align-last" , "quotes" , "list-style-type" , "image-rendering" , "word-wrap" , "text-indent" , "visibility" , "font-variant" , "mix-blend-mode" , "transform" , "word-spacing" , "scale" , "text-shadow" , "transform-style" , "translate" , "word-break" , "font-variant-caps" , "white-space" , "text-transform" , "cursor" , "hyphens" , "position" , "z-index"]

    var inherited_props_map = {}
    inherited_props.forEach(function(p) {
        inherited_props_map[p] = true;
    })

    var clearFlags = function(rules) {
        rules.forEach(function(rule) {
            if(rule.node.nodes) {
                rule.node.nodes.forEach(function(decl) {
                    clearNodes(decl, true)
                })
                rule.node[flag_related] = false;
                var p = rule.node.parent || null;
                while(p) {
                    clearNodes(p, true)
                    p = p.parent || null;
                }
            }
        })
    }

    var markAndFilterInherited = function(rules) {
        var r = [];
        rules.forEach(function(rule) {
            var has = false;
            if(rule.node.nodes) {
                rule.node.nodes.forEach(function(decl) {
                    if(decl.type === 'decl') {
                        if(decl.prop in inherited_props_map) {
                            decl[flag_not_inherited] = false;
                            has = true;
                        } else {
                            decl[flag_not_inherited] = true;
                        }
                    }
                })
            }
            //if(has) {
                r.push(rule)
            //}
        })
        return r;
    }

    var markOverriden = function(rules) {
        //mark overriden
        var defined = {}

        var isAStrongerThanB = function(a, b) {
            if(a.parent === b.parent) {
                //a comes after b in the same rule
                if(b.important && !a.important) return false;
                return true;
            } else {
                return a.important && !b.important;
            }
        }

        rules.forEach(function(rule) {
            if(rule.node.nodes) {
                rule.node.nodes.forEach(function(decl) {
                    if(decl.type === 'decl') {
                        if(decl.prop in defined) {
                            if(isAStrongerThanB(decl, defined[decl.prop])) {
                                defined[decl.prop][flag_overriden] = true;
                                defined[decl.prop] = decl;
                                decl[flag_overriden] = false;
                            } else {
                                decl[flag_overriden] = true;
                            }
                        } else {
                            defined[decl.prop] = decl;
                            decl[flag_overriden] = false;
                        }
                    }
                })
            }
        })
    }

    var getMatchedForPgelStack = function(pgel, done) {
        var p = new CrsaProfile(true, 'getMatchedForStack');

        pinegrow.pgActiveRules.clear();
        pinegrow.pgActiveRules.setPgel(pgel);

        pinegrow.pgActiveRules.updateMatchedRules(true, function (rules) {
            var an = pinegrow.pgActiveRules.getActiveNodes();
            console.log('BUBI', an)

            var list = []
            if(an) {
                var d = {
                    pgel: pgel,
                    rules: an.inline_rules.map(function(r) { return {node: r} }).concat(an.nodes_to_show)
                }

                //find related that are not visible
                if(true) {

                    var pgel_dom_node = pgel.getDOMElement();

                    var handleSassParents = function(rule, a) {
                        if(rule.parent && rule.parent.type === 'rule') {
                            var ps = getSelectors(rule.parent);
                            var r = []
                            for(var i = 0; i < a.length; i++) {
                                for(var n = 0; n < ps.length; n++) {
                                    if(a[i][0] !== '&') {
                                        r.push(ps[n] + a[i].substr(1))
                                    } else {
                                        r.push(ps[n] + ' ' + a[i])
                                    }
                                }
                            }
                            return r;
                        }
                        return a;
                    }

                    var getSelectors = function(rule) {
                        var a = rule.selector.split(',');
                        for(var i = 0; i < a.length; i++) {
                            a[i] = $.trim(a[i].replace("\n","").replace(/\s{2,}/ig," ").replace(/\s*>\s*/, '>')).replace(/:.*$/, '');
                        }
                        a = handleSassParents(rule, a)
                        return a;
                    }

                    var selectors = {}
                    var rules_map = new WeakMap();
                    var cs_list = [];
                    an.nodes_to_show.forEach(function(d) {
                        if(d.node.type === 'rule') {
                            getSelectors(d.node).forEach(function(sel) {
                                sel.length && (selectors[sel] = true);
                            })
                            rules_map.set(d.node, true);
                            if (cs_list.indexOf(d.pgStylesheet) < 0) {
                                cs_list.push(d.pgStylesheet);
                            }
                        }
                    })

                    var related = []

                    var forEachRule = function(node, func) {
                        if(node.type === 'rule') func(node);
                        if(node.nodes) {
                            node.nodes.forEach(function(n) {
                                forEachRule(n, func);
                            })
                        }
                    }

                    cs_list.forEach(function(cs) {
                        forEachRule(cs.getRootNode(), function(rule) {
                            getSelectors(rule).forEach(function(sel) {
                                if(sel.length && selectors[sel]) {
                                    if(!rules_map.has(rule)) {

                                        try {
                                            if (pgel_dom_node && !pgel_dom_node.matches(sel)) {
                                                return;
                                            }
                                        } catch(err) {}

                                        rule[flag_related] = true;
                                        rule.nodes.forEach(function(n) {
                                            n[flag_related] = true;
                                        })

                                        related.unshift({
                                            node: rule,
                                            pgStylesheet: cs
                                        });

                                        rules_map.set(rule, true);
                                    }
                                }
                            })
                        })
                    })
                    //d.rules = related;
                    //clearFlags(d.related);
                }

                list.push(d);

                clearFlags(d.rules);
                markOverriden(d.rules)

                if(related) {
                    d.rules = d.rules.concat(related);
                }

                an.inherited.forEach(function(info) {

                    markOverriden(info.data.nodes_to_show)
                    var rules = markAndFilterInherited(info.data.nodes_to_show)

                    if(rules.length) {
                        list.push({
                            pgel: info.pgel,
                            rules: rules
                        })
                    }

                })

                var computed = {}
                for(var i = list.length - 1; i >= 0; i--) {
                    list[i].rules.forEach(function(rule) {
                        if(rule.node.nodes) {
                            rule.node.nodes.forEach(function(node) {
                                if(node.prop) {
                                    if(computed[node.prop]) {
                                        if(computed[node.prop].important && !node.important) {
                                            //
                                        } else {
                                            computed[node.prop] = node;
                                        }
                                    } else {
                                        computed[node.prop] = node;
                                    }
                                }
                            })
                        }
                    })
                }
            }
            done(list);
            console.log('Computed', computed)
        })

        return;


        var list = []
        var cel = pgel;
        while(cel && cel.parent) {

            var an = data.ar.getActiveNodes();

            var data = {
                pgel: cel,
                is_done: false,
                rules: null
            }
            list.push(data);

            (function(data) {
                data.ar = new PgActiveRules(cel);
                data.ar.updateMatchedRules(true, function (rules) {
                    data.is_done = true;
                    data.rules = rules;

                    var all_done = true;
                    for(var i = 0; i < list.length; i++) {
                        if(!list[i].is_done) {
                            all_done = false;
                            break;
                        }
                    }

                    if(all_done) {
                        p.show('Got all ' + list.length)
                        done(list);
                    }
                })
            })(data)

            break;

            cel = cel.parent;
        }
    }

    this.show = function(cs, done) {
        shownCs = cs;
        if(isActive()) {
            showTreeForActive(done)
        } else {
            showTreeForStylesheet(done)
        }
    }

    this.refresh = function () {
        this.show(shownCs)
    }

    this.refreshWithoutGettingActive = function(done) {
        if(isActive()) {
            showTreeForActive(done, true)
        } else {
            this.show(shownCs)
        }
    }

    this.refreshDisplayOnly = function() {
        tableGrid.refresh();
    }

    var onElementSelected = function() {
        if(isActive()) {
            showTreeForActive();
        }
    }

    var current_active_list = null;

    var showTreeForActive = function(done, use_current_list) {

        view.whenVisible(function() {
            dimension = tableGrid.$element.get(0).getBoundingClientRect();
            var pgel = pinegrow.selectedElements.getLastSelected();
            currentPage = pinegrow.getSelectedPage();

            if (pgel) {
                var p = new CrsaProfile(true, 'Show active rules');

                var selected_rule_info = pinegrow.getSelectedRule();
                var selected_rule;
                if(selected_rule_info) {
                    selected_rule = selected_rule_info;
                }

                var withList = function (list) {
                    current_active_list = list;
                    ignore_resize_event = true;
                    //without this the flag is stuck
                    setTimeout(function() {
                        ignore_resize_event = false;
                    }, 200)

                    var shown_nodes = [];

                    p.show('Got from devtools')

                    //activeControls.update(pgel);

                    var top = {
                        rootNode: {
                            type: 'root',
                            pgStylesheet: {
                                name: 'Active'
                            },
                            nodes: []
                        }
                    }

                    list.forEach(function (data) {

                        var cs = {
                            rootNode: {
                                type: 'inherited_pgel',
                                name: data.pgel.getName(),
                                pgid: data.pgel.getId(),
                                pgel: data.pgel,
                                nodes: []
                            }
                        }

                        var current_cs = null;
                        var nodes = [];

                        data.rules.forEach(function (rule_info) {

                            if(rule_info.node.inline) {
                                cs.rootNode.nodes.push(rule_info.node);
                                if(false && selected_rule && selected_rule.selector === 'Style attribute' && rule_info.node.inline === 'source' && rule_info.node.inline_for_pgel === pgel) {
                                    rule_info.node.pg_selected = true;
                                }
                            } else {
                                if (current_cs !== rule_info.pgStylesheet) {
                                    if (nodes.length) {
                                        cs.rootNode.nodes.push({
                                            type: 'stylesheet',
                                            pgStylesheet: current_cs,
                                            nodes: nodes
                                        });
                                    }
                                    nodes = [];
                                    current_cs = rule_info.pgStylesheet;
                                }
                                nodes.push(rule_info.node);
                            }
                            if(pgel === data.pgel) {
                                shown_nodes.push(rule_info.node);
                            }
                        })

                        if (nodes.length) {
                            cs.rootNode.nodes.push({
                                type: 'stylesheet',
                                pgStylesheet: current_cs,
                                nodes: nodes
                            });
                        }
                        if(pgel === data.pgel) {
                            //add rules for the sel element to the top level
                            top.rootNode.nodes = top.rootNode.nodes.concat(cs.rootNode.nodes);
                        } else {
                            top.rootNode.nodes.push(cs.rootNode);
                        }
                    });

                    //console.log("TOP", top)

                    activeControls.setShowActive(shownCs, pgel);

                    pinegrow.autoSelectRule(pgel, shown_nodes, false);

                    cs_tree = new PgStylesheetTree(top);
                    cs_tree.showRoot = false;
                    cs_tree.showRuleParents = true;
                    cs_tree.flag_expanded = flag_expanded;
                    cs_tree.flag_related = flag_related;
                    cs_tree.create();
                    showTree(cs_tree);

                    p.show('Tree shown')

                    done && done();
                }

                if(use_current_list && current_active_list) {
                    withList(current_active_list)
                } else {
                    getMatchedForPgelStack(pgel, withList)
                }
            }
        })
    }

    var onPageLoaded = function(page) {

    }

    var onPageFrameworksChanged = function(page) {

    }

    var onElementIsolated = function(page, pgel) {

    }

    var onPageSelected = function(page) {

    }

    var onDragDropDone = function(page, drag_menu) {
        return;

        if(tableGrid) {
            tableGrid.dragStopped();
        }
    }

    var noop = function() {}

    var currentMenuData = null;

    var hoveredCell = null;

    var mouseSpeed = new PgMouseSpeed();

    var quickInsertPosition = null;
    var quickInsertPositionTimer = null;

    var onMouseMoved = function(event) {
        //var pos = _this.isOverTree(event);
        dimension = tableGrid.$element.get(0).getBoundingClientRect();
        var pos = {left: event.pageX - dimension.left, top: event.pageY - dimension.top - 0};

        //console.log(pos)

        mouseSpeed.track(event);

        if(currentMenuData && menu.isHidden()) menu.show();


        //tableGrid.quickInsertLine.show(null);

        if(quickInsertPositionTimer) {
            clearTimeout(quickInsertPositionTimer);
            quickInsertPositionTimer = null;
        }

        if(pos && currentPage) {
            var grid = tableGrid;

            var so = grid.getScrollOffset();
            pos.top += so.top;
            pos.left += so.left;

            var edge_y = 3;
            var edge_x = 5;

            var idx = grid.getVisibleDataIndexForY(pos.top, true);

            if(idx >= 0) {
                var idx_y = grid.getYForVisibleDataIndex(idx);
                var next_idx = idx;
                while(next_idx < grid.visibleData.length) {
                    var y = grid.getYForVisibleDataIndex(next_idx);
                    if(y > idx_y) break;

                    var node = grid.visibleData[next_idx].node;
                    if(node.type !== 'rule' && node.type !== 'decl' && node.type !== 'add_prop' && !(node.type === 'comment' && node.parent.type === 'rule')) {
                        break;
                    }

                    var x = grid.getXForVisibleData(grid.visibleData[next_idx]);
                    var w = grid.getCellWidthForData(grid.visibleData[next_idx]);
                    var next_x = 0;
                    //console.log(`${next_idx} x ${x}, pos.left ${pos.left}, pos.top ${pos.top}, w ${w}`)

                    var is_last_in_line = true;
                    var x_boundary = x + w + 9999;

                    if(w !== 0 && grid.visibleData.length > next_idx + 1 && grid.getYForVisibleDataIndex(next_idx + 1) === y) {
                        is_last_in_line = false;
                        next_x = grid.getXForVisibleData(grid.visibleData[next_idx + 1]);
                        x_boundary = next_x;
                    }

                    if(x <= pos.left && pos.left <= x_boundary) {
                        var on_edge = false;
                        //console.log(grid.visibleData[next_idx])
                        var line_pos = 'bottom';
                        if(!is_last_in_line) {
                            //has next in the same line
                            line_pos = 'right';

                            if(x + w - edge_x <= pos.left || pos.left >= x + w) {
                                on_edge = true;
                            }


                        } else {

                            var cell_h = grid.getCellHeightForData(grid.visibleData[next_idx]);
                            if(y + cell_h - edge_y <= pos.top || (w !== 0 && pos.left > x + w - edge_x)) {
                                on_edge = true;
                            }


                        }
                        if(on_edge) {
                            grid.quickInsertLine.show(grid.visibleData[next_idx], grid.visibleData[next_idx].level, line_pos);

                            if(!quickInsertPosition) {
                                tableGrid.$container.addClass('with-insert-position')
                            }
                            quickInsertPosition = {
                                data: grid.visibleData[next_idx],
                                pos: line_pos
                            }
                            return;
                        } else {
                            //grid.quickInsertLine.show(null)
                        }
                        break;
                    }
                    next_idx++;
                }
            }
            if(quickInsertPosition) {
                tableGrid.$container.removeClass('with-insert-position')
            }
            quickInsertPosition = null;
            grid.quickInsertLine.show(null)
            return;
        }
    }

    var setClassesForMenu = function(data) {
        var all = 'for-selected for-hidden for-collapsed for-search';

        var c = '';

        if(data.selected) c += ' for-selected';
        if(data.hidden) c += ' for-hidden';
        if(data.collapsed) c += ' for-collapsed';
        if((data.search || 0) === 1) c += ' for-search';

        menu.$menu.removeClass(all).addClass(c);
    }

    var onMouseOut = function(event) {
        tableGrid.highlightLevel(-1);
        tableGrid.quickInsertLine.hide();
        if(quickInsertPositionTimer) {
            clearTimeout(quickInsertPositionTimer);
            quickInsertPositionTimer = null;
        }
        menu.hide();
        if (hoveredCell) {
            hoveredCell.$element.removeClass('hovered');
        }
        hoveredCell = null;
    }

    var onMouseIn = function(event) {
        if(currentMenuData) menu.show();
    }

    tableGrid.$element.on('mousemove', onMouseMoved);
    tableGrid.$element.on('mouseleave', onMouseOut);
    tableGrid.$element.on('mouseenter', onMouseIn);

    pinegrow.addEventHandler('on_css_loaded', onCSSLoaded);
    pinegrow.addEventHandler('on_selected_elements_changed', onElementSelected);
    //pinegrow.addEventHandler('on_page_stylesheets_loaded', onPageStylesheetsLoaded);

    pinegrow.addEventHandler('on_page_changed', onPageChanged);
    pinegrow.addEventHandler('on_page_loaded', onPageLoaded);
    pinegrow.addEventHandler('on_page_refreshed', onPageLoaded);
    pinegrow.addEventHandler('on_page_selected', onPageSelected);
    pinegrow.addEventHandler('on_drag_drop_operation_done', onDragDropDone);
    pinegrow.addEventHandler('on_element_isolated', onElementIsolated);
    pinegrow.addEventHandler('on_page_view_resized', onElementSelected);

    pinegrow.addEventHandler('on_page_frameworks_changed', onPageFrameworksChanged);

    var updateMenuPosition = function() {
        if(currentMenuData) {
            var so = tableGrid.getScrollOffset();
            var top = tableGrid.getYForVisibleDataIndex(currentMenuData.visible_idx) - so.top;

            menu.showFor(top, top + tableGrid.cellHeight, currentMenuData.selected || false, currentMenuData);
        }
    }

    this.onSelected = function(data) {

        currentMenuData = data;

        var pgel = this.getPgel(data);

        if(pgel) {
            var $item = menu.find('hide');
            $item.find('i').removeClass('icon-hide icon-see').addClass(pgel.isHidden() ? 'icon-see' : 'icon-hide');
        }
        updateMenuPosition();
    }

    this.onDeselected = function(data) {
        //if(currentMenuData === data) setClassesForMenu(data);
        if(!pinegrow.selectedElements.hasSelection()) {
            currentMenuData = null;
            menu.hide();
        }
    }
}







var PgStylesheetTree = function(cs) {

    var _this = this;

    var max_tree_level = 0;
    var li_id_count = 0;
    var currentTreeRoot;

    var filter_options = {
        styles: false,
        images: false
    }

    var has_filter_options = false;

    var treeData = [];
    var treeData_PgIdMap = {};
    var helper;

    this.flag_expanded = null;
    this.flag_related = null;

    this.setFilterOptions = function(opt) {
        var o = has_filter_options;
        has_filter_options = false;
        $.each(opt, function(key, val) {
            if(val) {
                has_filter_options = true;
                return true;
            }
        })
        filter_options = opt;
        research_on_show = o !== has_filter_options;
    }

    var treeView;

    this.setTreeView = function(tv) {
        treeView = tv;
    }

    var tableGrid = null;

    this.setTableGrid = function(tg) {
        tableGrid = tg;
        this.$element = tableGrid.$element;
        tg.setData(treeData);

        if(research_on_show) {
            this.research();
        }
    }

    var treeTop = $('<div/>').addClass('crsa-tree-branch pg-tree-ul');

    this.$element = null;

    this.highlightOnMouseOver = true;

    this.destroy = function() {
        nextFrame.cancelAll();
        tableGrid = null;
        treeView = null;
        if(helper) helper.destroy();
        helper = null;
        treeData = null;
        treeData_PgIdMap = null;
        _this = null;
    }

    this.getDataFor$Element = function($el) {
        return tableGrid.getDataFor$Element($el);
    }

    this.updatePgIdMap = function() {
        var p = new CrsaProfile();
        treeData_PgIdMap = {};
        treeData.forEach(function(data) {
            if(data.pgid) {
                treeData_PgIdMap[data.pgid] = data;
            }
        })
        p.show('updatePgIdMap');
    }

    var removeItemPgidMap = function(data) {
        if(data && data.pgid) delete treeData_PgIdMap[data.pgid];
    }

    var removeItemAndChildrenFromPgidMap = function(data) {
        helper.withDataAndChildren(data, removeItemPgidMap);
    }

    var getTreeDataItemForPgId = function(pgid) {
        return treeData_PgIdMap[pgid] || null;
    }

    this.getTreeDataItemForPgId = function(pgid) {
        return getTreeDataItemForPgId(pgid);
    }

    var getDataItemsForPgIdAndDescendants = function(pgid) {
        var data = getTreeDataItemForPgId(pgid);
        if(data) {
            var list = [data];
            var num = data.idx + helper.getNumberOfDescendants(data.idx, treeData);
            for(var i = data.idx + 1; i <= num; i++) {
                list.push(treeData[i]);
            }
            return list;
        }
        return null;
    }

    var createDataItemsForPgEl = function(pgel, level) {
        var list = [];
        createDataItemForPgEl(list, pgel, false, level);
        return list;
    }

    var refreshGrid = function() {
        nextFrame.do('refreshGrid', function() {
            _this.research();
            if(tableGrid) {
                tableGrid.refresh();

                if(treeView && !treeView.view.isVisible()) {
                    treeView.view.whenVisible(function() {
                        tableGrid.show();
                    })
                }
            }
        })
    }

    var previous_selector_was_invalid = false;

    const SEARCH_IN = 1;
    const SEARCH_OUT = 3;
    const SEARCH_HAS_CHILD = 2;

    var currentFilter = null;

    this.research = function(force) {
        var obj = {
            selected_ids: {},
            changed: false
        }

        if(currentFilter || obj.changed || has_filter_options || force) this.search(currentFilter, true, obj);
    }

    var research_on_show = false;

    this.search = function(filter, research, custom_obj) {
        if(!treeView) {
            research_on_show = true;
            return;
        }

        research_on_show = false;

        if(filter === null) filter = '';
        var re = (filter.length > 0) ? new RegExp(escapeRegExp(filter), 'i') : null;

        var force_sel = false;
        var new_filter = filter;

        //try searching for selector
        var selected_ids = {};

        currentFilter = filter;

        var obj;

        if(custom_obj) {
            obj = custom_obj;
        } else {
            var obj = {
                selected_ids: {},
                changed: false
            }
            //page.callFrameworkHandler('on_custom_tree_filter', obj);
        }

        var custom_ids = obj.selected_ids;
        var custom_filter = obj.changed;

        if(!filter && !custom_filter && !has_filter_options) {
            treeData.forEach(function(data) {
                data.search = 0;
                data.force_search = false;
                if(data.peek_in) {
                    data.collapsed = true;
                    data.peek_in = false;
                }
            })
            tableGrid.refresh();
            return;
        }

        if(!helper) return;

        treeData.forEach(function(data) {
            data.search = 0;
            if(data.peek_in) {
                data.collapsed = true;
                data.peek_in = false;
            }
        })

        helper.forEachWithParents(function(data, parents) {

            var inc = false;

            if(!re || data.search_string.match(re)) {
                inc = true;
            }

            if(has_filter_options) {
                var only_type = 'decl';

                if(filter_options.position) {
                    if(data.node.type === 'decl') {
                        inc = inc && (('_' + data.node.prop + '_').match(/_(top|right|bottom|left|position|z\-index)_/i) !== null);
                    } else {
                        inc = false;
                    }
                }
            }

            if(inc) {
                //selected_ids[data.pgid] = true;
                data.search = SEARCH_IN;

                for(var i = parents.length - 1; i >= 0; i--) {
                    if(parents[i].search === SEARCH_OUT) {
                        parents[i].search = SEARCH_HAS_CHILD;
                        if(parents[i].collapsed) {
                            parents[i].peek_in = true;
                            //data.peeked = true;
                        }
                        parents[i].collapsed = false;
                    } else {
                        break;
                    }
                    //parents[i].collapsed = false;
                }
            } else {
                if(false && data.force_search && research) {
                    for(var i = parents.length - 1; i >= 0; i--) {
                        if(parents[i].search === SEARCH_OUT) {
                            parents[i].search = SEARCH_HAS_CHILD;
                        } else {
                            break;
                        }
                        //parents[i].collapsed = false;
                    }
                } else {
                    data.search = SEARCH_OUT;
                }
            }
        })

        tableGrid.refresh();
    }

    var unpopulateDataItem = function(data) {
        if(data) {
            data.populated = false;
            data.def = null;
        }
    }

    var updateBranchForPgel = function(pgel, data) {
        if(data === undefined) {
            data = getTreeDataItemForPgId(pgel.getId())
        }
        var list = createDataItemsForPgEl(pgel);
        helper.replaceWith(data, list);
    }

    var updateSelectedItems = function() {
        pinegrow.selectedElements.forEachElement(function(pgel) {
            var data = getTreeDataItemForPgId(pgel.getId());
            if(data) data.selected = true;
        })
    }

    var forceDisplayInSearch = function(list_or_data, val) {
        if(Array.isArray(list_or_data)) {
            list_or_data.forEach(function(data) {
                data.force_search = val;
            })
        } else {
            list_or_data.force_search = val;
        }
    }

    this.scrollToSelected = null;

    this.handleEvent = function(event) {

    }

    var ignore_scripts = false;
    var force_parent = null;

    this.create = function() {

        treeData = [];
        treeData_PgIdMap = {};

        var $ul = treeTop;
        var only_kids = false;

        var current_max_tree_level = max_tree_level;

        max_tree_level = 0;

        var test = false;

        var treeRoot = cs.rootNode;

        console.log(treeRoot);

        force_parent = null;

        var profile = new CrsaProfile(true);

        var start_level = 0;

        if(this.showRoot) {
            createDataItemForCSSNode(treeData, treeRoot, only_kids);
        } else {
            for (var i = 0; i < treeRoot.nodes.length; i++) {
                createDataItemForCSSNode(treeData, treeRoot.nodes[i], false, 0);
            }
        }

        profile.show('create CSS ' + treeData.length + ' tree data items');

        helper = new PgTreeDataHelper(treeData);

        helper.reindexData();

        this.research();
    }

    //helper methods
    var getCSSValueHTML = new PgGetCSSValueHTML();

    this.populateDataItem = function(data, page) {
        if(data.populated) return;

        var node = data.node;

        switch(node.type) {
            case 'root':
                break;
            case 'decl':
                //already done on gen fatas in order to calculate sizes
                //data.value_html = getCSSValueHTML.getHTML(node.value);
                break;
            case 'rule':
                //var p = new CrsaProfile();
                if(node.inline) {
                    data.use_count = 1;
                } else {
                    try {
                        var sel = node.selector.replace(/::?(hover|focus|active|visited|after|before)/g, '');
                        data.use_count = page.getDocument().querySelectorAll(sel).length;
                    } catch (err) {
                        data.use_count = '';
                    }
                }
                //p.show('Get use count')
                break;
        }

        data.populated = true;
    }

    var parent_chain = []
    var last_for_level = {}
    var target_pgel = null;

    var createDataItemForCSSNode = this.createDataItemForCSSNode = function (treeData, node, only_kids, level, showing_parents) {
        if (!level) level = 0;

        var cls = 'sort';
        var no_sort = false;
        var type = null;

        var active = _this.showRuleParents;

        if(active && treeData.length === 0) {
            parent_chain = []
            target_pgel = null;
        }

        var fata = {node: node, shown: true, level: level, tags: '', search_string: ''};



        switch(node.type) {
            case 'root':
            case 'stylesheet':
                cls = 'no-sort';
                no_sort = true;
                type = 'stylesheet';
                fata.tags = 'tag-block';
                fata.search_string += node.pgStylesheet.name;
                break;
            case 'inherited_pgel':
                cls = 'no-sort';
                no_sort = true;
                type = 'inherited_pgel';
                target_pgel = node.pgel;
                //fata.tags = 'tag-block';
                fata.search_string += node.name;
                break;
            case 'decl':
                type = 'decl';
                fata.value_html = getCSSValueHTML.getHTML(node.value, fata, pinegrow.devTools.getCSSPropertyValuesRegEx(node.prop));

                fata.search_string += node.prop + ":" + node.value;
                break;
            case 'component':
                type = 'component';
                fata.value_html = getCSSValueHTML.getHTML(node.value, fata);
                //fata.search_string += node.prop + ":" + node.value;
                break;
            case 'rule':
                type = 'rule';
                fata.search_string += node.selector;
                break;
            case 'atrule':
                type = 'atrule';
                fata.search_string += '@' + node.name + ' ' + node.params;
                if(node.name === 'import' || node.name === 'media') {
                    fata.params_html = node.params;
                } else {
                    fata.params_html = getCSSValueHTML.getHTML(node.params, fata);
                }
                break;
            case 'comment':
                type = 'comment';
                fata.search_string += '/*' + node.text + '*/';
                break;
            case 'add_prop':
                type = 'add_prop';
                break;
        }

        var force_collapsed = false;
        var focused = false;

        if(force_parent) {
            if(node === force_parent) {
                cls = 'no-sort';
                no_sort = true;
                focused = true;
            } else if(isDescendantOf(force_parent)) {
                force_collapsed = true;
            }
        }


        fata.classes = cls;
        fata.collapsed = isNodeCollapsed(node) || force_collapsed;
        fata.no_sort = no_sort;
        fata.focused = focused;
        fata.template_type = type;

        active && (fata.target_pgel = target_pgel);

        if(_this.showRuleParents && node.type === 'rule' && !showing_parents) {
            //in active panel, display any parent rules
            const parents = []
            let parent = node.parent;
            while(parent && parent.type !== 'root') {
                if(node[_this.flag_related]) {
                    parent[_this.flag_related] = true;
                } else {
                    parent[_this.flag_related] = false;
                }
                parents.unshift(parent);
                parent = parent.parent;
            }
            var parents_done = false;
            parents.forEach(function(parent) {
                if(last_for_level[level] === parent) {
                    parents_done = true;
                    level++;
                } else if(!parents_done) {
                    last_for_level[level] = parent;
                    createDataItemForCSSNode(treeData, parent, false, level++, true);
                }
            })
            fata.level = level;
            last_for_level[level] = node;
        }
        treeData.push(fata);

        /*
         if(pgid) {
         treeData_PgIdMap[pgid] = fata;
         }
         */
        //if(force_parent && pgel !== force_parent) return;
        if(!showing_parents) {
            if(false && node.type === 'decl' && node.prop === 'border-top') {
                //expanded nodes
                var test = [
                    {prop: 'border-top-color', value: 'red'},
                    {prop: 'border-top-style', value: 'solid'},
                    {prop: 'border-top-width', value: '10px'},
                ]

                test.forEach(function(t) {
                    createDataItemForCSSNode(treeData, {
                        type: 'component',
                        prop: t.prop,
                        value: t.value
                    }, false, level + 1);
                })

                node[_this.flag_expanded] = true;
            }

            if(node.type === 'inherited_pgel') {
                level--; //display children on the same level
            }

            var is_rule = node.type === 'rule';

            if (node.nodes) {
                for (var i = 0; i < node.nodes.length; i++) {
                    if(active && is_rule && (node.nodes[i].type !== 'decl' && node.nodes[i].type !== 'comment')) continue;
                    createDataItemForCSSNode(treeData, node.nodes[i], false, level + 1);
                }
                if(is_rule) {
                    //add prop
                    createDataItemForCSSNode(treeData, {
                        type: 'add_prop',
                        target_node: node
                    }, false, level + 1);
                }
            }

            if (_this.showRoot) {
                if (node.type === 'root' && node.pgStylesheet && node.pgStylesheet.importedFiles) {
                    node.pgStylesheet.importedFiles.forEach(function (cs) {
                        if (cs.rootNode) {
                            createDataItemForCSSNode(treeData, cs.rootNode, false, level + 1);
                        }
                    })
                }
            }
        }
    }


    var isDescendantOf = function(node, parent) {
        while(node) {
            if(node.parent === parent) return true;
            node = node.parent || null;
        }
        return false;
    }

    var isNodeCollapsed = function(node) {
        return false;
    }


    var isElementHidden = function(e) {
        return e.getAttribute('data-pg-hidden') == '';
    }

    var isPgElHidden = function(pgel) {
        return pgel.hasAttribute('data-pg-hidden');
    }

    var isCollapsed = function (e) {
        if (e.tagName == 'HEAD') return !page.show_head_in_tree;
        return e.getAttribute('data-pg-collapsed') === '';
    }

    var isPgElCollapsed = function (pgel) {
        if (pgel.tagName == 'head') return !page.show_head_in_tree;
        return pgel.hasAttribute('data-pg-collapsed');
    }

    var selectElement = function(pgid) {
        var $li = getTreeNodeForPgel(pgid);
        if($li) {
            $li.addClass('crsa-tree-node-selected');
            scrollToTreeNode($li);
        }
    }

    var deselectElement = function(pgid) {
        var $li = getTreeNodeForPgel(pgid);
        if($li) {
            $li.removeClass('crsa-tree-node-selected');
        }
    }

    var removeElement = function(pgid) {
        var $li = getTreeNodeForPgel(pgid);
        if($li) {
            $li.remove();
        }
    }

    var scrollToTreeNode = function($li) {
        var test = $li.get(0).getBoundingClientRect();
        var test2 = treeTop.get(0).getBoundingClientRect();

        var lip = {left: test.left - test2.left, top: test.top - test2.top};
        //var lip = $li.position();
        var $tree = treeTop.closest('.tree-container');

        var tree_h = $tree.height();
        var li_h = 20;//$li.height();
        var tree_st = $tree.scrollTop();

        if (lip.top >= 0 && lip.top < tree_h - li_h) {

        } else {
            var y = lip.top + tree_st - 100;
            if (y < 0) y = 0;
            $tree.stop().animate({scrollTop: y}, 150);
        }

    }
}

var PgCSSEditableText = function($container, selector) {

    var _this = this;

    this.onChange = null;
    this.onChangeDone = null;
    this.onGetOptions = null;
    this.onStart = null;
    this.onDone = null;
    this.onCanEdit = null;
    this.onListItemHighlighted = null;

    function autosize(el){
        return;
        setTimeout(function(){
            el.style.cssText = 'height:auto;';
            el.style.cssText = 'height:' + el.scrollHeight + 'px';
        },0);
    }

    $container.on('click', selector, function(e) {
        e.preventDefault();

        var $el = $(this);

        if($el.find('.pg-css-tree-edit-box').length > 0) return false;

        if(!_this.onCanEdit($el)) return false;

        var value = _this.onGetValue($el);

        $el.empty();

        //var $input = $('<input type="text" class="pg-css-tree-edit-box"/>').appendTo($el);



        var input = new PgInputField('size', {
            type: 'slider',
            name: 'dummy',
            slider_def_unit: 'px',
            slider_min: 0,
            without_text: true,
            //textarea: true,
            auto_resize: true,
            options: _this.onGetOptions ? _this.onGetOptions($el) : null,
            fill_list_on_open: true,
            open_list_on_focus: true,
            on_list_item_highlighted: function(item) {
                _this.onListItemHighlighted && _this.onListItemHighlighted(item, $el)
            }
        });

        input.$field.addClass('pg-css-tree-edit-box');
        var $input = input.$input;

        $el.addClass('in-edit');

        input.appendTo($el);
        input.setValue(value);

        autosize($input.get(0));

        //$input.val(value);
        $input.get(0).focus();
        $input.get(0).select();

        var done = function() {
            var value = $input.val();
            $el.empty();
            $el.removeClass('in-edit');
            $el.text(value);
            _this.onDone && _this.onDone($el);
            _this.onChange($el, true, value);
        }

        var cancel = function() {
            $el.empty();
            $el.text(value);
            $el.removeClass('in-edit');
            _this.onChange($el, true, value);
        }

        input.on('blur', function(e) {
            //done && done();
        })

        input.on('input', function(e) {
            var value = $input.val();
            _this.onChange($el, false, value);
            autosize($input.get(0));
        })

        input.on('change', function(e) {
            done && done();
            done = false;
        })

        input.on('keydown', function(e) {
            switch(e.key) {
                case 'Enter':
                    done();
                    break;
                case 'Escape':
                    cancel();
                    break;
            }
        })

        _this.onStart && _this.onStart($el, input);

        return false;
    })
}


var PgCSSEditableColor = function($container, selector) {

    var _this = this;

    this.onChange = null;
    this.onChangeDone = null;
    this.onCanEdit = null;

    $container.on('click', selector, function (e) {
        e.preventDefault();
        var $target = $(this);
        var $box = $target;

        var $color = $target.closest('color');
        var $span = $color.find('> span');

        if(!_this.onCanEdit($color)) return false;

        var $picker =  $('<input/>', { 'type' : 'hidden'}).appendTo($box);

        var noColor = 'rgba(0, 0, 0, 0)';

        var original_color;
        var ignore_change = false;

        var trigger_change_on_end = false;

        var setValue = function(color, is_done) {
            var c = colorToString(color);
            $span.text(c);
            $box.css('background-color', c);
            if(_this.onChange) _this.onChange($color, is_done);
        }

        original_color = $color.attr('data-color') || noColor;

        $picker.spectrum({
            showAlpha : true,
            clickoutFiresChange : true,
            showInitial : true,
            showInput : true,
            allowEmpty: true,
            preferredFormat: "hex",
            appendTo: $picker.closest('body'),
            // showPalette: true,
            palette: [
                //               []
            ],
            beforeShow : function(color) {
                //original_color = $color.attr('data-color') || noColor;
                return true;
            },
            move : function(color) {
               setValue(color);
            },
            show : function(color) {

            },
            change : function(color) {
                setValue(color, true);
            },
            hide : function(color) {
                /*
                var $input = $(this).siblings('.crsa-input').find('> input');
                if (original_color != $input.val()) {
                    ignore_change = true;
                    $input.val(original_color);
                    //$input.trigger('input');
                    $input.trigger('change');
                    ignore_change = false;
                } else {
                    if (trigger_change_on_end) {
                        ignore_change = true;
                        $input.trigger('change');
                        ignore_change = false;
                        trigger_change_on_end = false;
                    }
                }
                */
                $picker.remove();
            }
        });
        $picker.spectrum("set", original_color);

        var pgSpectrumHelper = new PgSpectrumHelper($picker, {
            'mouse-moved': function ($el) {
                var color = $el.spectrum('get');
                setValue(color);
            },
            'color-picked': function ($el) {
                var color = $el.spectrum('get');
                setValue(color);
                trigger_change_on_end = true;
            }
        });


        $picker.spectrum("show");
        return false;
    });
}

var PgCSSEditableListValue = function($container, selector) {

    this.onChange = null;
    this.onCanEdit = null;

    var _this = this;

    var getSlidingValInfo = function($num, list) {
        var val = $num.text();
        var idx = list.indexOf(val);

        return {
            val: idx >= 0 ? idx : 0
        }
    }

    var fdef = {};

    var def_unit = '';
    var def_step = 1;
    var def_min = 0;
    var def_max = 0;

    var step_f = 1;

    var mousePosY = null;

    $container.on('click', selector, function(event) {

        pgCloseContextMenus();

        var $num = $(this);
        var list = _this.onGetList($num);

        if(!_this.onCanEdit($num) || list.length === 0) return;

        _this.onStart && _this.onStart($num);

        var onSet = function() {
            $num.text(this.key)
            _this.onChange($num, this.key, true);
        }

        var onMouseEnter = function() {
            _this.onListItemHighlighted && _this.onListItemHighlighted($num, this.key);
        }

        var onMouseLeave = function() {
            _this.onListItemHighlighted && _this.onListItemHighlighted($num, null);
        }

        var a = list.map(function(val) {
            return {
                label: val,
                key: val,
                action: onSet,
                on_mouseenter: onMouseEnter,
                on_mouseleave: onMouseLeave
            }
        })

        var m = new CrsaContextMenu(a, $num);
        m.showForElement($num);

        m.onClosed = function() {
            _this.onDone && _this.onDone($num);
        }

        event.preventDefault()
        event.stopPropagation()
        return false;
    });

    $container.on('dblclick', selector, function(event) {

        var $num = $(this);
        $num.parent().trigger('click');
        return false;
    });


    $container.on('aaamousedown', selector, function(event) {

        var $num = $(this);
        var list = _this.onGetList($num);

        def_max = list.length - 1;

        var mouseDownTime = (new Date()).getTime();
        mousePosY = event.clientY;
        var info = getSlidingValInfo($num, list);

        var $numDragAndDrop = $num;

        if(!info) return;

        if(!_this.onCanEdit($num)) return;// false;

        var inputVal = info.val;
        var val = inputVal;
        var unit = def_unit;
        var newVal = val;

        if (isNaN(val)) {
            val = 0;
        }

        var $overflowDiv = $('<div style="position:fixed;width:100%;height:100%;top:0;left:0;opacity:0;cursor:row-resize;z-index:999;">').appendTo($numDragAndDrop.closest('body'));

        $overflowDiv.get(0).addEventListener('mousemove', function (event) {

            mouseDownTime = null;

            newVal = val +  ((mousePosY - event.clientY) / step_f) * def_step;

            if(newVal < def_min) {
                newVal = def_min;
            }
            if(newVal > def_max) {
                newVal = def_max;
            }
            $num.text(list[newVal])

            if(_this.onChange) {
                _this.onChange($num, list[newVal]);
            }
            return false;
        }, true);

        $overflowDiv.get(0).addEventListener('mouseup', function (event) {
            $overflowDiv.remove();

            if(mouseDownTime !== null && (new Date()).getTime() - mouseDownTime < 1000) {
                $num.parent().trigger('click');
            } else if(_this.onChange) {
                _this.onChange($num, list[newVal], true);
            }
            return false;
        }, true);

        return false;
    });
}


var PgCSSEditableValue = function($container, selector) {

    this.onChange = null;
    this.onCanEdit = null;

    var _this = this;

    var getSlidingValInfo = function($num) {
        var val = $num.text();

        return {
            val: val
        }
    }

    var fdef = {};

    var def_unit = ('slider_def_unit' in fdef) ? fdef.slider_def_unit : 'px';
    var def_step = ('slider_step' in fdef) ? fdef.slider_step : 1;
    var def_min = ('slider_min' in fdef) ? fdef.slider_min : -99999999;
    var def_max = ('slider_max' in fdef) ? fdef.slider_max : 99999999;

    var step_f = 1.0 / def_step;

    var mousePosY = null;

    $container.on('mousedown', selector, function(event) {

        pgCloseContextMenus()

        var mouseDownTime = (new Date()).getTime();
        mousePosY = event.clientY;

        var $num = $(this);
        var info = getSlidingValInfo($num);

        var $numDragAndDrop = $num;

        if(!info) return;

        if(!_this.onCanEdit($num)) return;// false;

        var inputVal = info.val || '0' + def_unit;
        var val = parseFloat(inputVal);
        var unit = def_unit;
        var newVal = val;

        var zero_unit = def_unit;

        if (isNaN(val)) {
            val = 0;
        }
        else {
            unit = inputVal.replace(val, '');
            if(unit.length === 0 && inputVal !== '0') {
                unit = def_unit;
                zero_unit = '';
            } else if(inputVal === '0') {
                zero_unit = unit;
                unit = def_unit;
            }
        }

        var $overflowDiv = $('<div style="position:fixed;width:100%;height:100%;top:0;left:0;opacity:0;cursor:row-resize;z-index:999;">').appendTo($numDragAndDrop.closest('body'));

        $overflowDiv.get(0).addEventListener('mousemove', function (event) {

            mouseDownTime = null;

            newVal = val +  ((mousePosY - event.clientY) / step_f) * def_step;

            if(def_step < 1) {
                newVal = Math.floor(newVal * step_f) / step_f;
            }
            if(newVal < def_min) {
                newVal = def_min;
            }
            if(newVal > def_max) {
                newVal = def_max;
            }
            if(newVal == Math.floor(newVal)) {
                //newVal = Math.floor(newVal);
            }
            var val_text = newVal + (newVal === 0 ? zero_unit : unit);
            $num.text(val_text)

            if(_this.onChange) {
                _this.onChange($num, val_text);
            }
            return false;
        }, true);

        $overflowDiv.get(0).addEventListener('mouseup', function (event) {
            $overflowDiv.remove();

            if(mouseDownTime !== null && (new Date()).getTime() - mouseDownTime < 1000) {
                $num.parent().trigger('click');
            } else if(_this.onChange) {
                var val_text = newVal + (newVal === 0 ? zero_unit : unit);
                _this.onChange($num, val_text, true);
            }
            return false;
        }, true);

        return false;
    });
}

var PgGetCSSValueHTML = function() {

    var colorNames = "AliceBlue|AntiqueWhite|Aqua|Aquamarine|Azure|Beige|Bisque|Black|BlanchedAlmond|Blue|BlueViolet|Brown|BurlyWood|CadetBlue|Chartreuse|Chocolate|Coral|CornflowerBlue|Cornsilk|Crimson|Cyan|DarkBlue|DarkCyan|DarkGoldenRod|DarkGray|DarkGreen|DarkGrey|DarkKhaki|DarkMagenta|DarkOliveGreen|DarkOrange|DarkOrchid|DarkRed|DarkSalmon|DarkSeaGreen|DarkSlateBlue|DarkSlateGray|DarkSlateGrey|DarkTurquoise|DarkViolet|DeepPink|DeepSkyBlue|DimGray|DimGrey|DodgerBlue|FireBrick|FloralWhite|ForestGreen|Fuchsia|Gainsboro|GhostWhite|Gold|Goldenrod|Gray|Green|GreenYellow|Grey|HoneyDew|HotPink|IndianRed|Indigo|Ivory|Khaki|Lavender|LavenderBlush|LawnGreen|LemonChiffon|LightBlue|LightCoral|LightCyan|LightGoldenRodYellow|LightGray|LightGreen|LightGrey|LightPink|LightSalmon|LightSeaGreen|LightSkyBlue|LightSlateGray|LightSlateGrey|LightSteelBlue|LightYellow|Lime|LimeGreen|Linen|Magenta|Maroon|MediumAquaMarine|MediumBlue|MediumOrchid|MediumPurple|MediumSeaGreen|MediumSlateBlue|MediumSpringGreen|MediumTurquoise|MediumVioletRed|MidnightBlue|MintCream|MistyRose|Moccasin|NavajoWhite|Navy|OldLace|Olive|OliveDrab|Orange|OrangeRed|Orchid|PaleGoldenRod|PaleGreen|PaleTurquoise|PaleVioletRed|PapayaWhip|PeachPuff|Peru|Pink|Plum|PowderBlue|Purple|Red|RosyBrown|RoyalBlue|SaddleBrown|Salmon|SandyBrown|SeaGreen|SeaShell|Sienna|Silver|SkyBlue|SlateBlue|SlateGray|SlateGrey|Snow|SpringGreen|SteelBlue|Tan|Teal|Thistle|Tomato|Turquoise|Violet|Wheat|White|WhiteSmoke|Yellow|YellowGreen";
    var colorNamesRe = new RegExp(colorNames, 'gi');

    var re = /([\-\+]*[0-9][0-9\.]+(|px|rem|em|%|pt|pc|in|cm|mm|Q|ex|ch|lh|rlh|vw|vh|vmin|vmax|vb|vi|svw|svh|lvh|lvw|dvw|dvh)?)|((^|[^\w\-\_\/])(AliceBlue|AntiqueWhite|Aqua|Aquamarine|Azure|Beige|Bisque|Black|BlanchedAlmond|Blue|BlueViolet|Brown|BurlyWood|CadetBlue|Chartreuse|Chocolate|Coral|CornflowerBlue|Cornsilk|Crimson|Cyan|DarkBlue|DarkCyan|DarkGoldenRod|DarkGray|DarkGreen|DarkGrey|DarkKhaki|DarkMagenta|DarkOliveGreen|DarkOrange|DarkOrchid|DarkRed|DarkSalmon|DarkSeaGreen|DarkSlateBlue|DarkSlateGray|DarkSlateGrey|DarkTurquoise|DarkViolet|DeepPink|DeepSkyBlue|DimGray|DimGrey|DodgerBlue|FireBrick|FloralWhite|ForestGreen|Fuchsia|Gainsboro|GhostWhite|Gold|Goldenrod|Gray|Green|GreenYellow|Grey|HoneyDew|HotPink|IndianRed|Indigo|Ivory|Khaki|Lavender|LavenderBlush|LawnGreen|LemonChiffon|LightBlue|LightCoral|LightCyan|LightGoldenRodYellow|LightGray|LightGreen|LightGrey|LightPink|LightSalmon|LightSeaGreen|LightSkyBlue|LightSlateGray|LightSlateGrey|LightSteelBlue|LightYellow|Lime|LimeGreen|Linen|Magenta|Maroon|MediumAquaMarine|MediumBlue|MediumOrchid|MediumPurple|MediumSeaGreen|MediumSlateBlue|MediumSpringGreen|MediumTurquoise|MediumVioletRed|MidnightBlue|MintCream|MistyRose|Moccasin|NavajoWhite|Navy|OldLace|Olive|OliveDrab|Orange|OrangeRed|Orchid|PaleGoldenRod|PaleGreen|PaleTurquoise|PaleVioletRed|PapayaWhip|PeachPuff|Peru|Pink|Plum|PowderBlue|Purple|Red|RosyBrown|RoyalBlue|SaddleBrown|Salmon|SandyBrown|SeaGreen|SeaShell|Sienna|Silver|SkyBlue|SlateBlue|SlateGray|SlateGrey|Snow|SpringGreen|SteelBlue|Tan|Teal|Thistle|Tomato|Turquoise|Violet|Wheat|White|WhiteSmoke|Yellow|YellowGreen|\#[0-9a-fA-F]*|rgb\(\d{1,3}\s*,\s*\d{1,3}\s*,\s*\d{1,3}\s*\)|rgba\(\d{1,3}\s*,\s*\d{1,3}\s*,\s*\d{1,3}\s*,\s*[0-1]?(?:\.[0-9]+)*\s*\)))/gi;

    this.getColor = function(str) {
        return str.replace(colorRe, function(color) {
            return `<color data-color="${color}"><colorbox style="background-color:${color};"></colorbox>${color}</color>`
        } )
    }

    this.getNumeric = function(str) {
        return str.replace(/[\-\+]*[0-9\.]+[a-z\%]*/gi, function(m) {
            return `<num>${m}</num>`;
        })
    }

    this.getHTML = function(str, info, list_regex) {
        let count_nums = 0;
        let count_colors = 0;
        var r = str.replace(re, function(m, num, a, /*b,*/ color) {
            if(num !== undefined && num.length) {
                count_nums++;
                return `<num>${m}</num>`;
            } else if(color !== undefined && color.length) {
                count_colors++;
                return /*b +*/ `<color data-color="${color}"><colorbox style="background-color:${color};"></colorbox><span>${color}</span></color>`;
            }
        })
        if(list_regex) {
            r = r.replace(list_regex, function(m, pre, val, suf) {
                return pre + '<numlist>' + val + '</numlist>';
            })
        }
        if(info) {
            info.html_val_count_nums = count_nums;
            info.html_val_count_colors = count_colors;
        }
        return r;
    }

}


var PgCSSCountHandler = function($el, elements) {

    var _this = this;

    var select = function(pgel) {
        pinegrow.selectElement(pgel);
        pgel.scrollTo();
        pinegrow.showQuickMessage(`Selected ${pgel.getName()}.`)
    }

    if(elements.length === 1) {
        var pgel = getElementPgNode($(elements[0]));
        if(pgel) {
            select(pgel)
        }
    } else if(elements.length > 1 ) {
        var menu = new CrsaContextMenu(null, $el);

        menu.add({
            type: 'header',
            label: 'Select element:'
        });

        var max = 10;

        for(var i = 0; i < elements.length; i++) {
            if(i === max) break;

            (function(el) {
                var pgel = getElementPgNode($(el));
                if(pgel) {
                    menu.add({
                        label: pgel.getName(),
                        action: function () {
                            select(pgel)
                        },
                        check: pinegrow.selectedElements.isSelectedElement(pgel)
                    })
                }
            })(elements[i])
        }

        if(elements.length > max) {
            menu.add({
                type: 'header',
                label: `${elements.length - max} more elements not shown`
            });
        }

        menu.showForElement($el, null, 8);
    }
}

var pgCSSTreeValueHTMLMaker = new PgGetCSSValueHTML();


class PgFastDOMStylePreviewForElement {

    constructor(el) {
        this.el = el;
        this.original = this.el.getAttribute('style');
    }

    setStyle(prop, value) {
        var _this = this;

        this.restore();
        value !== null && this.el.style.setProperty(prop, value.replace('!important', '').trim(), 'important');
    }

    restore() {
        this.el.setAttribute('style', this.original);
    }

    remember() {
        this.original = this.el.getAttribute('style');
    }
}

class PgFastDOMStylePreviewForPgel {
    constructor(pgel) {
        this.pgel = pgel;
        this.page = pgel.getPage();
        this.$elements = pgel.get$DOMElements();
        this.list = this.$elements.map(function($el) {
            return new PgFastDOMStylePreviewForElement($el.get(0))
        })
        this.destroyed = false;
        this.hidden_menus = false;
    }

    setStyle(prop, value) {
        var _this = this;
        if(this.destroyed) return;
        if(!this.hidden_menus) {
            pinegrow.selectedElements.temporaryHideMenus(true);
            this.hidden_menus = true;
        }

        this.list.forEach(function(i) {
            i.setStyle(prop, value);
        })
    }

    remember() {
        if(this.destroyed) return;

        this.list.forEach(function(i) {
            i.remember();
        })
    }

    restore() {
        if(this.destroyed) return;

        this.list.forEach(function(i) {
            i.restore();
        })

        if(this.hidden_menus) {
            pinegrow.selectedElements.restoreShowMenus(true);
            this.hidden_menus = false;
        }
    }

    destroy() {
        if(this.destroyed) return;
        this.restore();
        this.destroyed = true;
    }
}

