var PgStartScreenView = function() {

    var $element = $('<div class="pg-start-screen"><div class="left"></div><div class="right"></div></div>');

    var $right = $element.find('.right');

    var new_text = 'New project';

    var $opens_left = $('<ul class="icons">\
                <li class="menu-file-template remove-in-cm"><a href="#"><i class="icon icon-281"></i><b>' + new_text + '</b></a></li>\
                </ul><hr class="pgf_edit_html">');

    var right_html = '<ul class="icons">';

    var $opens_right = $(right_html + '</ul>').appendTo($right);

    var $info = $('<div class="info"><div class="info-inner pg-lessons-chapter"></div></div>').appendTo($right);

    if(pinegrow.getSetting('show-welcome-section', '1') !== '1') {
        pg$Hide($info);
        $element.addClass('no-info');
    }

    var $tabs = $(`<div class="pg-start-screen-tabs">
<!--<ul class="pg-start-screen-tabs-tabs">
   <li id="start-tab-create">${pgf.start_tab_create}</li> 
   <li id="start-tab-learn">${pgf.start_tab_learn}</li>
</ul>-->
<div class="pg-start-screen-tabs-content">
</div>
</div>`).appendTo($right);

    var $tabs_content = $tabs.find('.pg-start-screen-tabs-content');
    var $tab_learn = $tabs.find('#start-tab-learn');
    var $tab_create = $tabs.find('#start-tab-create');

    addTooltip($tab_learn, pgf.start_tab_learn_tooltip);
    addTooltip($tab_create, pgf.start_tab_create_tooltip);

    var $lessons = $(`<div class="lessons">
<div class="pg-start-screen-tab-content-header"><h2>Interactive tutorials</h2>
<button class="back-to-projects"><i class="icon icon-left"></i> Go back to your projects</button>
</div>
<ul></ul></div>`).appendTo($tabs_content);
    
    var $projects = $(`<div class="projects" style="min-height: 80vh;">
<div class="pg-start-screen-tab-content-header"><h2>${pgf.your_projects_label}</h2>
<button class="new-project"><i class="icon icon-plus"></i> New project</button>
<button class="open"><i class="icon icon-project"></i> Open...</button>
<button class="tutorials">Interactive tutorials <i class="icon icon-right"></i></button>
</div>
<div class="pg-lessons-chapter" style="margin-top: 40px;"><ul class="my-projects"></ul><ul class="public-projects"></ul></div>`).appendTo($tabs_content);

    addTooltip($projects.find('button.new-project'), 'Create a new project or a page.')
        .on('click', function(e) {
            if(isApp()) {
                pinegrow.newProjectFromTemplate();
            } else {
                if (pinegrow.backend.canCreateProject()) {
                    pinegrow.tutorialsManager.selectNewProjectTemplate()
                }
            }
        })

    if(isApp()) {
        addTooltip($projects.find('button.open'), 'Open a project folder, a single HTML document or a remote URL.')
            .on('click', function (e) {
                var $li = $(this);

                var actions = [
                    {
                        type: 'header',
                        label: 'Open'
                    }
                ]

                actions.push({
                    label: 'Project...',
                    helptext: 'Select and open a folder that contains the project.',
                    action: function () {
                        pinegrow.openProjectBySelectingFolder();
                    }
                })

                actions.push({
                    label: 'File...',
                    helptext: 'Select and open a HTML file, without opening its folder as a project.',
                    action: function () {
                        pinegrow.selectAndOpenFile();
                    }
                })

                actions.push({
                    label: 'URL...',
                    helptext: 'Open a remote URL.',
                    action: function () {
                        pinegrow.showOpenUrlDialogAndOpenPage();
                    }
                })

                var m = new CrsaContextMenu(actions, $li);
                m.showAt(e.pageX, e.pageY);
                return false;
            });
    } else {
        $projects.find('button.open').remove();
    }

    addTooltip($projects.find('button.tutorials'), 'Learn about Pinegrow and web development with fun interactive tutorials.')
        .on('click', function(e) {
            e.preventDefault();
            activateTab('learn');
        })

    addTooltip($lessons.find('button.back-to-projects'), 'Go back to editing and creating your projects.')
        .on('click', function(e) {
            e.preventDefault();
            activateTab('create');
        })



    var $settings = $('<a href="#" class="pg-start-screen-settings"><i class="icon icon-tools"></i></a>').appendTo($element);

    $settings.on('click', function(e) {
        var actions = [
            {
                label: 'Show "Welcome to Pinegrow" section',
                check: pinegrow.getSetting('show-welcome-section', '1') === '1',
                action: function() {
                    var val = pinegrow.getSetting('show-welcome-section', '1') === '1';
                    val = !val;
                    val ? pg$Show($info) : pg$Hide($info);
                    pinegrow.setSetting('show-welcome-section', val ? '1' : '0');

                    val ? $element.removeClass('no-info') : $element.addClass('no-info');
                }
            }
        ]

        if(isApp()) {
            actions.push({
                type: 'divider'
            });
            actions.push({
                label: 'Clear the recent list',
                action: function () {
                    pinegrow.recentFiles.removeAll();
                }
            });
            actions.push({
                label: 'Show thumbnails',
                check: function () {
                    return pinegrow.thumbnailMaker.enabled;
                },
                action: function () {
                    pinegrow.thumbnailMaker.setEnabled(!pinegrow.thumbnailMaker.enabled);
                    pinegrow.showMode('Show and save thumbnails', pinegrow.thumbnailMaker.enabled);
                    pinegrow.recentFiles.update();
                }
            });
        }

        var menu = new CrsaContextMenu(actions, $(this));
        menu.showForElement($(this), $('#pg-start-screen-container'));
        return false;
    })
    addTooltip($settings, 'Start screen settings');

    var activateTab = function(tab, just_show) {
        var $hide, $show, $active_tab, $inactive_tab;

        if(tab === 'learn') {
            $hide = $projects;
            $show = $lessons;
            $active_tab = $tab_learn;
            $inactive_tab = $tab_create;
        } else {
            $show = $projects;
            $hide = $lessons;
            $inactive_tab = $tab_learn;
            $active_tab = $tab_create;
        }

        pg$Show($show);
        pg$Hide($hide);
        $inactive_tab.removeClass('active');
        $active_tab.addClass('active');

        !just_show && pinegrow.setSetting('online-start-screen-active-tab', tab);
    }

    activateTab(pinegrow.getSetting('online-start-screen-active-tab', 'create'), true);

    $tab_learn.on('click', function(e) {
        e.preventDefault();
        activateTab('learn');
    })

    $tab_create.on('click', function(e) {
        e.preventDefault();
        activateTab('create');
    })

    if(pgf.kids) {
        var $footer = $(`<footer>HTML Planet for Kids &copy; <a href="https://pinegrow.com" target="_blank">Pinegrow Pte. Ltd.</a> - <a href="https://htmlplanetforkids.com/privacy-policy.html" target="_blank">Privacy policy</a> - <a href="https://htmlplanetforkids.com/terms-of-use.html" target="_blank">Terms of use</a></footer>`).appendTo($element);
    } else {
        var $footer = $(`<footer>${pgf.product_name} ${crsaGetVersionName()} &copy; <a href="https://pinegrow.com" target="_blank">Pinegrow Pte. Ltd.</a></footer>`).appendTo($element);
    }



    updateProductInfoIn$Element($element);

    var view = this.view = new PgUIView($element);

    view.onResize = function() {
    }

    view.onDestroy = function() {
    }



}

var PgStartScreenManager = function() {
    var view = new PgStartScreenView();

    var $full = $('<div id="pg-start-screen-container"></div>').appendTo($('body'));

    var $version_info = $('<div class="version-info"></div>').hide();

    var is_full = false;
    var scroll_top = 0;

    var light_theme = pgf.product === 'WPPLUGIN';

    var $body = $('body');

    var showFull = function() {
        if(!is_full) {
            if(light_theme) {
                pinegrow.setWorkspaceTheme('light', true);
            }
            pinegrow.recentFiles.populate();//update

            is_full = true;
            $full.show();

            $version_info.appendTo($full);

            $full.append(view.view.get$Element());

            //$full.append($footer);

            view.view.get$Element().scrollTop(scroll_top);
            pgQuickWindowManager.closeAll();

            $('.menu-open-library,.menu-current-project,.menu-project-menu').hide();
            $('.navbar-brand .logo-name').show();

            pinegrow.buttonToolbarTopCenter && pinegrow.buttonToolbarTopCenter.hide();

            $body.addClass('on-start-screen');

            if(!isApp()) {
                if(new Date('2022-12-15').getTime() < Date.now()) {
                    setTimeout(function () {
                        pinegrow.showAlert(`<p>Thank you for testing the Pinegrow beta version!</p><p>This version of the public beta has expired. Please update the plugin to the latest version, if the beta program is still active. Otherwise, update to the latest release version.</p>`, 'Expired beta version');

                        pgwpdata.ajaxnonce = 'banana';
                    }, 2000);
                }
            }
        }
    }

    var hideFull = function() {
        if(is_full) {
            scroll_top = view.view.get$Element().scrollTop();

            $full.hide();
            is_full = false;
            if(pinegrow.buttonToolbarTopCenter) {
                pinegrow.buttonToolbarTopCenter.show();
                pinegrow.buttonToolbarTopCenter.customReposition();
            }

            $('.menu-open-library,.menu-current-project,.menu-project-menu').show();
            $('.navbar-brand .logo-name').hide();

            if(light_theme) {
                pinegrow.setWorkspaceTheme(pinegrow.getSetting('workspace-theme', 'light'), true);
            }
            $body.removeClass('on-start-screen');
        }
    }

    showFull();

    if(window.parent) {
        window.parent.postMessage({
            action: 'pgAppLoaded'
        }, '*');
    }

    var onFileProjectLoaded = function() {
        hideFull();

        window.parent && window.parent.postMessage({
            action: 'pgProjectOpen'
        }, '*');
    }

    var onFileProjectClosed = function() {
        if(pinegrow.getCurrentProject() == null && pinegrow.getAllPages().length == 0) {
            showFull();
            window.parent && window.parent.postMessage({
                action: 'pgProjectClosed'
            }, '*');
        }
    }

    this.isVisible = function() {
        return is_full;
    }

    pinegrow.addEventHandler('on_page_view_started_loading', onFileProjectLoaded);
    pinegrow.addEventHandler('on_project_loaded', onFileProjectLoaded);

    pinegrow.addEventHandler('on_project_closed', onFileProjectClosed);
    pinegrow.addEventHandler('on_page_closed', onFileProjectClosed);

    $('body').on('crsa-recent-files-item-clicked', hideFull);
}