var PgStatusBarView = function() {

    var $element = $('<div class="status-bar"><ul class="status-bar-crumbs"></ul></div>').appendTo($('body'));

    var $desc = $element.find('>.status-bar-crumbs');

    var view;

    this.$element = $element;
    this.hide_on_empty = false;

    var open = true;

    view = new PgUIView($element);

    this.view = view;
    view.alwaysVisible = true;

    var _this = this;

    var current_pgel;

    var shown_nodes = [];
    var shown_pgids = [];

    view.onAddedToLayout = function(c) {

        c.layoutManager.on('stateChanged', function(){
            var $item = $element.closest('.lm_item');
            var $prev = $item.prevAll('.lm_item:visible');
            if($prev.length) {
                $prev = $($prev.get(0));
            }
            //if($prev.hasClass('pg-fullsize-item')) {
              //  $element.removeClass('not-after-pages')
            //} else {
                $element.addClass('not-after-pages')
            //}
        });
    }

    var resized = function() {
        return;

        var w = $element.width();
        $element.find('>.status-bar-crumbs > li').css('max-width', Math.floor(w / (shown_nodes.length || 1) - 0) + 'px');
    }

    var pos_right = 0;
    var pos_left = 0;

    this.onResize = function(left, right) {
        pos_right = right;
        pos_left = left;

        if(open) {
            $element.css({
                left: left + 'px',
                right: right + 'px'
            })
        } else {
            $element.css({
                right: right + 'px',
                left: 'auto'
            })
        }

        resized();
    }

    this.setOpen = function(o) {
        open = o;

        if(open) {
            $element.removeClass('closed');
            $open.removeClass('icon-plus').addClass('icon-minus');
        } else {
            $element.addClass('closed');
            $open.removeClass('icon-minus').addClass('icon-plus');
        }
        this.onResize(pos_left, pos_right);
    }

    /*
    var $open = $element.find('i');

    $open.on('click', function(e) {
        e.preventDefault();
        _this.setOpen(!open);
    })
*/
    var in_resize = false;

    var triggerResize = function() {
        if(!in_resize) {
            in_resize = true;
            $(window).trigger('resize');
            in_resize = false;
        }
    }

    var setEmptyMsg = function() {
        $desc.html('<li class="empty-desc">Click to select element. Use ' + pgShowKbd('CMD') + ' or ' + pgShowKbd('SHIFT') + ' to select multiple. ' + pgShowKbd('ESC') + ' to unselect elements.</li>');
    }

    setEmptyMsg();

    var updateCrumbs = function(pgel) {

        current_pgel = pgel;
        var page = pinegrow.getSelectedPage();

        var $el = pgel ? pgel.get$DOMElement() : null;

        var idx = -1;
        if($el && !isAnyElementDeleted() && (idx = isNodeOnTheList($el.get(0))) >= 0) {
            var $lis = $desc.find('li.item');
            $lis.each(function(i, e) {
                var $e = $(e);
                if(i != idx) {
                    $e.removeClass('selected');
                    if(i < idx) {
                        $e.removeClass('child-of-selected');
                    } else if(i > idx) {
                        $e.addClass('child-of-selected');
                    }
                } else {
                    $e.addClass('selected');
                    $e.removeClass('child-of-selected');
                }
            })
            $($lis.get(idx)).addClass('selected');
            return;
        }

        $desc.get(0).innerHTML = '';

        shown_nodes = [];
        shown_pgids = [];

        if(!pgel) {
            $desc.get(0).innerHTML = ''
            if(_this.hide_on_empty) $element.hide();
            setEmptyMsg();
            //triggerResize();
            return;
        }

        //$('<li/>').html(getObjectName(obj, def, true, true, false, true)).appendTo($desc);

        var i = 0;

        var html = '';

        if($el && $el.get(0).nodeType !== 9) {
            var $pel = $el;
            while($pel.length > 0 && $pel.get(0).nodeType !== 9) {
                //var $li = $('<li/>', {class: 'item parent'}).html().prependTo($desc);
                //$li.data('pg-id', $pel.attr('data-pg-id')).data('pg-idx', i);

                var pgel = getElementPgNode($pel);
                var pgid = 0;
                var name;

                if(pgel) {
                    pgid = pgel.getId();
                    name = pgel.getName({
                        short:true,
                        action_tag: page.getActionTag(pgel, false, true)
                    });
                    shown_pgids.unshift(pgid);
                } else {
                    name = pgGetDOMElementName($pel.get(0), true, true);
                }

                var li = '<li class="item parent' + (i == 0 ? ' selected' : '') + '" data-pg-id="' + pgid + '" data-pg-idx="' + i + '"><name>' + name + '</name></li>';

                if(i > 0) {
                    li += '<li class="divider"><i class="icon icon-right"></i>';
                }

                html = li + html;

                i++;

                shown_nodes.unshift($pel.get(0));

                $pel = $pel.parent();
            }
        }

        $desc.get(0).innerHTML = html;
/*
        if(!$element.is(':visible') && !in_resize) {
            if(_this.hide_on_empty) $element.show();
            //triggerResize();
        }
        resized();*/
    }

    var updateItem = function(pgel) {
        var $name = $desc.find('li[data-pg-id="' + pgel.getId() + '"] name');
        $name.html(pgel.getName({short: true}));
    }

    $desc
        .on('click', 'li.item', function(e) {
            e.preventDefault();
            var $li = $(this);
            var pgid = $li.data('pg-id');
            var pgel = getPgNodeByPgId(pgid);
            if(pgel) {
                //var $el = pgel.get$DOMElement();
                //if($el) {
                pinegrow.selectElement(pgel);
                pgel.scrollTo();
                //}
            }
        })
        .on('mouseover', 'li.item', function(e) {
            var $el = get$Element($(this));
            pinegrow.highlightElement($el);
        })
        .on('mouseout', 'li.item', function(e) {
            pinegrow.highlightElement(null);
        })
        .on('contextmenu', 'li.item', function(e) {
            if(!pgf.kids) {
                pinegrow.showContextMenuForElement(getPgElement($(this)), e);
            }
            return false;
        })

    this.showIfNeeded = function() {
        if(shown_nodes.length && _this.hide_on_empty) $element.show();
    }

    this.getHeight = function() {
        return $element.is(':visible') ? 0 : 0;
    }

    var get$Element = function($li) {
        var idx = shown_nodes.length - 1 - ($li.data('pg-idx') || 0);
        if(shown_nodes.length > idx) {
            var $node = pgGetActive$DOMElement($(shown_nodes[idx]), function() {
                //was invalid but got new one
                updateCrumbs(current_pgel);
            });
            if(!$node) updateCrumbs(current_pgel);
            return $node;
        } else {
            return null;
        }
    }

    var getPgElement = function($li) {
        var $el = get$Element($li);
        return $el ? getElementPgNode($el) : null;
    }

    var isNodeOnTheList = function(node) {
        return shown_nodes.indexOf(node);
    }

    var isAnyElementDeleted = function() {
        for(var i = 0; i < shown_nodes.length; i++) {
            if(!shown_nodes[i].parentNode) return true;
        }
        return false;
    }

    pinegrow.addEventHandler('on_selected_elements_changed', function() {
        view.whenVisible(function () {
            updateCrumbs(pinegrow.selectedElements.getLastSelected());
        })
    })
    /*
    //will be auto-offed on destroy
    view.on('crsa-element-selected', function (event, pgel) {
        view.whenVisible(function () {
            updateCrumbs(pgel);
        })
    })*/
    view.on('crsa-page-selected', function (event, page) {
        view.whenVisible(function () {
            updateCrumbs(null);
            if(_this.hide_on_empty) $element.hide();
        })
    })

    var onChangesDone = function(page, info, col) {
        var update = false;
        if(col) {
            col.forEachElement(function(pgel) {
                if(shown_pgids.indexOf(pgel.getId()) >= 0) {
                    updateItem(pgel);
                }
            })
        }
    }

    pinegrow.addEventHandler('on_page_changes_done', onChangesDone);

    view.onDestroy = function() {
        pinegrow.removeEventHandler('on_page_changes_done', onChangesDone);
    }
}