/**
 * Created by Matjaz on 2/3/14.
 */



$(function() {



    $('body').on('pinegrow-ready', function(e, pinegrow) {

        var cssPropsRe = function(s) {
            return pinegrow.devTools.getCSSPropsInfoSection(s).re;
        }

        // var marginPaddingBtnActive = false;
        var marginPaddingBtnActive = {
            margin: false,
            padding: false
        }
        var positionBtnActive = false;
        var raduisBtnActive = false;
        var borderBtnActive = false;

        var bShadowImportant = false,
            tShadowImportant = false,
            transformImportant = false,
            transitionImportant = false;

        var backgroundField = {};

        var bm = new PgToggleButtonMaker();
        var boxShadowRotation = [],
            textShadowRotation = [],
            transformObjArr = [],
            transitionObjArr = [];
        var marginPaddingObjs = {
            'margin-top': null,
            'margin-bottom': null,
            'margin-left': null,
            'margin-right': null,

            'padding-top': null,
            'padding-bottom': null,
            'padding-left': null,
            'padding-right': null
        };

        var borderObjs = {
            'border-top': {},
            'border-bottom': {},
            'border-left': {},
            'border-right': {}
        };
        var borderRadiusObjs = {
            'border-top-left-radius': null,
            'border-top-right-radius': null,
            'border-bottom-left-radius': null,
            'border-bottom-right-radius': null
        };

        var transitionProperties = [
            { key: 'all', name: 'All' },
            { key: 'none', name: 'None' },
            { key: 'width', name: 'Width' },
            { key: 'height', name: 'Height' },
            { key: 'margin', name: 'Margin' },
            { key: 'margin-top', name: 'Margin top' },
            { key: 'margin-left', name: 'Margin left' },
            { key: 'margin-right', name: 'Margin right' },
            { key: 'margin-bottom', name: 'Margin bottom' },
            { key: 'padding', name: 'Padding' },
            { key: 'padding-top', name: 'Padding top' },
            { key: 'padding-left', name: 'Padding left' },
            { key: 'padding-right', name: 'Padding right' },
            { key: 'padding-bottom', name: 'Padding bottom' },
            { key: 'top', name: 'Top' },
            { key: 'left', name: 'Left' },
            { key: 'right', name: 'Right' },
            { key: 'bottom', name: 'Bottom' },
            { key: 'z-index', name: 'Z-Index' },
            { key: 'opacity', name: 'Opacity' },
            { key: 'border', name: 'Border' },
            { key: 'border-top', name: 'Border top' },
            { key: 'border-left', name: 'Border left' },
            { key: 'border-right', name: 'Border right' },
            { key: 'border-bottom', name: 'Border bottom' },
            { key: 'border-top-color', name: 'Border top color' },
            { key: 'border-left-color', name: 'Border left color' },
            { key: 'border-right-color', name: 'Border right color' },
            { key: 'border-bottom-color', name: 'Border bottom color' },
            { key: 'border-top-width', name: 'Border top width' },
            { key: 'border-left-width', name: 'Border left width' },
            { key: 'border-right-width', name: 'Border right width' },
            { key: 'border-bottom-width', name: 'Border bottom width' },
            { key: 'border-top-style', name: 'Border top style' },
            { key: 'border-left-style', name: 'Border left style' },
            { key: 'border-right-style', name: 'Border right style' },
            { key: 'border-bottom-style', name: 'Border bottom style' },
            { key: 'border-radius', name: 'Border radius' },
            { key: 'border-top-left-radius', name: 'Border radius (top left)' },
            { key: 'border-top-right-radius', name: 'Border radius (top right)' },
            { key: 'border-bottom-left-radius', name: 'Border radius (bottom left)' },
            { key: 'border-bottom-right-radius', name: 'Border radius (bottom right)' },
            { key: 'font-size', name: 'Font size' },
            { key: 'color', name: 'Color' },
            { key: 'font-weight', name: 'Font weight' },
            { key: 'letter-spacing', name: 'Letter spacing' },
            { key: 'background', name: 'Background' },
            { key: 'background-color', name: 'Background color' },
            { key: 'background-origin', name: 'Background origin' },
            { key: 'box-shadow', name: 'Box shadow' },
            { key: 'text-shadow', name: 'Text shadow' },
            { key: 'transform', name: 'Transform' }
        ]

        var transitionTimingFn = ['linear', 'ease', 'ease-in', 'ease-out', 'ease-in-out', 'step-start', 'step-end', 'steps', 'cubic-bezier'];
        var borderStyleArr = ['solid', 'dashed', 'dotted', 'double', 'groove', 'inset', 'outset', 'ridge', 'none', 'hidden', 'inherit', 'initial'];
        var shadowTypes = ['inset', 'outset', 'none'];

        window.pgCreateSelectorControl = function () {
            var c = new PgCustomPropertyControl('css-selector');
            var selectorDef = {
                type : 'text',
                name : '',
                without_text: true,
                action : 'rule_name',
                live_update : false
            };

            var input, $container;

            c.onDefine = function() {
                this.registerInputField('class-name', selectorDef);
            }

            c.onShow = function() {
                $container = $('<div class="selector-container"></div>');
                var input = this.showInputField($container, 'class-name', selectorDef);
                return $container;
            }

            c.onSetValues = function() {
                var cs = this.obj.pgStylesheet;

                if (cs.canEditRuleSelector()) $container.show();
                else                          $container.hide();
            }

            return c;
        }

        window.pgCreateMediaQueryControl = function () {

            var c = new PgCustomPropertyControl('css-media-query');
            var mediaDef = {
                type : 'media-query',
                name : '',
                action : 'rule_media',
                without_text: true,
                live_update : true,
                skip_handle_events : false
            };

            var input, $container;

            c.onDefine = function() {
                this.registerInputField('media-query', mediaDef);
            }

            c.onShow = function() {
                $container = $('<div class="media-query-container"></div>');

                input = this.showInputField($container, 'media-query', mediaDef);

                var mqHelper = new PgMediaQueryHelperView(input.$input, pinegrow.getSelectedPage(), true);
                mqHelper.view.get$Element().appendTo($container);

                return $container;
            }

            c.onSetValues = function() {
                var mediaParams = this.values['media-query'];
                var page = pinegrow.getSelectedPage();
                if (page) {
                    //updateMediaView(mediaParams);
                }

                var cs = this.obj.pgStylesheet;

                if (cs.canAddChangeMediaQuery()) $container.show();
                else                             $container.hide();
            }

            return c;
        }

        var pgCreateSelectorAndMediaQueryControl = function () {
            var c = new PgCustomPropertyControl('css-selector-and-media-query');
            var mediaDef = {
                type : 'media-query',
                name : '',
                action : 'rule_media',
                without_text: true,
                live_update : true,
                skip_handle_events : false
            };
            var selectorDef = {
                type : 'text',
                name : '',
                without_text: true,
                action : 'rule_name',
                live_update : false
            };
            var supportsDef = {
                type : 'text',
                name : '',
                without_text: true,
                show_empty: true,
                action : 'rule_supports',
                placeholder: '@supports...',
                open_list_on_focus: true,
                live_update : false,
                options: [
                    {
                        key: '(display:grid)', name: '(display:grid)', html: '(display:grid) <small>Use if <b>CSS Grid</b> is supported.</small>'
                    },
                    {
                        key: 'not (display:grid)', name: 'not (display:grid)', html: 'not (display:grid) <small>Use if <b>CSS Grid</b> is <b>not</b> supported.</small>'
                    },
                    {
                        key: '(display:flex)', name: '(display:flex)', html: '(display:flex) <small>Use if <b>Flex</b> is supported.</small>'
                    },
                    {
                        key: 'not (display:flex)', name: 'not (display:flex)', html: 'not (display:flex) <small>Use if <b>Flex</b> is <b>not</b> supported.</small>'
                    }
                ]
            };

            var $container, $selectorContainer, $mediaContainer, $supportsContainer;
            var mqHelper;

            c.onDefine = function() {
                this.registerInputField('class-name', selectorDef);
                this.registerInputField('media-query', mediaDef);
                //this.registerInputField('supports', supportsDef);
            }

            c.onShow = function() {
                $container = $('<div class="selector-and-media-query-container"></div>');

                $selectorContainer = $('<div class="rule-selector-container"></div>').appendTo($container);
                var selectorInput = this.showInputField($selectorContainer, 'class-name', selectorDef);

                /*
                $supportsContainer = $('<div class="rule-supports-container"></div>').appendTo($container);
                var supportsInput = this.showInputField($supportsContainer, 'supports', supportsDef);
*/
                $mediaContainer = $('<div class="media-query-container"></div>');

                if(!pgf.kids) {
                    $mediaContainer.appendTo($container);
                }
                var mediaInput = this.showInputField($mediaContainer, 'media-query', mediaDef);

                mqHelper = new PgMediaQueryHelperView(mediaInput.$input, pinegrow.getSelectedPage(), true);

                if(!pgf.kids) {
                    mqHelper.view.get$Element().appendTo($mediaContainer);
                }


                return $container;
            }

            // c.onSetValues = function(values, skipUpdating) {
            c.onSetValues = function() {
                var cs = this.obj.pgStylesheet;

                // if (!skipUpdating) mqHelper.updateMediaValue(this.values['media-query'] || "");
                mqHelper.updateMediaValue(this.values['media-query'] || "");

                var canEditRuleSelector    = cs.canEditRuleSelector();
                var canAddChangeMediaQuery = cs.canAddChangeMediaQuery();

                if (canAddChangeMediaQuery) {
                    pg$Show($mediaContainer);
                    //pg$Show($supportsContainer);
                } else {
                    pg$Hide($mediaContainer);
                    //pg$Hide($supportsContainer);
                }

                if(canEditRuleSelector) {
                    $selectorContainer.find('input').removeAttr('disabled');
                } else {
                    $selectorContainer.find('input').attr('disabled', 'disabled');
                }

            }

            return c;
        }

        var getCssValueForShorthandable = function(values, f, sf, base_on_equal) {
            var ptoa = {
                left: [0, 1, 1, 3],
                right: [0, 1, 1, 1],
                top: [0, 0, 0, 0],
                bottom: [0, 0, 2, 2]
            };
            var v = null;
            if (values) {
                $.each(values, function(fn, fv) {
                    if (fv) fv = fv.value || fv;

                    var vobj = null;
                    if(fn == f + '-' + sf) {
                        v = fv;
                    } else if(fn == f) {
                        if(base_on_equal) {
                            v = fv;
                        } else {
                            // var a = splitCssValue(fv.value);
                            var a = splitCssValue(fv);
                            if(a.length == 0) return null;

                            var imp = null;
                            if(a[a.length-1].match(/!important/i)) {
                                imp = a.pop();
                            }
                            if(a.length > 0 && a.length <= 4) {
                                v = a[ptoa[sf][a.length-1]];
                            }
                            if(imp) v = v + " " + imp;
                        }
                    }
                });
            }
            return v;
        }

        var shadowValueChanged = function ($container, shadowRotation, f, sf, index) {
            var $input = $container.find('.crsa-field-' + f + '-' + sf + '-' + index).find('input');
            if ($input.length > 0 && !$input.is(":focus")) {
                $input.val(shadowRotation[index][sf]);
                if (shadowRotation[index][sf].length > 0) $input.parent().addClass('has-value');
            }
        }

        var getRotAndDisValuesForShadow = function (f, shadowRotation, index) {
            if (!shadowRotation[index].x || !shadowRotation[index].y) {
                return {
                    x: shadowRotation[index].x,
                    y: shadowRotation[index].y,
                    deg: 0,
                    distance: null
                }
            }

            var shadowValueArray = [shadowRotation[index].x, shadowRotation[index].y];

            var leftNoObj = crsaGetNumberAndUnit(shadowValueArray[0]);
            var topNoObj  = crsaGetNumberAndUnit(shadowValueArray[1]);

            var left =     leftNoObj.number;
            var top = -1 * topNoObj.number;

            var unit = shadowValueArray[0].replace(left, '').trim();
            var deg = Math.round(Math.atan2(top, left)* 180.0 / Math.PI);
            if (deg < 0) deg = 360 + deg;

            var x = Math.cos(deg * (Math.PI/180));
            var y = Math.sin(deg * (Math.PI/180));

            var distanceFromLeft = 0, distanceFromTop = 0;
            if (x != 0) distanceFromLeft = Math.round(left / x);
            if (y != 0) distanceFromTop  = Math.round(top  / y);

            var dist = distanceFromLeft > distanceFromTop ? distanceFromLeft : distanceFromTop;

            return {
                x: shadowValueArray[0],
                y: shadowValueArray[1],
                deg: deg,
                distance: dist + unit
            }
        }

        var getTokens = function (strValue, splitChar) {
            var tokens = [];

            var i = 0, bracketOpen = 0;
            var str = '';

            var addToken = function (token) {
                token = token.trim() || '';
                if (token.length > 0) {
                    tokens.push(token);
                }
            }

            while (i < strValue.length) {
                if (strValue[i] == splitChar && bracketOpen == 0) {
                    addToken(str);
                    str = '';
                }
                else {
                    if (strValue[i] == '(') {
                        bracketOpen++;
                    }
                    else if (strValue[i] == ')') {
                        bracketOpen++;
                    }
                    str += strValue[i];
                }
                i++;
            }
            str = addToken(str);

            return tokens;
        }

        var getShadowMultiValues = function (shadowValue) {
            if (!shadowValue) return { important: false, tokens: [] };
            shadowValue = shadowValue.value || shadowValue;

            var hasImportant = false;
            if (shadowValue.endsWith('!important')) {
                hasImportant = true;
                shadowValue = shadowValue.substr(0, shadowValue.length - 10).trim();
            }

            var allShadowVals = [], currValue = [];

            var i = 0, bracketOpen = false;
            var str = '';

            var addToken = function (token) {
                token = token.trim() || '';
                if (token.length > 0) {
                    currValue.push(token.trim());
                }
                return '';
            }

            while (i < shadowValue.length) {
                if (shadowValue[i] == ',' && !bracketOpen) {
                    str = addToken(str);
                    allShadowVals.push(currValue);
                    currValue = [];
                }
                else {
                    if (shadowValue[i] == ' ' && !bracketOpen) {
                        str = addToken(str);
                    }

                    if (shadowValue[i] == '(') {
                        bracketOpen = true;
                    }
                    if (shadowValue[i] == ')') {
                        bracketOpen = false;
                    }

                    str += shadowValue[i];
                }
                i++;
            }
            str = addToken(str);
            allShadowVals.push(currValue);
            currValue = [];

            return {
                important: hasImportant,
                tokens: allShadowVals
            };
        }

        var getTransformMultiValues = function (transformsValue) {
            if (!transformsValue) return { important: false, tokens: [] };

            var allTransformsVals = [], currValue = [];
            var hasImportant = false;
            if (transformsValue.endsWith('!important')) {
                hasImportant = true;
                transformsValue = transformsValue.substr(0, transformsValue.length - 10).trim();
            }

            var i = 0, bracketOpen = false;
            var str = '', fn = '', oldFn = '';

            var getFnType = function (currFn) {
                     if (currFn.indexOf('translate') > -1) return 'translate';
                else if (currFn.indexOf('scale') > -1)     return 'scale';
                else if (currFn.indexOf('rotate') > -1)    return 'rotate';
                else if (currFn.indexOf('skew') > -1)      return 'skew';
            }

            var getAxisValues = function (itemValues) {
                var axisVal = {};

                if (itemValues.length > 0) {
                    var type = getFnType(fn);
                    var axis = fn.replace(type, '');

                    if (axis) {
                        if (axis.length == 1) {
                            axisVal[axis.toLowerCase()] = itemValues[0];
                        }
                        else if (axis.toLowerCase() == '3d') {
                            if (type == 'rotate') {
                                axisVal['x'] = itemValues[0];
                                axisVal['y'] = itemValues[1];
                                axisVal['z'] = itemValues[2];
                                axisVal['angle'] = itemValues[3];
                            }
                            else {
                                axisVal['x'] = itemValues[0];
                                axisVal['y'] = itemValues[1];
                                axisVal['z'] = itemValues[2];
                            }
                        }
                    }
                    else {
                        if (type == 'rotate') {
                            axisVal['z'] = itemValues[0];
                        }
                        else if (type == 'scale') {
                            axisVal['x'] = itemValues[0];
                            axisVal['y'] = itemValues[0];
                        }
                        else {
                            axisVal['x'] = itemValues[0];
                            axisVal['y'] = itemValues[1];
                            axisVal['z'] = itemValues[2];
                        }
                    }
                }

                return axisVal;
            }

            var addItem = function (itemValues) {
                if (itemValues.length > 0) {
                    var type = getFnType(fn);
                    var axisVal = getAxisValues(itemValues);

                    allTransformsVals.push({
                        key: type,
                        values: axisVal
                    })
                }
                return '';
            }

            var addNewItemsTo = function (index, itemValues) {
                var axisVals = getAxisValues(itemValues);
                var oldVals = allTransformsVals[index].values;

                var foundSameVal = false;
                for (var key in axisVals) {
                    if (oldVals[key]) {
                        foundSameVal = true;
                        break;
                    }
                }

                if (foundSameVal) {
                    addItem(itemValues);
                }
                else {
                    var newVals = $.extend({}, axisVals, oldVals);
                    allTransformsVals[index].values = newVals;
                }
            }

            while (i < transformsValue.length) {
                if (transformsValue[i] == ',' && bracketOpen) {
                    currValue.push(str.trim());
                    str = '';
                }
                else {
                    if (transformsValue[i] == '(') {
                        fn = str.trim();
                        str = '';
                        bracketOpen = true;
                    }
                    else if (transformsValue[i] == ')') {
                        currValue.push(str.trim());
                        if (getFnType(fn) == getFnType(oldFn)) {
                            addNewItemsTo(allTransformsVals.length - 1, currValue)
                        }
                        else {
                            addItem(currValue);
                        }
                        currValue = [];
                        oldFn = fn;
                        fn = str = '';
                        bracketOpen = false;
                    }
                    else {
                        str += transformsValue[i];
                    }
                }
                i++;
            }

            return {
                important: hasImportant,
                tokens: allTransformsVals
            };
        }

        var getTransitionMultiValues = function (transitionValue) {
            if (!transitionValue) return { important: false, tokens: [] };

            var allTransitionVals = [], currValue = [];
            var hasImportant = false;

            if (transitionValue.endsWith('!important')) {
                hasImportant = true;
                transitionValue = transitionValue.substr(0, transitionValue.length - 10).trim();
            }

            var i = 0, bracketOpen = false;
            var str = '';

            var addToken = function (token) {
                token = token.trim() || '';
                if (token.length > 0) {
                    currValue.push(token.trim());
                }
                return '';
            }

            while (i < transitionValue.length) {
                if (transitionValue[i] == ',' && !bracketOpen) {
                    str = addToken(str);
                    allTransitionVals.push(currValue);
                    currValue = [];
                }
                else {
                    if (transitionValue[i] == ' ' && !bracketOpen) {
                        str = addToken(str);
                    }

                    if (transitionValue[i] == '(') {
                        bracketOpen = true;
                    }
                    if (transitionValue[i] == ')') {
                        bracketOpen = false;
                    }

                    str += transitionValue[i];
                }
                i++;
            }
            str = addToken(str);
            allTransitionVals.push(currValue);
            currValue = [];

            return {
                important: hasImportant,
                tokens: allTransitionVals
            };
        }

        // var getCSSFunctionNameAndParams = function (str) {
        //     var startBracketIndex = str.indexOf('(');
        //     var endBracketIndex = str.indexOf(')');
        //     var fnName = str;
        //     var params = null;
        //     if (startBracketIndex > -1) {
        //         fnName = str.substring(0, startBracketIndex);
        //         params = str.substring(startBracketIndex + 1, endBracketIndex);
        //     }

        //     return {
        //         name: fnName,
        //         params: params
        //     }
        // }

        var fillBorderRadiusValues = function (borderRadiusValue) {
            var value = borderRadiusValue.value || borderRadiusValue;
            var borderRadiusValues = {};
            if (!value) {
                return borderRadiusValues;
            }

            var importantText = '';
            if (value.endsWith('!important')) {
                importantText = ' !important';
                value = value.substr(0, value.length - 10).trim();
            }

            var radiusValueArr = value.split(' ');
            radiusValueArr = radiusValueArr.filter(function(n) { return n ? true : false; });

            if (radiusValueArr.length == 4) {
                borderRadiusValues['top-left'] = radiusValueArr[0] + importantText;
                borderRadiusValues['top-right'] = radiusValueArr[1] + importantText;
                borderRadiusValues['bottom-right'] = radiusValueArr[2] + importantText;
                borderRadiusValues['bottom-left'] = radiusValueArr[3] + importantText;
            }
            else if (radiusValueArr.length == 3) {
                borderRadiusValues['top-left'] = radiusValueArr[0] + importantText;
                borderRadiusValues['top-right'] = borderRadiusValues['bottom-left'] = radiusValueArr[1] + importantText;
                borderRadiusValues['bottom-right'] = radiusValueArr[2] + importantText;
            }
            else if (radiusValueArr.length == 2) {
                borderRadiusValues['top-left'] = borderRadiusValues['bottom-right'] = radiusValueArr[0] + importantText;
                borderRadiusValues['top-right'] = borderRadiusValues['bottom-left'] = radiusValueArr[1] + importantText;
            }
            else if (radiusValueArr.length == 1) {
                borderRadiusValues['top-left'] = borderRadiusValues['top-right'] = borderRadiusValues['bottom-left'] = borderRadiusValues['bottom-right'] = radiusValueArr[0] + importantText;
            }

            return borderRadiusValues;
        }

        var fillBorderValues = function (borderValue) {
            var borderValueObj = { width: '', color: '', style: '' };
            var i = 0, after = ['width', 'style', 'color'];
            var resetValues = [];

            while (i < borderValue.length) {
                if (after.indexOf('width') > -1 && $.isNumeric(parseInt(borderValue[i], 10))) {
                    borderValueObj.width = borderValue[i];
                    after.splice(after.indexOf('width'), 1);
                }
                else if (after.indexOf('style') > -1 && borderStyleArr.indexOf(borderValue[i]) > -1) {
                    borderValueObj.style = borderValue[i];
                    after.splice(after.indexOf('style'), 1);
                }
                else if (after.indexOf('color') > -1 && isNaN(parseInt(borderValue[i], 10)) && (borderValue[i] && (borderValue[i].startsWith('#') || borderValue[i].startsWith('rgb')) && !borderValue[i].startsWith('@') && !borderValue[i].startsWith('$'))) {
                    borderValueObj.color = borderValue[i];
                    after.splice(after.indexOf('color'), 1);
                }
                else {
                    resetValues.push(borderValue[i]);
                }
                i++;
            }

            for (i = 0; i < resetValues.length; i++) {
                var rest = resetValues[i];
                borderValueObj[after[0]] = rest;
                after.splice(0, 1);
            }
            return borderValueObj;
        }

        var fillShadowValues = function (shadowType, shadowValue, values, shadowRotation, index, declChar) {
            shadowRotation[index] = {};
            var shadowValueArray = shadowValue[index];
            var i = 0, after = ['type', 'color', 'x'];
            while (i < shadowValueArray.length) {
                if (shadowValueArray[i]) {
                    var nu = crsaGetNumberAndUnit(shadowValueArray[i]);

                    if (after.indexOf('type') > -1 && shadowTypes.indexOf(shadowValueArray[i]) > -1) {
                        //  = 'inside';
                        var value = shadowValueArray[i];
                        if (shadowValueArray[i] == 'inset') value = "inside";

                        shadowRotation[index].type = values[shadowType + '-type-' + index] = value;
                        after = ['color', 'x'];
                    }
                    else if (after.indexOf('color') > -1 && (!nu || isNaN(nu.number))) {
                        if (declChar && shadowValueArray[i][0] == declChar) {
                            shadowRotation[index] = {};
                            shadowRotation[index].text = values[shadowType + '-' + index] = shadowValueArray.join(' ');
                            return false;
                        }
                        shadowRotation[index].color = values[shadowType + '-color-' + index] = shadowValueArray[i];
                        after = ['type', 'x'];
                    }
                    else if (after.indexOf('x') > -1 && (nu && $.isNumeric(nu.number))) {
                        shadowRotation[index].x = values[shadowType + '-x-' + index] = nu.text;
                        after = ['y'];
                    }
                    else if (after.indexOf('y') > -1 && (nu && $.isNumeric(nu.number))) {
                        shadowRotation[index].y = values[shadowType + '-y-' + index] = nu.text;
                        after = ['blur', 'color', 'type'];
                    }
                    else if (after.indexOf('blur') > -1 && (nu && $.isNumeric(nu.number))) {
                        shadowRotation[index].blur = values[shadowType + '-blur-' + index] = nu.text;
                        after = ['size', 'color', 'type'];
                    }
                    else if (after.indexOf('size') > -1 && (nu && $.isNumeric(nu.number))) {
                        shadowRotation[index].size = values[shadowType + '-size-' + index] = nu.text;
                        after = ['color', 'type'];
                    }
                    else {
                        return false;
                    }
                }
                i++;
            }
            shadowRotation[index].type = values[shadowType + '-type-' + index] = shadowRotation[index].type || 'outside';

            var rotAndDis = getRotAndDisValuesForShadow(shadowType, shadowRotation, index);
            shadowRotation[index].distance = values[shadowType + '-distance-' + index] = rotAndDis.distance;
            shadowRotation[index].rotate   = values[shadowType + '-rotate-' + index]   = rotAndDis.deg;
            return true;
        }

        var fillTransformValues = function (transformValues, values, index, declChar) {
            transformObjArr[index] = {};
            var transformValueObj = transformValues[index];
            transformObjArr[index].type = values['transform-type-' + index] = transformValueObj.key;

            if (transformValueObj.key == 'rotate' && transformValueObj.values.angle) {
                var transValues = transformValueObj.values;
                transformObjArr[index].text = values['transform-text-' + index] = 'rotate3d(' + transValues.x + ',' + transValues.y + ',' + transValues.z + ', ' + transValues.angle + ')';
                return false;
            }

            var transformType = transformValueObj.key;
            if (!transformObjArr[index][transformType]) transformObjArr[index][transformType] = {};

            transformObjArr[index][transformType].x = values['transform-' + transformType + '-x-' + index] = transformValueObj.values.x;
            transformObjArr[index][transformType].y = values['transform-' + transformType + '-y-' + index] = transformValueObj.values.y;
            transformObjArr[index][transformType].z = values['transform-' + transformType + '-z-' + index] = transformValueObj.values.z;

            return true;
        }

        var fillTransitionValues = function (transitionValueArray, values, index, declChar) {
            transitionObjArr[index] = {};
            var i = 0, after = ['property', 'duration', 'timingFn'];
            while (i < transitionValueArray.length) {
                if (transitionValueArray[i]) {
                    if (after.indexOf('duration') > -1 && $.isNumeric(parseInt(transitionValueArray[i], 10))) {
                        transitionObjArr[index].duration = values['transition-duration-' + index] = transitionValueArray[i];
                        after.splice(after.indexOf('duration'), 1);
                        after.push('delay');
                    }
                    else if (after.indexOf('delay') > -1 && $.isNumeric(parseInt(transitionValueArray[i], 10))) {
                        transitionObjArr[index].delay = values['transition-delay-' + index] = transitionValueArray[i];
                        after.splice(after.indexOf('delay'), 1);
                    }
                    else if (after.indexOf('timingFn') > -1 && transitionTimingFn.indexOf(getCSSFunctionNameAndParams(transitionValueArray[i]).name) > -1) {
                        transitionObjArr[index].timingFn = values['transition-timing-function-' + index] = transitionValueArray[i];
                        after.splice(after.indexOf('timingFn'), 1);
                    }
                    else if (after.indexOf('property') > -1 && isNaN(parseInt(transitionValueArray[i], 10))) {
                        transitionObjArr[index].property = values['transition-property-' + index] = transitionValueArray[i];
                        after.splice(after.indexOf('property'), 1);
                    }
                    else {
                        return false;
                    }
                }
                i++;
            }

            return true;
        }

        var deleteCssShadowValue = function (obj, f, values, index, shadowRotation, important) {
            var valueArr = [], i = 0;

            var importantText = '';
            if (important) importantText = ' !important';

            for (var j = 0; j < shadowRotation.length; j++) {
                if (shadowRotation[j].deleted) continue;

                var added = false, lastIndex = i;
                if (j != index) {
                    if (values[f + '-type-' + j] == 'none') {
                        valueArr[i++] = 'none';
                    }
                    else {
                        if (values[f + '-type-' + j] == 'inside') valueArr[i++] = 'inset';

                        if (shadowRotation[j].x)     valueArr[i++] = shadowRotation[j].x;
                        if (shadowRotation[j].y)     valueArr[i++] = shadowRotation[j].y;
                        if (shadowRotation[j].blur)  valueArr[i++] = shadowRotation[j].blur;
                        if (shadowRotation[j].size)  valueArr[i++] = shadowRotation[j].size;

                        if (shadowRotation[j].color) valueArr[i++] = shadowRotation[j].color;
                    }
                    added = true;
                }

                if (added && j + 1 < shadowRotation.length && lastIndex != i) valueArr[i++] = ',';
            }


            var lastId = valueArr.length - 1;
            if (valueArr[lastId] == ",") valueArr.splice(lastId, 1);

            if (valueArr.length > 0) commitObjValue(obj, f, valueArr.join(' ') + importantText);
            else                     commitObjValue(obj, f, null);

            shadowRotation[index].deleted = true;
        }

        var addTransformCurrValue = function(currValue, type, x, y, z) {
            if (type === "translate") {
                if(x && y && z) {
                    currValue.push(`translate3d(${x}, ${y}, ${z})`);
                } else if(x && y) {
                    currValue.push(`translate(${x}, ${y})`);
                } else {
                    x && currValue.push(`translateX(${x})`);
                    y && currValue.push(`translateY(${y})`);
                    z && currValue.push(`translateZ(${z})`);
                }
            } else if (type === "scale") {
                if(x && y && z) {
                    currValue.push(`scale3d(${x}, ${y}, ${z})`);
                } else if(x && y) {
                    currValue.push(`scale(${x}, ${y})`);
                } else {
                    x && currValue.push(`scaleX(${x})`);
                    y && currValue.push(`scaleY(${y})`);
                    z && currValue.push(`scaleZ(${z})`);
                }
            } else if (type === "rotate") {
                if (x) {
                    currValue.push(`rotateX(${x})`);
                }
                if (y) {
                    currValue.push(`rotateY(${y})`);
                }
                if (z) {
                    currValue.push(`rotate(${z})`);
                }
            } else if (type === "skew") {
                if(x && y) {
                    currValue.push(`skew(${x}, ${y})`);
                } else if(x) {
                    currValue.push(`skewX(${x})`);
                } else if(y) {
                    currValue.push(`skewY(${y})`);
                }
            }
        }

        var deleteCssTransformValue = function (control, index, important) {
            var currValue = [], i = 0;

            var importantText = '';
            if (important) importantText = ' !important';

            for (var j = 0; j < transformObjArr.length; j++) {
                if (transformObjArr[j].deleted) continue;
                var tType = null;
                var added = false, lastId = i;
                if (j != index) {
                    var type = transformObjArr[j].type;

                    if (transformObjArr[j].text) {
                        currValue[i++] = transformObjArr[j].text;
                    }
                    else if (type == "translate") {
                        var fnId = i++;

                        var x = transformObjArr[j][type].x;
                        var y = transformObjArr[j][type].y;
                        var z = transformObjArr[j][type].z;
                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type == "scale") {
                        var fnId = i++;
                        var x = transformObjArr[j][type].x;
                        var y = transformObjArr[j][type].y;
                        var z = transformObjArr[j][type].z;
                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type == "rotate") {
                        var x = transformObjArr[j][type].x;
                        var y = transformObjArr[j][type].y;
                        var z = transformObjArr[j][type].z;
                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type == "skew") {
                        var fnId = i++;
                        var x = transformObjArr[j][type].x;
                        var y = transformObjArr[j][type].y;
                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                }
            }

            transformObjArr[index].deleted = true;
            var obj = control.obj;
            if (currValue.length > 0) commitObjValue(obj, 'transform', currValue.join(' ') + importantText);
            else                      commitObjValue(obj, 'transform', null);
        }

        var deleteCssTransitionValue = function (control, index, important) {
            var currValue = [], i = 0;

            var importantText = '';
            if (important) importantText = ' !important';

            for (var j = 0; j < transitionObjArr.length; j++) {
                if (transitionObjArr[j].deleted || j == index) continue;

                var lastId = i;
                if (transitionObjArr[j].text) {
                    currValue[i++] = transitionObjArr[j].text;
                }
                else {
                    if (transitionObjArr[j].property) currValue[i++] = transitionObjArr[j].property;
                    if (transitionObjArr[j].duration) currValue[i++] = transitionObjArr[j].duration;
                    if (transitionObjArr[j].timingFn) currValue[i++] = transitionObjArr[j].timingFn;
                    if (transitionObjArr[j].delay)    currValue[i++] = transitionObjArr[j].delay;
                }

                if (j + 1 < transitionObjArr.length && lastId != i) currValue[i++] = ',';
            }

            var lastId = currValue.length - 1;
            if (currValue[lastId] == ",") currValue.splice(lastId, 1);

            transitionObjArr[index].deleted = true;
            var obj = control.obj;
            if (currValue.length > 0) commitObjValue(obj, 'transition', currValue.join(' ').trim() + importantText);
            else                      commitObjValue(obj, 'transition', null);
        }

        var setCSSValueForShadow = function (obj, values, f, sf, v, index, shadowRotation, important) {
            var distance, blur, size, color, inside, rotate, x, y, shadowTextVal;

            var importantText = '';
            if (important) {
                importantText = ' !important';
            }

            if (sf == "distance") {
                var $shadowPanel = shadowRotation[index].$el.closest('.' + f + '-panel');

                shadowRotation[index].distance = distance = v;
                rotate = shadowRotation[index].value ||  0;

                if (distance) {
                    var distanceInt = parseInt(distance, 10);
                    if (!isNaN(distanceInt)) {
                        var unit = distance.replace(distanceInt, '').trim();

                        shadowRotation[index].x = x = Math.round(distanceInt * (Math.cos(parseInt(rotate)  * (Math.PI/180)))) + unit;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'x', index);

                        shadowRotation[index].y = y = -1 * Math.round(distanceInt * (Math.sin(parseInt(rotate)  * (Math.PI/180)))) + unit;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'y', index);
                    }
                }
                else {
                    shadowRotation[index].x = x = '';
                    shadowValueChanged($shadowPanel, shadowRotation, f, 'x', index);

                    shadowRotation[index].y = y = '';
                    shadowValueChanged($shadowPanel, shadowRotation, f, 'y', index);
                }
            }
            else if (sf == "rotate") {
                rotate = shadowRotation[index].value = v;
                distance = (sf == 'distance' ? v : (shadowRotation[index].distance || ''));
                if (distance) {
                    var $shadowPanel = shadowRotation[index].$el.closest('.' + f + '-panel');

                    var distanceInt = parseInt(distance, 10);
                    if (!isNaN(distanceInt)) {
                        var unit = distance.replace(distanceInt, '').trim();

                        shadowRotation[index].x = x = Math.round(distanceInt * (Math.cos(parseInt(rotate)  * (Math.PI/180)))) + unit;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'x', index);

                        shadowRotation[index].y = y = (-1 * Math.round(distanceInt * (Math.sin(parseInt(rotate)  * (Math.PI/180))))) + unit;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'y', index);
                    }
                }
            }
            else if (sf == "x" || sf == "y") {
                shadowRotation[index].x = x = (sf == 'x' ? v : (shadowRotation[index].x || ''));
                shadowRotation[index].y = y = (sf == 'y' ? v : (shadowRotation[index].y || ''));

                if (x && y) {
                    var $shadowPanel = shadowRotation[index].$el.closest('.' + f + '-panel');

                    var left =     parseInt(x, 10);
                    var top = -1 * parseInt(y, 10);

                    if (!isNaN(left) && !isNaN(top)) {
                        var unit = x.replace(left, '').trim();
                        rotate = Math.round(Math.atan2(top, left) * 180.0 / Math.PI);
                        if (rotate < 0) rotate = 360 + rotate;

                        var cosX = Math.cos(rotate * (Math.PI / 180));
                        var sinY = Math.sin(rotate * (Math.PI / 180));

                        var distanceFromLeft = 0, distanceFromTop = 0;
                        if (cosX != 0) distanceFromLeft = Math.round(left / cosX);
                        if (sinY != 0) distanceFromTop  = Math.round(top  / sinY);

                        shadowRotation[index].value = rotate;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'rotate', index);

                        shadowRotation[index].distance = distance = (distanceFromLeft > distanceFromTop ? distanceFromLeft : distanceFromTop) + unit;
                        shadowValueChanged($shadowPanel, shadowRotation, f, 'distance', index);
                    }
                }
            }
            else if (sf == f) {
                shadowRotation[index].text = shadowTextVal = (sf == f ? v : (shadowRotation[index].text || ''));
                // shadowTextVal = (sf == f ? v : (values[f + '-' + index] || ''));
            }
            else {
                shadowRotation[index][sf] = v;
                x = (sf == 'x' ? v : (shadowRotation[index].x || ''));
                y = (sf == 'y' ? v : (shadowRotation[index].y || ''));

                distance = (sf == 'distance' ? v : (shadowRotation[index].distance ||  ''));
                rotate   = (sf == 'rotate'   ? v : (shadowRotation[index].value    || '0'));
            }

            blur   = (sf == 'blur'  ? v : (shadowRotation[index].blur  || ''));
            size   = (sf == 'size'  ? v : (shadowRotation[index].size  || ''));
            color  = (sf == 'color' ? v : (shadowRotation[index].color || ''));
            inside = (sf == 'type'  ? v : (shadowRotation[index].type  || ''));


            var valueArr = [], i = 0;

            for (var j = 0; j < shadowRotation.length; j++) {
                if (shadowRotation[j].deleted) continue;

                var lastId = i;
                if (j == index) {
                    if (sf == f) {
                        if (shadowTextVal) valueArr[i++] = shadowTextVal;
                    }
                    else {
                        if (inside == 'none') {
                            valueArr[i++] = 'none';
                        }
                        else {
                            if (inside == 'inside') valueArr[i++] = 'inset';

                            if (x) valueArr[i++] = x;
                            if (y) valueArr[i++] = y;
                            if (blur) valueArr[i++] = blur;
                            if (size) valueArr[i++] = size;

                            if (color) valueArr[i++] = color;
                        }
                    }
                }
                else {
                    // if (values[f + '-' + j]) {
                    //     valueArr[i++] = values[f + '-' + j];
                    // }
                    if (shadowRotation[j].text) {
                        valueArr[i++] = shadowRotation[j].text;
                    }
                    else {
                        if (shadowRotation[j].type == 'none') {
                            valueArr[i++] = 'none';
                        }
                        else {
                            if (shadowRotation[j].type == 'inside') valueArr[i++] = 'inset';

                            if (shadowRotation[j].x)     valueArr[i++] = shadowRotation[j].x;
                            if (shadowRotation[j].y)     valueArr[i++] = shadowRotation[j].y;
                            if (shadowRotation[j].blur)  valueArr[i++] = shadowRotation[j].blur;
                            if (shadowRotation[j].size)  valueArr[i++] = shadowRotation[j].size;

                            if (shadowRotation[j].color) valueArr[i++] = shadowRotation[j].color;
                        }
                    }
                }

                if (j + 1 < shadowRotation.length && lastId != i) valueArr[i++] = ',';
            }

            while (valueArr.length > 0 && valueArr[valueArr.length - 1] == ',') valueArr.pop();

            // var shouldSetValue = shadowTextVal || (x && y) || valueArr.length > -1;
            var shouldSetValue = valueArr.length > 0;
            if (shouldSetValue) commitObjValue(obj, f, valueArr.join(' ') + importantText);
            else                commitObjValue(obj, f, null);

            return v;
        }

        var onTransformTypeChanged = function ($container, v) {
            var $fieldsCon = $container.find('> .fields-container');
            $fieldsCon.find('> div').hide();
            $fieldsCon.find('> .' + v + '-fileds').show();
        }

        var setCSSValueForTransform = function (obj, values, sf, v, index, important) {
            var currValue = [], i = 0;

            var importantText = '';
            if (important) importantText = ' !important';

            for (var j = 0; j < transformObjArr.length; j++) {
                if (transformObjArr[j].deleted) continue;

                if (sf == 'type' && j == index) {
                    var $container = $('#collapse-transform-' + j).find('> .panel-body');
                    onTransformTypeChanged($container, v);
                    transformObjArr[j].type = v;
                }

                if (transformObjArr[j].text) {
                    currValue[i++] = (sf == 'text' && index == j ? v : transformObjArr[j].text);
                }
                else {
                    var type = (sf === 'type' && index === j ? v : transformObjArr[j].type);
                    var tType = '', lastId = i;

                    if (!transformObjArr[j][type]) transformObjArr[j][type] = {};

                    if (type === "translate") {
                        var x = transformObjArr[j][type].x = (sf === 'translate-x' && index === j ? v : transformObjArr[j][type].x);
                        var y = transformObjArr[j][type].y = (sf === 'translate-y' && index === j ? v : transformObjArr[j][type].y);
                        var z = transformObjArr[j][type].z = (sf === 'translate-z' && index === j ? v : transformObjArr[j][type].z);

                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type === "scale") {
                        var x = transformObjArr[j][type].x = (sf === 'scale-x' && index === j ? v : transformObjArr[j][type].x);
                        var y = transformObjArr[j][type].y = (sf === 'scale-y' && index === j ? v : transformObjArr[j][type].y);
                        var z = transformObjArr[j][type].z = (sf === 'scale-z' && index === j ? v : transformObjArr[j][type].z);

                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type === "rotate") {
                        var x = transformObjArr[j][type].x = (sf === 'rotate-x' && index === j ? v : transformObjArr[j][type].x);
                        var y = transformObjArr[j][type].y = (sf === 'rotate-y' && index === j ? v : transformObjArr[j][type].y);
                        var z = transformObjArr[j][type].z = (sf === 'rotate-z' && index === j ? v : transformObjArr[j][type].z);

                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                    else if (type === "skew") {
                        var x = transformObjArr[j][type].x = (sf === 'skew-x' && index === j ? v : transformObjArr[j][type].x);
                        var y = transformObjArr[j][type].y = (sf === 'skew-y' && index === j ? v : transformObjArr[j][type].y);

                        addTransformCurrValue(currValue, type, x, y, z);
                    }
                }
            }

            if (currValue.length > 0) commitObjValue(obj, 'transform', currValue.join(' ') + importantText);
            else                      commitObjValue(obj, 'transform', null);

            return v;
        }

        var setCSSValueForTransition = function (obj, sf, v, index, important) {
            var currValue = [], i = 0;

            var importantText = '';
            if (important) importantText = ' !important';

            for (var j = 0; j < transitionObjArr.length; j++) {
                if (transitionObjArr[j].deleted) continue;

                var lastId = i;
                if (transitionObjArr[j].text) {
                    currValue[i++] = transitionObjArr[j].text;
                }
                else {
                    var value = transitionObjArr[j].property = (sf == "property" && index == j) ? v : transitionObjArr[j].property;
                    if (value) currValue[i++] = value;

                    value = transitionObjArr[j].duration = (sf == "duration" && index == j) ? v : transitionObjArr[j].duration;
                    if (value) currValue[i++] = value;

                    value = transitionObjArr[j].timingFn = (sf == "timingFn" && index == j) ? v : transitionObjArr[j].timingFn;
                    if (value) currValue[i++] = value;

                    value = transitionObjArr[j].delay    = (sf == "delay"    && index == j) ? v : transitionObjArr[j].delay;
                    if (value) currValue[i++] = value;
                }

                if (j + 1 < transitionObjArr.length && lastId != i) {
                    currValue[currValue.length - 1] = currValue[currValue.length - 1] + ',';
                }
            }

            if (currValue.length > 0) commitObjValue(obj, 'transition', currValue.join(' ').trim() + importantText);
            else                      commitObjValue(obj, 'transition', null);

            return v;
        }

        var addCssShadowDefForType = function (type, name, options, f, sf, i, shadowRotation) {
            return {
                'type': type,
                'name': name,
                'options': options,
                'toggle_buttons' : true,
                'skip-adding-prop': true,
                'show_empty' : true,
                'index': i,
                get_value: function (obj) {
                    // do nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForShadow(obj, values, f, sf, value, fieldDef.index, shadowRotation);
                }
            }
        }

        var addCssTransformDefForType = function (type, name, options, f, sf, i, no_text, important) {
            return {
                'type': type,
                'name': name,
                'options': options,
                'skip-adding-prop': true,
                'toggle_buttons' : true,
                'without_text': no_text,
                'index': i,
                'important': important,
                get_value: function (obj) {
                    // do nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, sf, value, fieldDef.index, fieldDef.important);
                }
            }
        }

        var getRuleFromObj = function (obj) {
            var pgStylesheet = obj.pgStylesheet;
            var rule = pinegrow.pgPostCSSHelper.getNodeByIndices(pgStylesheet.getRootNode(), obj.indices);

            return {
                pgStylesheet: pgStylesheet,
                rule: rule
            }
        }

        var getValuesFromObj = function (obj) {
            var values = {};
            var pgStylesheet = obj.pgStylesheet;
            var rule = pinegrow.pgPostCSSHelper.getNodeByIndices(pgStylesheet.getRootNode(), obj.indices);
            var values = pgStylesheet.getPropValuePairFor(rule);

            return values;
        }

        var commitObjValue = function (obj, prop, value, sync, forceChanging, dispatchEvent, ignoreUndo) {
            dispatchEvent = typeof dispatchEvent === 'undefined' ? true : dispatchEvent;

            var ruleAndCs = getRuleFromObj(obj);
            var rule = ruleAndCs.rule,
                cs   = ruleAndCs.pgStylesheet;

            var fn = null;
            if (sync) fn = cs.ruleValueChangedSync;
            else      fn = cs.ruleValueChanged;

            fn.call(cs, rule, prop, value, null, false, 'gui', dispatchEvent, forceChanging, null, null, ignoreUndo);
        }

        var GradientControl = function () {
            var $container;
            var _this = this;

            var gradientProp = 'background-image';
            var gradientField = [];
            var panelInputControl = null;
            var c = new PgCustomPropertyControl('css-gradient');
            var lastId = 0,
                titleId = 1;

            var skipGradientChange = false,
                colorPickerMoving = false,
                skipDispatchEvent = false,
                fillingColorPicker = false;

            // var gradArr = ['0deg', '90deg', '135deg', '180deg', 'top', 'left', 'center', 'right', 'bottom'];
            var gradArr = ['top', 'left', 'center', 'right', 'bottom'];

            var addNewPanel = function () {
                var $panel = panelInputControl.addPanel(lastId, titleId).$panel;
                $panel.find('> .panel-heading .collapsed').click();
                lastId++;
                titleId++;
            }

            var getGradientAngle = function (gradAngleArr) {
                var options = [];
                for (var i = 0; i < gradAngleArr.length; i++) {
                    var angle = gradAngleArr[i];
                    options.push({
                        key: angle,
                        name: angle.charAt(0).toUpperCase() + angle.slice(1)
                    });
                }

                return options;
            }

            var changeAngleValue = function (callback, skipChange, skipDispatch) {
                if (skipDispatch) skipDispatchEvent = true;
                if (skipChange) skipGradientChange = true;
                callback();
                if (skipChange) skipGradientChange = false;
                if (skipDispatch) skipDispatchEvent = false;
            }

            var getAngleValue = function (value) {
                switch (value) {
                    case 'right':
                        return '90deg';
                    case 'left':
                        return '270deg';
                    case 'top':
                        return '180deg';
                    case 'bottom':
                        return '0deg';
                    default:
                        return value;
                }
            }

            var getGradientAngleValue = function (value) {
                return (value + 90) % 360;
            }

            var getAngleControlValue = function (value) {
                var newValue = value - 90;
                if (newValue < 0) newValue = 360 + newValue;
                return newValue % 360;
            }

            var setAnglePickerValue = function (angle, skipDispatchEvent, inedx) {
                var fields = gradientField[inedx];

                var newAngle = angle;
                if (!newAngle || newAngle == 'center') newAngle = 'right';

                var angleValue = getAngleValue(newAngle);
                var angleNumber = parseInt(angleValue, 10);
                fields['angle'].selector.anglepicker("value", getAngleControlValue(angleNumber), skipDispatchEvent);
                var $label = fields['angle'].selector.siblings('.angle-value');
                $label.html(angleNumber + " deg");
            }

            var onTypeValueSet = function (value, index) {
                var fields = gradientField[index];
                var angleValue = fields['angle'].field.getValue();

                if (value.indexOf('radial') > -1) {
                    if (!angleValue) {
                        fields['angle'].field.setValue('right');
                        setAnglePickerValue('right', false, index);
                        fields['selector'].setDirection('right');
                    }

                    fields['angle'].selector.anglepicker('disable');
                } else {
                    fields['angle'].selector.anglepicker('enable');
                }
            }

            var onAngleValueSet = function (value, index) {
                changeAngleValue(function () {
                    setAnglePickerValue(value, true, index);
                }, true);
            }

            var anglepickerMove = function (value, index) {
                var fields = gradientField[index];
                var oldValue = fields['angle'].field.getValue();
                if (oldValue) {
                    // changeAngleValue(function () {
                    fields['angle'].field.setValue('');
                    // }, true);
                }

                var newValue = getGradientAngleValue(value);
                fields['selector'].setDirection(newValue + 'deg', 0);
                return newValue;
            }

            var onGradientValueChange = function (dispatchEvent) {
                var gradientValue = "";
                for (var i = 0; i < gradientField.length; i++) {
                    var fields = gradientField[i];
                    if (fields.deleted) continue;

                    gradientValue += fields['selector'].getValue() + ", ";
                    //this returned -webkit-linera..
                    //gradientValue += fields['selector'].getSafeValue() + ", ";
                }

                if (gradientValue.endsWith(', ')) {
                    gradientValue = gradientValue.substr(0, gradientValue.length - 2);
                }
                commitObjValue(c.obj, gradientProp, gradientValue, false, 'do', dispatchEvent);
                if (dispatchEvent) {
                    if (backgroundField[gradientProp]) {
                        backgroundField[gradientProp].setValue(gradientValue);
                    }
                }
            }

            var fillGradientValues = function (values, index) {
                var fields = gradientField[index];
                var points = values['points'],
                    type = values['type'],
                    angle = values['angle'];

                var gp = fields['selector'];

                fillingColorPicker = true;
                var length = points.length;
                for (var i = 0; i < length; i++) {
                    var point = points[i];
                    gp.addHandler(point.position, point.color);
                }
                fillingColorPicker = false;

                if (type) {
                    gp.setType(type);
                    fields['type'].setValue(type);
                    onTypeValueSet(type, index);
                }

                if (angle) {
                    gp.setDirection(angle);
                    setAnglePickerValue(angle, false, index);
                    if (!angle.endsWith('deg')) {
                        fields['angle'].field.setValue(angle);
                    }
                }
            }

            var addGradientFields = function ($container, index) {
                var $gradient = $('<div class="gradient"></div>').appendTo($container);
                var $gradientControls = $('<div class="gradient-control"></div>').appendTo($container);
                $gradientControls.data('index', index);

                var $row = $('<div class="row"></div>').appendTo($gradientControls);
                var $typeContainer = $('<div class="col-xs-8"></div>').appendTo($row);

                var fields = {};

                fields['type'] = c.showInputField($typeContainer, 'gradient-type-' + index, {
                    'type': 'select',
                    'name': 'Type',
                    'without_icon': false,
                    'show_empty': true,
                    'action': 'custom',
                    'index': index,
                    'options': [{
                            key: 'radial',
                            name: 'Radial'
                        },
                        {
                            key: 'linear',
                            name: 'Linear'
                        },
                        {
                            key: 'repeating-radial',
                            name: 'Repeating radial'
                        },
                        {
                            key: 'repeating-linear',
                            name: 'Repeating linear'
                        }
                    ],
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value: function (obj, value, values, oldValue, eventType, fieldDef) {
                        var index = fieldDef.index;
                        changeAngleValue(function () {
                            onTypeValueSet(value, index);
                        }, true);
                        var fields = gradientField[index];
                        fields['selector'].setType(value);
                        return value;
                    }
                });

                if (!fields['angle']) fields['angle'] = {};

                fields['angle'].field = c.showInputField($typeContainer, 'gradient-angle-' + index, {
                    'type': 'select',
                    'name': 'Angle',
                    'without_icon': false,
                    'show_empty': true,
                    'action': 'custom',
                    'index': index,
                    'options': getGradientAngle(gradArr),
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value: function (obj, value, values, oldValue, eventType, fieldDef) {
                        var index = fieldDef.index;

                        var fields = gradientField[index];
                        fields['selector'].setDirection(value);

                        onAngleValueSet(value, index);
                        return value;
                    }
                });

                var $angleContainer = $('<div class="col-xs-4"></div>').appendTo($row);
                var $angleControl = $('<div class="angle-controls"></div>').appendTo($angleContainer);

                var $angleSelectorDiv = $('<div class="angle-selector"></div>').appendTo($angleControl);
                var $angleSelectorLabel = $('<label class="angle-value">0 deg</label>').appendTo($angleControl);

                fields['angle'].selector = $angleSelectorDiv;

                $angleSelectorDiv.data('index', index);
                $angleSelectorDiv.anglepicker({
                    move: function (e, ui) {
                        var $el = $(this);
                        var index = $el.data('index');
                        changeAngleValue(function () {
                            var newValue = anglepickerMove(ui.value, index);
                            $el.siblings('.angle-value').text(newValue + ' deg');
                        }, false, true);
                    },
                    change: function (e, ui) {
                        var $el = $(this);
                        var index = $el.data('index');
                        changeAngleValue(function () {
                            var newValue = anglepickerMove(ui.value, index);
                            $el.siblings('.angle-value').text(newValue + ' deg');
                        });
                    },
                    stop: function (e, ui) {
                        var $el = $(this);
                        var index = $el.data('index');
                        var fields = gradientField[index];

                        var value = getGradientAngleValue(ui.value);
                        fields['selector'].setDirection(value + 'deg', 1);
                    },
                    clockwise: false
                });


                fields['selector'] = new Grapick({
                    el: $gradient[0],
                    colorEl: '<input class="gradient-colorpicker"/>'
                });

                var addSpectrum = function (handler, $el) {
                    var spectrumHidden = function ($el, color) {
                        setTimeout(function () {
                            try {
                                $el.spectrum('destroy');
                                $el.hide();

                                var $colorPlaceholder = $el.siblings('.color-value-placeholder');

                                $colorPlaceholder.css('background-color', color);
                                $colorPlaceholder.show();
                            } catch (err) {}
                        }, 10)
                    }

                    $el.spectrum({
                        color: handler.getColor(),
                        appendTo: $el.closest('body'),
                        clickoutFiresChange: true,
                        showInitial: true,
                        showAlpha: true,
                        showInput: true,
                        allowEmpty: true,
                        preferredFormat: "hex",
                        change(color) {
                            handler.setColor(color.toRgbString());
                        },
                        move(color) {
                            colorPickerMoving = true;
                            handler.setColor(color.toRgbString(), 0);
                            $(this).data('currColor', color);
                            colorPickerMoving = false;
                        },
                        hide(color) {
                            var currColor = $(this).data('currColor');
                            if (currColor && currColor.toRgbString() != color.toRgbString()) {
                                handler.setColor(color.toRgbString());
                            }

                            spectrumHidden($el, color.toRgbString());
                        }
                    });

                    var pgSpectrumHelper = new PgSpectrumHelper($el, {
                        'mouse-moved': function ($el) {
                            var color = $el.spectrum('get');
                            handler.setColor(color.toRgbString());
                        },
                        'color-picked': null
                    });
                }

                fields['selector'].setColorPicker(function (handler) {
                    const el = handler.getEl().querySelector('.gradient-colorpicker');

                    var $el = $(el);
                    $el.hide();

                    var $colorPlaceholder = $('<div class="color-value-placeholder"></div>').insertAfter($el);
                    $colorPlaceholder.css('background-color', handler.color);

                    $colorPlaceholder.click(function (e) {
                        e.preventDefault();
                        var $el = $colorPlaceholder.siblings('.gradient-colorpicker');
                        $colorPlaceholder.hide();

                        addSpectrum(handler, $el);

                        $el.spectrum('show');
                        return false;
                    });

                    var getColorAlpha = function (color) {
                        var matched = color.match(/rgba\((.*)\)/);
                        if (matched && matched.length > 0) {
                            var params = matched[1].split(',');
                            if (params[3]) return params[3].trim();
                        }

                        return "1";
                    }

                    var setColorAlpha = function (color, value) {
                        var matched = color.match(/rgba\((.*)\)/);
                        if (matched && matched.length > 0) {
                            var params = matched[1].split(',');
                            params[3] = " 1";
                        }

                        return "rgba(" + params.join(',') + ")";
                    }

                    if (!fillingColorPicker) {
                        var bgColor = $colorPlaceholder.css('background-color');
                        if (getColorAlpha(bgColor) == "0") {
                            changeAngleValue(function () {
                                var color = setColorAlpha(bgColor, 1);
                                $colorPlaceholder.css('background-color', color);
                                handler.setColor(color);
                            }, true);
                        }
                    }
                });

                fields['selector'].on('change', function (complete, args) {
                    if (!skipGradientChange) {
                        var dispatchEvent = false;
                        if (!skipDispatchEvent) {
                            dispatchEvent = !colorPickerMoving || complete;
                        }

                        onGradientValueChange(dispatchEvent);
                        $container.removeClass('no-value');
                    }
                });

                gradientField[index] = fields;
            }

            var getMatched = function (value) {
                var grdRegex = new RegExp('(\\-[a-z]*\\-)?(.*)\\-gradient\\((.*)\\)');
                return value.match(grdRegex);
            }

            this.updateGradientValue = function (obj, values) {
                var gradientSettings = null;

                gradientProp = 'background-image';
                gradientSettings = getGradientSettings(values['background-image'], obj);
                if (!gradientSettings) {
                    gradientSettings = getGradientSettings(values['background'], obj);
                    if (gradientSettings) gradientProp = 'background';
                }

                // One gradient
                changeAngleValue(function () {
                    var fields = gradientField[0];
                    fields['selector'].clear();

                    if (gradientSettings) {
                        var settings = gradientSettings[0];
                        var values = {
                            points: settings.points,
                            type: settings.type,
                            angle: settings.angle
                        }

                        fillGradientValues(values, 0);
                        $container.removeClass('no-value');
                    } else {
                        $container.addClass('no-value');
                    }
                }, true);

                /* // Multi gradients
                lastId = 0;
                titleId = 1;
                changeAngleValue(function () {
                    panelInputControl.clear();

                    if (gradientSettings) {
                        for (var i = 0; i < gradientSettings.length; i++) {
                            var settings = gradientSettings[i];
                            var $body = panelInputControl.addPanel(lastId, titleId, true).$body;

                            var values = {
                                points: settings.points,
                                type: settings.type,
                                angle: settings.angle
                            }

                            addGradientFields($body, i);
                            fillGradientValues(values, i);

                            lastId++;
                            titleId++;
                        }


                    }

                    panelInputControl.getPanelGroup().find('> .panel:first-child > .panel-collapse').addClass('in');
                }, true);
                */
            }

            this.isGradient = function (value) {
                var matched = getMatched(value);

                if (matched && matched.length > 0) {
                    return true;
                }
                else {
                    return false;
                }
            }

            var getGradientSettings = function (value, obj) {
                if (!value) return null;
                var pgStylesheet = obj.pgStylesheet;

                var updatePointPosition = function (points) {
                    var length = points.length;
                    var hasPosition = [];

                    var getIndexData = function (index) {
                        var dataPos = {};

                        for (var i = 0; i < length; i++) {
                            if (hasPosition.indexOf(i) > -1) {
                                if (i < index) {
                                    dataPos.prev = i;
                                } else if (i > index) {
                                    dataPos.next = i;
                                    break;
                                }
                            }
                        }

                        return dataPos;
                        // for (var i = index + 1; i < length; i++) {
                        //     if (hasPosition.indexOf(i) > -1) return i;
                        // }
                    }

                    for (var i = 0; i < length; i++) {
                        if (!points[i].position) {
                            if (i == 0) {
                                points[i].position = 0;
                            } else if (i + 1 == length) {
                                points[i].position = 100;
                            }
                        }

                        if ($.isNumeric(points[i].position)) {
                            hasPosition.push(i);
                        }
                    }

                    if (hasPosition.length < length) {
                        for (var i = 0; i < length; i++) {
                            if (hasPosition.indexOf(i) == -1) {
                                var dataPos = getIndexData(i);

                                var prevId = dataPos.prev;
                                var nextId = dataPos.next;

                                var prevPos = points[prevId].position;
                                var nextPos = points[nextId].position;

                                var centerPos = (nextPos - prevPos) / (nextId - prevId);
                                points[i].position = centerPos + prevPos;

                                // points[i].position = (points[dataPos.prev].position + points[dataPos.next].position) / (dataPos.next - dataPos.prev);
                                hasPosition.push(i);
                            }
                        }
                    }

                    return points;
                }

                var getTerms = function (pointPos) {
                    var terms = [];
                    var allTerms = [];

                    var str = '';
                    var openBrackets = 0;

                    var addTerm = function (term, fullTerm) {
                        if (term) terms.push(term);

                        if (fullTerm) {
                            allTerms.push({
                                frTerm: terms[0],
                                sdTerm: terms[1]
                            });
                            terms = [];
                        }
                    }

                    var length = pointPos.length;
                    for (var i = 0; i < length + 1; i++) {
                        var char = pointPos[i];
                        if (char == ' ' || char == ',' || i == length) {
                            if (openBrackets == 0) {
                                var fullTerm = false;
                                if (char == ',' || i == length) {
                                    fullTerm = true;
                                }

                                addTerm(str, fullTerm);
                                str = '';
                                continue;
                            }
                        } else if (char == '(') {
                            openBrackets++;
                        } else if (char == ')') {
                            openBrackets--;
                        }

                        str += char;
                    }

                    return allTerms;
                }

                var getPointOptions = function (options) {
                    var points = [];
                    for (var i = 0; i < options.length; i++) {
                        var option = options[i];

                        points.push({
                            color: option.frTerm,
                            position: option.sdTerm
                        });
                    }

                    return points;
                    // return updatePointPosition(points);
                }

                var getDirection = function (angle, centered) {
                    var dirs = angle.split(' ');
                    if (dirs.length == 1) {
                        return dirs[0];
                    } else if (dirs.length == 2) {
                        if (dirs[0] == 'to') {
                            return dirs[1];
                        } else if (centered) {
                            if (dirs[0] == 'center') return dirs[1];
                            else return dirs[0];
                        }
                    }

                    return null;
                }

                var isColor = function (value) {
                    var newDiv = document.createElement("div");
                    newDiv.style.color = value;
                    if (newDiv.style.color) {
                        return true;
                    } else {
                        return false;
                    }
                }

                var getAngle = function (value, type) {
                    var newValue = getDirection(value, type != 'linear');
                    if (gradArr.indexOf(newValue) > -1 || newValue.endsWith('deg')) {
                        return newValue;
                    } else {
                        throw "Value is not an angle";
                    }
                }

                var getColor = function (value) {
                    if (!value) return null;

                    if (isColor(value)) {
                        return value;
                    } else {
                        throw "Value is not a color";
                    }
                }

                var getPosition = function (value) {
                    if (!value) return null;

                    var valueNumber = parseInt(value, 10);
                    value = isNaN(valueNumber) ? value : valueNumber;

                    if ($.isNumeric(value) || value === undefined) {
                        return value;
                    } else {
                        throw "Value is not a number.";
                    }
                }

                var getValue = function (rule, value) {
                    if (!value) return null;

                    if (pgStylesheet.isVarValue(value)) {
                        var nodeVarArr = pgStylesheet.smartGetAllUsedNodes(rule, true, value);
                        var nodeVar = nodeVarArr.nodes[0];
                        if (nodeVar) {
                            return nodeVar.value;
                        }
                    }

                    return value;
                }

                var getDeclValues = function (rule, points, fileType) {
                    for (var i = 0; i < points.length; i++) {
                        var point = points[i];

                        var color = null,
                            position = null;

                        if (fileType != 'css') {
                            color = getValue(rule, point.color);
                            position = getValue(rule, point.position);
                        } else {
                            color = point.color;
                            position = point.position;
                        }

                        points[i].color = getColor(color);
                        points[i].position = getPosition(position);
                    }

                    return points;
                }

                var getSettings = function (value) {
                    var settings = {
                        points: [],
                        type: '',
                        angle: ''
                    };

                    var matched = getMatched(value);

                    if (matched && matched.length > 0) {
                        settings['borowser'] = matched[1];
                        settings['type'] = matched[2];
                        var optionsStr = matched[3];

                        var terms = getTerms(optionsStr);


                        var rule = getRuleFromObj(obj).rule;
                        var frValue = getValue(rule, terms[0].frTerm);
                        var sdValue = getValue(rule, terms[0].sdTerm);
                        if (!isColor(frValue)) {
                            var angle = frValue + (sdValue ? ' ' + sdValue : '');

                            settings['angle'] = getAngle(angle, settings['type']);
                            terms.splice(0, 1);
                        } else {
                            settings['angle'] = 'top';
                        }

                        var pointOptions = getPointOptions(terms);

                        pointOptions = getDeclValues(rule, pointOptions, pgStylesheet.fileType);

                        settings['points'] = updatePointPosition(pointOptions);
                    }

                    return settings;
                }

                var getCleanValue = function (value) {
                    return value
                        .replace(/\n/g, ' ')
                        .replace(/\s+/g, ' ');
                }

                var grdSettings = [];

                try {
                    var pureValue = getCleanValue(value);

                    var terms = getTerms(pureValue);
                    for (var i = 0; i < terms.length; i++) {
                        var term = terms[i].frTerm;
                        grdSettings.push(getSettings(term));
                    }
                } catch (e) {
                    grdSettings = null;
                }

                return grdSettings;
            }

            c.onDefine = function () {}

            c.onShow = function () {
                $container = $('<div class="gradient-container no-value"><label>Gradient</label></div>');
                // One gradient
                addGradientFields($container, 0);

                /* // Multi gradient
                panelInputControl = new PgPanelInputControl($container, 'background-gradient', "Gradient");
                var $add = $('<a href="#" class="btn btn-default add-btn"><i class="icon icon-plus"></i> Add Gradient</a>').appendTo($container);

                panelInputControl.onAdd = function ($body, i) {
                    addGradientFields($body, i);
                }

                panelInputControl.onDelete = function (i) {
                    gradientField[i].deleted = true;
                    onGradientValueChange(true);
                    titleId--;
                }

                $add.on('click', function (e) {
                    addNewPanel();
                    e.preventDefault();
                });
                */

                return $container;
            }

            c.onSetValues = function () {
                _this.updateGradientValue(c.obj, c.values);
            }

            this.getControl = function () {
                return c;
            }
        }

        var gradientControl = new GradientControl();
        var shouldDispatchEvent = function (dispatchEvent, value, oldValue) {
            return dispatchEvent || (!value || !oldValue);
        }

        var valueHasImportant = function (value, important) {
            if (!value) {
                return {
                    value: '',
                    important: false
                };
            }

            if (value.indexOf('!important') > -1) {
                return {
                    value: value.replace(/!important/, '').trim(),
                    important: true
                }
            }

            return {
                value: value,
                important: important || false
            }
        }

        var delayed_tasks = new PgDelayedTasks();

        var highlightOnChanged = function(obj, prop, value, oldValue, fieldDef, $field, eventType, values, crsaPage) {
            if(fieldDef.highlight) {
                var page = pinegrow.getSelectedPage();
                if (page) {
                    try {
                        var rule = getRuleFromObj(obj).rule;

                        var elements = page.get$Html().find(rule.selector);
                        pinegrow.highlightElement(elements, null, true /* force update */);

                        delayed_tasks.run('unhighlightChange', function() {
                            pinegrow.highlightElement(null);
                        }, 1000)
                    }
                    catch (err) {
                    }
                }
            } else {
                pinegrow.highlightElement(null);
            }
        }

        var addCssColorDef = function (name, placeholder, extended) {
            extended = extended || {};

            return $.extend({}, {
                'name' : name,
                'placeholder': placeholder,
                'type': 'color',
                'without_text': true,
                'without_icon': true,
                highlight: true,
                'on_changed': highlightOnChanged
            }, extended);
        }

        var addCssNumberDef = function (name, placeholder, extended) {
            extended = extended || {};

            return $.extend({}, {
                'name' : name,
                //'placeholder': placeholder,
                'type': 'slider',
                //'slider_min': 0,
                'slider_max': 2000,
                'units': true,
                'without_text': true,
                'without_icon': true,
                'highlight': true,
                'on_changed': highlightOnChanged
            }, extended);
        }

        var addCssOptionsDef = function (name, placeholder, extended) {
            extended = extended || {};

            return $.extend({}, {
                'name' : name,
                'placeholder': placeholder,
                'type': 'select',
                'units': true,
                'without_text': true,
                'without_icon': true,
                highlight: true,
                'on_changed': highlightOnChanged
            }, extended);
        }

        var addCssTextDef = function (name, placeholder, extended) {
            extended = extended || {};

            return $.extend({}, {
                'name' : name,
                'placeholder': placeholder,
                'type': 'text',
                'without_text': true,
                'without_icon': true,
                highlight: true,
                'on_changed': highlightOnChanged
            }, extended);
        }

        var getCssBackgroundValue = function(values, sf, url) {
            var getUrls = function(v) {
                var a = splitCssValue(v, true);
                var r = [];
                for(var i = 0; i < a.length; i++) {
                    if(a[i] == ',') continue;
                    r.push(getUrlFromCssUrlValue(a[i]));
                }
                return r.join(", ");
            }

            var f = 'background-' + sf;
            var v = null;
            if(values && values[f]) {
                v = values[f].value;
                if(url) {
                    v = getUrls(v);
                }
            }/* else if(values['background']) {
             var cp = new CssBackgroundParser(values['background'].value);
             v = cp.getValue(f);
             if(url) {
             v = getUrls(v);
             }
             }*/
            return v;
        }

        var setCssBackgroundValue = function(obj, sf, v, values) {
            if (sf == 'image' && v && !gradientControl.isGradient(v)) {
                var a = v.split(",");
                v = '';
                for(var i = 0; i < a.length; i++) {
                    if(v.length > 0) v += ", ";
                    if(a[i].indexOf('@') >= 0) {
                        v += "url(" + a[i] + ")";
                    } else {
                        v += "url('" + a[i] + "')";
                    }
                }
            }

            var f = 'background-' + sf;
            // var values = getValuesFromObj(obj);
            if (values[f]) {
                commitObjValue(obj, f, v);
            } else {
                if (false && values['background']) {
                    var bckv = values['background'].value;
                    var cp = new CssBackgroundParser(bckv);

                    var list = ['color', 'image', 'repeat', 'attachment', 'position'];
                    $.each(list, function(i, listsf) {
                        var val = listsf == sf ? v : cp.getValue('background-' + listsf);
                        commitObjValue(obj, 'background-' + listsf, val, false, "skip", false);
                    });

                    commitObjValue(obj, 'background', null, false, "do");
                } else {
                    commitObjValue(obj, f, v);
                }
            }
        }

        var filterInherits = function(list, other) {
            if(!pgf.kids) return list;

            return list.filter(function(a) {
                return a.key !== 'inherit' && a.key !== 'initial' && (!other || other.indexOf(a.key) < 0);
            })
        }

        var addCssBackgroundDef = function(name, f, icon, getValueCallback, setValueCallback) {
            var type = 'text';
            switch(f) {
                case 'color':
                    type = 'color';
                    break;
                case 'repeat':
                case 'attachment':
                case 'origin':
                    type = 'select';
                    break;
                case 'position':
                case 'size':
                    type = 'slider';
                    break;
                case 'image':
                    type = 'image';
                    break;
                case 'position':
                case 'size':
                    type = 'slider';
                    break;
                default:
                    type = 'text';
                    break;
            }
            var d = {
                'type' : type,
                can_add_items: true,
                'name' : name,
                //'icon': icon,
                style_input: true,
                'action' : 'custom',
                file_picker_use_image_menu: pgf.kids || false,
                add_default_unit: '',
                get_value: function(obj, fn, styles) {
                    var isUrl = false;
                    if (f == "image") {
                        var bgImage = styles[fn] && styles[fn].value ? styles[fn].value : styles[fn];
                        if (bgImage && !gradientControl.isGradient(bgImage)) isUrl = true;
                    }

                    var newValue = getCssBackgroundValue(styles, f, isUrl);
                    if (getValueCallback) getValueCallback();
                    return newValue
                },
                set_value: function(obj, value, values, oldValue, eventType) {
                    setCssBackgroundValue(obj, f, value, values);
                    if (setValueCallback) setValueCallback(obj, value, values, oldValue, eventType);
                    return value;
                }
            };

            if (f == 'repeat') {
                d['show_empty'] = true;
                d['options'] = [
                    {key: 'repeat', name: 'Repeat'},
                    {key: 'no-repeat', name: 'No repeat'},
                    {key: 'repeat-x', name: 'Repeat X'},
                    {key: 'repeat-y', name: 'Repeat Y'}
                ];
            }

            if (f == 'attachment') {
                d['show_empty'] = true;
                d['can_add_items'] = true;
                d['append_new_to_list'] = false;
                d['options'] = [
                    {key: 'scroll', name: 'scroll'},
                    {key: 'fixed', name: 'fixed'},
                    {key: 'local', name: 'local'},
                    {key: 'initial', name: 'initial'},
                    {key: 'inherit', name: 'inherit'}
                ];
            }

            if (f == 'position') {
                //d['show_empty'] = true;
                //d['can_add_items'] = true;
                //d['append_new_to_list'] = false;
                d.slider_def_unit = 'px';
                d.open_list_on_focus = true;
                d['options'] = [
                    {key: 'left top', name: 'Left top'},
                    {key: 'left center', name: 'Left center'},
                    {key: 'left bottom', name: 'Left bottom'},
                    {key: 'right top', name: 'Right top'},
                    {key: 'right center', name: 'Right center'},
                    {key: 'right bottom', name: 'Right bottom'},
                    {key: 'center top', name: 'Center top'},
                    {key: 'center center', name: 'Center center'},
                    {key: 'center bottom', name: 'Center bottom'},
                    {key: 'initial', name: 'Initial'},
                    {key: 'inherit', name: 'Inherit'}
                ];
            }

            if (f == 'origin') {
                d['show_empty'] = true;
                d['can_add_items'] = true;
                d['append_new_to_list'] = false;
                d['options'] = [
                    {key: 'padding-box', name: 'Padding box'},
                    {key: 'border-box', name: 'Border box'},
                    {key: 'content-box', name: 'Content box'},
                    {key: 'initial', name: 'Initial'},
                    {key: 'inherit', name: 'Inherit'}
                ];
            }

            if (f == 'size') {
                //d['show_empty'] = true;
                //d['can_add_items'] = true;
                //d['append_new_to_list'] = false;
                d.slider_def_unit = 'px';
                d.open_list_on_focus = true;
                d['options'] = [
                    {key: 'auto', name: 'Auto'},
                    {key: 'cover', name: 'Cover'},
                    {key: 'contain', name: 'Contain'},
                    {key: 'initial', name: 'Initial'},
                    {key: 'inherit', name: 'Inherit'}
                ];
            }
            d.options && (d.options = filterInherits(d.options));
            return d;
        }



        var getCssUrlValue = function(values, f) {
            var getUrls = function(v) {
                var a = splitCssValue(v, true);
                var r = [];
                for(var i = 0; i < a.length; i++) {
                    if(a[i] == ',') continue;
                    r.push(getUrlFromCssUrlValue(a[i]));
                }
                return r.join(", ");
            }

            var v = null;
            if(values && values[f]) {
                v = values[f].value;
                v = getUrls(v);
            }
            return v;
        }

        var setCssUrlValue = function(obj, sf, v) {
            if (v) {
                var a = v.split(",");
                v = '';
                for (var i = 0; i < a.length; i++) {
                    if (v.length > 0) v += ", ";
                    if (a[i].indexOf('@') >= 0) {
                        v += "url(" + a[i] + ")";
                    } else {
                        v += "url('" + a[i] + "')";
                    }
                }
            }

            commitObjValue(obj, sf, v);
            return v;
        }

        var addShadowField = function ($body, f, i, control, fields, shadowRotation, shadowImportant) {
            var important = shadowImportant;

            var changeShadowRotation = function (e, ui) {
                var $boxShadowBody = $(this).closest('.panel-body');
                var rotation = $boxShadowBody.data(f + '-rotation');

                $(this).siblings('.angle-value').text(ui.value + ' deg');
                if (!rotation.skipUpdatingAngle) {
                    setCSSValueForShadow(control.obj, control.values, f, 'rotate', ui.value, shadowRotation.indexOf(rotation), shadowRotation, important);
                }
            };

            // Rotate, X & Y
            var $row = $('<div class="row direction-prop"></div>').appendTo($body);
            if (!shadowRotation[i]) shadowRotation[i] = {}
            shadowRotation[i].value = control.values[f + '-rotate-' + i] || 0;

            // X and Y
            var $xyCol = $('<div class="col-xs-8"></div>').appendTo($row);

            if (fields.indexOf('distance') > -1) {
                var distanceField = control.showInputField($xyCol, f + '-distance-' + i, addCssNumberDef("Distance", "Distance", {
                    'without_text': false,
                    'without_icon': true,
                   // 'icon': 'icon-distance',
                    'action' : 'custom',
                    'index': i,
                    'important': important,
                    'slider_def_unit': 'px',
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        return setCSSValueForShadow(obj, values, f, 'distance', value, fieldDef.index, shadowRotation, fieldDef.important);
                    }
                }));
            }

            if (fields.indexOf('x') > -1) {
                var $xDiv = $('<div class="' + f + '-x"></div>').appendTo($xyCol);
                var $xField = control.showInputField($xDiv, f + '-x-' + i, addCssNumberDef("X", "X", {
                    'action' : 'custom',
                    'without_text': false,
                    'without_icon': true,
                    //'icon': 'icon-originx',
                    'index': i,
                    'important': important,
                    'slider_def_unit': 'px',
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        var v = setCSSValueForShadow(obj, values, f, 'x', value, fieldDef.index, shadowRotation, fieldDef.important);
                        shadowRotation[fieldDef.index].skipUpdatingAngle = true;
                        shadowRotation[fieldDef.index].$el.anglepicker("value", shadowRotation[fieldDef.index].value);
                        shadowRotation[fieldDef.index].skipUpdatingAngle = false;
                        return v;
                    }
                }));
            }

            if (fields.indexOf('y') > -1) {
                var $yDiv = $('<div class="' + f + '-y"></div>').appendTo($xyCol);
                var $yField = control.showInputField($yDiv, f + '-y-' + i, addCssNumberDef("Y", "Y", {
                    'action' : 'custom',
                    'without_text': false,
                    'without_icon': true,
                   // 'icon': 'icon-originy',
                    'index': i,
                    'important': important,
                    'slider_def_unit': 'px',
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        var v = setCSSValueForShadow(obj, values, f, 'y', value, fieldDef.index, shadowRotation, fieldDef.important);
                        shadowRotation[fieldDef.index].skipUpdatingAngle = true;
                        shadowRotation[fieldDef.index].$el.anglepicker("value", shadowRotation[fieldDef.index].value);
                        shadowRotation[fieldDef.index].skipUpdatingAngle = false;
                        return v;
                    }
                }));
            }

            var $angleSelectorCol = $('<div class="col-xs-4"></div>').appendTo($row);
            if (fields.indexOf('rotate') > -1) {
                var $angleSelectorDiv = $('<div class="angle-selector"></div>').appendTo($angleSelectorCol);
                var $angleSelectorLabel = $('<label class="angle-value">' + shadowRotation[i].value + ' deg</label>').appendTo($angleSelectorCol);
                shadowRotation[i].$el = $angleSelectorDiv;

                $angleSelectorDiv.anglepicker({
                    change: changeShadowRotation,
                    move: changeShadowRotation,
                    stop: function(e, ui) {
                        var $boxShadowBody = $(this).closest('.panel-body');
                        var rotation = $boxShadowBody.data(f + '-rotation');

                        setCSSValueForShadow(control.obj, control.values, f, 'rotate', ui.value, shadowRotation.indexOf(rotation), shadowRotation, important);
                    },
                    value: shadowRotation[i].value
                });
            }

            if (fields.indexOf('nonetype') > -1) {
                var $typeField = control.showInputField($body, f + '-type-' + i, addCssShadowDefForType('select', 'Type', [
                    {
                        'key' : 'none',
                        'name' : 'None',
                        'html' : bm.makeIcon('overflow-X', { attributes: { 'title': 'None' } })
                        // 'html' : '<div class="pg-tb-button-text"><div class="icon-shadow-out"></div></div>'
                }], f, 'type', i, shadowRotation));
            }

            if (fields.indexOf('type') > -1) {
                var $typeField = control.showInputField($body, f + '-type-' + i, addCssShadowDefForType('select', 'Type', [
                    {
                        'key' : 'none',
                        'name' : 'None',
                        'html' : bm.makeIcon('overflow-X', { attributes: { 'title': 'None' } })
                        // 'html' : '<div class="pg-tb-button-text"><div class="icon-shadow-out"></div></div>'
                    },
                    {
                        'key' : 'outside',
                        'name' : 'Outside',
                        'html' : bm.makeIcon('shadow-out', { attributes: { 'title': 'Outside' } })
                        // 'html' : '<div class="pg-tb-button-text"><div class="icon-shadow-out"></div></div>'
                    },
                    {
                        'key' : 'inside',
                        'name' : 'Inside',
                        'html' : bm.makeIcon('shadow-in', { attributes: { 'title': 'Inside' } })
                        // 'html' : '<div class="pg-tb-button-text"><div class="icon-shadow-in"></div></div>'
                }], f, 'type', i, shadowRotation));
            }


            if (fields.indexOf('blur') > -1) {
                var $blurField = control.showInputField($body, f + '-blur-' + i, addCssNumberDef("Blur", "Blur", {
                    'without_text': false,
                    'without_icon': false,
                    'icon': 'icon-blur',
                    'action' : 'custom',
                    'index': i,
                    'important': important,
                    'slider_def_unit': 'px',
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        return setCSSValueForShadow(obj, values, f, 'blur', value, fieldDef.index, shadowRotation, fieldDef.important);
                    }
                }));
            }

            if (fields.indexOf('size') > -1) {
                var $sizeField = control.showInputField($body, f + '-size-' + i, addCssNumberDef("Size", "Size", {
                    'without_text': false,
                    'without_icon': false,
                    'icon': 'icon-shadow-size',
                    'action' : 'custom',
                    'index': i,
                    'important': important,
                    'slider_def_unit': 'px',
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        return setCSSValueForShadow(obj, values, f, 'size', value, fieldDef.index, shadowRotation, fieldDef.important);
                    }
                }));
            }

            if (fields.indexOf('color') > -1) {
                var $colorField = control.showInputField($body, f + '-color-' + i, addCssColorDef("Color", "Color", {
                    'without_text': false,
                    'without_icon': false,
                    'icon': 'icon-color',
                    'action' : 'custom',
                    'index': i,
                    'important': important,
                    get_value: function (obj) {
                        // nothing
                    },
                    set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                        return setCSSValueForShadow(obj, values, f, 'color', value, fieldDef.index, shadowRotation, fieldDef.important);
                    }
                }));
            }

            $body.data(f + '-rotation', shadowRotation[i]);
        }

        var addTransformTranslateFields = function ($filedsCon, control, i, important) {
            var $translateFields = $('<div class="translate-fileds"></div>').appendTo($filedsCon);

            var $xField = control.showInputField($translateFields, 'transform-translate-x-' + i, addCssNumberDef("X", "X", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_X',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'px',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'translate-x', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $yField = control.showInputField($translateFields, 'transform-translate-y-' + i, addCssNumberDef("Y", "Y", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Y',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'px',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'translate-y', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $zField = control.showInputField($translateFields, 'transform-translate-z-' + i, addCssNumberDef("Z", "Z", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Z',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'px',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'translate-z', value, fieldDef.index, fieldDef.important);
                }
            }));

            return $translateFields;
        }

        var addTransformScaleFields = function ($filedsCon, control, i, important) {
            var $scaleFields = $('<div class="scale-fileds"></div>').appendTo($filedsCon);

            var $xField = control.showInputField($scaleFields, 'transform-scale-x-' + i, addCssNumberDef("X", "X", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_X',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': '',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'scale-x', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $yField = control.showInputField($scaleFields, 'transform-scale-y-' + i, addCssNumberDef("Y", "Y", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Y',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': '',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'scale-y', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $zField = control.showInputField($scaleFields, 'transform-scale-z-' + i, addCssNumberDef("Z", "Z", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Z',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': '',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'scale-z', value, fieldDef.index, fieldDef.important);
                }
            }));

            return $scaleFields;
        }

        var addTransformRotateFields = function ($filedsCon, control, i, important) {
            var $rotateFields = $('<div class="rotate-fileds"></div>').appendTo($filedsCon);

            var $xField = control.showInputField($rotateFields, 'transform-rotate-x-' + i, addCssNumberDef("X", "X", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_X',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'deg',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'rotate-x', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $yField = control.showInputField($rotateFields, 'transform-rotate-y-' + i, addCssNumberDef("Y", "Y", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Y',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'deg',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'rotate-y', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $zField = control.showInputField($rotateFields, 'transform-rotate-z-' + i, addCssNumberDef("Z", "Z", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Z',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'deg',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'rotate-z', value, fieldDef.index, fieldDef.important);
                }
            }));

            return $rotateFields;
        }

        var addTransformSkewFields = function ($filedsCon, control, i, important) {
            var $skewFields = $('<div class="skew-fileds"></div>').appendTo($filedsCon);

            var $xField = control.showInputField($skewFields, 'transform-skew-x-' + i, addCssNumberDef("X", "X", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_X',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'deg',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'skew-x', value, fieldDef.index, fieldDef.important);
                }
            }));

            var $yField = control.showInputField($skewFields, 'transform-skew-y-' + i, addCssNumberDef("Y", "Y", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Transform_Y',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'deg',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransform(obj, values, 'skew-y', value, fieldDef.index, fieldDef.important);
                }
            }));

            return $skewFields;
        }

        var addTransformFields = function ($body, control, i, important) {
            var $typeField = control.showInputField($body, 'transform-type-' + i, addCssTransformDefForType('select', 'Type', [
                { 'key' : 'translate', 'name' : 'Translate', 'html' : bm.makeText('Trans.') },
                { 'key' : 'scale',     'name' : 'Scale',     'html' : bm.makeText('Scale') },
                { 'key' : 'rotate',    'name' : 'Rotate',    'html' : bm.makeText('Rotate') },
                { 'key' : 'skew',      'name' : 'Skew',      'html' : bm.makeText('Skew') }
            ], 'transform', 'type', i, true /* no label */, important));


            var $filedsCon = $('<div class="fields-container"></div>').appendTo($body);

            var $translateFields = addTransformTranslateFields($filedsCon, control, i, important).hide();
            var $scaleFields = addTransformScaleFields($filedsCon, control, i, important).hide();
            var $rotateFields = addTransformRotateFields($filedsCon, control, i, important).hide();
            var $skewFields = addTransformSkewFields($filedsCon, control, i, important).hide();

                 if (transformObjArr[i].type == "translate") $translateFields.show();
            else if (transformObjArr[i].type == "scale") $scaleFields.show();
            else if (transformObjArr[i].type == "rotate") $rotateFields.show();
            else if (transformObjArr[i].type == "skew") $skewFields.show();

            // transformObjArr[i].type = control.values['transform-type-' + i];

            $body.data('transform-el', transformObjArr[i]);
        }

        var addTransitionFields = function ($body, control, i, important) {
            var propertyField = control.showInputField($body, 'transition-property-' + i, addCssOptionsDef("Property", "Property", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Property',
                'action' : 'custom',
                'index': i,
                'important': important,
                'options': transitionProperties,
                'append_new_to_list': true,
                'can_add_items': true,
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransition(obj, 'property', value, fieldDef.index, fieldDef.important);
                }
            }));

            var durationField = control.showInputField($body, 'transition-duration-' + i, addCssNumberDef("Duration", "Duration", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Duration',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'ms',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransition(obj, 'duration', value, fieldDef.index, fieldDef.important);
                }
            }));

            var getFnNameAndParams = function (value) {
                var fnNameAndParams = {
                    name: '',
                    params: '0, 0, 1, 1'
                };
                if (value) {
                    fnNameAndParams = getCSSFunctionNameAndParams(value);
                }

                if (fnNameAndParams.params) {
                    var paramsArr = fnNameAndParams.params.split(',');

                    var x1 = parseFloat(paramsArr[0]), y1 = parseFloat(paramsArr[1]),
                        x2 = parseFloat(paramsArr[2]), y2 = parseFloat(paramsArr[3]);

                    fnNameAndParams.params = {
                        x1: x1, y1: y1,
                        x2: x2, y2: y2
                    };
                }

                return fnNameAndParams;
            }

            var timingFnField = control.showInputField($body, 'transition-timing-function-' + i, addCssTextDef("Timing funciton", "Timing fn", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Easing',
                'action' : 'custom',
                'index': i,
                'important': important,
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    var fnNameAndParams = getFnNameAndParams(value);
                    $cubicBezier.cubicBezier('setValue', fnNameAndParams.name, fnNameAndParams.params);

                    return setCSSValueForTransition(obj, 'timingFn', value, fieldDef.index, fieldDef.important);
                }
            }));
            timingFnField.$field.addClass('crsa-field-curve');

            var fnNameAndParams = { name: '', params: {x1: 0, y1: 0, x2: 1, y2: 1} }
            if (transitionObjArr[i] && transitionObjArr[i].timingFn) {
                fnNameAndParams = getFnNameAndParams(transitionObjArr[i].timingFn);
            }

            var curveUpdated = function (value) {
                var newValue = value.name;
                if (value.params) {
                    newValue += '(' + value.params.x1 + ', ' + value.params.y1 + ', ' + value.params.x2 + ', ' + value.params.y2 + ')'
                }
                timingFnField.setValue(newValue);
                setCSSValueForTransition(control.obj, 'timingFn', newValue, i, important);
            }

            var $crsaInput = timingFnField.$field.find('.crsa-input');
            var $cubicBezier = $('<input type="text">').appendTo($crsaInput);
            var pgCubicBezier = new PgCubicBezier($cubicBezier, {
                'width': 200,
                'height': 200,
                'static-point-size': 10,
                'movable-point-size': 10,
                'point-color': '#dc9146',
                'value': {
                    name: fnNameAndParams.name,
                    params: fnNameAndParams.params
                },
                move:   function (value) { curveUpdated(value); },
                change: function (value) { curveUpdated(value); },
                hide:   function (value) { curveUpdated(value); }
            });

            var delayField = control.showInputField($body, 'transition-delay-' + i, addCssNumberDef("Delay", "Delay", {
                'without_text': false,
                'without_icon': false,
                'icon': 'icon-Delay',
                'action' : 'custom',
                'index': i,
                'important': important,
                'slider_def_unit': 'ms',
                get_value: function (obj) {
                    // nothing
                },
                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                    return setCSSValueForTransition(obj, 'delay', value, fieldDef.index, fieldDef.important);
                }
            }));
        }

        var crsaBootstrapAddHtmlSections = function(addTo) {
            var s = {
                hidden : {
                    name : 'Hidden',
                    show : false,
                    fields : {
                        'media-query' : { type : 'media-query', name : 'Media query', action : 'rule_media', live_update : true },

                        'min-width' : { name : 'Min width', 'type': 'slider' , min: 0, max: 2000, units: true, 'show_empty' : true, on_changed: highlightOnChanged },
                        'max-width' : { name : 'Max width', 'type': 'slider' , min: 0, max: 2000, units: true, 'show_empty' : true, on_changed: highlightOnChanged },

                        'min-height' : { name : 'Min height', 'type': 'slider' , min: 0, max: 2000, units: true, on_changed: highlightOnChanged },
                        'max-height' : { name : 'Max height', 'type': 'slider' , min: 0, max: 2000, units: true, on_changed: highlightOnChanged },

                        'margin': { name : 'margin', 'type': 'slider' },
                        'margin-left': { name : 'margin left', 'type': 'slider' },
                        'margin-right': { name : 'margin right', 'type': 'slider' },
                        'margin-top': { name : 'margin top', 'type': 'slider' },
                        'margin-bottom': { name : 'margin bottom', 'type': 'slider' },

                        'padding': { name : 'margin', 'type': 'slider' },
                        'padding-left': { name : 'padding left', 'type': 'slider' },
                        'padding-right': { name : 'padding right', 'type': 'slider' },
                        'padding-top': { name : 'padding top', 'type': 'slider' },
                        'padding-bottom': { name : 'padding bottom', 'type': 'slider' },


                        left : { name : 'Left', 'type': 'slider', 'show_empty' : true, on_changed: highlightOnChanged},
                        right : { name : 'Right', 'type': 'slider', 'show_empty' : true, on_changed: highlightOnChanged},
                        top : { name : 'Top', 'type': 'slider', 'show_empty' : true, on_changed: highlightOnChanged},
                        bottom : { name : 'Bottom', 'type': 'slider', 'show_empty' : true, on_changed: highlightOnChanged},


                        'border' : {name : 'Border', type : 'slider', 'show_empty' : true},
                        'border-style' : {name : 'Border', type : 'slider', 'show_empty' : true},
                        'border-color' : {name : 'Border', type : 'slider', 'show_empty' : true},

                        'border-left': {name : 'Border left', type : 'slider', 'show_empty' : true},
                        'border-left-style': {name : 'Border left', type : 'slider', 'show_empty' : true},
                        'border-left-color': {name : 'Border left', type : 'slider', 'show_empty' : true},

                        'border-right': {name : 'Border right', type : 'slider', 'show_empty' : true},
                        'border-right-style': {name : 'Border right', type : 'slider', 'show_empty' : true},
                        'border-right-color': {name : 'Border right', type : 'slider', 'show_empty' : true},

                        'border-top': {name : 'Border top', type : 'slider', 'show_empty' : true},
                        'border-top-style': {name : 'Border top', type : 'slider', 'show_empty' : true},
                        'border-top-color': {name : 'Border top', type : 'slider', 'show_empty' : true},

                        'border-bottom': {name : 'Border bottom', type : 'slider', 'show_empty' : true},
                        'border-bottom-style': {name : 'Border bottom', type : 'slider', 'show_empty' : true},
                        'border-bottom-color': {name : 'Border bottom', type : 'slider', 'show_empty' : true},

                        'border-radius' : {name : 'Border radius', type : 'slider'},
                        'border-top-left-radius' : {name : 'Border top left radius', type : 'slider', 'show_empty' : true},
                        'border-top-right-radius' : {name : 'Border top right radius', type : 'slider', 'show_empty' : true},
                        'border-bottom-left-radius' : {name : 'Border bottom left radius', type : 'slider', 'show_empty' : true},
                        'border-bottom-right-radius' : {name : 'Border bottom right radius', type : 'slider', 'show_empty' : true},

                        'font-size' : {name : 'Size', type : 'slider'},
                        'line-height' : {name : 'Line height', type : 'slider', add_default_unit: ''},

                        'background-repeat' : addCssBackgroundDef("Repeat", 'repeat'),

                        'flex-grow' : {name : 'Grow', type : 'slider', add_default_unit: ''},
                        'flex-shrink' : {name : 'Shrink', type : 'slider', add_default_unit: ''},

                        'box-shadow' : {name: 'Box shadow', type: 'text'},
                        'text-shadow' : {name: 'Text shadow', type: 'text'},
                        'transform' : {name: 'Transform', type: 'text'},
                        'transition' : {name: 'Transition', type: 'text'}
                    }
                },
                /*
                media_query: {
                    name : 'Media query',
                    icons : true,
                    fields : {
                        media_rule : {
                            type: 'custom',
                            name: 'Media query',
                            action: 'none',
                            control: pgCreateMediaQueryControl
                        }
                    }
                },
                */
                text : {
                    name : 'Text',
                    get_has_data: cssPropsRe('text'),
                    icons : true,
                    fields : {
                        // 'font-family' : {name : 'Family', type : 'text', icon: 'icon-family'},
                        'font-family' : {
                            'name': 'Font family',
                            'type': 'select',
                            'show_empty': true,
                            'style_input': true,
                            'can_add_items': true,
                            'append_new_to_list': true,
                            'fill_list_on_open': true,
                            'async_options_function': true,
                            'options': function () {
                                if(pgf.kids) {

                                    var sans = [
                                        'Arial, Helvetica, sans-serif',
                                        '"Arial Black", Gadget, sans-serif',
                                        '"Comic Sans MS", cursive, sans-serif',
                                        'Impact, Charcoal, sans-serif',
                                        '"Lucida Sans Unicode", "Lucida Grande", sans-serif',
                                        'Tahoma, Geneva, sans-serif',
                                        '"Trebuchet MS", Helvetica, sans-serif',
                                        'Verdana, Geneva, sans-serif'
                                    ]

                                    var serif = [
                                        '"Times New Roman", Times, serif',
                                        '"Palatino Linotype", "Book Antiqua", Palatino, serif',
                                        'Georgia, serif'
                                    ]

                                    var mono = [
                                        '"Courier New", Courier, monospace',
                                        '"Lucida Console", Monaco, monospace'
                                    ]

                                    var r = [];

                                    var add = function(list, what) {
                                        r.push({
                                            name: what + ':',
                                            header: true
                                        })
                                        list.forEach(function(f) {
                                            f = f.replace(/"/g, `'`);
                                            r.push({
                                                key: f,
                                                name: f,
                                                html: `<span style="font-family:${f};">${f}</span>`
                                            })
                                        })
                                    }

                                    add(sans, 'Sans serif');
                                    add(serif, 'Serif');
                                    add(mono, 'Monospace');
                                    return r;

                                } else {
                                    var page = pinegrow.getSelectedPage();
                                    var existedFonts = getAttachedGoogleFonts(page);
                                    var fontOptions = [];

                                    var map = {}

                                    for (var i = 0; i < existedFonts.length; i++) {
                                        var fontObj = existedFonts[i];

                                        var cat = fontObj.category;
                                        if (cat == "handwriting" || cat == "display") cat = "cursive"

                                        const key = `'${fontObj.name}'${cat ? ", " + cat : ""}`;
                                        map[key] = true;

                                        fontOptions.push({
                                            key: key,
                                            name: fontObj.name
                                        })
                                    }

                                    if(pgDmStore) {
                                        var dp = pgDmStore.getActiveDesignProvider();
                                        if(dp) {
                                            dp.getActiveFonts().forEach(function(family) {
                                                if(!map[family]) {
                                                    var name = family;

                                                    var f = pinegrow.fontLibrary.getFontByFamily(family);
                                                    if(f) {
                                                        family = f.getFamilyWithFallback();
                                                    }

                                                    if(family.indexOf(' ') >= 0 && family.indexOf('"') < 0 && family.indexOf("'") < 0) {
                                                        family = `'${family}'`;
                                                    }

                                                    fontOptions.push({
                                                        key: family,
                                                        name: name,
                                                        html: `<span style="font-family:${family}">${name}</span> <small>(Design panel)</small>`
                                                    })
                                                }
                                            })
                                        }
                                    }

                                    fontOptions.push({
                                        key: 'font-manager',
                                        name: 'Manage Google Fonts...',
                                        action: function () {
                                            pinegrow.assetManager.show();
                                        }
                                    })

                                    return fontOptions;
                                }
                            }
                        },
                        'font-size_line-height_control' : {
                            type: 'custom',
                            name: 'Font size & Line height',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-font-size-line-height');

                                c.onDefine = function() {
                                    this.registerInputField('font-size', addCssNumberDef('Font size', ''));
                                    this.registerInputField('line-height', addCssNumberDef('Line height', '', {
                                        add_default_unit: ''
                                    }));
                                }

                                c.onShow = function() {
                                    var $container = $('<div class="crsa-grid-fields double-fields">\
                                        <table class="crsa-grid-table">\
                                            <tbody>\
                                                <tr>\
                                                </tr>\
                                            </tbody>\
                                        </table>\
                                    </div>');

                                    var $mainTr = $container.find('tr');
                                    var $td = $('<td class="crsa-td-empty-width"></td>').appendTo($mainTr);

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Size</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var fontSizeField = this.showInputField($td, 'font-size', addCssNumberDef('Font size', '', {style_input: true}));
                                    fontSizeField.$field.addClass('crsa-inline-container');

                                    $td = $('<td></td>').appendTo($mainTr);

                                    $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Height</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var maxWidth = this.showInputField($td, 'line-height', addCssNumberDef('Line height', '', {style_input: true, add_default_unit: '', slider_def_unit: 'px'}));
                                    maxWidth.$field.addClass('crsa-inline-container');

                                    return $container;
                                }

                                c.onSetValues = function() {
                                }

                                return c;
                            }
                        },
                        'color' : {
                            name: 'Color',
                            type: 'color',
                            style_input: true,
                            //icon: 'icon-color'
                        },
                        'font-weight': {
                            name: 'Weight',
                            type: 'select',
                            //icon: 'icon-weight',
                            show_empty: true,
                            style_input: true,
                            add_default_unit: '',
                            can_add_items: true,
                            append_new_to_list: true,
                            fill_list_on_open: true,
                            async_options_function: true,
                            options: function (fdef, obj) {
                                var page = pinegrow.getSelectedPage();
                                var existedFonts = getAttachedGoogleFonts(page);

                                var ruleAndCs = getRuleFromObj(obj);
                                var rule = ruleAndCs.rule;

                                var props = pgcssh.getChildrenDeclWithPropName(rule, 'font-family');
                                var lastFont = props[props.length - 1];

                                var fontWeightOptions = [];
                                if (lastFont) {
                                    for (var i = 0; i < existedFonts.length; i++) {
                                        var fontObj = existedFonts[i];
                                        var variantAdded = [];
                                        if (lastFont.value.indexOf(fontObj.name) > -1) {
                                            var variants = fontObj.included_varients;
                                            if (!variants || variants.length == 0) {
                                                variants = ["400", "700"];
                                            }

                                            for (var j = 0; j < variants.length; j++) {
                                                var variant = variants[j];
                                                if (variant.indexOf('italic') > -1) continue;

                                                if (variant == "regular") {
                                                    variant = 400;
                                                }

                                                var variantText = pinegrow.pgGoogleFontManager.getWeightText(variant, null);

                                                if (variantAdded.indexOf(variant) < 0) {
                                                    variantAdded.push(variant);
                                                    fontWeightOptions.push({
                                                        key: variant,
                                                        name: variantText
                                                    });
                                                }
                                            }
                                        }
                                    }
                                }

                                if (fontWeightOptions.length == 0) {
                                    if(pgf.kids) {
                                        fontWeightOptions = [
                                            {key: 'normal', name: 'Normal'},
                                            {key: 'bold', name: 'Bold'},
                                        ];
                                    } else {
                                        fontWeightOptions = [
                                            {key: 'normal', name: 'Normal'},
                                            {key: 'bold', name: 'Bold'},
                                            {key: 'lighter', name: 'Lighter'},
                                            {key: 'bolder', name: 'Bolder'},
                                            {key: '100', name: '100'},
                                            {key: '200', name: '200'},
                                            {key: '300', name: '300'},
                                            {key: '400', name: '400'},
                                            {key: '500', name: '500'},
                                            {key: '600', name: '600'},
                                            {key: '700', name: '700'},
                                            {key: '800', name: '800'},
                                            {key: '900', name: '900'},
                                            {key: 'inherit', name: 'Inherit'}
                                        ];
                                    }
                                }

                                return fontWeightOptions;
                            }
                        },
                        'letter-spacing' : {name : 'Spacing', type : 'slider', aaicon: 'icon-spacing', style_input: true},
                        'text-indent' : {name : 'Indent', type : 'slider', aaicon: 'icon-131', style_input: true},
                        'font-style' : {
                            'type' : 'select',
                            'name' : 'Style',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'normal',
                                    'name' : 'Normal',
                                    'html' : bm.makeIcon('style_normal', { attributes: { 'title': 'Normal' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-style_normal"></div></div>'
                                },
                                {
                                    'key' : 'italic',
                                    'name' : 'Italic',
                                    'html' : bm.makeIcon('style_italic', { attributes: { 'title': 'Italic' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-style_italic"></div></div>'
                                }
                            ]
                        },
                        'font-variant' : {
                            'type' : 'select',
                            'name' : 'Variant',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'normal',
                                    'name' : 'Normal',
                                    'html' : bm.makeText('Abc', {
                                        styles: {'font-family': 'serif', 'font-size': '15px'},
                                        attributes: {'font-family': 'serif', 'font-size': '15px', 'title': 'Normal'}
                                    })
                                },
                                {
                                    'key' : 'small-caps',
                                    'name' : 'Small caps',
                                    'html' : bm.makeText('Abc', {
                                        styles: {'font-family': 'serif', 'font-size': '15px', 'font-variant': 'small-caps'},
                                        attributes: {'title': 'Small caps'}
                                    })
                                }
                            ]
                        },
                        'text-decoration' : {
                            'type' : 'select',
                            'name' : 'Decoration',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'none',
                                    'name' : 'None',
                                    'html' : bm.makeIcon('decoration-none', { attributes: { 'title': 'None' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-decoration-none"></div></div>'
                                },
                                {
                                    'key' : 'underline',
                                    'name' : 'Underline',
                                    'html' : bm.makeIcon('decoration-under', { attributes: { 'title': 'Underline' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-decoration-under"></div></div>'
                                },
                                {
                                    'key' : 'overline',
                                    'name' : 'Overline',
                                    'html' : bm.makeIcon('decoration-over', { attributes: { 'title': 'Overline' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-decoration-over"></div></div>'
                                },
                                {
                                    'key' : 'line-through',
                                    'name' : 'Line through',
                                    'html' : bm.makeIcon('decoration-through', { attributes: { 'title': 'Line through' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-decoration-through"></div></div>'
                                }
                            ]
                        },
                        'text-transform' : {
                            'type' : 'select',
                            'name' : 'Transform',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'none',
                                    'name' : 'None',
                                    'html' : bm.makeIcon('Transform-none', { attributes: { 'title': 'None' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-Transform-none"></div></div>'
                                },
                                {
                                    'key' : 'capitalize',
                                    'name' : 'Capitalize',
                                    'html' : bm.makeIcon('Transform-sentence-case', { attributes: { 'title': 'Capitalize' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-Transform-sentence-case"></div></div>'
                                },
                                {
                                    'key' : 'uppercase',
                                    'name' : 'Uppercase',
                                    'html' : bm.makeIcon('Transform-uppercase', { attributes: { 'title': 'Uppercase' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-Transform-uppercase"></div></div>'
                                },
                                {
                                    'key' : 'lowercase',
                                    'name' : 'Lowercase',
                                    'html' : bm.makeIcon('Transform-lowercase', { attributes: { 'title': 'Lowercase' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-Transform-lowercase"></div></div>'
                                }
                            ]
                        },
                        'text-align' : {
                            'type' : 'select',
                            'name' : 'Align',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'left',
                                    'name' : 'Left',
                                    'html' : bm.makeIcon('align-left', { attributes: { 'title': 'Left' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-align-left"></div></div>'
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html' : bm.makeIcon('align-center', { attributes: { 'title': 'Center' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-align-center"></div></div>'
                                },
                                {
                                    'key' : 'right',
                                    'name' : 'Right',
                                    'html' : bm.makeIcon('align-right', { attributes: { 'title': 'Right' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-align-right"></div></div>'
                                },
                                {
                                    'key' : 'justify',
                                    'name' : 'Justify',
                                    'html' : bm.makeIcon('align-full', { attributes: { 'title': 'Justify' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-align-full"></div></div>'
                                }
                            ]
                        },
                        'writing-mode': {
                            'type': 'select',
                            'name': 'Writing mode',
                            'show_empty' : true,
                            'style_input': true,
                            'options': [
                                { key: 'horizontal-tb', name: 'Horizontal TB' },
                                { key: 'vertical-rl', name: 'Vertical RL' },
                                { key: 'vertical-lr', name: 'Vertical LR' }
                            ]
                        },
                        'white-space' : {
                            'type' : 'select',
                            'name' : 'White space',
                            'show_empty' : true,
                            'style_input': true,
                            'options' : [
                                {
                                    'key' : 'normal',
                                    'name' : 'Normal'
                                },
                                {
                                    'key' : 'nowrap',
                                    'name' : 'Nowrap'
                                },
                                {
                                    'key' : 'pre',
                                    'name' : 'Pre'
                                },
                                {
                                    'key' : 'pre-wrap',
                                    'name' : 'Pre wrap'
                                },
                                {
                                    'key' : 'pre-line',
                                    'name' : 'Pre line'
                                }
                            ]
                        },
                        'word-break' : {
                            'type' : 'select',
                            'name' : 'Word break',
                            'show_empty' : true,
                            'style_input': true,
                            'options' : [
                                {
                                    'key' : 'normal',
                                    'name' : 'Normal'
                                },
                                {
                                    'key' : 'break-all',
                                    'name' : 'Break all'
                                },
                                {
                                    'key' : 'keep-all',
                                    'name' : 'Keep all'
                                },
                                {
                                    'key' : 'break-word',
                                    'name' : 'Break word'
                                }
                            ]
                        },
                        'direction' : {
                            'type' : 'select',
                            'name' : 'Direction',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'ltr',
                                    'name' : 'Ltr',
                                    'html' : bm.makeText('Ltr', {
                                        'title': 'Left to Right'
                                    })
                                },
                                {
                                    'key' : 'rtl',
                                    'name' : 'Rtl',
                                    'html' : bm.makeText('Rtl', {
                                        'title': 'Right to Left'
                                    })
                                }
                            ]
                        }
                    }
                },
                'margin_and_padding' : {
                    name : 'Margin &amp; Padding',
                    get_has_data: cssPropsRe('margin_padding'),
                    fields: {
                        'margin_padding_control': {
                            type: 'custom',
                            name: 'margin_padding',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-margin-padding');
                                var $container = null;

                                var mBorder = {
                                    'margin-left': 10,
                                    'margin-right': 10,
                                    'margin-top': 20,
                                    'margin-bottom': 20,

                                    'padding-left': 13,
                                    'padding-right': -13,
                                    'padding-top': 10,
                                    'padding-bottom': 10
                                }

                                var mBorderLastValue = {
                                    'height': 60,
                                    'margin-left': 13,
                                    'margin-right': 13,
                                    'margin-top': 0,
                                    'margin-bottom': 0
                                }

                                var mIconLastValue = {
                                    'top': 16,
                                    'left': 50,
                                    'right': 50,
                                }

                                var marginPaddingFieldsInput = {
                                    'margin-top': null,
                                    'margin-bottom': null,
                                    'margin-right': null,
                                    'margin-left': null,

                                    'padding-top': null,
                                    'padding-bottom': null,
                                    'padding-right': null,
                                    'padding-left': null
                                }

                                var toggleIconActivation = function (e, type, control) {
                                    var $target = $(e.currentTarget);
                                    $target.toggleClass('active');
                                    marginPaddingBtnActive[type] = $target.hasClass('active');

                                    if (marginPaddingBtnActive[type]) {
                                        setCssValueForShorthandable(control.obj, type, '', '', true);
                                    }
                                }

                                var updatePaddingAndMarginView = function (type, direction, valueStr) {
                                    var oldValueStr = $container.data('old-' + type + '-' + direction + '-value');

                                    var value = parseInt(valueStr, 10);
                                    var oldValue = parseInt(oldValueStr, 10);

                                    if (valueStr == oldValueStr || value == oldValue) return;

                                    var $border = null,
                                        firstParam,
                                        secondParam,
                                        $icon = null,
                                        unit = 'px';
                                    var iconCurrValue = null;
                                    var iconDirection = direction;

                                    if (direction == "left" || direction == "right") unit = '%';

                                    if (type == "margin") {
                                        $border = $container.find('.margin-border');
                                        firstParam = 'padding-' + direction;
                                        secondParam = 'margin-' + direction;
                                    }
                                    else if (type == "padding") {
                                        $border = $container.find('.padding-border');
                                        firstParam = 'margin-' + direction;
                                        if (direction == 'top' || direction == 'bottom') {
                                            secondParam = 'height';
                                        }
                                        else if (direction == 'left' || direction == 'right') {
                                            secondParam = '';
                                        }
                                        if (direction == 'top'|| direction == 'right' || direction == 'left') {
                                            $icon = $border.find('.change-all-icon');
                                            if (direction == "top") {
                                                // iconCurrValue = parseInt($icon.css(direction), 10);
                                                iconCurrValue = mIconLastValue[direction];
                                            }
                                            else if (direction == "left") {
                                                iconCurrValue = mIconLastValue[direction];
                                            }
                                            else if (direction == "right") {
                                                iconDirection = "left";
                                                iconCurrValue = mIconLastValue[iconDirection];
                                            }
                                        }
                                    }

                                    var currValue = mBorderLastValue[secondParam];
                                    if (currValue == undefined && secondParam) currValue = parseInt($border.css(secondParam), 10);

                                    var newValue = mBorder[type + '-' + direction];

                                    if (value != oldValue) {
                                        if (value == 0) {
                                            $border.css(firstParam, 0);
                                            if (secondParam) {
                                                $border.css(secondParam, (currValue + newValue) + unit);
                                                mBorderLastValue[secondParam] = currValue + newValue;
                                            }
                                            if ($icon) {
                                                $icon.css(iconDirection, (iconCurrValue + newValue) + unit);
                                                mIconLastValue[iconDirection] = iconCurrValue + newValue;
                                            }
                                        }
                                        else if (parseInt($border.css(firstParam), 10) == 0) {
                                            $border.css(firstParam, '');
                                            if (secondParam) {
                                                $border.css(secondParam, (currValue - newValue) + unit);
                                                mBorderLastValue[secondParam] = currValue - newValue;
                                            }
                                            if ($icon) {
                                                $icon.css(iconDirection, (iconCurrValue - newValue) + unit);
                                                mIconLastValue[iconDirection] = iconCurrValue - newValue;
                                            }
                                        }
                                    }
                                }

                                var updatePaddingAndMarginValue = function(obj, type, dir, value, skipCommit, action, dispatchEvent) {
                                    var propName = type + (dir ? `-${dir}` : '');
                                    updatePaddingAndMarginView(type, dir, value);

                                    if (!skipCommit) {
                                        commitObjValue(obj, propName, value, false, action, dispatchEvent);
                                    }

                                    $container.data('old-' + propName + '-value', value);
                                }

                                var getMarginPaddingValueForDirectionFrom = function(value, direction) {
                                    var valImp = valueHasImportant(value);
                                    var valArray = valImp.value.split(' ');
                                    valArray = valArray.filter(function (val) { if (val) return true; return false; });


                                    var getValue = function (index) {
                                        return valArray[index] + (valImp.important ? ' !important' : '');
                                    }

                                    if (valArray.length == 4) {
                                        switch (direction) {
                                            case 'top':
                                                return getValue(0);
                                            case 'right':
                                                return getValue(1);
                                            case 'bottom':
                                                return getValue(2);
                                            case 'left':
                                                return getValue(3);
                                        }
                                    }
                                    else if (valArray.length == 3) {
                                        switch (direction) {
                                            case 'top':
                                                return getValue(0);
                                            case 'right':
                                            case 'left':
                                                return getValue(1);
                                            case 'bottom':
                                                return getValue(2);
                                        }
                                    }
                                    else if (valArray.length == 2) {
                                        switch (direction) {
                                            case 'top':
                                            case 'bottom':
                                                return getValue(0);
                                            case 'right':
                                            case 'left':
                                                return getValue(1);
                                        }
                                    }
                                    else if (valArray.length == 1) {
                                        return getValue(0);
                                    }

                                    return null;
                                }

                                var setCssValueForShorthandable = function(obj, type, direction, value, dispatchEvent) {
                                    if (dispatchEvent === undefined) dispatchEvent = true;

                                    var impValue = valueHasImportant(value);

                                    var $icon = marginPaddingObjs[type + '-$icon'];
                                    var isActive = $icon.hasClass('active');

                                    var directions = ['', 'top', 'left', 'right', 'bottom'];

                                    var ruleAndCs = getRuleFromObj(obj);
                                    var rule = ruleAndCs.rule;

                                    var valuesNum = [];
                                    for (var i = 0; i < directions.length; i++) {
                                        var dir = directions[i];
                                        var baseDir = dir ? `-${dir}` : '';
                                        if (!valuesNum[dir]) valuesNum[dir] = { important: false };

                                        var nodeInside = pinegrow.pgPostCSSHelper.findNodeInside('decl', 'prop', type + baseDir, rule);
                                        if (nodeInside) {
                                            if (dir == '') {
                                                var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);

                                                valuesNum[dir] = { value: nodeInsideValue.value };

                                                for (var j = 1; j < directions.length; j++) {
                                                    var currDir = directions[j];
                                                    valuesNum[currDir] = {
                                                        value: getMarginPaddingValueForDirectionFrom(nodeInsideValue.value, currDir),
                                                        important: nodeInsideValue.important,
                                                        native: false
                                                    }
                                                }
                                            }
                                            else {
                                                var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);
                                                valuesNum[dir] = {
                                                    value: nodeInsideValue.value,
                                                    important: nodeInsideValue.important,
                                                    native: true
                                                }
                                            }
                                        }
                                    }

                                    var top    = direction == 'top' ? impValue.value : valuesNum['top'].value;
                                    var left   = direction == 'left' ? impValue.value : valuesNum['left'].value;
                                    var right  = direction == 'right' ? impValue.value : valuesNum['right'].value;
                                    var bottom = direction == 'bottom' ? impValue.value : valuesNum['bottom'].value;

                                    var topImp    = direction == 'top' ? impValue.important : valuesNum['top'].important;
                                    var leftImp   = direction == 'left' ? impValue.important : valuesNum['left'].important;
                                    var rightImp  = direction == 'right' ? impValue.important : valuesNum['right'].important;
                                    var bottomImp = direction == 'bottom' ? impValue.important : valuesNum['bottom'].important;

                                    var removeDirections = [];
                                    var addDirections = {};

                                    var isSameImp = (topImp == leftImp && leftImp == rightImp && rightImp == bottomImp);
                                    var isOneNotUndefined = top || left || right || bottom;
                                    var isNotUndefined = top && left && right && bottom;

                                    var iconActive = (isActive && isOneNotUndefined);
                                    var allHasValue = (isSameImp && isNotUndefined);

                                    if (iconActive || allHasValue) {
                                        var isSameVal = (top == left && left == right && right == bottom);

                                        if (valuesNum['top'].native) removeDirections.push('top');
                                        if (valuesNum['left'].native) removeDirections.push('left');
                                        if (valuesNum['right'].native) removeDirections.push('right');
                                        if (valuesNum['bottom'].native) removeDirections.push('bottom');

                                        if (isActive || isSameVal) {
                                            var isImportant = topImp || leftImp || rightImp || bottomImp;

                                            addDirections['']  = (isActive && direction ? impValue.value : (top || left || right || bottom))
                                            addDirections[''] += (isActive && direction) ? (impValue.important ? ' !important' : '') : (isImportant ? ' !important' : '');
                                        }
                                        else {
                                            addDirections[''] = `${top} ${right}`;
                                            if (top != bottom || left != right) {
                                                addDirections[''] += ` ${bottom}`;

                                                if (left != right) {
                                                    addDirections[''] += ` ${left}`;
                                                }
                                            }

                                            addDirections[''] += topImp ? ' !important' : '';
                                        }
                                    }
                                    else {
                                        if (valuesNum[''].value) {
                                            removeDirections.push('');

                                            valuesNum['top'].forceDispatch = true;
                                            valuesNum['left'].forceDispatch = true;
                                            valuesNum['right'].forceDispatch = true;
                                            valuesNum['bottom'].forceDispatch = true;

                                            addDirections['top'] = top + (topImp ? ' !important' : '');
                                            addDirections['left'] = left + (leftImp ? ' !important' : '');
                                            addDirections['right'] = right + (rightImp ? ' !important' : '');
                                            addDirections['bottom'] = bottom + (bottomImp ? ' !important' : '');
                                        }
                                        else {
                                            if (direction == 'top') addDirections['top'] = top + (topImp ? ' !important' : '');
                                            else if (direction == 'left') addDirections['left'] = left + (leftImp ? ' !important' : '');
                                            else if (direction == 'right') addDirections['right'] = right + (rightImp ? ' !important' : '');
                                            else if (direction == 'bottom') addDirections['bottom'] = bottom + (bottomImp ? ' !important' : '');
                                        }
                                    }

                                    var removeDirLength = removeDirections.length;
                                    for (var i = 0; i < removeDirLength; i++) {
                                        var dir = removeDirections[i];

                                        var action = 'skip';
                                        if (i + 1 == removeDirLength && addDirections.length == 0) {
                                            action = 'do';
                                        }

                                        updatePaddingAndMarginValue(obj, type, dir, null, false, action, true);
                                    }

                                    var dirKeys = Object.keys(addDirections);
                                    var keysLength = dirKeys.length
                                    for (var i = 0; i < keysLength; i++) {
                                        var dir = dirKeys[i];
                                        var dirValue = addDirections[dir];

                                        if (dirValue !== undefined) {
                                            var action = 'skip';
                                            if (i + 1 == keysLength) {
                                                action = 'do';
                                            }

                                            var oldValue = valuesNum[dir].value;
                                            if (valuesNum[dir].forceDispatch) oldValue = null;
                                            var dispatchNow = shouldDispatchEvent(dispatchEvent, dirValue, oldValue);
                                            commitObjValue(obj, type + (dir ? `-${dir}` : ''), dirValue, false, action, dispatchNow);

                                            if (dir == '') {
                                                for (var j = 1; j < directions.length; j++) {
                                                    var currDir = directions[j];
                                                    var currValue = getMarginPaddingValueForDirectionFrom(dirValue, currDir);

                                                    updatePaddingAndMarginValue(obj, type, currDir, currValue, true);
                                                    if(currDir === direction) continue; //skip changing the edited field
                                                    //return currValue;
                                                    //disable CssStyleInput helper when setting the rest of the fields
                                                    var orig_on_set_field_value = marginPaddingFieldsInput[type + '-' + currDir].def.on_set_field_value;
                                                    marginPaddingFieldsInput[type + '-' + currDir].def.on_set_field_value = null;
                                                    marginPaddingFieldsInput[type + '-' + currDir].setValue(currValue);
                                                    marginPaddingFieldsInput[type + '-' + currDir].def.on_set_field_value = orig_on_set_field_value;
                                                }
                                            }
                                            else {
                                                updatePaddingAndMarginValue(obj, type, dir, dirValue, true);
                                                //marginPaddingFieldsInput[type + '-' + dir].setValue(dirValue);
                                                return dirValue;
                                            }
                                        }
                                    }

                                    return value;
                                }

                                var addCssShorthandableDef = function(name, placeholder, f, sf, control, base_on_equal) {
                                    return {
                                        'type' : 'slider',
                                        'name' : name,
                                        // 'placeholder': placeholder,
                                        'action' : 'custom',
                                        'without_text': true,
                                        'without_icon': true,
                                        'show_empty' : true,
                                        'style_input': true,
                                        get_value: function(obj) {
                                            var value = getCssValueForShorthandable(control.values, f, sf, base_on_equal);
                                            return value;
                                        },
                                        set_value: function(obj, value, values, oldValue, eventType) {
                                            var newValue = setCssValueForShorthandable(obj, f, sf, value, eventType === 'change');
                                            return newValue;
                                        },
                                        on_changed: highlightOnChanged
                                    }
                                }

                                marginPaddingObjs = {
                                    'margin-top': {
                                        fdef: $.extend({}, addCssShorthandableDef("Margin top", "Top", "margin", "top", this), {
                                        }),
                                        $el: null
                                    },
                                    'margin-left': {
                                        fdef: $.extend({}, addCssShorthandableDef("Margin left", "Left", "margin", "left", this), {
                                        }),
                                        $el: null
                                    },
                                    'padding-top': {
                                        fdef: $.extend({}, addCssShorthandableDef("Padding top", "Top", "padding", "top", this), {
                                            slider_min: 0,
                                        }),
                                        $el: null
                                    },
                                    'padding-left': {
                                        fdef: $.extend({}, addCssShorthandableDef("Padding left", "Left", "padding", "left", this), {
                                            slider_min: 0,
                                        }),
                                        $el: null
                                    },
                                    'padding-right': {
                                        fdef: $.extend({}, addCssShorthandableDef("Padding right", "Right", "padding", "right", this), {
                                            slider_min: 0,
                                        }),
                                        $el: null
                                    },
                                    'padding-bottom': {
                                        fdef: $.extend({}, addCssShorthandableDef("Padding bottom", "Bottom", "padding", "bottom", this), {
                                            slider_min: 0,
                                        }),
                                        $el: null
                                    },
                                    'margin-right': {
                                        fdef: $.extend({}, addCssShorthandableDef("Margin right", "Right", "margin", "right", this), {
                                        }),
                                        $el: null
                                    },
                                    'margin-bottom': {
                                        fdef: $.extend({}, addCssShorthandableDef("Margin bottom", "Bottom", "margin", "bottom", this), {
                                        }),
                                        $el: null
                                    }
                                }

                                var setValueFromControl = function (values) {
                                    var propType = ['margin', 'padding'];
                                    var directions = ['top', 'bottom', 'left', 'right'];

                                    for (var i = 0; i < propType.length; i++) {
                                        for (var j = 0; j < directions.length; j++) {
                                            var value = getCssValueForShorthandable(values, propType[i], directions[j]);
                                            marginPaddingObjs[propType[i] + '-' + directions[j]].value = value;
                                            if (value) {
                                                values[propType[i] + '-' + directions[j]] = { value: value };
                                            }
                                        }
                                    }
                                }

                                c.onDefine = function() {
                                    for (var mp in marginPaddingObjs) {
                                        this.registerInputField(mp, marginPaddingObjs[mp].fdef);
                                    }
                                }

                                c.onShow = function() {
                                    var _this = this;
                                    $container = $('<div class="margin-and-padding-container text-center"></div>');

                                    var values = getValuesFromObj(this.obj);
                                    setValueFromControl(values);

                                    // Margin top
                                    var marginTop = this.showInputField($container, 'margin-top', marginPaddingObjs['margin-top'].fdef);
                                    marginPaddingObjs['margin-top'].$el = marginTop.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['margin-top'] = marginTop;

                                    // Margin left
                                    var marginLeft = this.showInputField($container, 'margin-left', marginPaddingObjs['margin-left'].fdef);
                                    marginPaddingObjs['margin-left'].$el = marginLeft.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['margin-left'] = marginLeft;

                                    var $marginBorder = $('<div class="margin-border"></div>').appendTo($container);

                                    var $marginIcon = $('<div class="change-all-margin-icon change-all-icon">\
                                                            <i class="icon-same"></i>\
                                                        </div>').appendTo($marginBorder);

                                    addTooltip($marginIcon, 'Use the same margin on all four sides.')

                                    marginPaddingObjs['margin-$icon'] = $marginIcon;
                                    $marginIcon.on('click', function (e) {
                                        toggleIconActivation(e, 'margin', _this);
                                    });

                                    var $paddingContainer = $('<div class="padding-container"></div>').appendTo($marginBorder);

                                    // Padding top
                                    var paddingTop = this.showInputField($paddingContainer, 'padding-top', marginPaddingObjs['padding-top'].fdef);
                                    marginPaddingObjs['padding-top'].$el = paddingTop.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['padding-top'] = paddingTop;

                                    // Padding left
                                    var paddingLeft = this.showInputField($paddingContainer, 'padding-left', marginPaddingObjs['padding-left'].fdef);
                                    marginPaddingObjs['padding-left'].$el = paddingLeft.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['padding-left'] = paddingLeft;

                                    var $paddingIcon = $('<div class="padding-border">\
                                        <div class="change-all-padding-icon change-all-icon"><i class="icon-same"></i></div>\
                                    </div>').appendTo($paddingContainer).find('> .change-all-icon');

                                    addTooltip($paddingIcon, 'Use the same padding on all four sides.')

                                    marginPaddingObjs['padding-$icon'] = $paddingIcon;
                                    $paddingIcon.on('click', function (e) {
                                        toggleIconActivation(e, 'padding', _this);
                                    });

                                    // Padding right
                                    var paddingRight = this.showInputField($paddingContainer, 'padding-right', marginPaddingObjs['padding-right'].fdef);
                                    marginPaddingObjs['padding-right'].$el = paddingRight.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['padding-right'] = paddingRight;

                                    // Padding bottom
                                    var paddingBottom = this.showInputField($paddingContainer, 'padding-bottom', marginPaddingObjs['padding-bottom'].fdef);
                                    marginPaddingObjs['padding-bottom'].$el = paddingBottom.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['padding-bottom'] = paddingBottom;

                                    // Margin right
                                    var marginRight = this.showInputField($container, 'margin-right', marginPaddingObjs['margin-right'].fdef);
                                    marginPaddingObjs['margin-right'].$el = marginRight.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['margin-right'] = marginRight;

                                    // Margin bottom
                                    var marginBottom = this.showInputField($container, 'margin-bottom', marginPaddingObjs['margin-bottom'].fdef);
                                    marginPaddingObjs['margin-bottom'].$el = marginBottom.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                    marginPaddingFieldsInput['margin-bottom'] = marginBottom;

                                    return $container;
                                }

                                c.onSetValues = function() {
                                    var values = getValuesFromObj(this.obj);
                                    setValueFromControl(values);

                                    for (var mp in marginPaddingObjs) {
                                        var value = null;
                                        // value = marginPaddingObjs[mp].value || null; //Added by MT
                                        if (values[mp]) {
                                            value = values[mp].value || values[mp];
                                        }

                                        var arr = mp.split('-');
                                        var $el = marginPaddingObjs[mp].$el;
                                        if ($el) {
                                            marginPaddingFieldsInput[mp].setValue(value);
                                            updatePaddingAndMarginView(arr[0], arr[1], value);
                                        }
                                        if ($container) $container.data('old-' + mp + '-value', value);
                                    }

                                    var types = ['margin', 'padding'];

                                    for (var i = 0; i < types.length; i++) {
                                        var type = types[i];
                                        var top = marginPaddingObjs[type + '-top'].value;
                                        var left = marginPaddingObjs[type + '-left'].value;
                                        var right = marginPaddingObjs[type + '-right'].value;
                                        var bottom = marginPaddingObjs[type + '-bottom'].value;

                                        if (top && top == left && left == right && right == bottom) {
                                            marginPaddingObjs[type + '-$icon'].addClass('active');
                                            marginPaddingBtnActive[type] = true;
                                        }
                                        else {
                                            marginPaddingObjs[type + '-$icon'].removeClass('active');
                                            marginPaddingBtnActive[type] = false;
                                        }
                                    }
                                }

                                return c;
                            }
                        }
                    }
                },

                dimension : {
                    name : 'Dimension',
                    icons : true,
                    get_has_data: cssPropsRe('dimension'),
                    fields : {
                        width : {
                            name : 'Width',
                            type: 'slider',
                            min: 0,
                            max: 2000,
                            icon: 'icon-width',
                            units: true,
                            on_changed: highlightOnChanged,
                            highlight: true,
                            style_input: true
                        },
                        'max_min_width_control' : {
                            type: 'custom',
                            name: 'Min/Max Width',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-min-max-width');

                                c.onDefine = function() {
                                    this.registerInputField('min-width', addCssNumberDef('Min width', ''));
                                    this.registerInputField('max-width', addCssNumberDef('Max width', ''));
                                }

                                c.onShow = function() {
                                    var $container = $('<div class="crsa-grid-fields double-fields">\
                                        <table class="crsa-grid-table">\
                                            <tbody>\
                                                <tr>\
                                                </tr>\
                                            </tbody>\
                                        </table>\
                                    </div>');

                                    var $mainTr = $container.find('tr');
                                    var $td = $('<td class="crsa-td-empty-width"></td>').appendTo($mainTr);

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Min.</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var minWidth = this.showInputField($td, 'min-width', addCssNumberDef('Min width', '', {highlight: true, style_input: true}));
                                    minWidth.$field.addClass('crsa-inline-container');

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Max.</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var maxWidth = this.showInputField($td, 'max-width', addCssNumberDef('Max width', '', {highlight: true, style_input: true}));
                                    maxWidth.$field.addClass('crsa-inline-container');

                                    return $container;
                                }

                                c.onSetValues = function() {
                                }

                                return c;
                            }
                        },

                        height : {
                            name : 'Height',
                            type: 'slider' ,
                            min: 0,
                            max: 2000,
                            icon: 'icon-height',
                            units: true,
                            on_changed: highlightOnChanged,
                            highlight: true,
                            style_input: true
                        },
                        'max_min_height_control' : {
                            type: 'custom',
                            name: 'Min/Max Height',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-min-max-height');

                                c.onDefine = function() {
                                    this.registerInputField('min-height', addCssNumberDef('Min height', ''));
                                    this.registerInputField('max-height', addCssNumberDef('Max height', ''));
                                }

                                c.onShow = function() {
                                    var $container = $('<div class="crsa-grid-fields double-fields">\
                                        <table class="crsa-grid-table">\
                                            <tbody>\
                                                <tr>\
                                                </tr>\
                                            </tbody>\
                                        </table>\
                                    </div>');

                                    var $mainTr = $container.find('tr');
                                    var $td = $('<td class="crsa-td-empty-width"></td>').appendTo($mainTr);

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Min.</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var minHeight = this.showInputField($td, 'min-height', addCssNumberDef('Min height', '', {highlight: true, style_input: true}));
                                    minHeight.$field.addClass('crsa-inline-container');

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Max.</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var maxHeight = this.showInputField($td, 'max-height', addCssNumberDef('Max height', '', {highlight: true, style_input: true}));
                                    maxHeight.$field.addClass('crsa-inline-container');

                                    return $container;
                                }

                                c.onSetValues = function() {
                                }

                                return c;
                            }
                        }
                    }
                },

                display_prop : {
                    name : 'Display',
                    get_has_data: cssPropsRe('display'),
                    fields : {
                        'display' : {
                            name : 'Display',
                            type : 'select',
                            can_add_items: true,
                            show_empty: true,
                            style_input: true,
                            options:[
                                {key:'none', name:'None'},
                                {key:'inline', name:'Inline'},
                                {key:'block', name:'Block'},
                                {key:'list-item', name:'List item'},
                                {key:'inline-block', name:'Inline block'},
                                {key:'inline-table', name:'Inline table'},
                                {key:'table', name:'Table'},
                                {key:'table-cell', name:'Table cell'},
                                {key:'table-column', name:'Table column'},
                                {key:'table-column-group', name:'Table column group'},
                                {key:'table-footer-group', name:'Table footer group'},
                                {key:'table-header-group', name:'Table header group'},
                                {key:'table-row', name:'Table row'},
                                {key:'table-row-group', name:'Table row group'},
                                {key:'flex', name:'Flex'},
                                {key:'inline-flex', name:'Inline flex'},
                                {key:'grid', name:'Grid'},
                                {key:'inline-grid', name:'Inline grid'},
                                {key:'run-in', name:'Run in'},
                                {key:'inherit', name:'Inherit'}
                            ]
                        },
                        'visibility' : {
                            name : 'Visibility',
                            can_add_items: true,
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            options:[
                                {key:'visible', name:'Visible'},
                                {key:'hidden',  name:'Hidden'},
                                {key:'collapse',name:'Collapse'},
                                {key:'inherit', name:'Inherit'}
                            ]
                        },
                        'vertical-align' : {
                            name : 'Vertical align',
                            can_add_items: true,
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            options:[
                                {key:'baseline',    name:'Baseline'},
                                {key:'sub',         name:'Sub'},
                                {key:'super',       name:'Super'},
                                {key:'text-top',    name:'Text top'},
                                {key:'text-bottom', name:'Text bottom'},
                                {key:'middle',      name:'Middle'},
                                {key:'top',         name:'Top'},
                                {key:'bottom',      name:'Bottom'},
                                {key:'inherit',     name:'Inherit'}
                            ]
                        },
                        'resize': {
                            type: 'select',
                            name: 'Resize',
                            show_empty: true,
                            style_input: true,
                            options: [
                                { key: 'none', name: 'None' },
                                { key: 'both', name: 'Both' },
                                { key: 'horizontal', name: 'Horizontal' },
                                { key: 'vertical', name: 'Vertical' },
                                { key: 'initial', name: 'Initial' },
                                { key: 'inherit', name: 'Inherit' },
                            ]
                        },
                        'overflow' : {
                            'type' : 'select',
                            'name' : 'Overflow',
                            'show_empty' : true,
                            'toggle_buttons' : true,
                            'style_input': true,
                            'options' : [
                                {
                                    'key' : 'hidden',
                                    'name' : 'Hidden',
                                    'html' : bm.makeIcon('overflow-X', { attributes: { 'title': 'Hidden' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-overflow-X"></div></div>'
                                },
                                {
                                    'key' : 'auto',
                                    'name' : 'Auto',
                                    'html' : bm.makeIcon('overflow-A', { attributes: { 'title': 'Auto' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-overflow-A"></div></div>'
                                },
                                {
                                    'key' : 'scroll',
                                    'name' : 'Scroll',
                                    'html' : bm.makeIcon('overflow-S', { attributes: { 'title': 'Scroll' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-overflow-S"></div></div>'
                                }
                            ]
                        },
                        float : {
                            'type' : 'select',
                            'name' : 'Float',
                            'show_empty' : true,
                            'toggle_buttons' : true,
                            'style_input': true,
                            'options' : [
                                {
                                    'key' : 'none',
                                    'name' : 'None',
                                    'html' : bm.makeIcon('float', { attributes: { 'title': 'None' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float"></div></div>'
                                },
                                {
                                    'key' : 'left',
                                    'name' : 'Left',
                                    'html' : bm.makeIcon('float-left"', { attributes: { 'title': 'Left' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float-left"></div></div>'
                                },
                                {
                                    'key' : 'right',
                                    'name' : 'Right',
                                    'html' : bm.makeIcon('float-right', { attributes: { 'title': 'Right' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float-right"></div></div>'
                                }
                            ]
                        },
                        clear : {
                            'type' : 'select',
                            'name' : 'Clear',
                            'show_empty' : true,
                            'toggle_buttons' : true,
                            'style_input': true,
                            'options' : [
                                {
                                    'key' : 'both',
                                    'name' : 'Both',
                                    'html' : bm.makeIcon('float', { attributes: { 'title': 'Both' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float"></div></div>'
                                },
                                {
                                    'key' : 'left',
                                    'name' : 'Left',
                                    'html' : bm.makeIcon('float-left', { attributes: { 'title': 'Left' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float-left"></div></div>'
                                },
                                {
                                    'key' : 'right',
                                    'name' : 'Right',
                                    'html' : bm.makeIcon('float-right', { attributes: { 'title': 'Right' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-float-right"></div></div>'
                                }
                            ]
                        },
                        'box-sizing': {
                            name: 'Box sizing',
                            type: 'select',
                            show_empty: true,
                            style_input: true,
                            options: [
                                { key: 'content-box', name: 'Content box' },
                                { key: 'border-box', name: 'Border box' },
                                { key: 'initial', name: 'Initial' },
                                { key: 'inherit', name: 'Inherit' }
                            ]
                        },
                        opacity: {
                            name : 'Opacity',
                            'type': 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            slider_step: 0.1,
                            slider_min: 0,
                            slider_max: 1,
                            add_default_unit: ''
                        },
                        'cursor': {
                            name: 'Cursor',
                            type: 'select',
                            show_empty: true,
                            style_input: true,
                            can_add_items: true,
                            options: [
                                { key: 'default', name: 'Default' },
                                { key: 'none', name: 'None' },
                                { key: 'alias', name: 'Alias' },
                                { key: 'all-scroll', name: 'All scroll' },
                                { key: 'auto', name: 'Auto' },
                                { key: 'cell', name: 'Cell' },
                                { key: 'context-menu', name: 'Context menu' },
                                { key: 'col-resize', name: 'Col resize' },
                                { key: 'copy', name: 'Copy' },
                                { key: 'crosshair', name: 'Crosshair' },
                                { key: 'e-resize', name: 'E resize' },
                                { key: 'ew-resize', name: 'EW resize' },
                                { key: 'grab', name: 'Grab' },
                                { key: 'grabbing', name: 'Grabbing' },
                                { key: 'help', name: 'Help' },
                                { key: 'move', name: 'Move' },
                                { key: 'n-resize', name: 'N resize' },
                                { key: 'ne-resize', name: 'Ne resize' },
                                { key: 'nesw-resize', name: 'NESW resize' },
                                { key: 'ns-resize', name: 'NS resize' },
                                { key: 'nw-resize', name: 'NW resize' },
                                { key: 'nwse-resize', name: 'NWSE resize' },
                                { key: 'no-drop', name: 'No drop' },
                                { key: 'not-allowed', name: 'Not allowed' },
                                { key: 'pointer', name: 'Pointer' },
                                { key: 'progress', name: 'Progress' },
                                { key: 'row-resize', name: 'Row resize' },
                                { key: 's-resize', name: 'S resize' },
                                { key: 'se-resize', name: 'SE resize' },
                                { key: 'sw-resize', name: 'SW resize' },
                                { key: 'text', name: 'Text' },
                                { key: 'w-resize', name: 'W resize' },
                                { key: 'wait', name: 'Wait' },
                                { key: 'zoom-in', name: 'Zoom in' },
                                { key: 'zoom-out', name: 'Zoom out' }
                            ]
                        },
                        'object-fit' : {
                            name : 'Object fit',
                            can_add_items: true,
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            options:[
                                {key:'fill', name:'Fill'},
                                {key:'contain', name:'Contain'},
                                {key:'cover', name:'Cover'},
                                {key:'none', name:'None'},
                                {key:'scale-down', name:'Scale-down'}
                            ]
                        },
                        'object-position': {
                            name : 'Object position',
                            'type': 'slider',
                            style_input: true
                        }/*,
                        'mask-image': {
                            name : 'Mask image',
                            'type': 'image'
                        }*/
                    }
                },

                position_prop : {
                    name : 'Position',
                    get_has_data: cssPropsRe('position'),
                    fields: {
                        'position_control': {
                            type: 'custom',
                            name: 'position',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-position');

                                var $container = null;
                                var $positionOverallBorder = null;
                                var unit = 'px';
                                const borderWidth = 100 - (12 * 2);
                                // `borderHeight`s value should be same as `@cssPositionBorderHeight` in less file
                                const borderHeight = 60;

                                var $equalIcon = null;

                                var lastBorderValue = {
                                    width: borderWidth,
                                    height: borderHeight
                                }

                                var fieldInputs = {
                                    'top': null,
                                    'bottom': null,
                                    'right': null,
                                    'left': null
                                }

                                var hwBorder = {
                                    'top': 20,
                                    'left': 12,
                                    'right': 12,
                                    'bottom': 20
                                }

                                var toggleIconActivation = function (e, control) {
                                    var $target = $(e.currentTarget);
                                    $target.toggleClass('active');
                                    positionBtnActive = $target.hasClass('active');

                                    if (positionBtnActive) {
                                        var directions = ['top', 'left', 'right', 'bottom'];
                                        var value = null;
                                        for (var i = 0; i < directions.length; i++) {
                                            var dir = directions[i];
                                            value = fieldInputs[dir].getValue();
                                            if (value) break;
                                        }
                                        updatePositionValue(control.obj, '', value, null, 'change');
                                    }
                                }

                                var updatePositionBlockView = function ($field, direction, valueStr, oldValueIsNull) {
                                    var oldValueStr = null;
                                    if (!oldValueIsNull) {
                                        oldValueStr = $container.data('old-' + direction + '-value');
                                    }

                                    var value = parseInt(valueStr, 10);
                                    var oldValue = parseInt(oldValueStr, 10);
                                    if (valueStr == oldValueStr || value == oldValue) return;

                                    var prop = '',
                                        sdProp = '';
                                    var $firstPadding = null,
                                        $secondPadding = null;

                                    var $overallBorder = $field.siblings('.position-overall-border');
                                    var $paddingBlock = $overallBorder.find('> .position-padding-' + direction);
                                    var $paddingBorder = $overallBorder.find('> .position-border');

                                    if (direction == 'top' || direction == 'bottom') {
                                        prop = 'height';
                                        unit = 'px';
                                        $firstPadding = $overallBorder.find('> .position-padding-left');
                                        $secondPadding = $overallBorder.find('> .position-padding-right');
                                    }
                                    if (direction == 'left' || direction == 'right') {
                                        prop = 'width';
                                        unit = '%';
                                        sdProp = 'margin-' + direction;
                                        $firstPadding = $overallBorder.find('> .position-padding-top');
                                        $secondPadding = $overallBorder.find('> .position-padding-bottom');
                                    }

                                    var currValue = lastBorderValue[prop];
                                    var newValue = hwBorder[direction];

                                    if (value == 0) {
                                        $paddingBlock.css(prop, 0);
                                        $paddingBorder.css(prop, (currValue + newValue) + unit);
                                        $firstPadding.css(prop, (currValue + newValue) + unit);
                                        $secondPadding.css(prop, (currValue + newValue) + unit);
                                        if (sdProp) {
                                            $firstPadding.css(sdProp, '0');
                                            $secondPadding.css(sdProp, '0');
                                        }

                                        lastBorderValue[prop] = currValue + newValue;
                                    }
                                    else if (parseInt($paddingBlock.css(prop), 10) == 0) {
                                        $paddingBlock.css(prop, '');
                                        $paddingBorder.css(prop, (currValue - newValue) + unit);
                                        $firstPadding.css(prop, (currValue - newValue) + unit);
                                        $secondPadding.css(prop, (currValue - newValue) + unit);
                                        if (sdProp) {
                                            $firstPadding.css(sdProp, '');
                                            $secondPadding.css(sdProp, '');
                                        }

                                        lastBorderValue[prop] = currValue - newValue;
                                    }
                                }

                                var resetBorderCSSValues = function () {
                                    $positionOverallBorder.find('.position-padding-top').css({
                                        'height': '',
                                        'width': '',
                                        'margin-left': '',
                                        'margin-right': ''
                                    });

                                    $positionOverallBorder.find('.position-padding-left').css({
                                        'height': '',
                                        'width': ''
                                    });

                                    $positionOverallBorder.find('.position-border').css({
                                        width: '',
                                        height: ''
                                    });

                                    $positionOverallBorder.find('.position-padding-right').css({
                                        'height': '',
                                        'width': ''
                                    });

                                    $positionOverallBorder.find('.position-padding-bottom').css({
                                        'width': '',
                                        'height': '',
                                        'margin-left': '',
                                        'margin-right': ''
                                    });

                                    lastBorderValue = {
                                        width: borderWidth,
                                        height: borderHeight
                                    }
                                }

                                var updatePositionValue = function (obj, direction, value, oldValue, eventType) {
                                    var dispatchEvent = shouldDispatchEvent(eventType == 'change', value, oldValue);

                                    if (positionBtnActive) {
                                        var directionArr = ['top', 'bottom', 'right', 'left'];

                                        for (var i = 0; i < directionArr.length; i++) {
                                            var dir = directionArr[i];
                                            if (dir != direction) {
                                                fieldInputs[dir].setValue(value);

                                                var forceChanging = "skip";
                                                if (i == directionArr.length - 1) forceChanging = "do";

                                                commitObjValue(obj, dir, value, false, forceChanging, dispatchEvent);
                                                updatePositionBlockView(positionObjs[dir].$el, dir, value);
                                                $container.data('old-' + dir + '-value', value);
                                            }
                                        }
                                    }

                                    highlightOnChanged(obj, null, null, null, {highlight: true})
                                }

                                var positionObjs = {
                                    'top': {
                                        fdef: addCssNumberDef("Top", "Top", {
                                            style_input: true,
                                            on_changed: function (obj, prop, value, oldValue, fdef, $field, eventType) {
                                                updatePositionBlockView($field, 'top', value);
                                                updatePositionValue(obj, 'top', value, oldValue, eventType);
                                                $container.data('old-top-value', value);
                                            }
                                        }),
                                        $el: null
                                    },
                                    'left': {
                                        fdef: addCssNumberDef("Left", "Left", {
                                            style_input: true,
                                            on_changed: function (obj, prop, value, oldValue, fdef, $field, eventType) {
                                                updatePositionBlockView($field, 'left', value);
                                                updatePositionValue(obj, 'left', value, oldValue, eventType);
                                                $container.data('old-left-value', value);
                                            }
                                        }),
                                        $el: null
                                    },
                                    'right': {
                                        fdef: addCssNumberDef("Right", "Right", {
                                            style_input: true,
                                            on_changed: function (obj, prop, value, oldValue, fdef, $field, eventType) {
                                                updatePositionBlockView($field, 'right', value);
                                                updatePositionValue(obj, 'right', value, oldValue, eventType);
                                                $container.data('old-right-value', value);
                                            }
                                        }),
                                        $el: null
                                    },
                                    'bottom': {
                                        fdef: addCssNumberDef("Bottom", "Bottom", {
                                            style_input: true,
                                            on_changed: function (obj, prop, value, oldValue, fdef, $field, eventType) {
                                                updatePositionBlockView($field, 'bottom', value);
                                                updatePositionValue(obj, 'bottom', value, oldValue, eventType);
                                                $container.data('old-bottom-value', value);
                                            }
                                        }),
                                        $el: null
                                    }
                                }

                                c.onDefine = function() {
                                    for (var p in positionObjs) {
                                        this.registerInputField(p, positionObjs[p].fdef);
                                    }
                                }

                                c.onShow = function() {
                                    var _this = this;
                                    $container = $('<div class="position-container text-center"></div>');

                                    for (var p in positionObjs) {
                                        var positionFieldProp = this.showInputField($container, p, positionObjs[p].fdef);
                                        positionObjs[p].$el = positionFieldProp.$field.addClass('crsa-small-input crsa-align-center-input crsa-inline-container');
                                        fieldInputs[p] = positionFieldProp;
                                    }

                                    $positionOverallBorder = $('<div class="position-overall-border"></div>').appendTo($container);

                                    var $positoinPaddingTop = $('<div class="position-padding-top"></div>').appendTo($positionOverallBorder);
                                    var $positoinPaddingTop = $('<div class="position-padding-left"></div>').appendTo($positionOverallBorder);
                                    var $positionBorder = $('<div class="position-border"></div>').appendTo($positionOverallBorder);
                                    var $positionPaddingRight = $('<div class="position-padding-right"></div>').appendTo($positionOverallBorder);
                                    var $positionPaddingRight = $('<div class="position-padding-bottom"></div>').appendTo($positionOverallBorder);

                                    $equalIcon = $('<div class="change-all-icon"><i class="icon-same"></i></div>').appendTo($positionBorder);
                                    $equalIcon.on('click', function (e) {
                                        toggleIconActivation(e, _this);
                                    });

                                    addTooltip($equalIcon, 'Use the same distance on all four sides.');
                                    return $container;
                                }

                                c.onSetValues = function() {
                                    resetBorderCSSValues();

                                    var sameValue = false;
                                    for (var p in positionObjs) {
                                        var $el = positionObjs[p].$el;
                                        if ($el) {
                                            updatePositionBlockView($el, p, this.values[p], true);
                                        }
                                        if ($container) $container.data('old-' + p + '-value', this.values[p]);
                                    }

                                    var top = this.values['top'];
                                    var left = this.values['left'];
                                    var right = this.values['right'];
                                    var bottom = this.values['bottom'];

                                    if (top && top == left && left == right && right == bottom) {
                                        $equalIcon.addClass('active');
                                        positionBtnActive = true;
                                    }
                                    else {
                                        $equalIcon.removeClass('active');
                                        positionBtnActive = false;
                                    }
                                }

                                return c;
                            }
                        },
                        'position' : {
                            name : 'Position',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            can_add_items: true,
                            options:[
                                {key:'static', name:'Static'},
                                {key:'relative', name:'Relative'},
                                {key:'absolute', name:'Absolute'},
                                {key:'fixed', name:'Fixed'},
                                {key:'sticky', name:'Sticky'},
                                {key:'inherit', name:'Inherit'}
                            ]
                        },
                        'z-index' : {
                            name : 'Z-Index',
                            'type': 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            add_default_unit: ''
                            //'without_icon': false,
                            //icon: 'icon-Z_index'
                        }
                    }
                },

                background : {
                    name : 'Background',
                    get_has_data: cssPropsRe('background'),
                    icons : true,
                    fields : {
                        // 'background' : {name : 'Bckgr.', type : 'text', icon: 'icon-bckgr'},
                        // 'background-image' : addCssBackgroundDef("Image", 'image', 'icon-image'),

                        'background_control': {
                            type: 'custom',
                            name: 'background',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-bg');
                                var field_settings = {
                                    'type': 'text',
                                    'name': 'Bckgr.',
                                    'style_input': true,
                                    //'icon': 'icon-bckgr',
                                    'action': 'custom',
                                    add_default_unit: '',
                                    get_value: function (obj, fn, styles) {
                                        var bgValue = styles[fn];
                                        if (bgValue) bgValue = bgValue.value || bgValue;

                                        return bgValue;
                                    },
                                    set_value: function (obj, value, values, oldValue, eventType) {
                                        commitObjValue(obj, 'background', value);
                                        if (eventType == 'change') {
                                            // update gradient
                                            gradientControl.updateGradientValue(obj, values);
                                        }
                                        return value;
                                    }
                                }

                                c.onDefine = function () {
                                    this.registerInputField('background', field_settings);
                                }

                                c.onShow = function () {
                                    var $container = $('<div class="background-container"></div>');
                                    backgroundField['background'] = this.showInputField($container, 'background', field_settings);

                                    return $container;
                                }

                                c.onSetValues = function () {}

                                return c;
                            }
                        },
                        'background-color': addCssBackgroundDef("Color", 'color', 'icon-color'),
                        'background-image_control': {
                            type: 'custom',
                            name: 'background-image',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-css-bg-image');
                                var field_settings = addCssBackgroundDef("Image", 'image', 'icon-image', function() {
                                    // do nothing
                                }, function (obj, value, values, oldValue, eventType) {
                                    if (eventType == 'change' && !pgf.kids) {
                                        // update gradient
                                        gradientControl.updateGradientValue(obj, values);
                                    }
                                });

                                c.onDefine = function () {
                                    this.registerInputField('background-image', field_settings);
                                }

                                c.onShow = function () {
                                    var $container = $('<div class="background-image-container"></div>');
                                    backgroundField['background-image'] = this.showInputField($container, 'background-image', field_settings);

                                    return $container;
                                }

                                c.onSetValues = function () {}

                                return c;
                            }
                        },
                        'gradient_control' : {
                            type: 'custom',
                            name: 'gradient',
                            action: 'none',
                            control: function () {
                                return gradientControl.getControl();
                            }
                        },
                        'gradient_lib' : {
                            type: 'button',
                            name: 'Gradient library',
                            func: function(obj, $el) {
                                var q = new PgQuickGradientLib($el);
                            }
                        },

                        'background-repeat' : {
                            'type' : 'select',
                            'name' : 'Repeat',
                            'show_empty' : true,
                            'style_input': true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'no-repeat',
                                    'name' : 'No repeat',
                                    'html' : bm.makeIcon('repeat', { attributes: { 'title': 'No repeat' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-repeat"></div></div>'
                                },
                                {
                                    'key' : 'repeat',
                                    'name' : 'Repeat',
                                    'html' : bm.makeIcon('repeat-XY', { attributes: { 'title': 'Repeat' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-repeat-XY"></div></div>'
                                },
                                {
                                    'key' : 'repeat-x',
                                    'name' : 'Repeat x',
                                    'html' : bm.makeIcon('repeat-X', { attributes: { 'title': 'Repeat x' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-repeat-X"></div></div>'
                                },
                                {
                                    'key' : 'repeat-y',
                                    'name' : 'Repeat y',
                                    'html' : bm.makeIcon('repeat-Y', { attributes: { 'title': 'Repeat y' } })
                                    // 'html' : '<div class="pg-tb-button-text"><div class="icon-repeat-Y"></div></div>'
                                }
                            ]
                        },
                        'background-position' : addCssBackgroundDef("Position", 'position', 'icon-posx'),
                        'background-size' : addCssBackgroundDef("Size", 'size', 'icon-size'),
                        'background-attachment' : addCssBackgroundDef("Attachment", 'attachment', 'icon-attach'),
                        'background-origin' :  addCssBackgroundDef("Origin", 'origin', ''),
                        'background-clip' : {
                            name : 'Background clip',
                            can_add_items: true,
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            options:[
                                {key:'border-box', name:'Border box'},
                                {key:'padding-box', name:'Padding box'},
                                {key:'content-box', name:'Content box'},
                                {key:'text', name:'Text'}
                            ]
                        }
                    }
                },

                border_prop : {
                    name : 'Border &amp; Border radius',
                    get_has_data: cssPropsRe('border'),
                    fields : {
                        'border_control' : {
                            type: 'custom',
                            name: 'border',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-border');
                                var $borderAndBoderRaduis = null;
                                var init = false;

                                var $changeWidthIcon = null,
                                    $changeBorderStyleIcon = null;

                                var fieldInputs = {
                                    'border-top': null,
                                    'border-bottom': null,
                                    'border-right': null,
                                    'border-left': null,

                                    'border-top-left-radius': null,
                                    'border-top-right-radius': null,
                                    'border-bottom-left-radius': null,
                                    'border-bottom-right-radius': null
                                }

                                var borders = [
                                    {
                                        prop: 'border-top',
                                        fdef: addCssNumberDef('border-top', 'Top', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            highlight: false,
                                            get_value: function (obj) {
                                                // nothing
                                            },
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderValue(obj, 'border', 'top', { 'width': value }, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        prop: 'border-left',
                                        fdef: addCssNumberDef('border-left', 'Left', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            get_value: function (obj) {
                                                // nothing
                                            },
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderValue(obj, 'border', 'left', { 'width': value }, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        prop: 'border-right',
                                        fdef: addCssNumberDef('border-right', 'Right', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            get_value: function (obj) {
                                                // nothing
                                            },
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderValue(obj, 'border', 'right', { 'width': value }, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        prop: 'border-bottom',
                                        fdef: addCssNumberDef('border-bottom', 'Bottom', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            get_value: function (obj) {
                                                // nothing
                                            },
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderValue(obj, 'border', 'bottom', { 'width': value }, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }
                                ];
                                var borderRadius = [
                                    {
                                        'prop': 'top-left',
                                        //'icon': 'icon-round_lu',
                                        fdef: addCssNumberDef('border-top-left-radius', '', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderRadiusValue(obj, 'radius', 'top-left', value, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        'prop': 'top-right',
                                        //'icon': 'icon-round_ru',
                                        fdef: addCssNumberDef('border-top-right-radius', '', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderRadiusValue(obj, 'radius', 'top-right', value, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        'prop': 'bottom-left',
                                        //'icon': 'icon-round-ld',
                                        fdef: addCssNumberDef('border-bottom-left-radius', '', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderRadiusValue(obj, 'radius', 'bottom-left', value, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }, {
                                        'prop': 'bottom-right',
                                        //'icon': 'icon-round_rd',
                                        fdef: addCssNumberDef('border-bottom-right-radius', '', {
                                            'action' : 'custom',
                                            'slider_def_unit': 'px',
                                            slider_min: 0,
                                            highlight: false,
                                            style_input: true,
                                            skip_adding_units_on_input: true,
                                            set_value: function(obj, value, values, oldValue, eventType, fieldDef) {
                                                setBorderRadiusValue(obj, 'radius', 'bottom-right', value, eventType == 'change');
                                                return value;
                                            }
                                        })
                                    }
                                ];

                                var $overlayBorder = $('<div class="overlay-border"></div>');
                                var $borderStyleMenu = $('<ul class="border-style-menu">\
                                    <li data-value="none" alt="none"><div class="empty-border icon-close"></div></li>\
                                    <li data-value="solid" alt="solid"><div class="solid-border"></div></li>\
                                    <li data-value="dashed" alt="dashed"><div class="dashed-border"></div></li>\
                                    <li data-value="dotted" alt="dotted"><div class="dotted-border"></div></li>\
                                    <li data-value="double" alt="double"><div class="double-border"></div></li>\
                                    <li data-value="groove" alt="groove"><div class="groove-border"></div></li>\
                                    <li data-value="inset" alt="inset"><div class="inset-border"></div></li>\
                                    <li data-value="outset" alt="outset"><div class="outset-border"></div></li>\
                                    <li data-value="ridge" alt="ridge"><div class="ridge-border"></div></li>\
                                </ul>');

                                var borderTypeChanged = function ($borderStyle, prop, value) {
                                    var $borderValue = $borderStyle.find('.border-value');
                                    $borderValue.attr('class', 'border-value');
                                    if (value == "none") {
                                        $borderValue.addClass('icon-minus');
                                        $borderValue.css('border-width', '');
                                    }
                                    else {
                                        $borderValue.css('border-style', value);
                                        if (value == "double") {
                                            $borderValue.css('border-width', '3px');
                                        }
                                        else {
                                            $borderValue.css('border-width', '');
                                        }
                                    }

                                    var viewValue = value;
                                    if (viewValue == "none") viewValue = 'solid';
                                    $borderAndBoderRaduis.css(prop + '-style', viewValue);
                                }

                                $overlayBorder.on('click', function (e) {
                                    $borderStyleMenu.detach();
                                    $overlayBorder.detach();
                                });

                                $borderStyleMenu.find('li').on('click', function (e) {
                                    var $target = $(e.target).closest('li');

                                    var $borderStyle = $borderStyleMenu.data('border-style');
                                    var prop = $borderStyleMenu.data('prop');
                                    var value = $target.data('value');


                                    borderTypeChanged($borderStyle, prop, value);
                                    if (borderObjs[prop].style) {
                                        value += borderObjs[prop].style.important ? ' !important' : '';
                                    }
                                    setBorderValue(c.obj, 'border', getDirectionFromProp(prop), { 'style': value }, true);

                                    $borderStyleMenu.detach();
                                    $overlayBorder.detach();
                                });

                                var getNewColor = function (color) {
                                    if (color.toRgb()['a'] == 1) return color.toHexString();
                                    else return color.toRgbString();
                                }

                                var getPropName = function (type, direction, style) {
                                    var dirBase = (direction ? `-${direction}` : '');
                                    var styleBase = (style ? `-${style}` : '');

                                    if (type == 'border') {
                                        return 'border' + dirBase + styleBase;
                                    }
                                    else if (type == 'radius') {
                                        return 'border' + dirBase + styleBase + '-radius';
                                    }
                                }

                                var getDirectionFromProp = function (propName) {
                                    if (!propName) return null;
                                    var propDir = propName.split('-');

                                    return propDir[1] || '';
                                }

                                var getBorderForDirectionFrom = function (type, value, direction) {
                                    if (type == 'border') {
                                        return value;
                                    }
                                    else if (type == 'radius') {
                                        var valImp = valueHasImportant(value);
                                        var valArray = valImp.value.split(' ');
                                            valArray = valArray.filter(function (val) { if (val) return true; return false; });

                                        var getValue = function (index) {
                                            return valArray[index] + (valImp.important ? ' !important' : '');
                                        }

                                        if (valArray.length == 4) {
                                            switch (direction) {
                                                case 'top-left':
                                                    return getValue(0);
                                                case 'top-right':
                                                    return getValue(1);
                                                case 'bottom-right':
                                                    return getValue(2);
                                                case 'bottom-left':
                                                    return getValue(3);
                                            }
                                        }
                                        else if (valArray.length == 3) {
                                            switch (direction) {
                                                case 'top-left':
                                                    return getValue(0);
                                                case 'top-right':
                                                case 'bottom-left':
                                                    return getValue(1);
                                                case 'bottom-right':
                                                    return getValue(2);
                                            }
                                        }
                                        else if (valArray.length == 2) {
                                            switch (direction) {
                                                case 'top-left':
                                                case 'bottom-right':
                                                    return getValue(0);
                                                case 'top-right':
                                                case 'bottom-left':
                                                    return getValue(1);
                                            }
                                        }
                                        else if (valArray.length == 1) {
                                            return getValue(0);
                                        }

                                        return null;
                                    }
                                }

                                var getBorderObjectFor = function (currDir) {
                                    switch (currDir) {
                                        case 'top':
                                            return borders[0];
                                        case 'left':
                                            return borders[1];
                                        case 'right':
                                            return borders[2];
                                        case 'bottom':
                                            return borders[3];
                                        default:
                                            return null;
                                    }
                                }

                                var setBorderValue = function (obj, type, direction, values, dispatchEvent) {
                                    var ruleAndCs = getRuleFromObj(obj);
                                    var rule = ruleAndCs.rule;

                                    var allDirections = ['', 'top', 'left', 'right', 'bottom'];
                                    var allStyles = ['', 'width', 'style', 'color'];


                                    var styleValues = Object.keys(values);

                                    var borderProps = [];
                                    var borderValue = {};

                                    var addAllStylesBorderValue = function (currDir, currType, propName, propValue, important) {
                                        var currStyles = [];
                                        if (currType == '') {
                                            // var valArr = propValue.split(' ');
                                            var valArr = getTokens(propValue, ' ');
                                                valArr = valArr.filter(function (val) { if (val) return true; return false; });

                                            var currStyles = [];
                                            var borderAllValues = fillBorderValues(valArr);
                                            for (var styleName in borderAllValues) {
                                                var styleValue = borderAllValues[styleName];
                                                // if (styleName == 'text') styleName = 'width';

                                                currStyles.push({
                                                    styleName: styleName,
                                                    value: styleValue,
                                                    prop: propName
                                                });
                                            }
                                        }
                                        else {
                                            currStyles.push({
                                                styleName: borderType,
                                                value: propValue,
                                                prop: propName
                                            })
                                        }

                                        for (var i = 0; i < currStyles.length; i++) {
                                            var currStyle = currStyles[i];
                                            borderValue[currDir][currStyle.styleName] = {
                                                value: currStyle.value,
                                                prop: currStyle.prop,
                                                important: important
                                            }
                                        }
                                    }

                                    for (var i = 0; i < allDirections.length; i++) {
                                        var dir = allDirections[i];
                                        if (dir && !borderValue[dir]) borderValue[dir] = {};

                                        for (var j = 0; j < allStyles.length; j++) {
                                            var borderType = allStyles[j];

                                            var fullPropName = getPropName(type, dir, borderType);

                                            var nodeInside = pinegrow.pgPostCSSHelper.findNodeInside('decl', 'prop', fullPropName, rule);
                                            if (nodeInside) {
                                                borderProps.push(fullPropName);

                                                if (dir == '') {
                                                    var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);

                                                    for (var k = 1; k < allDirections.length; k++) {
                                                        var currDir = allDirections[k];
                                                        if (!borderValue[currDir]) borderValue[currDir] = {};

                                                        addAllStylesBorderValue(currDir, borderType, fullPropName, nodeInsideValue.value, nodeInsideValue.important);
                                                    }
                                                }
                                                else {
                                                    var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);
                                                    addAllStylesBorderValue(dir, borderType, fullPropName, nodeInsideValue.value, nodeInsideValue.important);
                                                }
                                            }

                                            if (dir) {
                                                if ((dir == direction || borderBtnActive) && styleValues.indexOf(borderType) > -1) {
                                                    var value = values[borderType];
                                                    var impValue = valueHasImportant(value);

                                                    borderValue[dir][borderType] = {
                                                        value: impValue.value,
                                                        important: impValue.important
                                                    }

                                                    var prop = getPropName(type, dir);
                                                    borderObjs[prop][borderType] = {
                                                        value: impValue.value,
                                                        important: impValue.important
                                                    };

                                                    // if (dir != direction) {
                                                        var borderField = getBorderObjectFor(dir);
                                                        var propObj = borderField.obj;

                                                        if (borderType == 'width') {
                                                            propObj.setValue(value);
                                                        }
                                                        else if (borderType == 'style') {
                                                            var $borderStyle = propObj.$field.find('.border-style');
                                                            borderTypeChanged($borderStyle, prop, impValue.value);
                                                        }
                                                        else if (borderType == 'color') {
                                                            var $colorInput = propObj.$field.find('.color-input');
                                                            $colorInput.spectrum("set", impValue.value);
                                                        }
                                                    // }
                                                }
                                            }
                                        }
                                    }

                                    var directions = ['', direction];
                                    var types = ['', ...styleValues];

                                    var checkPropsToAdd = function (currDir, currType) {
                                        var propNoDir = getPropName('border', '', currType);
                                        var propNoTyp = getPropName('border', currDir, '');
                                        var propNone = getPropName('border', '', '');
                                        if (addDirections[propNoDir] || addDirections[propNoTyp] || addDirections[propNone]) return false;

                                        return true;
                                    }

                                    var checkPropsToRemove = function (currDir, currType) {
                                        var propName = getPropName('border', currDir, currType);
                                        if (!addDirections[propName] && borderProps.indexOf(propName) > -1) return true;

                                        return false;
                                    }

                                    var getBorderValueFromObject = function (direction) {
                                        var result = { width: '', style: '', color: ''};

                                        var getValue = function (valObj, wantedType) {
                                            return valObj[wantedType] ? valObj[wantedType] || "" : "";
                                        }

                                        if (borderValue[direction]) {
                                            result['width'] = getValue(borderValue[direction], 'width');
                                            result['style'] = getValue(borderValue[direction], 'style');
                                            result['color'] = getValue(borderValue[direction], 'color');
                                        }

                                        return result;
                                    }

                                    var shouldActivate = function (currDir, currType) {
                                        if (!checkPropsToAdd(currDir, currType)) return false;

                                        // border, border-width, border-style, border-color
                                        if (currDir == '') {
                                            var topValue = getBorderValueFromObject('top');
                                            var leftValue = getBorderValueFromObject('left');
                                            var rightValue = getBorderValueFromObject('right');
                                            var bottomValue = getBorderValueFromObject('bottom');

                                            // border
                                            if (currType == '') {
                                                var isWidthNotUndefined = topValue.width && leftValue.width && rightValue.width && bottomValue.width;
                                                var isWidthNotEmpty = isWidthNotUndefined && topValue.width.value && leftValue.width.value && rightValue.width.value && bottomValue.width.value;
                                                var sameImportant = isWidthNotUndefined && topValue.width.important == leftValue.width.important && leftValue.width.important == rightValue.width.important && rightValue.width.important == bottomValue.width.important;
                                                var sameWidth = isWidthNotEmpty && topValue.width.value == leftValue.width.value && leftValue.width.value == rightValue.width.value && rightValue.width.value == bottomValue.width.value;

                                                var isStyleNotUndefined = topValue.style && leftValue.style && rightValue.style && bottomValue.style;
                                                var isStyleNotEmpty = isStyleNotUndefined && topValue.style.value && leftValue.style.value && rightValue.style.value && bottomValue.style.value;
                                                var sameStyle = isStyleNotEmpty && topValue.style.value == leftValue.style.value && leftValue.style.value == rightValue.style.value && rightValue.style.value == bottomValue.style.value;

                                                var isColorNotUndefined = topValue.color && leftValue.color && rightValue.color && bottomValue.color;
                                                var isColorNotEmpty = isColorNotUndefined && topValue.color.value && leftValue.color.value && rightValue.color.value && bottomValue.color.value;
                                                var sameColor = isColorNotEmpty && topValue.color.value == leftValue.color.value && leftValue.color.value == rightValue.color.value && rightValue.color.value == bottomValue.color.value;

                                                return sameImportant && sameWidth && sameStyle && sameColor ? true : false;
                                            }
                                            // border-width, border-style, border-color
                                            else {
                                                var topHasValue = topValue.width.value && topValue.style.value && topValue.color.value;
                                                var leftHasValue = leftValue.width.value && leftValue.style.value && leftValue.color.value;
                                                var rightHasValue = rightValue.width.value && rightValue.style.value && rightValue.color.value;
                                                var bottomHasValue = bottomValue.width.value && bottomValue.style.value && bottomValue.color.value;

                                                var allHasValue = topHasValue && leftHasValue && rightHasValue && bottomHasValue;

                                                var isNotUndefined = topValue[currType] && leftValue[currType] && rightValue[currType] && bottomValue[currType];
                                                var isNotEmpty = isNotUndefined && topValue[currType].value && leftValue[currType].value && rightValue[currType].value && bottomValue[currType].value;
                                                var sameImportant = isNotUndefined && topValue[currType].important == leftValue[currType].important && leftValue[currType].important == rightValue[currType].important && rightValue[currType].important == bottomValue[currType].important;
                                                var sameValue = isNotEmpty && topValue[currType].value == leftValue[currType].value && leftValue[currType].value == rightValue[currType].value && rightValue[currType].value == bottomValue[currType].value;

                                                return (sameImportant && sameValue && !allHasValue) ? true : false;
                                            }
                                        }
                                        else {
                                            var dirValue = getBorderValueFromObject(currDir);
                                            // border-top, border-left, border-right, border-bottom
                                            if (currType == '') {
                                                var isNotUndefined = dirValue.width && dirValue.style && dirValue.color;
                                                var hasValue = isNotUndefined && dirValue.width.value && dirValue.style.value && dirValue.color.value;
                                                return hasValue ? true : false;
                                            }
                                            else {
                                                return dirValue[currType] && dirValue[currType].value ? true : false;
                                            }
                                        }
                                    }

                                    var shouldDeactivate = function (currDir, currType) {
                                        var propName = getPropName('border', currDir, currType);
                                        if (borderProps.indexOf(propName) == -1) return false;

                                        // border, border-width, border-style, border-color
                                        if (currDir == '') {
                                            var topValue = getBorderValueFromObject('top');
                                            var leftValue = getBorderValueFromObject('left');
                                            var rightValue = getBorderValueFromObject('right');
                                            var bottomValue = getBorderValueFromObject('bottom');

                                            // border
                                            if (currType == '') {
                                                var isOneWidthUndefined = !topValue.width.value || !leftValue.width.value || !rightValue.width.value || !bottomValue.width.value;
                                                var diffImportant = isOneWidthUndefined || (topValue.width.important != leftValue.width.important || leftValue.width.important != rightValue.width.important || rightValue.width.important != bottomValue.width.important);
                                                var diffWidth = isOneWidthUndefined || (topValue.width.value != leftValue.width.value && leftValue.width.value != rightValue.width.value && rightValue.width.value != bottomValue.width.value);

                                                var isOneStyleUndefined = !topValue.style.value || !leftValue.style.value || !rightValue.style.value || !bottomValue.style.value;
                                                var diffStyle = isOneStyleUndefined || (topValue.style.value != leftValue.style.value && leftValue.style.value != rightValue.style.value && rightValue.style.value != bottomValue.style.value);

                                                var isOneColorUndefined = !topValue.color.value || !leftValue.color.value || !rightValue.color.value || !bottomValue.color.value;
                                                var diffColor = isOneColorUndefined || (topValue.color.value != leftValue.color.value && leftValue.color.value != rightValue.color.value && rightValue.color.value != bottomValue.color.value);

                                                return diffImportant || diffWidth || diffStyle || diffColor ? true : false;
                                            }
                                            // border-width, border-style, border-color
                                            else {
                                                var diffImportant = topValue[currType].important != leftValue[currType].important || leftValue[currType].important != rightValue[currType].important || rightValue[currType].important != bottomValue[currType].important;
                                                var diffValue = topValue[currType].value != leftValue[currType].value || leftValue[currType].value != rightValue[currType].value || rightValue[currType].value != bottomValue[currType].value;
                                                return diffImportant || diffValue ? true : false;
                                            }
                                        }
                                        else {
                                            var dirValue = getBorderValueFromObject(currDir);
                                            // border-top, border-left, border-right, border-bottom
                                            if (currType == '') {
                                                return !dirValue.width.value || !dirValue.style.value || !dirValue.color.value ? true : false;
                                            }
                                            else {
                                                return !dirValue[currType].value ? true : false;
                                            }
                                        }
                                    }

                                    var getValueForProp = function (currDir, currType) {
                                        var dir = currDir || direction || 'top';
                                        var borderDirValue = borderValue[dir];

                                        if (currType) {
                                            if (borderDirValue[currType].value) {
                                                var impStr = borderDirValue[currType].important ? ' !important' : '';
                                                return borderDirValue[currType].value + impStr;
                                            }
                                        }
                                        else {
                                            if (borderDirValue.width.value && borderDirValue.style.value && borderDirValue.style.value) {
                                                var impStr = borderDirValue.width.important ? '!important' : '';
                                                return `${borderDirValue.width.value} ${borderDirValue.style.value} ${borderDirValue.color.value} ${impStr}`;
                                            }
                                        }

                                        return null;
                                    }

                                    var getDirStyleFrom = function (currDir, currType) {
                                        var directions = [];
                                        var styles = [];

                                        if (currDir) {
                                            directions.push(currDir)
                                        }
                                        else {
                                            directions.push('top', 'left', 'right', 'bottom');
                                        }

                                        if (currType) {
                                            styles.push(currType);
                                        }
                                        else {
                                            styles.push('', 'width', 'style', 'color');
                                        }

                                        return {
                                            directions: directions,
                                            styles: styles
                                        }
                                    }

                                    var getPropsToDeactivate = function (currDir, currType) {
                                        var dirStyle = getDirStyleFrom(currDir, currType);
                                        var directions = dirStyle.directions;
                                        var styles = dirStyle.styles;

                                        var allProps = [];
                                        for (var i = 0; i < directions.length; i++) {
                                            var dir = directions[i];
                                            for (var j = 0; j < styles.length; j++) {
                                                var style = styles[j];
                                                allProps.push({currDir: dir, currType: style});
                                            }
                                        }

                                        return allProps;
                                    }

                                    var deactivateProps = function (currDir, currType, callbackCheck, callback, extended) {
                                        var dirTypes = getPropsToDeactivate(currDir, currType, extended);

                                        for (var i = 0; i < dirTypes.length; i++) {
                                            var dirType = dirTypes[i];

                                            if (callbackCheck(dirType.currDir, dirType.currType)) {
                                                var value = getValueForProp(dirType.currDir, dirType.currType);
                                                if (value) {
                                                    var currPropName = getPropName(type, dirType.currDir) + (dirType.currType ? `-${dirType.currType}` : '');
                                                    callback(currPropName, value, dirType.currDir, dirType.currType);
                                                }
                                            }

                                        }
                                    }

                                    var addNewDirection = function (prop, value, direction, styleType) {
                                        addDirections[prop] = {
                                            value: value,
                                            direction: direction,
                                            styleType: styleType
                                        }
                                    }

                                    var removeDirection = function (prop) {
                                        if (removeDirections.indexOf(prop) < 0) {
                                            removeDirections.push(prop);
                                        }
                                    }

                                    var addExtraUndueProps = function () {
                                        if (addDirections['border']) {
                                            for (var i = 0; i < allDirections.length; i++) {
                                                var currDir = allDirections[i];
                                                for (var i = 0; i < allStyles.length; i++) {
                                                    var currStyle = allStyles[i];
                                                    var propName = getPropName('border', currDir, currStyle);
                                                    if (borderProps.indexOf(propName) > -1 && !addDirections[propName]) {
                                                        removeDirections.push(propName);
                                                    }
                                                }
                                            }
                                        }
                                        else {
                                            var borderTop = addDirections['border-top'] || borderProps.indexOf('border-top') > -1;
                                            var borderLeft = addDirections['border-left'] || borderProps.indexOf('border-left') > -1;
                                            var borderRight = addDirections['border-right'] || borderProps.indexOf('border-right') > -1;
                                            var borderBottom = addDirections['border-bottom'] || borderProps.indexOf('border-bottom') > -1;

                                            if (borderTop && borderLeft && borderRight && borderBottom) {
                                                for (var i = 0; i < allStyles.length; i++) {
                                                    var currStyle = allStyles[i];
                                                    var prop = getPropName(type, '', currStyle);
                                                    if (borderProps.indexOf(prop) > -1 && removeDirections.indexOf(prop) < 0) {
                                                        removeDirections.push(prop);
                                                    }
                                                }
                                            }
                                        }
                                    }

                                    var addDirections = {};
                                    var removeDirections = [];
                                    for (var i = 0; i < directions.length; i++) {
                                        var currDir = directions[i];

                                        for (var j = 0; j < types.length; j++) {
                                            var currType = types[j];
                                            var propName = getPropName(type, currDir) + (currType ? `-${currType}` : '');

                                            if (shouldActivate(currDir, currType)) {
                                                var newPropValue = getValueForProp(currDir, currType);
                                                if (newPropValue) addNewDirection(propName, newPropValue, currDir, currType);

                                                deactivateProps(currDir, currType, checkPropsToRemove, function (prop, value) {
                                                    removeDirection(prop);
                                                }, true);
                                            }
                                            else if (shouldDeactivate(currDir, currType)) {
                                                removeDirection(propName);
                                                deactivateProps(currDir, currType, checkPropsToAdd, function (prop, value, currDir, currType) {
                                                    addNewDirection(prop, value, currDir, currType);
                                                }, false);
                                            }
                                        }
                                    }


                                    addExtraUndueProps();

                                    var addDirKeys = Object.keys(addDirections);

                                    var removeDirLength = removeDirections.length;
                                    for (var i = 0; i < removeDirLength; i++) {
                                        var prop = removeDirections[i];

                                        var action = 'skip';
                                        if (i + 1 == removeDirLength && addDirKeys.length == 0) {
                                            action = 'do';
                                        }

                                        commitObjValue(obj, prop, null, false, action, true);
                                    }

                                    var addKeysLength = addDirKeys.length;
                                    for (var i = 0; i < addKeysLength; i++) {
                                        var currProp = addDirKeys[i];
                                        var currDir = addDirections[currProp];
                                        var currValue = currDir.value;

                                        var action = 'skip';
                                        if (i + 1 == addKeysLength) {
                                            action = 'do';
                                        }

                                        var oldValue = null;
                                        if (borderProps.indexOf(currProp) > -1) oldValue = "NotNull";

                                        var dispatchNow = shouldDispatchEvent(dispatchEvent, currValue, oldValue);
                                        commitObjValue(obj, currProp, currValue, false, action, dispatchNow);
                                    }

                                    if (false && pgIsDev()) {
                                        console.log('=>=>=>=> borderProps: ', borderProps);
                                        console.log('=>=>=>=> addDirections: ', addDirections);
                                        console.log('=>=>=>=> removeDirections: ', removeDirections);
                                    }
                                }

                                var setBorderRadiusValue = function (obj, type, direction, value, dispatchEvent) {
                                    if (dispatchEvent === undefined) dispatchEvent = true;

                                    var impValue = valueHasImportant(value);

                                    var isActive = $changeBorderStyleIcon.hasClass('active');
                                    var directions = ['', 'top-left', 'top-right', 'bottom-left', 'bottom-right'];

                                    var ruleAndCs = getRuleFromObj(obj);
                                    var rule = ruleAndCs.rule;

                                    var valuesNum = [];
                                    for (var i = 0; i < directions.length; i++) {
                                        var dir = directions[i];
                                        if (!valuesNum[dir]) valuesNum[dir] = { important: false };
                                        var propName = getPropName(type, dir);

                                        var nodeInside = pinegrow.pgPostCSSHelper.findNodeInside('decl', 'prop', propName, rule);
                                        if (nodeInside) {
                                            if (dir == '') {
                                                var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);

                                                valuesNum[dir] = { value: nodeInsideValue.value };

                                                for (var j = 1; j < directions.length; j++) {
                                                    var currDir = directions[j];
                                                    valuesNum[currDir] = {
                                                        value: getBorderForDirectionFrom(type, nodeInsideValue.value, currDir),
                                                        important: nodeInsideValue.important,
                                                        native: false
                                                    }
                                                }
                                            }
                                            else {
                                                var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);
                                                valuesNum[dir] = {
                                                    value: nodeInsideValue.value,
                                                    important: nodeInsideValue.important,
                                                    native: true
                                                }
                                            }
                                        }
                                    }

                                    var tl = direction == 'top-left' ? impValue.value : valuesNum['top-left'].value;
                                    var tr = direction == 'top-right' ? impValue.value : valuesNum['top-right'].value;
                                    var bl = direction == 'bottom-left' ? impValue.value : valuesNum['bottom-left'].value;
                                    var br = direction == 'bottom-right' ? impValue.value : valuesNum['bottom-right'].value;

                                    var tlImp = direction == 'top-left' ? impValue.important : valuesNum['top-left'].important;
                                    var trImp = direction == 'top-right' ? impValue.important : valuesNum['top-right'].important;
                                    var blImp = direction == 'bottom-left' ? impValue.important : valuesNum['bottom-left'].important;
                                    var brImp = direction == 'bottom-right' ? impValue.important : valuesNum['bottom-right'].important;

                                    var removeDirections = [];
                                    var addDirections = {};

                                    var isSameImp = (tlImp == trImp && trImp == blImp && blImp == brImp);
                                    if (isActive || ((tl && tr && bl && br) && isSameImp)) {
                                        var isSameVal = (tl == tr && tr == bl && bl == br);

                                        if (valuesNum['top-left'].native) removeDirections.push('top-left');
                                        if (valuesNum['top-right'].native) removeDirections.push('top-right');
                                        if (valuesNum['bottom-left'].native) removeDirections.push('bottom-left');
                                        if (valuesNum['bottom-right'].native) removeDirections.push('bottom-right');

                                        if (isActive || isSameVal) {
                                            var isImportant = tlImp || trImp || blImp || brImp;

                                            addDirections['']  = (isActive && direction ? impValue.value : (tl || tr || bl || br))
                                            addDirections[''] += (isActive && direction) ? (impValue.important ? ' !important' : '') : (isImportant ? ' !important' : '');
                                        }
                                        else {
                                            addDirections[''] = `${tl} ${tr}`;
                                            if (tl != br || tr != bl) {
                                                addDirections[''] += ` ${br}`;

                                                if (tr != bl) {
                                                    addDirections[''] += ` ${bl}`;
                                                }
                                            }

                                            addDirections[''] += tlImp ? ' !important' : '';
                                        }
                                    }
                                    else {
                                        if (valuesNum[''].value) {
                                            removeDirections.push('');

                                            valuesNum['top-left'].forceDispatch = true;
                                            valuesNum['top-right'].forceDispatch = true;
                                            valuesNum['bottom-left'].forceDispatch = true;
                                            valuesNum['bottom-right'].forceDispatch = true;

                                            addDirections['top-left'] = tl + (tlImp ? ' !important' : '');
                                            addDirections['top-right'] = tr + (trImp ? ' !important' : '');
                                            addDirections['bottom-left'] = bl + (blImp ? ' !important' : '');
                                            addDirections['bottom-right'] = br + (brImp ? ' !important' : '');
                                        }
                                        else {
                                                if (direction == 'top-left') addDirections['top-left'] = tl + (tlImp ? ' !important' : '');
                                            else if (direction == 'top-right') addDirections['top-right'] = tr + (trImp ? ' !important' : '');
                                            else if (direction == 'bottom-left') addDirections['bottom-left'] = bl + (blImp ? ' !important' : '');
                                            else if (direction == 'bottom-right') addDirections['bottom-right'] = br + (brImp ? ' !important' : '');
                                        }
                                    }

                                    var removeDirLength = removeDirections.length;
                                    for (var i = 0; i < removeDirLength; i++) {
                                        var dir = removeDirections[i];

                                        var action = 'skip';
                                        if (i + 1 == removeDirLength && addDirections.length == 0) {
                                            action = 'do';
                                        }

                                        var propName = getPropName(type, dir);
                                        updateBorderRadiusRView(propName, null);
                                        commitObjValue(obj, propName, null, false, action, true);
                                    }

                                    var dirKeys = Object.keys(addDirections);
                                    var keysLength = dirKeys.length
                                    for (var i = 0; i < keysLength; i++) {
                                        var dir = dirKeys[i];
                                        var dirValue = addDirections[dir];

                                        if (dirValue !== undefined) {
                                            var action = 'skip';
                                            if (i + 1 == keysLength) {
                                                action = 'do';
                                            }

                                            var propName = getPropName(type, dir);
                                            var oldValue = valuesNum[dir].value;
                                            if (valuesNum[dir].forceDispatch) oldValue = null;
                                            var dispatchNow = shouldDispatchEvent(dispatchEvent, dirValue, oldValue);
                                            commitObjValue(obj, propName, dirValue, false, action, dispatchNow);

                                            if (dir == '') {
                                                for (var j = 1; j < directions.length; j++) {
                                                    var currValue = getBorderForDirectionFrom(type, dirValue, directions[j]);
                                                    var currPropName = getPropName(type, directions[j]);
                                                    fieldInputs[currPropName].setValue(currValue);
                                                    updateBorderRadiusRView(currPropName, currValue);
                                                }
                                            }
                                            else {
                                                fieldInputs[propName].setValue(dirValue);
                                                updateBorderRadiusRView(propName, dirValue);
                                            }
                                        }
                                    }

                                    return value;
                                }

                                var onBorderStyleClicked = function (e) {
                                    var $window = $(e.view);
                                    var $borderStyle = $(e.target).closest('.border-style');
                                    var $crsaField = $borderStyle.closest('.crsa-field');

                                    $borderStyleMenu.data('border-style', $borderStyle);
                                    $borderStyleMenu.data('prop', $crsaField.data('crsa-field'));
                                    $overlayBorder.insertAfter($crsaField);
                                    $borderStyleMenu.insertAfter($crsaField);


                                    var offset = $borderStyle.offset();
                                    var top = offset.top + 21;
                                    var left = offset.left;

                                    if (top + $borderStyleMenu.height() > $window.height()) {
                                        top = top - ($borderStyleMenu.height() + 23);

                                        $borderStyleMenu.css({
                                            'top': top,
                                            'left': left
                                        });
                                    }
                                    else {
                                        $borderStyleMenu.css({
                                            'top': top,
                                            'left': left
                                        });
                                    }
                                }

                                var updateBorderRadiusRView = function (prop, value) {
                                    if (value == 0) {
                                        $borderAndBoderRaduis.css(prop, value);
                                    }
                                    else {
                                        $borderAndBoderRaduis.css(prop, '');
                                    }
                                }

                                var toggleBordderIcon = function (e, control) {
                                    var $target = $(e.currentTarget);
                                    $target.toggleClass('active');
                                    borderBtnActive = $target.hasClass('active');
                                    if (borderBtnActive) {
                                        var allValues = {};
                                        var allTypes = ['width', 'style', 'color'];
                                        var directions = ['top', 'left', 'right', 'bottom'];

                                        for (var i = 0; i < directions.length; i++) {
                                            var currDir = directions[i];
                                            for (var j = 0; j < allTypes.length; j++) {
                                                var currType = allTypes[j];

                                                var currValue = borderObjs['border-' + currDir][currType];
                                                if (currValue && currValue.value) {
                                                    allValues[currType] = currValue.value;
                                                    if (currValue.important) {
                                                        allValues[currType] += " !important";
                                                    }
                                                    allTypes.splice(j, 1);
                                                    j--
                                                }
                                            }
                                        }

                                        setBorderValue(control.obj, 'border', 'top', allValues, true);
                                    }
                                }

                                var toggleRaduisIcon = function (e, control) {
                                    var $target = $(e.currentTarget);
                                    $target.toggleClass('active');
                                    raduisBtnActive = $target.hasClass('active');

                                    if (raduisBtnActive) {
                                        var directions = ['top-left', 'top-right', 'bottom-right', 'bottom-left'];

                                        var obj = control.obj;

                                        for (var i = 0; i < directions.length; i++) {
                                            var propName = getPropName('radius', directions[i]);
                                            var pgField = fieldInputs[propName];
                                            var value = pgField.getValue()

                                            if (value) {
                                                setBorderRadiusValue(obj, 'radius', directions[i], value, true);
                                                break;
                                            }
                                        }
                                    }
                                }

                                var setBorderRadiusFromControl = function (control) {
                                    var values = getValuesFromObj(control.obj);

                                    if (values['border-radius']) {
                                        var borderRadiusValues = fillBorderRadiusValues(values['border-radius']);
                                        var props = Object.keys(borderRadiusValues);

                                        // check if we can parse border radius value
                                        if (props.length > 0) {
                                            for (var i = 0; i < borderRadius.length; i++) {
                                                var prop = 'border-' + borderRadius[i].prop + '-radius';
                                                control.values[prop] = borderRadiusObjs[prop] = borderRadiusValues[borderRadius[i].prop].value || borderRadiusValues[borderRadius[i].prop];
                                            }
                                        }
                                    }
                                    else {
                                        for (var i = 0; i < borderRadius.length; i++) {
                                            var value = '';

                                            var prop = 'border-' + borderRadius[i].prop + '-radius';
                                            if (values[prop]) value = values[prop].value || values[prop];

                                            control.values[prop] = borderRadiusObjs[prop] = value;
                                        }
                                    }
                                }

                                var setBorderFromControl = function (control) {
                                    var allDirections = ['', 'top', 'left', 'right', 'bottom'];
                                    var allStyles = ['', 'width', 'style', 'color'];

                                    var ruleAndCs = getRuleFromObj(control.obj);
                                    var rule = ruleAndCs.rule;

                                    var addAllStylesBorderValue = function (currDir, currType, currValue, important) {
                                        if (currType == '') {
                                            var valArr = getTokens(currValue, ' ');
                                                valArr = valArr.filter(function (val) { if (val) return true; return false; });

                                            var borderAllValues = fillBorderValues(valArr);
                                            for (var styleName in borderAllValues) {
                                                var styleValue = borderAllValues[styleName];

                                                borderObjs['border-' + currDir][styleName] = {
                                                    value: styleValue,
                                                    important: important
                                                }
                                            }
                                        }
                                        else {
                                            borderObjs['border-' + currDir][currType] = {
                                                value: currValue,
                                                important: important
                                            };
                                        }
                                    }


                                    for (var i = 0; i < allDirections.length; i++) {
                                        var dir = allDirections[i];

                                        for (var j = 0; j < allStyles.length; j++) {
                                            var borderType = allStyles[j];

                                            var fullPropName = getPropName('border', dir, borderType);

                                            var nodeInside = pinegrow.pgPostCSSHelper.findNodeInside('decl', 'prop', fullPropName, rule);
                                            if (nodeInside) {
                                                if (dir == '') {
                                                    var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);

                                                    for (var k = 1; k < allDirections.length; k++) {
                                                        var currDir = allDirections[k];
                                                        addAllStylesBorderValue(currDir, borderType, nodeInsideValue.value, nodeInsideValue.important);
                                                    }
                                                }
                                                else {
                                                    var nodeInsideValue = valueHasImportant(nodeInside.value, nodeInside.important);
                                                    addAllStylesBorderValue(dir, borderType, nodeInsideValue.value, nodeInsideValue.important);
                                                }
                                            }
                                        }
                                    }
                                }

                                var updateBorderIcon = function () {
                                    var top = borderObjs['border-top'];
                                    var left = borderObjs['border-left'];
                                    var right = borderObjs['border-right'];
                                    var bottom = borderObjs['border-bottom'];

                                    var active = false;

                                    var getValue = function (object, key, defaultValue) { return object ? object[key] || defaultValue : defaultValue; }
                                    var getWImpValue  = function (object) { return getValue(object.width, 'important', false); }
                                    var getWidthValue = function (object) { return getValue(object.width, 'value', null); }
                                    var getStyleValue = function (object) { return getValue(object.style, 'value', null); }
                                    var getColorValue = function (object) { return getValue(object.color, 'value', null); }

                                    var isOneWidthNotUndefined = top.width || left.width || right.width || bottom.width;
                                    var sameImportant = isOneWidthNotUndefined && getWImpValue(top) == getWImpValue(left) && getWImpValue(left) == getWImpValue(right) && getWImpValue(right) == getWImpValue(bottom);
                                    var sameWidth = isOneWidthNotUndefined && getWidthValue(top) == getWidthValue(left) && getWidthValue(left) == getWidthValue(right) && getWidthValue(right) == getWidthValue(bottom);

                                    var isOneStyleNotUndefined = top.style || left.style || right.style || bottom.style;
                                    var sameStyle = isOneStyleNotUndefined && getStyleValue(top) == getStyleValue(left) && getStyleValue(left) == getStyleValue(right) && getStyleValue(right) == getStyleValue(bottom);

                                    var isOneColorNotUndefined = top.color || left.color || right.color || bottom.color;
                                    var sameColor = isOneColorNotUndefined && getColorValue(top) == getColorValue(left) && getColorValue(left) == getColorValue(right) && getColorValue(right) == getColorValue(bottom);

                                    var allUndifined = !isOneWidthNotUndefined && !isOneStyleNotUndefined && !isOneColorNotUndefined;

                                    if (allUndifined) {
                                        active = false;
                                    }
                                    else {
                                        var width = true;
                                        if (isOneWidthNotUndefined && (!sameImportant || !sameWidth)) width = false;

                                        var style = true;
                                        if (isOneStyleNotUndefined && !sameStyle) style = false;

                                        var color = true;
                                        if (isOneColorNotUndefined && !sameColor) color = false;

                                        if (width && style && color) {
                                            active = true;
                                        }
                                    }

                                    if (active) {
                                        $changeWidthIcon.addClass('active');
                                        borderBtnActive = true;
                                    }
                                    else {
                                        $changeWidthIcon.removeClass('active');
                                        borderBtnActive = false;
                                    }
                                }

                                var updateBorderRadiusIcon = function () {
                                    var topLeft = borderRadiusObjs['border-top-left-radius'];
                                    var topRight = borderRadiusObjs['border-top-right-radius'];
                                    var bottomLeft = borderRadiusObjs['border-bottom-left-radius'];
                                    var bottomRight = borderRadiusObjs['border-bottom-right-radius'];


                                    if (topLeft && topLeft == topRight && topRight == bottomLeft && bottomLeft == bottomRight) {
                                        $changeBorderStyleIcon.addClass('active');
                                        raduisBtnActive = true;
                                    }
                                    else {
                                        $changeBorderStyleIcon.removeClass('active');
                                        raduisBtnActive = false;
                                    }
                                }

                                c.onDefine = function() {
                                    for (var i = 0; i < borderRadius.length; i++) {
                                        var prop = 'border-' + borderRadius[i].prop + '-radius';
                                        this.registerInputField(prop, borderRadius[i].fdef);
                                    }

                                    for (var i = 0; i < borders.length; i++) {
                                        this.registerInputField(prop, borders[i].prop, borders[i].fdef);
                                    }
                                }

                                c.onShow = function() {
                                    var _this = this;
                                    var $mainContainer = $('<div class="border-radius-container text-center"></div>');
                                    var $container = $('<div class="control-container"></div>').appendTo($mainContainer);

                                    setBorderRadiusFromControl(this);
                                    setBorderFromControl(this);

                                    for (var i = 0; i < borderRadius.length; i++) {
                                        var prop = 'border-' + borderRadius[i].prop + '-radius';
                                        var iconClass = '';//borderRadius[i].icon;

                                        var borderRadiusProp = this.showInputField($container, prop, borderRadius[i].fdef);
                                        fieldInputs[prop] = borderRadiusProp;
                                        var $borderRadiusField = borderRadiusProp.$field;
                                        $borderRadiusField.addClass('crsa-small-input crsa-align-left-input crsa-inline-container aaahas-icon-before');
                                        //$('<i class="' + iconClass + '"></i>').insertBefore($borderRadiusField.find('input'));
                                    }

                                    $borderAndBoderRaduis = $('<div class="border-radius-border"></div>').appendTo($container);

                                    for (var i = 0; i < borders.length; i++) {
                                        var prop = borders[i].prop;
                                        var border = this.showInputField($container, prop, borders[i].fdef);
                                        borders[i].obj = border;
                                        fieldInputs[prop] = border;

                                        var $border = border.$field;
                                        $border.addClass('crsa-small-input crsa-align-left-input triple-input');
                                        var $input = $border.find('input');

                                        /*
                                        $input.on('change', function(e) {

                                        })*/

                                        var $colorInput = $('<input class="color-input" type="text">').insertAfter($input);
                                        $colorInput.data('crsa-field', prop);
                                        $colorInput.spectrum({
                                            showAlpha: true,
                                            color: borderObjs[prop].color ? borderObjs[prop].color.value || 'black' : 'black',
                                            // preferredFormat: "hex6",
                                            showInput: true,
                                        });

                                        var updateBorderColorUsingProp = function (tinycolor, prop, dispatchEvent) {
                                            if (tinycolor) {
                                                var direction = prop.split('-')[1];
                                                var newColor = getNewColor(tinycolor);
                                                if (borderObjs[prop].color) {
                                                    newColor += borderObjs[prop].color.important ? ' !important' : '';
                                                }
                                                setBorderValue(_this.obj, 'border', direction, { 'color': newColor }, dispatchEvent);
                                            }
                                        }

                                        var updateBorderColor = function (e, tinycolor) {
                                            var prop = $(e.target).data('crsa-field');
                                            updateBorderColorUsingProp(tinycolor, prop, e.type != "move");
                                        }

                                        $colorInput.on('move.spectrum', updateBorderColor);
                                        $colorInput.on('change.spectrum', updateBorderColor);
                                        $colorInput.on('hide.spectrum', updateBorderColor);

                                        pgSpectrumHelper && pgSpectrumHelper.remove();

                                        var pgSpectrumHelper = new PgSpectrumHelper($colorInput, {
                                            'mouse-moved': function ($el) {
                                                var color = $el.spectrum('get');
                                                var prop = $el.data('crsa-field');
                                                updateBorderColorUsingProp(color, prop, false);
                                            },
                                            'color-picked': null
                                        });

                                        var borderAttr = 'class="border-value';
                                        var borderStyle = borderObjs[prop].style ? borderObjs[prop].style.value : '';
                                        if (!borderStyle || borderStyle == "none") {
                                            borderAttr += ' icon-minus"';
                                        }
                                        else {
                                            borderAttr += '" style="border-style:' + borderStyle;
                                            if (borderStyle == "double") {
                                                borderAttr += ";border-width:3px";
                                            }
                                            borderAttr += ';"'
                                        }

                                        var viewValue = borderStyle;
                                        if (viewValue == "none") viewValue = 'solid';
                                        $borderAndBoderRaduis.css(prop + '-style', viewValue);

                                        var $borderStyle = $('<div class="border-style"><div ' + borderAttr + '></div></div>').insertAfter($input);
                                    }

                                    $container.find('.border-style').on('click', onBorderStyleClicked);

                                    var $changeAllContainer = $('<div class="change-all-container"></div>').appendTo($mainContainer);

                                    $changeWidthIcon = $('<div data-type="width" class="change-all-icon"><i class="icon-same"></i></div>').appendTo($changeAllContainer);
                                    $changeWidthIcon.on('click', function (e) {
                                        toggleBordderIcon(e, _this)
                                    });

                                    addTooltip($changeWidthIcon, 'Use the same border on all four sides')

                                    $changeBorderStyleIcon = $('<div class="change-all-border-raduis"><i class="icon-round_lu"></i><i class="icon-same"></i></div>').appendTo($changeAllContainer);
                                    addTooltip($changeBorderStyleIcon, 'Use same radius in all four corners.')
                                    $changeBorderStyleIcon.on('click', function (e) {
                                        toggleRaduisIcon(e, _this);
                                    });

                                    updateBorderIcon();

                                    init = true;
                                    return $mainContainer;
                                }

                                c.onSetValues = function() {
                                    borderRadiusObjs = {
                                        'border-top-left-radius': null,
                                        'border-top-right-radius': null,
                                        'border-bottom-left-radius': null,
                                        'border-bottom-right-radius': null
                                    };

                                    setBorderRadiusFromControl(this);

                                    for (var i = 0; i < borderRadius.length; i++) {
                                        var prop = 'border-' + borderRadius[i].prop + '-radius';
                                        fieldInputs[prop].setValue(borderRadiusObjs[prop]);
                                        updateBorderRadiusRView(prop, this.values[prop]);
                                    }

                                    updateBorderRadiusIcon();

                                    borderObjs = {
                                        'border-top': {},
                                        'border-bottom': {},
                                        'border-left': {},
                                        'border-right': {}
                                    };

                                    setBorderFromControl(this);

                                    for (var i = 0; i < borders.length; i++) {
                                        var prop = borders[i].prop;
                                        var propObj = borders[i].obj;

                                        var width = borderObjs[prop].width ? borderObjs[prop].width.value : null;
                                        if (width && borderObjs[prop]['width'].important) width += ' !important';
                                        propObj.setValue(width);

                                        var $borderStyle = borders[i].obj.$field.find('.border-style');
                                        borderTypeChanged($borderStyle, prop, borderObjs[prop].style ? borderObjs[prop].style.value || 'none' : 'none');

                                        var $colorInput = propObj.$field.find('.color-input');
                                        $colorInput.spectrum("set", borderObjs[prop].color ? borderObjs[prop].color.value || 'black' : 'black');
                                    }

                                    updateBorderIcon();
                                }

                                return c;
                            }
                        },
                        'outline' : {
                            name : 'Outline',
                            type : 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            open_list_on_focus: true,
                            options:[
                                {key:'none', name:'None'},
                                {key:'1px solid #cccccc', name:'1px solid #cccccc'},
                            ]
                        },
                        'outline-offset' : {
                            name : 'Outline offset',
                            type : 'slider',
                            style_input: true,
                            slider_def_unit: 'px'
                        },
                    }
                },

                flex : {
                    name : 'Flex container',
                    icons : true,
                    get_has_data: cssPropsRe('flex_container'),
                    fields : {
                        'flex-direction' : {
                            name : 'Direction',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'row',
                                    'name' : 'Row',
                                    'html': bm.makeIcon('225', { attributes: { 'title': 'Row' } })
                                },
                                {
                                    'key' : 'row-reverse',
                                    'name' : 'Row reverse',
                                    html: bm.makeIcon('224', { attributes: { 'title': 'Row reverse' } })
                                },
                                {
                                    'key' : 'column',
                                    'name' : 'Column',
                                    'html': bm.makeIcon('227', { attributes: { 'title': 'Column' } })
                                },
                                {
                                    'key' : 'column-reverse',
                                    'name' : 'Column reverse',
                                    'html': bm.makeIcon('226', { attributes: { 'title': 'Column reverse' } })
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'flex-align-items' : {
                            name: 'Align items',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            css_property: 'align-items',
                            options:[
                                {
                                    'key' : 'flex-start',
                                    'name' : 'Start',
                                    'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-start')
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html': bm.makeIcon('221', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('align-items', 'center')
                                },
                                {
                                    'key' : 'flex-end',
                                    'name' : 'End',
                                    'html': bm.makeIcon('220', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-end')
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    'html': bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignBlock('align-items', 'stretch')
                                },
                                {
                                    'key' : 'baseline',
                                    'name' : 'Baseline',
                                    'html': bm.makeIcon('212', { attributes: { 'title': 'Baseline' } })
                                    //'html' : getFlexAlignBlock('align-items', 'baseline')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'flex-justify-content' : {
                            name: 'Justify content',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            css_property: 'justify-content',
                            options:[
                                {
                                    'key' : 'flex-start',
                                    'name' : 'Start',
                                    'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'flex-start')
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html': bm.makeIcon('219', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'center')
                                },
                                {
                                    'key' : 'flex-end',
                                    'name' : 'End',
                                    'html': bm.makeIcon('218', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'flex-end')
                                },
                                {
                                    'key' : 'space-between',
                                    'name' : 'Space between',
                                    'html': bm.makeIcon('206', { attributes: { 'title': 'Space between' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-between')
                                },
                                {
                                    'key' : 'space-around',
                                    'name' : 'Space around',
                                    'html': bm.makeIcon('205', { attributes: { 'title': 'Space around' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-around')
                                },
                                {
                                    'key' : 'space-evenly',
                                    'name' : 'Space evenly',
                                    'html': bm.makeIcon('205', { attributes: { 'title': 'Space evenly' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-around')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'flex-wrap' : {
                            name: 'Wrap',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'wrap',
                                    'name' : 'Wrap',
                                    html: bm.makeIcon('204', { attributes: { 'title': 'Wrap' } })
                                    //'html' : getFlexAlignBlock('flex-wrap', 'wrap')
                                },
                                {
                                    'key' : 'nowrap',
                                    'name' : 'No wrap',
                                    html: bm.makeIcon('203', { attributes: { 'title': 'No wrap' } })
                                    //'html' : getFlexAlignBlock('flex-wrap', 'wrap')
                                },
                                {
                                    'key' : 'wrap-reverse',
                                    'name' : 'Wrap reverse',
                                    html: bm.makeIcon('202', { attributes: { 'title': 'Wrap reverse' } })
                                    //'html' : getFlexAlignBlock('flex-wrap', 'wrap-reverse')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'flex-align-content' : {
                            name: 'Align content',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            css_property: 'align-content',
                            options:[
                                {
                                    'key' : 'flex-start',
                                    'name' : 'Start',
                                    html: bm.makeIcon('217', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('align-content', 'flex-start', 4, true)
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    html: bm.makeIcon('215', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('align-content', 'center', 4, true)
                                },
                                {
                                    'key' : 'flex-end',
                                    'name' : 'End',
                                    html: bm.makeIcon('216', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('align-content', 'flex-end', 4, true)
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    html: bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignBlock('align-content', 'stretch', 2, true)
                                },
                                {
                                    'key' : 'space-between',
                                    'name' : 'Space between',
                                    html: bm.makeIcon('210', { attributes: { 'title': 'Space between' } })
                                    //'html' : getFlexAlignBlock('align-content', 'space-between', 4, true)
                                },
                                {
                                    'key' : 'space-around',
                                    'name' : 'Space around',
                                    html: bm.makeIcon('209', { attributes: { 'title': 'Space around' } })
                                    //'html' : getFlexAlignBlock('align-content', 'space-around', 4, true)
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Gap',
                            placeholder: '10px',
                            //icon: 'icon-gap',
                            has_multiple_fields: true,
                        },
                        'row-gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Row gap',
                            placeholder: '10px',
                            //icon: 'icon-row-gap',
                            has_multiple_fields: true,
                        },
                        'column-gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Column gap',
                            placeholder: '10px',
                            //icon: 'icon-column-gap',
                            has_multiple_fields: true,
                        },
                    }
                },

                'flex-child' : {
                    name : 'Flex child',
                    icons : true,
                    get_has_data: cssPropsRe('flex_child'),
                    fields : {
                        'flex-basis' : {
                            name: 'Basis',
                            type: 'slider',
                            style_input: true
                        },
                        'flex-size' : {
                            type: 'custom',
                            name: 'Size',
                            action: 'none',
                            control: function () {
                                var c = new PgCustomPropertyControl('css-flex-grow-shrink');

                                c.onDefine = function() {
                                    this.registerInputField('flex-grow', addCssNumberDef('Gr.', '', {
                                        add_default_unit: ''
                                    }));
                                    this.registerInputField('flex-shrink', addCssNumberDef('Shr.', '', {
                                        add_default_unit: ''
                                    }));
                                }

                                c.onShow = function() {
                                    var $container = $('<div class="crsa-grid-fields double-fields">\
                                        <table class="crsa-grid-table">\
                                            <tbody>\
                                                <tr>\
                                                </tr>\
                                            </tbody>\
                                        </table>\
                                    </div>');

                                    var $mainTr = $container.find('tr');
                                    var $td = $('<td class="crsa-td-empty-width"></td>').appendTo($mainTr);

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Grow</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var flexGrow = this.showInputField($td, 'flex-grow', addCssNumberDef('Grow', '', {style_input: true, add_default_unit: '', slider_def_unit: ''}));
                                    flexGrow.$field.addClass('crsa-inline-container');

                                    $td = $('<td></td>').appendTo($mainTr);

                                    var $tr = $('<table><tbody><tr></tr></tbody></table>').appendTo($td).find('tr');

                                    $('<td><label>Shrink</label></td>').appendTo($tr);
                                    $td = $('<td></td>').appendTo($tr);

                                    var flexShrink = this.showInputField($td, 'flex-shrink', addCssNumberDef('Shrink', '', {style_input: true, add_default_unit: '', slider_def_unit: ''}));
                                    flexShrink.$field.addClass('crsa-inline-container');

                                    return $container;
                                }

                                c.onSetValues = function() {
                                }

                                return c;
                            }
                        },
                        'order' : {
                            name: 'Order',
                            type : 'slider',
                            show_empty: true,
                            style_input: true,
                            add_default_unit: '',
                            slider_def_unit: '',
                            // toggle_buttons : true,
                            // options:[
                            //     {
                            //         'key' : '0',
                            //         'name' : 'Auto',
                            //         html: bm.makeIcon('209', { attributes: { 'title': 'Auto' } })
                            //         //'html' : getFlexAlignSelfBlock('order', '0', 2)
                            //     },
                            //     {
                            //         'key' : '-1',
                            //         'name' : 'First',
                            //         html: bm.makeIcon('209', { attributes: { 'title': 'First' } })
                            //         //'html' : getFlexAlignSelfBlock('order', '-1', 2)
                            //     },
                            //     {
                            //         'key' : '1',
                            //         'name' : 'Last',
                            //         html: bm.makeIcon('209', { attributes: { 'title': 'Last' } })
                            //         //'html' : getFlexAlignSelfBlock('order', '1', 2)
                            //     }
                            // ]
                        },
                        'flex-align-self' : {
                            name: 'Align self',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            css_property: 'align-self',
                            options:[
                                {
                                    'key' : 'flex-start',
                                    'name' : 'Start',
                                    html: bm.makeIcon('211', { attributes: { 'title': 'Start' } })
                                   // 'html' : getFlexAlignSelfBlock('align-self', 'flex-start', 2)
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    html: bm.makeIcon('213', { attributes: { 'title': 'Center' } })
                                   // 'html' : getFlexAlignSelfBlock('align-self', 'center', 2)
                                },
                                {
                                    'key' : 'flex-end',
                                    'name' : 'End',
                                    html: bm.makeIcon('208', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignSelfBlock('align-self', 'flex-end', 2)
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    html: bm.makeIcon('207', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignSelfBlock('align-self', 'stretch', 2)
                                },
                                {
                                    'key' : 'baseline',
                                    'name' : 'Baseline',
                                    html: bm.makeIcon('212', { attributes: { 'title': 'Baseline' } })
                                    //'html' : getFlexAlignSelfBlock('align-self', 'baseline', 1)
                                }
                            ]
                        }
                    }
                },

                'box-shadow' : {
                    name : 'Box shadow',
                    icons : true,
                    get_has_data: /box\-shadow/i,
                    fields : {
                        'box-shadow_control' : {
                            type: 'custom',
                            name: 'Shadow',
                            action: 'none',
                            control: function () {
                                var panelInputControl = null;
                                var c = new PgCustomPropertyControl('css-box-shadow');
                                var lastId = 0, titleId = 1;

                                var addNewPanel = function (no_click) {
                                    var p = panelInputControl.addPanel(lastId, titleId);
                                    var $panel = p.$panel;
                                    p.$collapse_link.click();
                                    //$panel.find('> .panel-heading .collapsed').click();
                                    lastId++;
                                    titleId++;
                                }

                                c.onDefine = function() {
                                }

                                c.onShow = function() {
                                    var _this = this;

                                    var $container = $('<div class="box-shadow-container"></div>');

                                    panelInputControl = new PgPanelInputControl($container, 'box-shadow', "Shadow");
                                    var $add = $('<a href="#" class="btn btn-default add-btn"><i class="icon icon-plus"></i> Add Shadow</a>').appendTo($container);

                                    panelInputControl.onAdd = function ($body, i) {
                                        if (!boxShadowRotation[i]) boxShadowRotation[i] = {};
                                        boxShadowRotation[i].type = _this.values['box-shadow-type-' + i] = "outside";
                                        var fields = ['distance', 'blur', 'size', 'color', 'rotate', 'x', 'y', 'type'];
                                        addShadowField($body, 'box-shadow', i, _this, fields, boxShadowRotation, bShadowImportant);
                                        $body.data('box-shadow-rotation', boxShadowRotation[i]);
                                    }

                                    panelInputControl.onDelete = function (i) {
                                        delete _this.values['box-shadow-distance-' + i];
                                        delete _this.values['box-shadow-blur-' + i];
                                        delete _this.values['box-shadow-size-' + i];
                                        delete _this.values['box-shadow-color-' + i];
                                        delete _this.values['box-shadow-x-' + i];
                                        delete _this.values['box-shadow-y-' + i];
                                        delete _this.values['box-shadow-type-' + i];

                                        deleteCssShadowValue(_this.obj, 'box-shadow', _this.values, i, boxShadowRotation, bShadowImportant);
                                        titleId--;
                                    }

                                    $add.on('click', function (e) { addNewPanel(); e.preventDefault(); });

                                    return $container;
                                }

                                c.onSetValues = function() {
                                    lastId = 0;
                                    titleId = 1;
                                    boxShadowRotation = [];
                                    bShadowImportant = false;

                                    pgRemoveSpectrum(panelInputControl.$container);
                                    panelInputControl.clear();

                                    var obj = getShadowMultiValues(this.values['box-shadow']);
                                    var shadowValues = obj.tokens;
                                    bShadowImportant = obj.important;

                                    var declChar = this.obj.pgStylesheet.getDeclCharachter();

                                    for (var i = 0; i < shadowValues.length; i++) {
                                        var hasCorrectVal = fillShadowValues('box-shadow', shadowValues, this.values, boxShadowRotation, i, declChar);
                                        var $body = panelInputControl.addPanel(lastId, titleId, true).$body;

                                        if (hasCorrectVal) {
                                            var fields = ['distance', 'blur', 'size', 'color', 'rotate', 'x', 'y', 'type'];
                                            addShadowField($body, 'box-shadow', i, this, fields, boxShadowRotation, bShadowImportant);
                                        }
                                        else {
                                            boxShadowRotation[i] = {};
                                            boxShadowRotation[i].text = this.values['box-shadow-' + i] = shadowValues[i].join(' ');

                                            var boxShadowField = this.showInputField($body, 'box-shadow-' + i, addCssTextDef("Box shadow", "shadow", {
                                                'without_text': false,
                                                'without_icon': false,
                                                'action' : 'custom',
                                                'index': i,
                                                get_value: function (obj) {
                                                    // nothing
                                                },
                                                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                                                    return setCSSValueForShadow(obj, values, 'box-shadow', 'box-shadow', value, fieldDef.index, boxShadowRotation);
                                                }
                                            }));
                                        }
                                        lastId++;
                                        titleId++;
                                    }
                                    //if (titleId == 1 && pgf.kids) addNewPanel(true);

                                    panelInputControl.getPanelGroup().find('> .panel:first-child > .panel-collapse').addClass('in');
                                }

                                return c;
                            }
                        }
                    }
                },

                'text-shadow' : {
                    name : 'Text shadow',
                    icons : true,
                    get_has_data: /text\-shadow/i,
                    fields : {
                        'text-shadow_control' : {
                            type: 'custom',
                            name: 'Shadow',
                            action: 'none',
                            control: function () {
                                var panelInputControl = null;
                                var c = new PgCustomPropertyControl('css-text-shadow');
                                var lastId = 0, titleId = 1;

                                var addNewPanel = function () {
                                    var $panel = panelInputControl.addPanel(lastId, titleId).$panel;
                                    $panel.find('> .panel-heading .collapsed').click();
                                    lastId++;
                                    titleId++;
                                }

                                c.onDefine = function() {
                                }

                                c.onShow = function() {
                                    var _this = this;

                                    var $container = $('<div class="text-shadow-container"></div>');

                                    panelInputControl = new PgPanelInputControl($container, 'text-shadow', "Shadow");
                                    var $add = $('<a href="#" class="btn btn-default add-btn"><i class="icon icon-plus"></i> Add Shadow</a>').appendTo($container);

                                    panelInputControl.onAdd = function ($body, i) {
                                        if (!textShadowRotation[i]) textShadowRotation[i] = {};
                                        textShadowRotation[i].type = _this.values['text-shadow-type-' + i] = "outside";
                                        var fields = ['distance', 'blur', 'color', 'rotate', 'x', 'y', 'nonetype'];
                                        addShadowField($body, 'text-shadow', i, _this, fields, textShadowRotation, tShadowImportant);
                                        $body.data('text-shadow-rotation', textShadowRotation[i]);
                                    }

                                    panelInputControl.onDelete = function (i) {
                                        delete _this.values['text-shadow-distance-' + i];
                                        delete _this.values['text-shadow-blur-' + i];
                                        delete _this.values['text-shadow-size-' + i];
                                        delete _this.values['text-shadow-color-' + i];
                                        delete _this.values['text-shadow-x-' + i];
                                        delete _this.values['text-shadow-y-' + i];
                                        delete _this.values['text-shadow-type-' + i];

                                        deleteCssShadowValue(_this.obj, 'text-shadow', _this.values, i, textShadowRotation, tShadowImportant);
                                        titleId--;
                                    }

                                    $add.on('click', function (e) { addNewPanel(); e.preventDefault(); });

                                    return $container;
                                }

                                c.onSetValues = function() {
                                    lastId = 0;
                                    titleId = 1;
                                    textShadowRotation = [];
                                    tShadowImportant = false;

                                    pgRemoveSpectrum(panelInputControl.$container);
                                    panelInputControl.clear();

                                    var obj = getShadowMultiValues(this.values['text-shadow']);
                                    var shadowValues = obj.tokens;
                                    tShadowImportant = obj.important;

                                    var declChar = this.obj.pgStylesheet.getDeclCharachter();

                                    for (var i = 0; i < shadowValues.length; i++) {
                                        var hasCorrectVal = fillShadowValues('text-shadow', shadowValues, this.values, textShadowRotation, i, declChar);
                                        var $body = panelInputControl.addPanel(lastId, titleId, true).$body;

                                        if (hasCorrectVal) {
                                            var fields = ['distance', 'blur', 'color', 'rotate', 'x', 'y', 'nonetype'];
                                            addShadowField($body, 'text-shadow', i, this, fields, textShadowRotation, tShadowImportant);
                                        }
                                        else {
                                            textShadowRotation[i] = {};
                                            var $boxShadowField = this.showInputField($body, 'text-shadow-' + i, addCssTextDef("Box shadow", "shadow", {
                                                'without_text': false,
                                                'without_icon': false,
                                                'action' : 'custom',
                                                'index': i,
                                                get_value: function (obj) {
                                                    // nothing
                                                },
                                                set_value:function (obj, value, values, oldValue, eventType, fieldDef) {
                                                    return setCSSValueForShadow(obj, values, 'text-shadow', 'text-shadow', value, fieldDef.index, textShadowRotation);
                                                }
                                            }));
                                        }
                                        lastId++;
                                        titleId++;
                                    }

                                    //if (titleId == 1 && pgf.kids) addNewPanel();

                                    panelInputControl.getPanelGroup().find('> .panel:first-child > .panel-collapse').addClass('in');
                                }

                                return c;
                            }
                        }
                    }
                },

                'transforms' : {
                    name : 'Transforms',
                    icons : true,
                    get_has_data: /(transform|perspective)/i,
                    fields : {
                        'transform_control' : {
                            type: 'custom',
                            name: 'transform',
                            action: 'none',
                            control: function () {
                                var panelInputControl = null;
                                var c = new PgCustomPropertyControl('css-transform');
                                var lastId = 0, titleId = 1;

                                var addNewPanel = function () {
                                    var $panel = panelInputControl.addPanel(lastId, titleId).$panel;
                                    $panel.find('> .panel-heading .collapsed').click();
                                    lastId++;
                                    titleId++;
                                }

                                c.onDefine = function() {
                                }

                                c.onShow = function() {
                                    var _this = this;

                                    var $container = $('<div class="transform-container"></div>');

                                    panelInputControl = new PgPanelInputControl($container, 'transform', "Transform");
                                    var $add = $('<a href="#" class="btn btn-default add-btn"><i class="icon icon-plus"></i> Add Transform</a>').appendTo($container);

                                    panelInputControl.onAdd = function ($body, i) {
                                        if (!transformObjArr[i]) transformObjArr[i] = {};
                                        transformObjArr[i].type = _this.values['transform-type-' + i] = 'translate';
                                        addTransformFields($body, _this, i, transformImportant);
                                        $body.data('text-shadow-rotation', transformObjArr[i]);
                                    }

                                    panelInputControl.onDelete = function (i) {
                                        if (_this.values['transform-text-' + i]) {
                                            delete _this.values['transform-text-' + i];
                                        }
                                        if (_this.values['transform-type-' + i] == 'translate') {
                                            delete _this.values['transform-translate-x-' + i];
                                            delete _this.values['transform-translate-y-' + i];
                                            delete _this.values['transform-translate-z-' + i];
                                        }
                                        else if (_this.values['transform-type-' + i] == 'scale') {
                                            delete _this.values['transform-scale-x-' + i];
                                            delete _this.values['transform-scale-y-' + i];
                                            delete _this.values['transform-scale-z-' + i];
                                        }
                                        else if (_this.values['transform-type-' + i] == 'rotate') {
                                            delete _this.values['transform-rotate-x-' + i];
                                            delete _this.values['transform-rotate-y-' + i];
                                            delete _this.values['transform-rotate-z-' + i];
                                        }
                                        else if (_this.values['transform-type-' + i] == 'skew') {
                                            delete _this.values['transform-skew-x-' + i];
                                            delete _this.values['transform-skew-y-' + i];
                                        }
                                        delete _this.values['transform-type-' + i];

                                        deleteCssTransformValue(_this, i, transformImportant);
                                        titleId--;
                                    }

                                    $add.on('click', function (e) { addNewPanel(); e.preventDefault(); });

                                    return $container;
                                }

                                c.onSetValues = function() {
                                    lastId = 0;
                                    titleId = 1;

                                    transformObjArr = [];
                                    transformImportant = false;

                                    panelInputControl.clear();
                                    var transObj = getTransformMultiValues(this.values['transform']);
                                    var transformValues = transObj.tokens;
                                    transformImportant = transObj.important;

                                    var declChar = this.obj.pgStylesheet.getDeclCharachter();

                                    for (var i = 0; i < transformValues.length; i++) {
                                        var hasCorrectVal = fillTransformValues(transformValues, this.values, i, declChar);
                                        var $body = panelInputControl.addPanel(lastId, titleId, true).$body;

                                        if (hasCorrectVal) {
                                            addTransformFields($body, this, i, transformImportant);
                                        }
                                        else {
                                           transformObjArr[i] = {
                                                type: this.values['transform-type-' + i]
                                            };
                                            var $transformField = this.showInputField($body, 'transform-text-' + i, addCssTextDef("Transform", "", {
                                                'without_text': false,
                                                'without_icon': false,
                                                'action' : 'custom',
                                                'index': i,
                                                get_value: function (obj) {
                                                    // nothing
                                                },
                                                set_value: function (obj, value, values, oldValue, eventType, fieldDef) {
                                                    return setCSSValueForTransform(obj, values, 'text', value, fieldDef.index);
                                                }
                                            }));
                                        }
                                        lastId++;
                                        titleId++;
                                    }
                                    //if (titleId == 1) addNewPanel();

                                    panelInputControl.getPanelGroup().find('> .panel:first-child > .panel-collapse').addClass('in');
                                }

                                return c;
                            }
                        },
                        'transform-origin' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Transform origin'
                        },
                        'perspective' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Perspective'
                        },
                        'perspective-origin' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Perspective origin'
                        },
                        'transform-style' : {
                            type: 'select',
                            name: 'Trans. style',
                            show_empty: true,
                            style_input: true,
                            options: [
                                {key: 'flat', name: 'Flat'},
                                {key: 'preserve-3d', name: 'Preserve 3D'}
                            ]
                        }
                    }
                },

                'transitions' : {
                    name : 'Transitions',
                    icons : true,
                    get_has_data: /transition/i,
                    fields : {
                        'transition_control' : {
                            type: 'custom',
                            name: 'transition',
                            action: 'none',
                            control: function () {
                                var panelInputControl = null;
                                var c = new PgCustomPropertyControl('css-transition');
                                var lastId = 0, titleId = 1;

                                var addNewPanel = function () {
                                    var $panel = panelInputControl.addPanel(lastId, titleId).$panel;
                                    $panel.find('> .panel-heading .collapsed').click();
                                    lastId++;
                                    titleId++;
                                }

                                c.onDefine = function() {
                                }

                                c.onShow = function() {
                                    var _this = this;

                                    var $container = $('<div class="transform-container"></div>');

                                    panelInputControl = new PgPanelInputControl($container, 'transition', "Transition");
                                    var $add = $('<a href="#" class="btn btn-default add-btn"><i class="icon icon-plus"></i> Add Transition</a>').appendTo($container);

                                    panelInputControl.onAdd = function ($body, i) {
                                        if (!transitionObjArr[i]) transitionObjArr[i] = {};
                                        addTransitionFields($body, _this, i, transitionImportant);
                                    }

                                    panelInputControl.onDelete = function (i) {
                                        delete _this.values['transition-text-' + i];
                                        delete _this.values['transition-property-' + i];
                                        delete _this.values['transition-duration-' + i];
                                        delete _this.values['transition-timing-function-' + i];
                                        delete _this.values['transition-delay-' + i];

                                        deleteCssTransitionValue(_this, i, transitionImportant);
                                        titleId--;
                                    }

                                    $add.on('click', function (e) { addNewPanel(); e.preventDefault(); });

                                    return $container;
                                }

                                c.onSetValues = function() {
                                    lastId = 0;
                                    titleId = 1;

                                    transitionObjArr = [];
                                    transitionImportant = false;

                                    panelInputControl.clear();
                                    var values = getValuesFromObj(this.obj);
                                    var value = '';
                                    if (values['transition']) {
                                        value  = values['transition'].value || values['transition'];
                                    }
                                    // var transitionValues = getTransitionMultiValues(value);
                                    var transObj = getTransitionMultiValues(value);
                                    var transitionValues = transObj.tokens;
                                    transitionImportant = transObj.important;

                                    var declChar = this.obj.pgStylesheet.getDeclCharachter();

                                    for (var i = 0; i < transitionValues.length; i++) {
                                        var hasCorrectVal = fillTransitionValues(transitionValues[i], this.values, i, declChar);
                                        var $body = panelInputControl.addPanel(lastId, titleId, true).$body;

                                        if (hasCorrectVal) {
                                            addTransitionFields($body, this, i, transitionImportant);
                                        }
                                        else {
                                            transitionObjArr[i] = {};
                                            transitionObjArr[i].text = this.values['transition-text-' + i] = transitionValues[i];

                                            var $transitionField = this.showInputField($body, 'transition-text-' + i, addCssTextDef("Transition", "", {
                                                'without_text': false,
                                                'without_icon': false,
                                                'action' : 'custom',
                                                'index': i,
                                                get_value: function (obj) {
                                                    // nothing
                                                },
                                                set_value: function (obj, value, values, oldValue, eventType, fieldDef) {
                                                    return setCSSValueForTransition(obj, 'text', value, fieldDef.index);
                                                }
                                            }));
                                        }
                                        lastId++;
                                        titleId++;
                                    }
                                    //if (titleId == 1) addNewPanel();

                                    panelInputControl.getPanelGroup().find('> .panel:first-child > .panel-collapse').addClass('in');
                                }

                                return c;
                            }
                        }
                    }
                },

                'list' : {
                    name : 'Lists',
                    icons : true,
                    get_has_data: cssPropsRe('list'),
                    fields : {
                        'list-style-type' : {
                            name : 'List type',
                            type : 'select',
                            icon: 'icon-list-type',
                            show_empty: true,
                            style_input: true,
                            can_add_items: true,
                            options:[
                                {key:'disc', name:'Disc'},
                                {key:'circle', name:'Circle'},
                                {key:'square', name:'Square'},
                                {key:'decimal', name:'Decimal'},
                                {key:'decimal-leading-zero', name:'Decimal leading zero'},
                                {key:'lower-roman', name:'Lower roman'},
                                {key:'upper-roman', name:'Upper roman'},
                                {key:'lower-greek', name:'Lower greek'},
                                {key:'lower-latin', name:'Lower latin'},
                                {key:'upper-latin', name:'Upper latin'},
                                {key:'armenian', name:'Armenian'},
                                {key:'georgian', name:'Georgian'},
                                {key:'lower-alpha', name:'Lower alpha'},
                                {key:'upper-alpha', name:'Upper alpha'},
                                {key:'none', name:'None'}
                            ]
                        },
                        'list-style-position' : {
                            name : 'List position',
                            type : 'select',
                            icon: 'icon-list-pos',
                            show_empty: true,
                            style_input: true,
                            can_add_items: true,
                            options:[
                                {key:'inside', name:'Inside'},
                                {key:'outside', name:'Outside'},
                                {key:'inherit', name:'Inherit'}
                            ]
                        },
                        'list-style-image' : {
                            name : 'List image',
                            type : 'image',
                            style_input: true,
                            icon : 'icon-list-image',
                            'action' : 'custom',
                            get_value: function(obj, fn, styles) {
                                return getCssUrlValue(styles, 'list-style-image');
                            },
                            set_value: function(obj, value, values, oldValue, eventType) {
                                return setCssUrlValue(obj, 'list-style-image', value);
                            }
                        }
                    }
                },

                'grid-container' : {
                    name: 'Grid container',
                    get_has_data: cssPropsRe('grid_container'),
                    icons: true,
                    fields: {
                        'grid' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Grid',
                            icon: 'icon-grid'
                        },
                        'grid-template' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Template',
                            placeholder: 'rows / columns',
                            icon: 'icon-template'
                        },
                        'grid-template-areas' : {
                            type: 'text',
                            style_input: true,
                            name: 'Template areas',
                            placeholder: '"a b c" "a d e"',
                            icon: 'icon-area'
                        },
                        'grid-template-rows' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Template rows',
                            placeholder: '100px 1fr',
                            icon: 'icon-template-rows'
                        },
                        'grid-template-columns' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Template columns',
                            placeholder: '100px 1fr',
                            icon: 'icon-template-columns'
                        },
                        'gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Gap',
                            placeholder: '10px',
                            icon: 'icon-gap',
                            has_multiple_fields: true,
                        },
                        'row-gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Row gap',
                            placeholder: '10px',
                            icon: 'icon-row-gap',
                            has_multiple_fields: true,
                        },
                        'column-gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Column gap',
                            placeholder: '10px',
                            icon: 'icon-column-gap',
                            has_multiple_fields: true,
                        },
                        'grid-auto-rows' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Auto rows',
                            can_add_items: true,
                            options: [
                                {key: 'max-content', name: 'Max content'},
                                {key: 'min-content', name: 'Min content'},
                                {key: 'minmax(min, max)', name: 'minmax(min, max)'},
                                {key: 'auto', name: 'Auto'}
                            ],
                            icon: 'icon-auto-rows'
                        },
                        'grid-auto-columns' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Auto columns',
                            can_add_items: true,
                            options: [
                                {key: 'max-content', name: 'Max content'},
                                {key: 'min-content', name: 'Min content'},
                                {key: 'minmax(min, max)', name: 'minmax(min, max)'},
                                {key: 'fit-content(argument)', name: 'fit-content(argument)'},
                                {key: 'auto', name: 'Auto'}
                            ],
                            icon: 'icon-avto-columns'
                        },
                        'grid-auto-flow' : {
                            type: 'select',
                            style_input: true,
                            name: 'Auto flow',
                            can_add_items: true,
                            show_empty: true,
                            options: [
                                {key: 'row', name: 'Row'},
                                {key: 'column', name: 'Column'},
                                {key: 'dense', name: 'Dense'},
                                {key: 'row dense', name: 'Row dense'},
                                {key: 'column dense', name: 'Column dense'}
                            ],
                            icon: 'icon-auto-flow'
                        },
                        'align-items' : {
                            name: 'Align items',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'start',
                                    'name' : 'Start',
                                    'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-start')
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html': bm.makeIcon('221', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('align-items', 'center')
                                },
                                {
                                    'key' : 'end',
                                    'name' : 'End',
                                    'html': bm.makeIcon('220', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-end')
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    'html': bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignBlock('align-items', 'stretch')
                                },
                                {
                                    'key' : 'baseline',
                                    'name' : 'Baseline',
                                    'html': bm.makeIcon('212', { attributes: { 'title': 'Baseline' } })
                                    //'html' : getFlexAlignBlock('align-items', 'baseline')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'justify-content' : {
                            name: 'Justify content',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'start',
                                    'name' : 'Start',
                                    'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'flex-start')
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html': bm.makeIcon('219', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'center')
                                },
                                {
                                    'key' : 'end',
                                    'name' : 'End',
                                    'html': bm.makeIcon('218', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'flex-end')
                                },
                                {
                                    'key' : 'space-between',
                                    'name' : 'Space between',
                                    'html': bm.makeIcon('206', { attributes: { 'title': 'Space between' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-between')
                                },
                                {
                                    'key' : 'space-around',
                                    'name' : 'Space around',
                                    'html': bm.makeIcon('205', { attributes: { 'title': 'Space around' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-around')
                                },
                                {
                                    'key' : 'space-evenly',
                                    'name' : 'Space evenly',
                                    'html': bm.makeIcon('205', { attributes: { 'title': 'Space evenly' } })
                                    //'html' : getFlexAlignBlock('justify-content', 'space-around')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                        'align-content' : {
                            name: 'Align content',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'start',
                                    'name' : 'Start',
                                    html: bm.makeIcon('217', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('align-content', 'flex-start', 4, true)
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    html: bm.makeIcon('215', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('align-content', 'center', 4, true)
                                },
                                {
                                    'key' : 'end',
                                    'name' : 'End',
                                    html: bm.makeIcon('216', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('align-content', 'flex-end', 4, true)
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    html: bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignBlock('align-content', 'stretch', 2, true)
                                },
                                {
                                    'key' : 'space-between',
                                    'name' : 'Space between',
                                    html: bm.makeIcon('210', { attributes: { 'title': 'Space between' } })
                                    //'html' : getFlexAlignBlock('align-content', 'space-between', 4, true)
                                },
                                {
                                    'key' : 'space-around',
                                    'name' : 'Space around',
                                    html: bm.makeIcon('209', { attributes: { 'title': 'Space around' } })
                                    //'html' : getFlexAlignBlock('align-content', 'space-around', 4, true)
                                },
                                {
                                    'key' : 'space-evenly',
                                    'name' : 'Space evenly',
                                    'html': bm.makeIcon('209', { attributes: { 'title': 'Space evenly' } })
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        }
                    }
                },

                'grid-item' : {
                    name: 'Grid item',
                    get_has_data: cssPropsRe('grid_item'),
                    icons: true,
                    fields: {
                        'grid-area' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Area',
                            placeholder: 'area1 4 / 2 area2',
                            icon: 'icon-area'
                        },
                        'grid-row' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Row',
                            placeholder: '4 area / 6',
                            icon: 'icon-row',
                            add_default_unit: ''
                        },
                        'grid-column' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Column',
                            placeholder: '4 area / 6',
                            icon: 'icon-column',
                            add_default_unit: ''
                        },
                        'grid-row-start' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Row start',
                            placeholder: 'area 4',
                            icon: 'icon-row-start',
                            add_default_unit: ''
                        },
                        'grid-row-end' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Row end',
                            placeholder: 'area 6',
                            icon: 'icon-row-end',
                            add_default_unit: ''
                        },
                        'grid-column-start' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Column start',
                            placeholder: '2',
                            icon: 'icon-column-start',
                            add_default_unit: ''
                        },
                        'grid-column-end' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Column end',
                            placeholder: '4',
                            icon: 'icon-column-end',
                            add_default_unit: ''
                        },
                        'align-self' : {
                            name: 'Align self',
                            type : 'select',
                            show_empty: true,
                            style_input: true,
                            toggle_buttons : true,
                            options:[
                                {
                                    'key' : 'start',
                                    'name' : 'Start',
                                    'html': bm.makeIcon('223', { attributes: { 'title': 'Start' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-start')
                                },
                                {
                                    'key' : 'center',
                                    'name' : 'Center',
                                    'html': bm.makeIcon('221', { attributes: { 'title': 'Center' } })
                                    //'html' : getFlexAlignBlock('align-items', 'center')
                                },
                                {
                                    'key' : 'end',
                                    'name' : 'End',
                                    'html': bm.makeIcon('220', { attributes: { 'title': 'End' } })
                                    //'html' : getFlexAlignBlock('align-items', 'flex-end')
                                },
                                {
                                    'key' : 'stretch',
                                    'name' : 'Stretch',
                                    'html': bm.makeIcon('214', { attributes: { 'title': 'Stretch' } })
                                    //'html' : getFlexAlignBlock('align-items', 'stretch')
                                },
                                {
                                    'key' : 'baseline',
                                    'name' : 'Baseline',
                                    'html': bm.makeIcon('212', { attributes: { 'title': 'Baseline' } })
                                    //'html' : getFlexAlignBlock('align-items', 'baseline')
                                }
                            ],
                            on_fields_created : function (obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            },
                            on_changed : function(obj, prop, value) {
                                //updateFlexBlocks(prop, value);
                            }
                        },
                    }
                },
                /*
                'grid-simple' : {
                    name: 'Grid container',
                    get_has_data: cssPropsRe('grid_container'),
                    icons: true,
                    fields: {
                        'grid-control': {
                            type: 'custom',
                            action: 'none',
                            control: pinegrow.gridCreateSimpleGridCSSControl
                        },
                    }
                },*/
                'columns' : {
                    name: 'Columns',
                    get_has_data: cssPropsRe('columns'),
                    icons: false,
                    fields: {
                        'columns' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: '',
                            add_default_unit: '',
                            name: 'Columns',
                            placeholder: 'size count',
                            aaicon: 'icon-area'
                        },
                        'column-gap' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            name: 'Column gap',
                            placeholder: '',
                            aaicon: 'icon-row',
                            has_multiple_fields: true,
                        },
                        'column-rule' : {
                            type: 'slider',
                            style_input: true,
                            slider_def_unit: 'px',
                            add_default_unit: '',
                            name: 'Rule',
                            placeholder: '1px solid gray',
                            aaicon: 'icon-column'
                        },
                        'column-fill' : {
                            type: 'select',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Fill',
                            placeholder: '',
                            aaicon: 'icon-row-start',
                            show_empty: true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'auto',
                                    'name' : 'Auto',
                                    'html' : bm.makeText('Auto')
                                },
                                {
                                    'key' : 'balance',
                                    'name' : 'Balance',
                                    'html' : bm.makeText('Balance')
                                }
                            ]
                        },
                        'break-before' : {
                            type: 'select',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Break before',
                            show_empty: true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'auto',
                                    'name' : 'Auto',
                                    'html' : bm.makeText('Auto')
                                },
                                {
                                    'key' : 'avoid',
                                    'name' : 'Avoid',
                                    'html' : bm.makeText('Avoid')
                                }
                            ]
                        },
                        'break-inside' : {
                            type: 'select',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Break inside',
                            show_empty: true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'auto',
                                    'name' : 'Auto',
                                    'html' : bm.makeText('Auto')
                                },
                                {
                                    'key' : 'avoid',
                                    'name' : 'Avoid',
                                    'html' : bm.makeText('Avoid')
                                }
                            ]
                        },
                        'break-after' : {
                            type: 'select',
                            style_input: true,
                            slider_def_unit: '',
                            name: 'Break after',
                            show_empty: true,
                            'toggle_buttons' : true,
                            'options' : [
                                {
                                    'key' : 'auto',
                                    'name' : 'Auto',
                                    'html' : bm.makeText('Auto')
                                },
                                {
                                    'key' : 'avoid',
                                    'name' : 'Avoid',
                                    'html' : bm.makeText('Avoid')
                                }
                            ]
                        }
                    }
                }
            };

            if(pgf.kids) {
                delete s['grid-container'];
                delete s['grid-item'];
                delete s['columns'];

                delete s.text.fields['writing-mode'];
                delete s.text.fields['white-space'];
                delete s.text.fields['word-break'];
                delete s.text.fields['direction'];
                delete s.text.fields['text-indent'];

                delete s.background.fields['background_control'];
                delete s.background.fields['gradient_control'];
                delete s.background.fields['gradient_lib'];
                //delete s.background.fields['background-attachment'];
                delete s.background.fields['background-origin'];
                delete s.background.fields['background-clip'];

                delete s.border_prop.fields['outline-offset'];

                delete s.display_prop.fields.visibility;
                delete s.display_prop.fields['vertical-align'];
                delete s.display_prop.fields.resize;
                delete s.display_prop.fields.overflow;
                delete s.display_prop.fields['box-sizing'];
                delete s.display_prop.fields.cursor;
                delete s.display_prop.fields['object-fit'];
                delete s.display_prop.fields['object-position'];

                delete s.flex;
                delete s['flex-child'];
                delete s.list;

                s.display_prop.fields.display.options = [
                    {key:'none', name:'None'},
                    {key:'inline', name:'Inline'},
                    {key:'block', name:'Block'},
                    {key:'inline-block', name:'Inline block'}
                ]

                s.position_prop.fields.position.options = filterInherits(s.position_prop.fields.position.options, ['fixed', 'sticky', 'static']);

                var original_s = s;

                s = {
                    text: s.text,
                    background: s.background,
                    'margin_and_padding': s['margin_and_padding'],
                    dimension: s.dimension,
                    border_prop: s.border_prop,
                    position_prop: s.position_prop,
                    display_prop: s.display_prop,
                   // 'grid-simple': s['grid-simple'],
                   // flex: s.flex,
                   // 'flex-child': s['flex-child'],
                    'box-shadow': s['box-shadow'],
                    'text-shadow': s['text-shadow'],
                    //transforms: s.transforms,
                    //transitions: s.transitions,
                   // list: s.list
                }

                if(pgf.kids_with_transitions) {
                    s.transforms = original_s.transforms;
                    s.transitions = original_s.transitions;
                }
            }

            $.each(s, function(k,v) {
                addTo[k] = v;
            });
            return addTo;
        }


        //rules
        var name_sec = {
            name : {
                name : pgf.kids ? 'Selector' : 'Selector &amp; Media query',
                //show: false,
                fields : {
                    class_name_and_media_rule: {
                        type: 'custom',
                        name: '',
                        without_text: true,
                        action: 'none',
                        control: pgCreateSelectorAndMediaQueryControl
                    }
                }
            }
        }

        if(false && pgf.kids) {
            name_sec = {}
        }

        var rule = {
            'type' : 'rule',
            'selector' : 'img',
            'code' : '<img src=""/>',
            'name' : 'Image',
            'sections' : crsaBootstrapAddHtmlSections(name_sec)
        }
        $.fn.crsa.addRulesDefinition(rule);
    });
});
