$(function() {

    $('body').one('pinegrow-ready', function(e, pinegrow) {
        var f = new PgFramework('foundation.6.6.3', 'Foundation 6.6');
        f.type = "foundation";
        f.allow_single_type = true;

        f.description = '<a href="http://foundation.zurb.com/">Foundation</a> starting pages and components. Templates are based on Foundation 6.6.3.';
        f.author = 'Pinegrow';
        f.author_link = 'http://pinegrow.com';

        var prefix = 'fd6.';

        //f.info_badge = 'New';

        f.ignore_css_files = [/(^|\/)foundation\.css/i, /(^|\/)foundation\.min\.css/i, /(^|\/)normalize(\.min|)\.css/i];
        // f.detect = function(crsaPage) {
        //     return crsaPage.hasStylesheet(/(^|\/)foundation(\.min|)\.css/i);
        // }

        f.detect_async = function (crsaPage, done) {
            crsaPage.stylesheetsThatContain(/grid-x/i, /(^|\/)foundation(\.min|)\.(css|less)/i, function(list) {
                done(list.length > 0)
            });
        }

        f.has_actions = true; // Tell PG tree to look for action labels

        f.setScriptFileByScriptTagId('plugin-foundation-6'); //get url if script is included directly into edit.html
        pinegrow.addFramework(f, 4);

        var actions = []; // Will be shown in ACT tab
        f.getActionTypes = function(pgel) {
            var r = [];
            for(var i = 0; i < actions.length; i++) {
                var def = actions[i];
                // if( f.isType(def, $el, pgel)) {
                if (f.isType(def, null, pgel)) {
                    r.push(def);
                }
            }
            return r;
        }

        var getFoundationVersionForPage = function(page, force) {
            if(force_fd_version != 'auto') {
                setCurrentFdVersion( parseFloat(force_fd_version));
                return;
            }
            if(page.data.foundationVersion && !force) {
                setCurrentFdVersion(page.data.foundationVersion);
                //console.log('fd version = ' + current_fd_version);
            } else {
                page.stylesheetsThatContain(/Version\s(6[0-9\.]*)/i, /foundation/i, function (list, matches, async) {
                    if(list.length > 0) {
                        var a = matches[0][1].split('.');
                        var version = parseFloat(a[0]);
                        if (a.length > 1) {
                            version += parseFloat(a[1]) / 10.0;
                        }
                        setCurrentFdVersion(version);
                        page.data.foundationVersion = version;
                        if (async) {
                            pinegrow.selectedElements.reselect(); //trigger update
                        }
                        console.log('fd version = ' + current_fd_version + ' ' + async);
                    }
                }, force);
            }
        }

        var fd_version = 6.6
        var fd_minor_version = "6.6.3"; //must be a string

        var current_fd_version;
        var reqVersion = function (min_ver) {
            return current_fd_version >= min_ver;
        }


        var setCurrentFdVersion = function (ver) {
            current_fd_version = ver;
            f.name_short = 'Foundation ' + ver;
        }

        setCurrentFdVersion(fd_version);

        var force_fd_version = pinegrow.getSetting('fd6-force-version', 'auto');
        if (force_fd_version != 'auto') {
            setCurrentFdVersion(parseFloat(force_fd_version));
        }

        var isColumn = function (pgel) {
            if (pgel.tagName == 'div') {
                if (pgel.parent && pgel.parent.isSelector('.grid-x, .grid-y')) return true;
                if (pgel.getData(prefix + 'was-column')) return true;
            }
            if (pgel.tagName == 'label') return false;

            return false;
        }

        var getStandardPluginAction = function (options) {
            return $.extend({}, options, {
                'fd.data.options': {
                    type: 'text',
                    name: 'Data options',
                    action: 'element_attribute',
                    attribute : 'data-options',
                    placeholder : 'Plugin options'
                }
            })
        }

        // Helper vars
            var bm = new PgToggleButtonMaker();

            var num_columns = 12;
            var size_for_all = 'small';
            var sizes = ["small", "medium", "large"];
            var shortSizeNames = ["sm", "md", "lg"];
            var sizes_names = ["Small", "Medium", "Large"];

            var sizes_breakpoints = [0, 640, 1024];
            var sizes_view_sizes  = [320, 640, 1024];
            var sizes_icons = ['icon-Xs', 'icon-IPAD', 'icon-tableta-lezeca'];

            var sizes_breakpoints_map = {};
            for (var i = 0; i < sizes.length; i++) {
                sizes_breakpoints_map[sizes[i]] = sizes_breakpoints[i];
            }

            var fd_options = {
                num_columns: num_columns,
                size_for_all: 'small',
                sizes: sizes,
                sizes_short_names: shortSizeNames,
                sizes_breakpoints: sizes_breakpoints,
                sizes_breakpoints_map: sizes_breakpoints_map,
                sizes_view_sizes: sizes_view_sizes,
                sizes_icons: sizes_icons,
                sizes_names: sizes_names,
                prefix: prefix,
                col_prefix_class: '',
                isColumn: isColumn,
                onClickOnColumnPoint: function() {
                    var q = PgQuickProperties([def_all.sections[this.options.prefix + 'column']], this.menu.pgel, this.$element, 'Column size &amp; order', 300);
                },
                reqVersion: reqVersion
            }

            var attr_disabled = {
                type: 'checkbox',
                action: 'element_attribute',
                attribute: 'disabled',
                name: 'Disabled',
                value: 'disabled'
            };

            var gh = PgFoundationHelpers(fd_options, f, 6);
            var open_device_sections_map = {};
        // End helper vars


        // Helper functions
            //Add device selector on prop sections with multi-device controls
            var onSectionWithDevicesControlsShown = function(secdef, uiSection) {

                //var setActive = function($li, )
                var active = {}
                var no_active = true;

                sizes.forEach(function(size) {
                    if(open_device_sections_map[secdef.section_key] && open_device_sections_map[secdef.section_key][size]) {
                        active[size] = true;
                    }
                })

                var fields = uiSection.$content.get(0).querySelectorAll('[data-device-size]');

                fields.forEach(function(field) {
                    var size = field.getAttribute('data-device-size');
                    if(!active[size]) {
                        var has = field.classList.contains('sc-has-value');
                        active[size] = has;
                        no_active = no_active && !has;
                    }
                })

                if(no_active) {
                    active[size_for_all] = true;
                }

                fields.forEach(function(field) {
                    var size = field.getAttribute('data-device-size');
                    var display = field.getAttribute('data-device-display') || 'flex';

                    if(active[size]) {
                        pgShow(field, display);
                    } else {
                        pgHide(field);
                    }
                })

                var html = '<ul class="sc-device-selector">';
                sizes.forEach(function(size) {
                    html += '<li data-size="' + size + '" class="' + (active[size] ? 'sc-active' : '') + '">' + size + '</li>';
                })
                html += '</ul>';
                var $c = $(html);
                uiSection.$title.append($c);

                $c.on('click', 'li', function(e) {
                    e.preventDefault();
                    e.stopPropagation();

                    var $li = $(this);
                    var size = $li.attr('data-size');
                    var a = $li.hasClass('sc-active');
                    a = !a;

                    active[size] = a;

                    if(!a) {
                        if($c.find('li.sc-active').length == 1) {
                            pinegrow.showQuickError('At least one device size must be active.');
                            return;
                        }
                    }

                    if(!open_device_sections_map[secdef.section_key]) {
                        open_device_sections_map[secdef.section_key] = {};
                    }

                    open_device_sections_map[secdef.section_key][size] = a;

                    var $fields = uiSection.$content.find('[data-device-size="' + size + '"]');
                    $fields.each(function(i, field) {
                        var display = field.getAttribute('data-device-display') || 'flex';

                        if (a) {
                            pg$Show($(field), display);
                            $li.addClass('sc-active');
                        } else {
                            pg$Hide($(field));
                            $li.removeClass('sc-active');
                        }
                    });
                    updateLabels();
                })

                var updateVisibility = function() {
                    var page = pinegrow.getSelectedPage();
                    fields.forEach(function(field) {
                        var size = field.getAttribute('data-device-size');
                        if(gh.isSizeVisible(page, size)) {
                            field.classList.remove('sc-size-not-visible');
                        } else {
                            field.classList.add('sc-size-not-visible');
                        }
                    })

                    $c.children().each(function(i, li) {
                        var size = li.getAttribute('data-size');
                        if(gh.isSizeVisible(page, size)) {
                            li.classList.remove('sc-size-not-visible');
                        } else {
                            li.classList.add('sc-size-not-visible');
                        }
                    })
                }

                var updateLabels = function() {
                    var num_shown = 0;
                    var all_shown = false;

                    sizes.forEach(function(size) {
                        if(active[size]) {
                            num_shown++;
                            if(size == size_for_all) {
                                all_shown = true;
                            }
                        }
                    })

                    var $controls = uiSection.$content.find('.sc-device-control');

                    if(num_shown > 1) {
                        $controls.removeClass('sc-single-size');
                    } else {
                        $controls.addClass('sc-single-size');
                    }
                    if(all_shown) {
                        $controls.addClass('sc-for-all-shown');
                    } else {
                        $controls.removeClass('sc-for-all-shown');
                    }
                }

                updateVisibility();
                updateLabels();

            }

            var addPrefixToSectionsAndFields = function (sections) {
                return gh.addPrefixToSectionsAndFields(sections);
            }

            //Return a function that will create the control
            var getDevicesControlFactory = function(control_id, title, func) {
                //Returns function that creates the control
                var forSize = function(f) {
                    sizes.forEach(function(size) {
                        // f(size, size, prefix + control_id + '.' + size);
                        f(size, size == size_for_all ? '' : size + '-', prefix + control_id + '.' + size);
                        // f(size, size == size_for_all ? '' : '-' + size, prefix + control_id + '.' + size);
                    })
                }

                return function() {
                    //will keep helper functions and vars private

                    //Create control, needs a unique id
                    var c = new PgCustomPropertyControl(prefix + control_id);

                    //Register subfields.
                    c.onDefine = function () {

                        //These fields will not be shown when just registered. This is neccessary to get values.
                        forSize(function(size, size_token, field_key) {
                            var field = func(size, size_token);
                            if (field) c.registerInputField(field_key, field);
                        })
                    }

                    //Show control. Return the control $el.
                    c.onShow = function () {
                        var $div = $("<div/>", {class: 'sc-device-control'});
                        $('<div class="sc-device-control-title">' + title + '</div>').appendTo($div);
                        forSize(function(size, size_token, field_key) {
                            var field_def = func(size, size_token);
                            if (field_def) {
                                var field = c.showInputField($div, field_key, field_def);
                                field.$field.attr('data-device-size', size);
                            }
                        })
                        return $div;
                    }

                    //Called when control is recycled and new values are set
                    c.onSetValues = function(values) {
                        //return;
                        var none_or_all = true;

                        forSize(function(size, size_token, field_key) {
                            var $field = c.get$Field(field_key);
                            if(c.values[field_key]) {
                                $field.addClass('sc-has-value');
                                // if(size != size_for_all) {
                                //     none_or_all = false;
                                // }
                            } else {
                                $field.removeClass('sc-has-value');
                            }
                        })
                        if(none_or_all) {
                            c.$element.addClass('sc-none-or-all');
                        } else {
                            c.$element.removeClass('sc-none-or-all');
                        }
                    }

                    //Return the control
                    return c;
                };
            }

            //Return a function that will create the control
            var getGridControlFactory = function(control_id, rows) {
                //Returns function that creates the control
                return function() {
                    //will keep helper functions and vars private

                    //Create control, needs a unique id
                    var c = new PgCustomPropertyControl(prefix + control_id);

                    //Register subfields.
                    c.onDefine = function () {

                        //These fields will not be shown when just registered. This is neccessary to get values.
                        for (var n = 0; n < rows.length; n++) {
                            for (var m = 0; m < sizes.length; m++) {
                                var field = prefix + rows[n].field_prefix + '.' + sizes[m];
                                this.registerInputField(field, createFieldDef(rows[n], sizes[m]))
                            }
                        }
                    }

                    //Show control. Return the control $el.
                    c.onShow = function () {
                        var $table = $("<table/>", {class: 'grid-control columns-control six-col-grid'});
                        var html = '<td></td>';
                        sizes.forEach(function(size) {
                            html += '<td><label class="grid-control-size">' + size + '</label></td>';
                        })
                        var $row = $("<tr/>").html(html).appendTo($table);

                        for (var n = 0; n < rows.length; n++) {
                            $row = $("<tr/>", {class: ''}).appendTo($table);
                            var $td = $("<td/>").html('<label>' + rows[n].name + '</label>').appendTo($row);

                            for (var m = 0; m < sizes.length; m++) {
                                $td = $("<td/>").appendTo($row);
                                var field = prefix + rows[n].field_prefix + '.' + sizes[m];
                                this.showInputField($td, field, createFieldDef(rows[n], sizes[m]));
                            }
                        }
                        return $table;
                    }

                    //Called when control is recycled and new values are set
                    c.onSetValues = function () {
                        //Nothing to do in this case. PG will take care of updating sub fields with new values
                    }

                    //Helper functions and vars

                    var createFieldDef = function(row, size) {
                        var base = size + ( row.class_middle ? '-' + row.class_middle : '');
                        var span_select = {
                            'type': 'select',
                            'name': null,
                            'action': 'apply_class',
                            draggable_list : true,
                            'show_empty': true,
                            'options': [],
                            'on_changed' : row.on_changed
                        }
                        row.values.forEach(function(d) {
                            span_select.options.push({key: base + d.key, name: d.name});
                        })
                        return span_select;
                    }

                    //Return the control
                    return c;
                };
            }


            var columnOnChanged = function(pgel, prop, value) {
                pgel.setData(prefix + 'was-column', true);
                if(value) {
                    var pgp = pgel.parent;
                    var isParentOfGrid = pgp.hasClass('grid-x') || pgel.hasClass('gird-y');
                    if(!isParentOfGrid) {
                        pinegrow.showAlert('<p>Column must have a Grid parent element.</p><p>Would you like to add a Grid?</p>', 'Every Column needs a Grid', 'No', 'Yes, add a Grid', null, function() {
                            var gridX = pgCreate('<div class="grid-x"></div>');
                            gridX.insertBefore(pgel);
                            gridX.append(pgel);
                            pinegrow.showQuickMessage('Parent Grid added.');
                        })
                    }
                }
            }

            var makeFieldLabelForSize = function(label, size) {
                return '<span class="sc-label">' + label + '</span><span class="sc-device-size">' + size + '</span>';
            }

            var getPlaceholderImage = function () {
                return pinegrow.getPlaceholderImage();
            }

            var getGridPreview = function(t) {
                var colcont = '<div style="height:60px;background:#eee;"></div>';

                var sel = 'border:2px solid #0098cc;';
                var conts, rows, cols;
                conts = rows = cols = '';

                switch(t) {
                    case 'container':
                        conts = sel;
                        break;
                    case 'row':
                        rows = sel;
                        break;
                    case 'column':
                        cols = sel;
                        break;
                }

                return '<div class="container-fluid" style="' + conts + '">\
                    <div class="row" style="' + rows + '">\
                        <div class="col-4" style="' + cols + '">' + colcont + '</div>\
                        <div class="col-4">' + colcont + '</div>\
                        <div class="col-4">' + colcont + '</div>\
                    </div>\
                    <div class="row" style="margin-top:12px;">\
                        <div class="col-4">' + colcont + '</div>\
                        <div class="col-4">' + colcont + '</div>\
                        <div class="col-4">' + colcont + '</div>\
                    </div>\
                </div>';
            }

            var showOrbitMessage = function() {
                crsaQuickMessage('Refresh the page (Page -&gt; Refresh / CMD + R) to activate changes.', 3000);
            }

            var refreshPage = function () {
                var selectedPage = pinegrow.getSelectedPage();
                selectedPage.refresh();
            }

            var getFoundationColor = function (type) {
                switch (type) {
                    case 'primary':
                        return '#1779ba';
                    case 'secondary':
                        return '#767676';
                    case 'success':
                        return '#3adb76';
                    case 'warning':
                        return '#ffae00';
                    case 'alert':
                        return '#cc4b37';
                    default:
                        return '#fff';
                }
            }

            var getButtonTypeToggleButton = function(type, title) {
                var attr = {}
                if (title) attr.title = title;

                if(type == 'link') {
                    return bm.makeColor(null, 'T', {
                        'text-decoration': 'underline',
                        'attributes': attr
                    });
                } else {
                    var text_color = '#fff';
                    return bm.makeColor(getFoundationColor(type), '', {
                        'color': text_color,
                        'attributes': attr
                    });
                }
            }
        // End helper functions


        // Options
            var foundationColors = [
                { 'key' : 'primary',   'name' : 'Primary',   html: getButtonTypeToggleButton('primary', 'Primary') },
                { 'key' : 'secondary', 'name' : 'Secondary', html: getButtonTypeToggleButton('secondary', 'Secondary') },
                { 'key' : 'success',   'name' : 'Success',   html: getButtonTypeToggleButton('success', 'Success') },
                { 'key' : 'alert',     'name' : 'Alert',     html: getButtonTypeToggleButton('alert', 'Alert') },
                { 'key' : 'warning',   'name' : 'Warning',   html: getButtonTypeToggleButton('warning', 'Warning') }
            ]
        // End options


        // All
            // Add FD common sections to all elements
            var def_all = new PgComponentType(prefix + 'all', 'All elements', {
                selector : function(pgel) { return true },
                name : 'Div',
                display_name : 'tag',
                priority : 2001,
                sections : addPrefixToSectionsAndFields({
                    'fdtext' : {
                        name: 'Text &amp; Context',
                        fields: {
                            fdsubheader : {
                                'type' : 'checkbox',
                                'name' : 'Subheader',
                                'action' : 'apply_class',
                                'value' : 'subheader'
                            },
                            fdlead : {
                                'type' : 'checkbox',
                                'name' : 'Lead',
                                'action' : 'apply_class',
                                'value' : 'lead'
                            },
                            fdstat : {
                                'type' : 'checkbox',
                                'name' : 'Statistics',
                                'action' : 'apply_class',
                                'value' : 'stat'
                            },
                            fdtypescale : {
                                'type' : 'select',
                                'name' : 'Typescale',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'h1', name: 'h1' },
                                    { key: 'h2', name: 'h2' },
                                    { key: 'h3', name: 'h3' },
                                    { key: 'h4', name: 'h4' },
                                    { key: 'h5', name: 'h5' },
                                    { key: 'h6', name: 'h6' }
                                ]
                            }
                        }
                    },
                    'fdlayout' : {
                        name: 'Layout',
                        fields: {
                            fdfloat : {
                                'type' : 'select',
                                'name' : 'Float',
                                'action' : 'apply_class',
                                'toggle_buttons' : true,
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'float-center', 'name' : 'Center', 'html' : bm.makeIcon('float',       { attributes: { 'title': 'Center' } }) },
                                    { 'key' : 'float-left',   'name' : 'Left',   'html' : bm.makeIcon('float-left"', { attributes: { 'title': 'Left'   } }) },
                                    { 'key' : 'float-right',  'name' : 'Right',  'html' : bm.makeIcon('float-right', { attributes: { 'title': 'Right'  } }) }
                                ]
                            },
                            fdclearfix : {
                                'type' : 'checkbox',
                                'name' : 'Clear floats',
                                'action' : 'apply_class',
                                'value' : 'clearfix'
                            },
                            fdprint : {
                                'type' : 'select',
                                'name' : 'Print',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'show-for-print', name: 'Show' },
                                    { key: 'hide-for-print', name: 'Hide' }
                                ]
                            },
                            fdlandscape : {
                                'type' : 'select',
                                'name' : 'Landscape',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'show-for-landscape', name: 'Show' },
                                    { key: 'hide-for-landscape', name: 'Hide' }
                                ]
                            },
                            fdportrait : {
                                'type' : 'select',
                                'name' : 'Portrait',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'show-for-portrait', name: 'Show' },
                                    { key: 'hide-for-portrait', name: 'Hide' }
                                ]
                            },
                            fdinterchange : {
                                'type' : 'text',
                                'name' : 'Interchange',
                                'action' : 'custom',
                                live_update : false,
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    pgel.setAttr('data-interchange', value);
                                    showOrbitMessage();
                                    return value;
                                },
                                get_value: function (pgel) {
                                    return pgel.getAttr('data-interchange');
                                }
                            },
                            fddataanimation : {
                                'type' : 'text',
                                'name' : 'Data animation',
                                'action' : 'custom',
                                live_update : false,
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    pgel.setAttr('data-animate', value);
                                    reflowPage(pgel);
                                    return value;
                                },
                                get_value: function (pgel) {
                                    return pgel.getAttr('data-animate');
                                }
                            },
                            fdmagellandest : {
                                'type' : 'text',
                                'name' : 'Magellan target',
                                'action' : 'custom',
                                live_update : false,
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    pgel.setAttr('data-magellan-target', value);
                                    reflowPage(pgel);
                                    return value;
                                },
                                get_value: function (pgel) {
                                    return pgel.getAttr('data-magellan-target');
                                }
                            },
                            fdcloseable : {
                                'type' : 'text',
                                'name' : 'Closeable',
                                'action' : 'element_attribute',
                                'attribute' : 'data-closable'
                            },
                            fdclose : {
                                'type' : 'checkbox',
                                'name' : 'Close',
                                'value' : '1',
                                'action' : 'element_attribute',
                                'attribute' : 'data-close',
                                get_value : function (pgel) {
                                    return pgel.hasAttr('data-close') ? '1' : null;
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    if (value == '1') {
                                        pgel.setAttr('data-close', '');
                                    }
                                    else {
                                        pgel.removeAttr('data-close');
                                    }
                                    return value;
                                }
                            }
                        }
                    },
                    'fdlayoutres' : {
                        name : "Layout Res.",
                        on_section_shown : onSectionWithDevicesControlsShown,
                        fields: {
                            fdtextalign : {
                                type: 'custom',
                                name: 'text_align',
                                action: 'none',
                                control: getDevicesControlFactory('text.align', 'Text Align', function(size, size_token) {
                                    var base = size_token + 'text-';

                                    field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Text align', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : [
                                            { 'key' : base + 'left',    'name' : 'Left',    'html' : bm.makeIcon('align-left')   },
                                            { 'key' : base + 'center',  'name' : 'Center',  'html' : bm.makeIcon('align-center') },
                                            { 'key' : base + 'right',   'name' : 'Right',   'html' : bm.makeIcon('align-right')  },
                                            { 'key' : base + 'justify', 'name' : 'Justify', 'html' : bm.makeIcon('align-full')   }
                                        ]
                                    }

                                    return field;
                                })
                            },
                            fdvisibility : {
                                type: 'custom',
                                name: 'visibility',
                                action: 'none',
                                control: getDevicesControlFactory('block.visibility', 'Visibility', function(size, size_token) {
                                    var options = [];

                                    if (size == 'small') {
                                        options.push({
                                            key: 'show-for-' + size + '-only',
                                            name: 'Show for ' + size + ' only'
                                        }, {
                                            key: 'hide-for-' + size + '-only',
                                            name: 'Hide for ' + size + ' only'
                                        });
                                    }
                                    else {
                                        options.push({
                                            key: 'show-for-' + size + '-only',
                                            name: 'Show for ' + size + ' only'
                                        }, {
                                            key: 'show-for-' + size,
                                            name: 'Show for ' + size
                                        }, {
                                            key: 'hide-for-' + size + '-only',
                                            name: 'Hide for ' + size + ' only'
                                        }, {
                                            key: 'hide-for-' + size,
                                            name: 'Hide for ' + size
                                        });
                                    }

                                    field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Visibility', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : options
                                    }

                                    return field;
                                })
                            }
                        }
                    },
                    'fdaccessible' : {
                        name: 'Accessibility',
                        fields: {
                            fdhide : {
                                'type' : 'checkbox',
                                'name' : 'Hide',
                                'action' : 'apply_class',
                                'value' : 'hide'
                            },
                            fdinvisible : {
                                'type' : 'checkbox',
                                'name' : 'Invisible',
                                'action' : 'apply_class',
                                'value' : 'invisible'
                            },
                            fdscreenonly : {
                                'type' : 'checkbox',
                                'name' : 'Show only for screen readers',
                                'action' : 'apply_class',
                                'value' : 'show-for-sr'
                            },
                            fdshowonfocus : {
                                'type' : 'checkbox',
                                'name' : 'Show on focus',
                                'action' : 'apply_class',
                                'value' : 'show-on-focus'
                            },
                            fdalign : {
                                'type' : 'select',
                                'name' : 'Align',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'align-top',           name: 'Top' },
                                    { key: 'align-self-top',      name: 'Self top' },
                                    { key: 'align-bottom',        name: 'Bottom' },
                                    { key: 'align-self-bottom',   name: 'Self bottom' },
                                    { key: 'align-right',         name: 'Right' },
                                    { key: 'align-center',        name: 'Center' },
                                    { key: 'align-justify',       name: 'Justify' },
                                    { key: 'align-spaced',        name: 'Spaced' },
                                    { key: 'align-middle',        name: 'Middle' },
                                    { key: 'align-self-middle',   name: 'Self middle' },
                                    { key: 'align-stretch',       name: 'stretch' },
                                    { key: 'align-self-stretch',  name: 'Self stretch' },
                                    { key: 'align-center-middle', name: 'Self center middle' },
                                ]
                            }
                        }
                    },
                    'fdflexres' : {
                        name : "Flex container",
                        on_section_shown : onSectionWithDevicesControlsShown,
                        fields: {
                            fdflex : {
                                type: 'custom',
                                name: 'flex_display',
                                action: 'none',
                                control: getDevicesControlFactory('flex.display', 'Flex', function(size, size_token) {
                                    var field = {
                                        'type' : 'checkbox',
                                        'name' : makeFieldLabelForSize('Flex', size),
                                        'action' : 'apply_class',
                                        'value' : size_token + 'flex-container'
                                    }

                                    return field;
                                })
                            },
                            fddirection : {
                                type: 'custom',
                                name: 'flex_direction',
                                action: 'none',
                                control: getDevicesControlFactory('flex.direction', 'Direction', function(size, size_token) {
                                    var base = size_token + 'flex-dir-';

                                    var field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Direction', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : [
                                            {key : base + 'row', name : 'Row', html: bm.makeIcon('225', { attributes: { 'title': 'Row' } })},
                                            {key : base + 'row-reverse', name : 'Row rev.', html: bm.makeIcon('224', { attributes: { 'title': 'Row reverse' } })},
                                            {key : base + 'column',name: 'Column',html: bm.makeIcon('227', { attributes: { 'title': 'Column' } })},
                                            {key : base + 'column-reverse',name : 'Col. rev.',html: bm.makeIcon('226', { attributes: { 'title': 'Column reverse' } })}
                                        ]
                                    }

                                    return field;
                                })
                            },
                            fdchild : {
                                type: 'custom',
                                name: 'flex_child',
                                action: 'none',
                                control: getDevicesControlFactory('flex.child', 'Child', function(size, size_token) {
                                    var base = size_token + 'flex-child-';

                                    var field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Child', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'options' : [
                                            { key : base + 'auto', name : 'Auto' },
                                            { key : base + 'grow', name : 'Grow' },
                                            { key : base + 'shrink', name : 'Shrink' }
                                        ]
                                    }

                                    return field;
                                })
                            }
                        }
                    },
                    'fdoptions': {
                        name: 'Foundation options',
                        fields: {
                            fdversionlabel65: {
                                type: 'displayhtml',
                                name: '<p>Foundation <b>6.5</b> properties are shown for the current page.</p>',
                                action: 'custom',
                                show_if: function () {
                                    return current_fd_version == 6.5;
                                }
                            },
                            fdversionlabel66: {
                                type: 'displayhtml',
                                name: '<p>Foundation <b>6.6</b> properties are shown for the current page.</p>',
                                action: 'custom',
                                show_if: function () {
                                    return current_fd_version == 6.6;
                                }
                            },
                            fdforceversion: {
                                type: 'select',
                                name: 'Foundation version',
                                show_empty: false,
                                options: [
                                    {key: 'auto', name: 'Auto detect'},
                                    {key: '6.5', name: '6.5'},
                                    {key: '6.6', name: '6.6'},
                                ],
                                action: 'custom',
                                get_value: function() {
                                    return force_fd_version;
                                },
                                set_value: function(pgel, value) {
                                    force_fd_version = value;
                                    pinegrow.setSetting('fd6-force-version', value);
                                    if(value != 'auto') {
                                        setCurrentFdVersion( parseFloat(value));
                                    }
                                    setTimeout(function() {
                                        pinegrow.selectedElements.reselect();
                                    }, 100);
                                    return value;
                                }
                            }
                        }
                    }
                })


            })
            f.addComponentType(def_all);
        // End all

        // Container
            var def_container = new PgComponentType(prefix + 'container', 'Container', {
                'selector' : '.grid-container',
                tags: 'major',
                preview: getGridPreview('container'),
                'code' : '<div class="grid-container"></div>',
                empty_placeholder : true,
                action_menu: {
                    add: [prefix + 'grid']
                },
                'inline_edit' : true,
                'sections' : addPrefixToSectionsAndFields({
                    containeropt : {
                        name : "Container",
                        fields : {
                            cotype: {
                                name: 'Type',
                                type: 'select',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'full', name: 'Full' },
                                    { key: 'fluid', name: 'Fluid' }
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_container);
        // End container

        // Grid
            var grid_up_values = [];
            for (var i = 1; i <= num_columns; i++) {
                grid_up_values.push({ key: '-' + i, name: i });
            }

            var def_grid = new PgComponentType(prefix + 'grid', 'Grid', {
                selector : '.grid-x, .grid-y',
                tags: 'major',
                preview: getGridPreview('row'),
                invalid_drop_msg : "Row can only be dropped into a Container. Drop it to the tree if you want to put it somewhere else.",
                code : '<div class="grid-x"></div>',
                empty_placeholder : true,
                action_menu : {
                    add: [prefix + 'column', prefix + 'block-column-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                    grid: {
                        name: "Grid",
                        fields: {
                            grid_layout_control: {
                                type: 'custom',
                                name: 'layout_control',
                                action: 'none',
                                control: getGridControlFactory('grid-up', [
                                    {
                                        field_prefix: 'grid-up',
                                        class_middle: 'up',
                                        values: grid_up_values,
                                        name: 'Up'
                                    }
                                ])
                            },
                            griddirection : {
                                type: 'select',
                                name: 'Direction',
                                action: 'apply_class',
                                options: [
                                    { key: 'grid-x', name: 'X' },
                                    { key: 'grid-y', name: 'Y' }
                                ]
                            },
                            gridpadding : {
                                type: 'select',
                                name: 'Padding',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'grid-padding-x', name: 'X' },
                                    { key: 'grid-padding-y', name: 'Y' }
                                ]
                            },
                            gridmargin : {
                                type: 'select',
                                name: 'Margin',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'grid-margin-x', name: 'X' },
                                    { key: 'grid-margin-y', name: 'Y' }
                                ]
                            },
                            gridmargincollapse : {
                                type: 'select',
                                name: 'Margin Collapse',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'small-margin-collapse', name: 'Small' },
                                    { key: 'medium-margin-collapse', name: 'Medium' },
                                    { key: 'large-margin-collapse', name: 'Large' }
                                ]
                            },
                            gridframe : {
                                type: 'select',
                                name: 'Frame',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'small-grid-frame', name: 'Small' },
                                    { key: 'medium-grid-frame', name: 'Medium' },
                                    { key: 'large-grid-frame', name: 'Large' }
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_grid);
        // End grid

        // Columns
            var column_span_values = [
                {key: '-auto', name: 'Auto'}
            ];
            var column_offset_values = [
            ];
            var column_order_values = [
            ];

            for (var i = 0; i <= num_columns; i++) {
                if (i != 0) {
                    column_span_values.push({ key: '-' + i, name: i });
                    if (i <= num_columns / 2) {
                        column_order_values.push({ key: '-' + i, name: i });
                    }
                }

                if (i != 12) {
                    column_offset_values.push({ key: '-' + i, name: i });
                }
            }

            var columns_section_def = {
                name : "Grid",
                fields : {
                    column_layout_control: {
                        type: 'custom',
                        name: 'layout_control',
                        action: 'none',
                        control: getGridControlFactory('cell-span', [
                            {
                                field_prefix: 'cell',
                                class_middle: '',
                                values: column_span_values,
                                name: 'Size',
                                on_changed: columnOnChanged
                            },
                            {
                                field_prefix: 'offset',
                                class_middle: 'offset',
                                values: column_offset_values,
                                name: 'Offset',
                                on_changed: columnOnChanged

                            },
                            {
                                field_prefix: 'order',
                                class_middle: 'order',
                                values: column_order_values,
                                name: 'Order',
                                on_changed: columnOnChanged
                            }
                        ])
                    },
                    headercolumn: {
                        'type': 'checkbox',
                        'name': 'Header',
                        'action': 'apply_class',
                        'value': 'header'
                    },
                    footercolumn: {
                        'type': 'checkbox',
                        'name': 'Footer',
                        'action': 'apply_class',
                        'value': 'footer'
                    }
                }
            };

            var def_column = new PgComponentType(prefix + 'column', 'Column', {
                tags: 'major',
                selector : isColumn,
                parent_selector: '.grid-x,.grid-y',
                code : '<div class="medium-4 cell">\
                    <h3>Column title</h3>\
                    <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
                </div>',
                empty_placeholder : true,
                name : 'Column',
                sections : addPrefixToSectionsAndFields({
                    columns: columns_section_def,
                    rescolumns: {
                        name : "Column res.",
                        on_section_shown : onSectionWithDevicesControlsShown,
                        fields : {
                            rescolumncellblock : {
                                type: 'custom',
                                name: 'cell_block',
                                action: 'none',
                                control: getDevicesControlFactory('cell.block', 'Cell Block', function(size, size_token) {
                                    var base = size_token + 'cell-block';

                                    field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Cell block', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : [
                                            { 'key' : base + '',           'name' : 'Auto' },
                                            { 'key' : base + '-container', 'name' : 'Container' },
                                            { 'key' : base + '-y',         'name' : 'Y'}
                                        ]
                                    }

                                    return field;
                                })
                            },
                            rescolumntype : {
                                type: 'custom',
                                name: 'cell_view',
                                action: 'none',
                                control: getDevicesControlFactory('cell.view', 'View', function(size, size_token) {
                                    var options = [];

                                    if (size == "small") {
                                        options.push({ 'key' : 'auto',  'name' : 'Auto' });
                                    }
                                    else {
                                        options.push({ 'key' : size + '-auto',  'name' : 'Auto' });
                                    }

                                    options.push({ 'key' : size + '-shrink',  'name' : 'Shrink' });
                                    options.push({ 'key' : size + '-full',  'name' : 'Full' });

                                    field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('View', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : options
                                    }

                                    return field;
                                })
                            },
                            rescolumnframe : {
                                type: 'custom',
                                name: 'grid_frame',
                                action: 'none',
                                control: getDevicesControlFactory('grid.frame', 'Frame', function(size, size_token) {
                                    var key = '';

                                    if (size == "small") {
                                        key = 'grid-frame';
                                    }
                                    else {
                                        key = size + '-grid-frame';
                                    }

                                    field = {
                                        'type' : 'checkbox',
                                        'name' : makeFieldLabelForSize('Frame', size),
                                        'action' : 'apply_class',
                                        'value' : key
                                    }

                                    return field;
                                })
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_column);
        // End columns

        // Block columns item
            var def_block_column_item = new PgComponentType(prefix + 'block-column-item', 'Block column item', {
                'helplink' : 'grid.html',
                'code' : '<div class="large-12 cell">\
                    <img src="' + getPlaceholderImage() + '" class="thumbnail" alt="">\
                </div>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_block_column_item);

            var def_block_column = new PgComponentType(prefix + 'block-column', 'Block columns', {
                'helplink' : 'grid.html',
                tags: 'major',
                'code' : '<div class="grid-x small-up-3">\
                    <div class="cell">\
                        <img src="' + getPlaceholderImage() + '" class="thumbnail" alt="">\
                    </div>\
                    <div class="cell">\
                        <img src="' + getPlaceholderImage() + '" class="thumbnail" alt="">\
                    </div>\
                    <div class="cell">\
                        <img src="' + getPlaceholderImage() + '" class="thumbnail" alt="">\
                    </div>\
                </div>',
                'empty_placeholder' : false,
                priority: 100,
                'inline_edit' : true,
                action_menu : {
                    add: [prefix + 'block-column-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_block_column);
        // End

        // Grid sections
            var grid_section = new PgFrameworkLibSection(prefix + 'grid', 'Grid');
            grid_section.setComponentTypes([def_container, def_grid, def_column, def_block_column]);
            f.addLibSection(grid_section);
        // End grid sections


        // Topbar
            // Topbar form
            var def_topbar_form = new PgComponentType(prefix + 'topbar-form', 'Form', {
                'selector' : null,
                'helplink' : 'top-bar.html',
                'code' : '<ul class="menu">\
                    <li>\
                        <input type="search" placeholder="Search">\
                    </li>\
                    <li>\
                        <button type="button" class="button">Search</button>\
                    </li>\
                </ul>',
                'name' : 'Top bar form',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_topbar_form);

            // Topbar button
            var def_topbar_button = new PgComponentType(prefix + 'topbar-button', 'Button', {
                'selector' : null,
                'helplink' : 'top-bar.html',
                'code' : '<li><a href="#" class="button">Get Lucky</a></li>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_topbar_button);

            // Topbar link
            var def_topbar_link = new PgComponentType(prefix + 'topbar-link', 'Link', {
                'selector' : null,
                'helplink' : 'top-bar.html',
                'code' : '<li>\
                    <a href="#">Get Lucky</a>\
                </li>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_topbar_link);

            // Topbar dropdown
            var def_topbar_dropdown = new PgComponentType(prefix + 'topbar-dropdown', 'Dropdown', {
                'selector' : null,
                'helplink' : 'top-bar.html',
                'code' : '<li>\
                    <ul class="dropdown menu" data-dropdown-menu>\
                        <li>\
                            <a href="#">One</a>\
                            <ul class="menu vertical">\
                                <li><a href="#">One</a></li>\
                                <li><a href="#">Two</a></li>\
                                <li><a href="#">Three</a></li>\
                            </ul>\
                        </li>\
                    </ul>\
                </li>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_topbar_dropdown);

            // Topbar content (onAdd helper)
            var onNewElmAddedToTopbarContent = function(pgel, pgnew, newdef, prepend) {
                var getSection = function() {
                    var pgs = pgel.findOne('>ul');
                    if (!pgs) {
                        pgs = pgCreateNodeFromHtml('<ul class="menu"></ul>');
                        pgel.append(pgs);
                    }
                    return pgs;
                }

                if (newdef.type == prefix + 'topbar-link' ||
                    newdef.type == prefix + 'topbar-button') {
                    if (prepend) {
                        getSection().prepend(pgnew);
                    } else {
                        getSection().append(pgnew);
                    }
                }
                else if (newdef.type == prefix + 'topbar-dropdown') {
                    if (prepend) {
                        getSection().prepend(pgnew);
                    } else {
                        getSection().append(pgnew);
                    }

                    showOrbitMessage();
                }
                else {
                    if (prepend) {
                        pgel.prepend(pgnew);
                    } else {
                        pgel.append(pgnew);
                    }
                }
            }

            // Topbar left content
            var def_topbar_left = new PgComponentType(prefix + 'topbar-left-content', 'Top bar left content', {
                'selector' : '.top-bar-left',
                'priority' : 100,
                'helplink' : 'top-bar.html',
                'code' : '<div class="top-bar-left">\
                    <ul class="menu">\
                        <li><a href="#">Left Nav Button</a></li>\
                    </ul>\
                </div>',
                tags : 'major',
                action_menu: {
                    add: [prefix + 'topbar-form', prefix + 'topbar-link', prefix + 'topbar-button', prefix + 'topbar-dropdown'],
                    on_add : onNewElmAddedToTopbarContent
                },
                'sections' : addPrefixToSectionsAndFields({
                    layout : {
                        name : "Layout",
                        fields : {
                            fdposition: {
                                type: 'select',
                                name: 'Position',
                                action: 'apply_class',
                                show_empty : true,
                                options : [
                                    {key: 'top-bar-left', name: 'Left'},
                                    {key: 'top-bar-right', name: 'Right'}
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_topbar_left);

            // Topbar right content
            var def_topbar_right = new PgComponentType(prefix + 'topbar-right-content', 'Top bar right content', {
                'selector' : '.top-bar-right',
                'priority' : 100,
                'helplink' : 'top-bar.html',
                'code' : '<div class="top-bar-right">\
                    <ul class="menu">\
                        <li><a href="#">Left Nav Button</a></li>\
                    </ul>\
                </div>',
                tags : 'major',
                action_menu: {
                    add: [prefix + 'topbar-form', prefix + 'topbar-link', prefix + 'topbar-button', prefix + 'topbar-dropdown'],
                    on_add : onNewElmAddedToTopbarContent
                },
                'sections' : addPrefixToSectionsAndFields({
                    layout : {
                        name : "Layout",
                        fields : {
                            fdposition: {
                                type: 'select',
                                name: 'Position',
                                action: 'apply_class',
                                show_empty : true,
                                options : [
                                    {key: 'top-bar-left', name: 'Left'},
                                    {key: 'top-bar-right', name: 'Right'}
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_topbar_right);

            // Topbar title
            var def_topbar_title = new PgComponentType(prefix + 'topbar-title', 'Topbar title', {
                'selector' : '.menu-text',
                'helplink' : 'top-bar.html',
                'code' : '<div class="top-bar-left">\
                    <ul class="menu">\
                        <li class="menu-text">Site Title</li>\
                    </ul>\
                </div>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_topbar_title);

            // titlebar button
            var def_titlebar_icon = new PgComponentType(prefix + 'titlebar-icon', 'Title bar icon', {
                'selector' : '.menu-icon',
                'helplink' : 'top-bar.html',
                'code' : '<button class="menu-icon" type="button" data-toggle="responsive-menu"></button>',
                action_menu: {
                    add: [prefix + 'titlebar-title']
                },
                'sections' : addPrefixToSectionsAndFields({
                    titlebarbtn : {
                        name : "Titlebar button",
                        fields: {
                            titlebarbtnres : {
                                type: 'text',
                                name: 'Toggle',
                                action: 'custom',
                                get_value: function(pgel) {
                                    return pgel.getAttr('data-toggle');
                                },
                                set_value: function(pgel, value, values, oldValue, eventType) {
                                    if (value) {
                                        pgel.setAttr('data-toggle', value);

                                        var pgparent = pgel.parent;
                                        if (pgparent.hasClass('title-bar')) pgparent.setAttr('data-responsive-toggle', value);
                                    }
                                    else {
                                        pgel.removeAttr('data-toggle');

                                        var pgparent = pgel.parent;
                                        if (pgparent.hasClass('title-bar')) pgparent.removeAttr('data-responsive-toggle');
                                    }

                                    return value
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_titlebar_icon);

            // Titlebar title
            var def_titlebar_title = new PgComponentType(prefix + 'titlebar-title', 'Title bar title', {
                'selector' : '.title-bar-title',
                'helplink' : 'top-bar.html',
                'code' : '<div class="title-bar-title">Menu</div>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_titlebar_title);

            // Titlebar responsive
            var def_titlebar = new PgComponentType(prefix + 'titlebar', 'Title bar', {
                'selector' : '.title-bar',
                'helplink' : 'top-bar.html',
                'code' : '<div class="title-bar" data-responsive-toggle="responsive-menu" data-hide-for="medium">\
                    <button class="menu-icon" type="button" data-toggle="responsive-menu"></button>\
                    <div class="title-bar-title">Menu</div>\
                </div>',
                action_menu: {
                    add: [prefix + 'titlebar-title', prefix + 'titlebar-icon']
                },
                'sections' : addPrefixToSectionsAndFields({
                    titlebar : {
                        name : "Topbar",
                        fields: {
                            titlebarhide : {
                                type: 'select',
                                name: 'Hide',
                                action: 'element_attribute',
                                attribute: 'data-hide-for',
                                options: [
                                    { key: 'small',  name: 'Small'  },
                                    { key: 'medium', name: 'Medium' },
                                    { key: 'large',  name: 'Large'  }
                                ]
                            },
                            titlebarresp : {
                                type: 'text',
                                name: 'Toggle',
                                action: 'custom',
                                get_value: function(pgel) {
                                    return pgel.getAttr('data-responsive-toggle');
                                },
                                set_value: function(pgel, value, values, oldValue, eventType) {
                                    if (value) {
                                        pgel.setAttr('data-responsive-toggle', value);

                                        var pgelbutton = pgel.findOne('button');
                                        if (pgelbutton) pgelbutton.setAttr('data-toggle', value);
                                    }
                                    else {
                                        pgel.removeAttr('data-responsive-toggle');

                                        var pgelbutton = pgel.findOne('button');
                                        if (pgelbutton) pgelbutton.removeAttr('data-toggle');
                                    }

                                    return value
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_titlebar);

            // Topbar
            var def_topbar = new PgComponentType(prefix + 'topbar', 'Top bar', {
                'selector': '.top-bar',
                'helplink': 'top-bar.html',
                'code': '<div class="top-bar">\
                    <div class="top-bar-left">\
                        <ul class="dropdown menu" data-dropdown-menu>\
                            <li class="menu-text">Site Title</li>\
                            <li>\
                                <a href="#">One</a>\
                                <ul class="menu vertical">\
                                    <li><a href="#">One</a></li>\
                                    <li><a href="#">Two</a></li>\
                                    <li><a href="#">Three</a></li>\
                                </ul>\
                            </li>\
                            <li><a href="#">Two</a></li>\
                            <li><a href="#">Three</a></li>\
                        </ul>\
                    </div>\
                    <div class="top-bar-right">\
                        <ul class="menu">\
                            <li><input type="search" placeholder="Search"></li>\
                            <li><button type="button" class="button">Search</button></li>\
                        </ul>\
                    </div>\
                </div>',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'topbar-title', prefix + 'topbar-right-content', prefix + 'topbar-left-content']
                },
                'sections' : addPrefixToSectionsAndFields({
                    topbar : {
                        name : "Topbar",
                        fields: {
                            topbarid : {
                                type: 'text',
                                name: 'Toggle',
                                action: 'element_attribute',
                                attribute: 'id'
                            },
                            titlebarstacked : {
                                type: 'select',
                                name: 'Stacked',
                                action: 'apply_class',
                                show_empty: true,
                                options: [
                                    { key: 'stacked-for-medium', name: 'Medium' },
                                    { key: 'stacked-for-large',  name: 'Large'  }
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_topbar);
        // End Topbar

        // Iconbar
            var def_icon_bar = new PgComponentType(prefix + 'icon-bar', 'Icon bar', {
                'helplink' : 'menu.html',
                'code' : '<ul class="menu icon-top">\
                    <li><a href="#"><i class="fi-list"></i> <span>One</span></a></li>\
                    <li><a href="#"><i class="fi-list"></i> <span>Two</span></a></li>\
                    <li><a href="#"><i class="fi-list"></i> <span>Three</span></a></li>\
                    <li><a href="#"><i class="fi-list"></i> <span>Four</span></a></li>\
                </ul>',
                tags: 'major',
                'sections' : addPrefixToSectionsAndFields({
                    'iconbarop' : {
                        name : 'Iconbar options',
                        fields : {
                            'iconbaricon' : {
                                'type' : 'checkbox',
                                'name' : 'Icon',
                                'action' : 'apply_class',
                                'value' : 'icons'
                            },
                            'iconbarpos' : {
                                'type' : 'select',
                                'name' : 'Position',
                                'action' : 'apply_class',
                                'options' : [
                                    { key: 'icon-top', name: 'Top' },
                                    { key: 'icon-left', name: 'Left' },
                                    { key: 'icon-right', name: 'Right' },
                                    { key: 'icon-bottom', name: 'Bottom' }
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_icon_bar);
        // End Iconbar

        // Breadcrumbs
            // Breadcrumb item
            var def_bc_item = new PgComponentType(prefix + 'bc-item', 'Breadcrumbs item', {
                'helplink' : 'breadcrumbs.html',
                'selector_new' : function(pgel) {
                    if (pgel.parent && pgel.parent.isSelector('.breadcrumbs')) {
                        return true;
                    }
                    return false;
                },
                'code' : '<li><a href="#">Item</a></li>',
                'priority' : 99,
                'sections' : addPrefixToSectionsAndFields({
                    'fdbcstyle' : {
                        name : 'Status',
                        fields : {
                            'percent' : {
                                'type' : 'select',
                                'name' : 'Status',
                                'action' : 'custom',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'current',  'name' : 'Current'  },
                                    { 'key' : 'disabled', 'name' : 'Disabled' }
                                ],
                                'get_value' : function (pgel) {
                                    if (pgel.hasClass('disabled')) {
                                        return 'disabled';
                                    }
                                    else if (!pgel.findOne('a')) {
                                        return 'current';
                                    }
                                    else {
                                        return '';
                                    }
                                },
                                'set_value' : function (pgel, value, values, oldValue, eventType) {
                                    if (value == oldValue) return value;

                                    pgel.removeClass('disabled');

                                    if (value) {
                                        var link = pgel.findOne('a');
                                        var text = '';

                                        if (link) {
                                            text = link.html();
                                            pgel.html(text);
                                        }

                                        if (value == 'disabled') {
                                            pgel.addClass('disabled');
                                        }
                                    }
                                    else {
                                        var text = pgel.html();
                                        var link = pgel.findOne('a');
                                        if (!link) {
                                            link = pgCreateNodeFromHtml('<a href="#"></a>');
                                            pgel.html('');
                                            pgel.append(link);
                                        }
                                        link.html(text);
                                    }

                                    return value;
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_bc_item);

            // Breadcrumbs
            var def_bc = new PgComponentType(prefix + 'breadcrumbs', 'Breadcrumbs', {
                'type' : 'fd-breadcrumbs',
                'selector' : '.breadcrumbs',
                'priority' : 100,
                'helplink' : 'breadcrumbs.html',
                'code' : '<ul class="breadcrumbs">\
                    <li><a href="#">Home</a></li>\
                    <li><a href="#">Features</a></li>\
                    <li class="disabled">Gene Splicing</li>\
                    <li>Cloning</li>\
                </ul>',
                'name' : 'Breadcrumbs',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'bc-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_bc);
        // End breadcrumbs

        // Pagination
            // Pagination item
            var def_pagination_item = new PgComponentType(prefix + 'pag-item', 'Pagination item', {
                'helplink' : 'pagination.html',
                'selector_new' : function (pgel) {
                    if (pgel.parent && pgel.parent.isSelector('.pagination')) {
                        return true;
                    }
                    return false;
                },
                'code' : '<li><a href="#">Item</a></li>',
                'priority' : 99,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_pagination_item);

            // Pagination
            var def_pagination = new PgComponentType(prefix + 'pagination', 'Pagination', {
                'selector' : '.pagination',
                'priority' : 100,
                'helplink' : 'pagination.html',
                'code' : '<ul class="pagination" role="navigation" aria-label="Pagination">\
                    <li class="pagination-previous disabled">Previous <span class="show-for-sr">page</span></li>\
                    <li class="current"><span class="show-for-sr">You\'re on page</span> 1</li>\
                    <li><a href="#" aria-label="Page 2">2</a></li>\
                    <li><a href="#" aria-label="Page 3">3</a></li>\
                    <li><a href="#" aria-label="Page 4">4</a></li>\
                    <li class="ellipsis" aria-hidden="true"></li>\
                    <li><a href="#" aria-label="Page 12">12</a></li>\
                    <li><a href="#" aria-label="Page 13">13</a></li>\
                    <li class="pagination-next"><a href="#" aria-label="Next page">Next <span class="show-for-sr">page</span></a></li>\
                </ul>',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'pag-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdbcstyle' : {
                        name : 'Layout',
                        fields : {
                            'percent' : {
                                'type' : 'checkbox',
                                'name' : 'Centered',
                                'value' : 'text-center',
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_pagination);
        // End Pagination

        // Navigation
            var navigation_section = new PgFrameworkLibSection(prefix + 'navigation', 'Navigation');
            navigation_section.setComponentTypes([def_titlebar, def_icon_bar, def_topbar, def_bc, def_pagination]);
            f.addLibSection(navigation_section);
        // End navigation


        // Orbit slider
            // Orbit slider helper
            var addOrbitSlide = function (pgel, prepend) {
                var pgorbit = pgel.closest('.orbit');
                var pgbullets = pgorbit.findOne('> .orbit-bullets');
                var $bullets = pgbullets.get$DOMElement();

                var pgbullet = pgCreateNodeFromHtml('<button data-slide="' + $bullets.children().length + '">\
                    <span class="show-for-sr">Slide details.</span>\
                </button>');

                if (pgbullets) {
                    if (prepend) {
                        pgbullets.prepend(pgbullet);
                    } else {
                        pgbullets.append(pgbullet);
                    }
                }
            }

            var gotoSlide = function (pgel) {
                var pgorbit = pgel.closest('.orbit');
                callSlider(pgorbit, "pause");

                var pgp = pgel.parent;
                var slides = pgp.find('li');
                var slideId = slides.indexOf(pgel);
                var orbitBullets = pgorbit.findOne('.orbit-bullets');
                if (orbitBullets) {
                    var pgBullet = orbitBullets.findOne('[data-slide="' + slideId + '"]');
                    if (pgBullet) {
                        var id = pgBullet.getId();
                        var code = '$(\'[data-pg-id="' + id + '"]\').click()';

                        var page = pgel.getPage();
                        pinegrow.setIgnoreClicks(true);
                        pinegrow.executeScriptInPage(page, code);
                        pinegrow.setIgnoreClicks(false);
                    }
                }
            }

            var callSlider = function (pgel, action, message) {
                var code;
                if (action == "pause") {
                    var id = pgel.getAttr('data-pg-id');
                    var code = '$(\'[data-pg-id="' + id + '"]\').trigger("mouseover")';
                }
                else if (action == "resume") {
                    var id = pgel.getAttr('data-pg-id');
                    var code = '$(\'[data-pg-id="' + id + '"]\').trigger("mouseout")';
                }
                else if (action == "next") {
                    var id = pgel.findOne('.orbit-next').getAttr("data-pg-id");
                    var code = '$(\'[data-pg-id="' + id + '"]\').click()';
                }
                else if (action == "previous") {
                    var id = pgel.findOne('.orbit-previous').getAttr("data-pg-id");
                    var code = '$(\'[data-pg-id="' + id + '"]\').click()';
                }

                if (code) {
                    var page = pgel.getPage();
                    pinegrow.setIgnoreClicks(true);
                    pinegrow.executeScriptInPage(page, code);
                    pinegrow.setIgnoreClicks(false);

                    if (message) {
                        pinegrow.showQuickMessage(message);
                    }
                }
            }

            var def_orbit_caption = new PgComponentType(prefix + 'orbit-caption', 'Orbit caption', {
                'priority' : 100,
                'helplink' : 'orbit.html',
                'selector' : '.orbit-caption',
                'code' : '<figcaption class="orbit-caption">Lets Rocket!</figcaption>',
                'tags' : 'major',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_caption);

            var def_orbit_image = new PgComponentType(prefix + 'orbit-image', 'Orbit image', {
                'priority' : 100,
                'helplink' : 'orbit.html',
                'selector' : '.orbit-image',
                'code' : '<img class="orbit-image" src="' + pinegrow.getPlaceholderImage() + '" alt="Space">',
                'tags' : 'major',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_image);

            var def_orbit_figure = new PgComponentType(prefix + 'orbit-figure', 'Orbit figure', {
                'priority' : 100,
                'helplink' : 'orbit.html',
                'selector' : '.orbit-figure',
                'code' : '<figure class="orbit-figure">\
                    <img class="orbit-image" src="' + pinegrow.getPlaceholderImage() + '" alt="Space">\
                    <figcaption class="orbit-caption">Lets Rocket!</figcaption>\
                </figure>',
                'tags' : 'major',
                'action_menu' : {
                    add: [prefix + 'orbit-image', prefix + 'orbit-caption']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_figure);

            var def_orbit_slide = new PgComponentType(prefix + 'orbit-slide', 'Orbit slide', {
                'selector' : '.orbit-slide',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                on_selected: function(pgel) {
                    pinegrow.showQuickMessage("Going to slide...");
                    gotoSlide(pgel);
                },
                'action_menu' : {
                    add: [prefix + 'orbit-figure']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_slide);

            // Orbit slider image item
            var def_orbit_item_image = new PgComponentType(prefix + 'orbit-item-image', 'Orbit slide image', {
                'priority' : 100,
                'helplink' : 'orbit.html',
                'code' : function () {
                    return '<li class="orbit-slide">\
                        <div>\
                            <img src="' + pinegrow.getPlaceholderImage() + '" />\
                            <p class="orbit-caption">Lets Rocket!</p>\
                        </div>\
                    </li>';
                },
                'tags' : 'major',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_item_image);

            // Orbit slider non-image item
            var def_orbit_item_nonimage = new PgComponentType(prefix + 'orbit-item-nonimage', 'Orbit slide non-image', {
                'priority' : 100,
                'helplink' : 'orbit.html',
                'code' : '<li class="orbit-slide">\
                    <div>\
                        <h3 class="text-center">2: You can also throw some text in here!</h3>\
                        <p class="text-center">Lorem ipsum dolor sit amet, consectetur adipisicing elit. Unde harum rem, beatae ipsa consectetur quisquam. Rerum ratione, delectus atque tempore sed, suscipit ullam, beatae distinctio cupiditate ipsam eligendi tempora expedita.</p>\
                        <h3 class="text-center">This Orbit slider does not use animations.</h3>\
                    </div>\
                </li>',
                'tags': 'major',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_item_nonimage);

            var def_orbit_previous = new PgComponentType(prefix + 'orbit-previous', 'Orbit previous', {
                'selector' : '.orbit-previous',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<button class="orbit-previous"><span class="show-for-sr">Previous Slide</span>&#9664;&#xFE0E;</button>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_previous);

            var def_orbit_next = new PgComponentType(prefix + 'orbit-next', 'Orbit next', {
                'selector' : '.orbit-next',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<button class="orbit-next"><span class="show-for-sr">Next Slide</span>&#9654;&#xFE0E;</button>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_next);

            var def_orbit_controls = new PgComponentType(prefix + 'orbit-controls', 'Orbit controls', {
                'selector' : '.orbit-controls',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<div class="orbit-controls">\
                    <button class="orbit-previous"><span class="show-for-sr">Previous Slide</span>&#9664;&#xFE0E;</button>\
                    <button class="orbit-next"><span class="show-for-sr">Next Slide</span>&#9654;&#xFE0E;</button>\
                </div>',
                'action_menu' : {
                    add: [prefix + 'orbit-next', prefix + 'orbit-previous']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_controls);

            var def_orbit_container = new PgComponentType(prefix + 'orbit-container', 'Orbit container', {
                'selector' : '.orbit-container',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<ul class="orbit-container"></ul>',
                'action_menu' : {
                    add: [prefix + 'orbit-item-image', prefix + 'orbit-item-nonimage']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_container);

            var def_orbit_wrapper = new PgComponentType(prefix + 'orbit-wrapper', 'Orbit wrapper', {
                'selector' : '.orbit-wrapper',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<div class="orbit-wrapper"></div>',
                'action_menu' : {
                    add: [prefix + 'orbit-controls', prefix + 'orbit-container']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_wrapper);

            var def_orbit_slide_button = new PgComponentType(prefix + 'orbit-bullets-btn', 'Orbit bullets button', {
                'selector' : '[data-slide]',
                'helplink' : 'orbit.html',
                'code' : '<button data-slide="0">\
                    <span class="show-for-sr">Slide details.</span>\
                </button>',
                'sections' : addPrefixToSectionsAndFields({
                    'orbitsdbtn' : {
                        name : 'Slide button',
                        fields : {
                            'percent' : {
                                'type' : 'text',
                                'name' : 'Slide',
                                'action' : 'element_attribute',
                                'attribute' : 'data-slide'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_orbit_slide_button);

            var def_orbit_bullets = new PgComponentType(prefix + 'orbit-bullets', 'Orbit bullets', {
                'selector' : '.orbit-bullets',
                'priority' : 99,
                'helplink' : 'orbit.html',
                'tags' : 'major',
                'code' : '<nav class="orbit-bullets">\
                    <button class="is-active" data-slide="0">\
                        <span class="show-for-sr">First slide details.</span>\
                        <span class="show-for-sr">Current Slide</span>\
                    </button>\
                    <button data-slide="1">\
                        <span class="show-for-sr">Second slide details.</span>\
                    </button>\
                    <button data-slide="2">\
                        <span class="show-for-sr">Third slide details.</span>\
                    </button>\
                </nav>',
                'action_menu' : {
                    add: [prefix + 'orbit-bullets-btn']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_orbit_bullets);

            // Orbit slider
            var def_orbit = new PgComponentType(prefix + 'orbit', 'Orbit slider', {
                'helplink' : 'orbit.html',
                'selector': '[data-orbit]',
                'priority' : 100,
                'code' : '<div class="orbit" role="region" aria-label="Favorite Space Pictures" data-orbit data-use-m-u-i="false">\
                    <ul class="orbit-container">\
                        <button class="orbit-previous" aria-label="previous">\
                            <span class="show-for-sr">Previous Slide</span>&#9664;\
                        </button>\
                        <button class="orbit-next" aria-label="next">\
                            <span class="show-for-sr">Next Slide</span>&#9654;\
                        </button>\
                        <li class="is-active orbit-slide">\
                            <div>\
                                <img src="' + pinegrow.getPlaceholderImage() + '" />\
                                <p class="orbit-caption">Space, the final frontier.</p>\
                            </div>\
                        </li>\
                        <li class="orbit-slide">\
                            <div>\
                                <img src="' + pinegrow.getPlaceholderImage() + '" />\
                                <p class="orbit-caption">Lets Rocket!</p>\
                            </div>\
                        </li>\
                        <li class="orbit-slide">\
                            <div>\
                                <img src="' + pinegrow.getPlaceholderImage() + '" />\
                                <p class="orbit-caption">Encapsulating</p>\
                            </div>\
                        </li>\
                    </ul>\
                    <nav class="orbit-bullets">\
                        <button class="is-active" data-slide="0">\
                            <span class="show-for-sr">First slide details.</span>\
                            <span class="show-for-sr">Current Slide</span>\
                        </button>\
                        <button data-slide="1">\
                            <span class="show-for-sr">Second slide details.</span>\
                        </button>\
                        <button data-slide="2">\
                            <span class="show-for-sr">Third slide details.</span>\
                        </button>\
                    </nav>\
                </div>',
                on_changed : function() {
                    showOrbitMessage();
                },
                on_inserted : function() {
                    refreshPage();
                },
                tags: 'major',
                action_menu: {
                    actions : [
                        {label: "Pause Carousel", action: function(pgel) {
                            callSlider(pgel, "pause", "Orbit paused.");
                        }},
                        {label: "Resume Carousel", action: function(pgel) {
                            callSlider(pgel, "resume", "Orbit resumed.");
                        }},
                        {label: "Next Slide", action: function(pgel) {
                            callSlider(pgel, "next");
                        }},
                        {label: "Previous Slide", action: function(pgel) {
                            callSlider(pgel, "previous");
                        }}
                    ],
                    add: [prefix + 'orbit-item-image', prefix + 'orbit-item-nonimage', prefix + 'orbit-wrapper', prefix + 'orbit-bullets'],
                    on_add : function(pgel, pgnew, newdef, prepend) {
                        var pgParent = pgel;

                        if (newdef.type == prefix + 'orbit-item-image' || newdef.type == prefix + 'orbit-item-nonimage') {
                            pgParent = pgel.findOne('.orbit-container');
                        }

                        if (prepend) {
                            pgParent.prepend(pgnew);
                        } else {
                            pgParent.append(pgnew);
                        }

                        addOrbitSlide(pgel, prepend);
                        showOrbitMessage();
                    }
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdorbitoptions' : {
                        'name' : 'Orbit options',
                        'fields' : {
                            'fddataoptions': {
                                type: 'text',
                                name: 'Data options',
                                action: 'element_attribute',
                                attribute : 'data-options',
                                placeholder : 'Plugin options',
                                on_changed: function () {
                                    showOrbitMessage();
                                }
                            },
                            'fdorbitusemui' : {
                                type : 'checkbox',
                                name : 'Use Motion UI',
                                action : "element_attribute",
                                attribute: 'data-use-m-u-i',
                                value: 'true',
                                negvalue: 'false',
                                default_value: 'true',
                                on_changed : function(obj, prop, value, oldValue, fieldDef, $field, eventType, values, crsaPage) {
                                    if(value == 'true') {
                                        pinegrow.showQuickMessage('Motion UI needs to be included on the page for this to work.', 4000);
                                    }
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_orbit);
            // var orbit_action = new PgComponentType('fd-orbit-action', 'Orbit slider');
            // orbit_action.selector = "[data-orbit]";
            // orbit_action.attribute = 'data-orbit';
            // orbit_action.helplink = 'orbit.html';
            // orbit_action.action = true;
            // orbit_action.not_main_type = true;
            // orbit_action.sections = {
            //     'fd.orbit.parameters' : {
            //         name : 'Options',
            //         fields : getStandardPluginAction({})
            //     }
            // }
            // orbit_action.on_action_added = function(pgel, cp, action_def, $el) {
            //     pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate tooltip.');
            // }
            // f.addComponentType(orbit_action);
            // actions.push(orbit_action);
        // End Orbit slider

        // Thumbnail
            var def_thumbnail = new PgComponentType(prefix + 'thumbnail', 'Thumbnail', {
                'selector' : 'img.thumbnail',
                'priority' : 100,
                'helplink' : 'thumbnail.html',
                'code' : function() {
                    var img = pinegrow.getPlaceholderImage();
                    var thumb = pinegrow.getThumbnailForPlaceholderImage(img);
                    return '<img class="thumbnail" src="' + thumb + '"/>';
                },
                tags: 'major',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_thumbnail);
        // End Thumbnail

        // Badge
            var def_badge = new PgComponentType(prefix + 'badge', 'Badge', {
                'selector' : '.badge',
                'code' : '<span class="badge">1</span>',
                'priority' : 99,
                'helplink' : 'badge.html',
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle' : {
                        'name' : 'Badge options',
                        'fields' : {
                            'fdcolor' : {
                                'type' : 'select',
                                'action' : 'apply_class',
                                'toggle_buttons' : true,
                                'show_empty' : true,
                                'name' : 'Color',
                                'options' : foundationColors
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_badge);
        // End Badge

        // Flex video
            var def_responsive_embed = new PgComponentType(prefix + 'responsive-embed', 'Responsive embed', {
                'selector' : '.responsive-embed',
                'priority' : 100,
                'helplink' : 'responsive-embed.html',
                'code' : '<div class="responsive-embed">\
                    <iframe src="http://player.vimeo.com/video/60122989" width="400" height="225" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>\
                </div>',
                'drag_helper' : '<div class="flex-video pg-empty-placeholder"></div>',
                empty_placeholder : false,
                tags: 'major',
                'sections' : addPrefixToSectionsAndFields({
                    fdlightbox : {
                        name : 'Video options',
                        fields : {
                            'rsemcode' : {
                                'type' : 'text',
                                'name' : 'Embed code',
                                'action' : 'element_html',
                                live_update: false
                            },
                            'rsemwidescreen' : {
                                'type' : 'checkbox',
                                'name' : 'Widescreen',
                                'value' : 'widescreen',
                                'action' : 'apply_class'
                            },
                            'rsempanorama' : {
                                'type' : 'checkbox',
                                'name' : 'Panorama',
                                'value' : 'panorama',
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_responsive_embed);
        // End Flex video

        // Media
            var media_section = new PgFrameworkLibSection(prefix + 'media', 'Media');
            media_section.setComponentTypes([def_orbit, def_thumbnail, def_badge, def_responsive_embed]);
            f.addLibSection(media_section);
        // End media


        // Forms
            var formsCompArr = [];

            // Form
            var def_form = new PgComponentType(prefix + 'form', 'Form', {
                'tags' : 'major',
                'priority' : 100,
                'selector' : 'form',
                'helplink' : 'forms.html',
                'code' : '<form>\
                    <div class="grid-container">\
                        <div class="grid-x grid-padding-x">\
                            <div class="large-12 cell">\
                                <label>Input Label\
                                    <input type="text" placeholder="large-12.cell" />\
                                </label>\
                            </div>\
                        </div>\
                    </div>\
                    <div class="grid-container">\
                        <div class="grid-x grid-padding-x">\
                            <div class="large-4 cell">\
                                <label>Input Label\
                                    <input type="text" placeholder="large-4.cell" />\
                                </label>\
                            </div>\
                            <div class="large-4 cell">\
                                <label>Input Label\
                                    <input type="text" placeholder="large-4.cell" />\
                                </label>\
                            </div>\
                            <div class="large-4 cell">\
                                <div class="collapse">\
                                    <label>Input Label</label>\
                                    <div class="input-group">\
                                        <input class="input-group-field" type="url">\
                                        <span class="input-group-label">.com</span>\
                                    </div>\
                                </div>\
                            </div>\
                        </div>\
                    </div>\
                    <div class="grid-container">\
                        <div class="grid-x grid-padding-x">\
                            <div class="large-12 cell">\
                                <label>Select Box\
                                    <select>\
                                        <option value="husker">Husker</option>\
                                        <option value="starbuck">Starbuck</option>\
                                        <option value="hotdog">Hot Dog</option>\
                                        <option value="apollo">Apollo</option>\
                                    </select>\
                                </label>\
                            </div>\
                        </div>\
                    </div>\
                    <div class="grid-container">\
                        <div class="grid-x grid-padding-x">\
                            <div class="large-6 cell">\
                                <label>Choose Your Favorite</label>\
                                <input type="radio" name="pokemon" value="Red" id="pokemonRed">\
                                <label for="pokemonRed">Red</label>\
                                <input type="radio" name="pokemon" value="Blue" id="pokemonBlue">\
                                <label for="pokemonBlue">Blue</label>\
                            </div>\
                            <div class="large-6 cell">\
                                <label>Check these out</label>\
                                <input id="checkbox1" type="checkbox">\
                                <label for="checkbox1">Checkbox 1</label>\
                                <input id="checkbox2" type="checkbox">\
                                <label for="checkbox2">Checkbox 2</label>\
                            </div>\
                        </div>\
                    </div>\
                    <div class="grid-container">\
                        <div class="grid-x grid-padding-x">\
                            <div class="large-12 cell">\
                                <label>Textarea Label\
                                    <textarea placeholder="small-12.cell"></textarea>\
                                </label>\
                            </div>\
                        </div>\
                    </div>\
                </form>',
                action_menu: {
                    add: [prefix + 'container']
                },
                'sections' : addPrefixToSectionsAndFields({
                    attributes : {
                        //inherit this from html framework
                        inherit: true
                    }
                })
            });
            f.addComponentType(def_form);
            formsCompArr.push(def_form);

            // inputs
            var defineInputField = function(type) {
                var code;
                var name;
                switch(type) {
                    case 'input':
                        code = '<input type="text" placeholder="input fiels" />';
                        name = 'Input';
                        break;
                    case 'textarea':
                        code = '<textarea></textarea>';
                        name = 'Textarea';
                        break;
                    case 'select':
                        code = '<select></select>';
                        name = 'Select';
                        break;
                    case 'button':
                        code = '<button value="Button" />';
                        name = 'Button';
                        break;
                }

                var enableForField = function(pgfield, req) {
                    pgfield.closest('form').getAttr("data-abide", '');
                    var pglab = pgfield.parent;
                    if (req) {
                        if (pglab.tagName == 'label' && pglab.find('small').length == 0) {
                            pgCreateNodeFromHtml('<small>required</small>').insertBefore(pgfield);
                        }
                    }
                    if (pglab.tagName == 'label' && $pgab.find('> .form-error').length == 0) {
                        pgCreateNodeFromHtml('<span class="form-error">Field is required.</span>').insertAfter(pgfield);
                    }

                    // $.fn.crsa('setNeedsUpdate', false, $lab);
                }

                var def_input = new PgComponentType(prefix + type, name, {
                    'selector' : type,
                    priority: 100,
                    'code' : '<label>Input Label' + code + '</label>',
                    'sections' : addPrefixToSectionsAndFields({
                        attributes : {
                            //inherit this from html framework
                            inherit: true
                        },
                        'fdvalidation' : {
                            name : 'Validation',
                            fields : {
                                'fdrequired' : {
                                    'type' : 'checkbox',
                                    'name' : 'Required',
                                    'value' : '1',
                                    'action' : 'custom',
                                    get_value: function (pgel) {
                                        return pgel.hasAttr('required') ? '1' : null;
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        if (value) {
                                            enableForField(pgel, true);
                                            pgel.setAttr('required', '');
                                            showOrbitMessage();
                                        } else {
                                            pgel.removeAttr('required');
                                        }
                                        return value;
                                    }
                                },
                                'fdpattern' : {
                                    'type' : 'select',
                                    'name' : 'Pattern',
                                    'show_empty' : true,
                                    options: [
                                        {key: 'alpha', name: 'alpha'},
                                        {key: 'alpha_numeric', name: 'alpha_numeric'},
                                        {key: 'integer', name: 'integer'},
                                        {key: 'number', name: 'number'},
                                        {key: 'password', name: 'password'},
                                        {key: 'card', name: 'card'},
                                        {key: 'cvv', name: 'cvv'},
                                        {key: 'email', name: 'email'},
                                        {key: 'url', name: 'url'},
                                        {key: 'domain', name: 'domain'},
                                        {key: 'datetime', name: 'datetime'},
                                        {key: 'date', name: 'date'},
                                        {key: 'time', name: 'time'},
                                        {key: 'dateISO', name: 'dateISO'},
                                        {key: 'month_day_year', name: 'month_day_year'},
                                        {key: 'color', name: 'color'}
                                    ],
                                    'action' : 'custom',
                                    get_value: function (pgel) {
                                        return pgel.getAttr('pattern');
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        if (value) {
                                            enableForField(pgel)
                                            pgel.setAttr('pattern', value);
                                            showOrbitMessage();
                                        } else {
                                            pgel.removeAttr('pattern');
                                        }
                                        return value;
                                    }
                                },
                                'fdcustompat' : {
                                    'type' : 'text',
                                    'name' : 'Custom pattern',
                                    'value' : '1',
                                    'action' : 'custom',
                                    get_value: function (pgel) {
                                        return pgel.getAttr('pattern');
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        if (value) {
                                            enableForField(pgel)
                                            pgel.attr('pattern', value);
                                            showOrbitMessage();
                                        } else {
                                            pgel.removeAttr('pattern');
                                        }
                                        return value;
                                    }
                                },
                                'fderrortext' : {
                                    'type' : 'text',
                                    'name' : 'Error text',
                                    'action' : 'custom',
                                    get_value : function (pgel) {
                                        var pgerror = pgel.siblings('.form-error');
                                        if (pgerror.length > 0) {
                                            return pgerror[0].html();
                                        }
                                        else {
                                            return '';
                                        }
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        if (value == oldValue) return value;

                                        var pgerror = pgel.siblings('.form-error');
                                        if (pgerror.length == 0) {
                                            showAlert("Can't find form error with next to input. Add a form error first.", "Element not found");
                                            return '';
                                        }
                                        else {
                                            pgerror[0].html(value);
                                        }

                                        return value;
                                    }
                                }
                            }
                        }
                    })
                });
                f.addComponentType(def_input);
                formsCompArr.push(def_input);
            }
            defineInputField('input');
            defineInputField('textarea');
            defineInputField('select');
            defineInputField('button');

            // Form column
            var def_form_column = new PgComponentType(prefix + 'form-column', 'Form column', {
                'helplink' : 'forms.html',
                'selector_new' : function(pgel) {
                    return pgel.isSelector('.cell') && pgel.closest('form');
                },
                'tags' : 'major',
                'priority' : 100,
                'code' : '<div class="cell">\
                    <label>Input Label\
                        <input type="text" placeholder="text" />\
                    </label>\
                </div>',
                action_menu: {
                    // add: [prefix + 'input', prefix + 'textarea', prefix + 'select', 'fd-range-slider', 'fd-switch', 'fd-fieldset', 'fd-input-group']
                    add: [prefix + 'input', prefix + 'textarea', prefix + 'select']
                },
                'sections' : addPrefixToSectionsAndFields({
                    fdcollayout : {
                        inherit: true
                    }
                })
            });
            f.addComponentType(def_form_column);
            formsCompArr.push(def_form_column);

            // Form label
            var def_label = new PgComponentType(prefix + 'label-only', 'Label', {
                'selector' : null,
                'priority': 100,
                'helplink' : 'forms.html',
                'code' : '<label>Input Label</label>'
            });
            f.addComponentType(def_label);
            formsCompArr.push(def_label);

            // Form label with input
            var def_form_label_field = new PgComponentType(prefix + 'form-label', 'Label + Field', {
                'selector' : 'label',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<label>Input Label\
                    <input type="text" placeholder="input fiels" />\
                </label>',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Label options',
                        fields : {
                            'fdmiddle' : {
                                'type' : 'checkbox',
                                'name' : 'Middle',
                                'value' : 'middle',
                                'action' : 'apply_class'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_form_label_field);
            formsCompArr.push(def_form_label_field);

            // Range slider options
            var rangeSliderOptions = {
                'fdvertical' : {
                    'type' : 'checkbox',
                    'name' : 'Vertical',
                    'value' : '1',
                    'action' : 'custom',
                    get_value: function (pgel) {
                        return pgel.hasClass('vertical') ? 1 : 0;
                    },
                    set_value: function (pgel, value, values, oldValue, eventType) {
                        if (value == '1') {
                            pgel.addClass('vertical');
                            pgel.setAttr('data-vertical', 'true');
                        }
                        else {
                            pgel.removeClass('vertical');
                            pgel.removeAttr('data-vertical');
                        }

                        if (value != oldValue) {
                            showOrbitMessage();
                        }
                        return value;
                    }
                },
                'fdstartvalue' : {
                    type: 'text',
                    name: 'Inital start value',
                    action: 'element_attribute',
                    live_update: false,
                    attribute : 'data-initial-start',
                    on_changed: function () {
                        showOrbitMessage();
                    }
                },
                'fdstepvalue' : {
                    type: 'text',
                    name: 'Step',
                    action: 'element_attribute',
                    live_update: false,
                    attribute : 'data-step',
                    on_changed: function () {
                        showOrbitMessage();
                    }
                },
                'fdlength' : {
                    type: 'text',
                    name: 'Length',
                    action: 'element_attribute',
                    live_update: false,
                    attribute : 'data-end',
                    on_changed: function () {
                        showOrbitMessage();
                    }
                },
                'fddisabled' : {
                    'type' : 'checkbox',
                    'name' : 'Disabled',
                    'value' : 'disabled',
                    'action' : 'apply_class'
                },
                'fddatabinding' : {
                    'type' : 'text',
                    'name' : 'Data binding',
                    'live_update' : false,
                    'action' : 'custom',
                    get_value: function (pgel) {
                        var pgHandel = pgel.findOne('[data-slider-handle]')
                        return pgHandel.getAttr('aria-controls');
                    },
                    set_value: function (pgel, value, values, oldValue, eventType) {
                        var pgHandel = pgel.find('[data-slider-handle]')
                        pgHandel.setAttr('aria-controls', value);

                        if (pgHandel.getAttr('aria-controls')) {
                            var pginput = pgel.find('input[type="hidden"]');
                            for (var i = 0; i < pginput.length; i++) {
                                pginput[i].remove();
                            }
                        }
                        else {
                            var pginput = pgel.find('input[type="hidden"]');
                            if (pginput.length == 0) {
                                pgel.append(pgCreateNodeFromHtml('<input type="hidden">'));
                            }
                        }

                        if (value != oldValue) {
                            showOrbitMessage();
                        }

                        return value;
                    }
                }
            }

            // Range slider
            var def_range_slider = new PgComponentType(prefix + 'range-slider', 'Range Slider', {
                'helplink' : 'slider.html',
                'selector_new' : function (pgel) {
                    return (pgel.hasClass('slider') && pgel.find('input').length < 2);
                },
                'priority' : 100,
                'code' : '<div class="slider" data-slider data-initial-start="50" data-end="200">\
                    <span class="slider-handle"  data-slider-handle role="slider" tabindex="1"></span>\
                    <span class="slider-fill" data-slider-fill></span>\
                    <input type="hidden">\
                </div>',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Range slider options',
                        fields : rangeSliderOptions
                    }
                })
            });
            f.addComponentType(def_range_slider);
            formsCompArr.push(def_range_slider);

            // Range slider
            var def_range_two_slider = new PgComponentType(prefix + 'two-handles-range-slider', 'Range Slider (two handles)', {
                'helplink' : 'slider.html',
                'selector_new' : function (pgel) {
                    return (pgel.hasClass('slider') && pgel.find('input').length > 1);
                },
                'priority' : 100,
                'code' : '<div class="slider" data-slider data-initial-start="25" data-initial-end="75">\
                    <span class="slider-handle" data-slider-handle role="slider" tabindex="1"></span>\
                    <span class="slider-fill" data-slider-fill></span>\
                    <span class="slider-handle" data-slider-handle role="slider" tabindex="1"></span>\
                    <input type="hidden">\
                    <input type="hidden">\
                </div>',
                on_inserted: function () {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Range two handles slider options',
                        fields : $.extend({}, rangeSliderOptions, {
                            'fdendvalue': {
                                type: 'text',
                                name: 'Inital end value',
                                action: 'element_attribute',
                                live_update: false,
                                attribute : 'data-initial-end',
                                on_changed: function () {
                                    showOrbitMessage();
                                }
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_range_two_slider);
            formsCompArr.push(def_range_two_slider);

            // Switch
            var def_switch = new PgComponentType(prefix + 'switch', 'Switch', {
                'selector' : 'div.switch',
                'priority' : 100,
                'helplink' : 'switch.html',
                'preview' : function() {
                    var id = "previewSwitch";
                    return '<div class="switch">\
                      <input class="switch-input" id="' + id + '" type="checkbox" name="exampleSwitch">\
                      <label class="switch-paddle" for="' + id + '">\
                        <span class="show-for-sr">Download Kittens</span>\
                      </label>\
                    </div>';
                },
                'code' : function() {
                    var id = getUniqueId("switch");
                    return '<div class="switch">\
                      <input class="switch-input" id="'+id+'" type="checkbox" name="exampleSwitch">\
                      <label class="switch-paddle" for="'+id+'">\
                        <span class="show-for-sr">Download Kittens</span>\
                      </label>\
                    </div>';
                },
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Switch options',
                        fields : {
                            'fdtype' : {
                                'type' : 'select',
                                'name' : 'Type',
                                'show_empty' : false,
                                action: 'custom',
                                options: [
                                    {key: 'checkbox', name: 'Checkbox'},
                                    {key: 'radio', name: 'Radio'}
                                ],
                                get_value: function (pgel) {
                                    return pgel.findOne('input').getAttr('type');
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    pgel.findOne('input').setAttr('type', value);
                                    // pinegrow.setNeedsUpdate($el);
                                    return value;
                                }
                            },
                            'fdsize' : {
                                'type' : 'select',
                                'name' : 'Size',
                                'show_empty' : true,
                                action: 'apply_class',
                                options: [
                                    {key: 'tiny', name: 'Tiny'},
                                    {key: 'small', name: 'Small'},
                                    {key: 'large', name: 'Large'}
                                ]
                            },
                            'fdchecked' : {
                                'type' : 'checkbox',
                                'name' : 'Checked',
                                'value' : 1,
                                'action' : 'custom',
                                get_value : function (pgel) {
                                    var pginput = pgel.findOne('.switch-input');
                                    return pginput.hasAttr('checked');
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pginput = pgel.findOne('.switch-input');

                                    if (value == '1') {
                                        pginput.attr('checked', 'checked');
                                    }
                                    else {
                                        pginput.removeAttr('checked');
                                    }

                                    return value;
                                }
                            },
                            'fdswitchactive' : {
                                'type' : 'text',
                                'name' : 'Switch active text',
                                'action' : 'custom',
                                'live_update' : false,
                                get_value : function (pgel) {
                                    var pgactive = pgel.findOne('.switch-active');
                                    return pgactive ? pgactive.html() : null;
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pgactive = pgel.findOne('.switch-active');
                                    var pglabel = pgel.findOne('.switch-paddle')

                                    if (value) {
                                        if (!pgactive) {
                                            pgactive = pgCreateNodeFromHtml('<span class="switch-active" aria-hidden="true"></span>');
                                            pglabel.append(pgactive);
                                            // $.fn.crsa('setNeedsUpdate', false, $label);
                                        }

                                        pgactive.html(value);
                                    }
                                    else {
                                        if (pgactive) {
                                            pgactive.remove();
                                            // $.fn.crsa('setNeedsUpdate', false, $label);
                                        }
                                    }

                                    return value;
                                }
                            },
                            'fdswitchinactive' : {
                                'type' : 'text',
                                'name' : 'Switch inactive text',
                                'action' : 'custom',
                                'live_update' : false,
                                get_value : function (pgel) {
                                    var pgactive = pgel.findOne('.switch-inactive');
                                    return pgactive ? pgactive.html() : null;
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pgactive = pgel.findOne('.switch-inactive');
                                    var pglabel = pgel.findOne('.switch-paddle')

                                    if (value) {
                                        if (!pgactive) {
                                            pgactive = pgCreateNodeFromHtml('<span class="switch-inactive" aria-hidden="true"></span>');
                                            pglabel.append(pgactive);
                                            // $.fn.crsa('setNeedsUpdate', false, $label);
                                        }

                                        pgactive.html(value);
                                    }
                                    else {
                                        if (pgactive) {
                                            pgactive.remove();
                                            $.fn.crsa('setNeedsUpdate', false, $label);
                                        }
                                    }

                                    return value;
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_switch);
            formsCompArr.push(def_switch);

            // Fieldset
            var def_fieldset = new PgComponentType(prefix + 'fieldset', 'Fieldset', {
                'selector' : 'fieldset',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<fieldset class="fieldset">\
                    <legend>Fieldset Legend</legend>\
                    <label>Input Label\
                        <input type="text" placeholder="Inputs and other form elements go inside...">\
                    </label>\
                </fieldset>',
                'sections' : addPrefixToSectionsAndFields({
                    fdlightboxitem : {
                        name : 'Fieldset options',
                        fields : {
                            'fdlegend' : {
                                'type' : 'text',
                                'name' : 'Legend',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    return pgel.findOne('legend').html();
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    pgel.findOne('legend').html(value);
                                    return value;
                                }
                            }
                        }
                    }

                })
            });
            f.addComponentType(def_fieldset);
            formsCompArr.push(def_fieldset);

            // Input Group
            var def_input_group = new PgComponentType(prefix + 'input-group', 'Input group', {
                'selector' : '.input-group',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<div class="input-group">\
                    <span class="input-group-label">$</span>\
                    <input class="input-group-field" type="url">\
                    <div class="input-group-button">\
                        <input type="submit" class="button" value="Submit">\
                    </div>\
                </div>',
                action_menu: {
                    add: [prefix + 'input-group-label', prefix + 'input-group-field', prefix + 'input-group-button']
                }
            });
            f.addComponentType(def_input_group);
            formsCompArr.push(def_input_group);

            // Input group field
            var def_input_group_label = new PgComponentType(prefix + 'input-group-label', 'Input group label', {
                'selector' : '.input-group-label',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<span class="input-group-label">$</span>'
            });
            f.addComponentType(def_input_group_label);

            var def_input_group_field = new PgComponentType(prefix + 'input-group-field', 'Input group field', {
                'selector' : '.input-group-field',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<input class="input-group-field" type="url">'
            });
            f.addComponentType(def_input_group_field);

            var def_input_group_button = new PgComponentType(prefix + 'input-group-button', 'Input group button', {
                'selector' : '.input-group-button',
                'priority' : 100,
                'helplink' : 'forms.html',
                'code' : '<div class="input-group-button">\
                    <input type="submit" class="button" value="Submit">\
                </div>'
            });
            f.addComponentType(def_input_group_button);

            // Form field error
            var def_form_error = new PgComponentType(prefix + 'form-error', 'Error', {
                'selector' : '.form-error',
                'priority' : 100,
                'helplink' : 'abide.html',
                'code' : '<span class="form-error">Invalid entry</span>',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Error options',
                        fields : {
                            'fdinline' : {
                                'type' : 'text',
                                'name' : 'Message',
                                'action' : 'element_html'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_form_error);
            formsCompArr.push(def_form_error);

            var def_input = new PgComponentType(prefix + 'form-input', 'Input', {
                'selector' : 'input',
                'priority' : 100,
                'helplink' : 'form.html',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Input options',
                        fields : {
                            'fdinputtype' : {
                                'type' : 'select',
                                'name' : 'Type',
                                'action' : 'custom',
                                'options' : [
                                    {key: 'text', name: 'Text'},
                                    {key: 'password', name: 'Password'},
                                    {key: 'number', name: 'Number'},
                                    {key: 'email', name: 'Email'},
                                    {key: 'file', name: 'File'},
                                    {key: 'url', name: 'Url'},
                                    {key: 'search', name: 'Search'},
                                    {key: 'tel', name: 'Tel'},
                                    {key: 'color', name: 'Color'},
                                    {key: 'datetime', name: 'Datetime'},
                                    {key: 'datetime-local', name: 'Datetime local'},
                                    {key: 'date', name: 'Date'},
                                    {key: 'month', name: 'Month'},
                                    {key: 'time', name: 'Time'},
                                    {key: 'week', name: 'Week'}
                                ],
                                get_value: function (pgel) {
                                    return pgel.getAttr('type');
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    pgel.setAttr('type', value);
                                    return value;
                                }
                            },
                            'fdinputvalue': {
                                type: 'text',
                                name: 'Value',
                                action: 'custom',
                                attribute: 'value',
                                get_value: function (pgel) {
                                    return pgel.getAttr('value');
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    pgel.setAttr('value', value);
                                    return value;
                                }
                            },
                            'fdinputplaceholder': {
                                type: 'text',
                                name: 'Placeholder',
                                action: 'element_attribute',
                                attribute: 'placeholder'
                            },
                            'fddisabled_attr': attr_disabled
                        }
                    }
                })
            });
            f.addComponentType(def_input);

            var def_textarea = new PgComponentType(prefix + 'form-textarea', 'Textarea', {
                'selector' : 'textarea',
                'priority' : 100,
                'helplink' : 'form.html',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Textarea options',
                        fields : {
                            'fdtextarearows' : {
                                'type' : 'text',
                                'name' : 'Rows',
                                'action' : 'element_attribute',
                                'attribute' : 'rows'
                            },
                            'fddisabled_attr' : attr_disabled
                        }
                    }
                })
            });
            f.addComponentType(def_textarea);

            var def_select = new PgComponentType(prefix + 'form-select', 'Select', {
                'selector' : 'select',
                'priority' : 100,
                'helplink' : 'form.html',
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name : 'Textarea options',
                        fields : {
                            'formselectmultiple' : {
                                'type' : 'checkbox',
                                'name' : 'Multiple',
                                'action' : 'element_attribute',
                                'attribute' : 'multiple',
                                'value' : 'multiple',
                                'attribute_without_value' : true
                            },
                            'fddisabled_attr': attr_disabled
                        }
                    }
                })
            });
            f.addComponentType(def_select);
        // End Forms

        // Forms section
            var forms_section = new PgFrameworkLibSection(prefix + 'forms', 'Forms');
            forms_section.setComponentTypes(formsCompArr);
            f.addLibSection(forms_section);
        // End forms section


        // Button helper
            var linkOptionsSection = {
                name : 'Link options',
                fields : {
                    fdlabel : {
                        'type' : 'text',
                        'name' : 'Text',
                        'action' : 'custom',
                        get_value : function (pgel) {
                            return pgel.html();
                        },
                        set_value: function (pgel, value, values, oldValue, eventType) {
                            pgel.html((value ? value : ''));
                            return value;
                        }
                    }
                }
            }
        // End button helper

        // Link button
            var def_link_button = new PgComponentType(prefix + 'a-button', 'Button', {
                'selector' : '.button',
                'priority' : 100,
                'helplink' : 'button.html',
                'code' : '<a href="#" class="button">Button</a>',
                'sections' : addPrefixToSectionsAndFields({
                    'button' : {
                        name : 'Button options',
                        fields : {
                            'buttonsize' : {
                                'type' : 'select',
                                'name' : 'Size',
                                'show_empty' : true,
                                action: 'apply_class',
                                options: [
                                    {key: 'tiny', name: 'Tiny'},
                                    {key: 'small', name: 'Small'},
                                    {key: 'large', name: 'Large'}
                                ]
                            },
                            'fdbuttonarraow' : {
                                'type' : 'checkbox',
                                'name' : 'Arrow only',
                                'value' : 'arrow-only',
                                'action' : 'apply_class'
                            },
                            'buttontype' : {
                                'type' : 'select',
                                'name' : 'Color',
                                'show_empty' : true,
                                'toggle_buttons' : true,
                                action: 'apply_class',
                                options: foundationColors
                            },
                            'fddisabled' : {
                                'type' : 'checkbox',
                                'name' : 'Disabled',
                                'value' : 'disabled',
                                'action' : 'apply_class'
                            },
                            'fdexpand' : {
                                'type' : 'checkbox',
                                'name' : 'Expand',
                                'value' : 'expanded',
                                'action' : 'apply_class'
                            },
                            'fdhollow' : {
                                'type' : 'checkbox',
                                'name' : 'Hollow',
                                'value' : 'hollow',
                                'action' : 'apply_class'
                            },
                            'fdclear' : {
                                'type' : 'checkbox',
                                'name' : 'Clear',
                                'value' : 'clear',
                                'action' : 'apply_class'
                            },
                            'fddropdown' : {
                                'type' : 'checkbox',
                                'name' : 'Dropdown',
                                'value' : 'dropdown',
                                'action' : 'apply_class'
                            }
                        }
                    },
                    fdlink : linkOptionsSection
                })
            });
            f.addComponentType(def_link_button);
        // End link button

        // Button group
            var def_button_group = new PgComponentType(prefix + 'button-group', 'Button group', {
                'selector' : '.button-group',
                'priority' : 100,
                'helplink' : 'button-group.html',
                'code' : '<div class="button-group">\
                    <a class="button">One</a>\
                    <a class="button">Two</a>\
                    <a class="button">Three</a>\
                </div>',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'a-button']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdbuttongroup' : {
                        name : 'Button group options',
                        fields : {
                            'fdsize' : {
                                'type' : 'select',
                                'name' : 'Size',
                                'show_empty' : true,
                                action: 'apply_class',
                                options: [
                                    {key: 'tiny', name: 'Tiny'},
                                    {key: 'small', name: 'Small'},
                                    {key: 'large', name: 'Large'}
                                ]
                            },
                            'fdcolor' : {
                                'type' : 'select',
                                'name' : 'Color',
                                'show_empty' : true,
                                'toggle_buttons' : true,
                                'action' : 'apply_class',
                                'options' : foundationColors
                            },
                            'fdexpand' : {
                                'type' : 'checkbox',
                                'name' : 'Expand',
                                'value' : 'expanded',
                                'action' : 'apply_class'
                            },
                            'fdbuttonstacking' : {
                                'type' : 'select',
                                'name' : 'Stacking',
                                'action' : 'apply_class',
                                'options': [
                                    { key: 'stacked', name: 'All sizes' },
                                    { key: 'stacked-for-small', name: 'Small only' },
                                    { key: 'stacked-for-medium', name: 'Medium only' },
                                ]
                            },
                            'fdbuttonhollow': {
                                'type': 'checkbox',
                                'name': 'Hollow',
                                'value': 'hollow',
                                'action': 'apply_class',
                                show_if: function() {
                                    return current_fd_version == 6.6;
                                }
                            },
                            'fdbuttonclear': {
                                'type': 'checkbox',
                                'name': 'Clear',
                                'value': 'clear',
                                'action': 'apply_class',
                                show_if: function() {
                                    return current_fd_version == 6.6;
                                }
                            },
                            'fdbuttonnogaps': {
                                'type': 'checkbox',
                                'name': 'No gaps',
                                'value': 'no-gaps',
                                'action': 'apply_class',
                                show_if: function() {
                                    return current_fd_version == 6.6;
                                }
                            },
                        }
                    }
                })
            });
            f.addComponentType(def_button_group);
        // End button group

        // Split button
            var def_split_button = new PgComponentType(prefix + 'split-button', 'Split button', {
                'priority' : 99,
                'helplink' : 'button-group.html',
                'code' : '<div class="button-group">\
                    <a class="button">Primary Action</a>\
                    <a class="dropdown button arrow-only">\
                        <span class="show-for-sr">Show menu</span>\
                    </a>\
                </div>'
            });
            f.addComponentType(def_split_button);
        // End Split button

        // Close button
            var def_close_button = new PgComponentType(prefix + 'close-button', 'Close button', {
                'helplink' : 'close-button.html',
                'code' : '<button class="close-button" aria-label="Close alert" type="button">\
                    <span aria-hidden="true">&times;</span>\
                </button>'
            });
            f.addComponentType(def_close_button);
        // End close button

        // Button section
            var buttons_section = new PgFrameworkLibSection(prefix + 'buttons', 'Buttons');
            buttons_section.setComponentTypes([def_link_button, def_button_group, def_split_button, def_close_button]);
            f.addLibSection(buttons_section);
        // End button section


        // Heading
            var typeSectionArr = [];

            var hoptions = [
                {key: 'h1', name: 'Heading 1'},
                {key: 'h2', name: 'Heading 2'},
                {key: 'h3', name: 'Heading 3'},
                {key: 'h4', name: 'Heading 4'},
                {key: 'h5', name: 'Heading 5'},
                {key: 'h6', name: 'Heading 6'}
            ];

            // Headers
            var headings = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6'];
            $.each(headings, function(i, h) {
                var def_heading = new PgComponentType(prefix + h, h, {
                    'selector' : h,
                    'code' : '<' + h + '>Heading ' + (i+1) + '</' + h + '>',
                    'helplink' : 'typography-base.html',
                    action_menu: {
                        add: [prefix + 'secondary-text']
                    },
                    'sections' : addPrefixToSectionsAndFields({
                        'fdstyle' : {
                            name : 'Heading',
                            fields : {
                                fdtext : {
                                    'type' : 'text',
                                    'name' : 'Caption',
                                    'action' : 'custom',
                                    get_value: function (pgel) {
                                        var pgsmall = pgel.findOne('small');
                                        if (pgsmall) pgsmall.detach();

                                        var value = pgel.html();
                                        if (pgsmall) pgel.append(pgsmall);

                                        return value;
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        var pgsmall = pgel.findOne('small');
                                        if (pgsmall) pgsmall.detach();

                                        pgel.html(value);

                                        if (pgsmall) pgel.append(pgsmall);
                                        return value;
                                    }
                                },
                                fdlevel : {
                                    'type' : 'select',
                                    'name' : 'Level',
                                    'action' : 'custom',
                                    'show_empty' : false,
                                    options: hoptions,
                                    get_value: function (pgel) {
                                        for(var i = 0; i < hoptions.length; i++) {
                                            if(pgel.tagName == hoptions[i].key) {
                                                return hoptions[i].key;
                                            }
                                        }
                                        return null;
                                    },
                                    set_value: function (pgel, value, values, oldValue, eventType) {
                                        crsaWillChangeDom();
                                        // var pgp = pgel.parent;
                                        // var pgnewel = pgel.replaceTag(value);
                                        // $.fn.crsa('setNeedsUpdate', false, $p);
                                        // $.fn.crsa('setSelectElementOnUpdate', $(pgnewel.get(0).el));
                                        pgel.replaceTag(value);
                                        return value;
                                    }
                                },
                                fdsubheading : {
                                    'type' : 'checkbox',
                                    'name' : 'Subheader',
                                    'value' : 'subheader',
                                    'action' : 'apply_class'
                                }
                            }
                        }
                    })
                });
                f.addComponentType(def_heading);
                typeSectionArr.push(def_heading);
            });
        // End Heading

        // Secondary text
            var def_secondary_text = new PgComponentType(prefix + 'secondary-text', 'Secondary text', {
                'helplink' : 'typography-base.html',
                'selector_new' : function (pgel) {
                    return pgel.tagName == 'small' && pgel.parent && pgel.parent.isSelector('h1,h2,h3,h4,h5,h6');
                },
                'code' : '<small>Secondary text</small>',
                'preview' : '<h1>Title<small>Secondary text</small></h1>',
                priority : 100,
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle' : {
                        name : 'Secondary text options',
                        fields : {
                            content : {
                                'type' : 'text',
                                'name' : 'Caption',
                                'action' : 'element_html'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_secondary_text);
            typeSectionArr.push(def_secondary_text);
        // End small

        // Paragraph
            var def_paragraph = new PgComponentType(prefix + 'paragraph', 'Paragraph', {
                'type' : 'fd-p',
                'selector' : 'p',
                'helplink' : 'typography-base.html',
                'code' : '<p>Paragraph</p>',
                'name' : 'p',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_paragraph);
            typeSectionArr.push(def_paragraph);
        // End paragraph

        // Link
            var def_link = new PgComponentType(prefix + 'a', 'Link', {
                'selector' : 'a',
                'helplink' : 'typography-base.html',
                'code' : '<a href="#">Link</a>',
                'sections' : addPrefixToSectionsAndFields({
                    'fdlink' : linkOptionsSection
                })
            });
            f.addComponentType(def_link);
            typeSectionArr.push(def_link);
        // End link

        // List
            var def_list = new PgComponentType(prefix + 'list', 'List', {
                'type' : 'fd-list',
                tags: 'major',
                'selector' : 'ul,ol',
                'helplink' : 'menu.html',
                'code' : '<ul>\
                    <li>Lorem ipsum dolor sit amet</li>\
                    <li>Phasellus iaculis neque</li>\
                    <li>Purus sodales ultricies</li>\
                </ul>',
                action_menu: {
                    add: [prefix + 'list', prefix + 'list-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle' : {
                        name : 'List options',
                        fields : {
                            'fdordered' : {
                                'type' : 'checkbox',
                                'name' : 'Ordered',
                                'action' : 'custom',
                                'value' : '1',
                                get_value: function (pgel) {
                                    return pgel.tagName == "ol" ? "1" : null;
                                },
                                set_value: function (pgel, value, values) {
                                    crsaWillChangeDom();
                                    var tag = value == "1" ? 'ol' : 'ul';
                                    pgel = pgel.replaceTag(tag);

                                    // $.fn.crsa("setNeedsUpdate", false, obj.data);
                                    return value;
                                }
                            },
                            'fdstyle' : {
                                'type' : 'checkbox',
                                'name' : 'No bullet',
                                'action' : 'apply_class',
                                'value' : 'no-bullet'
                            },
                            'fdmenu' : {
                                'type' : 'checkbox',
                                'name' : 'Menu',
                                'action' : 'apply_class',
                                'value' : 'menu'
                            },
                            'fdexpand' : {
                                'type' : 'checkbox',
                                'name' : 'Expand',
                                'value' : 'expanded',
                                'action' : 'apply_class'
                            },
                            'fdsimple' : {
                                'type' : 'checkbox',
                                'name' : 'Simple',
                                'value' : 'simple',
                                'action' : 'apply_class'
                            },
                            'fdvertical' : {
                                'type' : 'checkbox',
                                'name' : 'Vertical',
                                'value' : 'vertical',
                                'action' : 'apply_class'
                            },
                            'fdnested' : {
                                'type' : 'checkbox',
                                'name' : 'Nested',
                                'value' : 'nested',
                                'action' : 'apply_class'
                            },
                            'fdsubmenu' : {
                                'type' : 'checkbox',
                                'name' : 'Sub-menu',
                                'value' : 'submenu',
                                'action' : 'apply_class'
                            }
                        }
                    },
                    reslist: {
                        name : "List responsive",
                        on_section_shown : onSectionWithDevicesControlsShown,
                        fields : {
                            reslistblock : {
                                type: 'custom',
                                name: 'vertical_horizontal',
                                action: 'none',
                                control: getDevicesControlFactory('vertical.horizontal', 'Alignment', function(size, size_token) {
                                    var base = size_token;

                                    field = {
                                        'type' : 'select',
                                        'name' : makeFieldLabelForSize('Alignment', size),
                                        'action' : 'apply_class',
                                        'show_empty' : true,
                                        'toggle_buttons' : true,
                                        'options' : [
                                            { 'key' : base + 'horizontal', 'name' : 'Horizontal' },
                                            { 'key' : base + 'vertical',   'name' : 'Vertical' }
                                        ]
                                    }

                                    return field;
                                })
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_list);
            typeSectionArr.push(def_list);

            // List item
            var def_list_item = new PgComponentType(prefix + 'list-item', 'List item', {
                'type' : 'fd-list-item',
                'selector' : 'li',
                'code' : '<li><a href="#">Link</a></li>',
                'name' : 'List item',
                'helplink' : 'menu.html',
                'sections' : addPrefixToSectionsAndFields({
                    fdstatus : {
                        name : "List item options",
                        fields : {
                            fdmenutext: {
                                type: 'checkbox',
                                name: 'Menu text',
                                action: 'apply_class',
                                value: 'menu-text'
                            },
                            fdactive: {
                                type: 'checkbox',
                                name: 'Active',
                                action: 'apply_class',
                                value: 'is-active'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_list_item);
            typeSectionArr.push(def_list_item);
        // End List

        // Description
            var def_description = new PgComponentType(prefix + 'description', 'Description list', {
                'selector' : 'dl',
                'helplink' : 'typography-base.html',
                'code' : '<dl>\
                    <dt>Description lists</dt>\
                    <dd>A description list is perfect for defining terms.</dd>\
                    <dt>Euismod</dt>\
                    <dd>Vestibulum id ligula porta felis euismod semper eget lacinia odio sem nec elit.</dd>\
                </dl>',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'description-term', prefix + 'description-def']
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_description);
            typeSectionArr.push(def_description);

            var def_description_term = new PgComponentType(prefix + 'description-term', 'Description term', {
                'selector' : 'dt',
                'parent_selector' : 'dl',
                'helplink' : 'typography-base.html',
                'code' : '<dt>Term</dt>',
                'sections' : addPrefixToSectionsAndFields({
                    'fdcontent' : {
                        name : 'Term options',
                        fields : {
                            content : {
                                'type' : 'text',
                                'name' : 'Text',
                                'action' : 'element_html'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_description_term);
            typeSectionArr.push(def_description_term);

            var def_description_def = new PgComponentType(prefix + 'description-def', 'Description definition', {
                'selector' : 'dd',
                'parent_selector' : 'dl',
                'helplink' : 'typography-base.html',
                'code' : '<dd>Term definition.</dd>',
                'sections' : addPrefixToSectionsAndFields({
                    'fdcontent' : {
                        name : 'Definition options',
                        fields : {
                            content : {
                                'type' : 'text',
                                'name' : 'Text',
                                'action' : 'element_html'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_description_def);
            typeSectionArr.push(def_description_def);
        // End Description

        // Blockquote
            // Blockquote set_value
            var blockQuoteCitationSetValue = function (pgel, value, values, oldValue) {
                var source = values.source;
                var pgsmall = pgel.findOne('cite');
                if (!value || value.length == 0) {
                    crsaWillChangeDom();
                    if (pgsmall) pgsmall.remove();
                } else {
                    if (!pgsmall) {
                        crsaWillChangeDom();
                        pgsmall = pgCreateNodeFromHtml('<cite></cite>');
                        pgel.append(pgsmall);
                    }
                    pgsmall.html(value);
                }
                return value;
            };

            // Blockquote
            var def_blockquote = new PgComponentType(prefix + 'blockquote', 'Blockquote', {
                'selector' : 'blockquote',
                'tags' : 'major',
                'helplink' : 'typography-base.html',
                'code' : '<blockquote>\
                        Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.\
                    <cite>Source Title</cite>\
                </blockquote>',
                action_menu: {
                    add: [prefix + 'blockquote-item', prefix + 'blockquote-cite-block']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name: "Blockquote options",
                        fields: {
                            citation: {
                                type: 'text',
                                name: 'Citation',
                                action: 'custom',
                                live_update: true,
                                get_value: function (pgel) {
                                    var pgsmall = pgel.findOne('cite');
                                    if (pgsmall) return null;

                                    return pgsmall.html();
                                },
                                set_value: blockQuoteCitationSetValue
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_blockquote);
            typeSectionArr.push(def_blockquote);

            var def_blockquote_item = new PgComponentType(prefix + 'blockquote-item', 'Blockquote item', {
                'helplink' : 'typography-base.html',
                'code' : '<cite>Source Title</cite>',
                'name' : 'Cite',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_blockquote_item);

            var def_blockquote_cite_block = new PgComponentType(prefix + 'blockquote-cite-block', 'Blockquote cite block', {
                'helplink' : 'typography-base.html',
                'code' : '<span class="cite-block">Source Title</span>',
                'name' : 'Cite block',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_blockquote_cite_block);
        // End Blockquote

        // Span label
            var def_span_label = new PgComponentType(prefix + 'span-label', 'Span label', {
                'selector' : '.label',
                'helplink' : 'label.html',
                'code' : '<span class="label">Regular Label</span>',
                'priority' : 100,
                'sections' : addPrefixToSectionsAndFields({
                    'fdcontent' : {
                        name : 'Label options',
                        fields : {
                            content : {
                                'type' : 'text',
                                'name' : 'Text',
                                'action' : 'element_html'
                            },
                            'fdcolor' : {
                                'type' : 'select',
                                'name' : 'Color',
                                'toggle_buttons' : true,
                                'show_empty' : true,
                                action: 'apply_class',
                                options: foundationColors
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_span_label);
            typeSectionArr.push(def_span_label);
        // End Span label


        // Code
            var def_code = new PgComponentType(prefix + 'code', 'Code', {
                'selector': 'code,.code-inline,.code-block',
                'code': '<span class="code-inline">Code</span>',
                'sections': addPrefixToSectionsAndFields({
                    'fdcode': {
                        name: "Code options",
                        fields: {
                            'fdcodedisplay': {
                                type: 'select',
                                name: 'Display',
                                action: 'apply_class',
                                options: [
                                    { key: 'code-inline', name: 'Inline' },
                                    { key: 'code-block', name: 'Block' },
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_code);
            typeSectionArr.push(def_code);
        // End Code

        // Type section
            var type_section = new PgFrameworkLibSection(prefix + 'type', 'Type');
            type_section.setComponentTypes(typeSectionArr);
            f.addLibSection(type_section);
        // End type section


        // Reveal modal
            // Reveal modal helpers
            var removeDisplayStyle = function(pgm) {
                var s = pgm.getAttr('style');
                if (s) {
                    s = s.replace(/display\:\s*[a-z]*;/i,'');
                    s = s.replace(/visibility\:\s*[a-z]*;/i,'');
                    s = s.replace(/opacity\:\s*[a-z0-9\.]*;/i,'');
                    s = s.replace(/top\:\s*[a-z0-9\.\-]*;/i,'');
                    s = $.trim(s);
                    if (s.length > 0) {
                        pgm.setAttr('style', s);
                    } else {
                        pgm.removeAttr('style');
                    }
                }
            }

            // Reveal modal
            var def_reveal_modal = new PgComponentType(prefix + 'reveal-modal', 'Reveal modal', {
                'selector' : '.reveal',
                'helplink' : 'reveal.html',
                'code' : function() {
                    var id = getUniqueId('modal');
                    return '<button value="Button" class="button" data-open="' + id + '">Open modal</button>';
                },
                tags: 'major',
                on_inserted : function(pgel) {
                    var id = pgel.getAttr('data-open');
                    var modal = pgCreateNodeFromHtml('<div class="reveal" id="' + id + '" data-reveal>\
                      <h1>Awesome. I Have It.</h1>\
                      <p class="lead">Your couch. It is mine.</p>\
                      <p>I\'m a cool paragraph that lives inside of an even cooler modal. Wins!</p>\
                      <button class="close-button" data-close aria-label="Close reveal" type="button">\
                        <span aria-hidden="true">&times;</span>\
                      </button>\
                    </div>');

                    modal.insertAfter(pgel);
                    // pinegrow.updateTree($el.parent());
                    showOrbitMessage();
                },
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                    'fdcontent' : {
                        name : 'Reveal modal options',
                        fields : {
                            'modalsize' : {
                                'type' : 'select',
                                'name' : 'Size',
                                'show_empty' : true,
                                action: 'apply_class',
                                options: [
                                    {key: 'tiny', name: 'Tiny'},
                                    {key: 'small', name: 'Small'},
                                    {key: 'large', name: 'Large'},
                                    {key: 'full', name: 'Full'}
                                ]
                            },
                            'modaloverlay' : {
                                'type' : 'checkbox',
                                'name' : 'Hide overlay',
                                'value' : 'false',
                                'negvalue' : 'true',
                                'action' : 'element_attribute',
                                'attribute' : 'data-overlay'
                            },
                            'modalanimationin': {
                                'type' : 'text',
                                'name' : 'Aimation in',
                                'action' : 'element_attribute',
                                'attribute' : 'data-animation-in'
                            },
                            'modalanimationout': {
                                'type' : 'text',
                                'name' : 'Aimation out',
                                'action' : 'element_attribute',
                                'attribute' : 'data-animation-out'
                            },
                            'modaleditshow' : {
                                'type' : 'checkbox',
                                'name' : 'Show during editing',
                                'value' : 'pg-show-modal',
                                'action' : 'custom',
                                get_value: function (pgel) {
                                    var $el = pgel.get$DOMElement();
                                    var $pel = $el.parent();

                                    if ($pel.hasClass('reveal-overlay')) $el = $pel;

                                    return $el.hasClass('pg-show-modal') ? 'pg-show-modal' : null;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    var $el = pgel.get$DOMElement();
                                    var $pel = $el.parent();

                                    if ($pel.hasClass('reveal-overlay')) $el = $pel;

                                    if (value) {
                                        $el.addClass(value);
                                    } else {
                                        $el.removeClass('pg-show-modal');
                                    }

                                    removeDisplayStyle(pgel);
                                    return value;
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_reveal_modal);
        // End Reveal modal

        // Callout
            var def_callout = new PgComponentType(prefix + 'callout', 'Callout', {
                'selector' : '.callout',
                'helplink' : 'callout.html',
                'code' : '<div class="callout">\
                    <h5>This is a callout.</h5>\
                    <p>It has an easy to override visual style, and is appropriately subdued.</p>\
                    <a href="#">It\'s dangerous to go alone, take this.</a>\
                </div>',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle': {
                        'name' : 'Callout options',
                        'fields' : {
                            'calloutcolor' : {
                                'type' : 'select',
                                'action' : 'apply_class',
                                'name' : 'Color',
                                'show_empty' : true,
                                'toggle_buttons' : true,
                                'options' : foundationColors
                            },
                            'calloutsize' : {
                                'type' : 'select',
                                'action' : 'apply_class',
                                'name' : 'Size',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'small', name: 'Small' },
                                    { key: 'large', name: 'Large' }
                                ]
                            },
                            'fdcalloutcloseable' : {
                                'type' : 'checkbox',
                                'action' : 'custom',
                                'value' : '1',
                                'name' : 'Closeable',
                                get_value : function (pgel) {
                                    return pgel.getAttr('data-closable') ? '1' : null;
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    if (value == 1) {
                                        pgel.setAttr('data-closable', 'true');
                                        var pgbutton = pgel.findOne('>.close-button');
                                        if (!pgbutton) {
                                            pgbutton = pgCreateNodeFromHtml('<button class="close-button" aria-label="Dismiss alert" type="button"><span aria-hidden="true">&times;</span></button>')
                                            pgel.append(pgbutton);
                                        }
                                    }
                                    else {
                                        pgel.removeAttr('data-closable');
                                        var pgbutton = pgel.findOne('>.close-button');
                                        if (pgbutton) pgbutton.remove();
                                    }

                                    return value;
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_callout);
        // End Callout

        // Card
            var def_card_image = new PgComponentType(prefix + 'card-image', 'Card section', {
                'selector' : '.card-section',
                'helplink' : 'card.html',
                'code' : function () {
                    var img = pinegrow.getPlaceholderImage();

                    return '<div class="card-image">\
                        <img src="' + img + '">\
                    </div>'
                },
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_card_image);

            var def_card_section = new PgComponentType(prefix + 'card-section', 'Card section', {
                'selector' : '.card-section',
                'helplink' : 'card.html',
                'code' : '<div class="card-section">\
                    <h4>This is a card.</h4>\
                    <p>It has an easy to override visual style, and is appropriately subdued.</p>\
                </div>',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_card_section);

            var def_card_divider = new PgComponentType(prefix + 'card-divider', 'Card divider', {
                'selector' : '.card-divider',
                'helplink' : 'card.html',
                'code' : '<div class="card-divider">\
                    Styled Card\
                </div>',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_card_divider);

            var def_card = new PgComponentType(prefix + 'card', 'Card', {
                'selector' : '.card',
                'helplink' : 'card.html',
                'code' : function () {
                    var img = pinegrow.getPlaceholderImage();

                    return '<div class="card">\
                        <img src="' + img + '">\
                        <div class="card-divider">\
                            Styled Card\
                        </div>\
                        <div class="card-section">\
                            <h4>This is a card.</h4>\
                            <p>It has an easy to override visual style, and is appropriately subdued.</p>\
                        </div>\
                    </div>'
                },
                priority: 100,
                action_menu: {
                    add: ['img', prefix + 'card-image', prefix + 'card-divider', prefix + 'card-section'],
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_card);
        // End card

        // Callouts section
            var callouts_section = new PgFrameworkLibSection(prefix + 'callouts', 'Callouts &amp; Prompts');
            callouts_section.setComponentTypes([def_reveal_modal, def_callout, def_card]);
            f.addLibSection(callouts_section);
        // End callouts section


        // Dropdown button
            // Dropdown helpers
            var getDropdownPanelForButton = function (pgel) {
                var id = pgel.getAttr('data-toggle');
                return pgel.closest('body').findOne('#' + id);
            }

            // Dropdown button
            var def_dropdown_button = new PgComponentType(prefix + 'dropdown-button', 'Dropdown button', {
                'priority': 99,
                'helplink' : 'dropdown.html',
                'code' : function() {
                    var id = getUniqueId('drop');
                    return '<button class="button" type="button" data-toggle="' + id + '">Toggle Dropdown</button>';
                },
                'tags' : 'major',
                action_menu: {
                    add: [prefix + 'dropdown-panel'],
                    on_add : function(pgel, pgnew, newdef, prepend) {
                        var id = pgel.getAttr('data-toggle');
                        if (id) {
                            pgnew.setAttr('id', id);
                            pgnew.insertAfter(pgel);
                            showOrbitMessage();
                        }
                        crsaQuickMessage("Dropdown content not found!");
                    }
                },
                on_inserted : function(pgel) {
                    var id = pgel.getAttr('data-toggle');
                    var c = '<div class="dropdown-pane" id="' + id + '" data-dropdown>\
                        Just some junk that needs to be said. Or not. Your choice.\
                    </div>';
                    var pgbr = pgCreateNodeFromHtml('<br/>').insertAfter(pgel);
                    var pgc = pgCreateNodeFromHtml(c).insertAfter(pgbr);
                    showOrbitMessage();
                    // setTimeout(function() {
                    //     $.fn.crsa("setNeedsUpdate", true, $el.parent());
                    // }, 500);
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_dropdown_button);

            // Dropdown panel
            var def_dropdown_pane = new PgComponentType(prefix + 'dropdown-panel', 'Dropdown panel', {
                'selector' : '.dropdown-pane[data-dropdown]',
                'priority' : 99,
                'helplink' : 'dropdown.html',
                'code' : function() {
                    var id = getUniqueId('drop');
                    return '<div class="dropdown-pane" id="' + id + '" data-dropdown>\
                        Just some junk that needs to be said. Or not. Your choice.\
                    </div>';
                },
                tags: 'major',
                'sections' : addPrefixToSectionsAndFields({
                    'fdbutton': {
                        'name': 'Dropdown options',
                        'fields' : {
                            'fdhover' : {
                                'type' : 'checkbox',
                                'name' : 'Show on hover',
                                'value' : 'true',
                                'negvalue' : 'false',
                                'action' : 'element_attribute',
                                'attribute' : 'data-hover'
                            },
                            'dppanelalign' : {
                                'type' : 'select',
                                'name' : 'Align',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'top', 'name' : 'Top'},
                                    { 'key' : 'right', 'name' : 'Right'},
                                    { 'key' : 'left', 'name' : 'Left'},
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_dropdown_pane);

            var def_dropdown_pane_action = new PgComponentType(prefix + 'dropdown-panel-action', 'Dropdown panel', {
                'selector': ".dropdown-pane[data-dropdown]",
                'attribute': 'data-dropdown',
                'helplink': 'dropdown.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.dropdownpane.parameters' : {
                        'name' : 'Options',
                        'fields' : getStandardPluginAction({
                            'fd.dropdownpane.hover': {
                                'type' : 'checkbox',
                                'name' : 'Show on hover',
                                'action' : 'element_attribute',
                                'attribute' : 'data-hover',
                                'value' : 'true'
                            },
                            'fd.dropdownpane.hover.pane': {
                                'type' : 'checkbox',
                                'name' : 'Hover on pane',
                                'action' : 'element_attribute',
                                'attribute' : 'data-hover-pane',
                                'value' : 'true'
                            },
                            'fd.dropdownpane.id': {
                                'type' : 'text',
                                'name' : 'Panel id',
                                'action' : 'element_attribute',
                                'attribute' : 'id'
                            },
                            'fd.dropdownpane.position': {
                                'type' : 'select',
                                'name' : 'Align',
                                'action' : 'element_attribute',
                                'attribute' : 'data-position',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'auto', 'name' : 'Auto'},
                                    { 'key' : 'top', 'name' : 'Top'},
                                    { 'key' : 'bottom', 'name' : 'Bottom'},
                                    { 'key' : 'right', 'name' : 'Right'},
                                    { 'key' : 'left', 'name' : 'Left'}
                                ]
                            },
                            'fd.dropdownpane.align': {
                                'type' : 'select',
                                'name' : 'Align',
                                'action' : 'element_attribute',
                                'attribute' : 'data-alignment',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'auto', 'name' : 'Auto'},
                                    { 'key' : 'center', 'name' : 'Center'},
                                    { 'key' : 'top', 'name' : 'Top'},
                                    { 'key' : 'bottom', 'name' : 'Bottom'},
                                    { 'key' : 'right', 'name' : 'Right'},
                                    { 'key' : 'left', 'name' : 'Left'}
                                ]
                            },
                            'fd.dropdownpane.alignment': {
                                type: 'select',
                                name: 'Alignment',
                                action: 'element_attribute',
                                attribute: 'data-alignment',
                                show_empty: true,
                                options: [
                                    { key: 'left', name: 'Left' },
                                    { key: 'right', name: 'Right' },
                                    { key: 'Center', name: 'Center' }
                                ]
                            },
                            'fd.dropdownpane.position': {
                                type: 'select',
                                name: 'Position',
                                action: 'element_attribute',
                                attribute: 'data-position',
                                show_empty: true,
                                options: [
                                    { key: 'top', name: 'Top' },
                                    { key: 'left', name: 'Left' },
                                    { key: 'right', name: 'Right' },
                                    { key: 'bottom', name: 'Bottom' }
                                ]
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_dropdown_pane_action);
            actions.push(def_dropdown_pane_action);
        // End dropdown button

        // Dropdown list
            // Dropdown list item
            var def_dropdown_list_item = new PgComponentType(prefix + 'dropdown-list-item', 'Dropdown list item', {
                'selector' : '.is-dropdown-submenu-item',
                'helplink' : 'dropdown-menu.html',
                'code' : '<li class="is-submenu-item is-dropdown-submenu-item">\
                    <a href="#">This is a link</a>\
                </li>',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_dropdown_list_item);

            // Dropdown list (list)
            var def_dropdown_list_submenu = new PgComponentType(prefix + 'dropdown-submenu', 'Dropdown submenu', {
                'helplink' : 'dropdown-menu.html',
                'selector' : '.is-dropdown-submenu',
                'code' : '<ul class="menu vertical submenu is-dropdown-submenu">\
                    <li class="is-submenu-item is-dropdown-submenu-item">\
                        <a href="#">This is a link</a>\
                    </li>\
                    <li class="is-submenu-item is-dropdown-submenu-item">\
                        <a href="#">This is another</a>\
                    </li>\
                    <li class="is-submenu-item is-dropdown-submenu-item">\
                        <a href="#">Yet another</a>\
                    </li>\
                </ul>',
                'priority' : 100,
                'action_menu' : {
                    add: [prefix + 'dropdown-list-item']
                },
                'tags' : 'major',
                on_inserted: function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_dropdown_list_submenu);

            // Dropdown list (list)
            var def_submenu_parent = new PgComponentType(prefix + 'dropdown-list', 'Dropdown list', {
                'helplink' : 'dropdown-menu.html',
                'selector' : '.is-dropdown-submenu-parent',
                'code' : '<li class="is-dropdown-submenu-parent">\
                    <a href="#">Dropdown link</a>\
                    <ul class="menu vertical submenu is-dropdown-submenu">\
                        <li class="is-submenu-item is-dropdown-submenu-item">\
                            <a href="#">This is a link</a>\
                        </li>\
                        <li class="is-submenu-item is-dropdown-submenu-item">\
                            <a href="#">This is another</a>\
                        </li>\
                        <li class="is-submenu-item is-dropdown-submenu-item">\
                            <a href="#">Yet another</a>\
                        </li>\
                    </ul>\
                </li>',
                'priority' : 100,
                'action_menu' : {
                    add: [prefix + 'dropdown-submenu']
                },
                'tags' : 'major',
                on_inserted: function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_submenu_parent);

            // Dropdown list
            var def_dropdown_menu = new PgComponentType(prefix + 'dropdown-menu', 'Dropdown menu', {
                'selector' : '.dropdown[data-dropdown-menu]',
                'helplink' : 'dropdown-menu.html',
                'code' : '<ul class="dropdown menu" data-dropdown-menu>\
                    <li>\
                        <a>Item 1</a>\
                        <ul class="menu">\
                            <li><a href="#">Item 1A Loooong</a></li>\
                            <li>\
                                <a href="#"> Item 1 sub</a>\
                                <ul class="menu">\
                                    <li><a href="#">Item 1 subA</a></li>\
                                    <li><a href="#">Item 1 subB</a></li>\
                                    <li>\
                                        <a href="#"> Item 1 sub</a>\
                                        <ul class="menu">\
                                            <li><a href="#">Item 1 subA</a></li>\
                                            <li><a href="#">Item 1 subB</a></li>\
                                        </ul>\
                                    </li>\
                                    <li>\
                                        <a href="#"> Item 1 sub</a>\
                                        <ul class="menu">\
                                            <li><a href="#">Item 1 subA</a></li>\
                                        </ul>\
                                   </li>\
                                </ul>\
                            </li>\
                            <li><a href="#">Item 1B</a></li>\
                        </ul>\
                    </li>\
                </ul>',
                'priority': 101,
                on_inserted: function () {
                    showOrbitMessage();
                },
                'action_menu' : {
                    add: [prefix + 'dropdown-list']
                },
                'tags' : 'major',
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_dropdown_menu);

            var def_dropdown_menu_action = new PgComponentType(prefix + 'dropdown-menu-action', 'Dropdown menu', {
                'selector': ".dropdown[data-dropdown-menu]",
                'attribute': 'data-dropdown-menu',
                'helplink': 'dropdown.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.dropdown-menu.parameters' : {
                        'name' : 'Options',
                        'fields' : getStandardPluginAction({
                            'fd.dropdown-menu.text' : {
                                'type' : 'text',
                                'name' : 'Name',
                                'attribute' : 'data-dropdown-menu',
                                'action' : 'element_attribute',
                                'placeholder' : 'Dropdown menu',
                                'attribute_keep_if_empty' : true
                            },
                            'fd.dropdown-menu.expanded' : {
                                'type' : 'checkbox',
                                'name' : 'Expand',
                                'value' : 'expanded',
                                'action' : 'apply_class'
                            },
                            'fd.dropdown-menu.align-right' : {
                                'type' : 'checkbox',
                                'name' : 'Right alignment',
                                'value' : 'align-right',
                                'action' : 'apply_class'
                            },
                            'fd.dropdown-menu.vertical' : {
                                'type' : 'checkbox',
                                'name' : 'Vertical',
                                'value' : 'vertical',
                                'action' : 'apply_class'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_dropdown_menu_action);
            actions.push(def_dropdown_menu_action);
        // End dropdown list

        // Accordion menu
            var def_accordion_menu = new PgComponentType(prefix + 'accordion-menu', 'Accordion menu', {
                'selector': '.accordion-menu[data-accordion-menu]',
                'helplink': 'accordion-menu.html',
                'code': '<ul class="vertical menu accordion-menu" data-accordion-menu>\
                    <li>\
                        <a href="#">Item 1</a>\
                        <ul class="menu vertical nested">\
                        <li><a href="#">Item 1A</a></li>\
                        <li><a href="#">Item 1B</a></li>\
                        </ul>\
                    </li>\
                    <li><a href="#">Item 2</a></li>\
                </ul>',
                'priority': 101,
                on_inserted: function () {
                    showOrbitMessage();
                },
                'tags': 'major',
                'sections': addPrefixToSectionsAndFields({
                    'fd.accordion.menu': {
                        'name': 'Accordion_menu',
                        'fields': {
                            'fd.accordion.menu.submenutoggle': {
                                type: 'checkbox',
                                name: 'Submenu toggle',
                                action: 'element_attribute',
                                attribute: 'data-submenu-toggle',
                                show_empty: true,
                                value: 'true'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_accordion_menu);
        // End Accordion menu

        // Magellan
            // Magellan item
            var def_magellan_item = new PgComponentType(prefix + 'magellan-item', 'Magellan list item', {
                'helplink' : 'magellan.html',
                selector_new : function (pgel) {
                    return pgel.tagName == 'li' && pgel.closest('ul[data-magellan]');
                },
                code: '<li><a href="#destination">Destination</a></li>',
                priority: 99,
                sections : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_magellan_item);

            // Magellan
            var def_magellan = new PgComponentType(prefix + 'magellan', 'Magellan list', {
                selector : '[data-magellan]',
                'helplink' : 'magellan.html',
                code: '<ul class="horizontal menu" data-magellan>\
                    <li><a href="#first">First Arrival</a></li>\
                    <li><a href="#second">Second Arrival</a></li>\
                    <li><a href="#third">Third Arrival</a></li>\
                </ul>',
                priority: 101,
                on_inserted: function () {
                    showOrbitMessage();
                },
                action_menu: {
                    add: [prefix + 'magellan-item']
                },
                tags: 'major',
                sections : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_magellan);
        // End Magellan

        // Drilldown
            var def_drilldown = new PgComponentType(prefix + 'drilldown', 'Drilldown', {
                selector : '[data-drilldown]',
                helplink : 'drilldown-menu.html',
                code: '<ul class="vertical menu drilldown" data-drilldown>\
                    <li>\
                        <a>Item 1</a>\
                        <ul class="vertical menu">\
                            <li><a href="#">Item 1A</a></li>\
                            <li><a href="#">Item 1B</a></li>\
                            <li><a href="#">Item 1C</a></li>\
                        </ul>\
                    </li>\
                    <li>\
                        <a>Item 2</a>\
                        <ul class="vertical menu">\
                            <li><a href="#">Item 2A</a></li>\
                            <li><a href="#">Item 2B</a></li>\
                            <li><a href="#">Item 2C</a></li>\
                        </ul>\
                    </li>\
                    <li>\
                        <a>Item 3</a>\
                        <ul class="vertical menu">\
                            <li><a href="#">Item 3A</a></li>\
                            <li><a href="#">Item 3B</a></li>\
                            <li><a href="#">Item 3C</a></li>\
                        </ul>\
                    </li>\
                    <li>\
                        <a>Item 4</a>\
                        <ul class="vertical menu">\
                            <li><a href="#">Item 4A</a></li>\
                            <li><a href="#">Item 4B</a></li>\
                            <li><a href="#">Item 4C</a></li>\
                        </ul>\
                    </li>\
                </ul>',
                priority: 101,
                on_inserted: function () {
                    showOrbitMessage();
                },
                tags: 'major',
                sections : addPrefixToSectionsAndFields({
                    'fd.drilldown': {
                        name: 'Drilldown',
                        fields: {
                            'fd.drilldown.autoHeight' : {
                                type: 'checkbox',
                                name: 'Auto height',
                                action: 'element_attribute',
                                attribute: 'data-auto-height',
                                show_empty: true,
                                value: 'true'
                            },
                            'fd.drilldown.animateHeight' : {
                                type: 'checkbox',
                                name: 'Animate height',
                                action: 'element_attribute',
                                attribute: 'data-animate-height',
                                show_empty: true,
                                value: 'true',
                            },
                            'fd.drilldown.scrollTop' : {
                                type: 'checkbox',
                                name: 'Scroll top',
                                action: 'element_attribute',
                                attribute: 'data-scroll-top',
                                show_empty: true,
                                value: 'true',
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_drilldown);

            var def_drilldown_action = new PgComponentType(prefix + 'drilldown-action', 'Drilldown', {
                'selector': "[data-drilldown]",
                'attribute': 'data-drilldown',
                'helplink': 'drilldown-menu.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fd.drilldown.parameters' : {
                        name : 'Options',
                        fields : getStandardPluginAction({
                            'fd.drilldown.expanded' : {
                                'type' : 'checkbox',
                                'name' : 'Expand',
                                'value' : 'expanded',
                                'action' : 'apply_class'
                            },
                            'fd.drilldown.vertical' : {
                                'type' : 'checkbox',
                                'name' : 'Vertical',
                                'value' : 'vertical',
                                'action' : 'apply_class'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_drilldown_action);
            actions.push(def_drilldown_action);
        // End Drilldown

        // Media object
            // Media object section
            var mediaObjSectionFields = {
                'name' : 'Media object section options',
                'fields' : {
                    'mediaObjMain': {
                        'type' : 'checkbox',
                        'name' : 'Main section',
                        'action' : 'apply_class',
                        'value': 'main-section'
                    },
                    'mediaObjAlign': {
                        'type' : 'select',
                        'name' : 'Align',
                        'action' : 'apply_class',
                        'show_empty' : true,
                        'options' : [
                            { 'key' : 'middle', 'name' : 'Middle' },
                            { 'key' : 'bottom', 'name' : 'Bottom' }
                        ]
                    },
                    'mediaObjSelfAlign': {
                        'type' : 'select',
                        'name' : 'Align self',
                        'action' : 'apply_class',
                        'show_empty' : true,
                        'options' : [
                            { 'key' : 'align-self-middle', 'name' : 'Middle' },
                            { 'key' : 'align-self-bottom', 'name' : 'Bottom' }
                        ]
                    }
                }
            }

            var def_media_object_section = new PgComponentType(prefix + 'media-object-section', 'Media object section', {
                'selector': '.media-object-section',
                'priority': 99,
                'helplink' : 'media-object.html',
                action_menu: {
                    add: [prefix + 'media-object']
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.media.section': mediaObjSectionFields
                })
            });
            f.addComponentType(def_media_object_section);

            // Media object content
            var def_media_object_section_content = new PgComponentType(prefix + 'media-object-section-content', 'Media object section content', {
                'priority': 99,
                'helplink' : 'media-object.html',
                'code' : '<div class="media-object-section">\
                    <h4>Dreams feel real while we\'re in them.</h4>\
                    <p>I\'m going to improvise. Listen, there\'s something you should know about me... about inception. An idea is like a virus, resilient, highly contagious. The smallest seed of an idea can grow. It can grow to define or destroy you.</p>\
                </div>',
                'sections' : addPrefixToSectionsAndFields({
                    'fd.media.content' : mediaObjSectionFields
                })
            });
            f.addComponentType(def_media_object_section_content);

            // Media object image
            var def_media_object_section_image = new PgComponentType(prefix + 'media-object-section-image', 'Media object section image', {
                'priority' : 99,
                'helplink' : 'media-object.html',
                'code' : '<div class="media-object-section">\
                    <div class="thumbnail">\
                        <img src= "' + getPlaceholderImage() + '" width="200">\
                    </div>\
                </div>'
            });
            f.addComponentType(def_media_object_section_image);

            // Media object
            var def_media_object = new PgComponentType(prefix + 'media-object', 'Media object', {
                'selector' : '.media-object',
                'priority' : 100,
                'helplink' : 'media-object.html',
                'code' : '<div class="media-object">\
                    <div class="media-object-section">\
                        <div class="thumbnail">\
                            <img src= "' + getPlaceholderImage() + '" width="200">\
                        </div>\
                    </div>\
                    <div class="media-object-section">\
                        <h4>Dreams feel real while we\'re in them.</h4>\
                        <p>I\'m going to improvise. Listen, there\'s something you should know about me... about inception. An idea is like a virus, resilient, highly contagious. The smallest seed of an idea can grow. It can grow to define or destroy you.</p>\
                    </div>\
                </div>',
                tags: 'major',
                action_menu: {
                    add: [prefix + 'media-object-section-content', prefix + 'media-object-section-image']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle' : {
                        'name' : 'Media object options',
                        'fields' : {
                            'fdstack': {
                                'type' : 'checkbox',
                                'name' : 'Stack for small',
                                'action' : 'apply_class',
                                'value' : 'stack-for-small'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_media_object);
        // End Media object

        // Progress bar
            var def_progress_bar_meter_text = new PgComponentType(prefix + 'progress-meter-text', 'Progress meter text', {
                'selector' : '.progress-meter-text',
                'helplink' : 'progress-bar.html',
                'code' : '<p class="progress-meter-text">50%</p>',
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_progress_bar_meter_text);

            var def_progress_bar_meter = new PgComponentType(prefix + 'progress-meter', 'Progress meter', {
                'selector' : '.progress-meter',
                'helplink' : 'progress-bar.html',
                'code' : '<div class="progress-meter" style="width: 50%"></div>',
                action_menu: {
                    add: [prefix + 'progress-meter-text']
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_progress_bar_meter);

            var def_progress_bar = new PgComponentType(prefix + 'progress-bar', 'Progress bar', {
                'selector' : 'div.progress',
                'helplink' : 'progress-bar.html',
                'code' : '<div class="progress" role="progressbar" tabindex="0" aria-valuenow="50" aria-valuemin="0" aria-valuetext="50 percent" aria-valuemax="100">\
                  <div class="progress-meter" style="width: 50%"></div>\
                </div>',
                action_menu: {
                    add: [prefix + 'progress-meter']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdstyle' : {
                        name : 'Progress bar options',
                        fields : {
                            'fdtext' : {
                                'type' : 'text',
                                'name' : 'Meter text',
                                'action': 'custom',
                                get_value : function (pgel) {
                                    var pgmeterText = pgel.findOne('.progress-meter-text');

                                    if (!pgmeterText) return null;
                                    else              return pgmeterText.html();
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    if (value == oldValue) return value;

                                    var pgmeter = pgel.findOne('> .progress-meter');
                                    var pgmeterText = pgmeter.findOne('> .progress-meter-text');

                                    if (!pgmeterText && value) {
                                        if (!pgmeter) {
                                            pgmeter = pgCreateNodeFromHtml('<span class="progress-meter"></span>');
                                            pgel.append(pgmeter);
                                        }
                                        pgmeterText = pgCreateNodeFromHtml('<p class="progress-meter-text">text</p>');
                                        pgmeter.append(pgmeterText);

                                        // $.fn.crsa('setNeedsUpdate', false, $el);
                                    }

                                    if (value) {
                                        pgmeterText.html(value);
                                    }
                                    else {
                                        pgmeterText.remove();
                                    }

                                    return value;
                                }
                            },
                            'fdminvalue' : {
                                'type' : 'text',
                                'name' : 'Min',
                                'action': 'element_attribute',
                                'attribute' : 'aria-valuemin'
                            },
                            'fdmaxvalue' : {
                                'type' : 'text',
                                'name' : 'Max',
                                'action': 'element_attribute',
                                'attribute' : 'aria-valuemax'
                            },
                            'fdvaluenow' : {
                                'type' : 'text',
                                'name' : 'Current',
                                'action' : 'custom',
                                get_value : function (pgel) {
                                    return pgel.getAttr('aria-valuenow');
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pgmeter = pgel.findOne('>.progress-meter');

                                    pgel.setAttr('aria-valuenow', value);
                                    pgmeter.setAttr('style', 'width:' + value + '%');
                                    return value;
                                }
                            },
                            'fdcolor' : {
                                'type' : 'select',
                                'name' : 'Color',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'toggle_buttons' : true,
                                'options' : foundationColors
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_progress_bar);

            var def_progress_tag = new PgComponentType(prefix + 'progress-bar-tag', 'Progress bar', {
                'selector' : 'progress',
                'helplink' : 'progress-bar.html',
                'code' : '<progress max="100" value="75"></progress>',
                'sections' : addPrefixToSectionsAndFields({
                    'pbstyle' : {
                        name : 'Progress bar options',
                        fields : {
                            'pbmax' : {
                                'type' : 'text',
                                'name' : 'Max',
                                'action' : 'element_attribute',
                                'attribute' : 'max'
                            },
                            'pbvalue' : {
                                'type' : 'text',
                                'name' : 'Value',
                                'action' : 'element_attribute',
                                'attribute' : 'value'
                            },
                            'pbcolor' : {
                                'type' : 'select',
                                'name' : 'Color',
                                'action' : 'apply_class',
                                'show_empty' : true,
                                'toggle_buttons' : true,
                                'options' : foundationColors
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_progress_tag);

            var def_meter_tag = new PgComponentType(prefix + 'progress-bar-tag', 'Progress bar', {
                'selector' : 'progress',
                'helplink' : 'progress-bar.html',
                'code' : '<meter value="30" min="0" low="33" high="66" optimum="100" max="100"></meter>',
                'sections' : addPrefixToSectionsAndFields({
                    'pbstyle' : {
                        name : 'Progress bar options',
                        fields : {
                            'pbmin' : {
                                'type' : 'text',
                                'name' : 'Min',
                                'action' : 'element_attribute',
                                'attribute' : 'min'
                            },
                            'pbmax' : {
                                'type' : 'text',
                                'name' : 'Max',
                                'action' : 'element_attribute',
                                'attribute' : 'max'
                            },
                            'pbvalue' : {
                                'type' : 'text',
                                'name' : 'Value',
                                'action' : 'element_attribute',
                                'attribute' : 'value'
                            },
                            'pblow' : {
                                'type' : 'text',
                                'name' : 'Low',
                                'action' : 'element_attribute',
                                'attribute' : 'low'
                            },
                            'pbhigh' : {
                                'type' : 'text',
                                'name' : 'High',
                                'action' : 'element_attribute',
                                'attribute' : 'high'
                            },
                            'pboptimum' : {
                                'type' : 'text',
                                'name' : 'Optimum',
                                'action' : 'element_attribute',
                                'attribute' : 'optimum'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_meter_tag);
        // End Progress bar

        // Table
            // Tables helpers
            var isTableRowEmpty = function (pgtr) {
                var empty = true;
                var pgtds = pgtr.find('> td');
                for (var i = 0; i < pgtds.length; i++) {
                    var pgtd = pgtds[i]
                    if ($.trim(pgtd.html()).length > 0) {
                        empty = false;
                        return false;
                    }
                }

                return empty;
            }

            var countNonEmptyTableRows = function(pgtbody) {
                var c = 0;

                var pgtrs = pgtbody.find("> tr");
                for (var i = 0; i < pgtrs.length; i++) {
                    var pgtr = pgtrs[i];
                    if (isTableRowEmpty(pgtr)) c++;
                }

                return c;
            }

            var getTablePreviewCode = function(t) {
                return '<table class="table preview-' + t + '">\
                    <thead>\
                        <tr>\
                            <th>#</th>\
                            <th>First Name</th>\
                            <th>Last Name</th>\
                            <th>Username</th>\
                        </tr>\
                    </thead>\
                    <tbody>\
                        <tr class="sel">\
                            <td>1</td>\
                            <td class="sel">Mark</td>\
                            <td>Otto</td>\
                            <td>@mdo</td>\
                        </tr>\
                        <tr>\
                            <td>2</td>\
                            <td>Jacob</td>\
                            <td>Thornton</td>\
                            <td>@fat</td>\
                        </tr>\
                        <tr>\
                            <td>3</td>\
                            <td>Larry</td>\
                            <td>the Bird</td>\
                            <td>@twitter</td>\
                        </tr>\
                    </tbody>\
                </table>';
            }

            // Table
            var def_table = new PgComponentType(prefix + 'table', 'Table', {
                'selector' : 'table',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<table>\
                    <thead>\
                        <tr>\
                            <th width="200">Table Header</th>\
                            <th>Table Header</th>\
                            <th width="150">Table Header</th>\
                            <th width="150">Table Header</th>\
                        </tr>\
                    </thead>\
                    <tbody>\
                        <tr>\
                            <td>Content Goes Here</td>\
                            <td>This is longer content Donec id elit non mi porta gravida at eget metus.</td>\
                            <td>Content Goes Here</td>\
                            <td>Content Goes Here</td>\
                        </tr>\
                        <tr>\
                            <td>Content Goes Here</td>\
                            <td>This is longer Content Goes Here Donec id elit non mi porta gravida at eget metus.</td>\
                            <td>Content Goes Here</td>\
                            <td>Content Goes Here</td>\
                        </tr>\
                        <tr>\
                            <td>Content Goes Here</td>\
                            <td>This is longer Content Goes Here Donec id elit non mi porta gravida at eget metus.</td>\
                            <td>Content Goes Here</td>\
                            <td>Content Goes Here</td>\
                        </tr>\
                    </tbody>\
                </table>',
                action_menu: {
                    add: [prefix + 'table-head', prefix + 'table-body']
                },
                preview: getTablePreviewCode('table'),
                'sections' : addPrefixToSectionsAndFields({
                    'data' : {
                        name: "Table options",
                        fields: {
                            rows: {
                                type: 'text',
                                name: 'Rows',
                                action: 'custom',
                                get_value: function (pgel) {
                                    var pgtbody = pgel.findOne('>tbody');
                                    var pgrows = pgtbody.find('>tr');
                                    return pgrows.length;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {
                                    crsaWillChangeDom();

                                    value = parseInt(value) || 0;

                                    var pgtbody = pgel.findOne('>tbody');

                                    if (!pgtbody) {
                                        //$tbody = $('<tbody/>').appendTo($el);
                                        pgtbody = pgCreateNodeFromHtml('<tbody></tbody>');
                                        pgel.append(pgtbody);
                                        // $tbody = $(pgtbody.get(0).el);
                                    }
                                    var pgrows = pgtbody.find('>tr');

                                    var cols = values.columns;
                                    var change = false;
                                    var empty_count = countNonEmptyTableRows(pgtbody);
                                    var new_value = value;

                                    if (pgrows.length < value) {
                                        for (var n = 0; n < value - pgrows.length; n++) {
                                            //var $tr = $('<tr/>').appendTo($tbody);
                                            var pgtr = pgCreateNodeFromHtml('<tr></tr>');
                                            pgtbody.append(pgtr);
                                            // var $tr = $(pgtr.get(0).el);
                                            for (var c = 0; c < cols; c++) {
                                                pgtr.append(pgCreateNodeFromHtml('<td></td>'));
                                                //$('<td/>').appendTo($tr);
                                            }
                                        }
                                        change = true;
                                    } else if (pgrows.length > value) {
                                        var remove = pgrows.length - value;
                                        for (var i = 0; i < pgrows.length; i++) {
                                            var pgtr = pgrows[i];

                                            if (isTableRowEmpty(pgtr)) {
                                                pgtr.remove();
                                                remove--;
                                                if (remove == 0) break;
                                            }
                                        }
                                        new_value = value + remove;
                                    } else {

                                    }
                                    if(eventType == "change") {
                                        // $.fn.crsa("setNeedsUpdate", false, $el);
                                        value = new_value;
                                    }
                                    return value;
                                }
                            },
                            columns: {
                                type: 'text',
                                name: 'Columns',
                                action: 'custom',
                                get_value: function (pgel) {
                                    var pgtbody = pgel.findOne('>tbody');
                                    var pgrows = pgtbody.find('>tr');
                                    var max_c = 0;

                                    for (var i = 0; i < pgrows.length; i++) {
                                        var c = pgrows[i].find('>th').length;
                                        if (c > max_c) max_c = c;
                                    }

                                    var pgtrs = pgel.find('>thead >tr');
                                    for (var i = 0; i < pgtrs.length; i++) {
                                        var c = pgtrs[i].find('>th').length;
                                        if (c > max_c) max_c = c;
                                    }

                                    return max_c;
                                },
                                set_value: function (pgel, value, values, oldValue, eventType) {

                                    crsaWillChangeDom();

                                    value = parseInt(value) || 0;

                                    var pgtbody = pgel.findOne('>tbody');
                                    var pgthead = pgel.findOne('>thead');

                                    var pgrows = [];
                                    if (pgtbody) pgrows = pgrows.concat(pgtbody.find('>tr'));
                                    if (pgthead) pgrows = pgrows.concat(pgthead.find('>tr'));

                                    var new_value = value;
                                    if (value) {
                                        var max_c = 0;

                                        for (var i = 0; i < pgrows.length; i++) {
                                            var pgtr = pgrows[i];
                                            var pgcells = pgtr.find('>td,>th');

                                            if (pgcells.length > value) {
                                                var remove = pgcells.length - value;

                                                for (var i = 0; i < pgcells.length; i++) {
                                                    var pgtd = pgcells[i];
                                                    if ($.trim(pgtd.html()) == '') {
                                                        //$td.remove();
                                                        pgtd.remove();
                                                        remove--;
                                                        if (remove == 0) break;
                                                    }
                                                }
                                            } else if (pgcells.length < value) {
                                                for (var n = pgcells.length; n < value; n++) {
                                                    var tag = pgtr.parent.tagName == 'thead' ? 'th' : 'td';
                                                    pgtr.append(pgCreateNodeFromHtml('<' + tag + '></' + tag + '>'));
                                                    //$('<' + tag +'/>').appendTo($(tr));
                                                }
                                            }
                                            var c = pgtr.find('>td,>th').length;
                                            if (c > max_c) max_c = c;
                                        }

                                        new_value = max_c;
                                    }
                                    if (eventType == "change") {
                                        // $.fn.crsa("setNeedsUpdate", false, $el);
                                        value = new_value;
                                    }
                                    return value;
                                }
                            },
                            'tablehover' : {
                                'type': 'checkbox',
                                'name': 'Hover',
                                'action': 'apply_class',
                                'value': 'hover'
                            },
                            'tableunstriped' : {
                                'type': 'checkbox',
                                'name': 'Unstriped',
                                'action': 'apply_class',
                                'value': 'unstriped'
                            },
                            'tablestack' : {
                                'type': 'checkbox',
                                'name': 'Stack',
                                'action': 'apply_class',
                                'value': 'stack'
                            },
                            'tabletablescroll' : {
                                'type': 'checkbox',
                                'name': 'Table scroll',
                                'action': 'apply_class',
                                'value': 'table-scroll'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_table);

            // Table head
            var def_table_head = new PgComponentType(prefix + 'table-head', 'Table head', {
                'selector' : 'thead',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<thead></thead>',
                action_menu: {
                    add: [prefix + 'table-row-head']
                },
                'sections' : addPrefixToSectionsAndFields({ })
            });
            f.addComponentType(def_table_head);

            // Table body
            var def_table_body = new PgComponentType(prefix + 'table-body', 'Table body', {
                'selector' : 'tbody',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<tbody></tbody>',
                action_menu: {
                    add: [prefix + 'table-row']
                },
                'sections' : addPrefixToSectionsAndFields({ })
            });
            f.addComponentType(def_table_body);

            // Table row head
            var def_table_row_head = new PgComponentType(prefix + 'table-row-head', 'Table row head', {
                'selector' : 'th',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<th></th>',
                action_menu: {
                    add: [prefix + 'table-cell']
                },
                'sections' : addPrefixToSectionsAndFields({ })
            });
            f.addComponentType(def_table_row_head);

            // Table row
            var def_table_row = new PgComponentType(prefix + 'table-row', 'Table row', {
                'selector' : 'tr',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<tr></tr>',
                action_menu: {
                    add: [prefix + 'table-cell']
                },
                'sections' : addPrefixToSectionsAndFields({ })
            });
            f.addComponentType(def_table_row);

            // Table cell
            var def_table_cell = new PgComponentType(prefix + 'table-cell', 'Table cell', {
                'selector' : 'td',
                'tags' : 'major',
                'helplink' : 'table.html',
                'code' : '<td></td>',
                'sections' : addPrefixToSectionsAndFields({ })
            });
            f.addComponentType(def_table_cell);
        // End Table

        // Accordion
            // Accordion title
            var def_accordion_title = new PgComponentType(prefix + 'accordion-title', 'Accordion title', {
                'selector' : '.accordion-title',
                'helplink' : 'accordion.html',
                'code' : '<a role="tab" href="#" class="accordion-title">Accordion</a>',
                tags: 'major',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_accordion_title);

            // Accordion item content
            var def_accordion_item_content = new PgComponentType(prefix + 'accordion-item-content', 'Accordion item content', {
                'selector' : '.accordion-content',
                'helplink' : 'accordion.html',
                'code' : '<div class="accordion-content" role="tabpanel" data-tab-content>\
                    Panel. Lorem ipsum dolor\
                </div>',
                tags: 'major',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_accordion_item_content);

            // Accordion item
            var def_accordion_item = new PgComponentType(prefix + 'accordion-item', 'Accordion item', {
                'selector' : '.accordion-item',
                'helplink' : 'accordion.html',
                'code' : '<li class="accordion-item" data-accordion-item>\
                    <a role="tab" href="#" class="accordion-title">Accordion</a>\
                    <div class="accordion-content" role="tabpanel" data-tab-content>\
                        Panel. Lorem ipsum dolor\
                    </div>\
                </li>',
                tags: 'major',
                priority: 100,
                action_menu: {
                    add: [prefix + 'accordion-title', prefix + 'accordion-item-content']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fdacc' : {
                        name: 'Item options',
                        fields: {
                            'fdaccordionname' : {
                                'type' : 'text',
                                'name' : 'Name',
                                'action' : 'custom',
                                live_update : true,
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pga = pgel.findOne('>a');
                                    if (pga) pga.html(value);
                                    return value;
                                },
                                get_value: function (pgel) {
                                    var pga = pgel.findOne('>a');

                                    if (pga) return pga.html();
                                    else     return null;
                                }
                            },
                            'fdaccordionactive' : {
                                'type' : 'checkbox',
                                'name' : 'Active',
                                'value' : 'is-active',
                                'action' : 'apply_class',
                                on_changed : function () {
                                    showOrbitMessage();
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_accordion_item);

            // Accordion
            var def_accordion = new PgComponentType(prefix + 'accordion', 'Accordion', {
                'selector' : '.accordion',
                'helplink' : 'accordion.html',
                'code' : '<ul class="accordion" data-accordion role="tablist">\
                    <li class="accordion-item is-active" data-accordion-item>\
                        <a href="#" role="tab" class="accordion-title">Accordion 1</a>\
                        <div class="accordion-content" role="tabpanel" data-tab-content>\
                            Panel 1. Lorem ipsum dolor\
                        </div>\
                    </li>\
                    <li class="accordion-item" data-accordion-item>\
                        <a href="#" role="tab" class="accordion-title">Accordion 2</a>\
                        <div class="accordion-content" role="tabpanel" data-tab-content>\
                            Panel 2. Lorem ipsum dolor\
                        </div>\
                    </li>\
                    <li class="accordion-item" data-accordion-item>\
                        <a href="#" role="tab" class="accordion-title">Accordion 3</a>\
                        <div class="accordion-content" role="tabpanel" data-tab-content>\
                            Panel 3. Lorem ipsum dolor\
                        </div>\
                    </li>\
                </ul>',
                tags: 'major',
                priority: 100,
                on_inserted : function() {
                    showOrbitMessage();
                },
                on_changed : function() {
                    showOrbitMessage();
                },
                action_menu: {
                    add: [prefix + 'accordion-item']
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fd.accordion.parameters' : {
                        name : 'Options',
                        fields : getStandardPluginAction({
                            'fd.accordion.disabled' : {
                                'type' : 'checkbox',
                                'action' : 'element_attribute',
                                'name' : 'Disabled',
                                'attribute' : 'disabled',
                                'value' : 'disabled',
                                'attribute_without_value' : false
                            },
                            'fd.accordion.expand' : {
                                'type' : 'checkbox',
                                'value' : 'true',
                                'action' : 'element_attribute',
                                'attribute' : 'data-multi-expand',
                                'name' : 'Multi expand'
                            },
                            'fd.accordion.close' : {
                                'type' : 'checkbox',
                                'value' : 'true',
                                'action' : 'element_attribute',
                                'attribute' : 'data-allow-all-closed',
                                'name' : 'Allow closing'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_accordion);

            var def_accordion_action = new PgComponentType('fd-accordion-action', 'Accordion', {
                'selector' : "[data-accordion]",
                'attribute' : 'data-accordion',
                'helplink' : 'accordion.html',
                'action' : true,
                'not_main_type' : true,
                'on_action_added' : function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fd.accordion.parameters' : {
                        name : 'Options',
                        fields : getStandardPluginAction({
                            'fd.accordion.expand' : {
                                'type' : 'checkbox',
                                'value' : 'true',
                                'action' : 'element_attribute',
                                'attribute' : 'data-multi-expand',
                                'name' : 'Multi expand'
                            },
                            'fd.accordion.close' : {
                                'type' : 'checkbox',
                                'value' : 'true',
                                'action' : 'element_attribute',
                                'attribute' : 'data-allow-all-closed',
                                'name' : 'Allow closing'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_accordion_action);
            //actions.push(def_accordion_action);
        // End Accordion

        // Tabs
            // Tab content
            var def_tabs_content = new PgComponentType(prefix + 'tabs-content', 'Tab content', {
                'selector' : '.tabs-content',
                'priority' : 99,
                'helplink' : 'tabs.html',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_tabs_content);

            // Tab item
            var def_tabs_item = new PgComponentType(prefix + 'tabs-item', 'Tab item', {
                'type' : 'fd-tabs-item',
                'selector' : '.tabs-title',
                'helplink' : 'tabs.html',
                'code' : function() {
                    var id1 = getUniqueId('panel');
                    return '<li class="tabs-title"><a href="#' + id1 + '">Tab</a></li>';
                },
                tags: 'major',
                priority: 100,
                'sections' : addPrefixToSectionsAndFields({
                    'fdacc' : {
                        name: 'Item options',
                        fields: {
                            fddest : {
                                'type' : 'text',
                                'name' : 'Panel id',
                                'action' : 'custom',
                                live_update : false,
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var pga = pgel.findOne('>a');
                                    if (pga) pga.setAttr('href', '#' + value);

                                    var pgtabs = pgel.parent.next();
                                    if (pgtabs.find('#' + value).length == 0) {
                                        showAlert('Can not find tab content with this id.', 'No tab content');
                                    } else {
                                        showOrbitMessage();
                                    }
                                    return value;
                                },
                                get_value: function (pgel) {
                                    var pga =  pgel.findOne('>a');
                                    var h = '';
                                    if (pga) h = pga.getAttr('href');
                                    return h ? h.replace('#','') : null;
                                }
                            },
                            fdname : {
                                'type' : 'text',
                                'name' : 'Name',
                                'action' : 'custom',
                                live_update : true,
                                set_value : function(pgel, value, values, oldValue, eventType) {
                                    var pga = pgel.findOne('>a');
                                    if (pga) pga.html(value);
                                    return value;
                                },
                                get_value: function(pgel) {
                                    var pga = pgel.find('>a');
                                    if (pga) return pga.html();
                                    return null;
                                }
                            },
                            fdactive: {
                                'type' : 'checkbox',
                                'name' : 'Active',
                                'action' : 'custom',
                                'value' : '1',
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var id = pgel.findOne('>a').getAttr('href');
                                    var idContent = pgel.parent.getAttr('id');
                                    var pgtabs = pgel.closest('body').findOne('[data-tabs-content="' + idContent + '"]');
                                    if (!pgtabs) {
                                        showAlert("Can't find tabs content with this element id. Add a tab content first.", "Tab content not found");
                                    }
                                    else {
                                        var pgtabContent = pgtabs.findOne(id);
                                        if (value == '1') {
                                            pgel.addClass('is-active');
                                            pgtabContent.addClass('is-active');
                                        }
                                        else {
                                            pgel.removeClass('is-active');
                                            pgtabContent.removeClass('is-active');
                                        }
                                        return value;
                                    }
                                },
                                get_value: function (pgel) {
                                    return pgel.hasClass('is-active') ? '1' : null;
                                }
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_tabs_item);

            // Tabs
            var def_tabs = new PgComponentType(prefix + 'tabs', 'Tabs', {
                'selector' : '.tabs',
                'helplink' : 'tabs.html',
                'code' : function() {
                    var idContent = getUniqueId('panel-content');
                    var id1 = getUniqueId('panel');
                    var id2 = getUniqueId('panel');
                    var id3 = getUniqueId('panel');
                    var id4 = getUniqueId('panel');

                    return '<ul class="tabs" data-tabs id="' + idContent + '">\
                      <li class="tabs-title is-active"><a href="#' + id1 + '" aria-selected="true">Tab 1</a></li>\
                      <li class="tabs-title"><a href="#' + id2 + '">Tab 2</a></li>\
                      <li class="tabs-title"><a href="#' + id3 + '">Tab 3</a></li>\
                      <li class="tabs-title"><a href="#' + id4 + '">Tab 4</a></li>\
                    </ul>';
                },
                tags: 'major',
                priority: 100,
                on_inserted : function(pgel) {
                    var idContent = pgel.getAttr('id');
                    var pgtc = pgCreateNodeFromHtml('<div class="tabs-content" data-tabs-content="' + idContent + '"></div>').insertAfter(pgel);

                    var pgelchildren = pgel.children;
                    var firstTime = true, index = 1;
                    for (var i = 0; i < pgelchildren.length; i++) {
                        var pgt = pgelchildren[i];

                        if (pgt.tagName == 'text') continue;

                        var pga = pgt.findOne('>a');

                        var id = null;
                        if (pga) id = pga.getAttr('href');
                        if (id) id = id.replace('#', '');

                        var pgp = pgCreateNodeFromHtml('<div class="tabs-panel"><p>Tab ' + index + ' content goes here...</p></div>');
                        if (id) pgp.setAttr('id', id);
                        if (firstTime) pgp.addClass('is-active');
                        pgtc.append(pgp);

                        if (firstTime) firstTime = false;
                        index++;
                    }
                    showOrbitMessage();
                },
                on_changed : function() {
                    showOrbitMessage();
                },
                action_menu: {
                    add: [prefix + 'tabs-item'],
                    on_add : function(pgel, pgnew, newdef, prepend) {
                        var id = pgnew.findOne('>a').attr('href').replace('#', '');
                        var pgdiv = pgCreateNodeFromHtml('<div class="tabs-panel" id="' + id + '"><p>Tab content goes here...</p></div>');

                        var pgtabs = pgel.next();
                        if (prepend) {
                            pgtabs.prepend(pgdiv);
                            pgel.prepend(pgnew);
                        } else {
                            pgtabs.append(pgdiv);
                            pgel.append(pgnew);
                        }
                    }
                },
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_tabs);

            // Tab panel
            var def_tabs_panel = new PgComponentType(prefix + 'tabs-panel', 'Tab panel', {
                'selector' : '.tabs-panel',
                'priority' : 99,
                'helplink' : 'tabs.html',
                'sections' : addPrefixToSectionsAndFields({
                })
            });
            f.addComponentType(def_tabs_panel);
        // End tabs

        // Offcanvas
            // Offcanvas content
            var def_offcanvas_content = new PgComponentType(prefix + 'offcanvas-content', 'Offcanvas content', {
                'selector' : '.off-canvas-content',
                'helplink' : 'off-canvas.html',
                'code' : '<div class="off-canvas-content" data-off-canvas-content></div>',
                'tags' : 'major',
                on_inserted : function() {
                    showOrbitMessage();
                },
                action_menu : {
                    add: [prefix + 'offcanvas-title-bar']
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_offcanvas_content);
            // var offcanvas_content_action = new PgComponentType('fd-offcanvas-content-action', 'Offcanvas content');
            // offcanvas_content_action.selector = "[data-off-canvas-content]";
            // offcanvas_content_action.attribute = 'data-off-canvas-content';
            // offcanvas_content_action.helplink = 'off-canvas.html';
            // offcanvas_content_action.action = true;
            // offcanvas_content_action.not_main_type = true;
            // offcanvas_content_action.sections = {};
            // offcanvas_content_action.on_action_added = function(pgel, cp, action_def, $el) {
            //     var pgq = new pgQuery($el);
            //     pgq.addClass('off-canvas-content');
            //     pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate tooltip.');
            // }
            // offcanvas_content_action.on_action_removed = function(pgel, cp, action_def, $el) {
            //     var pgq = new pgQuery($el);
            //     pgq.removeClass('off-canvas-content');
            // }
            // f.addComponentType(offcanvas_content_action);
            // actions.push(offcanvas_content_action);

            // Offcanvas inner wraper
            var def_offcanvas_inner_wrapper = new PgComponentType(prefix + 'offcanvas-inner-wrapper', 'Offcanvas inner wrapper', {
                'selector' : '.off-canvas-wrapper-inner',
                'helplink' : 'off-canvas.html',
                'code' : '<div class="off-canvas-wrapper-inner" data-off-canvas-wrapper>\
                    <div class="off-canvas position-left" id="offCanvas" data-off-canvas>\
                        <ul>\
                            <li>Lorem ipsum dolor sit amet</li>\
                            <li>Phasellus iaculis neque</li>\
                            <li>Purus sodales ultricies</li>\
                        </ul>\
                    </div>\
                    <div class="off-canvas-content" data-off-canvas-content></div>\
                </div>',
                'tags' : 'major',
                action_menu : {
                    add: [prefix + 'offcanvas-content', prefix + 'offcanvas']
                },
                on_inserted : function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_offcanvas_inner_wrapper);
            // var offcanvas_wrapper_action = new PgComponentType('fd-offcanvas-wrapper-action', 'Offcanvas wrapper');
            // offcanvas_wrapper_action.selector = "[data-off-canvas-wrapper]";
            // offcanvas_wrapper_action.attribute = 'data-off-canvas-wrapper';
            // offcanvas_wrapper_action.helplink = 'off-canvas.html';
            // offcanvas_wrapper_action.action = true;
            // offcanvas_wrapper_action.not_main_type = true;
            // offcanvas_wrapper_action.sections = {};
            // offcanvas_wrapper_action.on_action_added = function(pgel, cp, action_def, $el) {
            //     var pgq = new pgQuery($el);
            //     pgq.addClass('off-canvas-wrapper-inner');
            //     pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate tooltip.');
            // }
            // offcanvas_wrapper_action.on_action_removed = function(pgel, cp, action_def, $el) {
            //     var pgq = new pgQuery($el);
            //     pgq.removeClass('off-canvas-wrapper-inner');
            // }
            // f.addComponentType(offcanvas_wrapper_action);
            // actions.push(offcanvas_wrapper_action);

            // Offcanvas
            var def_offcanvas = new PgComponentType(prefix + 'offcanvas', 'Offcanvas', {
                'selector' : '[data-off-canvas]',
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id = getUniqueId("offcanvas");
                    return '<div class="off-canvas position-left" id="' + id + '" data-off-canvas></div>';
                },
                'tags' : 'major',
                on_inserted : function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fd.offcanvas.parameters' : {
                        name : 'Offcanvas Options',
                        fields : getStandardPluginAction({
                            'fd.offcanvas.position': {
                                'type' : 'select',
                                'name' : 'Position',
                                'options' : [
                                    { 'key' : 'top', 'name' : 'Top' },
                                    { 'key' : 'left', 'name' : 'Left' },
                                    { 'key' : 'right', 'name' : 'Right' },
                                    { 'key' : 'bottom', 'name' : 'Bottom' }
                                ],
                                'action' : 'custom',
                                get_value : function (pgel) {
                                    if (pgel.hasClass('position-left')) {
                                        return 'left';
                                    }
                                    else if (pgel.hasClass('position-right')) {
                                        return 'right';
                                    }
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    pgel.removeClass('position-left');
                                    pgel.removeClass('position-right');

                                    if (value) {
                                        pgel.addClass('position-' + value);
                                        pgel.setAttr('data-position', value);
                                    }
                                    else {
                                        pgel.removeAttr('data-position');
                                    }

                                    return value;
                                }
                            },
                            'fd.offcanvas.reveal' : {
                                'type' : 'select',
                                'name' : 'Reveal',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'reveal-for-medium', 'name' : 'Reveal for medium' },
                                    { 'key' : 'reveal-for-large', 'name' : 'Reveal for large' }
                                ],
                                'action' : 'apply_class'
                            },
                            'fd.offcanvas.id' : {
                                'type' : 'text',
                                'name' : 'Offcanvas id',
                                'action' : 'element_attribute',
                                'attribute' : 'id'
                            },
                            'fd.offcanvas.transition' : {
                                'type': 'select',
                                'name': 'Transition',
                                'action': 'element_attribute',
                                'attribute': 'data-transition',
                                'show_empty': true,
                                'options': [
                                    { key: 'overlap', name: 'Overlap' },
                                    { key: 'push', name: 'Push' }
                                ]
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_offcanvas);

            var def_offcanvas_action = new PgComponentType(prefix + 'offcanvas-action', 'Offcanvas', {
                'selector' : "[data-off-canvas]",
                'attribute' : 'data-off-canvas',
                'helplink' : 'off-canvas.html',
                'action' : true,
                'not_main_type' : true,
                'on_action_added' : function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections' : addPrefixToSectionsAndFields({
                    'fd.offcanvas.parameters' : {
                        name : 'Offcanvas Options',
                        fields : getStandardPluginAction({
                            'fd.offcanvas.position': {
                                'type' : 'select',
                                'name' : 'Position',
                                'options' : [
                                    { 'key' : 'left', 'name' : 'Left' },
                                    { 'key' : 'right', 'name' : 'Right' }
                                ],
                                'action' : 'custom',
                                get_value : function (pgel) {
                                    if (pgel.hasClass('position-left')) {
                                        return 'left';
                                    }
                                    else if (pgel.hasClass('position-right')) {
                                        return 'right';
                                    }
                                },
                                set_value : function (obj, value, values, oldValue, eventType) {
                                    pgel.removeClass('position-left');
                                    pgel.removeClass('position-right');

                                    if (value) {
                                        pgel.addClass('position-' + value);
                                        pgel.attr('data-position', value);
                                    }
                                    else {
                                        pgel.removeAttr('data-position');
                                    }

                                    return value;
                                }
                            },
                            'fd.offcanvas.reveal' : {
                                'type' : 'select',
                                'name' : 'Reveal',
                                'show_empty' : true,
                                'options' : [
                                    { 'key' : 'reveal-for-medium', 'name' : 'Reveal for medium' },
                                    { 'key' : 'reveal-for-large', 'name' : 'Reveal for large' }
                                ],
                                'action' : 'apply_class'
                            },
                            'fd.offcanvas.id' : {
                                'type' : 'text',
                                'name' : 'Offcanvas id',
                                'action' : 'element_attribute',
                                'attribute' : 'id'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_offcanvas_action);
            //actions.push(offcanvas_action);

            // Offcanvas wrapper
            var def_offcanvas_wraper = new PgComponentType(prefix + 'offcanvas-wraper', 'Offcanvas wrapper', {
                'selector' : '.off-canvas-wrapper',
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id = getUniqueId("offcanvas");
                    return '<div class="off-canvas-wrapper">\
                        <div class="off-canvas-wrapper-inner" data-off-canvas-wrapper>\
                            <div class="off-canvas position-left" id="' + id + '" data-off-canvas>\
                                <ul>\
                                    <li>Lorem ipsum dolor sit amet</li>\
                                    <li>Phasellus iaculis neque</li>\
                                    <li>Purus sodales ultricies</li>\
                                </ul>\
                            </div>\
                            <div class="off-canvas-content" data-off-canvas-content>\
                                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Officia eum neque maxime dignissimos voluptates cupiditate, quod commodi quisquam non doloremque. Rem sed quo aliquid eaque ex, hic odit officiis esse.</p>\
                                <p><a href="#" class="button" data-open="' + id + '">Open Offcanvas</a></p>\
                            </div>\
                        </div>\
                    </div>';
                },
                'tags' : 'major',
                action_menu : {
                    add: [prefix + 'offcanvas-inner-wrapper']
                },
                tags: 'major',
                on_inserted : function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_offcanvas_wraper);

            // Offcanvas title bar right
            var def_offcanvas_title_bar_right = new PgComponentType(prefix + 'offcanvas-title-bar-right', 'Title bar right', {
                'selector' : '.title-bar-right',
                'parent_selector' : '.title-bar',
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id = getUniqueId("offcanvas");

                    return '<div class="title-bar-right">\
                        <button class="menu-icon" type="button" data-open="' + id + '"></button>\
                    </div>';
                }
            });
            f.addComponentType(def_offcanvas_title_bar_right);

            // Offcanvas title bar left
            var def_offcanvas_title_bar_left = new PgComponentType(prefix + 'offcanvas-title-bar-left', 'Title bar left', {
                'selector' : '.title-bar-left',
                'parent_selector' : '.title-bar',
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id = getUniqueId("offcanvas");

                    return '<div class="title-bar-left">\
                        <button class="menu-icon" type="button" data-open="' + id + '"></button>\
                        <span class="title-bar-title">Foundation</span>\
                    </div>';
                }
            });
            f.addComponentType(def_offcanvas_title_bar_left);

            // Offcanvas title bar
            var def_offcanvas_title_bar = new PgComponentType(prefix + 'offcanvas-title-bar', 'Title bar', {
                'selector' : '.title-bar',
                'parent_selector' : '.off-canvas-content',
                'tags' : 'major',
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id1 = getUniqueId("offcanvas");
                    var id2 = getUniqueId("offcanvas");

                    return '<div class="title-bar">\
                        <div class="title-bar-left">\
                            <button class="menu-icon" type="button" data-open="' + id1 + '"></button>\
                            <span class="title-bar-title">Foundation</span>\
                        </div>\
                        <div class="title-bar-right">\
                            <button class="menu-icon" type="button" data-open="' + id2 + '"></button>\
                        </div>\
                    </div>';
                },
                action_menu : {
                    add: [prefix + 'offcanvas-title-bar-left', prefix + 'offcanvas-title-bar-right']
                }
            });
            f.addComponentType(def_offcanvas_title_bar);

            // Offcanvas wrapper topbar
            var def_offcanvas_wrapper_topbar = new PgComponentType(prefix + 'offcanvas-wraper-topbar', 'Offcanvas', {
                'helplink' : 'off-canvas.html',
                'code' : function () {
                    var id1 = getUniqueId("offcanvas");
                    var id2 = getUniqueId("offcanvas");

                    return '<div class="off-canvas-wrapper">\
                        <div class="off-canvas-wrapper-inner" data-off-canvas-wrapper>\
                            <div class="off-canvas position-left" id="' + id1 + '" data-off-canvas data-position="left">\
                                <ul>\
                                    <li>Lorem ipsum dolor sit amet</li>\
                                    <li>Phasellus iaculis neque</li>\
                                    <li>Purus sodales ultricies</li>\
                                </ul>\
                            </div>\
                            <div class="off-canvas position-right" id="' + id2 + '" data-off-canvas data-position="right">\
                                <ul>\
                                    <li>Lorem ipsum dolor sit amet</li>\
                                    <li>Phasellus iaculis neque</li>\
                                    <li>Purus sodales ultricies</li>\
                                </ul>\
                            </div>\
                            <div class="off-canvas-content" data-off-canvas-content>\
                                <div class="title-bar">\
                                    <div class="title-bar-left">\
                                        <button class="menu-icon" type="button" data-open="' + id1 + '"></button>\
                                        <span class="title-bar-title">Foundation</span>\
                                    </div>\
                                    <div class="title-bar-right">\
                                        <button class="menu-icon" type="button" data-open="' + id2 + '"></button>\
                                    </div>\
                                </div>\
                                <h3>Off-canvas main content</h3>\
                                <p>Cras justo odio, dapibus ac facilisis in, egestas eget quam. Donec id elit non mi porta gravida at eget metus. Nullam id dolor id nibh ultricies vehicula ut id elit.</p>\
                            </div>\
                        </div>\
                    </div>';
                },
                tags: 'major',
                on_inserted : function(pgel) {
                    pinegrow.showQuickMessage('Move your page content to <b>Offcanvas content</b>');

                    // TODO all element removed
                    // var pgcanvasoff = pgel.findOne('.off-canvas-content');
                    // if (pgcanvasoff) {
                    //     var pgelmToMove = pgel.siblings();
                    //     for (var i = 0; i < pgelmToMove.length; i++) {
                    //         var pgelToMove = pgelmToMove[i];
                    //         if (pgelToMove.tagName != 'script' && pgelToMove.tagName != 'text') {
                    //             pgcanvasoff.append(pgelToMove);
                    //         }
                    //     }
                    // }

                    // var pgel = new pgQuery($el.find('.off-canvas-content'));
                    // if (pgel.length > 0) {
                    //     var elmToMove = new pgQuery($el.siblings(':not(script)'));
                    //     var goodElements = new pgQuery();

                    //     for (var i = 0; i < elmToMove.list.length; i++) {
                    //         var currentElm = elmToMove.list[i];
                    //         if (currentElm.pgel) {
                    //             goodElements.add(currentElm);
                    //         }
                    //     }
                    //     pgel.append(goodElements);
                    // }
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_offcanvas_wrapper_topbar);

            // Offcanvas toggle
            var def_offcanvas_toggle = new PgComponentType(prefix + 'offcanvas-toggle', 'Offcanvas button', {
                'selector' : '[data-toggle]',
                'code' : '<button type="button" class="button" data-toggle="offCanvas">Open Menu</button>',
                'tags' : 'major',
                'helplink' : 'off-canvas.html',
                on_inserted : function() {
                    showOrbitMessage();
                },
                'sections' : addPrefixToSectionsAndFields({})
            });
            f.addComponentType(def_offcanvas_toggle);
        // End Offcanvas

        // Content section
            var content_section = new PgFrameworkLibSection(prefix + 'content', 'Content');
            content_section.setComponentTypes([def_dropdown_button, def_dropdown_pane, def_dropdown_menu, def_accordion_menu, def_submenu_parent, def_dropdown_list_submenu, def_magellan, def_drilldown, def_media_object, def_progress_bar, def_table, def_accordion, def_tabs, def_offcanvas_wrapper_topbar]);
            f.addLibSection(content_section);
        // End content section


        // Tooltip
            var def_tooltip_action = new PgComponentType(prefix + 'tooltip-action', 'Tooltip', {
                'selector': "[data-tooltip]",
                'attribute': 'data-tooltip',
                'helplink': 'tooltip.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function(pgel, cp, action_def, $el) {
                    pgel.addClass('has-tip');
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'on_action_removed': function(pgel, cp, action_def, $el) {
                    pgel.removeClass('has-tip');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.tooltip.parameters' : {
                        name : 'Options',
                        fields : getStandardPluginAction({
                            'fd.tooltip.text' : {
                                type : 'text',
                                name : 'Tip text',
                                action : "element_attribute",
                                attribute : 'data-tip-text',
                                attribute_keep_if_empty : false,
                                placeholder: f.textDefaultValue('title attribute')
                            },
                            'fd.tooltip.position' : {
                                type : 'select',
                                name : 'Position',
                                show_empty : true,
                                action: 'apply_class',
                                options: [
                                    {key: 'top', name: 'Top'},
                                    {key: 'right', name: 'Right'},
                                    {key: 'bottom', name: 'Bottom'},
                                    {key: 'left', name: 'Left'}
                                ]
                            },
                            'fd.tooltip.disablehover' : {
                                type : 'checkbox',
                                name : 'Disable hover',
                                action : "element_attribute",
                                attribute : 'data-disable-hover',
                                value: 'true'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_tooltip_action);
            actions.push(def_tooltip_action);
        // End Tooltip

        // Equalizer
            var def_equalizer_action = new PgComponentType(prefix + 'equalizer-action', 'Equalizer', {
                'selector': "[data-equalizer]",
                'attribute': 'data-equalizer',
                'helplink': 'equalizer.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function(pgel, cp, action_def, $el) {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate tooltip.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.equalizer.parameters' : {
                        'name' : 'Equalizer options',
                        'fields' : getStandardPluginAction({
                            'fd.equalizer.text': {
                                'type' : 'text',
                                'name' : 'Equalizer',
                                'action' : 'element_attribute',
                                'attribute' : 'data-equalizer',
                                'attribute_keep_if_empty' : true
                            },
                            'fd.equalizer.onmedium' : {
                                'type' : 'checkbox',
                                'name' : 'On Medium',
                                'action' : 'element_attribute',
                                'attribute' : 'data-equalize-on',
                                'value' : 'medium',
                                'attribute_keep_if_empty' : false
                            },
                            'fd.equalizer.byrow' : {
                                'type' : 'checkbox',
                                'name' : 'By row',
                                'action' : 'element_attribute',
                                'attribute' : 'data-equalize-by-row',
                                'value' : 'true',
                                'attribute_keep_if_empty' : false
                            },
                            'fd.equalizer.byrow' : {
                                'type' : 'checkbox',
                                'name' : 'By row',
                                'action' : 'element_attribute',
                                'attribute' : 'data-equalize-by-row',
                                'value' : 'true',
                                'attribute_keep_if_empty' : false
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_equalizer_action);
            actions.push(def_equalizer_action);

            var def_equalizer_watch_action = new PgComponentType(prefix + 'equalizer-watch-action', 'Equalizer watch', {
                'selector': "[data-equalizer-watch]",
                'attribute': 'data-equalizer-watch',
                'helplink': 'equalizer.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function(pgel, cp, action_def, $el) {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate tooltip.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.equalizer.parameters' : {
                        'name' : 'Equalizer options',
                        'fields' : {
                            'fd.equalizer.text': {
                                'type' : 'text',
                                'name' : 'Watch',
                                'action' : 'element_attribute',
                                'attribute' : 'data-equalizer-watch',
                                'attribute_keep_if_empty' : true
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_equalizer_watch_action);
            actions.push(def_equalizer_watch_action);
        // End equalizer

        // Abide
            var def_abide_action = new PgComponentType(prefix + 'data-abide-error-action', 'Data abide error', {
                'selector': "[data-abide-error]",
                'attribute': 'data-abide-error',
                'action': true,
                'not_main_type': true,
                'sections': addPrefixToSectionsAndFields({
                    'fd.abide.parameters' : {
                        name : 'Options',
                        fields : {
                            'fd.abide.hide' : {
                                type : 'checkbox',
                                name : 'Hide',
                                value : 1,
                                action : 'custom',
                                get_value : function (pgel) {
                                    return styleToObject(pgel.getAttr('style'))['display'] == "none" ? '1' : null;
                                },
                                set_value : function (pgel, value, values, oldValue, eventType) {
                                    var style = pgel.getAttr('style');
                                    style = style ? style : '';
                                    if (value == '1') {
                                        setStyle(pgel, 'display:none;', 'display:block;');
                                    }
                                    else {
                                        setStyle(pgel, 'display:block;', 'display:none;');
                                    }
                                    return value;
                                }
                            },
                            'fd.abide.callout' : {
                                type : 'checkbox',
                                name : 'Callout',
                                action : "apply_class",
                                value : 'callout'
                            },
                            'fd.abide.color' : {
                                'type' : 'select',
                                'action' : 'apply_class',
                                'name' : 'Callout color',
                                'show_empty' : true,
                                'options' : [
                                    { key: 'secondary', name: 'Secondary' },
                                    { key: 'primary', name: 'Primary' },
                                    { key: 'success', name: 'Success' },
                                    { key: 'warning', name: 'Warning' },
                                    { key: 'alert', name: 'Alert' }
                                ]
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_abide_action);
            actions.push(def_abide_action);
        // End abide

        // Toggler
            var def_toggler_action = new PgComponentType(prefix + 'data-toggler-action', 'Data toggler', {
                'selector': "[data-toggler]",
                'attribute': 'data-toggler',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.toggler.parameters' : {
                        name : 'Options',
                        fields : {
                            'fd.toggler.text' : {
                                type : 'text',
                                name : 'Data toggler',
                                action : "element_attribute",
                                attribute : 'data-toggler',
                                attribute_keep_if_empty : true,
                                placeholder: f.textDefaultValue('selector')
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_toggler_action);
            actions.push(def_toggler_action);

            var def_open_action = new PgComponentType(prefix + 'data-open-action', 'Data open', {
                'selector': "[data-open]",
                'attribute': 'data-open',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                sections: addPrefixToSectionsAndFields({
                    'fd.open.parameters' : {
                        name : 'Options',
                        fields : {
                            'fd.open.text' : {
                                type : 'text',
                                name : 'Data open',
                                action : "element_attribute",
                                attribute : 'data-open',
                                attribute_keep_if_empty : true,
                                placeholder: f.textDefaultValue('selector')
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_open_action);
            actions.push(def_open_action);

            var def_trigger_action = new PgComponentType(prefix + 'data-trigger-action', 'Data trigger', {
                'selector': "[data-trigger]",
                'attribute': 'data-trigger',
                'action': true,
                'not_main_type': true,
                'on_action_added': function() {
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.trigger.parameters' : {
                        name : 'Options',
                        fields : {
                            'fd.trigger.text' : {
                                type : 'text',
                                name : 'Data trigger',
                                action : "element_attribute",
                                attribute : 'data-trigger',
                                attribute_keep_if_empty : true,
                                placeholder: f.textDefaultValue('selector')
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_trigger_action);
            actions.push(def_trigger_action);
        // End toggler

        // Smooth scroll
            var def_smooth_scroll_action = new PgComponentType(prefix + 'data-smooth-scroll', 'Smooth scroll', {
                'selector': "[data-smooth-scroll]",
                'attribute': 'data-smooth-scroll',
                'action': true,
                'not_main_type': true,
                'sections': addPrefixToSectionsAndFields({
                    'fd.abide.parameters' : {
                        name : 'Options',
                        fields : {
                            'fd.smscroll.animation.duration' : {
                                type : 'text',
                                name : 'Animation duration',
                                action: 'element_attribute',
                                attribute : 'data-animation-duration'
                            },
                            'fd.smscroll.animation.easing' : {
                                type : 'text',
                                name : 'Animation easing',
                                action: 'element_attribute',
                                attribute : 'data-animation-easing'
                            },
                            'fd.smscroll.threshold' : {
                                type : 'text',
                                name : 'Threshold',
                                action: 'element_attribute',
                                attribute : 'data-threshold'
                            },
                            'fd.smscroll.offset' : {
                                type : 'text',
                                name : 'Offset',
                                action: 'element_attribute',
                                attribute : 'data-offset'
                            }
                        }
                    }
                })
            });
            f.addComponentType(def_smooth_scroll_action);
            actions.push(def_smooth_scroll_action);
        // End smooth scroll

        // Interchange
            var def_interchange_action = new PgComponentType(prefix + 'interchange-action', 'Interchange', {
                'selector': '[data-interchange]',
                'attribute': 'data-interchange',
                'helplink': 'sticky.html',
                'action': true,
                'not_main_type': true,
                'sections': addPrefixToSectionsAndFields({
                    'fd.interchange.parameters' : {
                        'name' : 'Options',
                        'fields' : getStandardPluginAction({
                            'fd.interchange.text' : {
                                'type' : 'text',
                                'name' : 'Text',
                                'action' : 'element_attribute',
                                'attribute' : 'data-interchange',
                                'attribute_keep_if_empty' : false
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_interchange_action);
            actions.push(def_interchange_action);
        // End Interchange

        // Sticky
            var def_sticky_action = new PgComponentType(prefix + 'sticky-action', 'Sticky', {
                'selector': '[data-sticky]',
                'attribute': 'data-sticky',
                'helplink': 'sticky.html',
                'action': true,
                'not_main_type': true,
                'on_action_added': function(pgel, cp, action_def, $el) {
                    var pgp = pgel.parent;
                    pgp.setAttr('data-sticky-container', '');
                    pinegrow.showQuickMessage('Do <b>Page -&gt; Refresh</b> to activate.');
                },
                'on_action_removed': function(pgel, cp, action_def, $el) {
                    var pgp = pgel.parent;
                    pgp.removeAttr('data-sticky-container');
                },
                'sections': addPrefixToSectionsAndFields({
                    'fd.sticky.parameters' : {
                        'name' : 'Options',
                        'fields' : getStandardPluginAction({
                            'fdanchortop' : {
                                'type' : 'text',
                                'name' : 'Data anchor top',
                                'action' : 'element_attribute',
                                'attribute' : 'data-top-anchor',
                                'attribute_keep_if_empty' : false,
                                'placeholder' : 'selector'
                            },
                            'fdanchorbottom' : {
                                'type' : 'text',
                                'name' : 'Data anchor bottom',
                                'action' : 'element_attribute',
                                'attribute' : 'data-btm-anchor',
                                'attribute_keep_if_empty' : false,
                                'placeholder' : 'selector'
                            }
                        })
                    }
                })
            });
            f.addComponentType(def_sticky_action);
            actions.push(def_sticky_action);
        // End Sticky


        // Actions
            var actions_section = new PgFrameworkLibSection('fdactions', 'Foundation');
            actions_section.setComponentTypes( actions );
            actions_section.closed = false;
            f.addActionsSection(actions_section);
        // End actions

        f.on_get_menu_points = function(page, pgel, menu, points) {
            gh.getMenuPoints(page, pgel, menu, points);
        }

        f.on_page_view_resized = function(page, pv) {
            gh.onPageViewResized(page, pv);
        }

        //GRID
        f.on_get_device_sizes = function(page, list) {
            gh.getDeviceSizesForPageViewMenu(page, list);
        }

        f.on_page_shown_in_live_view = function(page, pv) {
            gh.show(pv);
        }

        var extension_added = false;
        var plugin_builder = null;

        f.on_plugin_activated = function(page, done) {
            gh.onFrameworkActivatedOnPage(page);

            if (!plugin_builder) {
                plugin_builder = new PgPluginBuilder(f);
                plugin_builder.usePreviewIframe();
            }


            if(extension_added) {
                if(done) done(f);
                return;
            }
            var ext = new PgEditableAreaExtension('fd6', 'Foundation', f);

            ext.addFieldFromProp('button-type', 'Button type', def_link_button.sections[prefix + 'button'].fields[prefix + 'buttontype'], '.button');
            ext.addFieldFromProp('button-size', 'Button size', def_link_button.sections[prefix + 'button'].fields[prefix + 'buttonsize'], '.button');

            pinegrow.addEditableAreaExtension(ext);
            extension_added = true;
            //end add extension*/

            if(done) done(f);
        }


        f.pppon_page_loaded = function(crsaPage) {
            /*
            var $html = crsaPage.get$Html();

            if($html.find('ul.clearing-thumbs').length > 0) {
                pinegrow.setNeedsUpdate($(crsaPage.getBody()));
            }

            $html.find('[data-orbit]').each(function(i,e) {
                crsaQuickMessage("Orbit slider detected. It is recommended to pause the slider for better performance.", 2000);

            });
            */
        }


        f.on_set_inline_style = function(page, o) {
            o.css += gh.getViewCss();

            //modals
            o.css += '\
            .pg-show-modal {\
                position: relative;\
                top: auto;\
                right: auto;\
                left: auto;\
                bottom: auto;\
                display: block !important;\
                opacity: 1;\
                background-color: rgba(0, 0, 0, 0);\
            }\
            .reveal-overlay.pg-show-modal .reveal {\
                display: block !important;\
                top: 0 !important;\
            }';
        }

        f.on_page_changes_done = function(page, info, page_col) {
            gh.updateHelpersAfterChange(page, info, page_col);
        }

        f.on_inline_editing_done = function(page, pgel) {
            gh.updateHelpersAfterChange(page, null, new PgCollection(pgel));
        }

        f.on_get_page_libs = function(page, list) {
            gh.getPageLibs([
                {name: 'Components', url: 'index.html'}
            ]).forEach(function(item) {
                list.push(item);
            })
        }

        f.on_page_selected = function(page) {
            if(page) {
                getFoundationVersionForPage(page);
            }
        }

        f.on_before_properties_shown = function(page) {
            if(page && !page.data.bootstrapVersion) {
                getFoundationVersionForPage(page);
            }
        }

        f.on_after_resources_added = function() {
            pinegrow.getAllPages().forEach(function(page) {
                getFoundationVersionForPage(page, true /* force */);
            })
        }

        var res = new PgComponentTypeResource('https://cdnjs.cloudflare.com/ajax/libs/foundation/6.6.3/css/foundation.min.css');
        res.type = 'text/css';
        f.resources.add(res);

        res = new PgComponentTypeResource('https://cdnjs.cloudflare.com/ajax/libs/jquery/2.2.4/jquery.min.js');
        res.type = 'application/javascript';
        res.detect = /jquery/;
        res.footer = true;
        f.resources.add(res);

        res = new PgComponentTypeResource('https://cdnjs.cloudflare.com/ajax/libs/foundation/6.6.3/js/foundation.min.js');
        res.type = 'application/javascript';
        res.footer = true;
        f.resources.add(res);

        f.resources.description = "Include Foundation CSS and JS files from CDNJS. Updating resources will add the latest version of Foundation CSS and JS to the page. If you have older or local version of Foundation linked to the page, remove the old CSS and JS links from the page.";

        var templatesOrder = ["index.html", "portfolio.html", "branded.html", "blog.html", "blog-simple.html", "agency.html", "feed.html", "grid.html", "orbit-home.html", "banner-home.html", "sidebar.html", "contact.html", "product-page.html", "marketing.html", "marketing-site.html", "ecommerce.html", "news-magazine.html", "reality.html", "so-boxy.html", "store.html", "workspace.html", "real-estate.html"];

        //Register starting page template
        f.addTemplateProjectFromResourceFolder('template', null, 1, function (node) {
            var nodeIndex = templatesOrder.indexOf(node.name);
            if (nodeIndex >= 0) node.order = nodeIndex;
        });

    });
});